=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub AccountManager{
my ($Out, %User, $Temp);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	$Out =&TranslateFile($Global{AccountManagerMainTemplate});

	undef %User;
	%User = &Get_User($Param{User_ID});

	$Out =~ s/<!--User_ID-->/$User{User_ID}/;
	$Out =~ s/<!--First_Name-->/$User{FName}/;
	$Out =~ s/<!--Last_Name-->/$User{LName}/;
	$Out =~ s/<!--Street-->/$User{Street}/;
	$Out =~ s/<!--City-->/$User{City}/;
	$Out =~ s/<!--State-->/$User{State}/;
	$Out =~ s/<!--Zip-->/$User{Zip}/;
	$Out =~ s/<!--Country-->/$User{Country}/;
	$Out =~ s/<!--Phone-->/$User{Phone}/;
	$Out =~ s/<!--Email-->/$User{Email}/;
	$Out =~ s/<!--Company-->/$User{Company}/;
	
	$Temp = "";
	if ($User{Current_Balance} > 0) {
			$Temp = &Format_Digits(sprintf("%.2f", $User{Current_Balance}));
	}
	elsif ($User{Current_Balance} < 0) {
			$Temp = "-" . &Format_Digits(sprintf("%.2f", abs($User{Current_Balance})));
	}
	else{
			$Temp = "";
	}
	$Out =~ s/<!--BALANCE-->/$Temp/;
	#----------------------------------------------------------------
	# Copy this part of code to the location you want to display registration custom fields
	# In your templates, insert the classes: <!--UserXX--> where XX from 1 to 20.
	for $Temp (1..20) { #Custom fields
			$Key = "User" . $Temp;
			$Out =~ s/<!--$Key-->/$User{$Key}/g;
	}
	#----------------------------------------------------------------
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub AccountManager_Login{
my($URL, $Temp, $Form);

	if (&Check_Previous_User_Login ) {&AccountManager; return;}

	&LoadLangFile($Global{LanguageAccountManagerFile});
	$Form = &TranslateFile($Global{AccountManagerLoginTemplate});

	if ($Global{SSL_Status}){
			$URL = "$Global{SSL_URL}/$Global{MainProg}";
	}
	else{
			$URL = "$Global{CGI_URL}/$Global{MainProg}";
	}
	#------------------------------------------------------------------
	$Param{User_ID} ||= "";
	$Param{Password} ||= "";
	#------------------------------------------------------------------
	$Form =~ s/<!--Action-->/$URL/;
	$Form =~ s/<!--Language-->/$Global{Language}/g;
	$Form =~ s/<!--User_ID-->/$Param{User_ID}/g;
	$Form =~ s/<!--Password-->/$Param{Password}/g;

	$Temp = "";
	if ($Param{Login_Session}) {$Temp = "CHECKED";}
	$Form =~ s/<!--Checked-->/$Temp/;

	$Temp = qq!$URL?action=Forgot_User_ID!;
	$Form =~ s/<!--Forgot_Username_URL-->/$Temp/;

	$Temp = qq!$URL?action=Forgot_Password!;
	$Form =~ s/<!--Forgot_Password_URL-->/$Temp/;

	$Plugins{Body} = &Translate($Form);

	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub Check_AccountManager_Login {

	&LoadLangFile($Global{LanguageAccountManagerFile});

	$Param{User_ID} ||= "";
	$Param{User_ID} = lc($Param{User_ID});

	if (!&Check_User_Authentication($Param{User_ID} , $Param{Password})){
					$Plugins{Body} = $Language{login_error};
					&Display($Global{AccountManagerTemplate});
					&Quit;
	}
	
	if ($Global{MewsoftPassport}) {
			$Param{Login_Session} ||= 0;
			$Param{MewsoftPassport_Session} = $Param{Login_Session};
			&Set_Cookies ("MewsoftPassport_User", $Param{User_ID}, $Param{MewsoftPassport_Session});
			&Set_Cookies ("MewsoftPassport_Password", $Param{Password}, $Param{MewsoftPassport_Session});
			$Cookies{MewsoftPassport_User} = $Param{User_ID};
			$Cookies{MewsoftPassport_Password} = $Param{Password};
			$Cookies{MewsoftPassport_Session} = $Param{MewsoftPassport_Session};
	}
	else{
			$Param{Login_Session} ||= 0;
			$Param{Boardawy_Session} = $Param{Login_Session};
			&Set_Cookies ("Boardawy_User", $Param{User_ID}, $Param{Boardawy_Session});
			&Set_Cookies ("Boardawy_Password", $Param{Password}, $Param{Boardawy_Session});
			$Cookies{Boardawy_User} = $Param{User_ID};
			$Cookies{Boardawy_Password} = $Param{Password};
			$Cookies{Boardawy_Session} = $Param{Boardawy_Session};
	}
	
	if ($Param{Manage_Boardawy_User} && $Param{Manage_Boardawy_Password}) {
			&Set_Cookies ("Manage_Boardawy_User", $User{User_ID}, 0);
			&Set_Cookies ("Manage_Boardawy_Password", $User{Password}, 0);
			$Cookies{Manage_Boardawy_User} = $Param{User_ID};
			$Cookies{MewsoftPassport_Password} = $Param{Password};
	}

	&AccountManager;
}
#==========================================================
sub Country_List{
my ($Default) = @_;
my ($Country, $Selected, $List, %Countries);

	%Countries = &GetLangFile($Global{CountriesFile});
	$Default ||= "Any";

	$List = "";
	if (exists $Countries{Any}) {
			if ("Any" eq $Default) {$Selected = "SELECTED";}
			$List = qq!<option value="Any" $Selected>$Countries{Any}</option>!;
	}

	foreach $Country(sort  keys %Countries)  {
			if ($Country eq "Any") {next;}
			$Selected = "";
			if ($Country eq $Default) {$Selected="SELECTED";}
			$List .= qq!<option value="$Country" $Selected>$Countries{$Country}</option>!;
	}

	return $List;
}
#==========================================================
1;