=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub MyPosts{
my (@Topics, $Out);
	
	# search options
	$Param{Dir} ||= 0;
	$Param{Sort} ||= "Updated";
	$Param{Mode} ||= 0; # display mode, 1=topics, 0=posts
	$Param{PageSize} ||= $Global{Topics_Per_Page};	
	$Param{Period} ||= 0; # Search previous days
	$Param{TitlesOnly} ||= 0; # search title only
	$Param{Partial} ||= $Global{Posts_Return_Size}; # Return first characters of messages
	if ($Param{Sorted} ==1) {$Param{Dir} = !$Param{Dir};	}
	#------------------------------------------------------
	# search the forums for posts by the selected authors only
	#my ($Authors, $Forums, $Period, $Mode, $SortBy, $SortDir, $SaveCash) = @_;
	(undef, @Topics) = &Search_Forums_Authors($Param{User_ID}, "", $Param{Period}, 1, $Param{Sort}, $Param{Dir}, 0);
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_posts};
	$Plugins{Bar_Action} =~ s/<!--Author-->/$Param{User_ID}/g;
	#------------------------------------------------------
	$Plugins{ResultsFound} = $Language{topics_results_found};
	#------------------------------------------------------
	# parse the search results for display
	# ($Action, $Template, $Form1, $Form2, $Mode, $PostLink, @Topics)
	$Out = &ParseForumTopicsList("action=MyPosts", "MyPosts",
													&TranslateFile($Global{ForumSearchTopicsTemplate}),
													$Global{ForumTopicsListSearchForm},
													$Global{ForumTopicsListSearchForm1},
													1,
													$Param{User_ID},
													0,
													@Topics
												);
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub MyFavorites{
my (@Topics, $Out);

	# search options
	$Param{Dir} ||= 0;
	$Param{Sort} ||= "Updated";
	$Param{Mode} ||= 0; # display mode, 1=topics, 0=posts
	$Param{PageSize} ||= $Global{Topics_Per_Page};	
	$Param{Period} ||= 0; # Search previous days
	$Param{TitlesOnly} ||= 0; # search title only
	$Param{Partial} ||= $Global{Posts_Return_Size}; # Return first characters of messages
	if ($Param{Sorted} ==1) {$Param{Dir} = !$Param{Dir};	}
	#------------------------------------------------------
	# ($User, $SortBy, $SortDir, $Period)
	@Topics = &GetForumUserWatchingTopics($Param{User_ID}, $Param{Sort}, $Param{Dir}, $Param{Period});
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_favorites};
	$Plugins{Bar_Action} =~ s/<!--Author-->/$Param{User_ID}/;
	#------------------------------------------------------
	$Plugins{ResultsFound} = $Language{topics_results_found};
	#------------------------------------------------------
	# parse the search results for display
	# ($Action, $Template, $Form1, $Form2, $Mode, $PostLink, @Topics)
	$Out = &ParseForumTopicsList("action=MyFavorites", "MyFavorites",
													&TranslateFile($Global{ForumSearchTopicsTemplate}),
													$Global{ForumTopicsListSearchForm},
													$Global{ForumTopicsListSearchForm1},
													1,
													$Param{User_ID},
													0,
													@Topics
												);
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub MyBuddies{
	&AccountManager_Login;
}
#==========================================================
sub BlockList{
my ($Template, $Base, $User_ID, $Query, $sth, @Row, @Users, $User, $Temp);

	&Check_Account_Login;

	$Template = &TranslateFile($Global{BlockListTemplate});
	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Base = &Base_URL;
	$Temp = "$Base/$Global{MainProg}";
	$Template =~ s/<!--Action-->/$Temp/;
	#------------------------------------------------------
	$User_ID = $dbh->quote($Param{User_ID});
	$Query = qq!SELECT Blocked_ID FROM Forum_Block_List WHERE User_ID=$User_ID ORDER BY Blocked_ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Users;
	while (@Row = $sth->fetchrow_array){push @Users, $Row[0];}
	$sth->finish;

	$Temp = join (", ", @Users);
	$Template =~ s/<!--Block_List-->/$Temp/;

	$Plugins{Body} = $Template;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub Save_Block_List{
my ($User_ID, $Query, $sth, %Blocked, @Row, @List, $User, $Temp);

	&Check_Account_Login;

	$User_ID = $dbh->quote($Param{User_ID});
	$Query = qq!DELETE FROM Forum_Block_List WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Param{Block_List} ||= "";
	$Param{Block_List} =~ s/\cM/ /g;
	$Param{Block_List} =~ s/\,/ /g;
	@List = split(/\s+/, $Param{Block_List});
	foreach $User (@List) {
			$User =~ s/\s+//g;
			if (!$User) {next;}
			$Temp = $dbh->quote($User);
			$Query = qq!INSERT INTO Forum_Block_List VALUES ($User_ID, $Temp)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	$Plugins{Body} = $Language{block_list_saved};
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub BlockUser{
my ($User_ID, $User, $Query);

	&Check_Account_Login;

	$User_ID = $dbh->quote($Param{User_ID});
	$User = $dbh->quote($Param{User});

	$Query = qq!DELETE FROM Forum_Block_List WHERE User_ID=$User_ID AND Blocked_ID=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!INSERT INTO Forum_Block_List VALUES ($User_ID, $User)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Plugins{Body} = $Language{blocked_member_added};
	$Plugins{Body} =~ s/<!--User-->/$Param{User}/g;

	&Display($Global{AccountManagerTemplate});
}
#==========================================================
#			About Me
#==========================================================
sub AboutMe{
my ($Template, $Base, $Temp, $Content);

	&Check_Account_Login;

	$Plugins{Bar_Action} = $Language{bar_aboutme};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{AboutMeEditorTemplate});
	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	#------------------------------------------------------
	# Text/Visual HTML Editor
	#------------------------------------------------------
	$Template = &GetEditorForm($Template, "Message", "700px", "300px");
	#------------------------------------------------------
	#------------------------------------------------------
	$Content = "";
	$User_ID = $dbh->quote($Param{User_ID});
	$Content = &SqlVal(qq!SELECT Content from AboutMe WHERE User_ID=$User_ID!);
	$Content =~ s/\cM//g;
	$Template =~ s/<!--EditorText-->/$Content/;
	$Template =~ s/<!--User_ID-->/$Param{User_ID}/g;

	$Plugins{Body} = "";
	&Display($Template, 1);
}
#==========================================================
sub Save_AboutMe{
my ($Content, $User_ID, $Temp);

	&Check_Account_Login;

	$Param{Message} ||= "";
	$Param{Message} =~ s/\cM//g;
	$Global{AboutMePageLength} +=0;
	if (!$Global{AboutMePageLength}) {$Global{AboutMePageLength} = 100000;}
	
	$Content = $Param{Message};
	#substr EXPR,OFFSET,LENGTH
	$Content = substr($Content, 0, $Global{AboutMePageLength});
	#------------------------------------------------------
	$User_ID = $dbh->quote($Param{User_ID});
	$dbh->do(qq!DELETE from AboutMe WHERE User_ID=$User_ID!);
	$Content =  $dbh->quote($Content);
	$dbh->do(qq!INSERT INTO AboutMe values($User_ID, $Content)!);
	#------------------------------------------------------
	$Plugins{Body} = $Language{aboutme_page_saved};
	$Temp = qq!$Global{ProgURL}me/$Param{User_ID}!;
	$Plugins{Body} =~ s/<!--MyAboutMe-->/$Temp/g;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
#Show about me page
sub me{
my ($Template, $Base, $Temp, $Content, $User_ID);

	$Template = &TranslateFile($Global{AboutMeTemplate});

	&Check_Account_Login;

	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Base = &Base_URL;
	$Temp = "$Base/$Global{MainProg}";
	$Temp =~ s|(?<!:)\/+|\/|g;
	$Template =~ s/<!--Action-->/$Temp/;
	#------------------------------------------------------
	$Content = "";
	$User_ID = $dbh->quote($Param{me});
	$Content = &SqlVal(qq!SELECT Content from AboutMe WHERE User_ID=$User_ID!);
	$Content =~ s/\cM//g;
	$Template =~ s/<!--AboutMe_Body-->/$Content/;
	$Template =~ s/<!--User_ID-->/$Param{User_ID}/g;
	#------------------------------------------------------
	$Plugins{Body} = "";
	&Display($Template, 1);
}
#==========================================================
#==========================================================
sub MyPreferences{
my ($Message) = @_;
my (%User, $K, $V, $Temp);

	&Check_Account_Login;
	%User = &GetForumUser($Param{User_ID});
	while (($K, $V) = each %User) {
			$Param{$K} = $V;
	}
	
	if ($User{Avatar}) {
			$Param{Uploaded_File} = $User{Avatar};
			$Temp =  -s "$Global{Avatars_Dir}/$Param{Uploaded_File}";
			$Param{Uploaded_File_Size} = int($Temp/1000);
			$Param{Uploaded_File_Count} = 1;
	}

	&My_Preferences($Message);
}
#==========================================================
sub My_Preferences{
my ($Message) = @_;
my ($Template, %Info);

	$Plugins{Bar_Action} = $Language{bar_preferences};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPreferencesTemplate});
	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	#------------------------------------------------------
	$Template = &GetEditorForm($Template, "Sig", "700px", "300px");
	#------------------------------------------------------
	$Template =~ s/<!--Message-->/$Message/g;
	#------------------------------------------------------
	if ($Param{DeleteAvatar}) {
			unlink qq!$Global{Avatars_Dir}/$Param{Uploaded_File}!;
			$Param{Uploaded_File} = "";
			$Param{Uploaded_File_Size} = 0;
			$Param{Uploaded_File_Count} = 0;

			undef %Info;
			$Info{Avatar} = "";
			&UpdateForumUserInfo($Param{User_ID}, %Info);
	}
	#------------------------------------------------------
	#Upload avatar
	$Upload_Error = "";
	$Key = "Mewsoft_Corporation_Upload_File1";
	if ($Param{$Key}) {
				$Filename = ""; $File_Content = "";
				#($Filename, $File_Content) = split(/\|/, $Param{$Key});
				$Upload_File = $Param{$Key};
				$Upload_File =~ /\r\n\r\n|\n\n/;         #separate header and body 
				$Upload_File_Name = $`;                # front part
				$Upload_File_Content = $';             # rear part
				$Upload_File_Content =~ s/\r\n$//;  # the last \r\n was put in by Netscape

				# Parse uploaded files
				$Upload_File_Name =~ /filename=\"(.+)\"/; 
				$Upload_File_Name = $1;  #print "[[Header= $Header ]](($Input))<br>";
				$Upload_File_Name =~ s/\"//g; # remove "s
				$Upload_File_Name =~ s/\s//g; # make sure no space(include \n, \r..) in the file name 
				@File_Name = split(/[\/|\\]/, $Upload_File_Name); 
				$Upload_File_Name = pop @File_Name;
				$Filename = $Upload_File_Name;
				$File_Content = $Upload_File_Content;
				#print "\$Filename=$Filename<br><br>\$File_Content=$File_Content<br><br>";
				#$File_Content = $Param{$Key};
				#$File_Content =~ s/^$Filename\|//;
				if ($Filename) {
							$Upload_Error = &UploadAvatarFile($Filename, $File_Content);
							$Upload = 1;
				}
				delete $Param{Mewsoft_Corporation_Upload_File1};
	}
	#---------------------------------------------------------------------------------------------------------
	$Template =~ s/<!--Uploaded_File-->/$Param{Uploaded_File}/g;
	$Template =~ s/<!--Uploaded_File_Size-->/$Param{Uploaded_File_Size}/g;
	$Template =~ s/<!--Uploaded_File_Count-->/$Param{Uploaded_File_Count}/g;
	if ($Upload_Error) {
			$Upload_Error = $Language{pref_avatars_error_msg} . $Upload_Error;
	}
	$Template =~ s/<!--Upload_File_Error_Msg-->/$Upload_Error/g;
	#------------------------------------------------------
	if ($Param{Uploaded_File}) {
			$Temp = $Language{pref_avatars_image};
			$Link = qq!$Global{Avatars_URL}/$Param{Uploaded_File}!;
			$Temp =~ s/<!--AvatarsLink-->/$Link/g;
			$Template =~ s/<!--AvatarsImage-->/$Temp/g;

			$Temp = $Language{pref_avatars_name};
			$Temp =~ s/<!--Name-->/$Param{Uploaded_File}/g;
			$Template =~ s/<!--AvatarsImageName-->/$Temp/g;
			
			$Temp = $Language{pref_avatars_size};
			$Temp =~ s/<!--Size-->/$Param{Uploaded_File_Size}/g;
			$Template =~ s/<!--AvatarsImageSize-->/$Temp/g;

			$Temp = $Language{pref_avatars_delete};
			$Template =~ s/<!--AvatarsImageDelete-->/$Temp/g;
	}
	#------------------------------------------------------
	#------------------------------------------------------
	if ($Param{ViewEmail}) {
			$Template =~ s/<!--ViewEmail-->/checked/g;
	}
	else{
			$Template =~ s/<!--ViewEmail-->//g;
	}
	#------------------------------------------------------
	if ($Param{AttachSign}) {
			$Template =~ s/<!--AttachSign-->/checked/g;
	}
	else{
			$Template =~ s/<!--AttachSign-->//g;
	}
	#------------------------------------------------------
	if ($Param{AllowPM}) {
			$Template =~ s/<!--AllowPM-->/checked/g;
	}
	else{
			$Template =~ s/<!--AllowPM-->//g;
	}
	#------------------------------------------------------
	if ($Param{ViewOnline}) {
			$Template =~ s/<!--ViewOnline-->/checked/g;
	}
	else{
			$Template =~ s/<!--ViewOnline-->//g;
	}
	#------------------------------------------------------
	if ($Param{NotifyPM}) {
			$Template =~ s/<!--NotifyPM-->/checked/g;
	}
	else{
			$Template =~ s/<!--NotifyPM-->//g;
	}
	#------------------------------------------------------
	$Template =~ s/<!--EditorText-->/$Param{Sig}/g;
	#------------------------------------------------------
	$Template =~ s/<!--Timezone-->/$Param{Timezone}/g;
	$Template =~ s/<!--DateFormat-->/$Param{DateFormat}/g;
	$Template =~ s/<!--Language-->/$Param{Language}/g;
	$Template =~ s/<!--Location-->/$Param{Location}/g;
	$Template =~ s/<!--WebTitle-->/$Param{WebTitle}/g;
	$Template =~ s/<!--WebURL-->/$Param{WebURL}/g;
	$Template =~ s/<!--Occupation-->/$Param{Occupation}/g;
	$Template =~ s/<!--Interests-->/$Param{Interests}/g;
	$Template =~ s/<!--ICQ-->/$Param{ICQ}/g;
	$Template =~ s/<!--AIM-->/$Param{AIM}/g;
	$Template =~ s/<!--YIM-->/$Param{YIM}/g;
	$Template =~ s/<!--MSNM-->/$Param{MSNM}/g;
	#------------------------------------------------------
	$Template =~ s/<!--Avatar_Max_Size-->/$Global{Avatar_Max_Upload_File_Size}/g;
	$Template =~ s/<!--Avatar_Files_Ext-->/$Global{Avatar_Files_Ext_Allowed}/g;
	#------------------------------------------------------
	$Plugins{Body} = $Template;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub UploadAvatarFile{
my ($Filename, $File_Content) = @_;
my (@File_Exts, $File_Ext, $Ext, $Err);
my (@Files_Ext_Allowed, $File_Allowed, $File_Name, $File);
my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks);

	binmode(STDIN);
	binmode(STDOUT);
	binmode(STDERR);

	@File_Exts = split(/\./ , $Filename);
	$File_Ext = pop @File_Exts;
	$File_Ext = lc($File_Ext);

	@File_Name = split(/[\/|\\]/, $Filename); 
	$File = pop @File_Name;
	$File_Name = qq!$Global{Avatars_Dir}/$Param{User_ID}\.$File_Ext!;
	unlink ($File_Name);

	$Global{Avatar_Files_Ext_Allowed}=~ s/\,/ /g;
	@Files_Ext_Allowed = split(/\s+/, $Global{Avatar_Files_Ext_Allowed});
	$File_Allowed = 0;
	if ($Global{Avatar_Upload_Any_File}) {
				$File_Allowed = 1;
	}
	else{
				foreach $Ext(@Files_Ext_Allowed) {
						$Ext = lc($Ext);
						$Ext =~ s/\s+//g;
						if ($File_Ext eq $Ext){
								$File_Allowed =1; last;
						}
		      }
	}

	$Err = "";
	if ($File_Allowed) { 
				open(FILE,">$File_Name")  || &Exit("Can 't write media file $File_Name: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
				binmode FILE;
				print FILE $File_Content; 
				close(FILE); 
				($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($File_Name);
				chmod (0755, $File_Name);
				$Err = "";
	}
	else{
				# File ext. not allowed to upload
				$Err = $Language{pref_avatars_error_file_type};
	}

	if (!$Err) {
			if ($Filename) { 
						$Err = &CheckAvatarFile($File_Name, $size);
				}
			else {
						$Err = $Language{pref_avatars_file_no_name};
						unlink ($File_Name);
			 }
	 }

	return $Err;
}
#==========================================================
sub CheckAvatarFile{
my ($Fname, $Fsize) = @_;
my ($Msg, @File, $File);

	$Fsize = int($Fsize/1000);
	$Msg = "";

	if ($Fsize > $Global{Avatar_Max_Upload_File_Size}) {
			$Msg .= "$Language{pref_avatars_error_file_size} <b>$Global{Avatar_Max_Upload_File_Size} $Language{pref_avatar_kilo_bytes}</b>.<br>";
	}
	$Global{Avatar_Allow_File_Upload} = 1;
	$Global{Avatar_Upload_Any_File}  = 0;
	$Global{Avatar_Max_Upload_File_Size} = 15; #in KB
	$Global{Avatar_Files_Ext_Allowed} = "jpg gif png";
	
	if (!$Msg) {
			@File = split(/[\/|\\]/, $Fname); 
			$File = pop @File;

			$Param{Uploaded_File} = $File;
			$Param{Uploaded_File_Size} = $Fsize;
			$Param{Uploaded_File_Count} = 1;
	 }
	else {
			unlink ("$Fname");
	}

	return $Msg;
}
#==========================================================
sub SaveMyPreferences{
my (%User);

	#------------------------------------------------------
	if ($Param{UploadFile} || $Param{DeleteAvatar}) {
			&My_Preferences;
			return;
	}
	#------------------------------------------------------
	&Check_Account_Login;
	#------------------------------------------------------
	undef %User;

	$Param{Sig} =~ s/^\s+//;
	$Param{Sig} =~ s/\s+$//;
	$Param{Sig} = &HTML_Treat($Param{Sig}, $Global{Sig_Treat_HTML});
	$Param{Sig} = substr($Param{Sig}, 0, $Global{Sig_Max_Len});
	#------------------------------------------------------
	$Param{ViewEmail} ||= 0;
	$Param{AttachSign} ||= 0;
	$Param{AllowPM} ||= 0;
	$Param{ViewOnline} ||= 0;
	$Param{NotifyPM} ||= 0;
	$Param{Timezone} ||= 0;

	$Param{Language} ||= $Global{Language};
	$Param{Language} =~ s/^\s+//;
	$Param{Language} =~ s/\s+$//;

	$Param{DateFormat} ||= $Global{DateFormat};
	$Param{DateFormat} =~ s/^\s+//;
	$Param{DateFormat} =~ s/\s+$//;

	$Param{Timezone} ||= 0;
	$Param{Timezone} =~ s/^\s+//;
	$Param{Timezone} =~ s/\s+$//;

	$Param{Location} ||= "";
	$Param{Location} =~ s/^\s+//;
	$Param{Location} =~ s/\s+$//;

	$Param{WebTitle} ||= "";
	$Param{WebTitle} =~ s/^\s+//;
	$Param{WebTitle} =~ s/\s+$//;

	$Param{WebURL} ||= "";
	$Param{WebURL} =~ s/^\s+//;
	$Param{WebURL} =~ s/\s+$//;

	if ($Param{WebURL} !~ /^https?\:/i) {
			$Param{WebURL} = "http://". $Param{WebURL};
	}

	$Param{ICQ} ||= "";
	$Param{ICQ} =~ s/^\s+//;
	$Param{ICQ} =~ s/\s+$//;

	$Param{AIM} ||= "";
	$Param{AIM} =~ s/^\s+//;
	$Param{AIM} =~ s/\s+$//;

	$Param{YIM} ||= "";
	$Param{YIM} =~ s/^\s+//;
	$Param{YIM} =~ s/\s+$//;

	$Param{MSNM} ||= "";
	$Param{MSNM} =~ s/^\s+//;
	$Param{MSNM} =~ s/\s+$//;

	$Param{Occupation} ||= "";
	$Param{Occupation} =~ s/^\s+//;
	$Param{Occupation} =~ s/\s+$//;

	$Param{Interests} ||= "";
	$Param{Interests} =~ s/^\s+//;
	$Param{Interests} =~ s/\s+$//;

	$Param{Avatar} ||= "";
	$Param{Sig} ||= "";
	#------------------------------------------------------
	$User{Timezone} = $Param{Timezone};
	$User{DateFormat} = $Param{DateFormat};
	$User{ViewEmail} = $Param{ViewEmail};
	$User{AttachSign} = $Param{AttachSign};
	$User{AllowPM} = $Param{AllowPM};
	$User{ViewOnline} = $Param{ViewOnline};
	$User{NotifyPM} = $Param{NotifyPM};
	$User{Language} = $Param{Language};
	$User{Location} = $Param{Location};
	$User{WebTitle} = $Param{WebTitle};
	$User{WebURL} = $Param{WebURL};

	$User{ICQ} = $Param{ICQ};
	$User{AIM} = $Param{AIM};
	$User{YIM} = $Param{YIM};
	$User{MSNM} = $Param{MSNM};
	$User{Occupation} = $Param{Occupation};
	$User{Interests} = $Param{Interests};

	$User{Avatar} = $Param{Avatar};
	$User{Sig} = $Param{Sig};
	#------------------------------------------------------
	if ($Param{Uploaded_File}) {
				$User{Avatar} = $Param{Uploaded_File};
	}
	#------------------------------------------------------
	&UpdateForumUserInfo($Param{User_ID}, %User);
	
	&MyPreferences($Language{pref_saved});
}
#==========================================================

1;