=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Accounts_Manager{
my(@Accounts);

	undef @Accounts;
	if (!$Param{Group}) {$Param{Group} = "";}
	@Accounts = &Get_Accounts_Group($Param{Group});

	&List_Accounts_Manager("Accounts_Manager", "", @Accounts);
}
#==========================================================
sub List_Accounts_Manager{
my($Page_Action, $Param, @Accounts) = @_;
my ($CurrentPage, $NextPage, $PrevPage, $LastPage, $Start);
my ($NextPage_Link, $PrevPage_Link, $TotalCount,  $End);
my($Counter, $x, $Form, $Temp_Form, %Temp);
my ($Help);

	#$Global{AdminURL} = "$Global{CGI_URL}/$Global{Accounts_Adm_Prog}";
	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Accounts;
	$LastPage = int ($TotalCount / $Global{Admin_Accounts_Per_Page});
	if (($TotalCount % $Global{Admin_Accounts_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}

	$NextPage_Link = qq!<a href="$Global{AdminURL}action=$Page_Action&Page=$NextPage$Param">Next Page</a>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=$Page_Action&Page=$PrevPage$Param">Previous Page</a>!;

	$Start = ($CurrentPage - 1) * $Global{Admin_Accounts_Per_Page};
	$End = $Start + $Global{Admin_Accounts_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next Page";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "Previous Page";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}
	
	$Tables = "";
	$Temp_Form = &Accounts_Manager_Listing_Form;
		
	$Counter = 1;
	for $x($Start..$End-1){
				$Form = $Temp_Form;
				
				%Account = &Get_User($Accounts[$x]);
				%Info = &GetForumUserInfo($Account{User_ID});

				$Temp = sprintf("%d", $x + 1);
				$Form =~ s/<!--Counter-->/$Temp/g;

				if ($Info{Posts}) {$Temp = $Info{Posts};} else {$Temp = "-";}
				$Form =~ s/<!--Posts-->/$Temp/g;

				$Temp = qq!<a href="#" onClick="Javascript: Delete_Account($Counter);return false;">Delete</a>!;
				$Form =~ s/<!--Delete-->/$Temp/g;

				$Temp = qq!<input type="checkbox" name="X_Del_$Counter" value="$Account{User_ID}"  onClick="Javascript: Delete_Accountx($Counter);" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF">!;
				$Form =~ s/<!--Delete_Box-->/$Temp/g;

				$Temp = qq!<a href="#" onClick="Javascript: Account_Status($Counter);return false;">Status</a>!;
				$Form =~ s/<!--Status-->/$Temp/g;

				$Check = "";
				if ($Account{Status}) {$Check = "CHECKED";}
				$Temp = qq!<input type="checkbox" name="Account_Status_$Counter" value="$Account{User_ID}" onClick="Javascript: Account_Statusx($Counter);" $Check style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF">!;
				if ($Check) {
						$Temp .= qq!<input type="hidden" name="Status_On_$Counter" value="$Account{User_ID}">!;	
				}
				$Form =~ s/<!--Status_Box-->/$Temp/g;

				#$Temp = qq!<a href="$Global{AdminURL}action=Admin_Account_Edit&Account=$Account{User_ID}"><B>Manage</b></a>!;

				$Temp = qq!<a href="#" onClick="window.open('$Global{AdminURL}action=Admin_Manage_Account&Account=$Account{User_ID}&Lang=$Global{Language}','Mewsoft_AccountManager','WIDTH=600,HEIGHT=500,toolbar=yes,location=yes,directories=yes,scrollbars=yes,status=yes,menubar=yes,alwaysRaised=yes,resizable=yes,left=1,top=1');return false">Manage</a>!;
				$Form =~ s/<!--Manage-->/$Temp/g;

				$Temp = qq!<a href="mailto:$Account{Email}">$Account{Email}</a>!;
				$Form =~ s/<!--Email-->/$Temp/g;

				$Temp = qq!<a href="#" onClick="window.open('$Global{AdminURL}action=Admin_View_Account&Account=$Account{User_ID}','Mewsoft_AccountManager','WIDTH=600,HEIGHT=500,toolbar=yes,location=yes,directories=yes,scrollbars=yes,status=yes,menubar=yes,alwaysRaised=yes,resizable=yes,left=1,top=1');return false">$Account{User_ID}</a>!;
				$Form =~ s/<!--Account-->/$Temp/g;
				
				$Temp = "-";
				if ($Account{Current_Balance} != 0) {$Temp = $Language{currency}. sprintf("%.2f", $Account{Current_Balance});}
				$Form =~ s/<!--Balance-->/$Temp/g;
				
				$Temp = "$Account{FName} $Account{LName}";
				$Form =~ s/<!--Name-->/$Temp/g;
				
				$Temp = $Account{Street};
				if ($Account{City}) {$Temp .= ", $Account{City}";}
				if ($Account{State}) {$Temp .= ", $Account{State}";}
				if ($Account{Zip}) {$Temp .= ", $Account{Zip}";}
				$Form =~ s/<!--Address-->/$Temp/g;

				$Form =~ s/<!--Country-->/$Account{Country}/g;
				$Form =~ s/<!--Phone-->/$Account{Phone}/g;
				$Form =~ s/<!--Mobile-->/$Account{Mobile}/g;
				$Form =~ s/<!--Fax-->/$Account{Fax}/g;
				$Form =~ s/<!--Company-->/$Account{Company}/g;
				$Form =~ s/<!--Website-->/$Account{Website}/g;

				$Tables .= $Form;
				$Counter++;
	}

	$Start++;

$Tables .=<<HTML;
<script language="JavaScript">
<!--
function Delete_Account(X) {
			box = eval("document.Accounts_Manager.X_Del_" +X); 
			box.checked = ! box.checked;
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.Account_Status_" + X); 
						box.checked = false;
			}
}
function Delete_Accountx(X) {
			box = eval("document.Accounts_Manager.X_Del_" +X); 
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.Account_Status_" + X); 
						box.checked = false;
			}
}

function Account_Status(X) {
			box = eval("document.Accounts_Manager.Account_Status_" +X); 
			box.checked = ! box.checked;
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.X_Del_" + X); 
						box.checked = false;
			}
}
function Account_Statusx(X) {
			box = eval("document.Accounts_Manager.Account_Status_" +X); 
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.X_Del_" + X); 
						box.checked = false;
			}
}

function Delete_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = true;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Uncheck_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Disable_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Enable_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = true;
		}
}

// -->
</script>
HTML

	$Param{Group} ||= "";
	$Form = &Accounts_Manager_Form($Param{Group});

	$Form =~ s/<!--Body-->/$Tables/g;
	$Form =~ s/<!--Start-->/$Start/g;
	$Form =~ s/<!--End-->/$End/g;
	$Form =~ s/<!--Total_Count-->/$TotalCount/g;
	$Form =~ s/<!--PrevPage-->/$PrevPage/g;
	$Form =~ s/<!--NextPage-->/$NextPage/g;

	$Help =&Help_Link("Accounts_Manager");
	&Print_Page($Form, "Accounts Manager", $Help);	
}
#==========================================================
sub Accounts_Manager_Listing_Form{
my($Out);

$Out=<<HTML;
<tr>
	<td nowrap class="TableCell"><!--Counter--></td>
	<td nowrap class="TableCell"><!--Account--></td>
	<td nowrap class="TableCell"><!--Posts--></td>
	<td nowrap class="TableCell"><!--Balance--></td>
	<td nowrap class="TableCell"><!--Email--></td>
	<td nowrap class="TableCell"><!--Manage--></td>
	<td nowrap class="TableCell"><!--Delete_Box--></td>
	<td nowrap class="TableCell"><!--Status_Box--></td>
</tr>
HTML
  return $Out;

}
#==========================================================
sub Accounts_Manager_Form{
my($Group) = @_;
my ($Out, $Help, $Groups, $Accounts, $x);
my($Account, 	$Email, $Balance, $Phone, $Country);
my($First_Name, $Company, $Street, $City, $State, 	$Zip);

	if (!$Accounts) {$Accounts = "None";}
	$Group ||= "";
	#----------------------------------------------------------------
	$Groups = "<tr>";
	foreach $x("A".."N") {
		$Key = "Accounts_" . $x;
		$Global{$Key} ||= "0"; $y = $x;
		if ($y eq "#") {$y = 9;}
		$Groups .= qq!<td class="TableCell" nowrap align="center"><a href="$Global{AdminURL}action=Accounts_Manager&Group=$y">
			$x ($Global{$Key})</a></td>!;
	}
	$Groups .= "</tr>";
	$Groups .= "<tr>";
	foreach $x("O".."Z", "#") {
		$Key = "Accounts_" . $x;
		$Global{$Key} ||= "0"; $y = $x;
		if ($y eq "#") { $y = 9;}
		$Groups .= qq!<td class="TableCell" nowrap align="center"><a href="$Global{AdminURL}action=Accounts_Manager&Group=$y">
			$x ($Global{$Key})</a></td>!;
	}
	$Groups .= "</tr>";
	#----------------------------------------------------------------
	if ($Param{Search_By} eq 'Account') {$Account = "selected";} else {$Account = "";}
	if ($Param{Search_By} eq 'Email') {$Email = "selected";} else {$Email = "";}
	if ($Param{Search_By} eq 'Balance') {$Balance = "selected";} else {$Balance = "";}
	if ($Param{Search_By} eq 'Phone') {$Phone = "selected";} else {$Phone = "";}
	if ($Param{Search_By} eq 'Website') {$Website = "selected";} else {$Website= "";}
	if ($Param{Search_By} eq 'FName') {$FName = "selected";} else {$FName = "";}
	if ($Param{Search_By} eq 'LName') {$LName = "selected";} else {$LName = "";}
	if ($Param{Search_By} eq 'Company') {$Company = "selected";} else {$Company = "";}
	if ($Param{Search_By} eq 'Street') {$Street = "selected";} else {$Street = "";}
	if ($Param{Search_By} eq 'City') {$City = "selected";} else {$City = "";}
	if ($Param{Search_By} eq 'State') {$State = "selected";} else {$State = "";}
	if ($Param{Search_By} eq 'Zip') {$Zip = "selected";} else {$Zip = "";}
	if ($Param{Search_By} eq 'Country') {$Country = "selected";} else {$Country = "";}
	#----------------------------------------------------------------
	#----------------------------------------------------------------
$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="Accounts_Manager_Search">

<div style="padding: 4px" align="center"><center>
  <table width="95%" border="0" cellspacing="0" cellpadding="01">
    <tr><td nowrap align="right">Search for:</td>
	  <td nowrap><input type="text" name="Terms" size="35" value="$Param{Terms}"></td>
      <td nowrap>
			<select size="1" name="Search_By">
          <option value="Account" $Account>Account</option>
		  <option value="Email" $Email>Email</option>
          <option value="Website" $Website>Website</option>
          <option value="Phone" $Phone>Phone</option>
		  <option value="FName" $FName>First Name</option>
          <option value="LName" $LName>Last Name</option>
          <option value="Company" $Company>Company</option>
		  <option value="Street" $Street>Street</option>
		  <option value="City" $City>City</option>
		  <option value="State" $State>State</option>
          <option value="Zip" $Zip>Zip</option>
          <option value="Country" $Country>Country</option>
        </select></td>
      <td width="80%" nowrap><input type="submit" value="  Search  " name="Submit"></td>
	 <td nowrap width="100%" align="right"><a href="$Global{AdminURL}action=Admin_Update_Accounts_Counts" target="_top" >Update Counts</td>
    </tr>

  </table>
  </center>
</div>
</form>

<div style="padding: 4px" align="center"><center>
  <table border="0" width="95%" cellspacing="1" cellpadding="1" class="TableAttr">
	$Groups
  </table>
  </center>
</div>

<div style="padding: 5px;">
<a href="$Global{AdminURL}action=Accounts_Manager" TARGET="_top" >Accounts</a>&nbsp;&gt;&gt;&nbsp;$Group
</div>

<form method="post" action="$Global{AdminURL}"  name="Accounts_Manager">
<input type="hidden" name="action" value="Accounts_Manager_Action">

<DIV align="center">
<CENTER>
<TABLE  BORDER="0" WIDTH="97%" CELLSPACING="0" CELLPADDING="2">
  <TR WIDTH="100%">
    <TD align="LEFT" WIDTH="40%">Showing <!--Start--> - <!--End--> of <!--Total_Count--></td>
    <TD align="RIGHT" WIDTH="25%"><!--PrevPage--> &nbsp;<!--NextPage--></td>
  </tr>
</table>
 </center>
</div>

<table  width="100%" cellspacing="0" cellpadding="2" class="TableAttr">
<tr>
	<td nowrap align="center" class="TableHeader"><b>#</b></td>
	<td nowrap align="center" class="TableHeader"><B>Account</b></td>
	<td nowrap align="center" class="TableHeader"><B>Posts</b></td>
	<td nowrap align="center" class="TableHeader"><B>Balance</b></td>
	<td nowrap align="center" class="TableHeader"><B>Email</b></td>
	<td nowrap align="center" class="TableHeader"><B>Action</b></td>
	<td nowrap align="center" class="TableHeader"><B>Delete</b></td>
	<td nowrap align="center" class="TableHeader"><B>Status</b></td>
</tr>

<!--Body-->
</table>

<div align="center">
<center>
<table  border="0" width="97%" cellspacing="0" cellpadding="2">
  <tr width="100%">
    <td align="left" width="40%">Showing <!--Start--> - <!--End--> of <!--Total_Count--></td>
    <td align="right" width="25%"><!--PrevPage--> &nbsp;<!--NextPage--></td>
  </tr>
</table>
 </center>
</div>

<br>
<div align="center">
  <center>
  <table border="0" width="97%" cellspacing="1" cellpadding="5">
      <tr><td nowrap align="right" colspan="2">
				<input type="button" value="Delete All" onClick="Delete_All();">
				<input type="button" value="Disable All" onClick="Disable_All();">
				<input type="button" value="Enable All" onClick="Enable_All();">
				<input type="button" value="Uncheck All" onClick="Uncheck_All();">
	  </td>
      </tr>

      <tr>
        <td nowrap align="center" colspan="2"><br>
		<input type="submit" value="Submit Changes" NAME="Submit"> &nbsp; <input type="reset" value="Reset" name="Reset">
		</td>
      </tr>

  </table>
  </center>
</div>
</form>
HTML
	#----------------------------------------------------------------
	return $Out;
}
#==========================================================
sub Accounts_Manager_Action{
my(%Delete, %Status, %Credit, %Debit);
my($Key, $Value, $ID, %Status_On);

	undef %Delete;
	undef %Status;
	undef %Credit;
	undef %Debit;
	undef %Status_On;

	while (($Key, $Value) = each %Param) {
			if ($Key =~ /^X\_Del\_/ ) {
					$Delete{$Value} = 1;
			}

			if ($Key =~ /^Account\_Status\_/ ) {
					$Status{$Value} = 1;
			}

			if ($Key =~ /^X\_Credit/ ) {
					($Temp, $Account) = split(/\:/, $Key);
					if ($Value) {
							$Credit{$Account} = abs($Value);
					}
			}

			if ($Key =~ /^X\_Debit/) {
					($Temp, $Account) = split(/\:/, $Key);
					if ($Value) {
							$Debit{$Account} = abs($Value) * -1;
					}
			}

			if ($Key =~ /^Status\_On\_/ ) {
					$Status_On{$Value} = 1;
			}
	}

	foreach $ID (keys %Status_On) {
			if (! $Status{$ID}) {$Status{$ID} = 0;}
	}

	if (%Delete) { 
			&Delete_Accounts(keys %Delete);
	}

	if (%Status) { 
			&Change_Accounts_Status(%Status);
	}

	$Time = &Time(time);
	$Source = "admin_payment_source";
	if (%Credit) {
			while (($Account, $Value) = each %Credit) {
#					&Make_Deposit($Account, $Value, $Time, $Source);
			}
	}
	
	$Source = "admin_debit_source";
	if (%Debit) {
			while (($Account, $Value) = each %Debit) {
	#				&Make_Deposit($Account, $Value, $Time, $Source);
			}
	}

	&UpdateNewestUser;
	&Update_Accounts_Counts;
	&Accounts_Manager;
}
#==========================================================
sub Update_Accounts_Counts{
my(%Counts, $Letter, $Query, $sth, $Temp);

	undef %Counts;
	$Counts{Accounts_Total} = 0;
	foreach $Letter("A".."Z") {
			$Query = qq!SELECT COUNT(*) FROM Users WHERE User_ID LIKE '$Letter%'!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Temp = "Accounts_" . $Letter;
			$Counts{$Temp} = $sth->fetchrow_array;
			#p ("$Temp=$Counts{$Temp}");
			$Counts{Accounts_Total} += $Counts{$Temp};
	}
	
	#$Letter = "[^0-9]";
	#$Query = qq!SELECT COUNT(*) FROM Users WHERE User_ID LIKE '$Letter%'!;
	#SELECT * FROM pet WHERE name REGEXP "^[bB]";
	$Query = qq!SELECT COUNT(*) FROM Users WHERE User_ID REGEXP "^[0-9]"!;
	$Temp = "Accounts_#";
	$Counts{$Temp} = $sth->fetchrow_array;
	$Counts{Accounts_Total} += $Counts{$Temp};
	
	$sth->finish;
	$Counts{Total_Accounts_Count} = &Get_Total_Accounts_Count();
	&UpdateSettings(%Counts);
}
#==========================================================
sub Update_Pending_Accounts_Counts{
my(%Counts, $Letter, $Query, $sth, $Temp);

	undef %Counts;
	$Counts{Accounts1_Total} = 0;
	foreach $Letter("A".."Z") {
			$Query = qq!SELECT COUNT(*) FROM Pending_Users WHERE User_ID LIKE '$Letter%'!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Temp = "Accounts1_" . $Letter;
			$Counts{$Temp} = $sth->fetchrow_array;
			#p ("$Temp=$Counts{$Temp}");
			$Counts{Accounts1_Total} += $Counts{$Temp};
	}
	
	#$Letter = "[^0-9]";
	#$Query = qq!SELECT COUNT(*) FROM Users WHERE User_ID LIKE '$Letter%'!;
	#SELECT * FROM pet WHERE name REGEXP "^[bB]";
	$Query = qq!SELECT COUNT(*) FROM Pending_Users WHERE User_ID REGEXP "^[0-9]"!;
	$Temp = "Accounts1_#";
	$Counts{$Temp} = $sth->fetchrow_array;
	$Counts{Accounts1_Total} += $Counts{$Temp};
	
	$sth->finish;
	#&UpdateConfiguration(%Counts);
	#$Counts{Total_Accounts_Count} = &Get_Total_Accounts_Count();

	&UpdateSettings(%Counts);
	&UpdateNewestUser;
}
#==========================================================
sub Admin_Manage_Account{
my (%User);

	%User = &Get_User($Param{Account});

	&Set_Cookies ("Manage_Boardawy_User", $User{User_ID}, 0);
	&Set_Cookies ("Manage_Boardawy_Password", $User{Password}, 0);

	$Param{User_ID} = $User{User_ID};
	$Param{Password} = $User{Password};
	
	if ($Global{SSL_Status}){
			$Global{AdminURL} = "$Global{SSL_URL}/$Global{MainProg}";
	}
	else{
			$Global{AdminURL} = "$Global{CGI_URL}/$Global{MainProg}";
	}

	$URL = qq!$Global{AdminURL}action=Check_AccountManager_Login&User_ID=$User{User_ID}&Password=$User{Password}&Lang=$Global{Language}!;
	print "Location: $URL\n\n";
}
#==========================================================
sub Accounts_Manager_Search{
my(@Accounts, $Orginal_Terms);
my($Query, $sth);
	
	$Orginal_Terms = $Param{Terms};

	$Param{Terms} =~ s/\$//g;
	$Param{Terms} =~ s/\?//g; 
	$Param{Terms} =~ s/\(//g;
	$Param{Terms} =~ s/\)//g;
	$Param{Terms} =~ s/\[//g;
	$Param{Terms} =~ s/\]//g;

	$Param{Terms} = lc($Param{Terms});
	$Param{Terms} =~ s/^\s+//;
	$Param{Terms} =~ s/\s+$//;
	$Param{Terms} =~ s/\s+/ /g;
	$Param{Terms} =~ s/\'/\\'/g;
	$Param{Terms}=~ s/(\*+)/\%/g;
	
	$Param{Balance_From} =~ s/\s+//;
	$Param{Balance_To} =~ s/\s+//;
	$Param{Balance_From} ||= "";
	$Param{Balance_To} ||= "";
	$Balance = "";

	if ($Param{Balance_From} ne ""){
			$Balance = " AND Current_Balance >=$Param{Balance_From} ";
	}
	if ($Param{Balance_To} ne ""){
			$Balance .= " AND Current_Balance <=$Param{Balance_To} ";
	}

	if ($Param{Total_Paid_From} ne ""){
			$Balance = " AND Total_Paid >=$Param{Total_Paid_From} ";
	}
	if ($Param{Total_Paid_To} ne ""){
			$Balance .= " AND Total_Paid <=$Param{Total_Paid_To} ";
	}


	if ($Param{Search_By} eq "Account") {
			$Query = qq!SELECT User_ID FROM Users WHERE User_ID LIKE '%$Param{Terms}%' $Balance ORDER BY User_ID ASC!;
	}
	elsif ($Param{Search_By} eq "Email") {
			$Query = qq!SELECT User_ID FROM Users WHERE Email LIKE '%$Param{Terms}%' $Balance ORDER BY Email ASC!;
	}
	elsif ($Param{Search_By} eq "Website") {
			$Query = qq!SELECT User_ID FROM Users WHERE Website LIKE '%$Param{Terms}%' $Balance ORDER BY Website ASC!;
	}
	elsif ($Param{Search_By} eq "Phone") {
			$Query = qq!SELECT User_ID FROM Users WHERE Phone LIKE '%$Param{Terms}%' $Balance ORDER BY Phone ASC!;
	}
	elsif ($Param{Search_By} eq "FName") {
			$Query = qq!SELECT User_ID FROM Users WHERE FName LIKE '%$Param{Terms}%' $Balance ORDER BY FName ASC!;
	}
	elsif ($Param{Search_By} eq "LName") {
			$Query = qq!SELECT User_ID FROM Users WHERE LName LIKE '%$Param{Terms}%' $Balance ORDER BY LName ASC!;
	}
	elsif ($Param{Search_By} eq "Street") {
			$Query = qq!SELECT User_ID FROM Users WHERE Street LIKE '%$Param{Terms}%' $Balance ORDER BY Street ASC!;
	}
	elsif ($Param{Search_By} eq "City") {
			$Query = qq!SELECT User_ID FROM Users WHERE City LIKE '%$Param{Terms}%' $Balance ORDER BY City ASC!;
	}
	elsif ($Param{Search_By} eq "State") {
			$Query = qq!SELECT User_ID FROM Users WHERE State LIKE '%$Param{Terms}%' $Balance ORDER BY State ASC!;
	}
	elsif ($Param{Search_By} eq "Zip") {
			$Query = qq!SELECT User_ID FROM Users WHERE Zip LIKE '%$Param{Terms}%' $Balance ORDER BY Zip ASC!;
	}
	elsif ($Param{Search_By} eq "Country") {
			$Query = qq!SELECT User_ID FROM Users WHERE Country LIKE '%$Param{Terms}%' $Balance ORDER BY Country ASC!;
	}
	else{
			$Query = qq!SELECT User_ID FROM Users ORDER BY User_ID ASC!;
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	undef @Accounts;
	while (($User_ID) = $sth->fetchrow_array) {
				push @Accounts, $User_ID;
	}

	$Param{Terms} = $Orginal_Terms;
	$Param{Balance_From} ||= "";
	$Param{Balance_To} ||= "";

	&List_Accounts_Manager("Accounts_Manager_Search", "&Search_By=$Param{Search_By}&Balance_From=$Param{Balance_From}&Balance_To=$Param{Balance_To}&Terms=$Orginal_Terms", @Accounts);

}
#==========================================================
sub Admin_Update_Accounts_Counts{
	
	&Update_Accounts_Counts;
	&UpdateNewestUser;
	&Read_Configuration;
	&ReadSettings;
	&Accounts_Manager;
}
#==========================================================
sub Admin_Update_Pending_Accounts_Counts{
	
	&Update_Pending_Accounts_Counts;
	&Read_Configuration;
	&ReadSettings;
	&Pending_Accounts;
}
#==========================================================
sub Admin_View_Account{
my ($Help);

	$Help =&Help_Link("Accounts_Manager");
	&Print_Page(&Admin_View_Account_Form, "Account Manager", $Help);	
}
#==========================================================
sub Admin_View_Account_Form{
my ($Temp, $Form, %Account, $Credit_Reason, $Debit_Reason, $Started, %Info);
my ($View, $Browse, $Reads, $Post, $Reply, $Edit, $Deletes);
my ($Announce, $Sticky, $Poll, $Vote, $Attach, $ViewIP);
my ($Level0, $Level1, $Level2, $K, $V, $Email, $Balance, $Total_Paid);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	#&LoadLangFile($Global{LanguageRegisterFile});

	%Account = &Get_User($Param{Account});
	%Info = &GetForumUserInfo($Param{Account});
	$Started = &Format_Date(0, $Account{Start_Date});

	$Credit_Reason = "";
	while (($K, $V) = each %Language) {
			if ($K =~ /^credit\_reason_\d+/ && $V ne "") {
					$Credit_Reason .= qq!<option value="$K">$V</option>!;
			}
	}

	$Debit_Reason = "";
	while (($K, $V) = each %Language) {
			if ($K =~ /^debit\_reason_\d+/ && $V ne "") {
					$Debit_Reason .= qq!<option value="$K">$V</option>!;
			}
	}
	#------------------------------------------------------
	if ($Account{Status}) {$Status = "checked";} else {$Status = "";}
	#------------------------------------------------------
	if ($Info{View}) {$View = "checked";} else {$View = "";}
	if ($Info{Browse}) {$Browse = "checked";} else {$Browse = "";}
	if ($Info{Readx}) {$Reads = "checked";} else {$Reads = "";}
	if ($Info{Post}) {$Post = "checked";} else {$Post = "";}
	if ($Info{Reply}) {$Reply = "checked";} else {$Reply = "";}
	if ($Info{Edit}) {$Edit = "checked";} else {$Edit = "";}
	if ($Info{Deletes}) {$Deletes = "checked";} else {$Deletes = "";}
	if ($Info{Announce}) {$Announce = "checked";} else {$Announce = "";}
	if ($Info{Sticky}) {$Sticky = "checked";} else {$Sticky = "";}
	if ($Info{Poll}) {$Poll = "checked";} else {$Poll = "";}
	if ($Info{Vote}) {$Vote = "checked";} else {$Vote = "";}
	if ($Info{Attach}) {$Attach = "checked";} else {$Attach = "";}
	if ($Info{ViewIP}) {$ViewIP = "checked";} else {$ViewIP = "";}
	#------------------------------------------------------
	$Email = qq!<a href="mailto:$Account{Email}">$Account{Email}</a>!;
	if ($Account{Current_Balance} != 0) {$Balance = sprintf("%.2f", $Account{Current_Balance});} else {$Balance = "-";}
	if ($Account{Total_Paid} != 0) {$Total_Paid = sprintf("%.2f", $Account{Total_Paid});} else{$Total_Paid = "-";}
	#------------------------------------------------------
	# 0=User, 1=Admin, 2=Mod
	if (!$Info{Level}) {$Level0 = "checked";} else { $Level0 = "";}
	if ($Info{Level} == 1) {$Level1 = "checked"; $Administrator = qq!<font color="red"><b>Administrator</b></font>!;} else { $Level1 = "";$Administrator = qq!Administrator!;}
	if ($Info{Level} == 2) {$Level2 = "checked"; $Moderator = qq!<font color="#CC0099"><b>Moderator</b></font>!;} else { $Level2 = ""; $Moderator = qq!Moderator!;}
	#------------------------------------------------------

#class="TableAttr" class="TableCell" class="TableHeader"

$Form=<<HTML;
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="AdminForumUpdateAccountInfo">
<input type="hidden" name="Account" value="$Param{Account}">

<div align="center" style="padding: 2px;"></div>
<table width="100%" cellspacing="0" cellpadding="2" class="TableAttr">
		<tr><td nowrap align="center" colspan="2" class="TableHeader">$Account{User_ID}\'s Account</td>
		<tr><td nowrap class="TableCell"><b>Username:</b></td><td width="100%" class="TableCell">$Account{User_ID}</td></tr>
		<tr><td nowrap class="TableCell"><b>First Name:</b></td><td width="100%" class="TableCell">$Account{FName}</td></tr>
		<tr><td nowrap class="TableCell"><b>Last Name:</b></td><td width="100%" class="TableCell">$Account{LName}</td></tr>
		<tr><td class="TableCell"><b>Email:</b></td><td class="TableCell">$Email</td></tr>
		<tr><td class="TableCell"><b>Address:</b></td><td class="TableCell">$Account{Street} &nbsp; <b>City:</b>  $Account{City} &nbsp; <b>State:</b>  $Account{State}</td></tr>
		<tr><td class="TableCell"><b>Country:</b></td><td class="TableCell">$Account{Country}</td></tr>
	
		<tr><td class="TableCell"><b>Phone:</b></td><td class="TableCell">$Account{Phone} &nbsp; <b>Mobile:</b> $Account{Mobile} &nbsp; <b>Fax:</b> $Account{Fax}</td></tr>
		<tr><td class="TableCell"><b>Website:</b></td><td class="TableCell"><a href="$Account{Website}" target="_blank">$Account{Website}</a></td></tr>
		<tr><td class="TableCell"><b>Company:</b></td><td class="TableCell">$Account{Company}</td></tr>
		<tr><td class="TableCell"><b>Balance:</b></td><td class="TableCell">$Language{currrency}$Balance &nbsp; <b>Deposits:</b> $Language{currrency}$Total_Paid</td></tr>
		<tr><td class="TableCell"><b>Started:</b></td><td class="TableCell">$Started</td></tr>
		<tr><td class="TableCell"><b>Posts:</b></td><td class="TableCell">$Info{Posts}</td></tr>

		<tr><td class="TableCell"><b>Status:</b></td><td class="TableCell"><input type="checkbox" name="Status" value="1" $Status></td></tr>

		<tr><td class="TableCell"><b>Level:</b></td>
		<td class="TableCell">
		<input type="radio" name="Level" value="0" $Level0> Registered User
		<input type="radio" name="Level" value="1" $Level1> $Administrator
		<input type="radio" name="Level" value="2" $Level2> $Moderator
	</td>
	</tr>

	<tr>
	<td valign="top" class="TableCell"><b><font color="#FF0000">Permissions:</font></b></td>
		<td class="TableCell">
			<table border="0" cellspacing="02" cellpadding="2">
			<tr>
					<td><input type="checkbox" name="View" value="1" $View> View</td>
					<td><input type="checkbox" name="Browse" value="1" $Browse>Browse</td>
					<td><input type="checkbox" name="Readx" value="1"  $Reads>Read</td>
					<td><input type="checkbox" name="Post" value="1" $Post>Post</td>
					<td><input type="checkbox" name="Reply" value="1" $Reply>Reply</td>
					<td><input type="checkbox" name="Edit" value="1" $Edit>Edit</td>
					<td><input type="checkbox" name="Deletes" value="1" $Deletes>Delete</td>
			</tr>
			<tr>
					<td><input type="checkbox" name="Announce" value="1" $Announce>Announce</td>
					<td><input type="checkbox" name="Sticky" value="1" $Sticky>Sticky</td>
					<td><input type="checkbox" name="Poll" value="1" $Poll>Poll</td>
					<td><input type="checkbox" name="Vote" value="1" $Vote>Vote</td>
					<td><input type="checkbox" name="Attach" value="1" $Attach>Attach</td>
					<td><input type="checkbox" name="ViewIP" value="1" $ViewIP>View IP</td>
			</tr>
			</table>			
	</td>
	</tr>

	<tr><td class="TableCell"><b><font color="#003333">Rank:</font></b></td>
		<td class="TableCell"><input type="text" name="Rank" value="$Info{Rank}"> from 0.00 to 10.00</td>
	</tr>
		
  <tr>
    <td nowrap class="TableCell"><font color="#800000"><b>Add Credit </b></font></td>
    <td class="TableCell" width="100%" nowrap>&nbsp;</td>
  </tr>

  <tr>
    <td nowrap class="TableCell"><b>Amount:</b></td>
    <td nowrap  class="TableCell" width="100%">&nbsp;$Language{currency}<input type="text" name="Credit_Amount" size="20"></td>
  </tr>
  <tr>
    <td nowrap valign="top" class="TableCell"><b>Reason:</b></td>
    <td nowrap width="100%" class="TableCell">&nbsp;<select size="1" name="Credit_Reason">$Credit_Reason</select></td>
  </tr>
  <tr>
    <td nowrap class="TableCell">&nbsp;</td>
    <td nowrap width="100%" class="TableCell">&nbsp;</td>
  </tr>

  <tr>
    <td nowrap class="TableCell"><font color="#006666"><b>Add Debit </b></font></td>
    <td width="100%" nowrap class="TableCell">&nbsp;</td>
  </tr>

  <tr>
    <td nowrap class="TableCell"><b>Amount:</b></td>
    <td nowrap width="100%" class="TableCell">&nbsp;$Language{currency}<input type="text" name="Debit_Amount" size="20"></td>
  </tr>
  <tr>
    <td nowrap valign="top" class="TableCell"><b>Reason:</b></td>
    <td nowrap width="100%" class="TableCell">&nbsp;<select size="1" name="Debit_Reason">$Debit_Reason</select><br></td>
  </tr>
  <tr>
    <td nowrap colspan="2" class="TableCell">&nbsp;</td>
  </tr>

  <tr>
    <td nowrap class="TableCell" colspan="2">
		<input type="submit" value="Submit Changes" name="Submit">&nbsp;&nbsp;
        <input type="reset" value="Reset" name="Reset">&nbsp; 
	</td>
  </tr>

</table>

</form>

HTML

	return $Form;
}
#==========================================================
sub AdminForumUpdateAccountInfo{
my (%Info, %User);

	#------------------------------------------------------------------------
	$Param{Credit_Amount} ||= 0;
	$Param{Credit_Reason} ||= "";
	$Param{Credit_Amount} = abs ($Param{Credit_Amount});
	if ($Param{Credit_Amount} > 0) {
		&Make_Deposit($Param{Account}, $Param{Credit_Amount}, &Time(time), $Param{Credit_Reason}, "", "");
	}
	#------------------------------------------------------------------------
	$Param{Debit_Amount} ||= 0;
	$Param{Debit_Reason} ||= "";
	$Param{Debit_Amount} = abs ($Param{Debit_Amount});
	if ($Param{Debit_Amount} > 0) {
		&Make_Deposit($Param{Account}, $Param{Debit_Amount} * (-1), &Time(time), $Param{Debit_Reason}, "", "");
	}
	#------------------------------------------------------------------------
	$Param{Status} ||= "";
	$Param{View} ||= 0;
	$Param{Browse} ||= 0;
	$Param{Readx} ||= 0;
	$Param{Post} ||= 0;
	$Param{Reply} ||= 0;
	$Param{Edit} ||= 0;
	$Param{Deletes} ||= 0;
	$Param{Announce} ||= 0;
	$Param{Sticky} ||= 0;
	$Param{Poll} ||= 0;
	$Param{Vote} ||= 0;
	$Param{Attach} ||= 0;
	$Param{ViewIP} ||= 0;

	$Param{Level} ||= 0;

	$Param{Rank} ||= 0;
	if ($Param{Rank} > 10) { $Param{Rank} = 10;}
	if ($Param{Rank} < 0) { $Param{Rank} = 0;}

	undef %Info;

	$Info{View} = $Param{View};
	$Info{Browse} = $Param{Browse};
	$Info{Readx} = $Param{Readx};
	$Info{Post} = $Param{Post};
	$Info{Reply} = $Param{Reply};
	$Info{Edit} = $Param{Edit};
	$Info{Deletes} = $Param{Deletes};
	$Info{Announce} = $Param{Announce};
	$Info{Sticky} = $Param{Sticky};
	$Info{Poll} = $Param{Poll};
	$Info{Vote} = $Param{Vote};
	$Info{Attach} = $Param{Attach};
	$Info{ViewIP} = $Param{ViewIP};

	$Info{Level} = $Param{Level};
	$Info{Rank} = $Param{Rank};

	#&Update_User($Param{Account}, %User);

	&UpdateForumUserInfo($Param{Account}, %Info);

	&Admin_View_Account;
}
#==========================================================
sub UpdateForumUserInfo{
my ($User_ID, %Info) = @_;
my ($Query, $Field);
	
	$User_ID = $dbh->quote($User_ID);
	$Query = qq!UPDATE Forum_Users_Info SET !;
	foreach $Field (keys %Info) {
			next if ($Field eq "User_ID");
			$Query .= "$Field=". $dbh->quote($Info{$Field}) .",";
	}
	$Query =~ s/\,$//g;
	$Query .= qq! WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Account_Credit_Debit{

	$Param{Credit_Amount} ||= "";
	$Param{Credit_Reason} ||= "";
	$Param{Credit_Amount} = abs ($Param{Credit_Amount});

	if ($Param{Credit_Amount} > 0) {
		&Make_Deposit($Param{Account}, $Param{Credit_Amount}, &Time(time), $Param{Credit_Reason}, "", "");
	}

	$Param{Debit_Amount} ||= "";
	$Param{Debit_Reason} ||= "";
	$Param{Debit_Amount} = abs ($Param{Debit_Amount});

	if ($Param{Debit_Amount} > 0) {
		&Make_Deposit($Param{Account}, $Param{Debit_Amount} * (-1), &Time(time), $Param{Debit_Reason}, "", "");
	}

	&Admin_View_Account;
}
#==========================================================
sub Pending_Accounts{
my(@Accounts);

	undef @Accounts;
	if (!$Param{Group}) {$Param{Group} = "";}
	@Accounts = &Get_Pending_Accounts_Group($Param{Group});

	&List_Pending_Accounts("Pending_Accounts", "", @Accounts);
}
#==========================================================
sub List_Pending_Accounts{
my($Page_Action, $Param, @Accounts) = @_;
my ($CurrentPage, $NextPage, $PrevPage, $LastPage, $Start);
my ($NextPage_Link, $PrevPage_Link, $TotalCount,  $End);
my($Counter, $x, $Form, $Temp_Form, %Temp, %Account);
my ($Help);

	#$Global{AdminURL} = "$Global{CGI_URL}/$Global{Accounts_Adm_Prog}";
	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Accounts;
	$LastPage = int ($TotalCount / $Global{Admin_Accounts_Per_Page});
	if (($TotalCount % $Global{Admin_Accounts_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}

	$NextPage_Link = qq!<a href="$Global{AdminURL}action=$Page_Action&Page=$NextPage$Param">Next Page</a>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=$Page_Action&Page=$PrevPage$Param">Previous Page</a>!;

	$Start = ($CurrentPage - 1) * $Global{Admin_Accounts_Per_Page};
	$End = $Start + $Global{Admin_Accounts_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next Page";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "Previous Page";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}
	
	$Tables = "";
	$Temp_Form = &Pending_Accounts_Manager_Listing_Form;
		
	$Counter = 1;
	for $x($Start..$End-1){
				$Form = $Temp_Form;
				undef %Account;
				%Account = &Get_Pending_User_Info($Accounts[$x]);

				$Temp = sprintf("%d", $x + 1);
				$Form =~ s/<!--Counter-->/$Temp/g;

				$Temp = qq!<a href="#" onClick="Javascript: Delete_Account($Counter);return false;">Delete</a>!;
				$Form =~ s/<!--Delete-->/$Temp/g;

				$Temp = qq!<input type="checkbox" name="X_Del_$Counter" value="$Account{User_ID}"  onClick="Javascript: Delete_Accountx($Counter);" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF">!;
				$Form =~ s/<!--Delete_Box-->/$Temp/g;

				$Temp = qq!<a href="#" onClick="Javascript: Account_Status($Counter);return false;">Status</a>!;
				$Form =~ s/<!--Status-->/$Temp/g;

				$Check = "";
				if ($Account{Status}) {$Check = "CHECKED";}
				$Temp = qq!<input type="checkbox" name="Account_Status_$Counter" value="$Account{User_ID}" onClick="Javascript: Account_Statusx($Counter);" $Check style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF">!;
				if ($Check) {
						$Temp .= qq!<input type="hidden" NAME="Status_On_$Counter" value="$Account{User_ID}">!;	
				}
				$Form =~ s/<!--Status_Box-->/$Temp/g;

				#$Temp = qq!<a href="$Global{AdminURL}action=Admin_Account_Edit&Account=$Account{User_ID}"><B>Manage</b></a>!;
	#Global{Script_URL}
				$Temp = qq!<a href="#" onClick="window.open('$Global{AdminURL}action=Admin_Manage_Account&Account=$Account{User_ID}&Lang=$Global{Language}','Mewsoft_AccountManager','WIDTH=600,HEIGHT=500,toolbar=yes,location=yes,directories=yes,scrollbars=yes,status=yes,menubar=yes,alwaysRaised=yes,resizable=yes,left=1,top=1');return false">Manage</a>!;
				$Form =~ s/<!--Manage-->/$Temp/g;

				$Temp = qq!<a href="mailto:$Account{Email}">$Account{Email}</a>!;
				$Form =~ s/<!--Email-->/$Temp/g;

				$Temp = qq!<a onClick="window.open('$Global{AdminURL}action=Admin_View_Pending_Account&Account=$Account{User_ID}','Mewsoft_AccountManager','WIDTH=600,HEIGHT=500,toolbar=yes,location=yes,directories=yes,scrollbars=yes,status=yes,menubar=yes,alwaysRaised=yes,resizable=yes,left=1,top=1');return false">$Account{User_ID}</a>!;
				$Form =~ s/<!--Account-->/$Temp/g;
				
				$Temp = "$Account{FName} $Account{LName}";
				$Form =~ s/<!--Name-->/$Temp/g;
				
				$Form =~ s/<!--Company-->/$Account{Company}/g;
				
				$Temp = $Account{Street};
				if ($Account{City}) {$Temp .= ", $Account{City}";}
				if ($Account{State}) {$Temp .= ", $Account{State}";}
				if ($Account{Zip}) {$Temp .= ", $Account{Zip}";}
				if ($Account{Country}) {$Temp .= ", $Account{Country}";}
				$Form =~ s/<!--Address-->/$Temp/g;

				$Form =~ s/<!--Phone-->/$Account{Phone}/g;
				$Form =~ s/<!--Mobile-->/$Account{Mobile}/g;

				$Tables .= $Form;
				$Counter++;
	}

	$Start++;

$Tables .=<<HTML;
<script language="JavaScript">
<!--
function Delete_Account(X) {
			box = eval("document.Accounts_Manager.X_Del_" +X); 
			box.checked = ! box.checked;
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.Account_Status_" + X); 
						box.checked = false;
			}
}
function Delete_Accountx(X) {
			box = eval("document.Accounts_Manager.X_Del_" +X); 
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.Account_Status_" + X); 
						box.checked = false;
			}
}

function Account_Status(X) {
			box = eval("document.Accounts_Manager.Account_Status_" +X); 
			box.checked = ! box.checked;
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.X_Del_" + X); 
						box.checked = false;
			}
}
function Account_Statusx(X) {
			box = eval("document.Accounts_Manager.Account_Status_" +X); 
			if (box.checked == true) {
						box = eval("document.Accounts_Manager.X_Del_" + X); 
						box.checked = false;
			}
}

function Delete_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = true;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Uncheck_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Disable_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = false;
		}
}

function Enable_All() {
		for (var j = 1; j < $Counter; j++) {
			box = eval("document.Accounts_Manager.X_Del_" +j); 
			box.checked = false;
			box = eval("document.Accounts_Manager.Account_Status_" +j); 
			box.checked = true;
		}
}

// -->
</script>
HTML

	if (!$Param{Group}) {$Param{Group} = "";}
	$Form = &Pending_Accounts_Manager_Form($Param{Group});

	$Form =~ s/<!--Body-->/$Tables/g;
	$Form =~ s/<!--Start-->/$Start/g;
	$Form =~ s/<!--End-->/$End/g;
	$Form =~ s/<!--Total_Count-->/$TotalCount/g;
	$Form =~ s/<!--PrevPage-->/$PrevPage/g;
	$Form =~ s/<!--NextPage-->/$NextPage/g;

	$Help =&Help_Link("Pending_Accounts_Manager");
	&Print_Page($Form, "Pending Accounts Manager", $Help);	
}
#==========================================================
sub Pending_Accounts_Manager_Listing_Form{
my ($Out);

$Out=<<HTML;
<tr>
	<td nowrap class="TableCell"><!--Counter--></td>
	<td nowrap class="TableCell"><!--Account--></td>
	<td nowrap class="TableCell"><!--Email--></td>
	<td nowrap class="TableCell"><!--Manage--></td>
	<td nowrap class="TableCell"><!--Delete_Box--></td>
	<td nowrap class="TableCell"><!--Status_Box--></td>
</tr>
HTML
  return $Out;

}
#==========================================================
sub Pending_Accounts_Manager_Form{
my($Group) = @_;
my ($Out, $Help, $Row, $Accounts, $x);
my($Account, 	$Email, $Balance, $Phone, $Country);
my($First_Name, $Company, $Street, $City, $State, 	$Zip);

	if (!$Accounts) {$Accounts = "None";}
	$Group ||= "";
	#----------------------------------------------------------------
	$Groups = "<tr>";
	foreach $x("A".."N") {
		$Key = "Accounts1_" . $x;
		$Global{$Key} ||= "0"; $y = $x;
		if ($y eq "#") { $y = 9;}
		$Groups .= qq!<td class="TableCell" nowrap align="center"><a href="$Global{AdminURL}action=Pending_Accounts&Group=$y">
			$x ($Global{$Key})</a></td>!;
	}
	$Groups .= "</tr>";
	$Groups .= "<tr>";
	foreach $x("O".."Z", "#") {
		$Key = "Accounts1_" . $x;
		$Global{$Key} ||= "0"; $y = $x;
		if ($y eq "#") { $y = 9;}
		$Groups .= qq!<td class="TableCell" nowrap align="center"><a href="$Global{AdminURL}action=Pending_Accounts&Group=$y">
			$x ($Global{$Key})</a></td>!;
	}
	$Groups .= "</tr>";
	#----------------------------------------------------------------
	if ($Param{Search_By} eq 'Account') {$Account = "selected";} else {$Account = "";}
	if ($Param{Search_By} eq 'Email') {$Email = "selected";} else {$Email = "";}
	if ($Param{Search_By} eq 'Balance') {$Balance = "selected";} else {$Balance = "";}
	if ($Param{Search_By} eq 'Phone') {$Phone = "selected";} else {$Phone = "";}
	if ($Param{Search_By} eq 'Website') {$Website = "selected";} else {$Website= "";}
	if ($Param{Search_By} eq 'FName') {$FName = "selected";} else {$FName = "";}
	if ($Param{Search_By} eq 'LName') {$LName = "selected";} else {$LName = "";}
	if ($Param{Search_By} eq 'Company') {$Company = "selected";} else {$Company = "";}
	if ($Param{Search_By} eq 'Street') {$Street = "selected";} else {$Street = "";}
	if ($Param{Search_By} eq 'City') {$City = "selected";} else {$City = "";}
	if ($Param{Search_By} eq 'State') {$State = "selected";} else {$State = "";}
	if ($Param{Search_By} eq 'Zip') {$Zip = "selected";} else {$Zip = "";}
	if ($Param{Search_By} eq 'Country') {$Country = "selected";} else {$Country = "";}
	#----------------------------------------------------------------
	#----------------------------------------------------------------
$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="Pending_Accounts_Search">
<div align="center">
  <center>
  <table width="97%" border="0" cellspacing="0" cellpadding="01">
    <tr><td nowrap align="right">Search for:</td>
	  <td nowrap><input type="text" name="Terms" size="30" value="$Param{Terms}"></td>
      <td nowrap><select size="1" name="Search_By">
          <option value="Account" $Account>Account</option>
		  <option value="Email" $Email>Email</option>
          <option value="Website" $Website>Website</option>
          <option value="Phone" $Phone>Phone</option>
		  <option value="FName" $FName>First Name</option>
          <option value="LName" $LName>Last Name</option>
          <option value="Company" $Company>Company</option>
		  <option value="Street" $Street>Street</option>
		  <option value="City" $City>City</option>
		  <option value="State" $State>State</option>
          <option value="Zip" $Zip>Zip</option>
          <option value="Country" $Country>Country</option>
        </select></td>
      <td width="80%" nowrap><input type="submit" value="  Search  " name="Submit"></td>
	 <td nowrap width="100%" align="right">
			<a href="#" onClick="window.open('$Global{AdminURL}action=Resend_Confirmation','','width=700,height=550,toolbar=yes,location=yes,directories=yes,scrollbars=yes,status=yes,menubar=yes,alwaysRaised=yes,resizable=yes,left=1,top=1');">Resend Confirmation</a>
			&nbsp; <a href="$Global{AdminURL}action=Admin_Update_Pending_Accounts_Counts" target="_top" >Update Counts
	</td>
    </tr>
  </table>
  </center>
</div>
</form>

<div style="padding: 4px" align="center"><center>
  <table border="0" width="95%" cellspacing="1" cellpadding="1" class="TableAttr">
	$Groups
  </table>
  </center>
</div>

<div style="padding: 5px;">
<a href="$Global{AdminURL}action=Pending_Accounts" TARGET="_top" >Accounts</a>&nbsp;&gt;&gt;&nbsp;$Group
</div>

<form method="post" action="$Global{AdminURL}"  name="Accounts_Manager">
<input type="hidden" name="action" value="Pending_Accounts_Action">

<div align="center">
<center>
<table  border="0" width="97%" cellspacing="0" cellpadding="2">
  <tr width="100%">
    <td align="left" width="40%">Showing <!--Start--> - <!--End--> of <!--Total_Count--></td>
    <td align="right" width="25%"><!--PrevPage--> &nbsp;<!--NextPage--></td>
  </tr>
</table>
 </center>
</div>

<table class="TableAttr" width="100%">
<tr>
	<td nowrap class="TableHeader" align="center">#</td>
	<td nowrap class="TableHeader" align="center">Account</td>
	<td nowrap class="TableHeader" align="center">Email</td>
	<td nowrap class="TableHeader" align="center">Action</td>
	<td nowrap class="TableHeader" align="center">Delete</td>
	<td nowrap class="TableHeader" align="center">Activate</td>
</tr>

<!--Body-->

</table>

<div align="center">
<center>
<table  border="0" width="97%" cellspacing="0" cellpadding="2">
  <tr width="100%">
    <td align="left" width="40%">Showing <!--Start--> - <!--End--> of <!--Total_Count--></td>
    <td align="right" width="25%"><!--PrevPage--> &nbsp;<!--NextPage--></td>
  </tr>
</table>
 </center>
</div>

<br>
<div align="center">
  <center>
  <table border="0" width="97%" cellspacing="1" cellpadding="5">
      <tr><td nowrap align="right" colspan="2">
				<input type="button" value="Delete All" onClick="Delete_All();">
				<input type="button" value="Disable All" onClick="Disable_All();">
				<input type="button" value="Enable All" onClick="Enable_All();">
				<input type="button" value="Uncheck All" onClick="Uncheck_All();">
	  </td>
      </tr>

      <tr>
        <td nowrap align="center" colspan="2">
			<input type="submit" value="Submit Changes" name="Submit">&nbsp;&nbsp;
			<input type="reset" value="Reset" name="Reset">
		</td>
      </tr>

  </table>
  </center>
</div>
</form>
HTML
	return $Out;
}
#==========================================================
sub Pending_Accounts_Search{
my(@Accounts, $Orginal_Terms);
my($Query, $sth);
	
	$Orginal_Terms = $Param{Terms};

	$Param{Terms} =~ s/\$//g;
	$Param{Terms} =~ s/\?//g; 
	$Param{Terms} =~ s/\(//g;
	$Param{Terms} =~ s/\)//g;
	$Param{Terms} =~ s/\[//g;
	$Param{Terms} =~ s/\]//g;

	$Param{Terms} = lc($Param{Terms});
	$Param{Terms} =~ s/^\s+//;
	$Param{Terms} =~ s/\s+$//;
	$Param{Terms} =~ s/\s+/ /g;
	$Param{Terms} =~ s/\'/\\'/g;
	$Param{Terms}=~ s/(\*+)/\%/g;
	
	if ($Param{Search_By} eq "Account") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE User_ID LIKE '%$Param{Terms}%' $Balance ORDER BY User_ID ASC!;
	}
	elsif ($Param{Search_By} eq "Email") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Email LIKE '%$Param{Terms}%' $Balance ORDER BY Email ASC!;
	}
	elsif ($Param{Search_By} eq "Website") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Website LIKE '%$Param{Terms}%' $Balance ORDER BY Website ASC!;
	}
	elsif ($Param{Search_By} eq "Phone") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Phone LIKE '%$Param{Terms}%' $Balance ORDER BY Phone ASC!;
	}
	elsif ($Param{Search_By} eq "FName") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE FName LIKE '%$Param{Terms}%' $Balance ORDER BY FName ASC!;
	}
	elsif ($Param{Search_By} eq "LName") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE LName LIKE '%$Param{Terms}%' $Balance ORDER BY LName ASC!;
	}
	elsif ($Param{Search_By} eq "Street") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Street LIKE '%$Param{Terms}%' $Balance ORDER BY Street ASC!;
	}
	elsif ($Param{Search_By} eq "City") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE City LIKE '%$Param{Terms}%' $Balance ORDER BY City ASC!;
	}
	elsif ($Param{Search_By} eq "State") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE State LIKE '%$Param{Terms}%' $Balance ORDER BY State ASC!;
	}
	elsif ($Param{Search_By} eq "Zip") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Zip LIKE '%$Param{Terms}%' $Balance ORDER BY Zip ASC!;
	}
	elsif ($Param{Search_By} eq "Country") {
			$Query = qq!SELECT User_ID FROM Pending_Users WHERE Country LIKE '%$Param{Terms}%' $Balance ORDER BY Country ASC!;
	}
	else{
			$Query = qq!SELECT User_ID FROM Pending_Users ORDER BY User_ID ASC!;
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	undef @Accounts;
	while (($User_ID) = $sth->fetchrow_array) {
				push @Accounts, $User_ID;
	}

	$Param{Terms} = $Orginal_Terms;

	&List_Pending_Accounts("Pending_Accounts_Search", "&Search_By=$Param{Search_By}&Balance_From=$Param{Balance_From}&Balance_To=$Param{Balance_To}&Terms=$Orginal_Terms", @Accounts);
}
#==========================================================
sub Admin_View_Pending_Account{
my($Help);

	$Help =&Help_Link("Pending_Accounts_Manager");
	&Print_Page(&Admin_View_Pending_Account_Form, "Pending Account Manager", $Help);	

}
#==========================================================
sub Admin_View_Pending_Account_Form{
my($Temp, $Form, %Account, $Credit_Reason, $Debit_Reason, $Started, %Info);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	#&LoadLangFile($Global{LanguageRegisterFile});

	%Account = &Get_Pending_User_Info($Param{Account});
	%Info = &Get_User_Info($Param{Account});

	$Started = &Format_Date(0, $Account{Start_Date});
	#------------------------------------------------------
	$Email = qq!<a href="mailto:$Account{Email}">$Account{Email}</a>!;
	if ($Account{Current_Balance} != 0) {$Balance = sprintf("%.2f", $Account{Current_Balance});} else {$Balance = "-";}
	if ($Account{Total_Paid} != 0) {$Total_Paid = sprintf("%.2f", $Account{Total_Paid});} else{$Total_Paid = "-";}
	$Name = $Account{FName};
	if ($Account{LName}) {$Name .= ", $Account{LName}";}
	#------------------------------------------------------

$Form=<<HTML;
<table class="TableAttr" width="100%" cellspacing="0" cellpadding="2">
		<tr><td nowrap align="center" colspan="2" class="TableHeader">$Account{User_ID}\'s Pending Account</td>
		<tr><td nowrap class="TableCell"><b>Username:</b></td><td class="TableCell" width="100%">$Account{User_ID}</td></tr>
		<tr><td nowrap class="TableCell"><b>First Name:</b></td><td class="TableCell" width="100%">$Account{FName}</td></tr>
		<tr><td nowrap class="TableCell"><b>Last Name:</b></td><td class="TableCell" width="100%">$Account{LName}</td></tr>
		<tr><td class="TableCell"><b>Email:</b></td><td class="TableCell">$Email</td></tr>
		<tr><td class="TableCell"><b>Address:</b></td><td class="TableCell"> $Account{Street} &nbsp; <b>City:</b>  $Account{City} &nbsp; <b>State:</b>  $Account{State}</td></tr>
		<tr><td class="TableCell"><b>Country:</b></td><td class="TableCell">$Account{Country}</td></tr>
		<tr><td class="TableCell"><b>Phone:</b></td><td class="TableCell">$Account{Phone} &nbsp; <b>Mobile:</b> $Account{Mobile} &nbsp; <b>Fax:</b> $Account{Fax}</td></tr>
		<tr><td class="TableCell"><b>Website:</b></td><td class="TableCell"><a href="$Account{Website}" target="_blank">$Account{Website}</a></td></tr>
		<tr><td class="TableCell"><b>Company:</b></td><td class="TableCell">$Account{Company}</td></tr>
		<tr><td class="TableCell"><b>Registered:</b></td><td class="TableCell">$Started</td></tr>
</table>
HTML

	return $Form;
}
#==========================================================
sub Pending_Account_Update{

	&Admin_View_Pending_Account($Param{Account});

}
#==========================================================
sub Resend_Confirmation{
my(@Accounts, %Account, $Count, $Counter, $URL, $Temp);
my($Msg, $Subj, $Body);

	print "Content-type: text/html\n\n";
	print qq!<P align="center"><font size="4">Sending Pending Accounts Confirmation Emails</font></P>!;

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	&ReadClasses;

	undef @Accounts;
	@Accounts = &Get_Pending_Accounts_Group("");
	$Count = @Accounts;
	print "<b>$Count Pending Accounts Found.</b><br><br>";

	if ($Global{SSL_Status}){
			$URL = qq!$Global{SSL_URL}/$Global{MainProg}!;
	}
	else{
			$URL = qq!$Global{CGI_URL}/$Global{MainProg}!;
	}

	$Msg = &Translate_Classes(&Translate($Language{pre_registration_email_message}));
	$Subj = &Translate_Classes(&Translate($Language{pre_registration_email_subject}));

	$Counter = 0;
	foreach $Account (@Accounts) {
		undef %Account;
		%Account = &Get_Pending_User_Info($Account);
		$Counter++;
		print "<b>$Counter-</b> $Account ... $Account{Email} <br>";
		
		$Body = $Msg;
		$Body =~ s/<!--Name-->/$Account{FName} $Account{LName}/g;
		$Body =~ s/<!--FName-->/$Account{FName}/g;
		$Body =~ s/<!--LName-->/$Account{LName}/g;
		$Body =~ s/<!--User_ID-->/$Account{User_ID}/g;

		$Body =~ s/<!--Confirmation_Code-->/$Account{Confirmation_Code}/g;
		$Temp = qq!$URL?action=ConfirmRegistration&Email=$Account{Email}&Code=$Account{Confirmation_Code}!;
		$Body =~ s/<!--Confirmation_URL-->/$Temp/g;

		#print "<p>$Subj <br><br>$Body</p>";
		
		#Email($From, $TO, $Subject,   $Message);
		&Email($Global{Account_Confirmation_Email}, $Account{Email}, $Subj, $Body);
	}
	
	print qq!<P align="center"><a href="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></b></a></P>!;	

}
#==========================================================
sub Pending_Accounts_Action{
my(%Delete, %Status, $Temp);
my($Key, $Value,  %Status_On);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	&ReadClasses;

	undef %Delete;
	undef %Status;
	undef %Status_On;

	while (($Key, $Value) = each %Param) {
			if ($Key =~ /^X\_Del\_/ ) {
					$Delete{$Value} = 1;
			}

			if ($Key =~ /^Account\_Status\_/ ) {
					$Status{$Value} = 1;
			}

			if ($Key =~ /^Status\_On\_/ ) {
					$Status_On{$Value} = 1;
			}
	}

	foreach $ID (keys %Status_On) {
			if (! $Status{$ID}) {$Status{$ID} = 0;}
	}

	if (%Delete) { 
			foreach $Temp (keys %Delete) {
					&Delete_Pending_User	($Temp);
			}
			
	}

	foreach $ID (keys %Status) {
			if (!$Status{$ID}) {delete $Status{$ID};}
	}

	if (%Status) { 
			&Activate_Pending_Accounts(keys %Status);
			&UpdateNewestUser;
	}
	
	if ($Global{Auto_Update_Accounts_Counts}) {
			&UpdateSettings(Total_Accounts_Count => &Get_Total_Accounts_Count);
	}

	&Pending_Accounts;
}
#==========================================================
sub Activate_Pending_Accounts{
my (@Accounts) = @_;
my (%User, $Body, $Subject);

	$Global{New_Users_Status} ||= 0;
	%Promot = &Get_Promotional_Code_File;
	$Body = &Translate_Classes(&Translate($Language{registration_confimation_email}));
	$Subject = &Translate_Classes(&Translate($Language{registration_confimation_subject}));

	foreach $Account (@Accounts) {
			undef %User;
			%User = &Get_Pending_User_Info($Account);
			
			$User{Status} = $Global{New_Users_Status};
			
			if ($Promot{$User{Promotional_Code}}){
					$Promot = $Promot{$User{Promotional_Code}};
			}
						
			&Add_New_User(%User);
			&Activate_New_Pending_User($Subject, $Body, $Promot, %User);

			&Delete_Pending_User($User{User_ID});
	}#End foreach $Account
	
	
}
#==========================================================
sub Activate_New_Pending_User{
my ($Subj, $Msg, $Promot, %User) = @_;
my (%Card, %Info, $Source, $Temp, $Name);

	if ($Global{Require_Credit_Card}){
			%Card = %User;
			$Card{Street} = $User{Street1};
			$Card{City} = $User{City1};
			$Card{State} = $User{State1};
			$Card{Zip} = $User{Zip1};
			$Card{Country} = $User{Country1};
			$Card{DefaultCC} = 1; # Make it the default card for payments.
			&Save_Credit_Card(%Card);
	}

	#------------------------------------------------------
	undef %Info;
	$Info{User_ID} = $User{User_ID};

	$Info{Sell} = $Global{New_Users_Sellers};
	$Info{Buy} = $Global{New_Users_Buyers};
	$Info{Status} = $Global{New_Users_Status};
	$Info{Verified} = "";
	$Info{Verified1} = "";
	$Info{Verified2} = "";
	$Info{Partner} = "";
	$Info{Sponser} = "";
	$Info{Power} = "";
	$Info{Rated} = "";

	&Add_New_User_Info(%Info);
	#------------------------------------------------------
	undef %Info;
	$Info{User_ID} = $User{User_ID};

	$Info{View} = $Global{New_Users_View};
	$Info{Browse} = $Global{New_Users_Browse};
	$Info{Readx} = $Global{New_Users_Reads};
	$Info{Post} = $Global{New_Users_Post};
	$Info{Reply} = $Global{New_Users_Reply};
	$Info{Edit} = $Global{New_Users_Edit};
	$Info{Deletes} = $Global{New_Users_Deletes};
	$Info{Announce} = $Global{New_Users_Announce};
	$Info{Sticky} = $Global{New_Users_Sticky};
	$Info{Poll} = $Global{New_Users_Poll};
	$Info{Vote} = $Global{New_Users_Vote};
	$Info{Attach} = $Global{New_Users_Attach};
	$Info{ViewIP} = $Global{New_Users_ViewIP};
	
	$Info{LastVisit} = &Time(time);
	$Info{Level} = 0; # 0=User, 1=Admin, 2=Mod
	$Info{Posts} = 0;
	$Info{Timezone} = $Global{GMT_Offset};
	$Info{Language} = $Global{Language};
	$Info{DateFormat} = $Global{DateFormat};
	$Info{EmailTime} = 0;
	$Info{ViewEmail} = 1;
	$Info{AttachSign} = 1;
	$Info{AllowPM} = 1;
	$Info{ViewOnline} = 1;
	$Info{NotifyPM} = 1;
	$Info{Rank} = 0;
	$Info{Avatar} = "";
	$Info{Location} = "";
	$Info{WebTitle} = "";
	$Info{WebURL} = "";
	$Info{Sig} = "";
	$Info{ICQ} = "";
	$Info{AIM} = "";
	$Info{YIM} = "";
	$Info{MSNM} = "";
	$Info{Occupation} = "";
	$Info{Interests} = "";
	$Info{Custom1} = "";
	$Info{Custom2} = "";
	$Info{Custom3} = "";
	$Info{Custom4} = "";
	$Info{Custom5} = "";
	$Info{Custom6} = "";
	$Info{Custom7} = "";
	$Info{Custom8} = "";
	$Info{Custom9} = "";
	$Info{Custom10} = "";

	&Add_New_Forum_Users_Info(%Info);
	#------------------------------------------------------
	if ($Global{New_Account_Deposit} > 0) {
		$Source = "new_account_credit_payment_source";
		&Make_Deposit($User{User_ID}, $Global{New_Account_Deposit}, &Time(time), $Source, "", "");
	}
	elsif ($Global{New_Account_Deposit} < 0) {
		$Source = "new_account_debit_payment_source";
		&Make_Deposit($Param{User_ID}, $Promot, &Time(time), $Source, "", "");
	}

	if ($Promot > 0) {
		$Source = "new_account_promot_payment_source";
		&Make_Deposit($User{User_ID}, $Promot, &Time(time), $Source, "", "");
	}
	#------------------------------------------------------------
	#$Msg = &Translate_Classes(&Translate($Language{registration_confimation_email}));
	#$Subj = &Translate_Classes(&Translate($Language{registration_confimation_subject}));

	$Name = $User{FName};
	$Name .= " ".$User{LName} if ($User{LName} ne "");
	$Msg =~ s/<!--Name-->/$Name/g;
	$Msg =~ s/<!--FName-->/$User{FName}/g;
	$Msg =~ s/<!--LName-->/$User{LName}/g;
	$Msg =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Msg =~ s/<!--Password-->/$User{Password}/g;
	$Msg =~ s/<!--Email-->/$User{Email}/g;

	$Subj =~ s/<!--Name-->/$Name/g;
	$Subj =~ s/<!--FName-->/$User{FName}/g;
	$Subj =~ s/<!--LName-->/$User{LName}/g;
	$Subj =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Subj =~ s/<!--Email-->/$User{Email}/g;

	#Email($From, $TO, $Subject,   $Message);
	&Email($Global{Account_Confirmation_Email}, $User{Email}, $Subj, $Msg);
	#------------------------------------------------------------
	#$Param{User_ID} = $User{User_ID};
	&CreateAboutMe($User{User_ID});
}
#==========================================================
sub AccountsOptions{
my ($Help);

	$Help =&Help_Link("Accounts_Manager");
	&Print_Page(&AccountsOptionsForm(), "Account Manager", $Help);	
}
#==========================================================
sub AccountsOptionsForm{
my ($Out, $TotalUsers);
	
	$TotalUsers = &Get_Total_Accounts_Count;

$Out=<<HTML;
<div style="padding: 1px; width:100%">
<table border="0" cellpadding="3" cellspacing="3" style="border-collapse: collapse" width="100%">
  <tr><td width="100%"><b><a href="$Global{AdminURL}action=RegistrationFieldsOptions">Registration Page Options</a></b></td></tr>
  <tr><td width="100%"><b><a href="$Global{AdminURL}action=BannedEmailsList">Banned domains and emails list</a></b></td></tr>
</table>
</div>

<br>
HTML
	return $Out;
}
#==========================================================
sub BannedEmailsList{
	$Help =&Help_Link("Accounts_Manager");
	&Print_Page(&BannedEmailsListForm(), "Account Manager", $Help);	
}
#==========================================================
sub BannedEmailsListForm{
my ($Out, $List);

	open (File, "$Global{BannedEmail_File}") || &Exit("Cannot read file $Global{BannedEmail_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	$List = join ("", <File>);
	close File;

$Out=<<HTML;
<form method="POST" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveBannedEmailsList">
<table class="TableAttr" cellpadding="3" cellspacing="0">
  <tr class="TableHeader">
    <td width="100%">User registration banned domains and emails list<br>
	</td>
  </tr>
  <tr><td width="100%" class="TableCell">
    Please enter each entry on one line. You can ban entire domain using *\@domain.com. 	You can use Perl regular experssions.
	</td>
  </tr>
  <tr>
    <td width="100%" class="TableCell">
      <textarea name="List" style="width: 600px; height: 300px">$List</textarea>
	</td>
	</tr>
  <tr>
    <td width="100%" class="TableCell">
		<input type="submit" value="Save List" name="Submit"> &nbsp;&nbsp;&nbsp;
		<input type="reset" value="Reset" name="Reset">
    </td>
  </tr>
</table>
    </form>

HTML
	return $Out;
}
#==========================================================
sub SaveBannedEmailsList{
my (@List, $List, %List);

	$Param{List} ||= "";
	$Param{List} = lc($Param{List});

	$Param{List} =~ s/^\s+//g;
	$Param{List} =~ s/\s+$//g;

	@List = split(/\cM/, $Param{List});
	
	undef %List;
	foreach $List (@List) {
			$List =~ s/^\s+//g;
			$List =~ s/\s+$//g;
			if (!$List) {next;}
			$List{$List} = 1;
	}

	@List = sort keys %List;
	
	open (File, ">$Global{BannedEmail_File}") || &Exit("Cannot create file $Global{BannedEmail_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	foreach $List (@List) {
			print File "$List\n";
	}
	close File;

	&AccountsOptions;
}
#==========================================================
sub RegistrationFieldsOptions{
my ($Message) = @_;
my ($Help);

	$Help =&Help_Link("Accounts_Manager");
	&Print_Page(&RegistrationFieldsOptions_Form($Message), "Account Manager", $Help);	
}
#==========================================================
sub RegistrationFieldsOptions_Form{
my ($Message) = @_;
my ($Out);

	%Fields = &GetRegisterSettings;
	undef %Option;
	undef %Option1;
	undef %Option2;
	foreach $Field (keys %Fields) {
			if ($Fields{$Field}{Required}) {$Option{$Field} = "checked";} else {$Option{$Field} = "";}
			if ($Fields{$Field}{Register}) {$Option1{$Field} = "checked";} else {$Option1{$Field} = "";}
			if ($Fields{$Field}{Edit}) {$Option2{$Field} = "checked";} else {$Option2{$Field} = "";}
	}

$Out=<<HTML;
<div align="center" style="padding: 5px; width: 100%">
	$Message
</div>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveRegistrationFieldsOptions">

<table cellpadding="2" cellspacing="0" width="600" class="TableAttr">
  <tr><td class="TableHeader" align="center" colspan="4">User Registration Options</td></tr>
  <tr>
    <td class="TableSubHeader" align="center"><b>Field</b></td>
    <td class="TableSubHeader" align="center"><b>Required</b></td>
    <td class="TableSubHeader" align="center"><b>Register</b></td>
    <td class="TableSubHeader" align="center" nowrap width="100%"><b>Edit Profile</b></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Email:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Email" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Email}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Email" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Email}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Email" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Email}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">First name:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="FName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{FName}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_FName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{FName}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_FName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{FName}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Last name:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="LName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{LName}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_LName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{LName}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_LName" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{LName}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Company:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Company" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Company}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Company" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Company}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Company" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Company}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Job title:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Job_Title" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Job_Title}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Job_Title" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Job_Title}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Job_Title" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Job_Title}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Street:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Street}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Street}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Street}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">City:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{City}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{City}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{City}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">State:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{State}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{State}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{State}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Zip:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Zip}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Zip}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Zip}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Country:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Country}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Country}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Country}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Phone:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Phone}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Phone}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Phone}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Mobile:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Mobile" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Mobile}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Mobile" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Mobile}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Mobile" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Mobile}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Fax:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Fax" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Fax}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Fax" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Fax}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Fax" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Fax}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Website:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Website" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Website}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Website" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Website}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Website" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Website}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Promotional Code:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Promotional_Code" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Promotional_Code}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Promotional_Code" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Promotional_Code}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Promotional_Code" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Promotional_Code}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Security Code:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="SecurityCode" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{SecurityCode}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_SecurityCode" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{SecurityCode}></td>
    <td width="25%" align="center" class="TableCell"><input disabled type="checkbox" name="Y_SecurityCode" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{SecurityCode}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Agree:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Agree" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{Agree}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_Agree" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{Agree}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_Agree" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{Agree}></td>
  </tr>
  <tr>
    <td width="100%" colspan="4">&nbsp;<p><b>Billing Information:</b></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">Card Type:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Type" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Type}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Type" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Type}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Type" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Type}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Card Number:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Number" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Number}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Number" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Number}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Number" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Number}></td>
  </tr>
	
  <tr>
    <td width="50%"  class="TableCell">Name on card:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Name" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Name}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Name" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Name}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Name" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Name}></td>
  </tr>

 <tr>
    <td width="50%"  class="TableCell">Expiration Month:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Month" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Month}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Month" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Month}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Month" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Month}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Expiration Year:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Year" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Year}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Year" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Year}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Year" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Year}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">CCV:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_CVV" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_CVV}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_CVV" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_CVV}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_CVV" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_CVV}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Issue Number:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_IssueNum" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_IssueNum}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_IssueNum" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_IssueNum}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_IssueNum" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_IssueNum}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Card Bank:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Bank" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Bank}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Bank" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Bank}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Bank" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Bank}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Card Bank Phone:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Phone}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Phone}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Phone" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Phone}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Billing Street:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Street}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Street}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Street" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Street}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Billing City:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_City}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_City}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_City" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_City}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Billing State:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_State}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_State}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_State" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_State}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Billing Zip:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Zip}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Zip}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Zip" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Zip}></td>
  </tr>
  <tr>
    <td width="50%"  class="TableCell">Billing Country:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="CC_Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{CC_Country}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_CC_Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{CC_Country}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_CC_Country" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{CC_Country}></td>
  </tr>

  <tr>
    <td width="100%" colspan="4">&nbsp;<p><b>Custom Fields:</b></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User1:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User1" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User1}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User1" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User1}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User1" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User1}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User2:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User2" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User2}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User2" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User2}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User2" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User2}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User3:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User3" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User3}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User3" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User3}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User3" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User3}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User4:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User4" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User4}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User4" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User4}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User4" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User4}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User5:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User5" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User5}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User5" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User5}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User5" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User5}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User6:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User6" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User6}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User6" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User6}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User6" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User6}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User7:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User7" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User7}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User7" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User7}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User7" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User7}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User8:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User8" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User8}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User8" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User8}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User8" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User8}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User9:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User9" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User8}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User9" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User8}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User9" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User8}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User10:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User10" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User10}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User10" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User10}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User10" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User10}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User11:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User11" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User11}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User11" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User11}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User11" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User11}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User12:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User12" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User12}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User12" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User12}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User12" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User12}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User13:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User13" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User13}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User13" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User13}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User13" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User13}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User14:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User14" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User14}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User14" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User14}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User14" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User14}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User15:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User15" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User15}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User15" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User15}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User15" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User15}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User16:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User16" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User16}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User16" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User16}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User16" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User16}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User17:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User17" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User17}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User17" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User17}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User17" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User17}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User18:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User18" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User18}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User18" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User18}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User18" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User18}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User19:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User19" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User19}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User19" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User19}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User19" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User19}></td>
  </tr>
<tr>
    <td width="50%"  class="TableCell">User20:</td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="User20" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option{User20}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="X_User20" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option1{User20}></td>
    <td width="25%" align="center" class="TableCell"><input type="checkbox" name="Y_User20" value="1" style="BORDER-RIGHT: 0px solid; PADDING-RIGHT: 0px; BORDER-TOP: 0px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; BORDER-LEFT: 0px solid; PADDING-TOP: 0px; BORDER-BOTTOM: 0px solid; BACKGROUND-COLOR: #FFFFFF" $Option2{User20}></td>
  </tr>

  <tr>
    <td colspan="4" align="center" class="TableCell">
			<input type="submit" value="Save Changes" name="submit">&nbsp;&nbsp;
		    <input type="reset" value="Reset" NAME="Reset">&nbsp; 
	  </td>
  </tr>
</table>
</form>
HTML
	return $Out;
}
#==========================================================
sub SaveRegistrationFieldsOptions{
my ($K, $V, $Active, $Required);

	open (File, ">$Global{RegisterOptions_File}") || &Exit("Cannot create file $Global{RegisterOptions_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);

	@Fields = &GetAccountFields;
	foreach $K (@Fields) {
				$Required = $Param{$K};
				$K1 = "X_" . $K;
				$Register = $Param{$K1};
				$K2 = "Y_" . $K;
				$Edit = $Param{$K2};
				$Required ||= "0"; $Register ||= "0"; $Edit ||= "0";
				print File "$K|$Required|$Register|$Edit\n";
	}

	close(File);
	#&RegistrationFieldsOptions(qq!<p align="center"><font color="red" size="3"><b>Changes Saved</b></font></p>!);
	&AccountsOptions;
}
#==========================================================
sub GetAccountFields{
my (@Fields);

	@Fields = qw(
							Email
							FName
							LName
							Company
							Job_Title
							Street
							City
							State
							Zip
							Country
							Phone
							Mobile
							Fax
							Website
							Promotional_Code
							SecurityCode
							Payment_Method
							CC_Number
							CC_Name
							CC_Type
							CC_Month
							CC_Year
							CC_CVV
							CC_IssueNum
							CC_Bank
							CC_Phone
							CC_Street
							CC_City
							CC_State
							CC_Zip
							CC_Country
							Agree
							User1
							User2
							User3
							User4
							User5
							User6
							User7
							User8
							User9
							User10
							User11
							User12
							User13
							User14
							User15
							User16
							User17
							User18
							User19
							User20
				);
	return @Fields;
}
#==========================================================
1;
