=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Community{
my ($Template, @Boards);
	
	$Template = &TranslateFile($Global{CommunityTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	#----------------------------------------------------------------
	@Boards = &GetForumBoards;
	$Param{Board} ||= $Boards[0];
	$Template =~ s/<!--Board-->/$Param{Board}/g;
	#----------------------------------------------------------------
	%Board = &GetForumBoard($Param{Board});
	$Template =~ s/<!--Zone1-->/$Board{Zone1}/g;
	$Template =~ s/<!--Zone2-->/$Board{Zone2}/g;
	$Template =~ s/<!--Zone3-->/$Board{Zone3}/g;
	$Template =~ s/<!--Zone4-->/$Board{Zone4}/g;
	$Template =~ s/<!--Description-->/$Board{Description}/g;
	#----------------------------------------------------------------
	&DeleteOldForumBoardPosts($Param{Board});
	#----------------------------------------------------------------
	$List = "";
	foreach $Board (@Boards) {
			%Board = &GetForumBoard($Board);
			$Line = $Language{board_list_line};
			$Line =~ s/<!--ID-->/$Board{Board}/g;
			$Line =~ s/<!--Name-->/$Board{Name}/g;
			if ($Param{Board} eq $Board) {
					$Selected = "Selected";
			}
			else{
					$Selected = "";
			}
			$Line =~ s/<!--Selected-->/$Selected/g;
			$List .= $Line;
	}
	$Template =~ s/<!--BoardList-->/$List/g;
	#----------------------------------------------------------------
	@Times = split(/\|/, $Language{message_times});
	$List = "";
	foreach $Time (@Times) {
			($Period, $Name) = split(/\:/, $Time);
			$Line = $Language{message_times_line};
			$Line =~ s/<!--Period-->/$Period/g;
			$Line =~ s/<!--Name-->/$Name/g;
			if ($Param{MessageTime} eq $Time) {
					$Selected = "Selected";
			}
			else{
					$Selected = "";
			}
			$Line =~ s/<!--Selected-->/$Selected/g;
			$List .= $Line;
	}
	$Template =~ s/<!--MessageTimeList-->/$List/g;
	#----------------------------------------------------------------
	@Colors = split(/\|/, $Language{color_list});
	$List = "";
	$Param{Color} ||= $Language{default_color};
	foreach $Color (@Colors) {
			$Line = $Language{color_list_line};
			$Line =~ s/<!--Color-->/$Color/g;
			if ($Param{Color} eq $Color) {
					$Selected = "Selected";
			}
			else{
					$Selected = "";
			}
			$Line =~ s/<!--Selected-->/$Selected/g;
			$List .= $Line;
	}
	$Template =~ s/<!--ColorList-->/$List/g;
	#----------------------------------------------------------------
	if ($Param{Bold}) {
		$Template =~ s/<!--Bold-->/checked/g;
	}
	else{
		$Template =~ s/<!--Bold-->//g;
	}
	#----------------------------------------------------------------
	if ($Param{Italic}) {
		$Template =~ s/<!--Italic-->/checked/g;
	}
	else{
		$Template =~ s/<!--Italic-->//g;
	}
	#----------------------------------------------------------------
	$Template =~ s/<!--Color-->/$Param{Color}/g;
	#----------------------------------------------------------------
	@Posts = &GetForumBoardPosts($Param{Board});
	@Forms = (&Translate($Global{BoardListingForm}), &Translate($Global{BoardListingForm1}));

	$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Forms[1] =~ m/(<!--)(PostTime)(:\(?)([^\)]+)(\)?-->)/){
				$PostTimeClass = $1 . $2 . $3. $4. $5;
				$PostTimeFormat =  $4;
	}
	$PostTimeClass =~ s/\(/\\\(/g;
	$PostTimeClass =~ s/\)/\\\)/g;
	
	$List = "";
	for $Counter (0.. $#Posts-0) {
			%Post = &GetForumBoardPost($Posts[$Counter]);
			$Form = $Forms[int($Counter % 2)]; 
			$Temp = $Counter+1;
			$Form =~ s/<!--Counter-->/$Temp/g;
			$Form =~ s/<--Poster-->/$Post{User_ID}/g;
			$Form =~ s/<!--Message-->/$Post{Message}/g;

			$Temp = &ParseDate($PostTimeFormat, $Post{Date});
			$Form =~ s/$PostTimeClass/$Temp/g;

			$Post{Color} ||= "Black";
			$Form =~ s/<!--Color-->/$Post{Color}/g;
			if ($Post{Bold}) {
					$Form =~ s/<!--Bold-->/<B>/g;
					$Form =~ s/<!--Bold1-->/<\/B>/g;
			}
			else{
					$Form =~ s/<!--Bold-->//g;
					$Form =~ s/<!--Bold1-->//g;
			}

			if ($Post{Italic}) {
					$Form =~ s/<!--Italic-->/<I>/g;
					$Form =~ s/<!--Italic1-->/<\/I>/g;
			}
			else{
					$Form =~ s/<!--Italic-->//g;
					$Form =~ s/<!--Italic1-->//g;
			}

			$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Post{User_ID}&Lang=$Global{Language}!;
			$Form =~ s/<!--PosterLink-->/$Temp/g;
			#------------------------------------------------------
			if ($Global{Auctionawy_Plugin}) {
					($Rating, $Stars) = &Get_User_Feedback_Stars($Post{User_ID});
					if (!$Rating) {
							$Temp = $Language{feedback_rating_zero};
					}
					else{
							$Temp = $Language{feedback_rating};
					}
					$Temp =~ s/<!--FeedbackRating-->/$Rating/g;
					$Temp =~ s/<!--FeedbackStars-->/$Stars/g;
					$Form =~ s/<!--Feedback-->/$Temp/g;

					$Temp1 = &GetUserOpenAuctionsCount($Post{User_ID});
					if ($Temp1 > 0) {
						$Temp = $Language{member_auctions};
					}
					else {
						$Temp = $Language{member_auctions_zero};
					}
					$Link = qq!$Global{AuctionMainURL}?action=Browse&Search=SellerAuctions&Status=&SellerID=$Post{User_ID}&Lang=$Global{Language}!;
					$Temp =~ s/<!--MemberAuctionsLink-->/$Link/g;
					$Temp =~ s/<!--Auctions-->/$Temp1/g;
					$Form =~ s/<!--MemberAuctions-->/$Temp/g;
					$Form =~ s/<!--Auctions-->/$Temp1/g;

					$Temp = qq!$Global{AuctionMainURL}?action=ListUserFeedback&User_ID_Feedback=$Post{User_ID}&Lang=$Global{Language}!;
					$Form =~ s/<!--MemberFeedbackLink-->/$Temp/g;
			}
			#------------------------------------------------------
			if ($Global{Classifiedawy_Plugin}) {
					$Temp1 = &GetUserOpenAdsCount($Post{User_ID});
					if ($Temp1 > 0) {
							$Temp = $Language{member_ads};
					}
					else {
							$Temp = $Language{member_ads_zero};
					}
					$Link = qq!$Global{ClassifiedMainURL}?action=Browse&Search=SellerAds&Status=&SellerID=$Post{User_ID}&Lang=$Global{Language}!;
					$Temp =~ s/<!--MemberAdsLink-->/$Link/g;
					$Temp =~ s/<!--Ads-->/$Temp1/g;
					$Form =~ s/<!--MemberAds-->/$Temp/g;
					$Form =~ s/<!--Ads-->/$Temp1/g;
			}
			#------------------------------------------------------
			$Temp = $Language{about_me_link};
			$Link = qq!$Global{AboutMe_URL}/$Post{User_ID}!;
			$Temp =~ s/<!--AboutMeLink-->/$Link/g;
			$Temp =~ s/<!--Author-->/$Post{Author}/g;
			$Form =~ s/<!--AboutMe-->/$Temp/g;
			#------------------------------------------------------
			$List .= $Form;
	}
	$Template =~ s/<!--MessageList-->/$List/g;

	&Display($Template, 1);
}
#==========================================================
sub CommunityBoardPost{
	
	&Check_Account_Login;

	if (!$Global{AllowCommunityBoards}) {
			$Plugins{Body} = $Language{communitry_boards_disabled};
			&Display($Global{GeneralTemplate});
			&Quit;
	}

	$Param{Board} ||= "";
	$Param{Message} ||= "";

	$Param{Message} ||= "";
	$Param{Message} =~ s/^\s+//;
	$Param{Message} =~ s/\s+$//;
	$Param{Message} = &HTML_Treat($Param{Message}, $Global{Board_Treat_HTML});
	$Param{Message} = substr($Param{Message}, 0, $Global{Board_Max_Len});

	if (!$Param{Board} || !$Param{Message}) {
		&Community;
		return;
	}

	$Param{Bold} ||= "";
	$Param{Italic} ||= "";
	$Param{Color} ||= "";

	$Message = $dbh->quote($Param{Message});
	$Post = &GetNewBoardPostID;
	$User_ID = $dbh->quote($Param{User_ID});
	$Date = &Time(time);
	$IP = $ENV{REMOTE_ADDR};
	$IP = $dbh->quote($IP);
	if ($Param{Bold}) {$Param{Bold} ="1";}
	if ($Param{Italic}) {$Param{Italic} ="1";}
	$Bold = $dbh->quote($Param{Bold});
	$Italic = $dbh->quote($Param{Italic});
	$Color = $dbh->quote($Param{Color});

	$Query = qq!INSERT INTO Forum_CommunityPosts SET
								Board=$Param{Board},
								Post=$Post,
								Message=$Message,
								User_ID=$User_ID,
								Date=$Date,
								Bold=$Bold,
								Italic=$Italic,
								Color=$Color,
								IP=$IP
								!;

	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	&Community;
}
#==========================================================
1;