=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub GetAllBoardsID{
my ($Query, %Boards, $sth, $ID);

	$Query = qq!SELECT Board FROM Forum_CommunityBoards!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Boards;
	while(($ID) = $sth->fetchrow_array) {$Boards{$ID}=1;}
	$sth->finish;
	return %Boards;
}
#==========================================================
sub GetForumBoards{
my ($Query, @Boards);

	undef @Boards;
	$Query = qq!SELECT Board FROM Forum_CommunityBoards ORDER BY Sort ASC, Name ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while(($ID) = $sth->fetchrow_array) {push @Boards, $ID;}
	$sth->finish;
	return @Boards;
}
#==========================================================
sub GetForumBoard{
my ($Board) = @_;
my ($Query, %Board);
	
	undef %Board;
	if (!$Board) {return %Board;}
	$Query = qq!SELECT * FROM Forum_CommunityBoards WHERE Board=$Board!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	%Board = %{$sth->fetchrow_hashref()};
	$sth->finish;
	return %Board;
}
#==========================================================
sub GetNewBoardPostID{
my ($ID, %Posts);

	$ID = 1;
	%Posts = &GetAllBoardsPostsID;
	while ($Posts{$ID}) {$ID++;}
	return $ID;
}
#==========================================================
sub GetAllBoardsPostsID{
my ($Query, %Posts, $sth, $ID);

	$Query = qq!SELECT Post FROM Forum_CommunityPosts!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Posts;
	while(($ID) = $sth->fetchrow_array) {$Posts{$ID}=1;}
	$sth->finish;
	return %Posts;
}
#==========================================================
sub GetForumBoardPosts{
my ($Board) = @_;
my ($Query, @Posts);
	
	undef @Posts;
	if (!$Board) {return @Posts;}
	$Query = qq!SELECT Post FROM Forum_CommunityPosts WHERE Board=$Board ORDER BY Date DESC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while(($ID) = $sth->fetchrow_array) {push @Posts, $ID;}
	$sth->finish;
	return @Posts;
}
#==========================================================
sub GetForumBoardPost{
my ($Post) = @_;
my ($Query, %Post);

	$Query = qq!SELECT * FROM Forum_CommunityPosts WHERE Post=$Post!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	%Post = %{$sth->fetchrow_hashref()};
	$sth->finish;
	return %Post;
}
#==========================================================
sub DeleteOldForumBoardPosts{
my ($Board) = @_;

	# delete board posts
	if (!$Board) {return;}
	$Time = &Time(time) - 24*60*60;
	$Query = qq!DELETE From Forum_CommunityPosts WHERE Board=$Board AND Date<=$Time!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

}
#==========================================================
1;