=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub CommunityManager{
my ($Message) = @_;
my ($Help);

	$Message ||= "";
	$Help = &Help_Link("Community_Manager");
	&Print_Page(&CommunityManagerForm($Message), "Community Manager", $Help);
}
#==========================================================
sub CommunityManagerForm{
my ($Message) = @_;
my ($Out, $List);

	@Boards = &GetForumBoards;
	
	$List = "";
	foreach $Board (@Boards) {
			%Board = &GetForumBoard($Board);
			$Link = qq!<a href="$Global{AdminURL}action=CommunityManager&Board=$Board&Lang=$Param{Lang}"><b>$Board{Name}</b></a>!;
			$Edit = qq!<a href="$Global{AdminURL}action=EditBoard&Board=$Board&Lang=$Param{Lang}"><b>Edit</b></a>!;
			$Delete = qq!<a href="$Global{AdminURL}action=DeleteBoard&Board=$Board&Lang=$Param{Lang}"><b>Delete</b></a>!;
			$Line = &Board_Manager_Line($Link, $Board{Sort}, $Edit, $Delete);
			$List .= $Line;
	}

$Out=<<HTML;
<table border="0" width="100%" cellspacing="0" cellpadding="0">
<tr>
	<td width="100%">&nbsp;</td>
	<td align="right" nowrap>&nbsp;$Update_Boards_Counts&nbsp;</td>
</tr>
</table>

<table border="0" width="100%" cellspacing="0" cellpadding="2">
<tr><td width="100%">$Guide_Bar</td></tr>
</table>

<table class="TableAttr" width="100%"  cellspacing="0" cellpadding="2">
<tr>
  <td width="60%" class="TableHeader" align="center">Board</td>
  <td width="20%" class="TableHeader" align="center">Sort</td>
  <td width="20%" class="TableHeader"  align="center" colspan="2">Action</td>
</tr>
  $List
</table>
<br>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateNewBoards">
<input type="hidden" name="Forum" value="$Param{Board}">
<input type="hidden" name="Lang" value="$Param{Lang}">

<table class="TableAttr" width="100%" cellspacing="0" cellpadding="0">
 <tr><td width="100%" class="TableHeader">Create New Boards</td></tr>
<tr><td  valign="top" align="left" class="TableCell">
		<p align="justify">Please enter one board name per line and press enter at the end of each line. <br>
		You can create any number of boards.<br>
	</P>
	</td></tr>
	<tr><td  valign="top" align="left" class="TableCell">
			<font color="#000000" face="tahoma,arial, helvetica" size="2">$Guide_Bar</font>
	</td></tr>
	<tr><td valign="top" align="left" class="TableCell">
				<textarea name="NewBoardsNames" style="width: 500px; height: 200px;"></textarea>
	</td>
	</tr>
	<tr><td valign="top" align="left" class="TableCell">
	  <input type="submit" value="Create Boards"> &nbsp;&nbsp;
	  <input type="reset" value="Clear Form">
	  </td>
	</tr>
</table>
</form>
<br>
HTML
	return $Out;

	return $Out;
}
#==========================================================
sub Board_Manager_Line{
my ($Link, $Sort, $Edit, $Delete) = @_;

$Out=<<HTML;
<tr>
<td width="60%" class="TableCell">&nbsp;$Link</td>
<td width="20%" class="TableCell" align="center" >$Sort</td>
<td width="10%" class="TableCell" align="center" >&nbsp;$Edit&nbsp;</td>
<td width="10%" class="TableCell" align="center" >&nbsp;$Delete&nbsp;</td>
</tr>
HTML
	return $Out;
}
#==========================================================
sub CreateNewBoards{
my (@Names,  $Name, $Forum, $Query);

	if (!$Param{Forum}) {$Param{Forum} = 0;}

	$Param{NewBoardsNames} =~ s/^\s+//;
	$Param{NewBoardsNames} =~ s/\s+$//;
	$Param{NewBoardsNames} =~ s/\s+$/ /g;

	if (!$Param{NewBoardsNames}) {
		&CommunityManager(qq!<p align="center"><b><font size="4" color="red">Error: No boards names</font></b></p>!);
		return;
	}
	
	undef @Names;
	@Names = split(/\n/, $Param{NewBoardsNames});

	foreach $Name(sort @Names){
				$Name =~ s/\n//g;
				$Name =~ s/\r//g;
				$Name =~ s/\cM//g;
				$Name=~ s/^\s+//g;
				$Name=~ s/\s+$//g;
				if (!$Name) {next;}

				$Name = $dbh->quote($Name);

				$Query = qq!INSERT INTO Forum_CommunityBoards SET
											Board=NULL,
											Name=$Name,
											Description='',

											Sort=0,
											Posts=0,

											Meta_Title='',
											Meta_Description='',
											Meta_Keywords='',

											Zone1='',
											Zone2='',
											Zone3='',
											Zone4=''
								!;

				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	} # foreach $Name(sort @Names){
	
	&CommunityManager(qq!<p align="center"><b><font size="4" color="red">Boards created</font></b></p>!);
}
#==========================================================
sub DeleteBoard{
my ($Help);
my (%Board, @SubForums, $SubForumsCount, $SubForums, $Out);
my ($Forum, $ID_Ref, $Name_Ref, @ID, @Name);

	$Param{Board} ||= "";
	%Board = &GetForumBoard($Param{Board});
	if (!$Param{Board}) {
			&CommunityManager();
			return;
	}
	
$Out=<<HTML;
<br>
<div align="center">
<form method="post" action="$Global{AdminURL}">
  <input type="hidden" name="action" value="ProcessDeleteBoard">
  <input type="hidden" name="Board" value="$Param{Board}">

<table width="600" border="0" cellspacing="0" cellpadding="4" STYLE="border: 0 outset #F7F7F7" bordercolor="#7FFF81">
		<tr><td colspan="2" align="center"><b><font color="#FF0000" size="4">Delete Board Confirmation</font></td></tr>
		<tr><td colspan="2"><p align="justify"><b>Please confirm that you want to delete this Board and all its posts. Please note, this action can not be undone. All messages and all data associated with this board will be delete.</b></p>
		</td></tr>
		<tr><td nowrap><b>Board Name :</b></td><td width="100%">$Board{Board}</td></tr>
		<tr><td nowrap><b>Board ID :</b></td><td>$Board{Board}</td></tr>
		<tr><td nowrap><b>Board Posts :</b></td><td>$Board{Posts}</td></tr>

		<tr><td colspan="2" align="center"><b><font color="#FF0000">Are you sure you still want to delete this board?</font></td></tr>
		<tr><td align="center" colspan="2">
			<input type="submit" value="Yes Delete This Board" style="color: #000080; border-style: ridge">
		</td>
		</tr>

</table>
</form>
</div>
HTML

	$Help = &Help_Link("Community_Manager");
	&Print_Page($Out, "Community Manager", $Help);
}
#==========================================================
sub ProcessDeleteBoard{
my (@Forums, $Forums, $Query, $sth, @Topics, $Temp);
my (%Forum, @Posts, $Posts, $Topics);

	$Param{Board} ||= "";
	if (!$Param{Board}) {
			&CommunityManager();
			return;
	}

	# delete board posts
	$Query = qq!DELETE From Forum_CommunityPosts WHERE Board=$Param{Board}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE From Forum_CommunityBoards WHERE Board=$Param{Board}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	&CommunityManager();
}
#==========================================================
sub EditBoard{
my (%Forum, $Active, $Accept, $Status, $Bar, $Out, $Help);
	
	$Param{Board} ||= "";
	%Board = &GetForumBoard($Param{Board});
	if (!$Param{Board}) {
			&CommunityManager();
			return;
	}
	
	$Board_Name =&Encode_HTML($Board{Name});

	$Bar = qq!<a href="$Global{AdminURL}action=CommunityManager">Community Manager</a> > $Board{Name} > Edit Board!;

	#-----------------------------------------------------------------------------------
$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
  <input type="hidden" name="action" value="SaveEditBoard">
  <input type="hidden" name="Board" value="$Param{Board}">

<div style="padding: 5px;">$Bar</div>

<table class="TableAttr" width="100%" border="0" cellspacing="0" cellpadding="2">
<tr><td align="center" colspan="2" width="100%" class="TableHeader">Editing Board $Board{Name}</td></tr>
<tr><td nowrap class="TableCell"><b>Board Name :</b></td><td class="TableCell">$Board{Name}</td></tr>
<tr><td nowrap class="TableCell"><b>Board ID :</b></td><td class="TableCell">$Board{Board}</td></tr>
<tr><td class="TableCell"><b>Sort Order:</b></td><td class="TableCell"><input type="text" name="Sort" size="15" value="$Board{Sort}" ></td></tr>

<tr><td class="TableCell"><b>Board:</b></td>
<td class="TableCell"><input type="text" name="Name" size="60" value="$Board_Name"> HTML allowed</td>
</tr>

<tr><td valign="top" class="TableCell"><b>Description:</b><br>HTML allowed</td>
<td class="TableCell"><textarea rows="7" name="Description" cols="50">$Board{Description}</textarea></td>
</tr>

<tr><td nowrap class="TableCell"><b>Meta Title:</b></td>
<td class="TableCell"><input type="text" name="Meta_Title" size="55" value="$Board{Meta_Title}"></td>
</tr>
<tr><td nowrap valign="top" class="TableCell"><b>Meta Description:</b><br>HTML allowed</td>
<td class="TableCell"><textarea rows="7" name="Meta_Description" cols="50">$Board{Meta_Description}</textarea></td>
</tr>

<tr><td nowrap valign="top" class="TableCell"><b>Meta Keywords:</b></td>
<td class="TableCell"><textarea rows="7" name="Meta_Keywords" cols="50">$Board{Meta_Keywords}</textarea></td>
</tr>

<tr><td nowrap valign="top" class="TableCell"><b>Zone1:</b><br>HTML allowed</td>
<td class="TableCell"><textarea rows="5" name="Zone1" cols="50">$Board{Zone1}</textarea></td>
</tr>

<tr><td nowrap valign="top" class="TableCell"><b>Zone2:</b><br>HTML allowed</td>
<td class="TableCell" class="TableCell"><textarea rows="5" name="Zone2" cols="50">$Board{Zone2}</textarea></td>
</tr>

<tr><td nowrap valign="top" class="TableCell"><b>Zone3:</b><br>HTML allowed</td>
<td class="TableCell"><textarea rows="5" name="Zone3" cols="50">$Board{Zone3}</textarea></td>
</tr>

<tr><td nowrap valign="top" class="TableCell"><b>Zone4:</b><br>HTML allowed</td>
<td class="TableCell"><textarea rows="5" name="Zone4" cols="50">$Board{Zone4}</textarea></td>
</tr>

<tr><td align="center" colspan="2" class="TableCell">
	<input type="submit" value="Save Changes" style="color: #000080; border-style: ridge">
	<input type="reset" value="Reset Form" style="color: #000080; border-style: ridge">&nbsp;
	</td>
</tr>
  </table>
</form>
<br>
HTML

	$Help = &Help_Link("Community_Manager");
	&Print_Page($Out, "Community Manager", $Help);
}
#==========================================================
sub SaveEditBoard{
my ($Name, $Icon, $Description, $Redirect, $Meta_Title);
my ($Meta_Description, $Meta_Keywords, $Zone1);
my ($Zone2, $Zone3, $Zone4, $Query, %Forum);

	$Name = &Web_Decode($Param{Name});
	$Name =~ s/\n//g;
	$Name =~ s/\r//g;
    $Name =~ s/\cM//g;
	$Name =~ s/^\s+//g;
	$Name =~ s/\s+$//g;
	
	$Param{Sort} ||= 0;

	$Name = $dbh->quote($Name);
	$Description = $dbh->quote($Param{Description});
	$Meta_Title = $dbh->quote($Param{Meta_Title});
	$Meta_Description =$dbh->quote( $Param{Meta_Description});
	$Meta_Keywords =$dbh->quote($Param{Meta_Keywords});
	
	$Param{Zone1} ||= "";
	$Param{Zone2} ||= "";
	$Param{Zone3} ||= "";
	$Param{Zone4} ||= "";
	$Zone1 = $dbh->quote($Param{Zone1});
	$Zone2 = $dbh->quote($Param{Zone2});
	$Zone3 = $dbh->quote($Param{Zone3});
	$Zone4 = $dbh->quote($Param{Zone4});

	$Query = qq!UPDATE Forum_CommunityBoards SET 
								Name=$Name,
								Description=$Description,
								Sort=$Param{Sort},

								Meta_Title=$Meta_Title,
								Meta_Description=$Meta_Description,
								Meta_Keywords=$Meta_Keywords,

								Zone1=$Zone1,
								Zone2=$Zone2,
								Zone3=$Zone3,
								Zone4=$Zone4

								WHERE Board=$Param{Board}
							!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	&CommunityManager();
}
#==========================================================

1;