=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ContactUs{
my ($Template, $Temp);

	&LoadLangFile($Global{LanguageContactUsFile});
	$Template =&TranslateFile($Global{ContactUsTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/;
	$Template =~ s/<!--Language-->/$Global{Language}/;
	
	$Template =~ s/<!--IP-->/$ENV{REMOTE_ADDR}/g;
	$Temp = &GetHostname($ENV{REMOTE_ADDR});
	$Template =~ s/<!--Host-->/$Temp/g;

	$Plugins{Bar_Action} = $Language{contact_us_menu_label};
	$Plugins{Menu_Bar} = "";

	$Param{SecurityCode} ||= "";
	$Template =~ s/<!--SecurityCode-->/$Param{SecurityCode}/g;
	$SecImgLink = &GetSecurityImage("BoardawyContactUS");
	$Template =~ s/<!--SecurityImageLink-->/$SecImgLink/g;

	$Plugins{Body}="";
    &Display($Template,1);
}
#==========================================================
sub Send_ContactUs{
my ($Msg, $Temp);

	&LoadLangFile($Global{LanguageContactUsFile});

	$Msg = "";

	if (!&Check_Email_Address($Param{Email})) {
			$Msg .= $Language{invalid_email};
	}

	$Param{Name} =~ s/^\s+//;
	$Param{Name} =~ s/\s+$//;
	$Param{Name} =~ s/\s+/ /g;
	$Param{Name} =~ s/\cM//g;
	
	$Param{Subject} =~ s/^\s+//;
	$Param{Subject} =~ s/\s+$//;
	$Param{Subject} =~ s/\s+/ /g;
	$Param{Subject} =~ s/\cM//g;

	$Param{Phone} =~ s/^\s+//;
	$Param{Phone} =~ s/\s+$//;
	$Param{Phone} =~ s/\s+/ /g;
	$Param{Phone} =~ s/\cM//g;

	$Param{Email} =~ s/^\s+//;
	$Param{Email} =~ s/\s+$//;
	$Param{Email} =~ s/\s+/ /g;
	$Param{Email} =~ s/\cM//g;

	$Param{Message} =~ s/^\s+//;
	$Param{Message} =~ s/\s+$//;
	$Param{Message} =~ s/\cM//g;
	$Param{Message} =~ s/\n/\<br\>/g;

	$Param{SecurityCode} =~ s/^\s+//;
	$Param{SecurityCode} =~ s/\s+$//;

	if (!$Param{Name}) {$Msg .= $Language{error_name};}
	if (!$Param{Phone}) {$Msg .= $Language{error_phone};}
	if (!$Param{Subject}) {$Msg .= $Language{error_subject};}
	if (!$Param{Message}) { $Msg .= $Language{error_message};}
	if (!$Param{Email}) { $Msg .= $Language{error_email};}
	#----------------------------------------------------------------
	if (!$Param{SecurityCode}) {$Msg .= $Language{error_security_code};}
	$Param{SecurityCode} = uc($Param{SecurityCode});
	if ($Param{SecurityCode}) {
		$Digest = md5_hex($Param{SecurityCode} . $Global{Secure_Key});
		if (!-e "$Global{HTML_Dir}/SecImg/$Digest\.jpg") {
			$Msg .= $Language{error_security_code};
		}
	}
	#----------------------------------------------------------------
	$Param{Message} =~ s/[\>]\s*\n/\> /g;
	$Param{Message} =~ s/\n/\<br\>/g;

	if ($Msg) {
					$Plugins{Body} = &Msg($Language{missing_information}, $Msg, 1);
					&Display($Global{GeneralTemplate});
					return;
	}
	#----------------------------------------------------------------
	unlink "$Global{HTML_Dir}/SecImg/$Digest\.jpg";
	#----------------------------------------------------------------
	$Msg = $Language{contact_email_body};
	$Msg =~ s/<!--Name-->/$Param{Name}/g;
	$Msg =~ s/<!--Email-->/$Param{Email}/g;
	$Msg =~ s/<!--Phone-->/$Param{Phone}/g;
	$Msg =~ s/<!--Subject-->/$Param{Subject}/g;
	$Msg =~ s/<!--Message-->/$Param{Message}/g;
	$Msg =~ s/<!--Contact-->/$Param{Contact}/g;
	$Msg =~ s/<!--SenderLink-->/$Global{ProgURL}/g;
	$Msg =~ s/<!--IP-->/$ENV{REMOTE_ADDR}/g;
	$Temp = &Get_Host;
	$Msg =~ s/<!--IP-->/$Temp/g;
	
	$Temp = &GetHostname($ENV{REMOTE_ADDR});
	$Msg =~ s/<!--Host-->/$Temp/g;

	if ($Global{Demo_Mode}) {
			$Plugins{Body} = &Msg("Email Disabled. Demo Mode.","Sorry Email System Disabled. Your Message Not Sent. Demo Mode.", 2);
	}
	else {
			&Email($Param{Email}, $Global{ContactUs_Email}, $Language{contact_us_email_subject}, $Msg);
			if ($Param{Contact}) {
				&Email($Param{ContactUs_Email}, $Global{ContactUs_Email}, $Language{contact_us_email_subject}, $Msg);
			}
			$Plugins{Body} = &Msg($Language{contact_us_received}, $Language{contact_us_received_description}, 2);
	}

	&Display($Global{GeneralTemplate});
}
#==========================================================
1;