=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Database_Manager{
my($Help);

	$Help =&Help_Link("Database_Manager");

	&Print_Page(&Database_Manager_Form, "Database & SQL Manager", $Help);
}
#==========================================================
sub Database_Manager_Form{
my($Out, $Tables, $Temp, $Mode);

	@Tables = &DB_Show_Tables;

	$Tables = qq!<select name="Tables_Selected" size="5" multiple>!;
	foreach $Temp (@Tables) {
				$Tables .= qq!<option value="$Temp"> $Temp </option>!;
	} 
	$Tables .= qq!</select>!;
	
	if ($Global{DB_File_Priv}) {
			$Mode = qq!<option selected value="1">Fast</option><option value="0">Normal</option>!;
	}
	else{
			$Mode = qq!<option value="1">Fast</option><option selected value="0">Normal</option>!;
	}

$Out=<<HTML;
<br>
<table border="0" width="100%"  cellspacing="1" cellpadding="2" class="TableAttr">

	  <tr><td width="100%" class="TableCell">
		<a href="#" onClick="SQL_Text_Backup_Confirm(); return false;">Backup SQL Database Into Text Files</a>
		</td></tr>

      <tr><td width="100%" class="TableCell">
			<a href="#" onClick="Load_SQL_Backup_Confirm(); return false;">Restore SQL Database From The Text Files Backup</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=Load_Unload_SQL_Tables">Load/Unload SQL Database Tables</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=Manage_SQL_Tables">Manage SQL Database Tables</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=Manage_SQL_Databases">Manage SQL Databases</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=SQL_Commander">SQL Commander</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a href="#" onClick="SQL_Compress_Confirm(); return false;">Compress All SQL Database Files</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a href="#" onClick="SQL_Extract_Confirm(); return false;">Extract All SQL Database Files</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a href="#" onClick="SQL_DeleteTextFiles_Confirm(); return false;">Delete All SQL Database Text Backup Files</a>
      </td></tr>

	  <tr><td width="100%" class="TableCell">
		  <a href="#" onClick="SQL_DeleteZipFiles_Confirm(); return false;">Delete All SQL Database Compressed Backup Files</a>
      </td></tr>

      <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=SQL_Administration">SQL Server Administration</a>
      </td></tr>

	  <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=SQL_Server_Status">Display SQL Server Status</a>
      </td></tr>

	  <tr><td width="100%" class="TableCell">
		  <a  href="$Global{AdminURL}action=SQL_Server_Variables">Display SQL Server Variables</a>
      </td></tr>
	  
	</table>
<br>

<!--------------------------------------------------------------------------------->
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveDatabaseOptions">

<table width="100%" cellpadding="4" cellspacing="0" class="TableAttr">
<tr><td colspan="2" class="TableHeader" align="center">SQL Options</td></tr>
	<td colspan="2">Please select the database backup/restore and tables Load/Unload mode.</td></tr>
    <tr><td colspan="2">Mode: <select name="DB_File_Priv" size="1">$Mode</select></td></tr>
	<td colspan="2"><p align="justify"><b>Fast</b> mode uses the sql server OUTFILE/LOAD statements to backup and restore tables. Much faster but requires the <font color="#990000"><b>File_Priv</b></font> option set to 'Y' (Enabled) on the database for the user. Ask your server administrator for it.</p></td></tr>
	<td colspan="2"><p align="justify"><b>Normal</b> mode uses the sql server single SELECT/INSERT statements to backup and restore tables.</p></td></tr>
	<td colspan="2"><p align="justify"><b>Mode</b> used to backup or unload MUST be used for restore or load.</p></td></tr>
	<tr><td nowrap align="center" colspan="2">
			<input type="submit" value="Save Changes" name="Submit">&nbsp;
			<input type="reset" value="Reset" name="Reset">
	</td>
    </tr>
    </tr>
  </table>
</form>
<br>
<!-------------------------------------------------------------------------------->
<script language="JavaScript">
<!--
function SQL_Text_Backup_Confirm() {
	var agree=confirm("Are you sure you want to create text backup of the current SQL Database contents?\\nSQL database tables will be unloaded to text files with the same names as the tables.\\n");
	if (agree){
					//window.location = "$Global{AdminURL}action=SQL_Text_Backup";
					window.open('$Global{AdminURL}action=SQL_Text_Backup','MEWSOFT','WIDTH=600,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
	}
}

function Load_SQL_Backup_Confirm() {
	var agree=confirm("Are you sure you want to DELETE the current SQL Database contents\\nand load a new contents from previously made text backup?\\n");
	if (agree){
			var agree=confirm("Please note this process can not be undone , you will not be able to recover the current SQL database contents again.\\nAre you sure you still want to load the backup Database?\\n");
			if (agree){
					//window.location = "$Global{AdminURL}action=Load_SQL_Text_Backup";
					window.open('$Global{AdminURL}action=Load_SQL_Text_Backup','MEWSOFT','WIDTH=500,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
			}
	}
}

function SQL_Compress_Confirm() {
	var agree=confirm("Are you sure you want to compress the current SQL Database files?\\nThis will overwrite any current compressed files.\\n");
	if (agree){
					window.open('$Global{AdminURL}action=CompressDatabaseFiles','MEWSOFT','WIDTH=740,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
	}
}
function SQL_Extract_Confirm() {
	var agree=confirm("Are you sure you want to extract the current SQL Database Compressed  files?\\nThis will overwrite any current uncompressed database files.\\n");
	if (agree){
					window.open('$Global{AdminURL}action=ExtractDatabaseFiles','MEWSOFT','WIDTH=740,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
	}
}

function SQL_DeleteTextFiles_Confirm() {
	var agree=confirm("Are you sure you want to delete the current SQL Database Text Backup files?\\n");
	if (agree){
					window.open('$Global{AdminURL}action=DeleteTextDatabaseFiles','MEWSOFT','WIDTH=740,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
	}
}
function SQL_DeleteZipFiles_Confirm() {
	var agree=confirm("Are you sure you want to delete the current SQL Database Compressed Backup files?\\n");
	if (agree){
					window.open('$Global{AdminURL}action=DeleteCompressedDatabaseFiles','MEWSOFT','WIDTH=740,HEIGHT=400,scrollbars=yes,toolbar=yes,location=no,directories=no,status=yes,menubar=no,alwaysRaised=yes,resizable=yes,left=1,top=1');
	}
}

//onClick=window.open('','Mewsoft','WIDTH=500,HEIGHT=400,scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');
//link=open(GoTo, "$Title","toolbar=no, scrollbars=yes, directories=no,menubar=no,resizable=yes,width=400,height=500");
-->
</script>
HTML
	return $Out;
}
#==========================================================
sub Load_Unload_SQL_Tables{
my ($Help);

	$Help = &Help_Link("Load_Unload_SQL_Tables");
	&Print_Page(&Load_Unload_SQL_Tables_Form, "Load / Unload SQL Tables", $Help);	
}
#==========================================================
sub Load_Unload_SQL_Tables_Form{
my($Out, $Tables, $Temp);

	@Tables = &DB_Show_Tables;

	$Tables = "";
	foreach $Temp (@Tables) {
				$Tables .= qq!<OPTION VALUE="$Temp"> $Temp </OPTION>!;
	} 

$Out=<<HTML;
<div align="left" style="padding: 5px;"><b>To select more than one table, drag your mouse or click with the &lt;CTRL&gt; Key pressed.</b></div>

<form name="Tables_Action" method="post" action="$Global{AdminURL}" target="Mewsoft">
<input type="hidden" value="SQL_Tables_Load_Unload" name="action">

<table width="500" cellpadding="4" cellspacing="0" class="TableAttr">
	<tr><td align="right" nowrap valign="top"><b>Select Table(s): </b></td>
		<td align="left" width="100%">
			<select name="Tables_Selected" style="width: 350px; height: 350px;" multiple>$Tables</select>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
		<input type="submit" value="Load" name="Table_Action" onClick="Load_SQL_Tables_Confirm(); return false;">
		&nbsp;&nbsp;
		<input type="submit" value="UnLoad" name="Table_Actionx" onClick="UnLoad_SQL_Tables_Confirm(); return false;">
		<input type="hidden" value="" name="Table_Actions">
		</td>
	</tr>
</table>

</form>

<script language="JavaScript">
<!--
function Load_SQL_Tables_Confirm() {
	var agree=confirm("Are you sure you want to DELETE the selected SQL Tables contents\\nand Load a new contents from previously made text backup?\\n");
	if (agree){
			var agree=confirm("Please note this process can not be undone , you will not be able to recover the current SQL tables contents again.\\nAre you sure you still want to load the backup tables?\\n");
			if (agree){
				document.Tables_Action.Table_Actions.value=document.Tables_Action.Table_Action.value;
				Mewsoft = window.open('','Mewsoft','WIDTH=500,HEIGHT=400,toolbar=yes, location=yes,directories=yes,menubar=yes,scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');
				Mewsoft.document.open();
				Mewsoft.document.focus();
				document.Tables_Action.submit();
			}
	}
}

function UnLoad_SQL_Tables_Confirm() {
	var agree=confirm("Are you sure you want to Unload selected SQL tables contents into text files?\\n");
	if (agree){
			var agree=confirm("Please note this process may take long time for big tables.\\nAre you sure you still want to unload these tables?\\n");
			if (agree){
				document.Tables_Action.Table_Actions.value=document.Tables_Action.Table_Actionx.value;
				Mewsoft = window.open('','Mewsoft','WIDTH=500,HEIGHT=400,toolbar=yes, location=yes,directories=yes,menubar=yes,scrollbars=yes,resizable=yes,left=0,top=0,screenX=0,screenY=0');
				Mewsoft.document.open();
				Mewsoft.document.focus();
				document.Tables_Action.submit();
			}
	}
}

-->
</script>
HTML
	return $Out;
}
#==========================================================
sub SQL_Text_Backup{
my(@Tables);

	print "Content-type: text/html\n\n";
	@Tables = &DB_Show_Tables;
	&Do_SQL_Tables_Load_Unload("UnLoad", @Tables);

}
#==========================================================
sub Load_SQL_Text_Backup{
my(@Tables);
	
	print "Content-type: text/html\n\n";
	@Tables = &DB_Show_Tables;

	&Do_SQL_Tables_Load_Unload("Load", @Tables);

}
#==========================================================
sub SQL_Tables_Load_Unload{
my(@Tables);
	
	$| = 1;
	#print "Content-Type: text/plain\n\n";
	print "Content-type: text/html\n\n";
	@Tables = split(/\|\|/, $Param{Tables_Selected});
	&Do_SQL_Tables_Load_Unload($Param{Table_Actions}, @Tables);

}
#==========================================================
sub Do_SQL_Tables_Load_UnloadX{
my($Table_Action, @Tables) = @_;
my($Table, %Var, $File, $Counter, $Start, @Fields, %Skip, $Delimiter);

	undef %Var;
	$Start = time;
	
	# Skip built in Microsoft SQL server tables.
	$Skip{sysconstraints} = 1; 	$Skip{syssegments} = 1;

	foreach $Table(@Tables) {
			if ($Skip{$Table}) {print "<B>Skipping table $Table...</B><BR>"; next;}

			$File = "$Global{Database_Dir}/$Table"."\.sql\.pm";
			$Delimiter = '~||~';
			#----------------------------------------------
			if ($Table_Action eq "UnLoad") {
					print "<B>Unloading table $Table...</B><BR>";
					print "File: $File<BR>";
					open (FILE, ">$File") || &Exit("Cannot create $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

					undef @Fields1;
					@Fields1 = &Get_Table_Fields($Table);

					$Query = qq!SELECT * FROM $Table!;
					$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					 
					 $Rows = $sth->rows;
					 print "Rows: $Rows<BR><BR>";

					$Counter = 0;
					while (@Row = $sth->fetchrow_array) {
							$Line = "";

							foreach $Row (@Row) {
								$Row =~ s/\cM//g;
								$Row =~ s/\n//g;
								$Row =~ s/\r//g;
								$Line .= $Delimiter . $Row;
							}

							$Empty = @Fields1 - @Row;
							for $Row(1..$Empty) {
								$Line .= $Delimiter;
							}
							
							$Line =~ s/^\~\|\|\~//;

							print FILE "$Line\n";
							$Counter++;
							if (!($Counter % 10)) {print "<BR>\n";}
							print "$Counter ";
					}

					$sth->finish;
					close(FILE);

					print "<BR>Done...<BR><BR>";
			}#end if Unload
			#----------------------------------------------
			if ($Table_Action eq "Load") {
					print "<B>Loading table $Table...</B><BR>";
					
					if (-e "$File") {
							$Size = -s "$File";
							print "File Size: $Size Bytes<BR>";
							print "File: $File<BR>";
							
							&DB_Empty_Table($Table);
							
							open (FILE, "$File") || &Exit("Cannot open $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
							
							$Counter = 0;
							
							while ($Line = <FILE>){
									$Line =~ s/\n$//; 
									$Line .= $Delimiter. "x";
									@Row = split (/\~\|\|\~/, $Line); 
									pop @Row;
									#$Row[$#Row] =~ s/\n$//; 
									$Line = "";
									foreach $Row (@Row) {
										$Line .=   $dbh->quote($Row) . ",";
									}
									$Line =~ s/\,$//;

									$Query = qq!INSERT INTO $Table VALUES($Line)!;
									$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
									$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

									$Counter++;
									if (!($Counter % 10)) {print "<BR>\n";}
									print "$Counter ";
							}

							close(FILE);
							print "Done...<BR><BR>";
					}
					else{
							print "Error Loading table $Table: Table file $File does not exists\n";
					}
			}
			#----------------------------------------------
	}
	
	$Time = sprintf("%6.2f", (time - $Start)/60);
	print "<BR>Time consumed: $Time minutes<BR>";
	print qq!<P align="center"><a href="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></B></a></P>!;
}
#==========================================================
sub SQL_Server_Status{
my(%Var, @Var, $Status, $Out);
my ($Help);

	$Help = &Help_Link("SQL_Manager");

	%Var = &DB_STATUS;
	@Var = sort keys %Var;
	
	$Status = "";

	foreach $Var (@Var) {
			$Status .= qq!<tr><td nowrap class="TableCell">&nbsp;&nbsp;$Var</td><td class="TableCell" width="100%">&nbsp;&nbsp;$Var{$Var}</td></tr>!;
	}

	$Back = &Go_Back(0);

$Out=<<HTML;
<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
	<tr>
		<td class="TableHeader" align="center">Variable Name</td>
		<td class="TableHeader" align="center">Value</td>
	</tr>
	$Status
</table>
HTML

		&Print_Page($Out, "SQL Server Status", $Help);
}
#==========================================================
sub SQL_Server_Variables{
my(%Var, @Var, $Status, $Out);
my ($Help);

	$Help = &Help_Link("SQL_Manager");

	%Var = &DB_Variables;
	@Var = sort keys %Var;
	
	$Status = "";

	foreach $Var (@Var) {
			$Status .= qq!<tr><td nowrap class="TableCell">&nbsp;&nbsp;$Var</td><td width="100%" class="TableCell">&nbsp;&nbsp;$Var{$Var}</td></tr>!;
	}

	$Back = &Go_Back(0);

$Out=<<HTML;
<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
	<tr>
		<td class="TableHeader" align="center">Variable Name</td>
		<td class="TableHeader" align="center">Value</td>
	</tr>
		$Status
</table>
HTML

		&Print_Page($Out, "SQL Server Variables", $Help);
}
#==========================================================
sub Manage_SQL_Tables{
my ($Help);

	$Help = &Help_Link("Manage_SQL_Tables");
	&Print_Page(&Manage_SQL_Tables_Form, "Manage SQL Tables", $Help);	
}
#==========================================================
sub Manage_SQL_Tables_Form{
my($Out, $Temp, @Tables, @DB, $Tables, $DB);

	@Tables = &DB_Show_Tables;
	$Tables = "";
	foreach $Temp (@Tables) {
				$Tables .= qq!<option value="$Temp">$Temp</option>!;
	} 
	
	@DB = &Get_DB_List;
	$DB = "";
	foreach $Temp (@DB) {
				$DB .= qq!<option value="$Temp">$Temp</option>!;
	} 
#DB_Variables
$Out=<<HTML;
<form name="Tables_Action" method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SQL_Table_Action">
<input type="hidden" name="Table_Action" value="Describe">

<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">

<tr><td class="TableCell" align="right" nowrap valign="top">Selecte Table(s): </td>
	<td class="TableCell" width="100%"><select name="Tables_Selected" style="width: 550px; height: 350px;" multiple>$Tables</select>
		<p align="justify">To select more than one table, drag your mouse or click with the &lt;CTRL&gt; Key pressed.</p>
	</td>
</tr>

<tr><td class="TableCell">What to do: </td>
	<td class="TableCell">
		<table border="0" cellspacing="0" cellpadding="2">
				<tr><td align="left"><input type="button" value="Empty" name="Table_Action1" onClick="Empty_Table_Confirm(); return false;" style="width: 80px;"></td>
				<TD>Delete all selected tables contents</TD</TR>

				<tr><td align="left"><input type="submit" value="Delete" name="Table_Action2" onClick="Delete_Table_Confirm(); return false;" style="width: 80px;"></td>
				<TD>Delete selected tables and its contents</td></tr>

				<tr><td align="left"><input type="submit" value="Optimize" name="Table_Action3" onClick="Optimize_Table_Confirm(); return false;" style="width: 80px;"></td>
				<TD>Eliminate any wasted space</td></tr>

				<tr><td align="left"><input type="submit" value="Describe" name="Table_Action4"  onClick="Describe_Table_Confirm(); return false;" style="width: 80px;"></td>
				<td>Show selected tables information</td></tr>
		</table>
	</td>
</tr>
</table>
</form>

<script language="JavaScript">
<!--
function Empty_Table_Confirm() {
	var agree=confirm("Are you sure you want to Delete the contents of these SQL Tables\\n");
	if (agree){
			var agree=confirm("Please note once the Tables contents deleted, you will not be able to recover it again\\nAre you sure you still want to empty these SQL Tables?\\n");
			if (agree){
					document.Tables_Action.Table_Action.value='Empty';
					document.Tables_Action.submit();
			}
	}
}

function Delete_Table_Confirm() {
	var agree=confirm("Are you sure you want to delete these SQL Tables?\\n");
	if (agree){
			var agree=confirm("Please note once these Tables deleted, you will not be able to recover it again\\nAre you sure you still want to delete these SQL Tables\\n");
			if (agree){
					document.Tables_Action.Table_Action.value='Delete';
					document.Tables_Action.submit();
			}
	}
}

function Optimize_Table_Confirm() {
	var agree=confirm("Are you sure you want to optimize these SQL Tables?\\n");
	if (agree){
			var agree=confirm("Please note this  process may take long time if the tables has lots of data.\\nAre you sure you still want to optimize these SQL Tables?\\n");
			if (agree){
					document.Tables_Action.Table_Action.value='Optimize';
					document.Tables_Action.submit();
			}
	}
}

function Describe_Table_Confirm() {
					document.Tables_Action.Table_Action.value='Describe';
					document.Tables_Action.submit();
}

-->
</script>
HTML
	return $Out;
}
#==========================================================
sub SQL_Table_Action{
my(@Tables, $Table, $Out, %Var, $Status);
my ($Help);

	@Tables = split(/\|\|/, $Param{Tables_Selected});

	$Help = &Help_Link("SQL_Manager");
	
	$Out = "";
	$Back = &Go_Back(0);
	
	if ($Param{Table_Action} eq "Describe"){
				foreach $Table (@Tables) {
						undef %Var;
						%Var = &DB_Show_Table($Table);
						undef @Var;
						@Var = sort keys %Var;
				
						$Status = "";

						foreach $Var (@Var) {
								$Status .= qq!<tr><td nowrap>&nbsp;&nbsp;$Var</td><td width="80%">&nbsp;&nbsp;$Var{$Var}</td></tr>!;
						}

						$Out .= qq~
										<br><b><font size="3">Table: $Table </font></b><br>
										 <div align="center">
											<center>
											<table width="100%" border="01" cellspacing="0" cellpadding="3">
												<tr><td align="center" bgcolor="#f1f1e2"><b>Variable Name</b></td><td align="center" bgcolor="#F1F1E2"><b>Value</b></td></tr>
													$Status
											</table>
											</center>
										</div>~;
					
				}
				$Out .= qq!<p align="center">$Back</p>!;
				&Print_Page($Out, "SQL Table Information", $Help);
	}
	elsif ($Param{Table_Action} eq "Empty"){
				foreach $Table (@Tables) {
						if ($Table) {
							&DB_Empty_Table($Table);
						}
				}
				
				&Manage_SQL_Tables;
	}
	elsif ($Param{Table_Action} eq "Delete"){
				foreach $Table (@Tables) {
						if ($Table) {
							&DB_Drop_Table($Table);
						}
				}
				
				&Manage_SQL_Tables;
	}
	elsif ($Param{Table_Action} eq "Optimize"){
				foreach $Table (@Tables) {
						if ($Table) {
							&DB_Optimize_Table($Table);
						}
				}
				
				&Manage_SQL_Tables;
	}
	else{
				&Manage_SQL_Tables;
	}

}
#==========================================================
sub SQL_Database_Action{

	if ($Param{Database_Action} eq "Delete Database"){
				&DB_Drop($Param{Drop_Database_Name});
	}

	if ($Param{Database_Action} eq "Create Database"){
				$Param{Create_Database_Name} =~ s/^\s+//g;
				$Param{Create_Database_Name} =~ s/\s+$//g;
				if ($Param{Create_Database_Name}) {
					&DB_Create($Param{Create_Database_Name});
				}
	}

	&Manage_SQL_Databases;

}
#==========================================================
sub Manage_SQL_Databases{
my ($Help);

	$Help = &Help_Link("Manage_SQL_Databases");
	&Print_Page(&Manage_SQL_Databases_Form, "Manage SQL Databases", $Help);	
}
#==========================================================
sub Manage_SQL_Databases_Form{
my($Out, $Temp, @DB, $DB);

	@DB = &Get_DB_List;
	$DB = "";
	foreach $Temp (@DB) {
				$DB .= qq!<OPTION VALUE="$Temp">$Temp</OPTION>!;
	} 

$Out=<<HTML;
<BR><BR>

<form name="Database_Action" method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SQL_Database_Action">

<table cellpadding="2" cellspacing="0" class="TableAttr" width="600">
<tr><td colspan="2" class="TableHeader" align="center">Delete Database</td></tr>
<tr><td class="TableCell">Delete Database: </td>
<td class="TableCell">
	<select  name="Drop_Database_Name"  size="1">
	<option selected value="">-----Select database-----</option>
	$DB
  </select>
  <input type="submit" value="Delete Database" name="Database_Action" onClick="Delete_Database_Confirm(document.Database_Action.Drop_Database_Name[document.Database_Action.Drop_Database_Name.selectedIndex].value); return false;">
  </td>
</tr>
</table>

<br><br>

<table cellpadding="2" cellspacing="0" class="TableAttr" width="600">
<tr><td colspan="2" class="TableHeader" align="center">Create Database</td></tr>
<tr><td class="TableCell">New Database Name:</td>
	<td class="TableCell">
			<input type="text" name="Create_Database_Name" value="" size="50">
			<input type="submit" value="Create Database" name="Database_Action">
</td>
</tr>
</table>
</form>

<script language="JavaScript">
<!--
function Delete_Database_Confirm(Database) {
	if (! Database) {alert("Please select a Database"); return;}
	var agree=confirm("Are you sure you want to delete this SQL Database and all its Tables?\\nTable: "+Database+"\\n");
	if (agree){
			var agree=confirm("Please note once the Database deleted, you will not be able to recover it again\\nAre you sure you still want to delete this Database?\\nDatabase: "+Database+"\\n");
			if (agree){
					window.location = "$Global{AdminURL}action=SQL_Database_Action&Database_Action=Delete+Database&Drop_Database_Name=" +Database;
			}
	}
}

-->
</script>
HTML
	return $Out;

}
#==========================================================
sub SQL_Commander{

my($Help);

	$Help =&Help_Link("Database_Manager");

	&Print_Page(&SQL_Commander_Form, "SQL Commander", $Help);

}
#==========================================================
sub SQL_Commander_Form{
my($Result, $Query, $sth);

	$Param{Query} ||= "";
	$Param{Query} =~ s/^\s+//;
	$Param{Query} =~ s/\s+$//;

	$Result = "";
	if ($Param{Query} ne "") {
			$Query = $Param{Query};
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$Count = 0;
			while (@Row = $sth->fetchrow_array){
					$Result .= join ("<br>", @Row) . "<br>";
			}
			$sth->finish;
	}

$Out=<<HTML;
<p align="left"><b>Please enter the SQL Statement you want to execute.</b></p>

<form name="Tables_Action" method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SQL_Commander">
<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
	<tr>
		<td class="TableCell">
			<textarea name="Query" style="width: 100%; height: 200px;" >$Param{Query}</textarea>
		</td>
	</tr>
	<tr><td class="TableCell" align="center">
		<input type="submit" value="Run Statement"> &nbsp;&nbsp; <input type="reset" value="Reset">
		</td>
	</tr>
</table>
</form>
<br><br>

<table width="100%" cellspacing="0" cellpadding="2" class="TableAttr" height="100%">
	<tr><td class="TableHeader" align="center">Output</td></tr>
	<tr><td align="left" width="100%"  height="100%" class="TableCell">$Result</td></tr>
</table>
HTML
	return $Out;
}
#==========================================================
sub Do_SQL_Tables_Load_Unload{
my ($Table_Action, @Tables) = @_;
my ($Table, %Var, $File, $Counter, $Start, @Fields, %Skip, $Delimiter);
my ($Escape, $EOLine, @Fields1);

	undef %Var;
	$Start = time;
	
	# Skip built in Microsoft SQL server tables.
	$Skip{sysconstraints} = 1; 	$Skip{syssegments} = 1;
	
	foreach $Table(@Tables) {
			if ($Skip{$Table}) {print "<B>Skipping table $Table...</B><BR>"; next;}

			$File = "$Global{Database_Dir}/$Table\.sql\.pm";
			#$File = "$Table"."\.sql\.pm";
			$Delimiter = '<~|||~>'; $Escape = "\\"; $EOLine = "'\n'";
			#----------------------------------------------
			if ($Table_Action eq "UnLoad") {
					print "<B>Unloading table $Table...</B><BR>";
					print "File: $File<BR>";

					if ($Global{DB_File_Priv}) {
						unlink $File;
						&Export_Table($Table, $Delimiter, $Escape, $EOLine, $File);
						next;
					}
					open (FILE, ">$File") || &Exit("Cannot create $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

					undef @Fields1;
					@Fields1 = &Get_Table_Fields($Table);

					$Query = qq!SELECT * FROM $Table!;
					$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					 
					 $Rows = $sth->rows;
					 print "Rows: $Rows<BR><BR>";

					$Counter = 0;
					while (@Row = $sth->fetchrow_array) {
							$Line = "";

							foreach $Row (@Row) {
								$Row =~ s/\cM//g;
								$Row =~ s/\n/\\n/g;
								$Row =~ s/\r/\\r/g;
								$Line .= $Delimiter . $Row;
							}

							$Empty = @Fields1 - @Row;
							for $Row(1..$Empty) {
								$Line .= $Delimiter;
							}
							
							$Line =~ s/^\<\~\|\|\|\~\>//;

							print FILE "$Line\n";
							
							$Counter++;
							if (!($Counter % 10)) {print "<BR>\n";}
							print "$Counter ";
					}

					$sth->finish;
					close(FILE);

					print "<BR>Done...<BR><BR>";
			}#end if Unload
			#----------------------------------------------
			if ($Table_Action eq "Load") {
					print "<B>Loading table $Table...</B><BR>";
					
					if (-e "$File") {
							$Size = -s "$File";
							print "File Size: $Size Bytes<BR>";
							print "File: $File<BR>";
							
							&DB_Empty_Table($Table);

							if ($Global{DB_File_Priv}) {
								&Import_Table($Table, $Delimiter, $Escape, $EOLine, $File);
								next;
							}
							
							open (FILE, "$File") || &Exit("Cannot open $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
							
							$Counter = 0;
							
							while ($Line = <FILE>){
									$Line =~ s/\n$//; 
									$Line .= $Delimiter. "x";
									@Row = split (/\<\~\|\|\|\~\>/, $Line); 
									pop @Row;
									$Line = "";
									foreach $Row (@Row) {
										$Row =~ s/\\n/\n/g;
										$Row =~ s/\\r/\r/g;
										$Line .=   $dbh->quote($Row) . ",";
									}
									$Line =~ s/\,$//;

									$Query = qq!INSERT INTO $Table VALUES($Line)!;
									$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
									$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

									$Counter++;
									if (!($Counter % 10)) {print "<BR>\n";}
									print "$Counter ";
							}

							close(FILE);
							print "Done...<BR><BR>";
					}
					else{
							print "Error Loading table $Table: Table file $File does not exists\n";
					}
			}
			#----------------------------------------------
	}
	
	$Time = sprintf("%6.2f", (time - $Start)/60);
	print "<BR>Time consumed: $Time minutes<BR>";
	print qq!<p align="center"><a href="javascript:window.close()"><b><font color="blue">Close This Window</font></b></a></p>!;
}
#==========================================================
sub SaveDatabaseOptions{
my (%Config);

	undef %Config;
	$Param{DB_File_Priv} ||= 0;
	$Config{DB_File_Priv} = $Param{DB_File_Priv};
	&UpdateConfiguration(%Config);
	$Global{DB_File_Priv} = $Param{DB_File_Priv};
	&Database_Manager;
}
#==========================================================
sub SQL_Administration{
my ($Result, $Error) = @_;
my ($Help);
	
	$Help =&Help_Link("Database_Manager");

	$Error = &SQL_Root_Connect;
	
	&Print_Page(&SQL_Administration_Form($Error), "Database & SQL Manager", $Help);
	
	$dbh1->disconnect if($dbh1);
}
#==========================================================
sub SQL_Administration_Form{
my ($Error) = @_;
my ($Out, %Priv, %User, $Key, $Value);
	
		undef %Priv;
		if ($Param{action} eq "SQLUserPriv") {
				if ($Param{SubAction} eq "Update") {
						$Result = &SQLSetUserPriv;
				}
				%User = &SQLGetUserPriv;
				while (($Key, $Value) = each %User) {
						if ($Value eq "Y") {$Priv{$Key} = "checked";} else {$Priv{$Key} = "";}
				}
		}
	
$Out =<<HTML;
<!--------------------------------------------------------------------------------->
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SQL_Administration_Connect">

<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
	<tr><td colspan="2" class="TableHeader" align="center">Root User Login</td></tr>
	<tr><td class="TableCell" colspan="2">Please enter the SQL server root user login. Login information not saved.</td></tr>
	<tr><td class="TableCell">User: </td><td class="TableCell"><input type="password" name="SQL_Root_User" size="40" value="$Param{SQL_Root_User}"></td></tr>
	<td class="TableCell">Password: </td><td class="TableCell"><input type="password" name="SQL_Root_Pass" size="40" value="$Param{SQL_Root_Pass}"></td></tr>
	<tr><td class="TableCell" nowrap align="center" colspan="2">
		<input type="submit" value="Connect" name="Submit" style="width: 100px;">&nbsp;
		<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
	</tr>
</table>

</form>
<br>
<b>Connection Result: </b>$Error
<br><br>

<!--------------------------------------------------------------------------------->
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SQLUserPriv">
<input type="hidden" name="SQL_Root_User" value="$Param{SQL_Root_User}">
<input type="hidden" name="SQL_Root_Pass" value="$Param{SQL_Root_Pass}">

<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
	<tr><td colspan="2" class="TableHeader" align="center">User Privilages</td></tr>
	<tr><td colspan="2" class="TableCell">Show and update user privilages.</td></tr>
    <tr><td class="TableCell">User: </td><td class="TableCell"><input type="text" name="User" size="40" value="$Param{User}"></td></tr>
    <tr><td class="TableCell">Privilages: </td><td class="TableCell">
				<table border="0" cellspacing="0" cellpadding="2" class="TableAttr">
				<tr>
					<td>	Select_priv</td><td> <input type="checkbox" name="Select_priv" value="1" $Priv{Select_priv}></td>
					<td>Insert_priv</td><td> <input type="checkbox" name="Insert_priv" value="1" $Priv{Insert_priv}></td>
					<td>Update_priv</td><td> <input type="checkbox" name="Update_priv" value="1" $Priv{Update_priv}></td>
					<td>Delete_priv</td><td> <input type="checkbox" name="Delete_priv" value="1" $Priv{Delete_priv}></td>
				</tr>
				<tr>
					<td>Create_priv</td><td> <input type="checkbox" name="Create_priv" value="1" $Priv{Create_priv}></td>
					<td>Drop_priv</td><td> <input type="checkbox" name="Drop_priv" value="1" $Priv{Drop_priv}></td>
					<td>Reload_priv</td><td> <input type="checkbox" name="Reload_priv" value="1" $Priv{Reload_priv}></td>
					<td>Shutdown_priv</td><td> <input type="checkbox" name="Shutdown_priv" value="1" $Priv{Shutdown_priv}></td>
				</tr>
				<tr>
					<td>Process_priv</td><td> <input type="checkbox" name="Process_priv" value="1" $Priv{Process_priv}></td>
					<td>File_priv</td><td> <input type="checkbox" name="File_priv" value="1" $Priv{File_priv}></td>
					<td>Grant_priv</td><td> <input type="checkbox" name="Grant_priv" value="1" $Priv{Grant_priv}></td>
					<td>References_priv</td><td> <input type="checkbox" name="References_priv" value="1" $Priv{References_priv}></td>
				</tr>
				<tr>
					<td>Index_priv</td><td> <input type="checkbox" name="Index_priv" value="1" $Priv{Index_priv}></td>
					<td>Alter_priv</td><td> <input type="checkbox" name="Alter_priv" value="1" $Priv{Alter_priv}></td>
					</td><td></td><td>
					</td><td></td><td>
				</tr>
				</table>
	</td>
    </tr>

	<tr><td nowrap class="TableCell" align="center" colspan="2">
			<input type="submit" value="Show" name="SubAction" style="width: 100px;">&nbsp;
			<input type="submit" value="Update" name="SubAction" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
	</td>
    </tr>
	</form>
    </tr>
  </table>
<br>
<!-------------------------------------------------------------------------------->
<b><font color="#CC0033" size="3">Output</font></b><br>
$Result
HTML
}
#==========================================================
sub SQL_Administration_Connect{
my ($Status);

	$Status = &SQL_Root_Connect;
	&SQL_Administration("", $Status);
}
#==========================================================
sub SQL_Root_Connect{
my ($Status, $DSN1, $sth, $Query, $Temp);
	
   $Param{SQL_Root_User} ||= ""; $Param{SQL_Root_Pass} ||= "";
   $DSN1 = "DBI:$Global{DB_Driver}:database=mysql;host=$Global{DB_Host};port=$Global{DB_Port}";

   if ($dbh1 = DBI->connect($DSN1, $Param{SQL_Root_User}, $Param{SQL_Root_Pass})){
			$Status = "<b>Status: Connected</b>";
   }
	else{	
			$Status = qq!<b><font color="#CC0033">$DBI::errstr<br>$Query</font></b>!;
	}
	return $Status;
}
#==========================================================
sub SQLGetUserPriv{
my ($User, $Query, $sth, $Temp, %User);

	$Param{User} =~ s/^\s+//;
	$Param{User} =~ s/\s+$//;
	$Param{User} ||= $Global{DB_UserID};
	
	if ($dbh1) {
			$User = $dbh1->quote($Param{User});
			$Query = qq!SELECT * FROM user WHERE user=$User!;
			$sth = $dbh1->prepare($Query);
			$sth->execute;
			undef %User;
			while ($Temp = $sth->fetchrow_hashref){%User = %{$Temp}; last;}
			$sth->finish;
	}

	return %User;
}
#==========================================================
sub SQLSetUserPriv{
my (@Priv, $Privilages, $Key, $Query, $sth, @Row, $User_Priv);
	
	&Demo; 
	$Param{User} =~ s/^\s+//;
	$Param{User} =~ s/\s+$//;
	$Param{User} ||= return "";
	
	$User_Priv = "";

	@Priv = qw (
						Select_priv
						Insert_priv
						Update_priv
						Delete_priv
						Create_priv
						Drop_priv
						Reload_priv
						Shutdown_priv
						Process_priv
						File_priv
						Grant_priv
						References_priv
						Index_priv
						Alter_priv
					);
	$Privilages = "";
	foreach $Key (@Priv) {
			$Privilages .= "$Key=";
			if ($Param{$Key}) {$Privilages .= "\'Y\'";} else {$Privilages .= "\'N\'";}
			$Privilages .= ", ";
	}
	$Privilages =~ s/\,\s*$//;

	if ($dbh1 && $Param{User}) {
			$User = $dbh1->quote($Param{User});
			$Query = qq!UPDATE user set $Privilages WHERE user=$User!;
			$sth = $dbh1->prepare($Query);
			$sth->execute;
			while ((@Row) = $sth->fetchrow_array){$User_Priv .= join "<br>", @Row;}
			$sth->finish;
	}

	eval{system("mysqladmin reload -u$Param{SQL_Root_User} -p$Param{SQL_Root_Pass}")};
	return $User_Priv ;;#."<br>Query:$Query<br>";
}
#==========================================================
sub CompressDatabaseFiles{
my ($Start, @Files, $File, @DataFiles, $Size, $Zip, $Member);
my ($Status, $ZipSize, $Percent, $Time);
	
	$| = 1;
	print "Content-type: text/html\n\n";
	print "<br><b>Compressing database files, this may take long time, please wait...</b><br>";

	$Start = time;
	
	&ModLoad("constant", "Archive::Zip qw( :ERROR_CODES :CONSTANTS )");

	undef @Files;
	opendir(Dir, "$Global{Database_Dir}");
	foreach $File (readdir(Dir)) {
			push (@Files, "$File");
    }
	closedir(Dir);

	undef @DataFiles;
	foreach $File(@Files) {
			if ($File =~ m/\.sql\.pm$/) {
					push @DataFiles, $File;
			}
	}
	print scalar @DataFiles ." Files found.<br><br>";
	
	@DataFiles = sort {lc($a) cmp lc($b)} @DataFiles;

	foreach $File(sort @DataFiles) {
			$Size = -s "$Global{Database_Dir}/$File";
			print qq!Compressing file <font color="#3333CC">$File</font>, $Size bytes, !;
			#--------- Zip file------------------------
			$Zip = Archive::Zip->new();
			$Member = $Zip->addFile("$Global{Database_Dir}/$File", $File);
			$Member->desiredCompressionMethod(COMPRESSION_DEFLATED); #COMPRESSION_STORED 
			$Member->desiredCompressionLevel(9); #0..9
			$Status = $Zip->writeToFileNamed("$Global{Database_Dir}/$File\.zip");
			$ZipSize = -s "$Global{Database_Dir}/$File\.zip";
			$Size ||= 1;
			$Percent = int(($ZipSize/$Size)*100);
			if ($Percent>100) {$Percent = 100;}
			$Percent = 100 - $Percent;
			print "Compressed to $ZipSize, <b>$Percent\%</b><br>";
	}

	$Time = sprintf("%6.3f", (time - $Start)/60);
	print "<br><b>Time consumed: $Time minutes</b><br>";
	print qq!<p align="center"><a href="javascript:window.close()"><b><font color="blue">Close This Window</font></b></a></p>!;
}
#==========================================================
sub ExtractDatabaseFiles{
my ($Start, @Files, $File, @DataFiles, $Size, $Zip, $Member);
my ($Status, $ZipSize, $Percent, $Time);
	
	$| = 1;
	print "Content-type: text/html\n\n";
	print "<br><b>Extracting compressed database files, this may take long time, please wait...</b><br>";

	$Start = time;
	
	&ModLoad("constant", "Archive::Zip qw( :ERROR_CODES :CONSTANTS )");

	undef @Files;
	opendir(Dir, "$Global{Database_Dir}");
	foreach $File (readdir(Dir)) {
			push (@Files, "$File");
    }
	closedir(Dir);

	undef @DataFiles;
	foreach $File(@Files) {
			if ($File =~ m/\.sql\.pm\.zip$/) {
					push @DataFiles, $File;
			}
	}
	print scalar @DataFiles ." Files found.<br><br>";
	
	@DataFiles = sort {lc($a) cmp lc($b)} @DataFiles;
		
	foreach $File(@DataFiles) {
			$ZipSize = -s "$Global{Database_Dir}/$File";
			print qq!Extracting file <font color="#3333CC">$File</font>, $ZipSize bytes, !;
			
			$Zip = Archive::Zip->new();

			unless ($Zip->read("$Global{Database_Dir}/$File") == AZ_OK) {
					print qq|<font color="red">Error: $!<\/font><br>|; 
					next;
			}

			foreach my $member ($Zip->members)
			{
					next if $member->isDirectory;
					(my $extractName = $member->fileName) =~ s{.*/}{};
					#$member->extractToFileNamed("$destinationDirectory/$extractName");
					unless ($member->extractToFileNamed("$Global{Database_Dir}/$extractName") == AZ_OK) {
							print qq|<font color="red">Error: $!<\/font><br>|; 
							next;
					}
			}
			$Filename = "$Global{Database_Dir}/$File";
			$Filename =~ s/\.zip$//;
			$Size = -s $Filename;
			$Size ||= 1;
			$Percent = int(($ZipSize/$Size)*100);
			if ($Percent>100) {$Percent = 100;}
			$Percent = 100 - $Percent;
			print "uncompressed to $Size, <b>$Percent\%</b><br>";
	}

	$Time = sprintf("%6.3f", (time - $Start)/60);
	print "<br><b>Time consumed: $Time minutes</b><br>";
	print qq!<p align="center"><a href="javascript:window.close()"><b><font color="blue">Close This Window</font></b></a></p>!;
}
#==========================================================
sub DeleteTextDatabaseFiles{
my (@Files, $Counter, $File);

	$| = 1;
	print "Content-type: text/html\n\n";
	print "<br><b>Deleting database text backup files, please wait...</b><br>";

	undef @Files;
	opendir(Dir, "$Global{Database_Dir}");
	$Counter = 0;
	foreach $File (readdir(Dir)) {
			if ($File =~ /\.sql\.pm$/) {
					unlink "$Global{Database_Dir}/$File";
					$Counter++;
					print "$Counter)- Deleted file: $File <br>";
			}
    }
	closedir(Dir);
	
	print "<br><b>$Counter Files deleted<b><br>";
	print qq!<p align="center"><a href="javascript:window.close()"><b><font color="blue">Close This Window</font></b></a></p>!;
}
#==========================================================
sub DeleteCompressedDatabaseFiles{
my (@Files, $Counter, $File);

	$| = 1;
	print "Content-type: text/html\n\n";
	print "<br><b>Deleting database compressed backup files, please wait...</b><br>";

	undef @Files;
	opendir(Dir, "$Global{Database_Dir}");
	$Counter = 0;
	foreach $File (readdir(Dir)) {
			if ($File =~ /\.sql\.pm\.zip$/) {
					unlink "$Global{Database_Dir}/$File";
					$Counter++;
					print "$Counter)- Deleted file: $File <br>";
			}
    }
	closedir(Dir);
	
	print "<br><b>$Counter Files deleted<b><br>";
	print qq!<p align="center"><a href="javascript:window.close()"><b><font color="blue">Close This Window</font></b></a></p>!;
}
#==========================================================

1;