=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Get_Menu_Bar{
my($Home_Action, $Action, $JS_URL)=@_;
my ($Home, $x, $Last_ID, $Last_Name, $Guide_Bar);
my($ID_Ref, $Name_Ref, @Name, @ID, $JS_URL1);

	if (!$JS_URL) {$JS_URL = "";}
	if ($JS_URL) {
					$JS_URL1 = $JS_URL; $x = 0;
					$JS_URL1 =~ s/<<Cat_ID>>/$x/g;
	}
	
	$Home=qq!<a href="$Global{ProgURL}$Home_Action" $JS_URL1>$Language{menu_bar_home}</a>!;

	$Param{Cat_ID} ||= 0;

	($ID_Ref, $Name_Ref)=&Get_Category_Fullname($Param{Cat_ID});
	@ID = @{$ID_Ref};
	@Name = @{$Name_Ref};

	$Last_ID = pop @ID;
	$Last_Name = pop @Name;
	
	$Guide_Bar = $Home . $Global{MenuLine_Home};
	
	 for $x (0..$#ID) {
				if ($JS_URL) {
							$JS_URL1 = $JS_URL;
							$JS_URL1 =~ s/<<Cat_ID>>/$ID[$x]/g;
				}
				
				$Guide_Bar .= qq!<a href="$Global{ProgURL}$Action&Cat_ID=$ID[$x]" $JS_URL1>$Name[$x]</a>!;
				$Guide_Bar .= $Global{MenuLine_Separator};
	}
	if ($Last_ID) {
		$Guide_Bar .= qq!<a href="$Global{ProgURL}$Action&Cat_ID=$Last_ID" $JS_URL1>$Last_Name</a>!;
	};

	$Plugins{Menu_Bar} = $Guide_Bar;
	return $Guide_Bar;
}
#==========================================================
sub TranslateFile{
my ($Template_File) = @_;
my (@Temp, $Out);
	
	($package, $filename, $line) = caller;

	open(FILE, "$Template_File") || 
			&Exit("Error, Can't open file $Template_File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__ .", <br>Caller: " .  "$filename, Line: $line");
    @Temp = <FILE>;
    close(FILE);

	$Out = join("", @Temp);
	$Out = Translate($Out);
	return $Out;
}
#==========================================================
sub Translate {
my ($Text) = @_;
my ($K, $V);
	
	#	First pass
	$Text =~ s/\[\[(.*?)\]\]/exists $Language{$1}?$Language{$1}: $1/gexs;
	
	#	Second pass for variables inside variables
	$Text =~ s/\[\[(.*?)\]\]/exists $Language{$1}?$Language{$1}: $1/gexs;
	
	return $Text;
	
	#while (($K, $V) = each %Language) {$Text =~ s/\[\[$K\]\]/$V/gs;}
	#m  Multiline mode - ^ and $ match internal lines
	#s  match as a Single line - . matches \n
	#o  compile pattern Once
	#x  eXtended legibility - free whitespace and comments
	#c  dont reset pos on failed matches when using /g
}
#==========================================================
sub Translate_Classes {
my ($Out) = @_;
my($K, $V);
	#$sw->lap("Translate_Classes 1 ...");
	while (($K, $V) = each %Plugins) {
				$V ||= "";
				$Out =~ s/<!--CLASS::$K-->/$V/g  if (defined ($V) );
	}
	#$sw->lap("Translate_Classes 2 ...");
	return $Out;
}
#==========================================================
sub Base_URL{

	if ($Global{SSL_Status}){return $Global{SSL_URL};}
	return $Global{CGI_URL};
}
#==========================================================
sub ReadClasses{
my ($Line, $K, $V, $Cat, $Temp, %Custom, %Data);
my ($x, %User, $Out, $Ext, $Base, %Zones);
	
	if ($Global{ReadClassesDone} && !$Global{ForceReadClasses}) {return;}
	$Global{ReadClassesDone} = 1; # To avoid reading and translating classes again
	#------------------------------------------------------
	%Custom = %Plugins;
	#------------------------------------------------------
	# https URL's
	#------------------------------------------------------
	$Global{MainProg} = "";

	$Base = &Base_URL;

	$Plugins{AccountManager} = qq!$Base$Global{MainProg}action=AccountManager_Login!;
	$Plugins{Account_Overview} = qq!$Base$Global{MainProg}action=AccountManager_Login!;
	$Plugins{Edit_Profile} = qq!$Base$Global{MainProg}action=Edit_Profile!;
	$Plugins{Sign_Out} = qq!$Base$Global{MainProg}action=Sign_Out!;
	$Plugins{Register} = qq!$Base$Global{MainProg}action=Register!;
	$Plugins{BlockList} = qq!$Base$Global{MainProg}action=BlockList!;
	$Plugins{AboutMe} = qq!$Base$Global{MainProg}action=AboutMe!;

	$Plugins{MyMail} = qq!$Base$Global{MainProg}action=MyMail!;
	$Plugins{MyInbox} = qq!$Base$Global{MainProg}action=MyInbox!;
	$Plugins{MyOutbox} = qq!$Base$Global{MainProg}action=MyOutbox!;
	$Plugins{MySentbox} = qq!$Base$Global{MainProg}action=MySentbox!;
	$Plugins{MySavedbox} = qq!$Base$Global{MainProg}action=MySavedbox!;
	$Plugins{MyDraftsbox} = qq!$Base$Global{MainProg}action=MyDraftsbox!;
	$Plugins{MyCompose} = qq!$Base$Global{MainProg}action=MyCompose!;

	$Plugins{MyPosts} = qq!$Base$Global{MainProg}action=MyPosts!;
	$Plugins{MyFavorites} = qq!$Base$Global{MainProg}action=MyFavorites!;
	$Plugins{MyBuddies} = qq!$Base$Global{MainProg}action=MyBuddies!;
	$Plugins{MyPreferences} = qq!$Base$Global{MainProg}action=MyPreferences!;
	#------------------------------------------------------
	# http URL's
	#------------------------------------------------------
	$Plugins{AdvertiserLogin} = qq!$Global{CGI_URL}$Global{BannerStatsProg}!;
	$Plugins{AdvertiserLogout} = qq!$Global{CGI_URL}$Global{BannerStatsProg}action=Logout!;
	$Plugins{AdvancedSearch} = qq!$Global{CGI_URL}$Global{MainProg}action=AdvancedSearch&Forum=$Param{Forum}!;
	
	$Plugins{Home} = qq!$Global{CGI_URL}$Global{MainProg}!;
	$Plugins{Privacy_Policy} = qq!$Global{CGI_URL}$Global{MainProg}action=Privacy_Policy!;
	$Plugins{Copyright} = qq!$Global{CGI_URL}$Global{MainProg}action=Copyright!;
	$Plugins{Terms_of_Use} = qq!$Global{CGI_URL}$Global{MainProg}action=Terms_of_Use!;
	$Plugins{AboutUs} = qq!$Global{CGI_URL}$Global{MainProg}action=AboutUs!;
	$Plugins{Language} = qq!$Global{CGI_URL}$Global{MainProg}action=Set_Language!;
	$Plugins{ContactUs} = qq!$Global{CGI_URL}$Global{MainProg}action=ContactUs!;
	$Plugins{Search_Help_Link} = qq!$Global{CGI_URL}$Global{MainProg}action=Search_Help&$Cat!;
	$Plugins{Help} = qq!$Global{CGI_URL}$Global{MainProg}action=Help!;
	$Plugins{Newest} = qq!$Global{CGI_URL}$Global{MainProg}action=Newest!;
	$Plugins{Unread} = qq!$Global{CGI_URL}$Global{MainProg}action=Unread!;
	$Plugins{Top} = qq!$Global{CGI_URL}$Global{MainProg}action=Top!;
	$Plugins{Popular} = qq!$Global{CGI_URL}$Global{MainProg}action=Popular&!;
	$Plugins{Advertise} = qq!$Global{CGI_URL}$Global{MainProg}action=Advertise!;
	$Plugins{Community} = qq!$Global{CGI_URL}$Global{MainProg}action=Community!;

	$Plugins{Browse} = qq!$Global{CGI_URL}$Global{MainProg}action=Browse!;
	$Plugins{MarkForum} = qq!$Global{CGI_URL}$Global{MainProg}action=MarkForum&Forum=$Param{Forum}&Category=$Param{Category}!;
	$Plugins{UnMarkForum} = qq!$Global{CGI_URL}$Global{MainProg}action=UnMarkForum&Forum=$Param{Forum}&Category=$Param{Category}!;
	$Plugins{Members} = qq!$Global{CGI_URL}$Global{MainProg}action=Members!;
	$Plugins{FeedRss} = qq!$Global{CGI_URL}$Global{MainProg}action=FeedRss&Forum=$Param{Forum}!;
	#------------------------------------------------------
	$Plugins{Action} = qq!$Global{CGI_URL}$Global{MainProg}!;
	$Plugins{CGI_Dir} = $Global{CGI_Dir};
	$Plugins{HTML_Dir} = $Global{HTML_Dir};
	$Plugins{CGI_URL} = $Global{CGI_URL};
	$Plugins{HTML_URL} = $Global{HTML_URL};
	#------------------------------------------------------
	#$Temp = &Web_Encode(&Encrypt("$ENV{HTTP_REFERER}?$ENV{QUERY_STRING}", "urlxya"));
	$Temp = "http://";
	if ($ENV{HTTP_REFERER}) {if ($ENV{HTTP_REFERER} =~ m|^https://|i) {$Temp = "https://";}}
	$Temp = &Web_Encode(&Encrypt("$Temp$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}?$ENV{QUERY_STRING}", "urlxya"));
	$Plugins{Adult_Verification} = qq!$Global{CGI_URL}$Global{MS_Prog}action=Adult_Verification&Target=$Temp!;

	$Plugins{Site_Name} = $Language{site_name};
	$Plugins{ProgURL} = qq!$Global{CGI_URL}$Global{MainProg}!;
	$Plugins{Categories_Count} = $Global{Categories_Count};
	$Plugins{Categories_Count} ||= "0";
	
	$Plugins{Total_Auctions_Count} = $Global{Total_Auctions_Count};
	$Plugins{Total_Auctions_Count} ||= "0";
	
	$Plugins{Total_Accounts_Count} = $Global{Total_Accounts_Count};
	$Plugins{Total_Accounts_Count} ||= "0";
	
	$Plugins{Open_Auctions_Count} = $Global{Open_Auctions_Count};
	$Plugins{Open_Auctions_Count} ||= "0";

	$Plugins{Closed_Auctions_Count} = $Global{Closed_Auctions_Count};
	$Plugins{Closed_Auctions_Count} ||= "0";

	$Plugins{PrevPage_Link} = $Language{previous_page_label};
	$Plugins{NextPage_Link} = $Language{next_page_label};
	$Plugins{Images} = $Global{Images};
	$Plugins{ThemeImages} = $Global{ThemeImages};
	$Plugins{ImagesSSL} = $Global{ImagesSSL};

	if (&Check_Previous_User_Login) {
				%User = &Get_User($Param{User_ID});
				$Plugins{Welcome_User} = $Language{welcome_current_user};
				$Plugins{Welcome_User} =~ s/<!--User_ID-->/$Param{User_ID}/g;
				$Plugins{Welcome_User} =~ s/<!--FName-->/$User{FName}/g;
				$Plugins{Welcome_User} =~ s/<!--LName-->/$User{LName}/g;
				$Plugins{User_ID} = $Param{User_ID};
				$Plugins{User_Name} = "$User{FName} $User{LName}";
				$Plugins{FName} = $User{FName};
				$Plugins{LName} = $User{LName};
				if ($Global{PM_Status}) {
						$Temp = &GetUserInboxUnReadMsgsCount($Param{User_ID});
						if ($Temp > 0) {
								$Plugins{NewMail} = $Language{inbox_unread_msgs};
								$Plugins{NewMail} =~ s/<!--Count-->/$Temp/g;
						}
						else {
								$Plugins{NewMail} = $Language{inbox_no_unread_msgs};
						}
				}
				else{
						$Plugins{NewMail} = "";
				}
	}
	else{
				$Plugins{Welcome_User} = $Language{welcome_new_user};
				$Plugins{User_ID} = "";
				$Plugins{User_Name} = "";
				$Plugins{NewMail} = "";
				$Plugins{MarkForum} = "";
				$Plugins{UnMarkForum} = "";
	}
	#------------------------------------------------------
	#------------------------------------------------------
	# Translate general classes
	@Class = &ReadGeneralClassesNames;
	foreach $K (@Class) {
			delete $PluginsNames{$K};
			$Plugins{$K} = &Translate($Global{$K});
	}
	
	#Do not translate special classes here, they are translated where they needed
	@Class = &ReadSpecialClassesNames;
	foreach $K (@Class) {
			delete $PluginsNames{$K};
	}
	
	# Translate custom classes. These Classes generated by admin in the Class editor and they are general
	foreach $K (keys %PluginsNames) {
			$Plugins{$K} = &Translate($Global{$K});
	}
	#------------------------------------------------------
	undef %Data;
	if ($Param{Forum}) {
			%Data = &GetForum($Param{Forum});
	}

	if (%Data) {
			if ($Data{Meta_Title}) {$Global{Meta_Title} = $Data{Meta_Title};}
			if ($Data{Meta_Description}) {$Global{Meta_Description} = $Data{Meta_Description};}
			if ($Data{Meta_Keywords}) {$Global{Meta_Keywords} = $Data{Meta_Keywords};}
			$Plugins{Zone1} = &Translate($Data{Zone1});
			$Plugins{Zone2} = &Translate($Data{Zone2});
			$Plugins{Zone3} = &Translate($Data{Zone3});
			$Plugins{Zone4} = &Translate($Data{Zone4});
	}
	#------------------------------------------------------
	$Plugins{Meta_Title} = $Global{Meta_Title};
	$Plugins{Meta_Description} = $Global{Meta_Description};
	$Plugins{Meta_Keywords} = $Global{Meta_Keywords};
	#------------------------------------------------------
	$Plugins{LanguageMenu} = &GetLanguageMenu($Global{Language});
	#------------------------------------------------------
	# Translate custom classes
	foreach $K (keys %Custom) {
			$Plugins{$K} = &Translate($Plugins{$K});
	}
	#------------------------------------------------------
	$Plugins{HeadCode} ||= "";
	$Plugins{JS_Code} ||= "";
	$Plugins{FooterCode} ||= "";
	#------------------------------------------------------
	$Plugins{CurrentForumLink} = qq!$Global{CGI_URL}$Global{MainProg}action=Forums&Forum=$Param{Forum}!;
	$Plugins{CurrentForumName} = &GetForumName($Param{Forum});
	$Plugins{CurrentCategoryLink} = qq!$Global{CGI_URL}$Global{MainProg}Category=$Param{Category}!;
	
	$Plugins{ForumMenuBar} = &GetForumMenuBar;
	$Plugins{ForumsMenu} = &GetForumsMenu;
	$Plugins{SearchForums} = &SearchForumsBox;

	$Plugins{TotalTopics} = $Global{TotalTopics};
	$Plugins{TotalPosts} = $Global{TotalPosts};
	$Plugins{TotalUsers} = $Global{TotalUsers};
	$Plugins{TotalViews} = $Global{TotalViews};
	$Plugins{TotalFroums} = $Global{TotalFroums};
	
	if ($Global{NewestUser}) {
			$Plugins{NewestUser} = $Language{newest_user_link};
			$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Global{NewestUser}!;
			$Plugins{NewestUser} =~ s/<!--AuthorLink-->/$Temp/g;
			$Plugins{NewestUser} =~ s/<!--Author-->/$Global{NewestUser}/g;
	}

	if ($Global{Working_Mode} == 1 && $Param{User_ID}) { # Auction plugin
			($Plugins{UserRating}, $Plugins{UserStars}) = &Get_User_Feedback_Stars($Param{User_ID});
	}

}
#==========================================================
sub Display{
my ($Template, $Translated_Flag) = @_; 
my ($Line, $K, $V, $Temp, $Plugin, $s, $x, $Out);

	#$sw->lap("Display start...");
	&ReadClasses;
	#$sw->lap("Display ReadClasses");
	#------------------------------------------------------
	if (!$Translated_Flag) {
			$Out = &TranslateFile("$Template");
	}
	else{
			$Out = $Template;
	}
	#------------------------------------------------------
	# Scan Classes: Pass Number: 1
	$Out =~ s/(<!--CLASS::([^:].*?)-->)/exists $Plugins{$2}?$Plugins{$2}: $1/gexs;
	#$sw->lap("Display 1");
	#------------------------------------------------------
	# Scan Classes: Pass Number: 2
	$Out =~ s/(<!--CLASS::([^:].*?)-->)/exists $Plugins{$2}?$Plugins{$2}: $1/gexs;
	#------------------------------------------------------
	#<!--CLASS::DateTime:20-->
	while ($Out =~ m/(<!--)(CLASS::DateTime)(:)(\d{1,3})(-->)/ ){
				$s = $1 . $2 . $3 . $4 . $5;
				$x =&Format_Date($4, &Time(time));
				$Out =~ s/$s/$x/g;
	}
	#------------------------------------------------------
	#<!--CLASS::Search_Main:20-->
	while ($Out =~ m/(<!--)(CLASS::Search_Main)(:)(\d{1,3})(-->)/  ){
				$s = $1 . $2 . $3 . $4 . $5;
				$x = &Search_Main_Form($4, $Param{Cat_ID});
				$Out =~ s/$s/$x/g;
	}
	#------------------------------------------------------
	#<!--CLASS::Search_Category:20-->
	while ($Out =~ m/(<!--)(CLASS::Search_Category)(:)(\d{1,3})(-->)/){
		$s = $1 . $2 . $3 . $4 . $5;
		if ($Param{Cat_ID}) {
				$x = &Search_Category_Form($4, $Param{Cat_ID});
		}
		else{
				$x = &Search_Main_Form($4, $Param{Cat_ID});
		}
		$Out =~ s/$s/$x/g;
	}
	#------------------------------------------------------
	#<!--CLASS::Banner:Zone_Name-->
	#<!--CLASS::Banner:Get:Campaign_Name-->
	while ($Out =~ m/(<!--)(CLASS::Banner)(:)(.*?)(-->)/ ){
				$s = $1 . $2 . $3 . $4 . $5;
				$x = &Get_Banner_Class($4, $Global{Building_Pages});
				$Out =~ s/$s/$x/;
	}
	#------------------------------------------------------
	#<!--CLASS::Page:Page_Name-->
	while ($Out =~ m/(<!--)(CLASS::Page)(:)([^-->]+)(-->)/  ){
				$s = $1 . $2 . $3 . $4 . $5;
				$Temp = $4;
				$Temp =~ s/^\s+//g;
				$Temp =~ s/\s+$//g;
				$Temp || next;
				$x = qq!$Global{CGI_URL}$Global{MainProg}action=GetPage&Name=$Temp!;
				$Out =~ s/$s/$x/g;
	}
	#------------------------------------------------------
	while ($Out =~ m/(<!--)(CLASS::Help)(:)([^-->]+)(-->)/  ){
				$s = $1 . $2 . $3 . $4 . $5;
				$Temp = $4;
				$Temp =~ s/^\s+//g;
				$Temp =~ s/\s+$//g;
				$Temp || next;
				$x = qq!$Global{CGI_URL}$Global{MainProg}action=GetHelp&Page=$Temp!;
				$Out =~ s/$s/$x/g;
	}
	#------------------------------------------------------
	if ($Global{TimeHiRes}) {
			$Global{Program_End_Time} = eval "Time::HiRes::gettimeofday();";
	}
	else{
			$Global{Program_End_Time} = time;
	}

	$Plugins{Benchmark} = sprintf("%.4f", $Global{Program_End_Time} - $Global{ProgramStartTime});
	#------------------------------------------------------
	# Scan Classes: Pass Number: 3
	$Out =~ s/(<!--CLASS::([^:].*?)-->)/exists $Plugins{$2}?$Plugins{$2}: $1/gexs;
	#------------------------------------------------------
	# Scan Classes: Pass Number: 4
	$Out =~ s/(<!--CLASS::([^:].*?)-->)/exists $Plugins{$2}?$Plugins{$2}: $1/gexs;
	#------------------------------------------------------
	#------------------------------------------------------
	#------------------------------------------------------
	#$sw->lap("Display end...");
	#------------------------------------------------------
	#------------------------------------------------------
	print "Content-type: text/html\n\n";
	print "$Out";
	#------------------------------------------------------
}
#==========================================================
1;