=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub EditPost{
my (%Post, %Message, %Media);
	
	&Check_Account_Login;

	$Plugins{Bar_Action} = $Language{bar_edit_post};
	
	$Param{Topic} += 0;
	$Param{Post} += 0;

	%Topic = &GetForumTopic($Param{Topic});
	%Post = &GetForumPost($Param{Post});
	%Message = &GetForumMessage($Param{Post});
	%Media = &GetForumPostMedia($Param{Post});
	#------------------------------------------------------
	%Topic = &GetForumTopic($Param{Topic});
	if (!%Topic || !%Post) {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	if (!&CheckPostActionPermissions("Edit", %Post)) {
				$Plugins{Body} = $Language{error_edit_post_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Param{Type} = $Topic{Type};
	$Param{Subject} = $Message{Subject};
	$Param{Message} = $Message{Message};

	$Param{Topic} = $Post{Topic};
	$Param{Forum} = $Post{Forum};

	$Param{Color} = $Media{Color};
	$Param{Icon} = $Media{Icon};
	$Param{Media_Show} = $Media{Media_Show};
	$Param{Uploaded_Files} = $Media{Media};
	
	&Edit_Post;
}
#==========================================================
sub Edit_Post{
my ($Template, $Temp, $Form, $PostTimeClass, $PostTimeClass);
my ($Message, @Code, $Code, $Temp1);

	$Plugins{Bar_Action} = $Language{bar_edit_post};

	$Template = &TranslateFile($Global{ForumEditPostTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Param{Forum}/g;
	$Template =~ s/<!--Topic-->/$Param{Topic}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;
	#------------------------------------------------------
	# Text/Visual HTML Editor
	#------------------------------------------------------
	$Template = &GetEditorForm($Template, "Message", "700px", "300px");
	#------------------------------------------------------
	$Param{Subject} ||= "";
	$Param{Message} ||= "";
	$Template =~ s/<!--Subject-->/$Param{Subject}/g;
	$Template =~ s/<!--EditorText-->/$Param{Message}/g;
	#------------------------------------------------------
	#Delete uploaded file
	$Upload = 0;
	if ($Param{Delete_Uploaded_File}) {
			@Files = split(/\|/, $Param{Uploaded_Files});
			undef %Files;
			foreach $File (@Files) {
				$Files{$File} = 1;
			}
			delete $Files{$Param{Delete_Uploaded_File}};
			$Param{Uploaded_User_Size} -=  int((-s "$Global{Upload_Dir}/$Param{Delete_Uploaded_File}")/1000);
			$Param{Uploaded_User_Count}--;
			if (!$Param{Uploaded_User_Count}) {
					$Param{Uploaded_User_Size} = 0;
					undef %Files;
			}

			unlink ("$Global{Upload_Dir}/$Param{Delete_Uploaded_File}");
			@Files = keys %Files;
			$Param{Uploaded_Files} = join("\|", @Files);
			$Upload = 1;
	}
	#------------------------------------------------------
	#Upload files
	$Upload_Error = "";
	foreach $Key (keys %Param) {
			if ($Key =~ m/Mewsoft_Corporation_Upload_File\d+/) {
						$Filename = ""; $File_Content = "";
						#($Filename, $File_Content) = split(/\|/, $Param{$Key});
						$Upload_File = $Param{$Key};
						$Upload_File =~ /\r\n\r\n|\n\n/;         #separate header and body 
						$Upload_File_Name = $`;                # front part
						$Upload_File_Content = $';             # rear part
						$Upload_File_Content =~ s/\r\n$//;  # the last \r\n was put in by Netscape

						# Parse uploaded files
						$Upload_File_Name =~ /filename=\"(.+)\"/; 
						$Upload_File_Name = $1;  #print "[[Header= $Header ]](($Input))<br>";
						$Upload_File_Name =~ s/\"//g; # remove "s
						$Upload_File_Name =~ s/\s//g; # make sure no space(include \n, \r..) in the file name 
						@File_Name = split(/[\/|\\]/, $Upload_File_Name); 
						$Upload_File_Name = pop @File_Name;
						$Filename = $Upload_File_Name;
						$File_Content = $Upload_File_Content;
						#print "\$Filename=$Filename<br><br>\$File_Content=$File_Content<br><br>";
						#$File_Content = $Param{$Key};
						#$File_Content =~ s/^$Filename\|//;
						if ($Filename) {
									$Upload_Error .= &Upload_File($Filename, $File_Content);
									$Upload = 1;
						}
						delete $Param{$Key};
			}
	}
	#---------------------------------------------------------------------------------------------------------
	$Template =~ s/<!--Uploaded_Files-->/$Param{Uploaded_Files}/;
	$Template =~ s/<!--Uploaded_User_Size-->/$Param{Uploaded_User_Size}/;
	$Template =~ s/<!--Uploaded_User_Count-->/$Param{Uploaded_User_Count}/;
	if ($Upload_Error) {
			$Upload_Error = $Language{upload_error_msg} . $Upload_Error;
	}
	$Template =~ s/<!--Upload_File_Error_Msg-->/$Upload_Error/;
	#------------------------------------------------------
	@Files = split(/\|/, $Param{Uploaded_Files});
	$List = ""; $Count = 0;
	foreach $File (@Files) {
			$Count++;
			$Line = $Global{ManageUploadedFilesRow};
			$Line =~ s/<!--Count-->/$Count/;

			$Link = qq!$Global{HTML_URL}/upload/$File!;
			$Temp = $Language{upload_file_view_link};
			$Temp =~ s/<!--Link-->/$Link/g;
			$Temp =~ s/<!--Name-->/$File/g;
			$Line =~ s/<!--File-->/$Temp/g;
			
			$Temp = -s "$Global{Upload_Dir}/$File";
			$Line =~ s/<!--Size-->/$Temp/g;
			
			$Temp = $Language{editpost_delete_uploaded_file_link};
			$Temp =~ s/<!--File-->/$File/g;
			$Line =~ s/<!--Delete-->/$Temp/;

			if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_image};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.wav$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_sound};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mid$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_mid};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mov$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_movie};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.avi$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_avi};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			else{
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_other};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			$Line =~ s/<!--Preview-->/$URL/;
			$List .= $Line;
	}
	$Template =~ s/<!--Uploaded_Files_List_Manager-->/$List/;
	#------------------------------------------------------
	$Param{Media_Show} ||= 0;
	@Options = ($Language{media_type_1}, $Language{media_type_2}, $Language{media_type_3});
	$Temp = "";
	for $x(0..$#Options) {
				$Selected = "";
				if ($x eq $Param{Media_Show}) {$Selected = "SELECTED";}
				$Temp .= qq!<option value="$x" $Selected>$Options[$x]!;
	}
	$Template =~ s/<!--Media_Show-->/$Temp/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Param{Uploaded_User_Count} ||= 0; $Temp = 0;
	if ($Param{Uploaded_User_Count} == 1) {$Temp = $Global{Upload_One_File_Fee};}
	if ($Param{Uploaded_User_Count} == 2) {$Temp = $Global{Upload_Two_File_Fee};}
	if ($Param{Uploaded_User_Count} == 3) {$Temp = $Global{Upload_Three_File_Fee};}
	if ($Param{Uploaded_User_Count} == 4) {$Temp = $Global{Upload_Four_File_Fee};}
	if ($Param{Uploaded_User_Count} >= 5) {$Temp = ($Global{Upload_Five_File_Fee} * $Param{Uploaded_User_Count});}
	$Template =~ s/<!--Total_Uploaded_Fees-->/$Temp/;
	$Template =~ s/<!--Total_Uploaded_Count-->/$Param{Uploaded_User_Count}/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Template =~ s/<!--MAX_UPLOAD_FILES-->/$Global{Max_Upload_Files}/;
	$Template =~ s/<!--MAX_UPLOAD_FILE_SIZE-->/$Global{Max_Upload_File_Size}/;
	$Template =~ s/<!--MAX_UPLOAD_SIZE-->/$Global{Max_Upload_Size}/;
	$Template =~ s/<!--UPLOADED_USER_SIZE-->/$Param{Uploaded_User_Size}/;
	$Template =~ s/<!--UPLOADED_FILES_COUNT-->/$Param{Uploaded_User_Count}/;
	$Template =~ s/<!--ALLOWED_TYPES-->/$Global{Files_Ext_Allowed}/;
	$Template =~ s/<!--Max_Title_Length-->/$Global{Max_Title_Length}/g;
	$Template =~ s/<!--Post_Max_Len-->/$Global{Post_Max_Len}/g;
	#------------------------------------------------------
	#------------------------------------------------------
	# Announce, Sticky, Poll, Vote, Attach, ViewIP
	$Param{Type} ||= 0; # Normal, Sticky, Announcement
	if ($Param{Type} ==0) {
			$Template =~ s/<!--NormalStatus-->/checked/g;
	}
	else{
			$Template =~ s/<!--NormalStatus-->//g;
	}

	if (&CheckForumActionPermissions("Sticky", %Forum)) {
			if ($Param{Type} == 1) {
					$Template =~ s/<!--StickyStatus-->/checked/g;
			}
			else{
					$Template =~ s/<!--StickyStatus-->//g;
			}
	}
	else{
			$Template =~ s/<!--StickyStatus-->/disabled/g;
	}

	if (&CheckForumActionPermissions("Announce", %Forum)) {
			if ($Param{Type} == 2) {
					$Template =~ s/<!--AnnounceStatus-->/checked/g;
			}
			else{
					$Template =~ s/<!--AnnounceStatus-->//g;
			}
	}
	else{
			$Template =~ s/<!--AnnounceStatus-->/disabled/g;
	}
	#------------------------------------------------------
	if ($Param{Preview}) {
			$Form = &TranslateFile($Global{PreviewPostFormTemplate});
			#------------------------------------------------------
			$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
			if ($Form =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
						$PostTimeClass = $1 . $2 . $3. $4. $5;
						$PostTimeFormat =  $4;
			}
			$PostTimeClass =~ s/\(/\\\(/g;
			$PostTimeClass =~ s/\)/\\\)/g;
			#------------------------------------------------------
			#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
			$Temp = &ParseDate($PostTimeFormat, &Time(time));
			$Form =~ s/$PostTimeClass/$Temp/g;
			#------------------------------------------------------
			$Temp = $Param{Subject};
			$Form =~ s/<!--Subject-->/$Temp/g;
			$Message = $Param{Message};
			$Form =~ s/<!--Message-->/$Message/g;
			#------------------------------------------------------
			if ($Param{Uploaded_Files}) {
					undef @Media; undef @Docs;
					@Upload = split(/\|/, $Param{Uploaded_Files});
					foreach $File (@Upload) {
						if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
							push @Media, $File;
						}
						else{
							push @Docs, $File;
						}
					}
					$Temp = &Get_Media_Show($Param{Media_Show}, @Media);
					$Form =~ s/<!--Multimedia-->/$Temp/;

					$Docs = "";
					foreach $File (@Docs) {
							if ($File =~ /\.wav$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_sound};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.mid$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_mid};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.mov$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_movie};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.avi$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_avi};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							else{
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_other};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							$Docs .= $URL . $Language{docs_files_join};
					}
					$Docs =~ s/$Language{docs_files_join}$//g;
					$Form =~ s/<!--Documents-->/$Docs/;
			}
			#------------------------------------------------------
	}
	else{
			$Form = "";
	}
	$Template =~ s/<!--PreviewEditPost-->/$Form/g;
	#------------------------------------------------------
	#------------------------------------------------------
	if (&Check_Previous_User_Login ) {
			$Temp = $Language{user_logged_in_message};
			$Temp =~ s/<!--User_ID-->/$Param{User_ID}/g;
			$Template =~ s/<!--Login_Message-->/$Temp/g;
	}
	else{
			$Template =~ s/<!--Login_Message-->/$Language{register_login_message}/g;
	}
	#------------------------------------------------------
	&Display($Template, 1);
}
#==========================================================
sub SaveEditPost{
my (%Post, %Topic, $Subject, $Message, $Author, $Time, $Query);
my ($Username, $IP);

	&Check_Account_Login;
	
	if ($Param{Preview} || $Param{SubAction} eq "Preview") {
			&Edit_Post;
			return;
	}
	#------------------------------------------------------
	%Post = &GetForumPost($Param{Post});
	$Param{Topic} = $Post{Topic};
	$Param{Forum} = $Post{Forum};
	%Topic = &GetForumTopic($Param{Topic});
	#------------------------------------------------------
	if (!&CheckPostActionPermissions("Edit", %Post)) {
				$Plugins{Body} = $Language{error_edit_post_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Param{Subject} =~ s/^\s+//;
	$Param{Subject} =~ s/\s+$//;
	$Param{Subject} =~ s/<[^>]+>//ig;
	
	$Param{Message} =~ s/^\s+//;
	$Param{Message} =~ s/\s+$//;
	$Param{Message} =~ s/\cM//g;

	$Param{Message} = &HTML_Treat($Param{Message}, $Global{Post_Treat_HTML});
	$Param{Message} = substr($Param{Message}, 0, $Global{Post_Max_Len});
	#------------------------------------------------------
	if (!$Param{Subject}) {
			#&NewPost();
			#return;
	}

	if (!$Param{Message}) {
			&Edit_Post();
			return;
	}
	#------------------------------------------------------
	#$Param{Message} =~ s/\cM//g; # \cM = \n = \015
	#$Param{Message} =~ s/\n/\\\n/g;
	#------------------------------------------------------	
	$Subject = $dbh->quote($Param{Subject});
	$Message = $dbh->quote($Param{Message});

	$Param{User_ID} ||= $Global{Guest_User};
	$Author = $dbh->quote($Param{User_ID});
	
	$Time = &Time(time);
	#------------------------------------------------------
	$Param{Type} ||= 0;  # Normal, Sticky, Announcement
	#$Param{Status} ||= 0;  # Open , Closed
	#------------------------------------------------------
	# Update forum last post
	$Query = qq!UPDATE Forum_Topics SET Updated=$Time, LastPost=$Param{Post}, Type=$Param{Type} WHERE Topic=$Param{Topic}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# Update topic title if this is the first post
	if ($Param{Post} == $Topic{FirstPost}) {
		$Query = qq!UPDATE Forum_Topics SET Title=$Subject WHERE Topic=$Param{Topic}!;
		$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	# Update the post information
	$Username =  $dbh->quote("");
	$Param{Notify} ||= 0;
	
	$IP = &Get_Host;
	$IP = $dbh->quote($ENV{REMOTE_ADDR});

	$Query = qq!UPDATE Forum_Posts SET 
							Updated=$Time,
							Username=$Username,
							Notify=$Param{Notify},
							IP=$IP
							WHERE Post=$Param{Post}
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# Update the post message and subject
	$Query = qq!UPDATE Forum_Messages SET 
							Subject=$Subject,
							Message=$Message
							WHERE Post=$Param{Post}
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# Update the post media options
	$Param{Icon} ||= "";
	$Param{Color} ||= "";
	$Param{Uploaded_Files} ||= "";
	$Param{Media_Show} ||= 0;

	$Icon = $dbh->quote($Param{Icon});
	$Color = $dbh->quote($Param{Color});
	$Media = $dbh->quote($Param{Uploaded_Files});
	
	$Query = qq!UPDATE Forum_Media SET 
							Color=$Color,
							Icon=$Icon,
							Media_Show=$Param{Media_Show},
							Media=$Media
							WHERE Post=$Param{Post}
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# mark topic as unread for all users
	$Query = qq!DELETE FROM Forum_Topic_Read WHERE Topic=$Param{Topic}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# Mark topic read for this user
	&MarkTopicRead($Param{User_ID}, $Param{Topic});
	#------------------------------------------------------
	&Forums;
}
#==========================================================
1;