=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ClassEditor {
my ($Help);

	$Param{EditorTheme} ||= $Global{Theme};
	$Help = &Help_Link("ClassEditor");
	&Print_Page(&ClassEditorForm, "Class Editor - $Param{EditorTheme}", $Help);
}
#==========================================================
sub ClassEditorForm {
my ($Out, %Class, @Class, $Classes, %Custom);
my ($ClassIndex, $Class, $x, $y, $Key);

	$Param{EditorTheme} ||= $Global{Theme};
	#------------------------------------------------------------------
	open (FILE, "$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot open configuration file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	undef %Class;

	foreach $Line(@All){
			($K, $V) = split(/\~\=\=\~/ , $Line);
			$V =~ s/\n$//g;
			$V=~ s/\\n/\n/g;
			if (!$K) {next;}
			$Class{$K} = &Encode_HTML($V);
	}
	#------------------------------------------------------------------
	open (FILE, "$Global{Data_Dir}/GeneralClasses.pm") || &Exit("Cannot open configuration file $Global{Data_Dir}/GeneralClasses.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	undef %General;

	foreach $Line(@All){
			$Line =~ s/\n$//g;
			$Line =~ s/\s+//g;
			if (!$Line) {next;}
			$General{$Line} = 1;
	}
	@General = keys %General;
	#------------------------------------------------------------------
	open (FILE, "$Global{Data_Dir}/SpecialClasses.pm") || &Exit("Cannot open configuration file $Global{Data_Dir}/SpecialClasses.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	undef %Special;

	foreach $Line(@All){
			$Line =~ s/\n$//g;
			$Line =~ s/\s+//g;
			if (!$Line) {next;}
			$Special{$Line} = 1;
	}
	@Special = keys %Special;
	#------------------------------------------------------------------
	%Custom = %Class;
	foreach $Class (@General) { # User created custom classes
			delete $Custom{$Class};
	}
	foreach $Class (@Special) { # User created custom classes
			delete $Custom{$Class};
	}
	@Custom = keys %Custom;

	@General = sort @General;
	@Custom = sort @Custom;
	@Special = sort @Special;
	
	unshift @General, '';
	unshift @Custom, '';
	unshift @Special, '';

	push @Class, @General;
	push @Class, @Custom;
	push @Class, @Special;

	$ClassIndex = "";
	for $x(0..$#Class) {
			$y = $x+1;
			 $ClassIndex .= qq!ClassIndex[$y] = \'$Class[$x]\';\n!;
	}

	$EditClassName = ""; $EditClassText = "";
	$Param{ClassName} ||= $Class[0];

	$Classes = "";
	foreach $Class(@General) {
		if ($Class eq '') {
				$Classes .= qq!\n<option value="" style="background-color:#6193E4; color:#FFFFFF;">--------------------- General Classes ---------------------</option>\n!;
				next;
		}
		$Selected = "";
		if ($Class eq $Param{ClassName}) {$Selected ="selected"; $EditClassName = $Param{ClassName}; $EditClassText = $Class{$Class};}
		$Classes .= qq!\n<option value="$Class{$Class}" style="background-color:#D9E4F9; color:#000000;" $Selected>$Class</option>\n!;
	}
	
	foreach $Class(@Custom) {
		if ($Class eq '') {
				$Classes .= qq!\n<option value="" style="background-color:#9B009B; color:#FFFFFF;">---------------- Custom General Classes ---------------</option>\n!;
				next;
		}
		$Selected = "";
		if ($Class eq $Param{ClassName}) {$Selected ="selected"; $EditClassName = $Param{ClassName}; $EditClassText = $Class{$Class};}
		$Classes .= qq!\n<option value="$Class{$Class}"  style="background-color:#D2F0FF; color:#000000;" $Selected>$Class</option>\n!;
	}

	foreach $Class(@Special) {
		if ($Class eq '') {
				$Classes .= qq!\n<option value="" style="background-color:#CC0000; color:#FFFFCC;">--------------------- Special Classes ---------------------</option>\n!;
				next;
		}
		$Selected = "";
		if ($Class eq $Param{ClassName}) {$Selected ="selected"; $EditClassName = $Param{ClassName}; $EditClassText = $Class{$Class};}
		$Classes .= qq!\n<option value="$Class{$Class}"  style="background-color:#A6C1F0; color:#000000;" $Selected>$Class</option>\n!;
	}
	$Global{AdminTextEditorWidth} ||= "100%";
	$Global{AdminTextEditorHeight} ||= "400px";
	$Global{AdminTextEditorFontSize} ||= "13px";
	#------------------------------------------------------------------
	@Themes = &ThemesList;
	$Themes = "";
	$Themes .= qq!\n<option value="" style="background-color:#739EE8; color:#FFFFFF;">-- Theme --</option>\n!;
	foreach $Theme(sort @Themes) {
			$Selected = "";
			if ($Theme eq $Param{EditorTheme}) {$Selected = "selected";}
			$Themes .= qq!\n<option value="$Theme" style="background-color:#739EE8; color:#FFFFFF;" $Selected>$Theme</option>\n!;
	}
	#------------------------------------------------------------------
	@Colors = ('BLACK','RED','GREEN','BLUE','AQUA','GRAY','NAVY','SILVER','OLIVE','TEAL','LIME','PURPLE','WHITE','FUCHSIA','MAROON','YELLOW','#000000','#003300','#006600','#009900','#00CC00','#00FF00','#000033','#003333','#006633','#009933','#00CC33','#00FF33','#000066','#003366','#006666','#009966','#00CC66','#00FF66','#000099','#003399','#006699','#009999','#00CC99','#00FF99','#0000CC','#0033CC','#0066CC','#0099CC','#00CCCC','#00FFCC','#0000FF','#0033FF','#0066FF','#0099FF','#00CCFF','#00FFFF','#330000','#333300','#336600','#339900','#33CC00','#33FF00','#330033','#333333','#336633','#339933','#33CC33','#33FF33','#330066','#333366','#336666','#339966','#33CC66','#33FF66','#330099','#333399','#336699','#339999','#33CC99','#33FF99','#3300CC','#3333CC','#3366CC','#3399CC','#33CCCC','#33FFCC','#3300FF','#3333FF','#3366FF','#3399FF','#33CCFF','#33FFFF','#660000','#663300','#666600','#669900','#66CC00','#66FF00','#660033','#663333','#666633','#669933','#66CC33','#66FF33','#660066','#663366','#666666','#669966','#66CC66','#66FF66','#660099','#663399','#666699','#669999','#66CC99','#66FF99','#6600CC','#6633CC','#6666CC','#6699CC','#66CCCC','#66FFCC','#6600FF','#6633FF','#6666FF','#6699FF','#66CCFF','#66FFFF','#990000','#993300','#996600','#999900','#99CC00','#99FF00','#990033','#993333','#996633','#999933','#99CC33','#99FF33','#990066','#993366','#996666','#999966','#99CC66','#99FF66','#990099','#993399','#996699','#999999','#99CC99','#99FF99','#9900CC','#9933CC','#9966CC','#9999CC','#99CCCC','#99FFCC','#9900FF','#9933FF','#9966FF','#9999FF','#99CCFF','#99FFFF','#CC0000','#CC3300','#CC6600','#CC9900','#CCCC00','#CCFF00','#CC0033','#CC3333','#CC6633','#CC9933','#CCCC33','#CCFF33','#CC0066','#CC3366','#CC6666','#CC9966','#CCCC66','#CCFF66','#CC0099','#CC3399','#CC6699','#CC9999','#CCCC99','#CCFF99','#CC00CC','#CC33CC','#CC66CC','#CC99CC','#CCCCCC','#CCFFCC','#CC00FF','#CC33FF','#CC66FF','#CC99FF','#CCCCFF','#CCFFFF','#FF0000','#FF3300','#FF6600','#FF9900','#FFCC00','#FFFF00','#FF0033','#FF3333','#FF6633','#FF9933','#FFCC33','#FFFF33','#FF0066','#FF3366','#FF6666','#FF9966','#FFCC66','#FFFF66','#FF0099','#FF3399','#FF6699','#FF9999','#FFCC99','#FFFF99','#FF00CC','#FF33CC','#FF66CC','#FF99CC','#FFCCCC','#FFFFCC','#FF00FF','#FF33FF','#FF66FF','#FF99FF','#FFCCFF','#FFFFFF');
	
	$AdminEditorBackground = "";
	foreach $Color (@Colors) {
			$Selected = "";
			if ($Color eq $Global{AdminEditorBackground}) {$Selected = "selected";}
			$AdminEditorBackground .= qq!\n<option value="$Color" style="background-color:$Color; color:#000000;" $Selected>$Color</option>\n!;
	}

	$AdminEditorForeground = "";
	foreach $Color (@Colors) {
			$Selected = "";
			if ($Color eq $Global{AdminEditorForeground}) {$Selected = "selected";}
			$AdminEditorForeground .= qq!\n<option value="$Color" style="background-color:$Color; color:#000000;" $Selected>$Color</option>\n!;
	}
	#------------------------------------------------------
	$EditorSettings = &EditorSettingsForm;
	#------------------------------------------------------
	#Enable/ Disable admin JS syntax hilighter
	$Global{AdminEditorHighlighter} += 0;
	if (!$Global{AdminEditorHighlighter}) {$Global{AdminEditorHighlighter} = "0";}
	if ($Global{AdminEditorHighlighter}) {
			$EditorHighlighter = qq!<script src="$Global{HTML_URL}/texteditor/codepress.js" type="text/javascript"></script>!;
			$ToggleEditor = qq!<input type="button" value="Toggle Editor" name="TEditor" id="TEditor" onClick="MyToggleEditor(); return false;">!;
	}
	else {
			$EditorHighlighter = "";
			$ToggleEditor = "";
	}
	#------------------------------------------------------
	#------------------------------------------------------

$Out =<<HTML;
<form method="post" id="EditorForm" name ="EditorForm" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveEditorClass">
<input type="hidden" name="ClassName" value="$EditClassName">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">

<table border="0" width="100%" cellspacing="0" cellpadding="2" class="TableAttr">
  <tr><td width="100%" align="left">
			<table border="0" cellspacing="0" cellpadding="2">
				<tr>
					<td><b>Theme:</b> </td><td><select name="Themes" onChange="ChangeTheme();">$Themes</select></td>
					<td><b>&nbsp;Class:</td><td></b> <select name="Classes" onChange="ChangeClass();">$Classes</select></td>
					<td>
						<input type="submit" value="Save Class">&nbsp;&nbsp;
						$ToggleEditor
						</td>
				</tr>
			</table>		
	</td>
  </tr>
  <tr><td width="100%" align="left"> 
			<table border="$EditorBorder" width="100%" cellspacing="0" cellpadding="0">
			  <tr><td width="100%" align="left" valign="top">
					<textarea class="codepress html linenumbers-on" id="MyEditor" name="MyEditor" style="font-size: $Global{AdminTextEditorFontSize};width: $Global{AdminTextEditorWidth}; height: $Global{AdminTextEditorHeight}; border: 1px solid #62B0FF; padding: 2; background-color:$Global{AdminEditorBackground}; color:$Global{AdminEditorForeground};">$EditClassText</textarea>
				</td>
			  </tr>
			</table>
	</td>
  </tr>
    <tr><td width="100%" align="center">
			<input type="submit" value="Save Class" name="Submit" style="width: 100px;">&nbsp;
			$ToggleEditor&nbsp;
			<input type="button" value="Delete Class" name="Delete" onClick="DeleteClass(); return false;" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
    </tr>
</table>
</form>
<br>
<!--------------------------------------------------------------------------------->

<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('CustomClass');"><img src="$Global{Skin}/expand.gif" border="0" align="absmiddle">Create New General Class</a>
</div>
<div name="CustomClass" id="CustomClass" style="display: none;">

<form method="post" name ="NewEditorForm" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateCustomClass">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">
<table cellpadding="2" cellspacing="0" class="TableAttr" width="700">
	<tr><td class="TableHeader" align="center">Create New General Class</td></tr>
    <tr><td width="100%" nowrap>New Class Name: <input type="text" value="" name="NewCustomClass" size="35"></td>
    <tr><td width="100%" align="center">
			<input type="submit" value="Add Class" name="Submit" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
    </tr>
</table>
</form>
<br>
</div>

<!--------------------------------------------------------------------------------->
<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('EditorSettings');"><img src="$Global{Skin}/expand.gif" border="0" align="absmiddle">Editor Settings</a>
</div>
<div name="EditorSettings" id="EditorSettings" style="display: none;">
$EditorSettings
</div>

<!--------------------------------------------------------------------------------->
$EditorHighlighter

<script type="text/javascript">
function mySubmit() {
	//MyEditor.toggleEditor();
	//document.EditorForm.submit();
	//return false;
}
</script>
<!-------------------------------------------------->
<script language="JavaScript">
<!--

function MyToggleEditor(){
	MyEditor.toggleEditor();
}

var SyntaxHilighterStatus = $Global{AdminEditorHighlighter};

var ClassIndex = new Array();
$ClassIndex

function ChangeClass() {

	var Selected = 0;
	Selected = document.EditorForm.Classes.selectedIndex;
	document.EditorForm.ClassName.value = ''+ClassIndex[Selected+1];

	if (SyntaxHilighterStatus == 1) {
			//Syntax hilighter enabled
			MyEditor.edit(document.EditorForm.Classes[Selected].value);
	}
	else {
			document.EditorForm.MyEditor.value = document.EditorForm.Classes[Selected].value;
	}
}

function ChangeTheme() {
	var Theme;
	if (!document.EditorForm.Themes.selectedIndex) {return false;}
	Theme = document.EditorForm.Themes[document.EditorForm.Themes.selectedIndex].value;
	window.location = "$Global{AdminURL}action=ClassEditor&EditorTheme=" +Theme;
}

function DeleteClass() {
	if (!document.EditorForm.Classes.selectedIndex) {return false;}
	var agree=confirm("Are you sure you want to delete this class?\\n\\n" + "    Class: ["+document.EditorForm.ClassName.value +"]\\n");
	if (agree){
			agree=confirm("Please note this  process can not be undone.\\nAre you sure you still want to delete this class?\\n\\n"+ "    Class: ["+document.EditorForm.ClassName.value +"]\\n");
			if (agree){
					document.EditorForm.action.value = 'DeleteClass';
					document.EditorForm.submit();
			}
	}
}

/* Cross browser related methods */
function GetElementById(id) {
	if (document.all) {
		return document.all(id);
	} else
		if (document.getElementById) {
			return document.getElementById(id);
		}
}

function Toggle(id) {  
	//HideOthers(id);
	var ctrlID = '';
	if (document.all) {ctrlID = document.all(id);}
	else	if (document.getElementById) {ctrlID = document.getElementById(id);}

	if (ctrlID.style.display == 'none'){ctrlID.style.display = 'block';	}
	else	{ctrlID.style.display = 'none';}
}

function HideAll(){
	var tags = document.getElementsByTagName("div")
	for(i=0;i<tags.length;i++){
		tags[i].style.display = 'none'
	}
}

function HideOthers(divID){
	var tags = document.getElementsByTagName("div")
	for(i=0;i<tags.length;i++){
		if (tags[i].getAttribute('id') != divID){
			tags[i].style.display = 'none'
		}
	}
}

function toggleVisibility(me){
	if (me.style.visibility=="hidden"){
		me.style.visibility="visible";
	}
	else {
		me.style.visibility="hidden";
	}
}

// -->
</script>

HTML

	return $Out;
}
#==========================================================
sub EditorSettingsForm {
my ($Out, $AdminEditorHighlighter);
	
		if ($Global{AdminEditorHighlighter}) {
				$AdminEditorHighlighter = "checked";
		}
		else {
				$AdminEditorHighlighter = "";
		}

$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveEditorSetting">
<input type="hidden" name="Editor" value="ClassEditor">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">

<table cellpadding="2" cellspacing="0" class="TableAttr" width="700">
<tr><td class="TableHeader" align="center">Editor Settings</td></tr>
    <tr><tr><td nowrap class="TableCell">
			Width: <input type="text" name="AdminTextEditorWidth" value="$Global{AdminTextEditorWidth}" size="10">&nbsp;
			Height: <input type="text" name="AdminTextEditorHeight" value="$Global{AdminTextEditorHeight}" size="10">&nbsp;
			Size in percentage or pixels
	</td></tr>
	<tr><td nowrap class="TableCell">
			Font Size : <input type="text" name="AdminTextEditorFontSize" value="$Global{AdminTextEditorFontSize}" size="10">&nbsp;
	</td></tr>

	<tr><td nowrap class="TableCell">
			Background Color : <input type="text" name="AdminEditorBackground" value="$Global{AdminEditorBackground}" size="10">&nbsp;
			Foreground Color: <input type="text" name="AdminEditorForeground" value="$Global{AdminEditorForeground}" size="10">
	</td></tr>

	<tr><td nowrap class="TableCell">
			Real Time Syntax Highlighting: <input type="checkbox" name="AdminEditorHighlighter" value="1" $AdminEditorHighlighter>
	</td></tr>

	<tr><td nowrap class="TableCell" align="center">
			<input type="submit" value="Save Changes" style="width: 100px;" name="Submit">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
	</td></tr>
  </table>
</form>
<br>
HTML
	return $Out;		
}
#==========================================================
sub SaveEditorClass {
my (@All, %Config, $Line, $Key, $Value);

	if (!$Param{ClassName}) {
				&ClassEditor;
				return;
	}

	$Param{MyEditor} =~ s/\cM//g;

	open (FILE, "$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot open file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);

	undef %Config;
	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}
	$Config{$Param{ClassName}} = $Param{MyEditor};

	open (FILE, ">$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot write file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	foreach $Key (sort keys %Config) {
			$Value = $Config{$Key};
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}
	close(FILE);

	&Read_Configuration;
	&ClassEditor;
}
#==========================================================
sub DeleteClass{
my (@All, %Config, $Line, $Key, $Value);

	if (!$Param{ClassName}) {
				&ClassEditor;
				return;
	}

	$Param{MyEditor} =~ s/\cM//g;

	open (FILE, "$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot open file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);

	undef %Config;
	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}
	
	delete $Config{$Param{ClassName}};

	open (FILE, ">$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot write file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	foreach $Key (sort keys %Config) {
			$Value = $Config{$Key};
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}
	close(FILE);

	&Read_Configuration;
	&ClassEditor;
}
#==========================================================
sub SaveEditorSetting {
my (%Config, $Key);

	undef %Config;

	$Param{AdminTextEditorWidth} ||= "100%";
	$Param{AdminTextEditorHeight} ||= "400px";
	$Param{AdminEditorBackground} ||= '#99FFFF';
	$Param{AdminEditorForeground} ||= '#000000';
	$Param{AdminTextEditorFontSize} ||= "13px";
	$Global{AdminEditorHighlighter} += 0;

	$Config{AdminTextEditorWidth} = $Param{AdminTextEditorWidth};
	$Config{AdminTextEditorHeight} = $Param{AdminTextEditorHeight};
	$Config{AdminEditorBackground} = $Param{AdminEditorBackground};
	$Config{AdminEditorForeground} = $Param{AdminEditorForeground};
	$Config{AdminTextEditorFontSize} = $Param{AdminTextEditorFontSize};
	$Config{AdminEditorHighlighter} = $Param{AdminEditorHighlighter};

	&UpdateConfiguration(%Config);
	
	&Read_Configuration;

	if ($Param{Editor} eq "ClassEditor") {
		&ClassEditor;
	}
	elsif ($Param{Editor} eq "TemplateEditor") {
			&TemplateEditor;
	}
	else{
			&TemplateEditor;
	}
}
#==========================================================
sub TemplateEditor{
my ($Help);

	$Help = &Help_Link("TemplateEditor");
	&Print_Page(&TemplateEditorForm, "Template Editor - $Param{File}", $Help);
}
#==========================================================
sub TemplateEditorForm{
my ($Out, %Class, @Class, $Classes, @Files, $File);
my ($ClassIndex, $Class, $x, $y, %Details);
	
	$Param{EditorTheme} ||= $Global{Theme};
	$Directory = "$Global{Data_Dir}/templates/$Param{EditorTheme}";

	undef @Files;
	opendir(Dir,$Directory);
	foreach $File (readdir(Dir)) {
			if( -f "$Directory/$File" && $File ne "." && $File ne ".." && $File !~ /\.bak$/i && $File !~ /\.pm$/i) { 
				push @Files, $File;
			}
    }
	closedir(Dir);
	@Files = sort @Files;
	#----------------------------------------------------------------
	# Get the templates names
	undef %Details;
	open (FILE, "$Global{Data_Dir}/ThemeFiles.pm") || &Exit("Cannot open file $Global{Data_Dir}/ThemeFiles.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);
	foreach $Line(@All){
			$Line =~ s/\n$//; next if (!$Line);
			($Key, $Value) = split(/\=/ , $Line);
			next if (!$Key);
			$Value =~ s/\\n/\n/g;
			$Details{$Key} = $Value;
	}
	#----------------------------------------------------------------
	$Param{File} ||= ""; #$Files[0];
	$Files = "";
	$Files = qq!\n<option value="" style="background-color:#6193E4; color:#FFFFFF;">------------------ Templates ------------------</option>\n!;
	foreach $File(@Files) {
		$Name = $File;
		if (defined $Details{$File}) {$Name = $Details{$File};}
		$Selected = "";
		if ($File eq $Param{File}) {$Selected = "selected";}
		$Files .= qq!\n<option value="$File" style="background-color:#D1E0F8; color:#000000;" $Selected>$Name</option>\n!;
	}
	#------------------------------------------------------------------
	$Global{AdminTextEditorWidth} ||= "100%";
	$Global{AdminTextEditorHeight} ||= "400px";
	#------------------------------------------------------------------
	@Themes = &ThemesList;
	$Themes = "";
	$Themes .= qq!\n<option value="" style="background-color:#739EE8; color:#FFFFFF;">-- Theme --</option>\n!;
	foreach $Theme(sort @Themes) {
			$Selected = "";
			if ($Theme eq $Param{EditorTheme}) {$Selected = "selected";}
			$Themes .= qq!\n<option value="$Theme" style="background-color:#739EE8; color:#FFFFFF;" $Selected>$Theme</option>\n!;
	}
	#------------------------------------------------------------------
	$EditorText = "";
	if ($Param{File}) {
			$File = "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}";
			open (FILE, "$File") || &Exit("Cannot open file $File: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
			@All = <FILE>;
			close(FILE);
			$EditorText = join("", @All);
			$EditorText = &Encode_HTML($EditorText);
	}
	#------------------------------------------------------
	$EditorSettings = &EditorSettingsForm;
	#------------------------------------------------------
	#Enable/ Disable admin JS syntax hilighter
	if ($Global{AdminEditorHighlighter}) {
			$EditorHighlighter = qq!<script src="$Global{HTML_URL}/texteditor/codepress.js" type="text/javascript"></script>!;
			$ToggleEditor = qq!<input type="button" value="Toggle Editor" name="TEditor" id="TEditor" onClick="MyToggleEditor(); return false;">!;
	}
	else {
			$EditorHighlighter = "";
			$ToggleEditor = "";

	}
	#------------------------------------------------------
	#------------------------------------------------------

$Out =<<HTML;
<form method="post" id="EditorForm" name ="EditorForm" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveTemplateEditor">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">

<table border="0" width="100%" cellspacing="0" cellpadding="2" class="TableAttr">
  <tr><td width="100%" align="left">
			<table border="0" cellspacing="0" cellpadding="2">
				<tr>
					<td><b>Theme:</b> </td><td><select name="Themes" onChange="ChangeTheme();">$Themes</select></td>
					<td><b>&nbsp;Template: </td><td></b><select name="File" onChange="ChangeFile();">$Files</select></td>
					<td>
								<input type="submit" value="Save File" > &nbsp;
								$ToggleEditor
					</td>
				</tr>
			</table>		
	</td>
  </tr>
  <tr><td width="100%" align="left"> 
			<table border="0" width="100%" cellspacing="0" cellpadding="0">
			  <tr><td width="100%" align="left" valign="top">
					<textarea class="codepress html linenumbers-on" id="MyEditor" name="MyEditor" style="font-size: $Global{AdminTextEditorFontSize};width: $Global{AdminTextEditorWidth}; height: $Global{AdminTextEditorHeight}; border: 1px solid #62B0FF; padding: 2; background-color:$Global{AdminEditorBackground}; color:$Global{AdminEditorForeground};">$EditorText</textarea>
				</td>
			  </tr>
			</table>
	</td>
  </tr>
    <tr><td width="100%" align="center">
			<input type="submit" value="Save File" name="Submit" style="width: 100px;">&nbsp;
			$ToggleEditor&nbsp;
			<input type="button" value="Delete File" name="Delete" onClick="DeleteFile(); return false;" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
    </tr>
</table>
</form>
<br>

<!--------------------------------------------------------------------------------->
<div style="padding-bottom: 5px;width:100%;">
<a href="Javascript:Toggle('CustomPage');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Create Custom Page</a>
</div>

<div name="CustomPage" id="CustomPage" style="display: none;">
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateCustomPage">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">
<table cellpadding="2" cellspacing="0" class="TableAttr" width="700">
	<tr><td class="TableHeader" align="center">Create Custom Page</td></tr>
    <tr><td width="100%" nowrap>New Custom Page Name: <input type="text" value="" name="Name" size="40"> No spaces or strange letters</td>
	</tr>
    <tr><td width="100%" align="center">
			<input type="submit" value="Create Page" name="Submit" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
    </tr>
	<tr><td width="100%">
		
		<br>If you create a new custom page with name <b>PageName</b>, the program will automatically create a template file in every template directory with the name <b>PageName.page.shtml</b>, and a language file with the name <b>PageName.page.pm</b> in every language directory.
		<br><br>You can directly link to the custom page as:
		<input type="text" value="&lt;a href=&quot;$Global{CGI_URL}/$Global{MainProg}?action=GetPage&Name=PageName&Lang=$Global{Language}&quot;&gt;Visit My Page&lt;/a&gt;" style="width: 100%">
		<br><br>Also in your templates you can insert the class:
			<input type="text" value="&lt;a href=&quot;&lt;!--CLASS::Page:PageName--&gt;&quot;&gt;Visit My Page&lt;/a&gt;" style="width: 100%"> to link to your custom page.<br>

	</td>
</table>
</form>
<br><br>
</div>
<!--------------------------------------------------------------------------------->

<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript:Toggle('CustomFile');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Create New File</a>
</div>

<div name="CustomFile" id="CustomFile" style="display: none;">
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateNewTemplate">
<input type="hidden" name="EditorTheme" value="$Param{EditorTheme}">
<table cellpadding="2" cellspacing="0" class="TableAttr" width="700">
	<tr><td class="TableHeader" align="center">Create New File</td></tr>
    <tr><td width="100%" nowrap>New File Name: <input type="text" value="" name="NewFile" size="40"> No spaces or strange letters</td>
    <tr><td width="100%" align="center">
			<input type="submit" value="Create File" name="Submit" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
    </tr>
</table>
</form>
<br><br>
</div>
<!--------------------------------------------------------------------------------->
<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('EditorSettings');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Editor Settings</a>
</div>
<div name="EditorSettings" id="EditorSettings" style="display: none;">
$EditorSettings
</div>
<!--------------------------------------------------------------------------------->
<br>

<!--------------------------------------------------------------------------------->
$EditorHighlighter

<script type="text/javascript">
function mySubmit() {
	//MyEditor.toggleEditor();
	//document.EditorForm.submit();
	//return false;
}
</script>
<!-------------------------------------------------->
<script language="JavaScript">
<!--

function MyToggleEditor(){
	MyEditor.toggleEditor();
}

//function silentErrorHandler() {return true;}
//window.onerror = silentErrorHandler;

function ChangeFile() {
	var File;
	//if (!document.EditorForm.File.selectedIndex) {return false;}
	File = document.EditorForm.File[document.EditorForm.File.selectedIndex].value;
	window.location = "$Global{AdminURL}action=TemplateEditor&EditorTheme=$Param{EditorTheme}&File=" +File;
}

function ChangeTheme() {
	var Theme;
	if (!document.EditorForm.Themes.selectedIndex) {return false;}
	Theme = document.EditorForm.Themes[document.EditorForm.Themes.selectedIndex].value;
	window.location = "$Global{AdminURL}action=TemplateEditor&EditorTheme=" +Theme;
}

function DeleteFile() {
	if (!document.EditorForm.File.selectedIndex) {return false;}
	var agree=confirm("Are you sure you want to delete this template file?\\n\\n" + "    File: ["+document.EditorForm.File.value +"]\\n");
	if (agree){
			agree=confirm("Please note this  process can not be undone.\\nAre you sure you still want to delete this template file?\\n\\n"+ "    File: ["+document.EditorForm.File.value +"]\\n");
			if (agree){
					document.EditorForm.action.value = 'DeleteTemplate';
					document.EditorForm.submit();
			}
	}
}

/* Cross browser related methods */
function GetElementById(id) {
	if (document.all) {
		return document.all(id);
	} else
		if (document.getElementById) {
			return document.getElementById(id);
		}
}

function Toggle(id) {  
	var ctrlID = '';
	if (document.all) {
		ctrlID = document.all(id);
	} else
		if (document.getElementById) {
			ctrlID = document.getElementById(id);
	}
	if (ctrlID.style.display == 'none')
	{
		ctrlID.style.display = 'block';
	}
	else
	{
		ctrlID.style.display = 'none';
	}        
}

// -->
</script>

HTML

	return $Out;
}
#==========================================================
sub DeleteTemplate {
	
	if ($Param{File} && $Param{EditorTheme}) {
		if  (-f "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}") {
			unlink "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}\.bak";
			rename  "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}", unlink "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}\.bak";
			unlink "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}";
			$Param{File} = "";
		}
	}
	&Read_Configuration;
	&TemplateEditor;
}
#==========================================================
sub SaveTemplateEditor {
my ($File);

	$Param{EditorTheme} ||= $Global{Theme};
	$File = "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{File}";
	chmod (0777, $File);
	open (FILE, ">$File") || &Exit("Error: Can't create file $File: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);

    $Param{MyEditor} =~ s/\cM//g;

    print FILE $Param{MyEditor};
	close (FILE);
	chmod (0755, $File);

	&Read_Configuration;
	&TemplateEditor;
}
#==========================================================
sub CreateNewTemplate{
my ($File);

	$Param{NewFile} =~ s/^\s+//;
	$Param{NewFile} =~ s/\s+$//;
	if ($Param{NewFile} !~ /\./) {$Param{NewFile} .= "\.html";}

	$File = "$Global{Data_Dir}/templates/$Param{EditorTheme}/$Param{NewFile}";
	
	if (!-f $File) {
			open (FILE, ">$File") || &Exit("Error: Can't create file $File: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			close (FILE);
			chmod (0755, $File);
	}
	$Param{File} = $Param{NewFile};
	&TemplateEditor;
}
#==========================================================
sub CreateCustomClass{
my (@All, %Config, $Line, $Key, $Value);
	
	$Param{NewCustomClass} =~ s/\s+//g;

	open (FILE, "$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot open file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);

	undef %Config;
	foreach $Line(@All){
			$Line =~ s/\n$//;
			($Key, $Value) = split(/\~\=\=\~/ , $Line);
			$Value =~ s/\\n/\n/g;
			$Config{$Key} = $Value;
	}
	
	$Config{$Param{ClassName}} = $Param{MyEditor};
	
	if ($Param{NewCustomClass} && ! exists $Config{$Param{NewCustomClass}}) {
				$Config{$Param{NewCustomClass}} = "";
	}

	open (FILE, ">$Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm") || &Exit("Cannot write file $Global{Data_Dir}/templates/$Param{EditorTheme}/Config.pm: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	foreach $Key (sort keys %Config) {
			$Value = $Config{$Key};
			$Value  =~ s/\n/\\n/g;
			print FILE  "$Key~==~$Value\n";
	}
	close(FILE);
	
	$Param{ClassName} = $Param{NewCustomClass};
	&Read_Configuration;
	&ClassEditor;
}
#==========================================================
sub CreateCustomPage {
my ($Help, $Lang_File, $Template_File, $Msg);
my (@Langs, $Lang, @Themes, $Theme);

	$Param{Name} =~ s/^\s+//;
	$Param{Name} =~ s/\s+$//;

	if (!$Param{Name}) {&Admin_Msg("Error", "Please enter a filename to create the custom page you want.", 1);}
	
	@Langs = &LanguagesList;
	@Themes = &ThemesList;

	foreach $Lang(@Langs){
			$Lang_File = qq!$Global{Data_Dir}/language/$Lang/$Param{Name}\.page\.pm!;
			if (!-e $Lang_File) {
					open (Out, ">$Lang_File") || &Exit("Cannot create file $Lang_File: $!\n" . "<BR>Line " . __LINE__ . ", File ". __FILE__);
					print Out qq|page_title~==~Custom Page<BR><BR>\n|;
					print Out qq|page_body_text~==~This is an exmple of how to create unlimited custom pages. You create custom pages from the template editor. All you need to link to this custom page in your templates is to insert the class <B>&lt;!--CLASS::Page:PageName--&gt;</B> in your templates, where <B>PageName</B> is the name of the page you want to create. The program will automatically create a template file in the templates directory with the name <B>PageName.page.shtml</B> and a language files with the name <B>PageName.page.pm</B> in every language directory.<BR><BR> You can then edit these generated files in the normal way. Also you can use inside these files all the General Classes, your custom functions, and the banner classes. For example you may want to use the Header, Top and Bottom Navigations Classes.<BR>\n|;
					close Out;
					chmod (0755, $Lang_File);
			}
	}

	foreach $Theme(@Themes){
			$Template_File = qq!$Global{Data_Dir}/templates/$Theme/$Param{Name}\.page\.shtml!;
			if (-e $Template_File) {next;}

			open (Out, ">$Template_File") || &Exit("Cannot create file $Template_File: $!\n" . "<BR>Line " . __LINE__ . ", File ". __FILE__);

print Out <<HTML;
<!--CLASS::Header-->
<DIV align="center"><CENTER>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="0" BGCOLOR="#FFFFFF" CELLSPACING="0">
<TR><TD align="center" WIDTH="100%">
<!--CLASS::TopNav-->
<!--CLASS::TopArea-->
<!--CLASS::WelcomeArea-->
<!-------------------------------------------------->
<TABLE BORDER="0" align="center" Valign="middle" WIDTH="600" CELLSPACING="1" CELLPADDING="4">
  <TR><TD WIDTH="100%">[[page_title]]</TD></TR>
  <TR><TD WIDTH="100%">
	[[page_body_text]]
	<BR>
	<B>How to edit these custom files</B><BR>
	Edit the language files <B>$Param{Name}\.page\.pm</B> from the Language Manager. Also edit the template file <B>$Param{Name}\.page\.shtml</B> from the template editor for each them.<BR>
	</TD></TR>
</TABLE>
<!-------------------------------------------------->
<BR>
<!--CLASS::BottomNav-->
<!--CLASS::Bottom-->
</TD></TR>
</TABLE>
</CENTER></DIV>
<!--CLASS::Footer-->
HTML

			close Out;
			chmod (0755, $Template_File);
	}# foreach $Theme(@Themes){

	$Msg = qq|&nbsp;<BR>Custom page <b>$Param{Name}</b> has been created.<BR><BR>Edit the language files <B>$Param{Name}\.page\.pm</B> from the Language Manager for each language. Also edit the template file <B>$Param{Name}\.page\.shtml</B> from the template editor for each them. To insert a link in your templates for this page, insert the class <B>&lt;!--CLASS::Page:$Param{Name}--&gt;</B> in your templates.<BR><br><br><A HREF="$Global{AdminURL}?action=TemplateEditor&File=$Param{Name}\.page\.shtml&Theme=$Param{EditorTheme}">&nbsp;<b>Return to the template editor</b></a><br><br>|;

	$Help = &Help_Link("Template Editor");
	&Print_Page($Msg, "Template Editor", $Help);		
}
#==========================================================
sub VisualEditorAdm{
my ($Template);

	$Template = &ReadFile($Global{VisualEditorAdminTemplate});
	$Template =~ s/<!--CLASS::Images-->/$Global{Images}/g;
	$Template =~ s/<!--CLASS::Meta_Title-->/$Global{Meta_Title}/g;
	$Template =~ s/<!--CLASS::Meta_Description-->/$Global{Meta_Description}/g;
	$Template =~ s/<!--CLASS::Meta_Keywords-->/$Global{Meta_Keywords}/g;
	$Template =~ s/<!--FormField-->/$Param{FormField}/g;
	print "Content-type: text/html\n\n";
	print $Template;
}
#==========================================================

1;