=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ForumsManager{
my ($Message) = @_;
my ($Help);

	$Message ||= "";
	$Help = &Help_Link("Forum_Manager");
	&Print_Page(&ForumsManagerForm($Message), "Forum Manager", $Help);
}
#==========================================================
sub ForumsManagerForm{
my ($Message) = @_;
my ($Out, @Forums, $Forum, %Forum, $Link, $Edit, $Delete);
my ($Permissions, $Line);

	$Param{Forum} ||= 0;
	$Out = "";
	
	@Forums = &GetSubForums($Param{Forum});

	foreach $Forum(@Forums) {
			%Forum = &GetForum($Forum);
			$Link = qq!<a href="$Global{AdminURL}action=ForumsManager&Forum=$Forum&Lang=$Param{Lang}">$Forum{Name}</a>!;
			$Edit = qq!<a href="$Global{AdminURL}action=EditForum&Forum=$Forum&Lang=$Param{Lang}">Edit</a>!;
			$Delete = qq!<a href="$Global{AdminURL}action=DeleteForum&Forum=$Forum&Lang=$Param{Lang}">Delete</a>!;
			$Permissions = qq!<a href="$Global{AdminURL}action=ForumPermissions&Forum=$Forum&Lang=$Param{Lang}">Permissions</a>!;
			$Line = &Forum_Manager_Line($Link, $Forum{Active}, $Forum{Accept}, $Forum{Status} , $Forum{Sort}, $Edit, $Delete, $Permissions);
			$Out .= $Line;
	}			

	return &Forum_Manager_Form($Out);
}
#==========================================================
sub Forum_Manager_Line{
my ($Link, $Active, $Accept, $Status, $Sort, $Edit, $Delete, $Permissions) = @_;
my ($Active_Image, $Accept_Image, $Status_Image);
my ($Yes, $No, $Out);

	$Yes = qq!<img border="0" src="$Global{Skin}/tick.gif" align="absmiddle" alt="">!;
	$No = qq!<img border="0" src="$Global{Skin}/untick.gif" align="absmiddle" alt="">!;

	$Active_Image = $No;
	if ($Active){$Active_Image = $Yes;}

	$Accept_Image = $No;
	if ($Accept){$Accept_Image = $Yes;}

	$Status_Image = $No;
	if ($Status){$Status_Image=$Yes;}

$Out=<<HTML;
      <tr >
        <td class="TableCell" width="70%" >&nbsp;$Link</td>
        <td class="TableCell" width="11%"  valign="middle" align="center">$Active_Image</td>
        <td class="TableCell" width="11%" valign="middle" align="center" >$Accept_Image</td>
        <td class="TableCell" width="8%" valign="middle" align="center" >$Status_Image</td>
        <td class="TableCell" width="12%" valign="middle" align="center" >$Sort</td>
        <td class="TableCell" width="10%" valign="middle" align="center" >&nbsp;$Edit&nbsp;</td>
        <td class="TableCell" width="10%" valign="middle" align="center" >&nbsp;$Delete&nbsp;</td>
        <td class="TableCell" width="9%" valign="middle" align="center" >&nbsp;$Permissions&nbsp;</td>
      </tr>
HTML

	return $Out;
}
#==========================================================
sub Forum_Manager_Form{
my ($ForumsList) = @_;
my ($Out, $Guide_Bar, $Forum_Tree_Link);
my ($Update_Forums_Counts, $Edit_All);
	
	 $ForumsList ||= qq!<tr><td colspan="6"><br>&nbsp;No More Sub Forums.<br><br></td></tr>!;

	$Param{Cat_ID} ||= 0;
	$Guide_Bar = &Guide_Bar("ForumsManager");
	$Forum_Tree_Link = qq!<a href="$Global{AdminURL}action=Forum_Tree&Lang=$Param{Lang}">Forum Tree</a>!;
	$Update_Forums_Counts = qq!<a href="$Global{AdminURL}action=Update_Forums_Counts&Lang=$Param{Lang}">Update Forums Count</a>!;
	$Edit_All = qq!<a href="$Global{AdminURL}action=Edit_All_Forum&Forum=$Param{Forum}&Lang=$Param{Lang}">Edit All</A>!;
	
$Out=<<HTML;
<table border="0" width="100%" cellspacing="0" cellpadding="0">
<tr><td width="100%">&nbsp;</td>
<td align="right" nowrap>&nbsp;$Forum_Tree_Link&nbsp;|&nbsp;$Update_Forums_Counts&nbsp;</td>
</tr>
</table>

<table border="0" width="100%" cellspacing="0" cellpadding="2">
<tr><td width="100%">$Guide_Bar</td></tr>
</table>

<table class="TableAttr"  width="100%">
<tr>
  <td width="100%" class="TableHeader">Forum</td>
  <td width="11%" class="TableHeader">Active</td>
  <td width="11%" valign="middle" align="center" class="TableHeader">Accept</td>
  <td width="8%" valign="middle" align="center" class="TableHeader">Open</td>
  <td width="12%" valign="middle" align="center" class="TableHeader">Sort</td>
  <td width="19%" valign="middle" align="center" class="TableHeader" colspan="3">Action</td>
</tr>
  $ForumsList
</table>

<br>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateNewForums">
<input type="hidden" name="Forum" value="$Param{Forum}">
<input type="hidden" name="Lang" value="$Param{Lang}">

<table border="0" width="600" class="TableAttr"  cellspacing="0" cellpadding="5">
	<tr><td  valign="top" align="left" class="TableHeader">Create  New Forums</td></tr>
	<tr><td  valign="top" align="left" width="100%">
		<p align="justify">Please enter one forum name per line and press enter at the end of each line. Forums will be created under the current forum shown by the guide bar. You can create any number of forums.<br>
	</P>
	</td></tr>
	<tr><td  valign="top" align="left">$Guide_Bar</td></tr>

	<tr><td valign="top" align="left">
				<textarea style="width: 550px; height: 150px" name="NewForumsNames"></textarea>
	</td>
	</tr>

	<tr><td valign="top" align="center">
	  <input type="submit" value="Create Forums" style="color: #000080; border-style: ridge"> &nbsp;&nbsp;
	  <input type="reset" value="Clear Form" style="color: #000080; border-style: ridge">
	  </td>
	</tr>
</table>

</form>
<br>
HTML
	return $Out;
}
#==========================================================
sub Guide_Bar{
my ($Action) = @_;
my ($Home, $x, $Last_ID, $Last_Name, $Guide_Bar);
my ($ID_Ref, $Name_Ref, @Name, @ID);

	$Home = qq!<a href=$Global{AdminURL}action=$Action&Lang=$Param{Lang}>Top</a>!;

	if (!$Param{Forum}){$Param{Forum} = 0;}

	($ID_Ref, $Name_Ref) = &GetForumFullname($Param{Forum});
	@ID = @{$ID_Ref};
	@Name = @{$Name_Ref};

	$Last_ID = pop @ID;
	$Last_Name=pop @Name;
	
	$Guide_Bar = $Home . $Language{admin_forum_mgr_separator};

	 for $x(0..$#ID) {
		$Guide_Bar .= qq!<a href="$Global{AdminURL}action=$Action&Forum=$ID[$x]&Lang=$Param{Lang}">$Name[$x]</a>!;
		$Guide_Bar .= $Language{admin_forum_mgr_separator};
	}

	if ($Last_Name) {$Guide_Bar=$Guide_Bar . $Last_Name};

	return $Guide_Bar;
}
#==========================================================
sub CreateNewForums{
my (@Names,  $Name, $Forum, $Query);

	if (!$Param{Forum}) {$Param{Forum} = 0;}

	$Param{NewForumsNames} =~ s/^\s+//;
	$Param{NewForumsNames} =~ s/\s+$//;
	$Param{NewForumsNames} =~ s/\s+$/ /g;

	if (!$Param{NewForumsNames}) {
		&ForumsManager(qq!<p align="center"><b><font size="4" color="red">Error: No forums names</font></b></p>!);
		return;
	}
	
	undef @Names;
	@Names = split(/\n/, $Param{NewForumsNames});

	foreach $Name(sort @Names){
				$Name =~ s/\n//g;
				$Name =~ s/\r//g;
				$Name =~ s/\cM//g;
				$Name=~ s/^\s+//g;
				$Name=~ s/\s+$//g;
				if (!$Name) {next;}

				$Name = $dbh->quote($Name);

				$Query = qq!INSERT INTO Forum_Forums SET
											Forum=NULL,
											Parent=$Param{Forum},
											Name=$Name,
											Description='',

											Sort=0,
											Active=1,
											Accept=1,
											Status=1,

											Posts=0,
											Topics=0,
											LastPost=0,

											SubPosts=0,
											SubTopics=0,

											View=0,
											Browse=0,
											Readx=0,
											Post=1,
											Reply=1,
											Edit=1,
											Deletes=1,
											Announce=3,
											Sticky=3,
											Poll=1,
											Vote=1,
											Attach=1,
											ViewIP=3,

											Icon='',
											Redirect='',

											Template='',
											
											Meta_Title='',
											Meta_Description='',
											Meta_Keywords='',

											Zone1='',
											Zone2='',
											Zone3='',
											Zone4=''
								!;

				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				$Forum = $dbh->{mysql_insertid};
	} # foreach $Name(sort @Names){
	
	&UpdateForumsNumber;

	&ForumsManager(qq!<p align="center"><b><font size="4" color="red">Categories created</font></b></p>!);
}
#==========================================================
sub DeleteForum{
my ($Help);
my (%Forum, @SubForums, $SubForumsCount, $SubForums, $Out);
my ($Forum, $ID_Ref, $Name_Ref, @ID, @Name);

	$Param{Forum} ||= "";
	%Forum = &GetForum($Param{Forum});
	if (!$Param{Forum}) {
			&ForumsManager();
			return;
	}
	
	@SubForums = &GetForumTree($Param{Forum});
	$SubForumsCount = @SubForums;

	
	$SubForums = "";
	foreach $Forum (@SubForums) {
			($ID_Ref, $Name_Ref) = &GetForumFullname($Forum);
			@ID = @{$ID_Ref};
			@Name = @{$Name_Ref};
			$SubForums .= join(">", @Name);
			$SubForums .= "<br>";
	}

$Out=<<HTML;
<br>
<div align="center">
<form method="post" action="$Global{AdminURL}">
  <input type="hidden" name="action" value="ProcessDeleteForum">
  <input type="hidden" name="Forum" value="$Param{Forum}">

<table width="600" border="0" cellspacing="0" cellpadding="4" STYLE="border: 0 outset #F7F7F7" bordercolor="#7FFF81">
		<tr><td colspan="2" align="center"><b><font color="#FF0000" size="4">Delete Forum Confirmation</font></td></tr>
		<tr><td colspan="2"><p align="justify"><b>Please confirm that you want to delete this forum and all its sub forums. Please note, this action can not be undone. All topic, posts, messages and all data associated with this forum will be delete.</b></p>
		</td></tr>
		<tr><td nowrap><b>Forum Name :</b></td><td width="100%">$Forum{Name}</td></tr>
		<tr><td nowrap><b>Forum ID :</b></td><td>$Forum{Forum}</td></tr>
		<tr><td nowrap><b>Forum Topics :</b></td><td>$Forum{Topics}</td></tr>
		<tr><td nowrap><b>Forum Posts:</b></td><td>$Forum{Posts}</td></tr>
		<tr><td nowrap valign="top"><b>Sub Forums:</b></td><td>$SubForums</td></tr>

		<tr><td colspan="2" align="center"><b><font color="#FF0000">Are you sure you still want to delete this forum?</font></td></tr>
		<tr><td align="center" colspan="2">
			<input type="submit" value="Yes Delete This Forum" style="color: #000080; border-style: ridge">
		</td>
		</tr>

</table>
</form>
</div>
HTML

	$Help = &Help_Link("Forum_Manager");
	&Print_Page($Out, "Forum Manager", $Help);
}
#==========================================================
sub ProcessDeleteForum{
my (@Forums, $Forums, $Query, $sth, @Topics, $Temp);
my (%Forum, @Posts, $Posts, $Topics);

	$Param{Forum} ||= "";
	if (!$Param{Forum}) {
			&ForumsManager();
			return;
	}

	@Forums = &GetForumTree($Param{Forum});
	unshift @Forums, $Param{Forum};

	$Forums = join (",", @Forums);

	# get all the forum topics
	$Query = qq!SELECT Topic FROM Forum_Topics WHERE Forum IN ($Forums)!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Topics;
	while(($Temp) = $sth->fetchrow_array) {push @Topics, $Temp;}


	# get all the forum posts
	$Query = qq!SELECT Post FROM Forum_Posts WHERE Forum IN ($Forums)!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Posts;
	while(($Temp) = $sth->fetchrow_array) {push @Posts, $Temp;}

	# delete forum info
	$Query = qq!DELETE From Forum_Forums WHERE Forum IN ($Forums)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	# delete forum topics
	$Query = qq!DELETE From Forum_Topics WHERE Forum IN ($Forums)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	# delete forum posts
	$Query = qq!DELETE From Forum_Posts WHERE Forum IN ($Forums)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	# delete forum posts messages
	$Query = qq!DELETE From Forum_Messages WHERE Forum IN ($Forums)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	# delete upload files and other media info
	if (@Posts) {
			$Posts = join(",", @Posts);
			$Query = qq!DELETE From Forum_Media WHERE Post IN ($Posts)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	# delete the forum marked read topics
	if (@Topics) {
			$Topics = join(",", @Topics);
			$Query = qq!DELETE From Forum_Topic_Read WHERE Topic IN ($Topics)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	%Forum = &GetForum($Param{Forum});
	$Param{Forum} = $Forum{Parent};
	
	&UpdateForumsNumber;
	&ForumsManager();
}
#==========================================================
sub ForumPermissionsMenu{
my ($Pers) = @_;
my (%Groups, $Menu, $Group);

	%Groups = (0=>"Everyone", 1=>"Registered Users", 2=>"Private Groups", 3=>"Moderators", 4=>"Administartors");
	
	$Menu = "";
	foreach $Group (sort keys %Groups) {
			if ($Group == $Pers) {$Sel = "selected";} else{$Sel = "";}
			$Menu .= qq!<option value="$Group" $Sel>$Groups{$Group}</option>!;
	}

	return $Menu;
}
#==========================================================
sub ForumPermissions{
my ($Out, $Help, %Forum);
my ($View, $Browse, $Reads, $Post, $Reply, $Edit, $Deletes, $Announce);
my ($Sticky, $Poll, $Vote, $Attach, $ViewIP, $Bar);

	$Param{Forum} ||= "";
	%Forum = &GetForum($Param{Forum});
	
	$View = &ForumPermissionsMenu($Forum{View});
	$Browse = &ForumPermissionsMenu($Forum{Browse});
	$Reads = &ForumPermissionsMenu($Forum{Readx});
	$Post = &ForumPermissionsMenu($Forum{Post});
	$Reply = &ForumPermissionsMenu($Forum{Reply});
	$Edit = &ForumPermissionsMenu($Forum{Edit});
	$Deletes = &ForumPermissionsMenu($Forum{Deletes});
	$Announce = &ForumPermissionsMenu($Forum{Announce});
	$Sticky = &ForumPermissionsMenu($Forum{Sticky});
	$Poll = &ForumPermissionsMenu($Forum{Poll});
	$Vote = &ForumPermissionsMenu($Forum{Vote});
	$Attach = &ForumPermissionsMenu($Forum{Attach});
	$ViewIP = &ForumPermissionsMenu($Forum{ViewIP});

	$Bar = qq!<a href="$Global{AdminURL}action=ForumsManager">Forums Manager</a> > $Forum{Name} > Permissions!;
#-----------------------------------------------------------------------------------
$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="SaveForumPermissions">
<input type="hidden" name="Forum" value="$Param{Forum}">

<div style="padding: 5px;">$Bar</div>

<table width="100%" class="TableAttr" cellpadding="4">
	<tr><td class="TableCell" nowrap><b>Forum Name :</b></td><td class="TableCell" >$Forum{Name}</td></tr>
	<tr><td class="TableCell" nowrap><b>Forum ID :</b></td><td class="TableCell" >$Forum{Forum}</td></tr>

	<tr><td class="TableCell" nowrap><b>View:</b></td><td class="TableCell" width="100%"><select style="width: 175px;" name="View">$View</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Browse:</b></td><td class="TableCell"><select style="width: 175px;" name="Browse">$Browse</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Read:</b></td><td class="TableCell"><select style="width: 175px;" name="Readx">$Reads</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Start Topic:</b></td><td class="TableCell"><select style="width: 175px;" name="Post">$Post</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Post Reply:</b></td><td class="TableCell"><select style="width: 175px;" name="Reply">$Reply</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Edit:</b></td><td class="TableCell"><select style="width: 175px;" name="Edit">$Edit</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Delete:</b></td><td class="TableCell"><select style="width: 175px;" name="Deletes">$Deletes</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Announcements:</b></td><td class="TableCell"><select style="width: 175px;" name="Announce">$Announce</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Sticky:</b></td><td class="TableCell"><select style="width: 175px;" name="Sticky">$Sticky</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Create Poll:</b></td><td class="TableCell"><select style="width: 175px;" name="Poll">$Poll</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Vote:</b></td><td class="TableCell"><select style="width: 175px;" name="Vote">$Vote</select></td></tr>
	<tr><td class="TableCell" nowrap><b>Upload Files:</b></td><td class="TableCell"><select style="width: 175px;" name="Attach">$Attach</select></td></tr>
	<tr><td class="TableCell" nowrap><b>View IP:</b></td><td class="TableCell" ><select style="width: 175px;" name="ViewIP">$ViewIP</select></td></tr>

  <tr>
	<td align="center" colspan="2" class="TableCell">
		<input type="submit" value="Save Changes"> &nbsp; <input type="reset" value="Reset Form">
	</td>
  </tr>
</table>
</form>
HTML

	$Help = &Help_Link("Forum_Manager");
	&Print_Page($Out, "Forum Manager", $Help);
}
#==========================================================
sub SaveForumPermissions{
my ($Query, %Forum);

	$Param{View} ||= 0;
	$Param{Browse} ||= 0;
	$Param{Readx} ||= 0;
	$Param{Post} ||= 0;
	$Param{Reply} ||= 0;
	$Param{Edit} ||= 0;
	$Param{Deletes} ||= 0;
	$Param{Announce} ||= 0;
	$Param{Sticky} ||= 0;
	$Param{Poll} ||= 0;
	$Param{Vote} ||= 0;
	$Param{Attach} ||= 0;
	$Param{ViewIP} ||= 0;

	$Query = qq!UPDATE Forum_Forums SET 
												View=$Param{View},
												Browse=$Param{Browse},
												Readx=$Param{Readx},
												Post=$Param{Post},
												Reply=$Param{Reply},
												Edit=$Param{Edit},
												Deletes=$Param{Deletes},
												Announce=$Param{Announce},
												Sticky=$Param{Sticky},
												Poll=$Param{Poll},
												Vote=$Param{Vote},
												Attach=$Param{Attach},
												ViewIP=$Param{ViewIP}
									WHERE Forum=$Param{Forum}
								!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	%Forum = &GetForum($Param{Forum});
	$Param{Forum} = $Forum{Parent};

	&ForumsManager();
}
#==========================================================
sub EditForum{
my (%Forum, $Active, $Accept, $Status, $Bar, $Out, $Help);
	
	$Param{Forum} ||= "";
	%Forum = &GetForum($Param{Forum});
	if (!$Param{Forum}) {
			&ForumsManager();
			return;
	}
	
	if ($Forum{Active}) {$Active = "checked";} else {$Active = "";}
	if ($Forum{Accept}) {$Accept = "checked";} else {$Accept = "";}
	
	if ($Forum{Status}){
			$Status = qq!<option value="1" selected>Open</option><option value="0">Closed</option>!;
	}
	else{
			$Status = qq!<option value="1">Open</option><option value="0" selected>Closed</option>!;
	}
	
	$Forum_Name =&Encode_HTML($Forum{Name});

	$Bar = qq!<a href="$Global{AdminURL}action=ForumsManager">Forums Manager</a> > $Forum{Name} > Edit Forum!;
	#-----------------------------------------------------------------------------------
$Out=<<HTML;
<form method="post" action="$Global{AdminURL}">
  <input type="hidden" name="action" value="SaveEditForum">
  <input type="hidden" name="Forum" value="$Param{Forum}">

  <div style="padding: 5px;">$Bar</div>
	 
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="TableAttr">
      <tr><td nowrap class="TableCell"><b>Forum Name :</b></td><td class="TableCell">$Forum{Name}</td></tr>
      <tr><td nowrap class="TableCell"><b>Forum ID :</b></td><td class="TableCell">$Forum{Forum}</td></tr>
      <tr><td nowrap class="TableCell"><b>Parent:</b></td><td class="TableCell"><input type="text" name="Parent" size="15" value="$Forum{Parent}" > Change to move forum</td></tr>
      <tr><td nowrap class="TableCell"><b>Active:</b></td><td class="TableCell"><INPUT TYPE="checkbox" name="Active" value="1" $Active></td></tr>
      <tr><td nowrap class="TableCell"><b>Accept:</b></td><td class="TableCell"><INPUT TYPE="checkbox" name="Accept" value="1" $Accept></td></tr>
      <tr><td nowrap class="TableCell"><b>Status:</b></td><td class="TableCell"><select name="Status">$Status</select></td></tr>
	  <tr><td class="TableCell"><b>Sort Order:</b></td><td class="TableCell"><input type="text" name="Sort" size="15" value="$Forum{Sort}" ></td></tr>
	  <tr><td class="TableCell"><b>Icon File:</b></td><td class="TableCell"><input type="text" name="Icon" size="70" value="$Forum{Icon}" ></td></tr>

	  <tr><td class="TableCell"><b>Name:</b></td>
        <td class="TableCell"><input type="text" name="Name" size="70" value="$Forum_Name"> HTML allowed</td>
      </tr>

      <tr><td valign="top" class="TableCell"><b>Description:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="7" name="Description" cols="70">$Forum{Description}</textarea></td>
      </tr>

      <tr><td nowrap class="TableCell"><b>Meta Title:</b></td>
        <td class="TableCell"><input type="text" name="Meta_Title" size="70" value="$Forum{Meta_Title}"></td>
      </tr>
      <tr><td nowrap valign="top" class="TableCell"><b>Meta Description:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="7" name="Meta_Description" cols="70">$Forum{Meta_Description}</textarea></td>
      </tr>

      <tr><td class="TableCell" nowrap valign="top"><b>Meta Keywords:</b></td>
        <td class="TableCell"><textarea rows="7" name="Meta_Keywords" cols="70">$Forum{Meta_Keywords}</textarea></td>
      </tr>

      <tr><td class="TableCell" nowrap valign="top"><b>Zone1:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="5" name="Zone1" cols="70">$Forum{Zone1}</textarea></td>
      </tr>

      <tr><td class="TableCell" nowrap valign="top"><b>Zone2:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="5" name="Zone2" cols="70">$Forum{Zone2}</textarea></td>
      </tr>

      <tr><td class="TableCell" nowrap valign="top"><b>Zone3:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="5" name="Zone3" cols="70">$Forum{Zone3}</textarea></td>
      </tr>

      <tr><td class="TableCell" nowrap valign="top"><b>Zone4:</b><br>HTML allowed</td>
        <td class="TableCell"><textarea rows="5" name="Zone4" cols="70">$Forum{Zone4}</textarea></td>
      </tr>

	  <tr><td class="TableCell" align="center" colspan="2">
			<input type="submit" value="Save Changes"> &nbsp; <input type="reset" value="Reset Form">
			</td>
      </tr>
    </table>

</form>
HTML

	$Help = &Help_Link("Forum_Manager");
	&Print_Page($Out, "Forum Manager", $Help);
}
#==========================================================
sub SaveEditForum{
my ($Name, $Icon, $Description, $Redirect, $Meta_Title);
my ($Meta_Description, $Meta_Keywords, $Zone1);
my ($Zone2, $Zone3, $Zone4, $Query, %Forum);

	$Name = &Web_Decode($Param{Name});
	$Name =~ s/\n//g;
	$Name =~ s/\r//g;
    $Name =~ s/\cM//g;
	$Name =~ s/^\s+//g;
	$Name =~ s/\s+$//g;
	
	$Param{Active} ||= 0;
	$Param{Accept} ||= 0;
	$Param{Status} ||= 0;
	$Param{Sort} ||= 0;

	$Param{Icon} ||= "";
	$Param{Icon} =~ s/^\s+//;
	$Param{Icon} =~ s/\s+$//;

	$Param{Redirect} ||= "";
	$Param{Redirect} =~ s/^\s+//;
	$Param{Redirect} =~ s/\s+$//;

	$Name = $dbh->quote($Name);
	$Icon = $dbh->quote($Param{Icon});
	$Description = $dbh->quote($Param{Description});
	$Redirect = $dbh->quote($Param{Redirect});

	$Meta_Title = $dbh->quote($Param{Meta_Title});
	$Meta_Description =$dbh->quote( $Param{Meta_Description});
	$Meta_Keywords =$dbh->quote($Param{Meta_Keywords});
	
	$Param{Zone1} ||= "";
	$Param{Zone2} ||= "";
	$Param{Zone3} ||= "";
	$Param{Zone4} ||= "";
	$Zone1 = $dbh->quote($Param{Zone1});
	$Zone2 = $dbh->quote($Param{Zone2});
	$Zone3 = $dbh->quote($Param{Zone3});
	$Zone4 = $dbh->quote($Param{Zone4});

	$Query = qq!UPDATE Forum_Forums SET 
								Name=$Name,
								Description=$Description,
								Active=$Param{Active},
								Accept=$Param{Accept},
								Status=$Param{Status},
								Sort=$Param{Sort},
								Redirect=$Redirect,
								Icon=$Icon,

								Meta_Title=$Meta_Title,
								Meta_Description=$Meta_Description,
								Meta_Keywords=$Meta_Keywords,

								Zone1=$Zone1,
								Zone2=$Zone2,
								Zone3=$Zone3,
								Zone4=$Zone4

								WHERE Forum=$Param{Forum}
							!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	%Forum = &GetForum($Param{Forum});
	$Param{Forum} = $Forum{Parent};

	&ForumsManager();
}
#==========================================================
sub Forum_Tree{
my ($Help, $Out);

	$Out = &ForumsTreeForm(0, "ForumsManager");
	
	$Help = &Help_Link("Forum_Manager");
	&Print_Page($Out, "Forum Manager", $Help);
}
#==========================================================
sub Update_Forums_Counts{
	
	&UpdateForumsCounts;
	&UpdateForumsNumber;
	&ForumsManager();
}
#==========================================================
sub UpdateForumsNumber{
	&UpdateSettings(TotalFroums=>&GetForumsNumber);
}
#==========================================================
1;