=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Mail_Manager{
my($Help);

	$Help=&Help_Link("Mail_Manager");
	&Print_Page(&Mail_Manager_Menu, "Mail Manager", $Help);

}
#==========================================================
sub Mail_Manager_Menu{
my ($Out);

$Out=<<HTML;
<br><br>
<div align="center"><center>
    <table border="0" width="100%" cellspacing="01" cellpadding="3">
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Manage_Letters">Manage Letters</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Manage_Lists">Manage Lists</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Add_New_Subscribers">Add New Subscribers</a></td></tr>
      <tr><td width="100%"><a href="$Global{AdminURL}action=Delete_Subscribers">Delete Subscribers</a></td></tr>
      <tr><td width="100%"><a href="$Global{AdminURL}action=Create_Mail_Lists">Create New Lists</a></td></tr>
      <tr><td width="100%"><a href="$Global{AdminURL}action=Delete_Lists">Delete Lists</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Send_Mass_Email">Send Mass Email</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Update_Lists_Count">Update Lists Counts</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Prepare_Users_Emails">Prepare Registered Users List</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Prepare_Pending_Users_Emails">Prepare Pending Users List</a></td></tr>
	  <tr><td width="100%"><a href="$Global{AdminURL}action=Export_Lists">Export List To Text Files</a></td></tr>
    </table>
</center>
</div>
HTML

	return $Out;
}
#==========================================================
sub Read_Mail_List{
my($List) = @_;
my(%Lists, $Query, $sth);
my($Count);

	undef %Lists;
	if (!$List) {return undef;}

	$List = $dbh->quote($List);
	$Query = qq!SELECT Email FROM Mail WHERE List=$List!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth ->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	while(($Email) = $sth->fetchrow_array) {
					$Lists{$Email} = 1;
	}

	$sth->finish;

	return keys %Lists;

}
#==========================================================
sub Manage_Lists{
my($Help);

	$Help=&Help_Link("Mail_Manager");
	&Print_Page(&Manage_Lists_Form, "Manage Lists", $Help);

}
#==========================================================
sub Manage_Lists_Form{
my($Lists, $Out, %Lists, @Emails, @Temp);
my(@Lists, $List, $Selected, @Delete);

	%Lists = &Get_Mail_Lists;
	@Temp = keys %Lists;
	$Lists = qq!<select  NAME="Lists" size="1" >!;
	
	if (!$Param{Lists}) {$Param{Lists} = $Temp[0];}

	undef @Emails;
	if ($Param{Lists}) {@Emails = &Read_Mail_List($Param{Lists});}

	@Lists = sort  keys %Lists;

	foreach $List (@Lists) {
			$Selected = "";
			if ($List eq $Param{Lists}) {$Selected = "SELECTED";}
			 $Lists .= qq!<OPTION value="$List" $Selected > &nbsp; $List ($Lists{$List}) &nbsp;</OPTION>!;
	}

	$Lists .= qq!</select>!;
	#------------------------------------------------------
	@Emails = sort @Emails;

	if (!$Param{Page}) {$Param{Page} = 1;}
	if (!$Param{Submit}) {$Param{Submit} = "";}

	if ($Param{Submit} eq "Delete Selected") {
			@Delete = split(/\|\|/, $Param{Emails});
			&Demo;
			&Delete_Emails_From_List($Param{Lists}, @Delete);
	}

	$TotalCount = @Emails;
	$LastPage = int ($TotalCount / $Global{Admin_Emails_Per_Page});
	if (($TotalCount % $Global{Admin_Emails_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	if ($Param{Submit} eq ">>") {$CurrentPage++;}
	if ($Param{Submit} eq "<<") {$CurrentPage--;}
	if ($CurrentPage<1) {$CurrentPage = 1;}
	if ($CurrentPage > $LastPage) {$CurrentPage = $LastPage;}
	$Start = ($CurrentPage - 1) * $Global{Admin_Emails_Per_Page};
	if ($Start < 0) {$Start = 0;}
	$End = $Start + $Global{Admin_Emails_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}
	$Param{Page} = $CurrentPage;

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next Page";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "Previous Page";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}
	
	$Emails = qq!<select  NAME="Emails"  MULTIPLE="MULTIPLE" size="20" >!;

	for $x($Start..$End-1){
			$Emails .= qq!<OPTION VALUE="$Emails[$x]">$Emails[$x]</OPTION>!
	}

	$Emails .= qq!</select>!;

	$Start++;

$Out=<<HTML;
  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="90%"  CELLSPACING="1" CELLPADDING="5">
      <TR>
		<FORM METHOD="POST" ACTION="$Global{AdminURL}">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="Manage_Lists">
	  <TD Valign="TOP" align="center">
		Select list: $Lists
		<INPUT TYPE="submit" VALUE="Load" NAME="Submit" STYLE="color: #000080; border-style: ridge">
		</TD>
		</FORM>
	</TR>
    </TABLE>
    </CENTER>
  </DIV>

  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="90%"  CELLSPACING="1" CELLPADDING="5">
      <TR>
		<FORM METHOD="POST" ACTION="$Global{AdminURL}">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="Manage_Lists">
		<INPUT TYPE="HIDDEN" NAME="Lists" VALUE="$Param{Lists}">
		<INPUT TYPE="HIDDEN" NAME="Page" VALUE="$Param{Page}">
	  <TD Valign="TOP" align="center">
           To select more than one email, drag your mouse <BR>or click with the &lt;CTRL&gt; Key pressed.<BR>
		  $Emails <BR>
		  Showing $Start - $End of $TotalCount
		  <INPUT TYPE="submit" VALUE=">>" NAME="Submit" STYLE="color: #000080; border-style: ridge">
		  <INPUT TYPE="submit" VALUE="<<" NAME="Submit" STYLE="color: #000080; border-style: ridge">
		  </TD>
		</TD>
	</TR>
	  </TR>
        <TD nowrap align="center">
			<INPUT TYPE="submit" VALUE="Delete Selected" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
			<INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
			</TD>
		  </FORM>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
HTML

	return $Out;

}
#==========================================================
sub Delete_Emails_From_List{
my($List, @Emails) = @_;
my($Email, $Emails, $Query);

	$List = $dbh->quote($List);
	foreach $Email (@Emails) {
				$Email =~ s/\n//g;
				$Email =~ s/\s+$//g;
				$Email =~ s/^\s+//g;
				if (!$Email) {next;}
				$Email = $dbh->quote($Email);
				$Emails .= "$Email, ";
	}

	$Emails =~ s/\,\s*$//;

	if ($Emails) {
				$Query = qq!DELETE FROM Mail WHERE Email IN ($Emails) AND List = $List!;
				$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

}
#==========================================================
sub Mail_Lists_Form{
my(%Lists) = @_;
my ($Out, @Lists, $List, $Selected);

	$Out = qq!<select  NAME="Lists"  MULTIPLE="MULTIPLE" size="6" >!;

	@Lists = sort  keys %Lists;
	$Counter=0;

	foreach $List (@Lists) {
			$Selected = "";
			if ($Counter == 0) {$Selected="SELECTED";}
			$Counter++;
			 $Out .= qq!<OPTION value="$List" $Selected > &nbsp; $List ($Lists{$List}) &nbsp;</OPTION>!;
	}

	$Out .= qq!</select>!;

	return $Out;
}
#==========================================================
sub Update_Lists_Count{

	&Update_Mail_Lists_Counts;
	$Out = &Msgs("Lists Updated", "The mailing lists counts updated according to the number of email address in each list.", 1);
	&Print_Page($Out);

}
#==========================================================
sub Update_Mail_Lists_Counts{
my($Query, $sth);
my($Mail, $Count);

	$Query = qq!SELECT List, COUNT(Email) FROM Mail GROUP BY List!;

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	while (($List, $Count) = $sth->fetchrow_array) {
					$Lists{$List} = $Count;
					$Query = qq!UPDATE Mail_Lists SET Count=$Count WHERE List='$List'!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	
	$sth->finish;
}
#==========================================================
sub Save_New_Subscribers{
my (@Lists, @Emails, $List, $Email, $Query);

	@Lists = split(/\|\|/, $Param{Lists});
	@Emails = split(/\n/, $Param{New_Email_Addresses});

	foreach $List (@Lists) {
		$List = $dbh->quote($List);
		foreach $Email (@Emails) {
			$Email =~ s/\n//g;
			$Email =~ s/\s+$//g;
			$Email =~ s/^\s+//g;
			if (!$Email) {next;}
			$Email = $dbh->quote($Email);

			if ($Email) {
					$Query = qq!DELETE FROM Mail WHERE Email = $Email AND List = $List!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}

			$Query = qq!INSERT INTO Mail VALUES ($Email, $List)!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
		}
	}

	$Out = &Msgs("Subscribers Added", "The new subscribers has been added to all selected mailing lists.", 2);
	&Print_Page($Out);
}
#==========================================================
sub Add_New_Subscribers{
my($Help);

	$Help = &Help_Link("Mail_Manager");

	&Print_Page(&Add_New_Subscribers_Form, "Add New Subscribers", $Help);

}
#==========================================================
sub Add_New_Subscribers_Form{
my ($Lists, $Out, %Lists);

	%Lists = &Get_Mail_Lists;
	$Lists = &Mail_Lists_Form(%Lists);

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Global{AdminURL}">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="Save_New_Subscribers">
  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="90%"  CELLSPACING="1" CELLPADDING="5">
      <TR><TD  Valign="TOP">
		Select the mailing lists to add subscribers. To select more than one list, drag your mouse or click with the &lt;CTRL&gt; Key pressed. 
          <BR><BR>
		  $Lists
		</TD>
	</TR>
      <TR><TD  Valign="TOP">
		Enter email addresses you want to add. Please enter one email address per line and press
          &quot;Enter&quot; at the end of each line.<BR><BR>

          <TEXTAREA ROWS="8" NAME="New_Email_Addresses" COLS="30"></TEXTAREA></TD>
		</TD>
	</TR>
	  </TR>
        <TD nowrap align="center">
			<INPUT TYPE="submit" VALUE="Submit" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
			<INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
				</TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>

HTML
	return $Out;
}
#==========================================================
sub Delete_Subscribers{
my($Help);

	$Help=&Help_Link("Mail_Manager");
	&Print_Page(&Delete_Subscribers_Form, "Delete Subscribers", $Help);

}
#==========================================================
sub Delete_Subscribers_Form{
my ($Lists, $Out, %Lists);

	%Lists = &Get_Mail_Lists;
	$Lists = &Mail_Lists_Form(%Lists);

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Global{AdminURL}">
<INPUT TYPE="hidden" NAME="action" VALUE="Do_Delete_Subscribers">
  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="90%"  CELLSPACING="1" CELLPADDING="5">
      <TR><TD  Valign="TOP">
		Select the mailing lists to delete subscribers. To select more than one list, drag your mouse or click with the &lt;CTRL&gt; Key pressed. 
          <BR><BR>
		  $Lists
		</TD>
	</TR>
      <TR><TD  Valign="TOP">
		Enter email addresses you want to delete. Please enter one email address per line and press
          &quot;Enter&quot; at the end of each line.<BR><BR>

          <TEXTAREA ROWS="8" NAME="New_Email_Addresses" COLS="30"></TEXTAREA></TD>
		</TD>
	</TR>
	  </TR>
        <TD nowrap align="center">
			<INPUT TYPE="submit" VALUE="Submit" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
			<INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
				</TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>

HTML
	return $Out;
}
#==========================================================
sub Do_Delete_Subscribers{
my (@Lists, @Emails, $List, $Email, $Query);

	@Lists = split(/\|\|/, $Param{Lists});
	@Emails = split(/\n/, $Param{New_Email_Addresses});

	foreach $List (@Lists) {
		$List = $dbh->quote($List);
		foreach $Email (@Emails) {
			$Email =~ s/\n//g;
			$Email =~ s/\s+$//g;
			$Email =~ s/^\s+//g;
			if (!$Email) {next;}
			$Email = $dbh->quote($Email);
			
			if ($Email) {
					$Query = qq!DELETE FROM Mail WHERE Email = $Email AND List = $List!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
		}
	}

	$Out=&Msgs("Subscribers Deleted", "The required emails has been removed from all selected lists.", 2);
	&Print_Page($Out);

}
#==========================================================
sub Create_Mail_Lists{
my($Help);

	$Help = &Help_Link("Mail_Manager");
	&Print_Page(&Create_Mail_Lists_Form, "Create New Mailing Lists", $Help);
}
#==========================================================
sub Create_Mail_Lists_Form{
my $Out;

$Out=<<HTML;
<form method="POST" action="$Global{AdminURL}">
<input type="hidden" name="action" value="Create_New_Lists">

  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" CELLSPACING="1" CELLPADDING="5">
      <TR>
        <TD Valign="TOP">
		Please enter here the name of the new mailing lists you want to create. <BR>
		Please use only letters and numbers in list names no strange characters.
		<BR><BR>
		</TD>
      </TR>
      <TR>
        <TD Valign="TOP">
		List Name: <input type="text" name="List_Filename1" size="30" >
		</TD>
      </TR>
      <TR>
        <TD Valign="TOP">
		List Name: <input type="text" name="List_Filename2" size="30" >
		</TD>
      </TR>
      <TR>
        <TD Valign="TOP">
		List Name: <input type="text" name="List_Filename3" size="30" >
		</TD>
      </TR>
      <TR>
        <TD Valign="TOP">
		List Name: <input type="text" name="List_Filename4" size="30" >
		</TD>
      </TR>
      <TR>
        <TD Valign="TOP">
		List Name: <input type="text" name="List_Filename5" size="30" >
		</TD>
      </TR>
      <TR>
        <TD WIDTH="100%" COLSPAN="2">
          <p align="center"><input type="submit" value="Create Lists" STYLE="color: #000080; border-style: ridge">
		  <input type="reset" value="Reset Form"  STYLE="color: #000080; border-style: ridge">&nbsp;
			  </td>
      </tr>
    </table>
    </center>
  </div>
</form>

HTML
	return $Out;
}
#==========================================================
sub Create_New_Lists{
my ($Listname, $x, %data, $Out);
my(%Lists, $Query, $sth);

	%Lists = &Get_Mail_Lists;

	for $x(1..5) {
			$Listname = "";
			$Name = "List_Filename".$x;
			if ($Param{$Name}) {
				$Listname = $Param{$Name};
				$Listname =~ s/([^a-zA-Z0-9_\.\-\@])//g;
			}

			if ($Listname && !$Lists{$Listname}) {
						$Listname = $dbh->quote($Listname);
						$Query = qq!INSERT INTO Mail_Lists VALUES ($Listname, 0)!;
						$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}	
	}

	$Out = &Msgs("New Lists Created", "The required new mailing lists has been created and prepared for use.", 2);
	&Print_Page($Out);

}
#==========================================================
sub Get_Mail_Lists{
my(%Lists, $Query, $sth);
my($List, $Count);

	undef %Lists;

	$Query = qq!SELECT * FROM Mail_Lists!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth ->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	while(($List, $Count) = $sth->fetchrow_array) {
					$Lists{$List} = $Count;
	}

	$sth->finish;

	return %Lists;
}
#==========================================================
sub Delete_Lists{
my($Help);

	$Help = &Help_Link("Mail_Manager");

	&Print_Page(&Delete_Lists_Form, "Delete Mailing Lists", $Help);
}
#==========================================================
sub Delete_Lists_Form{
my ($Lists, $Out, %Lists);

	%Lists = &Get_Mail_Lists;
	$Lists = &Mail_Lists_Form(%Lists);

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Global{AdminURL}">
<INPUT TYPE="hidden" NAME="action" VALUE="Do_Delete_Lists">
  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="1" CELLPADDING="5">
      <TR><TD WIDTH="100%" Valign="TOP">
		Select the mailing lists to delete. To Select more than one list, drag your mouse or click with the &lt;CTRL&gt; Key pressed.
          <BR><BR>
        </TD>
      </TR>
      <TR><TD WIDTH="100%" align="center"> $Lists</TD>
      </TR>
      <TR>
        <TD nowrap align="center">
			<INPUT TYPE="submit" VALUE="Submit" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
			<INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
				</TD>
      </TR>
    </TABLE>
    </CENTER>
  </DIV>
</FORM>

HTML
	return $Out;
}
#==========================================================
sub Do_Delete_Lists{
my (@Lists, @Emails, $List, $Query, $Out);

	@Lists = split(/\|\|/, $Param{Lists});

	foreach $List (@Lists) {
			$List = $dbh->quote($List);
			$Query = qq!DELETE FROM Mail WHERE  List = $List!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

			$Query = qq!DELETE FROM Mail_Lists WHERE  List = $List!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	$Out = &Msgs("Lists Deleted", "The required lists has been removed from the system.", 2);
	&Print_Page($Out);
}
#==========================================================
sub Get_Letters_Menu{
my($ID) = @_;
my($Letters, @Lines, $Line);
my($IDs, $Sub, $Msg);

	$Letters = qq!<SELECT NAME="ID" size=1>!;

	if (!(-e $Global{MailLettersFile})) {
			open (FILE, ">$Global{MailLettersFile}")
				or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			close (FILE);
	}

	open (FILE, "$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	@Lines = <FILE>;
	close (FILE);

	if (!$ID) {$ID = "";}

	foreach $Line (@Lines) {
				($IDs, $Sub, $Msg) = split(/\~\=\=\=\~/, $Line);
				$Temp = "";
				if ($IDs == $ID) {$Temp = "SELECTED";}
				$Letters .= qq!<OPTION VALUE="$IDs" $Temp>$Sub</OPTION>!;
	}

	$Letters .= qq!</SELECT>!;

	return $Letters;

}
#==========================================================
sub Send_Mass_Email{
my($Help);

	$Help = &Help_Link("Mail_Manager");
	&Print_Page(&Send_Mass_Email_Form, "Send Mass Email", $Help);

}
#==========================================================
sub Send_Mass_Email_Form{
my ($Lists, $Out, %Lists, $Subject);
my($Letters, @Lines, $Line);
my($ID, $Sub, $Msg);

	%Lists = &Get_Mail_Lists;
	$Lists = &Mail_Lists_Form(%Lists);

	$Letters = &Get_Letters_Menu;
	$Subject = &Encode_HTML($Subject);

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Global{AdminURL}" TARGET="_BLANK">
<INPUT TYPE="hidden" NAME="action" VALUE="Do_Send_Mass_Email">
  <DIV align="center">
    <CENTER>
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="1" CELLPADDING="5">
      <TR>
        <TD WIDTH="100%" Valign="TOP">
		<TABLE WIDTH=100%>
		<TR><TD  WIDTH="30%" Valign="TOP">
			Please select the letter you want to send.
		  </TD>
        <TD  WIDTH="70%" Valign="TOP">
		  $Letters
		  </TD>
		</TR>
		</TABLE>
		</TD>
		</TR>
	  
		<TR>
        <TD WIDTH="100%"  Valign="TOP">
		<TABLE WIDTH=100%>
		<TR>
        <TD  WIDTH="30%" Valign="TOP">
		<P align="JUSTIFY">
			Select the lists you want to send the selected letter. To Select more than one list, drag your mouse or click with the &lt;CTRL&gt; Key pressed. 
        </TD>
		<TD WIDTH="70%" Valign="TOP">
		  $Lists
        </TD>
      </TR>
		</TD>
		</TR>
		</TABLE>

  <TR>
    <TD WIDTH="100%" Valign="TOP">
	<TABLE WIDTH=100%>
	<TR>
        <TD  WIDTH="30%" Valign="TOP">
		<INPUT TYPE="checkbox" NAME="Only_Send_To_These_Email_Addresses" VALUE="YES">
		<B>Send to these emails only.</B><BR>
		<P align="JUSTIFY">
		Please enter one email address per line and press &quot;Enter&quot; at the end of each line.<BR>
		  </TD>
        <TD  WIDTH="70" Valign="TOP">
          <TEXTAREA ROWS="7" NAME="Only_These_Email_Addresses" COLS="40"  ></TEXTAREA>
		  </TD>
		</TR>
	</TABLE>
	</TD></TR>

	  <TR>
        <TD WIDTH="100%"   Valign="TOP">
				<INPUT TYPE="checkbox" NAME="Send_As_HTML" value="YES" CHECKED>
				<b>Send letter as HTML.</b>
		  </TD>
		</TR>

	  <TR>
        <TD nowrap align="center" COLSPAN="2" >
		<INPUT TYPE="submit" VALUE="Send Letter" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
			  </TD>
      </TR>
    </table>
    </center>
  </div>
</form>

HTML
	return $Out;
}
#==========================================================
sub Do_Send_Mass_Email{
my ($Subject, $Message, $Sent, $Skipped);
my ($Old, @Emails, $Out, $List, $Total, @Lists);
my ($Lists, $TO, $time, $Msg, $Start_Time);
	
	print "Content-type: text/html\n\n";
	print "<B>Sending bulk email</B><BR>";
	print "This process may take a long time. Please wait...<BR>";

	($Subject, $Message) = &Get_Mail_Letter($Param{ID});
	
	print "<B>Sending letter: </B><br><B>Subject: </B>$Subject <br><B>Message: </B>$Message";	
	print "<BR>----------------------------------------------------------------------<BR>";

	$Start_Time = time;

	$Old = $Global{Email_Format};
	if ($Param{Send_As_HTML}) {
		$Global{Email_Format} = 1;
	}
	else{
		$Global{Email_Format} = 0;
	}
	#------------------------------------------------------
	$Sent = 0;
	$Skipped = 0;
	if ($Param{Only_Send_To_These_Email_Addresses}) {
			@Emails = split(/\n/, $Param{Only_These_Email_Addresses});
			$Total = @Emails;
			print "<B>Total emails to send: </B>$Total<BR>";
			#&Email($From, $TO, $Subject,   $Message);
			foreach $TO (@Emails) {
					$TO =~ s/\cM//;
					$Msg = qq!...<FONT COLOR="blue">OK</FONT>!;
					if (! &Check_Email_Address($TO)) {
							$Msg = qq!...<FONT COLOR="RED">Skipped</FONT>!;
							$Skipped++;
					}
					else{
							$Sent++;
							&Email($Global{Webmaster_Email}, $TO, $Subject, $Message);
					}

					print "$TO $Msg<BR>";
			}
	}
	else{#----------------------------------------------
			@Lists = split(/\|\|/, $Param{Lists});
			foreach $List (@Lists) {
					@Emails = &Read_Mail_List($List);
					$Total = @Emails;
					print "<BR><B>Sending List: </B> $List<BR>";
					print "<B>Total emails to send in this list: </B>$Total<BR>";
					foreach $TO (@Emails) {
							$Msg = qq!...<FONT COLOR="Blue">OK</FONT>!;
							if (! &Check_Email_Address($TO)) {
									$Msg = qq!...<FONT COLOR="RED">Skipped</FONT>!;
									$Skipped++;
							}
					else{
							$Sent++;
							&Email($Global{Webmaster_Email}, $TO, $Subject, $Message);
					}
							print "$TO $Msg<BR>";
					}
			}
	}
	#------------------------------------------------------
	$Global{Email_Format} = $Old;
	print "----------------------------------------------------------------------";
	print "<BR><B>Done...</B><br>";
	print "<B>Total Emails Sent: </B>$Sent <BR>";
	print "<B>Total Emails Skipped: </B>$Skipped <BR>";

	$Time = sprintf("%5.3f", (time - $Start_Time)/60);
	print "<B>Time consumed: </B>$Time Minutes<BR>";
	print qq!<P align="center"><A HREF="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></B></A></P>!;
}
#==========================================================
sub Get_Mail_Letter{
my($Required_ID) = @_;
my($Message, $Subject, $ID, $IDs, $Sub, $Msg);
my($Line, @Lines);

	if (!(-e $Global{MailLettersFile})) {return ("", "");}

	open (FILE, "$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	@Lines = <FILE>;
	close (FILE);

	$Message = "";
	$Subject = "";
	$ID = "";

	foreach $Line (@Lines) {
				($IDs, $Sub, $Msg) = split(/\~\=\=\=\~/, $Line);
				if ($IDs == $Required_ID) {
							$Message = $Msg;
							$Subject = $Sub;
							$ID = $IDs;
							last;
				}
	}

	return ($Subject, $Message);

}
#==========================================================
sub Delete_Letter{
my($Message, $Subject, $ID, $IDs, $Sub, $Msg);
my($Line, @Lines);
my($Help);

	open (FILE, "$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	@Lines = <FILE>;
	close (FILE);

	if (!$Param{ID}) {$Param{ID} = "";}

	if (!&Lock($Global{MailLettersFile})) {&Exit("Cannot Lock database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);}
	open (FILE, ">$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	foreach $Line (@Lines) {
				$Line =~ s/\n$//g;
				($ID, $Sub, $Msg) = split(/\~\=\=\=\~/, $Line);
				if ($ID != $Param{ID}) {
						 print FILE "$Line\n";
				}
	}

	close (FILE);
	&Unlock($Global{MailLettersFile});

	&Print_Page(&Edit_Letters_Form("", ""), "Manage Mailing Letters", $Help);
}
#==========================================================
sub Save_Letter{
my ($dir, $Key, %data);
my($Help);

	$Help = &Help_Link("Mail_Manager");
	
	if (!$Param{ID}) {
			$Param{ID} = &Time(time);
	}

	$Param{Subject} =~ s/\cM//g;
	$Param{Subject} =~ s/\n//g;
	$Param{Message} =~ s/\cM//g;
	$Param{Message} =~ s/\n//g;

	if (!(-e $Global{MailLettersFile})) {
			open (FILE, ">$Global{MailLettersFile}")
				or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			close (FILE);
	}

	open (FILE, "$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	@Lines = <FILE>;
	close (FILE);

	if (!&Lock($Global{MailLettersFile})) {&Exit("Cannot Lock database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);}
	open (FILE, ">$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	foreach $Line (@Lines) {
				$Line =~ s/\n$//g;
				($ID, $Sub, $Msg) = split(/\~\=\=\=\~/, $Line);
				if ($ID != $Param{ID}) {
						 print FILE "$Line\n";
				}
	}
	
	$ID = &Time(time);

	print FILE "$ID~===~$Param{Subject}~===~$Param{Message}\n";
	close FILE;
	&Unlock($Global{MailLettersFile});

	&Print_Page(&Edit_Letters_Form("", ""), "Manage Mailing Letters", $Help);
}
#==========================================================
sub Edit_Letter{
my($Message, $Subject, $ID, $IDs, $Sub, $Msg);
my($Line, @Lines);
my($Help);

	$Help = &Help_Link("Mail_Manager");

	if (!(-e $Global{MailLettersFile})) {
			open (FILE, ">$Global{MailLettersFile}")
				or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			close (FILE);
	}

	open (FILE, "$Global{MailLettersFile}")
			or &Exit("Cannot open database file $Global{MailLettersFile}: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	@Lines = <FILE>;
	close (FILE);

	$Message = "";
	$Subject = "";
	$ID = "";

	foreach $Line (@Lines) {
				($IDs, $Sub, $Msg) = split(/\~\=\=\=\~/, $Line);
				if ($IDs == $Param{ID}) {
							$Message = $Msg;
							$Subject = $Sub;
							$ID = $IDs;
							last;
				}
	}

	&Print_Page(&Edit_Letters_Form($ID, $Subject, $Message), "Manage Mailing Letters", $Help);

}
#==========================================================
sub Manage_Letters{
my($Help);

	$Help = &Help_Link("Mail_Manager");
	&Print_Page(&Edit_Letters_Form("", "", ""), "Manage Mailing Letters", $Help);

}
#==========================================================
sub Edit_Letters_Form{
my ($ID, $Subject, $Message)=@_;
my ($Out, $time, $Sub, $Msg, $Letters);

	if (!$ID) {$ID = "";}
	$Letters = &Get_Letters_Menu($ID);	

	$Subject = &Encode_HTML($Subject);
	$Message = &Encode_HTML($Message);

$Out=<<HTML;
<FORM METHOD="POST" ACTION="$Global{AdminURL}" NAME="Mailing_Letters">
<DIV align="center">
<CENTER>
<INPUT TYPE="hidden" NAME="action" VALUE="Edit Letter">
    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="1" CELLPADDING="8">
      <TR><TD WIDTH="100%" Valign="TOP"><B>Current Letters: </B>
				$Letters
				&nbsp;
			  <A HREF="#" onclick="document.Mailing_Letters.action.value='Edit_Letter'; document.Mailing_Letters.submit(); return false;"><b>View/Edit</b></a>
				&nbsp;&nbsp;
			  <A HREF="#" onclick="document.Mailing_Letters.action.value='Delete_Letter'; document.Mailing_Letters.submit(); return false;"><b>Delete</b></a>
		</TD>
      </TR>
	</TABLE>
	</CENTER>
 </DIV>
</FORM>

<DIV align="center">
<CENTER>
<FORM METHOD="POST" ACTION="$Global{AdminURL}" NAME="Edit_Mailing_Letters">
<INPUT TYPE="hidden" NAME="action" VALUE="Save_Letter">
<INPUT TYPE="hidden" NAME="ID" VALUE="$ID">

    <TABLE BORDER="0" WIDTH="100%" CELLSPACING="1" CELLPADDING="8">
      <TR><TD WIDTH="100%" align="center" COLSPAN="2">
          <FONT COLOR="#000000"><B>Edit Letter</B></FONT>
        </TD>
      </TR>

      <TR>
        <TD nowrap><B>Subject: </B></TD>
		<TD><INPUT TYPE="text" NAME="Subject" size="65" VALUE="$Subject" ></TD>
      </TR>

      <TR>
        <TD Valign="TOP"><B>Message:</B></TD>
		<TD><TEXTAREA ROWS="12" NAME="Message" COLS="70" >$Message</TEXTAREA></TD>
      </TR>

	  <TR>
        <TD nowrap align="center" COLSPAN="2" >
		<INPUT TYPE="submit" VALUE="Save Letter" NAME="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;&nbsp;
          <INPUT TYPE="reset" VALUE="Reset" NAME="Reset" STYLE="color: #000080; border-style: ridge">&nbsp; 
			  </TD>
      </TR>
	</TABLE>
	</FORM>
	</CENTER>
 </DIV>

HTML
	return $Out;
}
#==========================================================
sub Prepare_Users_Emails{
my($List, %Emails, $Query, $sth, $Email);

	$List = $Global{Users_Email_List};

	%Lists = &Get_Mail_Lists;

	$List = $dbh->quote($List);
	if ($List && !$Lists{$List}) {
				$Query = qq!INSERT INTO Mail_Lists VALUES ($List, 0)!;
				$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	$Query = qq!DELETE FROM Mail Where List=$List!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!SELECT Email FROM Users!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Email) = $sth->fetchrow_array) {
			$Emails{$Email} = 1;
	}
	$sth->finish;
	
	foreach $Email (keys %Emails) {
			$Email = $dbh->quote($Email);
			$Query = qq!DELETE FROM Mail WHERE Email = $Email AND List = $List!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Query = qq!INSERT INTO Mail VALUES ($Email, $List)!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	&Update_Mail_Lists_Counts;
	$List = keys %Emails;

	$Out = &Msgs("Users List Created", "All users emails addresses has been exported to the <B>$Global{Users_Email_List}</B> mailing list .", 2);
	&Print_Page($Out);

}
#==========================================================
sub Prepare_Pending_Users_Emails{
my($List, %Emails, $Query, $sth, $Email);

	$List = $Global{Pending_Users_Email_List};

	%Lists = &Get_Mail_Lists;

	$List = $dbh->quote($List);
	if ($List && !$Lists{$List}) {
				$Query = qq!INSERT INTO Mail_Lists VALUES ($List, 0)!;
				$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	$Query = qq!DELETE FROM Mail Where List=$List!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!SELECT Email FROM Pending_Users!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Email) = $sth->fetchrow_array) {
			$Emails{$Email} = 1;
	}
	$sth->finish;
	
	foreach $Email (keys %Emails) {
			$Email = $dbh->quote($Email);
			$Query = qq!DELETE FROM Mail WHERE Email = $Email AND List = $List!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Query = qq!INSERT INTO Mail VALUES ($Email, $List)!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	&Update_Mail_Lists_Counts;
	$List = keys %Emails;

	$Out = &Msgs("Pending Users List Created", "All pending users emails addresses has been exported to the <B>$Global{Pending_Users_Email_List}</B> mailing list .", 2);
	&Print_Page($Out);

}
#==========================================================
sub Export_Lists{
my (%Lists, $List, @Emails, $File, $Emails, $Temp, $All, $Total, $Out);
	
	%Lists = &Get_Mail_Lists;
	$All = ""; $Total =0;

	foreach $List (keys %Lists) {
			@Emails = &Read_Mail_List($List);
			$File = "$Global{Mail_Lists_Dir}/$List\.txt";
			open(FILE,">$File")  || &Exit("Can 't create file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			$Emails = join ("\n", @Emails);
			print FILE $Emails; 
			close(FILE);
			$Temp .= "$List\.txt: ". $Lists{$List} ." Emails<br>";
			$All .= $Emails;
			$Total += @Emails;
	}

	$File = "$Global{Mail_Lists_Dir}/All_Lists\.txt";
	open(FILE,">$File")  || &Exit("Can 't create file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
	print FILE $All; 
	close(FILE);
	$Temp .= "All_Lists\.txt: ". $Total ." Emails<br>";

	$Out = qq!<p align="center"><b>Lists Exported</b></p>All system mailing lists exported to ASCII text files under the directory: <br>$Global{Mail_Lists_Dir}<br><br>The following lists exported.<br><br>$Temp<br><p align="center"><b><a href="$Global{AdminURL}action=Mail_Manager">Return to Mail Manager</a></b></p>!;
	&Print_Page($Out);
}
#==========================================================
1;
