=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub MarkForum{
my (@Topics, $Topics, $User, $Query, $Temp, $Topic);
	
	$Param{Forum} +=0;
	$Param{User_ID} ||= "";

	&Check_Account_Login;

	# mark all topics as read for this user
	if ($Param{User_ID}) {
			@Topics = &GetForumsMarkTopics($Param{Forum});
			$Topics = join (",", @Topics);

			$User = $dbh->quote($Param{User_ID});

			if ($Topics) {
					$Query = qq!DELETE From Forum_Topic_Read WHERE Topic IN($Topics) AND User=$User!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					
					$Temp = "";
					foreach $Topic (@Topics) {	
							$Temp .= "($Topic, $User),";
					}
					$Temp =~ s/\,$//g;
					$Query = qq!INSERT INTO Forum_Topic_Read VALUES $Temp!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
			
	}
	#------------------------------------------------------
	&Forums;
}
#==========================================================
sub UnMarkForum{
my (@Topics, $Topics, $User, $Query);

	$Param{Forum} +=0;
	$Param{User_ID} ||= "";

	&Check_Account_Login;

	# mark all topics as not read for this user
	if ($Param{User_ID}) {
			@Topics = &GetForumsMarkTopics($Param{Forum});
			$Topics = join (",", @Topics);

			$User = $dbh->quote($Param{User_ID});

			if ($Topics) {
					$Query = qq!DELETE From Forum_Topic_Read WHERE Topic IN($Topics) AND User=$User!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
	}
	#------------------------------------------------------
	&Forums;
}
#==========================================================
sub GetForumsMarkTopics{
my ($Forum) = @_;
my ($StartTime, $Filter, $Query, @Topics, $sth, $ID);

	$StartTime = &Time - int($Global{UnreadTopicsTime} * 86400);
	
	if ($Forum > 0) {
			$Filter = "AND Forum=$Forum";
	}
	else {
			$Filter = "";
	}
	$Query = qq!SELECT Topic FROM Forum_Topics WHERE Updated > $StartTime $Filter!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Topics;
	while(($ID) = $sth->fetchrow_array) {push @Topics, $ID;}
	$sth->finish;
	return @Topics;
}
#==========================================================
sub MarkTopicUnread {
my ($Topics, $User, $Query);

	$Param{Topic} += 0;
	$Param{Forum} += 0;
	$Param{User_ID} ||= "";

	&Check_Account_Login;

	if ($Param{Topic}) {
			$User = $dbh->quote($Param{User_ID});
			$Query = qq!DELETE From Forum_Topic_Read WHERE Topic=$Param{Topic} AND User=$User!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	&Forums;
}
#==========================================================
1;