=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
use ImageSize;
#==========================================================
sub Get_Media_Show{
my($Mode, @Files) = @_;
my($Image, $Images);

	#-----------------------------------------------------
	if ($Mode == 0) {#above each other
				$Images = qq!<TABLE BORDER="0" CELLSPACING="3" CELLPADDING="3">!;
				foreach $File (@Files) {
						#style="filter:progid:DXImageTransform.Microsoft.Pixelate(MaxSquare=15,Duration=10)"
						$Image = qq!<IMG SRC="$Global{'HTML_URL'}/upload/$File" BORDER="1" style="filter:revealTrans(duration=2,transition=21)">!;
						$Images .= qq!<TR><TD align="center">$Image</TD></TR>!;
				}
				$Images .= qq!</TABLE>!;
	}
	#-----------------------------------------------------
	elsif ($Mode == 1) {#besides each other
				$Images = qq!<TABLE BORDER="0" CELLSPACING="3" CELLPADDING="3"><TR>!;
				foreach $File (@Files) {
						$Image = qq!<IMG SRC="$Global{'HTML_URL'}/upload/$File" BORDER="1" style="filter:revealTrans(duration=2,transition=21)">!;
						$Images .= qq!<TD align="center">$Image</TD>!;
				}
				$Images .= qq!</TR></TABLE>!;
	}
	#-----------------------------------------------------
	elsif ($Mode == 2) {#slide show
				$Images = &Get_Slide_Show_Controller(@Files);
	}
	#-----------------------------------------------------
	elsif ($Mode == 3) {#menu selections
				$Images = &Get_Slide_Show_Code(@Files);
	}
	#-----------------------------------------------------

	return $Images;
}
#==========================================================
sub Get_Slide_Show_Code{
my(@Files) = @_;
my($Code, $Array);
my($Width, $Height);
	
	($Width, $Height) = &Find_Max_Image_Size(@Files);

	if ($Width > $Global{'Slide_Show_Max_Width'}) {
				$Width = $Global{'Slide_Show_Max_Width'};
	}

	if ($Height > $Global{'Slide_Show_Max_Height'}) {
				$Height = $Global{'Slide_Show_Max_Height'};
	}

	$Array = "";
	for $x(0..$#Files) {
			$Array .= "Pic[". $x . "] = \'$Global{'HTML_URL'}/upload/$Files[$x]\';\n";
	}

$Code=<<HTML;
<IMG SRC="" BODER="01" NAME="Slide_Show" WIDTH="$Width" HEIGHT="$Height">

<script language="JavaScript">
<!--
var delay = 800;
var Pic = new Array();
$Array

var t;
var j = 0;
var p = Pic.length;
var preLoad = new Array();

for (i = 0; i < p; i++){
	preLoad[i] = new Image();
	preLoad[i].src = Pic[i];
}

function Run_Mewsoft_Slide_Show(){
	document.Slide_Show.src = preLoad[j].src
	j = j + 1;
	if (j > (p-1)) j=0;
	t = setTimeout('Run_Mewsoft_Slide_Show()', delay);
}

//-->
</script>

<script language="JavaScript">
<!--
Run_Mewsoft_Slide_Show();
//-->
</script>
HTML

	return $Code;
}
#==========================================================
sub Get_Slide_Show_Controller{
my(@Files) = @_;
my($Array, $Code, $Show);
my($Width, $Height);
	
	($Width, $Height) = &Find_Max_Image_Size(@Files);

	if ($Width > $Global{'Slide_Show_Max_Width'}) {
				$Width = $Global{'Slide_Show_Max_Width'};
	}

	if ($Height > $Global{'Slide_Show_Max_Height'}) {
				$Height = $Global{'Slide_Show_Max_Height'};
	}

	$Array = "";
	for $x(0..$#Files) {
			$Array .= "Pic[". $x . "] = \'$Global{'HTML_URL'}/upload/$Files[$x]\';\n";
	}

$Code=<<HTML;
<script language="JavaScript">
<!-- 
//Copyright 2002 Mewsoft, http://www.mewsoft.com
var Pic = new Array();
$Array

var rotate_delay = 800;
var j=0;
var running = 0;
var start_stop = 0;

var p = Pic.length;
var preLoad = new Array();

for (i = 0; i < p; i++){
	preLoad[i] = new Image();
	preLoad[i].src = Pic[i];
}

function next() {
	j = j + 1;
	if (j > (p-1)) {j=0;}
	change_slide();
}

function previous() {
	j = j - 1;
	if (j < 0 ) {j = (p-1);}
	change_slide();
}

function first() {
	j = 0;
	change_slide();
}

function last() {
	j = (p-1);
	change_slide();
}

function show_start_stop() {
	if (!start_stop) {
			start_stop =1;
			document.Start_Stop_Show.src = "<!--CLASS::Images-->/media_stop.gif";
			rotate();
	}
	else
	{
			start_stop = 0; 
			window.clearInterval(running);
			document.Start_Stop_Show.src = "<!--CLASS::Images-->/media_start.gif";
	}
}

function change_slide() {
		document.Slide_Show_Image.src = preLoad[j].src;
}

function rotate() {
		document.Slide_Show_Image.src = preLoad[j].src;
		j = j + 1;
		if (j > (p-1)) {j=0;}
		running = window.setTimeout("rotate()", rotate_delay);
}
//-->
</script>

<script language="JavaScript">
<!-- 
show_start_stop();
//window.onload=show_start_stop();
//if (document.all||document.getElementById)
//show_start_stop();
//else
//window.onload=show_start_stop();

//-->
</script>

HTML

	$Show = $Global{'Slide_Show_Control_Form'};
	$Show =~ s/<!--Width-->/$Width/;
	$Show =~ s/<!--Height-->/$Height/;
	$Show .= "\n$Code\n";
	$Show =~ s/<!--CLASS::Images-->/$Global{'Images'}/g;
	$Show = &Translate($Show);
	
	return $Show;
}
#==========================================================
sub Find_Max_Image_Size{
my(@Files) = @_;
my($W, $H, $Width, $Height, $srcID, $File);

	$Width = 0; $Height = 0;
	foreach $File(@Files) {
			($W, $H, $srcID) = imgsize("$Global{'Upload_Dir'}/$File");
			if ($W > $Width) {$Width = $W;}
			if ($H > $Height) {$Height = $H;}
	}
	return ($Width, $Height);
}
#==========================================================
1;