=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Members {
my ($Template, $Temp);

	#&LoadLangFile($Global{LanguageContactUsFile});
	$Template =&TranslateFile($Global{MembersTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/;
	$Template =~ s/<!--Language-->/$Global{Language}/;
	
	$Plugins{Bar_Action} = $Language{members_menu_bar};
	$Plugins{Menu_Bar} = "";
	#------------------------------------------------------
	$Param{Sorted} += 0;
	$Param{Dir} += 0;
	$Param{Sort} ||= "Joined";
	if ($Param{Sorted} == 1) {$Param{Dir} = !$Param{Dir};	}
	if ($Param{Dir} == 1) {$Dir = "ASC";}	else{$Dir = "DESC";}
	$Param{Filter} ||= "";
	#------------------------------------------------------
	if ($Param{Sort} eq "Author") {$Sort = "Users.User_ID";}
	elsif ($Param{Sort} eq "Joined") {$Sort = "Users.Start_Date";}
	elsif ($Param{Sort} eq "Posts")  {$Sort = "Forum_Users_Info.Posts";}
	elsif ($Param{Sort} eq "Location")  {$Sort = "Forum_Users_Info.Location";}
	else{$Sort = "Users.User_ID";}
	#------------------------------------------------------
	$Filter = "";
	if ($Param{Filter}) {
			$Filter = qq!WHERE User_ID REGEXP \'^[$Param{Filter}]\'!;
	}
	#$Query = qq!SELECT Users.User_ID FROM Users, Forum_Users_Info WHERE Users.User_ID=Forum_Users_Info.User_ID $Filter ORDER BY  $Sort $Dir!;
	@Users = @{$dbh->selectcol_arrayref(qq!SELECT User_ID FROM Users $Filter ORDER BY $Sort $Dir!)};
	#------------------------------------------------------
	@Forms = (&Translate($Global{MembersListForm}), &Translate($Global{MembersListForm1}));
	#------------------------------------------------------
	$TotalUsers = &Get_Total_Accounts_Count;
	$TotalCount = @Users;
	#------------------------------------------------------
	$Param{Page} ||= 1;
	$Param{NewPage} += 0;
	if ($Param{NewPage} > 0) {$Param{Page} = $Param{NewPage};}
	$Global{Members_Per_Page} ||= 10;
	#------------------------------------------------------
	#------------------------------------------------------
	# Pagination start
	#------------------------------------------------------
	use Pagination;
	my $paginate = Mewsoft::Pagination->new(
												entries_per_page    => $Global{Members_Per_Page},
												total_entries       => $TotalCount, 
												current_page        => $Param{Page},
												pages_per_set       => $Global{Pages_Per_Set},
												mode => $Global{Pages_Mode}, #modes are 'slide', 'fixed', default is 'slide'
											);

	$Param{Page} = $paginate->current_page;
	$LastPage = $paginate->last_page;
	$NextPage = $paginate->next_page;
	$PrevPage = $paginate->previous_page;
	$Start = $paginate->first;
	$End = $paginate->last;
	$CurrentPage = $Param{Page};
	#------------------------------------------------------
	$NextPageLink = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$NextPage!;
	$PrevPageLink = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$PrevPage!;
	$FirstPageLink = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=1!;
	$LastPageLink = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$LastPage!;
	#------------------------------------------------------
	# Next Page, Last page
	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$Template =~ s/<!--NextPage-->/$Language{paginate_next_page_current}/g;
			$Template =~ s/<!--LastPage-->/$Language{paginate_last_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_next_page};
			$Temp =~ s/<!--Link-->/$NextPageLink/g;
			$Template =~ s/<!--NextPage-->/$Temp/g;
			if ($paginate->last_page_in_set) {
				$Temp = ""; # Last page in set
			}
			else {
				$Temp = $Language{paginate_last_page};
				$Temp =~ s/<!--Page-->/$LastPage/g; # Last page number
				$Temp =~ s/<!--Link-->/$LastPageLink/g;
			}

			$Template =~ s/<!--LastPage-->/$Temp/g;
	}
	#----------------------------------------------
	# Previous Page, First Page
	if ($CurrentPage == 1) {
			$Template =~ s/<!--PrevPage-->/$Language{paginate_prev_page_current}/g;
			$Template =~ s/<!--FirstPage-->/$Language{paginate_first_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_prev_page};
			$Temp =~ s/<!--Link-->/$PrevPageLink/g;
			$Template =~ s/<!--PrevPage-->/$Temp/g;
			
			if ($paginate->first_page_in_set) {
					$Temp = ""; # First page in set
			}
			else {
				$Temp = $Language{paginate_first_page};
				$Temp =~ s/<!--Link-->/$FirstPageLink/g;
			}
			$Template =~ s/<!--FirstPage-->/$Temp/g;
	}
	#------------------------------------------------------
	# Pagination Pages set
	$Pages = ""; 
	foreach $Page (@{$paginate->pages_in_set()}) {
			if ($Page == $CurrentPage) {
					$Link = $Language{paginate_current_page};
			}
			else{
					$Link = $Language{paginate_page};
			}
			$Temp = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Page!;
			$Link =~ s/<!--Link-->/$Temp/;
			$Link =~ s/<!--Page-->/$Page/;
			$Pages .= $Link;
			if ($Page != $LastPage) {
					$Pages .= $Language{paginate_separtor};
			}
	}

	$Pages =~ s/$Language{paginate_separtor}$//g;
	$Template =~ s/<!--Pages-->/$Pages/g;
	#------------------------------------------------------
	$Temp = $Language{paginate_showing_page};
	$Temp =~ s/<!--CurrentPage-->/$CurrentPage/g;
	$Temp =~ s/<!--TotalPages-->/$LastPage/g;
	$Template =~ s/<!--ShowingPage-->/$Temp/g;
	#------------------------------------------------------
	# Pagination end
	#------------------------------------------------------
	#------------------------------------------------------
	$Plugins{ResultsFound} = $Language{members_results_found};
	$Plugins{ResultsFound} =~ s/<!--Found-->/$TotalCount/g;
	$Plugins{ResultsFound} =~ s/<!--FoundStart-->/$Start/g;
	$Plugins{ResultsFound} =~ s/<!--FoundEnd-->/$End/g;
	#------------------------------------------------------
	# Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS AP
	$LastVisitTimeClass = ""; $LastVisitTimeFormat = "";	# <!--LastVisitTime:(MON-MD-YY HH:MM AP)-->
	if ($Forms[0] =~ m/(<!--)(LastVisit)(:\()([^\)]+)(\)-->)/){
				$LastVisitTimeClass = $1 . $2 . $3. $4. $5;
				$LastVisitTimeFormat =  $4;
	}
	#------------------------------------------------------
	$JoinedTimeClass = ""; $JoinedTimeFormat = "";	# <!--JoinedTime:(MON-MD-YY HH:MM AP)-->
	if ($Forms[0] =~ m/(<!--)(JoinedTime)(:\()([^\)]+)(\)-->)/){
				$JoinedTimeClass = $1 . $2 . $3. $4. $5;
				$JoinedTimeFormat =  $4;
	}
	#------------------------------------------------------
	$Output = "";
	for $Counter($Start-1..$End-1){
					if ($Counter < 0) {next;}
					%User = &GetForumUser($Users[$Counter]);
					$Form = $Forms[int($Counter % 2)];

					$Form =~ s/<!--Author-->/$User{User_ID}/g;
					
					$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$User{User_ID}!;
					$Form =~ s/<!--AuthorLink-->/$Temp/g;

					$Form =~ s/<!--Posts-->/$User{Posts}/g;
					$Form =~ s/<!--Location-->/$User{Location}/g;
					$Form =~ s/<!--Interests-->/$User{Interests}/g;
					$Form =~ s/<!--Occupation-->/$User{Occupation}/g;

					if ($User{Avatar}) {
							$Temp = $Language{members_avatar_link};
							$Link = qq!$Global{Avatars_URL}/$User{Avatar}!;
							$Temp =~ s/<!--AvatarLink-->/$Link/g;
							$Form =~ s/<!--Avatar-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--Avatar-->//g;
					}
					#------------------------------------------------------
					$Temp = &ParseDate($JoinedTimeFormat, $User{Start_Date});
					$Form =~ s/\Q$JoinedTimeClass\E/$Temp/g;
					#------------------------------------------------------
					$Temp = &ParseDate($LastVisitTimeFormat, $User{LastVisit});
					$Form =~ s/\Q$LastVisitTimeClass\E/$Temp/g;
					#------------------------------------------------------
					if ($User{WebURL}) {
							#$User{Website} = 'http://ramy:mypasswd@www.mewsoft.com:1234/cgi-bin/auction/auction.cgi?action=help#fragment';
							#http://www.w3.org/TR/2007/WD-powder-grouping-20070709/
							#http://joe:mypasswd@www.example.com:1234/example1/example2?query=help#fragment
							#\   /  \          / \             / \  /\                / \        / \      /
							# ---    ----------   -------------   --  ----------------   --------   ------ 
							#  |         |              |         |           |              |        |
							#scheme  user info         host      port        path          query   fragment
				
							$User{Website} =~ m,(([^:/?#]+):)?(//(([^/?#@]+)@)?([^:/?#@]*)(:([0-9]+))?)?([^?#]*)(\?([^#]*))?(#(.*))?,;
							$scheme =$2; $authority =$3; $userInfo =$5; $host =$6; $port =$8; $path =$9; $query= $11; $fragment =$13;
							
							#// Another Parse URL (Credits goes to Steave, http://blog.stevenlevithan.com/archives/parseuri)
							#strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
							#loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
							#["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"]
							
							$Temp = $Language{member_website};
							$Temp =~ s/<!--Link-->/$User{Website}/g;
							$Temp =~ s/<!--Name-->/$host/g;
					}
					else {
							$Temp = "";
					}
					$Form =~ s/<!--Website-->/$Temp/g;
					#------------------------------------------------------
					$Form =~ s/<!--Email-->/$User{Email}/g;
					$Form =~ s/<!--FName-->/$User{FName}/g;
					$Form =~ s/<!--LName-->/$User{LName}/g;
					$Form =~ s/<!--Company-->/$User{Company}/g;
					$Form =~ s/<!--Job_Title-->/$User{Job_Title}/g;
					$Form =~ s/<!--Street-->/$User{Street}/g;
					$Form =~ s/<!--City-->/$User{City}/g;
					$Form =~ s/<!--State-->/$User{State}/g;
					$Form =~ s/<!--Zip-->/$User{Zip}/g;
					$Form =~ s/<!--Country-->/$User{Country}/g;
					$Form =~ s/<!--Phone-->/$User{Phone}/g;
					$Form =~ s/<!--Mobile-->/$User{Mobile}/g;
					$Form =~ s/<!--Fax-->/$User{Fax}/g;
					#------------------------------------------------------
					if ($Global{Auctionawy_Plugin}) {
							($Rating, $Stars) = &Get_User_Feedback_Stars($User{User_ID});
							if (!$Rating) {
									$Temp = $Language{feedback_rating_zero};
							}
							else{
									$Temp = $Language{feedback_rating};
							}
							$Temp =~ s/<!--FeedbackRating-->/$Rating/g;
							$Temp =~ s/<!--FeedbackStars-->/$Stars/g;
							$Form =~ s/<!--Feedback-->/$Temp/g;

							$Temp1 = &GetUserOpenAuctionsCount($User{User_ID});
							if ($Temp1 > 0) {
								$Temp = $Language{member_auctions};
							}
							else {
								$Temp = $Language{member_auctions_zero};
							}
							$Link = qq!$Global{AuctionMainURL}?action=Browse&Search=SellerAuctions&Status=&SellerID=$User{User_ID}!;
							$Temp =~ s/<!--MemberAuctionsLink-->/$Link/g;
							$Temp =~ s/<!--Auctions-->/$Temp1/g;
							$Form =~ s/<!--MemberAuctions-->/$Temp/g;
							$Form =~ s/<!--Auctions-->/$Temp1/g;

							$Temp = qq!$Global{AuctionMainURL}?action=ListUserFeedback&User_ID_Feedback=$User{User_ID}!;
							$Form =~ s/<!--MemberFeedbackLink-->/$Temp/g;
					}
					#------------------------------------------------------
					if ($Global{Classifiedawy_Plugin}) {
							$Temp1 = &GetUserOpenAdsCount($User{User_ID});
							if ($Temp1 > 0) {
									$Temp = $Language{member_ads};
							}
							else {
									$Temp = $Language{member_ads_zero};
							}
							$Link = qq!$Global{ClassifiedMainURL}?action=Browse&Search=SellerAds&Status=&SellerID=$User{User_ID}!;
							$Temp =~ s/<!--MemberAdsLink-->/$Link/g;
							$Temp =~ s/<!--Ads-->/$Temp1/g;
							$Form =~ s/<!--MemberAds-->/$Temp/g;
							$Form =~ s/<!--Ads-->/$Temp1/g;
					}
					#------------------------------------------------------
					$Temp = $Language{about_me_link};
					$Link = qq!$Global{ProgURL}me/$User{User_ID}!;
					$Temp =~ s/<!--AboutMeLink-->/$Link/g;
					$Temp =~ s/<!--Author-->/$User{User_ID}/g;
					$Form =~ s/<!--AboutMe-->/$Temp/g;
					#------------------------------------------------------
					if ($User{Posts} > 0) {
						$Temp = $Language{member_posts};
					}
					else {
						$Temp = $Language{member_posts_zero};
					}
					$Link = qq!$Global{ProgURL}action=ForumSmartSearch&Authors=$User{User_ID}&Dir=0&Sort=Updated&Mode=1&Period=0&TitlesOnly=1&&Terms=!;
					$Temp =~ s/<!--MemberPostsLink-->/$Link/g;
					$Temp =~ s/<!--Posts-->/$User{Posts}/g;
					$Form =~ s/<!--MemberPosts-->/$Temp/g;
					#----------------------------------------------
					$Output .= $Form;
	}
	#------------------------------------------------------
	$Template =~ s/<!--MembersList-->/$Output/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Plugins{SortAuthor} = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=1&Sort=Author&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}!;
	$Plugins{SortJoined} = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=1&Sort=Joined&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}!;
	$Plugins{SortPosts} = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=1&Sort=Posts&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}!;
	$Plugins{SortLocation} = qq!$Global{ProgURL}action=Members&Filter=$Param{Filter}&Sorted=1&Sort=Location&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}!;

	$Plugins{SortAuthorImg} = "";
	$Plugins{SortJoinedImg} = "";
	$Plugins{SortPostsImg} = "";
	$Plugins{SortLocationImg} = "";

	if ($Param{Dir} == 1){
			$Temp = $Language{sort_up_image};
	}
	else{
			$Temp = $Language{sort_dn_image};
	}

	if ($Param{Sort} eq "Author") {$Temp =~ s/<!--Link-->/$Plugins{SortAuthor}/; $Plugins{SortAuthorImg} = $Temp;}
	elsif ($Param{Sort} eq "Joined") {$Temp =~ s/<!--Link-->/$Plugins{SortJoined}/; $Plugins{SortJoinedImg} = $Temp;}
	elsif ($Param{Sort} eq "Posts") {$Temp =~ s/<!--Link-->/$Plugins{SortPosts}/; $Plugins{SortPostsImg} = $Temp;}
	elsif ($Param{Sort} eq "Location") {$Temp =~ s/<!--Link-->/$Plugins{SortLocation}/; $Plugins{SortLocationImg} = $Temp;}
	#------------------------------------------------------
	$Template =~ s/<!--Sorted-->/0/g;
	$Template =~ s/<!--Sort-->/$Param{Sort}/g;
	$Template =~ s/<!--Dir-->/$Param{Dir}/g;
	$Template =~ s/<!--Page-->/$Param{Page}/g;
	$Template =~ s/<!--PageSize-->/$Param{PageSize}/g;
	#------------------------------------------------------
	$Template =~ s/<!--TotalUsers-->/$TotalUsers/g;
	#------------------------------------------------------
	@Filters = split /\|/, $Language{members_filters};
	$Filters = "";
	foreach $Filter (@Filters) {
			($K, $V) = split /\:/, $Filter;
			$Temp = qq!$Global{ProgURL}action=Members&Filter=$V&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=1!;
			$Link = $Language{members_filters_form};
			$Link =~ s/<!--Link-->/$Temp/g;
			$Link =~ s/<!--Name-->/$K/g;
			$Filters .= $Link;
	}
	
	$Template =~ s/<!--MembersFilters-->/$Filters/g;
	#------------------------------------------------------
	$Plugins{Body}="";
    &Display($Template, 1);
}
#==========================================================



#==========================================================
1;
