=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ModeratorsManager{
my ($Message) = @_;
my ($Help);

	$Message ||= "";
	$Help = &Help_Link("Moderators_Manager");
	&Print_Page(&ModeratorsManagerForm($Message), "Moderators Manager", $Help);
}
#==========================================================
sub ModeratorsManagerForm{
my ($Message) = @_;
my ($Out, @Forums, $ForumsMenu, $Forum, %Forum, @Mods);
my ($Link, $Mods, $User, %User, $Temp, $Box, $Line);

	$Param{Forum} ||= 0;

	@Forums = &GetSubForums($Param{Forum});
	
	$ForumsMenu = "";
	$Out = "";

	foreach $Forum(@Forums) {
			%Forum = &GetForum($Forum);
			@Mods = &GetForumModerators($Forum);

			$ForumsMenu .= qq!<option value="$Forum">$Forum{Name}</option>!;

			$Link = qq!<a href="$Global{AdminURL}action=ModeratorsManager&Forum=$Forum&Lang=$Param{Lang}"><b>$Forum{Name}</b></a>!;
			
			$Mods = qq!<table border="0" width="100%"  cellspacing="0" cellpadding="02">!;

			$Counter = 0;
			foreach $User (@Mods) {
						if ($Counter == 0) { $Mods .="<tr>";}
						
						%User = &Get_User($User);
						$Temp = qq!<a href="$Global{AdminURL}action=Admin_View_Account&Account=$User" target="_blank">$User</a>!;
						$Box = qq!<input type="checkbox" name="DeleteMod\:$Forum\:$User" value="DeleteMod\:$Forum\:$User" style="background-color:#FFFFFF;border-style: solid; border-width: 0; padding: 0">!;
						$Break = "";
						$Counter++;
						
						$Mods .= qq!<td width="25%" nowrap>$Box $Temp &nbsp;</td>!;
						
						if ($Counter == 4) {
								$Counter = 0;
								 $Mods .= "</tr>";
						}
			}

			# close the unfinished table row
			if ($Counter> 0 && $Counter < 4) {
						for $Temp ($Counter..4-1) {
							 $Mods .= "<td>&nbsp;</td>";
						}
						 $Mods .="</tr>";
			}
			# close the modetarors table
			$Mods .= qq!</table>!;

			$Line = &Moderators_Manager_Line($Link, $Mods);

			$Out .= $Line;
	}

	return &Moderators_Manager_Form($Message, $Out, $ForumsMenu);
}
#==========================================================
sub Moderators_Manager_Line{
my ($Forum, $Moderators) = @_;
my ($Out);

$Out=<<HTML;
<tr>
<td class="TableCell" width="40%" nowrap valign="top">&nbsp;$Forum</td>
<td class="TableCell" width="60%" valign="top" align="left">$Moderators</td>
</tr>
HTML

	return $Out;
}
#==========================================================
sub Moderators_Manager_Form{
my ($Message, $ForumsList, $ForumsMenu) = @_;
my ($Out, $Guide_Bar);
	
	 $ForumsList ||= qq!<tr><td colspan="2"><br>&nbsp;No More Sub Forums.<br><br></td></tr>!;

	$Param{Cat_ID} ||= 0;
	$Guide_Bar = &Guide_Bar("ModeratorsManager");
	
$Out=<<HTML;
$Message
<div style="padding: 5px;">$Guide_Bar</div>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="DeleteForumsModerators">
<input type="hidden" name="Forum" value="$Param{Forum}">
<input type="hidden" name="Lang" value="$Param{Lang}">

<table class="TableAttr" width="100%"  cellspacing="0" cellpadding="2">
<tr>
  <td nowrap width="40%" bgcolor="#004800" align="center" class="TableHeader">Forum</td>
  <td width="60%" valign="middle" align="center" class="TableHeader">Moderators</td>
</tr>
  $ForumsList
</table>
<br>

<!--------------------------------Delete mods----------------------------->
<table width="100%" class="TableAttr" cellspacing="0" cellpadding="3">
	<tr><td width="100%" class="TableHeader">Delete Moderators</td></tr>
	<tr><td valign="top" align="left" class="TableCell">
			<input type="checkbox" name="DeleteSelected" value="1" style="border: 0px;" checked>
			Delete selected moderators
	</td>
	</tr>
	<tr><td valign="top" align="left" class="TableCell">
			<input type="checkbox" name="SubForums" value="1" style="border: 0px;">
			Delete moderators from the sub forums of the selected forums also
	</td>
	</tr>
	<tr><td valign="top" align="center">
	  <input type="submit" value="Delete Moderators"> &nbsp;&nbsp; <input type="reset" value="Reset Form">
	  </td>
	</tr>

	<tr><td valign="top" align="left"  width="100%">
			<table  width="100%" cellspacing="04" cellpadding="0"><tr><td width="100%" bgcolor="#215dc6"><img src="$Global{Skin}/dot.gif" height="1" border="0" width="100%"></td></tr></table>
	</td>
	</tr>

	<tr><td valign="top" align="left" >
			Delete these moderators from all forums and sub forums. Separate by space or comma<br>
			<input type="text" name="ModeratorsNames" value="" size="60">
	</td>
	</tr>

	<tr><td valign="top" align="center" class="TableCell">
	  <input type="submit" value="Delete Moderators" style="color: #000080; border-style: ridge"> &nbsp;&nbsp;
	  <input type="reset" value="Clear Form" style="color: #000080; border-style: ridge">
	  </td>
	</tr>
</table>

</form>
<br>

<!-------------------------------Add Mods-------------------------------->
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="AddForumsModerators">
<input type="hidden" name="Forum" value="$Param{Forum}">
<input type="hidden" name="Lang" value="$Param{Lang}">

<table class="TableAttr" width="100%" cellpadding="2">
	<tr><td width="100%" class="TableHeader">Add New Moderators</td></tr>

	<tr><td class="TableCell" valign="top" align="left">
		<p align="justify">Please enter one User ID per line and press enter at the end of each line. <br>
		You can add any number of moderators.<br>
	</P>
	</td></tr>
	<tr><td class="TableCell" valign="top" align="left">
			<font color="#000000" face="tahoma,arial, helvetica" size="2">$Guide_Bar</font>
	</td></tr>

	<tr><td valign="top" align="left" class="TableCell">
				<textarea name="NewModeratorsNames" style="width: 550px; height: 200px;"></textarea>
	</td>
	</tr>

	<tr><td valign="top" align="left" class="TableCell">
				Select forums to add moderators:<br>
				<select name="Forums" Multiple style="width: 400px; height: 100px;border: 1px solid blue;">$ForumsMenu</select>
	</td>
	</tr>

	<tr><td valign="top" align="left" class="TableCell">
				<input type="checkbox" name="SubForums" value="1" style="border: 0;">
		Add moderators to all sub forums of the selected forums also
	</td>
	</tr>
	
	<tr><td valign="top" align="left" class="TableCell">
				<input type="checkbox" name="VerifyUsers" value="1" checked style="border: 0;">
		Verify the existance of moderators users accounts
	</td>
	</tr>

	<tr><td valign="top" align="center" class="TableCell">
	  <input type="submit" value="Add Moderators" style="color: #000080; border-style: ridge"> &nbsp;&nbsp;
	  <input type="reset" value="Clear Form" style="color: #000080; border-style: ridge">
	  </td>
	</tr>
</table>
</form>
<br>
HTML
	return $Out;
}
#==========================================================
sub Guide_Bar{
my ($Action) = @_;
my ($Home, $x, $Last_ID, $Last_Name, $Guide_Bar);
my ($ID_Ref, $Name_Ref, @Name, @ID);

	$Home = qq!<a href=$Global{AdminURL}action=$Action&Lang=$Param{Lang}>Top</a>!;

	if (!$Param{Forum}){$Param{Forum} = 0;}

	($ID_Ref, $Name_Ref) = &GetForumFullname($Param{Forum});
	@ID = @{$ID_Ref};
	@Name = @{$Name_Ref};

	$Last_ID = pop @ID;
	$Last_Name=pop @Name;
	
	$Guide_Bar = $Home . $Language{admin_forum_mgr_separator};

	 for $x(0..$#ID) {
		$Guide_Bar .= qq!<a href="$Global{AdminURL}action=$Action&Forum=$ID[$x]&Lang=$Param{Lang}">$Name[$x]</a>!;
		$Guide_Bar .= $Language{admin_forum_mgr_separator};
	}

	if ($Last_Name) {$Guide_Bar=$Guide_Bar . $Last_Name};

	return $Guide_Bar;
}
#==========================================================
sub AddForumsModerators{
my (@Names, %Users, @Users, @Forums, @AllForums);
my ($Name, $Forum, @SubForums, $Users, $Query, $sth, $Temp);

	if (!$Param{Forum}) {$Param{Forum} = 0;}

	$Param{NewModeratorsNames} =~ s/^\s+//;
	$Param{NewModeratorsNames} =~ s/\s+$//;
	$Param{NewModeratorsNames} =~ s/\s+$/ /g;

	undef @Names;
	@Names = split(/\n|\s|\,/, $Param{NewModeratorsNames});

	undef %Users;

	foreach $Name(sort @Names){
				$Name =~ s/\n//g;
				$Name =~ s/\r//g;
				$Name =~ s/\cM//g;
				$Name=~ s/^\s+//g;
				$Name=~ s/\s+$//g;
				if (!$Name) {next;}
				$Users{$Name} = 1;
	}
	@Users = keys %Users;

	if (!@Users) {
		&ModeratorsManager(qq!<p align="center"><b><font size="4" color="red">Error: No forums moderators entered</font></b></p>!);
		return;
	}
	#------------------------------------------------------
	# make sure the users accounts are created
	if ($Param{VerifyUsers}) {
			$Users = "";
			foreach $User (@Users) {
					$Users .= $dbh->quote($User);
					$Query = qq!SELECT User_ID FROM Users WHERE User_ID IN($Users)!;
					$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					undef @Users;
					while(($Temp) = $sth->fetchrow_array) {push @Users, $Temp;}
					$sth->finish;
			}
	}
	#------------------------------------------------------
	undef @Forums;
	@Forums = split(/\|\|/, $Param{Forums});
	if (!@Forums) {
		&ModeratorsManager(qq!<p align="center"><b><font size="4" color="red">Error: No forums selected</font></b></p>!);
		return;
	}

	undef @AllForums;
	push @AllForums, @Forums;

	#------------------------------------------------------
	# delete sub forums of all forums also
	if ($Param{SubForums}) {
		foreach $Forum (@Forums) {
				@SubForums = &GetForumTree($Forum);
				push @AllForums, @SubForums;
		}
	}
	#------------------------------------------------------
	foreach $Forum (@AllForums) {
			&AddForumModerators($Forum, @Users);
	}
	#------------------------------------------------------
	&ModeratorsManager(qq!<p align="center"><b><font size="4" color="red">New Moderators Add</font></b></p>!);
}
#==========================================================
sub AddForumModerators{
my ($Forum, @Users) = @_;
my ($User, $List, $Query);

	if (!$Forum || !@Users) {return;}
	#------------------------------------------------------
	# delete already existing forum moderators first
	foreach $User (@Users) {
			$List .= $dbh->quote($User). ",";
	}
	$List =~ s/\,\s*$//g;
	$Query = qq!DELETE FROM Forum_Moderators WHERE Forum=$Forum AND User IN ($List)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# now add the required forum moderators
	$List = "";
	foreach $User (@Users) {
			$User = $dbh->quote($User);
			$List .= qq!($User, $Forum),!;
	}
	$List =~ s/\,\s*$//g;

	$Query = qq!INSERT INTO Forum_Moderators VALUES $List!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DeleteForumsModerators{
my ($Key, $Value, $Temp, $Forum, $User, @SubForums);
my (@Names, %Users, @Users);

	while (($Key, $Value) = each %Param) {
			if ($Key !~ /^DeleteMod\:/) {next;}
			($Temp, $Forum, $User) = split(/\:/, $Key);
			@SubForums = &GetForumTree($Forum);
			push @SubForums, $Forum;
			&DeleteForumsModerator($User, @SubForums);
	}
	
	$Param{ModeratorsNames} ||= "";
	$Param{ModeratorsNames} =~ s/^\s+//;
	$Param{ModeratorsNames} =~ s/\s+$//;
	$Param{ModeratorsNames} =~ s/\s+$/ /g;

	undef @Names;
	@Names = split(/\n|\s+|\,/, $Param{ModeratorsNames});

	undef %Users;

	foreach $Name(sort @Names){
				$Name =~ s/\n//g;
				$Name =~ s/\r//g;
				$Name =~ s/\cM//g;
				$Name=~ s/^\s+//g;
				$Name=~ s/\s+$//g;
				if (!$Name) {next;}
				$Users{$Name} = 1;
	}
	@Users = keys %Users;

	if (@Users) {
			&DeleteAllForumsModerator(@Users);
	}

	&ModeratorsManager(qq!<p align="center"><b><font size="4" color="red">Moderators Deleted</font></b></p>!);
}
#==========================================================
sub DeleteForumsModerator{
my ($User, @Forums) = @_;
my ($Forums, $Query);

	if (!$User || !@Forums) {return;}
	$Forums = join (",", @Forums);
	$User = $dbh->quote($User);
	$Query = qq!DELETE FROM Forum_Moderators WHERE Forum IN ($Forums) AND User=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DeleteAllForumsModerator{
my (@Users) = @_;
my ($Users, $User, $Query);

	if (!@Users) {return;}
	$Users = "";
	foreach $User (@Users) {
		$Users .= $dbh->quote($User) . ",";
	}
	$Users =~ s/\,\s*$//g;
	$Query = qq!DELETE FROM Forum_Moderators WHERE User IN ($Users)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================

1;