=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub PostingOptions{
my ($Message) = @_;
my ($Help, $Out);

	$Help = &Help_Link("Posting_Options");
	$Out = &PostingOptionsForm($Message);
	&Print_Page($Out, "Posting Options", $Help);
}
#==========================================================
sub SavePostingOptions{
my (%Config, $Key);

	undef %Config;

	$Config{Post_Treat_HTML} = $Param{Post_Treat_HTML};
	
	$Config{Max_Title_Length} = $Param{Max_Title_Length};
	$Config{Post_Max_Len} = $Param{Post_Max_Len};

	$Config{Posting_Max_Limit} = $Param{Posting_Max_Limit};
	$Config{Posting_Max_Limit_Time} = $Param{Posting_Max_Limit_Time};
	
	$Config{Slide_Show_Max_Width} = $Param{Slide_Show_Max_Width};
	$Config{Slide_Show_Max_Height} = $Param{Slide_Show_Max_Height};
	
	$Config{Items_Per_Page} = $Param{Items_Per_Page};
		
	$Config{Banner_Gragh_Width} = $Param{Banner_Gragh_Width};

	$Config{Allow_File_Upload} = $Param{Allow_File_Upload};
	$Config{Max_Upload_Files} = $Param{Max_Upload_Files};
	$Config{Max_Upload_File_Size} = $Param{Max_Upload_File_Size};
	$Config{Max_Upload_Size} = $Param{Max_Upload_Size};
	$Config{Upload_Any_File} = $Param{Upload_Any_File};
	
	$Param{Files_Ext_Allowed} =~ s/\cM|\n|\r//g;
	$Config{Files_Ext_Allowed} = $Param{Files_Ext_Allowed};

	&UpdateConfiguration(%Config);
	&Save_Banned_Words_File($Param{Banned_Words});

	foreach $Key (keys %Config) {
			$Global{$Key} = $Config{$Key};
	}

	&PostingOptions("Posting Options Successfully Saved");
}
#==========================================================
sub PostingOptionsForm{
my ($Message) = @_;
my (%HTM, $Out, $Post_Treat_HTML, $T1, $T2, $T3, $T4, @Banned, $BannedWords);
my ($Allow_File_Upload, $Upload_Any_File);

	%HTM = (
			Show_Code => "Disable All HTML",
			Show_Safe_Code => "Allow Safe HTML",
			Remove_Code => "Remove All HTML",
			Show_HTML => "Allow All HTML"
		);
	
	$Post_Treat_HTML = "";
	foreach $Key  (sort keys %HTM) {
				$Selected = "";
				if ($Key eq $Global{Post_Treat_HTML}) {$Selected = "selected";}
				$Post_Treat_HTML .= qq!<option value="$Key" $Selected>$HTM{$Key}</option>!;
	}
	#----------------------------------------------------------------
	@Banned = &Load_Banned_Words_File;
	$BannedWords = join(", ", @Banned);
	#----------------------------------------------------------------
	if ($Global{Allow_File_Upload}) {
            $Allow_File_Upload = qq!<option selected value="1">YES</option><option value="0">NO</option>!;
	}
	else{
           $Allow_File_Upload = qq!<option selected value="0">NO</option><option value="1">YES</option>!;
	}

	if ($Global{Upload_Any_File}) {
            $Upload_Any_File = qq!<option selected value="1">YES</option><option value="0">NO</option>!;
	}
	else{
           $Upload_Any_File = qq!<option selected value="0">NO</option><option value="1">YES</option>!;
	}
	#----------------------------------------------------------------
$Out=<<HTML;
<div align="center" style="padding: 5px;"><font color="red" size="3"><b>$Message</b></font></div>

<form method="post" action="$ScriptURL">
<input type="hidden" name="action" value="SavePostingOptions">

<table class="TableAttr" width="100%" cellspacing="0" cellpadding="3">
    <tr><td class="TableCell">Posts HTML Manipulation:</td><td class="TableCell"><select size="1" name="Post_Treat_HTML">$Post_Treat_HTML</select></td></tr>
	<tr><td class="TableCell">Maximum Title Size:</td><td class="TableCell"><input type="text" name="Max_Title_Length" size="10" value="$Global{Max_Title_Length}"> Bytes</td></tr>
    <tr><td class="TableCell">Maximum Message Size:</td><td class="TableCell"><input type="text" name="Post_Max_Len" size="10" value="$Global{Post_Max_Len}"> Bytes</td></tr>

    <tr><td class="TableCell">Maximum Posts Per Session:</td><td class="TableCell"><input type="text" name="Posting_Max_Limit" size="10" value="$Global{Posting_Max_Limit}"></td></tr>
    <tr><td class="TableCell">Posts Session Time:</td><td class="TableCell"><input type="text" name="Posting_Max_Limit_Time" size="10" value="$Global{Posting_Max_Limit_Time}"> Minutes</td></tr>

	<tr><td class="TableCell">Allow Users to Upload Files</td><td class="TableCell"><select size="1" name="Allow_File_Upload">$Allow_File_Upload</select></td></tr>
	<tr><td class="TableCell">Maximum Number of Files Allowed to Upload:</td><td class="TableCell"><input type="text" name="Max_Upload_Files" size="10" value="$Global{Max_Upload_Files}"></td></tr>
	<tr><td class="TableCell">Maximum Upload File Size (Per File):</td><td class="TableCell"><input type="text" name="Max_Upload_File_Size" size="10" value="$Global{Max_Upload_File_Size}"> KB</td></tr>
	<tr><td class="TableCell">Maximum Upload Combined Total Files Size</td><td class="TableCell"><input type="text" name="Max_Upload_Size" size="10" value="$Global{Max_Upload_Size}"> KB</td></tr>
	<tr><td class="TableCell">Allow any File Type to Upload:</td><td class="TableCell"><select size="1" name="Upload_Any_File">$Upload_Any_File</select></td></tr>
	<tr><td valign="top">Files Extensions Allowed: <br>Separate by a Space</td><td class="TableCell"><textarea name="Files_Ext_Allowed" rows="5" cols="55">$Global{Files_Ext_Allowed}</textarea></td></tr>

    <tr><td class="TableCell">Slide Show Max Width:</td><td class="TableCell"><input type="text" name="Slide_Show_Max_Width" size="10" value="$Global{Slide_Show_Max_Width}"> Pixels</td></tr>
    <tr><td class="TableCell">Slide Show Max Height:</td><td class="TableCell"><input type="text" name="Slide_Show_Max_Height" size="10" value="$Global{Slide_Show_Max_Height}"> Pixels</td></tr>

    <tr><td class="TableCell">Banner Gragh Width:</td><td class="TableCell"><input type="text" name="Banner_Gragh_Width" size="10" value="$Global{Banner_Gragh_Width}"> Pixels</td></tr>
	<tr><td class="TableCell" valign="top">Banned words:</td><td class="TableCell"><textarea rows="8" name="Banned_Words" cols="60">$BannedWords</textarea><br>Separate words or phrases by comma</td></tr>

      <tr><td nowrap align="center" colspan="2" class="TableCell">
			<input type="submit" value="Save Changes" name="submit">&nbsp;&nbsp;
			  <input type="reset" value="Reset" name="Reset">
	  </td>
      </tr>

</table>
</form>
HTML

	return $Out;
}
#==========================================================
sub Load_Banned_Words_File{
my (@All, $Line, $Word, %Words);

	if (!-e $Global{Banned_Words_File}){	
			open (FILE, ">$Global{Banned_Words_File}") || &Exit("Cannot create data file $Global{Banned_Words_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
			close(FILE);
	}

	open (FILE, "$Global{Banned_Words_File}") || &Exit("Cannot read data file $Global{Banned_Words_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);

	$Line = join(",", @All);
	$Line =~ s/\s*\,\s*\,/\,/g;
	@All = split(/\,/, $Line);
	
	foreach $Word (@All) {
			$Word =~ s/^\s+//;
			$Word =~ s/\s+$//;
			$Word =~ s/\s+/ /g;
			next if (!$Word);
			$Words{$Word} = 1;
	}
	return sort keys %Words;
}
#==========================================================
sub Save_Banned_Words_File{
my ($BannedWords) = @_;
my (@Words, $Word, %Words);

	$BannedWords =~ s/\s*\,\s*\,/\,/g;
	$BannedWords =~ s/\s*\,\s*/\,/g;
	$BannedWords =~ s/\n//g;
	$BannedWords =~ s/\cM//g;

	@Words = split(/\,/, $BannedWords);
	
	foreach $Word (@Words) {
			$Word =~ s/^\s+//;
			$Word =~ s/\s+$//;
			$Word =~ s/\s+/ /g;
			next if (!$Word);
			$Words{$Word} = 1;
	}
	
	$BannedWords = join(",", sort keys %Words);

	open (FILE, ">$Global{Banned_Words_File}") || &Exit("Cannot create data file $Global{Banned_Words_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	print FILE "$BannedWords";
	close(FILE);
}
#==========================================================

1;