=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub MyMail{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_mail};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsTemplate});
	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	#------------------------------------------------------
	$Temp = &GetUserInboxUnReadCount($Param{User_ID});
	$Template =~ s/<!--UnReadInbox-->/$Temp/g;
	
	$Temp = &GetUserInboxTotalCount($Param{User_ID});
	$Template =~ s/<!--TotalInbox-->/$Temp/g;

	$Template =~ s/<!--MaxInbox-->/$Global{PM_Max_Inbox}/g;
	$Template =~ s/<!--MaxSentbox-->/$Global{PM_Max_Sentbox}/g;
	$Template =~ s/<!--MaxSavedbox-->/$Global{PM_Max_Savedbox}/g;
	$Template =~ s/<!--MaxDraftsbox-->/$Global{PM_Max_Draftsbox}/g;
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Template;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub GetPrivMsgsBox{
my ($User, $Folder) = @_;
my ($Source, $Query, $ID, @List);
	
	$User = $dbh->quote($User);
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	#------------------------------------------------------
	if ($Folder == 0) {# Inbox
			$Source = qq!User=$User AND Folder=$Folder!;
	}
	elsif ($Folder == 1) {# Outbox, the sent and still unread messages
			$Source = qq!FromUser=$User AND Status=0 AND Folder=0!;
	}
	elsif ($Folder == 2) {# Sentbox, the sent and read messages
			$Source = qq!User=$User AND Folder=$Folder!;
	}
	elsif ($Folder == 3) {# Savedbox, the messages saved by the user
			$Source = qq!User=$User AND Folder=$Folder!;
	}
	elsif ($Folder == 4) {# Draftsbox, the messages saved in the drafts box
			$Source = qq!User=$User AND Folder=$Folder!;
	}

	#------------------------------------------------------
	$Param{Sorted} ||= 0;
	$Param{Dir} ||= 0;
	if ($Param{Sorted} ==1) {$Param{Dir} = !$Param{Dir};	}
	$Param{Sort} ||= "Date";
	if ($Param{Dir} ==1 ) {$SortDir = "ASC";	} else {$SortDir = "DESC";}
	#------------------------------------------------------
	$Query = qq!SELECT ID FROM PrivMsgs WHERE $Source ORDER BY $Param{Sort} $SortDir!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @List;
	while(($ID) = $sth->fetchrow_array) {push @List, $ID;}
	$sth->finish;
	return @List;
}
#==========================================================
sub MyInbox{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_inbox};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsInboxTemplate});
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	@List = &GetPrivMsgsBox($Param{User_ID}, 0);
	#my ($Action, $Template, $Form1, $Form2, @Messages) = @_;
	$Out = &ParsePrivMsgsList("action=MyInbox", 0, $Template, $Global{PrivMsgInboxRow}, $Global{PrivMsgInboxRow1}, @List);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub MyOutbox{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_outbox};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsOutboxTemplate});
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	@List = &GetPrivMsgsBox($Param{User_ID}, 1);
	#my ($Action, $Template, $Form1, $Form2, @Messages) = @_;
	$Out = &ParsePrivMsgsList("action=MyOutbox", 1, $Template, $Global{PrivMsgOutboxRow}, $Global{PrivMsgOutboxRow1}, @List);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub MySentbox{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_sentbox};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsSentboxTemplate});
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	@List = &GetPrivMsgsBox($Param{User_ID}, 2);
	#my ($Action, $Template, $Form1, $Form2, @Messages) = @_;
	$Out = &ParsePrivMsgsList("action=MySentbox", 2, $Template, $Global{PrivMsgSentboxRow}, $Global{PrivMsgSentboxRow1}, @List);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub MySavedbox{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_savedbox};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsSavedboxTemplate});
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	@List = &GetPrivMsgsBox($Param{User_ID}, 3);
	#my ($Action, $Template, $Form1, $Form2, @Messages) = @_;
	$Out = &ParsePrivMsgsList("action=MySavedbox", 3, $Template, $Global{PrivMsgSavedboxRow}, $Global{PrivMsgSavedboxRow1}, @List);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub MyDraftsbox{
	
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_my_draftsbox};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{MyPrivMsgsDraftsboxTemplate});
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	@List = &GetPrivMsgsBox($Param{User_ID}, 4);
	#my ($Action, $Template, $Form1, $Form2, @Messages) = @_;
	$Out = &ParsePrivMsgsList("action=MyDraftsbox", 4, $Template, $Global{PrivMsgDraftsboxRow}, $Global{PrivMsgDraftsboxRow1}, @List);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub MyCompose{
my ($Message) = @_;

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_aboutme};
	$Plugins{Menu_Bar} = "";

	$Template = &TranslateFile($Global{PrivMsgTemplate});
	$Template =~ s/<!--Language-->/$Global{Language}/;
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	#------------------------------------------------------
	#------------------------------------------------------
	#Delete uploaded file
	$Upload = 0;
	if ($Param{PM_Delete_Uploaded_File}) {
			@Files = split(/\|/, $Param{PM_Uploaded_Files});
			undef %Files;
			foreach $File (@Files) {
				$Files{$File} = 1;
			}
			($DeleteFile, $RealFile) = split(/\~\=\=\~/, $Param{PM_Delete_Uploaded_File});

			delete $Files{$Param{PM_Delete_Uploaded_File}};
			$Param{PM_Uploaded_User_Size} -=  int((-s "$Global{Attach_Dir}/$DeleteFile")/1000);
			$Param{PM_Uploaded_User_Count}--;
			if (!$Param{PM_Uploaded_User_Count}) {
					$Param{PM_Uploaded_User_Size} = 0;
					undef %Files;
			}

			unlink ("$Global{Attach_Dir}/$DeleteFile");
			@Files = keys %Files;
			$Param{PM_Uploaded_Files} = join("\|", @Files);
			$Upload = 1;
	}
	#------------------------------------------------------
	#Upload files
	$Upload_Error = "";
	if ($Global{PM_Allow_File_Upload}) {
		foreach $Key (keys %Param) {
				if ($Key =~ m/Mewsoft_Corporation_Upload_File\d+/) {
							$Filename = ""; $File_Content = "";
							#($Filename, $File_Content) = split(/\|/, $Param{$Key});
							$Upload_File = $Param{$Key};
							$Upload_File =~ /\r\n\r\n|\n\n/;         #separate header and body 
							$Upload_File_Name = $`;                # front part
							$Upload_File_Content = $';             # rear part
							$Upload_File_Content =~ s/\r\n$//;  # the last \r\n was put in by Netscape

							# Parse uploaded files
							$Upload_File_Name =~ /filename=\"(.+)\"/; 
							$Upload_File_Name = $1;  #print "[[Header= $Header ]](($Input))<br>";
							$Upload_File_Name =~ s/\"//g; # remove "s
							$Upload_File_Name =~ s/\s//g; # make sure no space(include \n, \r..) in the file name 
							@File_Name = split(/[\/|\\]/, $Upload_File_Name); 
							$Upload_File_Name = pop @File_Name;
							$Filename = $Upload_File_Name;
							$File_Content = $Upload_File_Content;
							#print "\$Filename=$Filename<br><br>\$File_Content=$File_Content<br><br>";
							#$File_Content = $Param{$Key};
							#$File_Content =~ s/^$Filename\|//;
							if ($Filename) {
										$Upload_Error .= &Attach_File($Filename, $File_Content);
										$Upload = 1;
							}
							delete $Param{$Key};
				}
		}
	}
	else{
			$Upload_Error = $Language{upload_not_allowed_error};
	}
	#---------------------------------------------------------------------------------------------------------
	$Template =~ s/<!--PM_Uploaded_Files-->/$Param{PM_Uploaded_Files}/;
	$Template =~ s/<!--PM_Uploaded_User_Size-->/$Param{PM_Uploaded_User_Size}/;
	$Template =~ s/<!--PM_Uploaded_User_Count-->/$Param{PM_Uploaded_User_Count}/;
	if ($Upload_Error) {
			$Upload_Error = $Language{pm_upload_error_msg} . $Upload_Error;
	}
	$Template =~ s/<!--Upload_File_Error_Msg-->/$Upload_Error/;
	#------------------------------------------------------
	@Files = split(/\|/, $Param{PM_Uploaded_Files});
	$List = ""; $Count = 0;
	foreach $Filename (@Files) {
			($File, $RealFile) = split(/\~\=\=\~/, $Filename);
			$Count++;
			$Line = $Global{PrivMsgManageUploadedFilesRow};
			$Line =~ s/<!--Count-->/$Count/;

			$Link = qq!$Global{Attach_URL}/$File!;
			$Temp = $Language{pm_upload_file_view_link};
			$Temp =~ s/<!--Link-->/$Link/g;
			$Temp =~ s/<!--Name-->/$RealFile/g;
			$Line =~ s/<!--File-->/$Temp/g;
			
			$Temp = -s "$Global{Attach_Dir}/$File";
			$Line =~ s/<!--Size-->/$Temp/g;
			
			$Temp = $Language{pm_delete_uploaded_file_link};
			$Temp =~ s/<!--File-->/$Filename/g;
			$Line =~ s/<!--Delete-->/$Temp/;

			if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_image};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.wav$/i) {
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_sound};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mid$/i) {
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_mid};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mov$/i) {
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_movie};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.avi$/i) {
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_avi};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			else{
					$Link = qq!$Global{Attach_URL}/$File!;
					$URL = $Language{pm_upload_file_other};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			$Line =~ s/<!--Preview-->/$URL/;
			$List .= $Line;
	}
	$Template =~ s/<!--PM_Uploaded_Files_List_Manager-->/$List/;
	#------------------------------------------------------
	$Param{To} ||= "";
	$Param{Message} ||= "";

	$Param{Subject} ||= "";
	$Param{Subject} =~ s/^\s+//;
	$Param{Subject} =~ s/\s+$//;
	$Param{Subject} =~ s/\cM//g;

	$Template =~ s/<!--Subject-->/$Param{Subject}/g;
	#------------------------------------------------------
	$Template = &GetEditorForm($Template, "Message", "700px", "300px");
	#------------------------------------------------------
	$Param{Message} =~ s/\cM//g;
	$Template =~ s/<!--EditorText-->/$Param{Message}/g;
	#------------------------------------------------------
	$Param{To} =~ s/^\s+//;
	$Param{To} =~ s/\s+$//;
	$Param{To} =~ s/\s+/\,/g;
	$Param{To} =~ s/\,+/\,/g;
	@To = split(/\,/, $Param{To});

	undef %To;
	foreach $To (@To) {
			$To =~ s/^\s+//;
			$To =~ s/\s+$//;
			if (!$To) {next;}
			$To{$To} = 1;
	}
	@To = sort keys %To;
	
	$Users = "";
	foreach $To (@To) {
			$Users .= $dbh->quote($To) . ",";
	}
	$Users =~ s/\,$//g;
	undef @To;
	if ($Users) {
			$Query = qq!SELECT User_ID FROM Users WHERE User_ID IN($Users)!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			while(($Temp) = $sth->fetchrow_array) {push @To, $Temp;}
			$sth->finish;
	}

	if (@To > $Global{PM_Max_To}) {
			@To = @To[0..$Global{PM_Max_To}-1];
	}
	$Param{To} = join(", ", @To);
	$Template =~ s/<!--To-->/$Param{To}/g;
	#------------------------------------------------------
	$Param{Priority} ||= 2; $Temp = "selected";
	if ($Param{Priority} == 1) {
			$Template =~ s/<!--PriorityL-->/$Temp/g;
			$Template =~ s/<!--PriorityN-->//g;
			$Template =~ s/<!--PriorityH-->//g;
	}
	elsif ($Param{Priority} == 2) {
			$Template =~ s/<!--PriorityL-->//g;
			$Template =~ s/<!--PriorityN-->/$Temp/g;
			$Template =~ s/<!--PriorityH-->//g;
	}
	else {
			$Template =~ s/<!--PriorityL-->//g;
			$Template =~ s/<!--PriorityN-->//g;
			$Template =~ s/<!--PriorityH-->/$Temp/g;
	}
	#------------------------------------------------------
	#------------------------------------------------------
	$Param{PM_Uploaded_User_Count} ||= 0; $Temp = 0;
	$Template =~ s/<!--PM_Total_Uploaded_Count-->/$Param{PM_Uploaded_User_Count}/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Template =~ s/<!--PM_MAX_UPLOAD_FILES-->/$Global{PM_Max_Upload_Files}/;
	$Template =~ s/<!--PM_MAX_UPLOAD_FILE_SIZE-->/$Global{PM_Max_Upload_File_Size}/;
	$Template =~ s/<!--PM_MAX_UPLOAD_SIZE-->/$Global{PM_Max_Upload_Size}/;
	$Template =~ s/<!--PM_UPLOADED_USER_SIZE-->/$Param{PM_Uploaded_User_Size}/;
	$Template =~ s/<!--PM_UPLOADED_FILES_COUNT-->/$Param{PM_Uploaded_User_Count}/;
	$Template =~ s/<!--PM_ALLOWED_TYPES-->/$Global{PM_Files_Ext_Allowed}/;
	$Template =~ s/<!--PM_Max_Title_Length-->/$Global{PM_Max_Title_Length}/g;
	$Template =~ s/<!--PM_Max_Len-->/$Global{PM_Max_Len}/g;
	$Template =~ s/<!--PM_Max_To-->/$Global{PM_Max_To}/g;
	#------------------------------------------------------
	#------------------------------------------------------
	if ($Param{Preview}) {
			$Form = &TranslateFile($Global{PreviewPrivMsgTemplate});
			#------------------------------------------------------
			$Form =~ s/<!--PreviewTo-->/$Param{To}/g;

			$Temp = $Param{Subject};
			$Form =~ s/<!--PreviewSubject-->/$Temp/g;

			$Temp = $Param{Message};
			
			$Form =~ s/<!--PreviewMessage-->/$Temp/g;
			#------------------------------------------------------
			if ($Param{PM_Uploaded_Files}) {
					undef @Media; undef @Docs;
					@Upload = split(/\|/, $Param{PM_Uploaded_Files});
					foreach $Filename (@Upload) {
						($File, $RealFile) = split(/\~\=\=\~/, $Filename);
						if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
							push @Media, $Filename;
						}
						else{
							push @Docs, $Filename;
						}
					}
					
					$Images = qq!<table border="0" cellspacing="3" cellpadding="3">!;
					foreach $Filename (@Media) {
							($File, $RealFile) = split(/\~\=\=\~/, $Filename);
							#style="filter:progid:DXImageTransform.Microsoft.Pixelate(MaxSquare=15,Duration=10)"
							#$Name = &Web_Encode($Filename);
							$Image = qq!<img src="$Global{Attach_URL}/$File" border="0" alt="$RealFile" style="filter:revealTrans(duration=2,transition=21)">!;
							$Images .= qq!<tr><td align="center">$Image</td></tr>!;
					}
					$Images .= qq!</table>!;
					$Form =~ s/<!--PreviewMultimedia-->/$Images/g;

					$Docs = "";
					foreach $Filename (@Docs) {
							($File, $RealFile) = split(/\~\=\=\~/, $Filename);
							if ($File =~ /\.wav$/i) {
									$Link = qq!$Global{Attach_URL}/$File!;
									$URL = $Language{pm_upload_file_sound};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$RealFile/g;
							}
							elsif ($File =~ /\.mid$/i) {
									$Link = qq!$Global{Attach_URL}/$File!;
									$URL = $Language{pm_upload_file_mid};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$RealFile/g;
							}
							elsif ($File =~ /\.mov$/i) {
									$Link = qq!$Global{Attach_URL}/$File!;
									$URL = $Language{pm_upload_file_movie};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$RealFile/g;
							}
							elsif ($File =~ /\.avi$/i) {
									$Link = qq!$Global{Attach_URL}/$File!;
									$URL = $Language{pm_upload_file_avi};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$RealFile/g;
							}
							else{
									$Link = qq!$Global{Attach_URL}/$File!;
									$URL = $Language{pm_upload_file_other};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$RealFile/g;
							}
							$Docs .= $URL . $Language{pm_docs_files_join};
					}
					$Docs =~ s/$Language{pm_docs_files_join}$//g;
					$Form =~ s/<!--PreviewDocuments-->/$Docs/;
			}
			#------------------------------------------------------
	}
	else{
			$Form = "";
	}
	$Template =~ s/<!--PreviewPM-->/$Form/g;
	#------------------------------------------------------
	$Temp = ""; $Message ||= "";
	if ($Message) {
			$Temp = $Language{new_pm_errors};
			$Temp =~ s/<!--ErrorsMsgs-->/$Message/g;
	}
	$Template =~ s/<!--ErrorsPM-->/$Temp/g;
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Template;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub PrivMsgSaveAsDraft{

	#------------------------------------------------------
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$Param{Message} = &HTML_Treat($Param{Message}, $Global{PM_Treat_HTML});
	$Param{Message} = substr($Param{Message}, 0, $Global{PM_Max_Len});
	
	$Param{Subject} ||= "";
	$Param{Message} ||= "";
	$Param{Message} =~ s/\cM//g;
	#$Param{Message} =~ s/\n/\\\n/g;
	#------------------------------------------------------	
	$Param{To} =~ s/^\s+//;
	$Param{To} =~ s/\s+$//;
	$Param{To} =~ s/\s+/\,/g;
	$Param{To} =~ s/\,+/\,/g;
	@To = split(/\,/, $Param{To});

	undef %To;
	foreach $To (@To) {
			$To =~ s/^\s+//;
			$To =~ s/\s+$//;
			if (!$To) {next;}
			$To{$To} = 1;
	}
	@To = sort keys %To;
	
	$Users = "";
	foreach $To (@To) {
			$Users .= $dbh->quote($To) . ",";
	}
	$Users =~ s/\,$//g;
	undef @To;
	if ($Users) {
			$Query = qq!SELECT User_ID FROM Users WHERE User_ID IN($Users)!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			while(($Temp) = $sth->fetchrow_array) {push @To, $Temp;}
			$sth->finish;
	}

	$Param{To} = join(", ", @To);
	$Param{To} ||= "";
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Subject = $dbh->quote($Param{Subject});
	$Message = $dbh->quote($Param{Message});
	$Media = $dbh->quote($Param{PM_Uploaded_Files});
	$IP = $dbh->quote($ENV{REMOTE_ADDR});

	$Param{User_ID} ||= $Global{Guest_User};
	$FromUser = $dbh->quote($Param{User_ID});
	
	$Time = &Time(time);
	
	$Param{Priority} ||= 2;
	$Param{PM_Uploaded_Files} ||= "";
	if ($Param{PM_Uploaded_Files}) {$Attach = 1;} else { $Attach = 0;}

	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4

	$ToUser =  $dbh->quote($Param{To});

	$Query = qq!INSERT INTO PrivMsgs SET 
							ID=NULL,
							Folder=4,
							User=$User,
							FromUser=$FromUser,
							ToUser=$ToUser,
							Subject=$Subject,
							Date=$Time,
							Status=0,
							Priority=$Param{Priority},
							Attach=$Attach,
							IP=$IP
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$MsgID = $dbh->{mysql_insertid};

	$Query = qq!INSERT INTO PrivMsgsBody SET 
							ID=$MsgID,
							Folder=4,
							User=$User,
							FromUser=$FromUser,
							ToUser=$ToUser,
							Date=$Time,
							Priority=$Param{Priority},
							Attach=$Attach,
							Media=$Media,
							Subject=$Subject,
							Message=$Message
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	&MyDraftsbox;
}
#==========================================================
sub SaveNewCompose{
my (@To, %To, $To, $Users, $Query, $sth, @ToUsers);
my ($User, $Subject, $Message, $Media, $FromUser, $Time);
my ($Attach, $MsgID, $IP, $ToUser, %User);

	if ($Param{Preview}) {
			&MyCompose();
			return;
	}

	if ($Param{SaveAsDraft}) {
			&PrivMsgSaveAsDraft();
			return;
	}
	#------------------------------------------------------
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
#	$Param{Subject} =~ s/^\s+//;
#	$Param{Subject} =~ s/\s+$//;
#	$Param{Subject} =~ s/<[^>]+>//ig;
	
#	$Param{Message} =~ s/^\s+//;
#	$Param{Message} =~ s/\s+$//;

	$Param{Message} = &HTML_Treat($Param{Message}, $Global{PM_Treat_HTML});
	$Param{Message} = substr($Param{Message}, 0, $Global{PM_Max_Len});
	
	if (!$Param{Subject}) {
			&MyCompose($Language{new_pm_no_subject});
			return;
	}

	if (!$Param{Message}) {
			&MyCompose($Language{new_pm_no_msg});
			return;
	}

#	$Param{Message} =~ s/[^\>]\s*\cM/\<br\>/g;
#	$Param{Message} =~ s/[\>]\s*\cM/\> /g;
#	$Param{Message} =~ s/\cM/\<br\>/g;

	$Param{Message} =~ s/\cM//g;
	#$Param{Message} =~ s/\n/\\\n/g;
	#------------------------------------------------------	
	$Param{To} =~ s/^\s+//;
	$Param{To} =~ s/\s+$//;
	$Param{To} =~ s/\s+/\,/g;
	$Param{To} =~ s/\,+/\,/g;
	@To = split(/\,/, $Param{To});

	undef %To;
	foreach $To (@To) {
			$To =~ s/^\s+//;
			$To =~ s/\s+$//;
			if (!$To) {next;}
			$To{$To} = 1;
	}
	@To = sort keys %To;
	
	$Users = "";
	foreach $To (@To) {
			$Users .= $dbh->quote($To) . ",";
	}
	$Users =~ s/\,$//g;
	undef @To;
	if ($Users) {
			$Query = qq!SELECT User_ID FROM Users WHERE User_ID IN($Users)!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			while(($Temp) = $sth->fetchrow_array) {push @To, $Temp;}
			$sth->finish;
	}

	if (@To > $Global{PM_Max_To}) {
			@To = @To[0..$Global{PM_Max_To}-1];
	}
	$Param{To} = join(", ", @To);
	@ToUsers = @To;
	
	if (!$Param{To}) {
			&MyCompose($Language{new_pm_no_to});
			return;
	}
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Subject = $dbh->quote($Param{Subject});
	$Message = $dbh->quote($Param{Message});
	$Media = $dbh->quote($Param{PM_Uploaded_Files});

	$Param{User_ID} ||= $Global{Guest_User};
	$FromUser = $dbh->quote($Param{User_ID});
	
	$Time = &Time(time);
	
	$Param{Priority} ||= 2;
	$Param{PM_Uploaded_Files} ||= "";
	if ($Param{PM_Uploaded_Files}) {$Attach = 1;} else { $Attach = 0;}

	$IP = $dbh->quote($ENV{REMOTE_ADDR});
	
	foreach $ToUser (@ToUsers) {
				$ToUser =  $dbh->quote($ToUser);
				$Query = qq!INSERT INTO PrivMsgs SET 
										ID=NULL,
										Folder=0,
										User=$ToUser,
										FromUser=$FromUser,
										ToUser=$ToUser,
										Subject=$Subject,
										Date=$Time,
										Status=0,
										Priority=$Param{Priority},
										Attach=$Attach,
										IP=$IP
									!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				$MsgID = $dbh->{mysql_insertid};

				$Query = qq!INSERT INTO PrivMsgsBody SET 
										ID=$MsgID,
										Folder=0,
										User=$ToUser,
										FromUser=$FromUser,
										ToUser=$ToUser,
										Date=$Time,
										Priority=$Param{Priority},
										Attach=$Attach,
										Media=$Media,
										Subject=$Subject,
										Message=$Message
									!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	# send the notify emails to recipients
	$Subject = $Language{pm_email_notify_subject};
	$Subject =~ s/<!--Subject-->/$Param{Subject}/g;
	$Subject =~ s/<!--FromUser-->/$Param{User_ID}/g;

	$Message = $Language{pm_email_notify_message};
	$Message =~ s/<!--Subject-->/$Param{Subject}/g;
	$Message =~ s/<!--Message-->/$Param{Message}/g;
	$Message =~ s/<!--FromUser-->/$Param{User_ID}/g;

	foreach $User (@ToUsers) {
			%User = &Get_User($User);
			if (!%User) {next;}
			#Email($From, $TO, $Subject,   $Message);
			&Email($Global{PrivMsg_Notify_Email}, $User{Email}, $Subject, $Message);
	}
	#------------------------------------------------------
	#$Topics = &GetForumTopicsCount($Param{Forum});
	#$Posts = &GetForumPostsCount($Param{Forum});
	#$Query = qq!UPDATE Forums SET Posts=$Posts, Topics=$Topics, LastPost=$Post WHERE Forum=$Param{Forum}!;
	#$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	&MyMail;
}
#==========================================================
#==========================================================
sub Attach_File{
my ($Filename, $File_Content) = @_;
my (@File_Exts, $File_Ext, $Ext, $Err, $RealFile);
my (@Files_Ext_Allowed, $File_Allowed, $File_Name, $File);
my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks);

	binmode(STDIN);
	binmode(STDOUT);
	binmode(STDERR);

	@File_Exts = split(/\./ , $Filename);
	$File_Ext = pop @File_Exts;
	$File_Ext = lc($File_Ext);

	@File_Name = split(/[\/|\\]/, $Filename); 
	$File = pop @File_Name;
	$RealFile = $File;
	$File_Name = qq!$Global{Attach_Dir}/$File!;
	if (-e $File_Name) {
			$File_Name = &GetRandomAttachFilename($Global{Attach_Dir}, $File);
	}

	$Global{PM_Files_Ext_Allowed}=~ s/\,/ /g;
	@Files_Ext_Allowed = split(/\s+/, $Global{PM_Files_Ext_Allowed});
	$File_Allowed = 0;
	if ($Global{PM_Upload_Any_File}) {
				$File_Allowed = 1;
	}
	else{
				foreach $Ext(@Files_Ext_Allowed) {
						$Ext = lc($Ext);
						$Ext =~ s/\s+//g;
						if ($File_Ext eq $Ext){
								$File_Allowed =1; last;
						}
		      }
	}

	if ($File_Allowed) { 
				open(FILE,">$File_Name")  || &Exit("Can 't write media file $File_Name: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
				binmode FILE;
				print FILE $File_Content; 
				close(FILE); 
				($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = stat($File_Name);
				$Err = "";
				chmod (0755, $File_Name);
	}
	else{
				# File ext. not allowed to upload
				$Err = $Language{pm_upload_file_type_error};
	}

	if (!$Err) {
			if ($Filename) { 
						$Err = &Check_Attached_File($RealFile, $File_Name, $size);
				}
			else {
						$Err = $Language{pm_upload_file_no_name};
						unlink ($File_Name);
			 }
	 }

	$Upload_Error_Msg = "";
	
	return $Err;
}
#==========================================================
sub Check_Attached_File{
my ($RealFile, $Fname, $Fsize) = @_;
my ($Msg, @File, $File);

	$Fsize = int($Fsize/1000);
	$Msg = "";

	if ($Param{PM_Uploaded_User_Count} >= $Global{PM_Max_Upload_Files} ){
				$Msg .= "$Language{pm_error_max_upload_files} <b>$Global{PM_Max_Upload_Files}</b>.<br>";
	}
	
	if ($Fsize > $Global{PM_Max_Upload_File_Size}) {
			$Msg .= "$Language{pm_error_max_upload_file_size} <b>$Global{PM_Max_Upload_File_Size} $Language{pm_kilo_bytes}</b>.<br>";
	}
	
	if ( ( $Fsize + $Param{PM_Uploaded_User_Size}) > $Global{PM_Max_Upload_Size}) {
			$Msg .= "$Language{pm_error_max_total_upload_size} <b>$Global{PM_Max_Upload_Size} $Language{pm_kilo_bytes}</b>.<br>";
	}

	if (!$Msg) {
			@File = split(/[\/|\\]/, $Fname); 
			$File = pop @File;

			if (!$Param{PM_Uploaded_Files}) {
					$Param{PM_Uploaded_Files} .= "$File~==~$RealFile";
			}
			else{
					$Param{PM_Uploaded_Files} .= "|$File~==~$RealFile";
			}
			
			$Param{PM_Uploaded_User_Size} ||= 0;
			$Param{PM_Uploaded_User_Size} += $Fsize;

			$Param{PM_Uploaded_User_Count} ||= 0;
			$Param{PM_Uploaded_User_Count}++;
	 }
	else {
			unlink ("$Fname");
	}

	return $Msg;
}
#==========================================================
sub GetRandomAttachFilename{
my ($Dir, $File) = @_;
my ($Tmp, @Name, $Ext, $T, $x, @C, $R, $N);

	srand(time ^ $$);
	@C = ('a'..'k','0'..'4', 'm'..'q', 'r'..'z', '5'..'9');
	$R = "";
	for $x(0..14){
		$N = int(rand($#C + 1));
		$R .= $C[$N];
	}
	
	$File =~ s/^\s+//; 
	$File =~ s/\s+$//;
	$File =~ s/\s+/_/g;

	$Ext = "";
	@Name = split(/\./, $File);
	$Ext = pop @Name;
	$Name = join (".", @Name);
	$T = "";
   do {
			$Tmp  = "$Dir/$R$T\.$Ext";
			$T++;
   } until (!-e $Tmp);

   return $Tmp;
}
#==========================================================
sub ParsePrivMsgsList{
my ($Action, $Folder, $Template, $Form1, $Form2, @Messages) = @_;
my (@Forms, $TotalCount, $Last_Page, $CurrentPage);
my ($Next_Page, $Previous_Page, $Temp, $Pages, @Pages, $Link);
my ($Start, $End, $TimeFormat, $Output);
my ($Counter, $Message, %Message, $Form);

	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	#------------------------------------------------------
	@Forms = (&Translate($Form1), &Translate($Form2));
	#------------------------------------------------------
	$Param{Page} ||= 1;
	$TotalCount = @Messages;
	
	$Global{Messages_Per_Page} ||= 10;
	$Param{PageSize} ||= $Global{Messages_Per_Page};

	$Last_Page = int ($TotalCount / $Param{PageSize});
	if (($TotalCount % $Param{PageSize})) {$Last_Page++;}
	$CurrentPage = $Param{Page};
	$Next_Page = $CurrentPage + 1;
	$Previous_Page = $CurrentPage - 1;
	if ($Next_Page > $Last_Page) {$Next_Page = $Last_Page;}
	#----------------------------------------------
	$Next_Page_URL = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Next_Page&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Previous_Page_URL = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Previous_Page&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	#----------------------------------------------
	if ($CurrentPage == $Last_Page || $TotalCount <= 0) {
			$Temp = $Language{messages_last_page};
	}
	else{
			$Temp = $Language{messages_next_page};
			$Temp =~ s/<!--Next_Page_URL-->/$Next_Page_URL/g;
	}
	$Template =~ s/<!--Next_Page-->/$Temp/g;

	if ($CurrentPage == 1) {
			$Temp = $Language{messages_first_page};
	}
	else{
			$Temp = $Language{messages_previous_page};
			$Temp =~ s/<!--Previous_Page_URL-->/$Previous_Page_URL/g;
	}
	$Template =~ s/<!--Previous_Page-->/$Temp/g;
	#----------------------------------------------
	if ($Last_Page > 1) {
			$Temp = $Language{messages_first_page_link};
			$First_Page_URL = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
			$Temp =~ s/<!--First_Page_URL-->/$First_Page_URL/g;
			$Template =~ s/<!--First_Page-->/$Temp/g;

			$Temp = $Language{messages_last_page_link};
			$Last_Page_URL = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Last_Page&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
			$Temp =~ s/<!--Last_Page_URL-->/$Last_Page_URL/g;
			$Template =~ s/<!--Last_Page-->/$Temp/g;
	}
	else{
			$Template =~ s/<!--First_Page-->/$Language{messages_first_page_no_link}/g;
			$Template =~ s/<!--Last_Page-->/$Language{messages_first_page_no_link}/g;
	}

	#----------------------------------------------
	$Pages = ""; 
	@Pages = &PrivMsgPagesNumbers($CurrentPage, $Last_Page);

	foreach $Page(@Pages) {
			if ($Page == $CurrentPage) {
					$Link = $Language{messages_current_page_link};
			}
			else{
					$Link = $Language{messages_pages_link};
			}
			$Temp = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Page&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
			$Link =~ s/<!--Link-->/$Temp/;
			$Link =~ s/<!--Page-->/$Page/;
			$Pages .= $Link;
			if ($Page != $Last_Page) {
					$Pages .= $Language{messages_pages_link_separtor};
			}
	}
	$Pages =~ s/$Language{messages_pages_link_separtor}$//g;
	$Template =~ s/<!--Pages-->/$Pages/g;
	#----------------------------------------------
	$Temp = $Language{messages_showing_page};
	$Temp =~ s/<!--CurrentPage-->/$CurrentPage/g;
	$Temp =~ s/<!--TotalPages-->/$Last_Page/g;
	$Template =~ s/<!--Showing_Page-->/$Temp/g;
	#------------------------------------------------------
	$Start = ($CurrentPage - 1) * $Param{PageSize};
	$End = $Start + $Param{PageSize};
	if ($End > $TotalCount) {$End = $TotalCount;}
	#------------------------------------------------------
	$Plugins{ResultsFound} = $Language{messages_results_found};
	$Plugins{ResultsFound} =~ s/<!--Found-->/$TotalCount/g;
	$Temp = $Start+1;
	$Plugins{ResultsFound} =~ s/<!--FoundStart-->/$Temp/g;
	$Plugins{ResultsFound} =~ s/<!--FoundEnd-->/$End/g;
	#------------------------------------------------------
	$Output = "";
	for $Counter ($Start..$End-1){
				$Message = $Messages[$Counter];
				#%Message = &GetPrivMsg($Message);
				%Message = &GetPrivMsgFull($Message);
				$Form = $Forms[int($Counter % 2)]; 
				#----------------------------------------------------------------------------------
				# Message status, new or old
				if ($Message{Status}) { # read message
						$Icon = $Language{read_message_icon};
						$Form =~ s/<!--StatusOpen-->/$Language{read_message_open}/g;
						$Form =~ s/<!--StatusClose-->/$Language{read_message_close}/g;
						$Form =~ s/<!--LinkClass-->/$Language{read_message_linkclass}/g;
				}
				else{ # unread message
						$Icon = $Language{unread_message_icon};
						$Form =~ s/<!--StatusOpen-->/$Language{unread_message_open}/g;
						$Form =~ s/<!--StatusClose-->/$Language{unread_message_close}/g;
						$Form =~ s/<!--LinkClass-->/$Language{unread_message_linkclass}/g;
				}

				$Form =~ s/<!--Status-->/$Icon/g;
				#----------------------------------------------------------------------------------
				# Message attachments flag
				if ($Message{Attach}) { # has attachments
						$Icon = $Language{message_attach_icon};
				}
				else{ # read message
						$Icon = $Language{message_no_attach_icon};
				}

				$Form =~ s/<!--Attach-->/$Icon/g;
				#----------------------------------------------------------------------------------
				# Message Priority
				if ($Message{Priority} == 1) {
						$Temp = $Language{priority_msg_low};
				}
				elsif ($Message{Priority} == 2) {
						$Temp = $Language{priority_msg_normal};
				}
				elsif ($Message{Priority} == 3) {
						$Temp = $Language{priority_msg_high};
				}
				$Form =~ s/<!--Priority-->/$Temp/g;
				#----------------------------------------------------------------------------------
				$Temp = $Language{privmsg_mark_link};
				$Temp =~ s/<!--MarkID-->/Mark\_$Message/g;
				$Temp =~ s/<!--RowID-->/Row\_$Message/g;
				$Temp =~ s/<!--ID-->/$Message/g;
				$Form =~ s/<!--Mark-->/$Temp/g;

				$Form =~ s/<!--RowID-->/Row\_$Message/g;
				#----------------------------------------------------------------------------------
				$Temp = $Counter + 1;
				$Form =~ s/<!--Counter-->/$Temp/g;

				# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
				if ($Folder == 4) { # Draft box
							$Temp = qq!$Global{ProgURL}action=MyDraftCompose&Folder=$Folder&ID=$Message&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
				}
				else{
							$Temp = qq!$Global{ProgURL}action=ViewMessage&Folder=$Folder&ID=$Message&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
				}
				$Form =~ s/<!--SubjectLink-->/$Temp/g;

				$Temp = $Message{Subject};
				$Temp ||= $Language{pm_no_subject};
				$Form =~ s/<!--Subject-->/$Temp/g;

				$Temp = $Message{Subject};
				$Form =~ s/<!--Preview-->/$Temp/g;

				$Temp = qq!$Global{ProgURL}action=MyCompose&To=$Message{FromUser}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
				$Form =~ s/<!--FromLink-->/$Temp/g;
				
				$Temp = $Message{FromUser};
				$Form =~ s/<!--FromUser-->/$Temp/g;

				# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
				if ($Folder == 4) { # Drafts box
							$Temp = qq!$Global{ProgURL}action=MyDraftCompose&Folder=$Folder&ID=$Message&Lang=$Global{Language}!;
				}
				else{
							$Temp = qq!$Global{ProgURL}action=MyCompose&To=$Message{ToUser}&Lang=$Global{Language}!;
				}
				$Form =~ s/<!--ToLink-->/$Temp/g;
				
				$Temp = $Message{ToUser};
				$Temp ||= $Language{pm_no_to_users};
				$Form =~ s/<!--ToUser-->/$Temp/g;
				#----------------------------------------------------------------------------------
				if ($Message{Date} > 0) {
						$Temp = &ParseDate($Global{PM_ListDateFormat}, $Message{Date});
				}
				else{	
						$Temp = "";
				}
				$Form =~ s/<!--Date-->/$Temp/g;
				#----------------------------------------------------------------------------------
				$Counter++;
				$Form =~ s/<!--Counter-->/$Counter/g;

				$Output .= $Form;
	}

	$Template =~ s/<!--MessagesList-->/$Output/;
	#------------------------------------------------------
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Folder-->/$Folder/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;

	$Plugins{SortSubject} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Subject&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortFromUser} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=FromUser&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortToUser} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=ToUser&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortDate} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Date&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortAttach} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Attach&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortStatus} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Status&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortPriority} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Priority&Dir=$Param{Dir}&Page=1&PageSize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;

	$Plugins{SortSubjectImg} = "";
	$Plugins{SortFromUserImg} = "";
	$Plugins{SortToUserImg} = "";
	$Plugins{SortDateImg} = "";
	$Plugins{SortAttachImg} = "";
	$Plugins{SortStatusImg} = "";
	$Plugins{SortPriorityImg} = "";

	if ($Param{Dir} ==1){$Temp = $Language{pm_sort_up};}
	else{$Temp = $Language{pm_sort_dn};}

	if ($Param{Sort} eq "Subject") {$Temp =~ s/<!--Link-->/$Plugins{SortSubject}/; $Plugins{SortSubjectImg} = $Temp;}
	elsif ($Param{Sort} eq "FromUser") {$Temp =~ s/<!--Link-->/$Plugins{SortFromUser}/; $Plugins{SortFromUserImg} = $Temp;}
	elsif ($Param{Sort} eq "ToUser") {$Temp =~ s/<!--Link-->/$Plugins{SortToUser}/; $Plugins{SortToUserImg} = $Temp;}
	elsif ($Param{Sort} eq "Date") {$Temp =~ s/<!--Link-->/$Plugins{SortDate}/; $Plugins{SortDateImg} = $Temp;}
	elsif ($Param{Sort} eq "Attach") {$Temp =~ s/<!--Link-->/$Plugins{SortAttach}/; $Plugins{SortAttachImg} = $Temp;}
	elsif ($Param{Sort} eq "Status") {$Temp =~ s/<!--Link-->/$Plugins{SortStatus}/; $Plugins{SortStatusImg} = $Temp;}
	elsif ($Param{Sort} eq "Priority") {$Temp =~ s/<!--Link-->/$Plugins{SortPriority}/; $Plugins{SortPriorityImg} = $Temp;}
	#------------------------------------------------------
	return $Template;
}
#==========================================================
sub GetPrivMsg{
my ($ID) = @_;
my ($Query, %Msg);

	$Query = qq!SELECT * FROM PrivMsgs WHERE ID=$ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	%Msg = %{$sth->fetchrow_hashref()};
	$sth->finish;
	return %Msg;
}
#==========================================================
sub GetPrivMsgFull{
my ($ID) = @_;
my ($Query, %Msg);

	$Query = qq!SELECT * FROM PrivMsgs, PrivMsgsBody WHERE PrivMsgs.ID=$ID AND PrivMsgsBody.ID=$ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	%Msg = %{$sth->fetchrow_hashref()};
	$sth->finish;
	return %Msg;
}
#==========================================================
sub PrivMsgMarkRead{
my ($ID) = @_;

	$Query = qq!UPDATE PrivMsgs SET Status=1 WHERE ID=$ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub PrivMsgMarkUnRead{
my ($ID) = @_;

	$Query = qq!UPDATE PrivMsgs SET Status=0 WHERE ID=$ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub PrivMsgCopyMsg{
my ($User, $ToFolder, $Status, %Message) = @_;
my ($MsgID, $FromUser, $ToUser, $Subject, $Message, $Media);
my ($NewMedia, @Files, $Filename, $File, $RealFile, @Filename);
my ($Name, $IP, $Query);

	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	#------------------------------------------------------
	$ToFolder ||= 0;
	$Status ||= 0;
	#------------------------------------------------------
	# copy message attachments to new files for new message
	$NewMedia = "";
	if ($Message{Media}) {
			@Files = split(/\|/, $Message{Media});
			foreach $Filename (@Files) {
					($File, $RealFile) = split(/\~\=\=\~/, $Filename);
					$Filename = &GetRandomAttachFilename($Global{Attach_Dir}, $RealFile);
					copy("$Global{Attach_Dir}/$File",	$Filename);
					@Filename = split(/[\/|\\]/, $Filename); 
					$Name = pop @Filename;
					$NewMedia .= "$Name~==~$RealFile|";
		    }
			$NewMedia =~ s/\|$//;
	}
	#------------------------------------------------------
	$User= $dbh->quote($User);
	$FromUser = $dbh->quote($Message{FromUser});
	$ToUser = $dbh->quote($Message{ToUser});

	$Subject = $dbh->quote($Message{Subject});
	$Message = $dbh->quote($Message{Message});
	$Media = $dbh->quote($NewMedia);
	$IP = $dbh->quote($Message{IP});

	$Query = qq!INSERT INTO PrivMsgs SET 
							ID=NULL,
							Folder=$ToFolder,
							User=$User,
							FromUser=$FromUser,
							ToUser=$ToUser,
							Subject=$Subject,
							Date=$Message{Date},
							Status=$Status,
							Priority=$Message{Priority},
							Attach=$Message{Attach},
							IP=$IP
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$MsgID = $dbh->{mysql_insertid};

	$Query = qq!INSERT INTO PrivMsgsBody SET 
							ID=$MsgID,
							Folder=$ToFolder,
							User=$User,
							FromUser=$FromUser,
							ToUser=$ToUser,
							Date=$Message{Date},
							Priority=$Message{Priority},
							Attach=$Message{Attach},
							Media=$Media,
							Subject=$Subject,
							Message=$Message
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	return $MsgID;
}
#==========================================================
sub ViewMessage{
my (%Message, $Template);

	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	#------------------------------------------------------
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	#------------------------------------------------------
	if ($Message{Folder} == 0 && $Message{ToUser} eq $Param{User_ID}) {# inbox message
			$Template = &TranslateFile($Global{ViewPrivMsgInboxTemplate});
			# if message first time read by receiver, mark as read and copy to sender sentbox
			if (!$Message{Status}) {
					# (%Message, $User, $ToFolder, $Status)
					# copy message to the Sentbox of the sender
					&PrivMsgCopyMsg($Message{FromUser}, 2, 0, %Message);
					# mark as read to hide it from the Outbox of the sender
					&PrivMsgMarkRead($Message{ID});
			}
	}
	elsif ($Message{Folder} == 1 || ($Message{Folder} == 0 && $Message{FromUser} eq $Param{User_ID})) { # outbox message
			$Template = &TranslateFile($Global{ViewPrivMsgOutboxTemplate});
	}
	elsif ($Message{Folder} == 2) { # sentbox message
			$Template = &TranslateFile($Global{ViewPrivMsgSentboxTemplate});
			if (!$Message{Status}) {
					&PrivMsgMarkRead($Message{ID});
			}
	}
	elsif ($Message{Folder} == 3) { # savedbox message
			$Template = &TranslateFile($Global{ViewPrivMsgSavedboxTemplate});
			if (!$Message{Status}) {
					&PrivMsgMarkRead($Message{ID});
			}
	}
	elsif ($Message{Folder} == 4) { # draftsbox message
			$Template = &TranslateFile($Global{ViewPrivMsgDraftsboxTemplate});
			if (!$Message{Status}) {
					&PrivMsgMarkRead($Message{ID});
			}
	}
	
	$Out = &ParsePrivMsg($Template, $Param{Folder}, %Message);
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Out;
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub ParsePrivMsg{
my ($Template, $Folder, %Message) = @_;
	
	$Temp = $Message{Subject};
	$Template =~ s/<!--Subject-->/$Temp/g;

	$Temp = $Message{Message};
	$Template =~ s/<!--Message-->/$Temp/g;

	$Template =~ s/<!--FromUser-->/$Message{FromUser}/g;
	$Template =~ s/<!--ToUser-->/$Message{ToUser}/g;

	$Temp = &ParseDate($Global{PM_MsgDateFormat}, $Message{Date});
	$Template =~ s/<!--Date-->/$Temp/g;
	#----------------------------------------------------------------------------------
	# Message Priority
	if ($Message{Priority} == 1) {
			$Temp = $Language{msg_view_priority_low};
	}
	elsif ($Message{Priority} == 2) {
			$Temp = $Language{msg_view_priority_normal};
	}
	elsif ($Message{Priority} == 3) {
			$Temp = $Language{msg_view_priority_high};
	}
	$Template =~ s/<!--Priority-->/$Temp/g;
	#----------------------------------------------------------------------------------
	#------------------------------------------------------
	if ($Message{Media}) {
			undef @Media; undef @Docs;
			@Upload = split(/\|/, $Message{Media});
			$Attachs = "";
			foreach $Filename (@Upload) {
						($File, $RealFile) = split(/\~\=\=\~/, $Filename);
						if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
							push @Media, $Filename;
						}
						else{
							push @Docs, $Filename;
						}
						$Name = &Web_Encode($Filename);
						$Attach = $Language{msg_view_attach_file};
						$Temp = qq!$Global{ProgURL}action=GetAttach&Folder=$Folder&ID=$Message{ID}&File=$Name&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
						$Attach =~ s/<!--Link-->/$Temp/g;
						$Attach =~ s/<!--Name-->/$RealFile/g;
						$Attachs .= $Attach . $Language{msg_view_attach_file_space};
			}
			
			$Attachs =~ s/$Language{msg_view_attach_file_space}$//g;
			$Template =~ s/<!--Attachements-->/$Attachs/g;

			$Images = "";
			foreach $Filename (@Media) {
						($File, $RealFile) = split(/\~\=\=\~/, $Filename);
						$Image = $Language{msg_view_images};
						$Name = &Web_Encode($Filename);
						$Temp = qq!$Global{ProgURL}action=GetAttach&Folder=$Folder&ID=$Message{ID}&File=$Name&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
						$Image =~ s/<!--DwonloadLink-->/$Temp/g;
						$Temp = qq!$Global{Attach_URL}/$File!;
						$Image =~ s/<!--Link-->/$Temp/g;
						$Image =~ s/<!--Name-->/$RealFile/g;
						$Images .= $Image . $Language{msg_view_images_space};
			}
			$Images =~ s/$Language{msg_view_images_space}$//g;
			$Template =~ s/<!--Multimedia-->/$Images/g;

			$Docs = "";
			foreach $Filename (@Docs) {
					($File, $RealFile) = split(/\~\=\=\~/, $Filename);
					$Link = qq!$Global{Attach_URL}/$File!;
					
					if ($File =~ /\.wav$/i) {$URL = $Language{msg_view_file_sound};}
					elsif ($File =~ /\.mid$/i) {$URL = $Language{msg_view_file_mid};}
					elsif ($File =~ /\.mov$/i) {$URL = $Language{msg_view_file_movie};}
					elsif ($File =~ /\.avi$/i) {$URL = $Language{msg_view_file_avi};}
					else{
							#$URL = $Language{msg_view_file_other};
					}

					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$RealFile/g;
					$Docs .= $URL . $Language{msg_view_docs_files_join};
			}
			$Docs =~ s/$Language{msg_view_docs_files_join}$//g;
			$Template =~ s/<!--Documents-->/$Docs/;
	}
	#------------------------------------------------------
	# Message navigation links
	$Temp = &Translate($Global{PrivMsgViewMsgTopNav});
	$Template =~ s/<!--CLASS::PrivMsgViewMsgTopNav-->/$Temp/g;
	$Temp = &Translate($Global{PrivMsgViewMsgBottomNav});
	$Template =~ s/<!--CLASS::PrivMsgViewMsgBottomNav-->/$Temp/g;
	#------------------------------------------------------
	$Temp = qq!$Global{ProgURL}action=ReplyMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--ReplyLink-->/$Temp/g;

	$Temp = qq!$Global{ProgURL}action=ForwordMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--ForwordLink-->/$Temp/g;

	$Temp = qq!$Global{ProgURL}action=DeleteMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--DeleteLink-->/$Temp/g;

	$Temp = qq!$Global{ProgURL}action=PrintMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--PrintLink-->/$Temp/g;

	$Temp = qq!$Global{ProgURL}action=SaveMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--SaveLink-->/$Temp/g;
	
	$Temp = qq!$Global{ProgURL}action=PrevMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--PrevLink-->/$Temp/g;

	$Temp = qq!$Global{ProgURL}action=NextMessage&Folder=$Folder&ID=$Message{ID}&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Lang=$Global{Language}!;
	$Template =~ s/<!--NextLink-->/$Temp/g;
	#------------------------------------------------------
	return $Template;
}
#==========================================================
sub GetAttach{
my (%Message, @Upload, $Filename, $Found, $RealFile);
my ($File, $FileType, $Mime, $Filesize, $Buffer, $BytesRead);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});

	@Upload = split(/\|/, $Message{Media});
	$Found = 0;
	foreach $Filename (@Upload) {
			if ($Param{File} eq $Filename) {
					$Found = 1; last;
			}
	}
	#------------------------------------------------------
	if ($Found) {
			($Filename, $RealFile) = split(/\~\=\=\~/, $Param{File});
			$File = qq!$Global{Attach_Dir}/$Filename!;
			$FileType = File::Type->new();
			$Mime = $FileType->mime_type($File);
			$Mime ||= "application/octet-stream";

			$Filesize = -s $File;
			print "Content-length: $Filesize\n";
			print "Content-Disposition: attachment; filename=$RealFile\n";
			print "Content-type: $Mime\n\n";
			open (File, "<$File") || &Exit("Cannot open $Filename: $!"."<br>Line ". __LINE__ . ", File ". __FILE__); 
			binmode (File);
			
			binmode STDOUT;
			$Buffer = "";
			#while ($BytesRead = sysread(File, $Buffer, 4096)) {
			while ($BytesRead = read(File, $Buffer, 4096)) {
					print $Buffer;
					$Buffer = "";
			}

			close (File);
	}
	#------------------------------------------------------
}
#==========================================================
sub ReplyMessage{
my (%Message, $K, $V, @Files, $Filename, $File, $RealFile);
my (@Filename, $Name);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	#------------------------------------------------------
	while (($K, $V) = each %Message) {
			$Param{$K} = $V;
	}
	#------------------------------------------------------
	# do not resend attachments when replying
	$Message{Media} = "";

	$Param{PM_Uploaded_Files} = "";
	$Param{PM_Uploaded_User_Size} = 0;
	$Param{PM_Uploaded_User_Count} = 0;

	if ($Message{Media}) {
			@Files = split(/\|/, $Message{Media});
			foreach $Filename (@Files) {
					($File, $RealFile) = split(/\~\=\=\~/, $Filename);
					$Filename = &GetRandomAttachFilename($Global{Attach_Dir}, $RealFile);
					copy("$Global{Attach_Dir}/$File",	$Filename);
					@Filename = split(/[\/|\\]/, $Filename); 
					$Name = pop @Filename;
					$Param{PM_Uploaded_Files} .= "$Name~==~$RealFile|";
					$Param{PM_Uploaded_User_Size} += -s $Filename;
					$Param{PM_Uploaded_User_Count}++;
		    }
			$Param{PM_Uploaded_Files} =~ s/\|$//;
	}
	#------------------------------------------------------
	$Param{Subject} = $Language{msg_reply_prefix} . $Message{Subject};
	#------------------------------------------------------
	$Param{To} = $Param{FromUser};
	#------------------------------------------------------
	&MyCompose;
}
#==========================================================
sub ForwordMessage{
my (%Message, $K, $V, @Files, $Filename, $File, $RealFile);
my (@Filename, $Name);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	#------------------------------------------------------
	while (($K, $V) = each %Message) {
			$Param{$K} = $V;
	}
	#------------------------------------------------------
	$Param{PM_Uploaded_Files} = "";
	$Param{PM_Uploaded_User_Size} = 0;
	$Param{PM_Uploaded_User_Count} = 0;

	if ($Message{Media}) {
			@Files = split(/\|/, $Message{Media});
			foreach $Filename (@Files) {
					($File, $RealFile) = split(/\~\=\=\~/, $Filename);
					$Filename = &GetRandomAttachFilename($Global{Attach_Dir}, $RealFile);
					copy("$Global{Attach_Dir}/$File",	$Filename);
					@Filename = split(/[\/|\\]/, $Filename); 
					$Name = pop @Filename;
					$Param{PM_Uploaded_Files} .= "$Name~==~$RealFile|";
					$Param{PM_Uploaded_User_Size} += -s $Filename;
					$Param{PM_Uploaded_User_Count}++;
		    }
			$Param{PM_Uploaded_Files} =~ s/\|$//;
	}
	#------------------------------------------------------
	$Param{Subject} = $Language{msg_forword_prefix} . $Message{Subject};
	#------------------------------------------------------
	&MyCompose;
}
#==========================================================
sub MyDraftCompose{
my (%Message, $K, $V, @Files, $Filename, $File, $RealFile);
my (@Filename, $Name);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	#------------------------------------------------------
	while (($K, $V) = each %Message) {
			$Param{$K} = $V;
	}
	#------------------------------------------------------
	$Param{PM_Uploaded_Files} = "";
	$Param{PM_Uploaded_User_Size} = 0;
	$Param{PM_Uploaded_User_Count} = 0;

	if ($Message{Media}) {
			@Files = split(/\|/, $Message{Media});
			foreach $Filename (@Files) {
					($File, $RealFile) = split(/\~\=\=\~/, $Filename);
					$Filename = &GetRandomAttachFilename($Global{Attach_Dir}, $RealFile);
					copy("$Global{Attach_Dir}/$File",	$Filename);
					@Filename = split(/[\/|\\]/, $Filename); 
					$Name = pop @Filename;
					$Param{PM_Uploaded_Files} .= "$Name~==~$RealFile|";
					$Param{PM_Uploaded_User_Size} += -s $Filename;
					$Param{PM_Uploaded_User_Count}++;
		    }
			$Param{PM_Uploaded_Files} =~ s/\|$//;
	}
	#------------------------------------------------------
	$Param{To} = $Message{ToUser};

	&MyCompose;
}
#==========================================================
sub PrintMessage{
my (%Message, $Template, $Out);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	
	$Template = &TranslateFile($Global{PrintPrivMsgTemplate});
	$Out = &ParsePrivMsg($Template, $Param{Folder}, %Message);
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub SaveMessage{
my (%Message);

	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	#------------------------------------------------------
	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	%Message = &GetPrivMsgFull($Param{ID});
	
	# %Message, $ToFolder, $Status
	&PrivMsgCopyMsg($Message{User}, 3, 0, %Message);
	&ViewMessage;
}
#==========================================================
sub PrevMessage{

	&Check_Account_Login;
	&Check_PM_Status;
	$Param{ID} = &GetPrevPrivMsg($Param{ID});
	&ViewMessage;
}
#==========================================================
sub NextMessage{

	&Check_Account_Login;
	&Check_PM_Status;
	$Param{ID} = &GetNextPrivMsg($Param{ID});
	&ViewMessage;
}
#==========================================================
sub GetPrevPrivMsg{
my ($MsgID) = @_;
my (@List, $ID, $Counter);

	@List = &GetPrivMsgsBox($Param{User_ID}, $Param{Folder});

	for $Counter (0..$#List) {
			$ID = $List[$Counter];
			if ($ID == $MsgID) {
					$Counter--;
					if ($Counter < 0) {$Counter = $#List;}
					return $List[$Counter];
					last;
			}
	}
	
	return $MsgID;
}
#==========================================================
sub GetNextPrivMsg{
my ($MsgID) = @_;
my (@List, $ID, $Counter);

	@List = &GetPrivMsgsBox($Param{User_ID}, $Param{Folder});

	for $Counter (0..$#List) {
			$ID = $List[$Counter];
			if ($ID == $MsgID) {
					$Counter++;
					if ($Counter > $#List) {
							$Counter  = 0;
					}
					return $List[$Counter];
					last;
			}
	}
	
	return $MsgID;
}
#==========================================================
sub ProcessDeletePrivMsg{
my ($ID) = @_;

	$Query = qq!DELETE FROM PrivMsgs WHERE ID=$ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM PrivMsgsBody WHERE ID=$ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DeleteMessage{
my ($DeleteID);

	&Check_Account_Login;
	&Check_PM_Status;
	#------------------------------------------------------
	$DeleteID = $Param{ID};
	$Param{ID} = &GetNextPrivMsg($Param{ID});

	&ProcessDeletePrivMsg($Param{ID});

	if ($DeleteID == $Param{ID}) {
			$Param{ID} = &GetPrevPrivMsg($Param{ID});
	}
	
	if ($DeleteID == $Param{ID}) {
			&MyInbox;
			return;
	}
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	if ($Param{Folder} == 0) {
			&MyInbox;
	}
	elsif ($Param{Folder} == 1) {
			&MyOutbox;
	}
	elsif ($Param{Folder} == 2) {
			&MySentbox;
	}
	elsif ($Param{Folder} == 3) {
			&MySavedbox;
	}
	elsif ($Param{Folder} == 4) {
			&MyDraftsbox;
	}
	else {
			&MyInbox;
	}
	#------------------------------------------------------

	&ViewMessage;
}
#==========================================================
sub PrivMsgPagesNumbers{
my ($CurrentPage, $Last_Page) = @_;
my ($TotalPages, %Pages, $Count, $Div, $Page);
my ($LtPage, $RtPage, @Pages);

	if ($Last_Page <= 25) {$Div = 1;}
	elsif ($Last_Page > 25 && $Last_Page <= 50) {$Div = 2;}
	elsif ($Last_Page > 50 && $Last_Page <= 75) {$Div = 3;}
	elsif ($Last_Page > 75 && $Last_Page <= 100) {$Div = 4;}
	elsif ($Last_Page > 100 && $Last_Page <= 250) {$Div = 5;}
	elsif ($Last_Page > 250 && $Last_Page <= 500) {$Div = 10;}
	elsif ($Last_Page > 500 && $Last_Page <= 1000) {$Div = 20;}
	elsif ($Last_Page > 1000 && $Last_Page <= 2500) {$Div = 40;}
	elsif ($Last_Page > 2500 && $Last_Page <= 5000) {$Div = 100;}
	elsif ($Last_Page > 5000 && $Last_Page <= 7500) {$Div = 150;}
	elsif ($Last_Page > 7500 && $Last_Page <= 10000) {$Div = 200;}
	elsif ($Last_Page > 10000) {$Div = 250;}
	
	$TotalPages = int($Last_Page / $Div);

	undef %Pages;
	for $Count(1..$TotalPages) {
		$Page = $Count * $Div;
		$Pages{$Page} = 1;
	}

	$LtPage = $CurrentPage-5;
	$RtPage = $CurrentPage+5;
	
	if ($LtPage < 1 ) {$LtPage = 1;}

	if ($RtPage > $Last_Page) {$RtPage = $Last_Page;}

	for $Page($LtPage..$RtPage) {
			$Pages{$Page} = 1;
	}
	
	@Pages = sort {$a <=> $b} keys %Pages;
	return @Pages;
}
#==========================================================
sub PrivMsgsSelectedAction{
my (%Messages, $Temp, $ID, @Messages);

	#------------------------------------------------------
	undef %Messages;
	while (($Temp, $ID) = each %Param) {
			if ($Temp =~ /^Mark\_/) {
				$Messages{$ID} =  1;
			}
	}
	@Messages = keys %Messages;

	if ($Param{DeleteMessages}) {
			foreach $ID (@Messages) {
					&ProcessDeletePrivMsg($ID);
			}
	}

	if ($Param{ReadMessages}) {
			foreach $ID (@Messages) {
					&PrivMsgMarkRead($ID);
			}
	}

	if ($Param{UnreadMessages}) {
			foreach $ID (@Messages) {
					&PrivMsgMarkUnRead($ID);
			}
	}
	#------------------------------------------------------
	# Folder type: Inbox=0, Outbox=1, Sentbox=2, Savedbox=3, Draftsbox=4
	if ($Param{Folder} == 0) {
			&MyInbox;
	}
	elsif ($Param{Folder} == 1) {
			&MyOutbox;
	}
	elsif ($Param{Folder} == 2) {
			&MySentbox;
	}
	elsif ($Param{Folder} == 3) {
			&MySavedbox;
	}
	elsif ($Param{Folder} == 4) {
			&MyDraftsbox;
	}
	else {
			&MyInbox;
	}
	#------------------------------------------------------

}
#==========================================================
sub Check_PM_Status{
	
	if ($Global{PM_Status}) {return;}
	#------------------------------------------------------
	$Plugins{PrivMsgNav} = &Translate($Global{PrivMsgNav});
	$Plugins{Body} = $Language{pm_admin_disabled};
	&Display($Global{AccountManagerTemplate});
	&Quit;
}
#==========================================================
sub GetUserInboxUnReadCount{
my ($User) = @_;
my ($Query, $sth, $Count);
	
	$User = $dbh->quote($User);
	$Query = qq!SELECT Count(*) FROM PrivMsgs WHERE Status=0 AND User=$User AND Folder=0!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	($Count) = $sth->fetchrow_array;
	return $Count;
}
#==========================================================
sub GetUserInboxTotalCount{
my ($User) = @_;
my ($Query, $sth, $Count);
	
	$User = $dbh->quote($User);
	$Query = qq!SELECT Count(*) FROM PrivMsgs WHERE ToUser=$User AND Folder=0!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	($Count) = $sth->fetchrow_array;
	return $Count;
}
#==========================================================

1;
