=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub PrivMsgsOptions{
my ($Message) = @_;
my ($Help, $Out);

	$Help = &Help_Link("PrivMsgs_Options");
	$Out = &PrivMsgsOptionsForm($Message);
	&Print_Page($Out, "Private Messages Options", $Help);
}
#==========================================================
sub PrivMsgsOptionsForm{
my ($Message) = @_;
my (%HTM, $Out, $Sig_Treat_HTML, $Avatar_Allow_File_Upload);

	#----------------------------------------------------------------
	%HTM = (
			Show_Code => "Disable All HTML",
			Show_Safe_Code => "Allow Safe HTML",
			Remove_Code => "Remove All HTML",
			Show_HTML => "Allow All HTML"
		);
	
	$PM_Treat_HTML = "";
	foreach $Key  (sort keys %HTM) {
				$Selected = "";
				if ($Key eq $Global{PM_Treat_HTML}) {$Selected = "selected";}
				$PM_Treat_HTML .= qq!<option value="$Key" $Selected>$HTM{$Key}</option>!;
	}
	#----------------------------------------------------------------
	#----------------------------------------------------------------
	$PM_Status = &OptionYesNo($Global{PM_Status});
	$PM_Allow_File_Upload = &OptionYesNo($Global{PM_Allow_File_Upload});
	$PM_Upload_Any_File = &OptionYesNo($Global{PM_Upload_Any_File});
	#----------------------------------------------------------------
#<table width="100%"  cellspacing="0" cellpadding="3" class="TableAttr">
#<tr><td colspan="2" class="TableHeader" align="center">Create New Theme</td></tr>
#    <tr><td class="TableCell" nowrap>Copy from theme: </td><td class="TableCell" width="100%"><select size="1" name="CopyFromTheme">$Themes</select></td></tr>

$Out=<<HTML;
<p align="center"><font color="red" size="3"><b>$Message</b></font></p>

<form method="post" action="$ScriptURL">
  <input type="hidden" name="action" value="SavePrivMsgsOptions">

  <table width="100%"  cellspacing="0" cellpadding="2" class="TableAttr">

    <tr><td class="TableCell">Enable Private Messages System:</td><td class="TableCell"><select size="1" name="PM_Status">$PM_Status</select></td></tr>
    <tr><td class="TableCell">Messages HTML Manipulation:</td><td class="TableCell"><select size="1" name="PM_Treat_HTML">$PM_Treat_HTML</select></td></tr>
	<tr><td class="TableCell">Title Maximum Size:</td><td class="TableCell"><input type="text" name="PM_Max_Title_Length" size="10" value="$Global{PM_Max_Title_Length}"> Bytes</td></tr>
	<tr><td class="TableCell">Message Maximum Size:</td><td class="TableCell"><input type="text" name="PM_Max_Len" size="10" value="$Global{PM_Max_Len}"> Bytes</td></tr>
	<tr><td class="TableCell">Maximum TO Users:</td><td class="TableCell"><input type="text" name="PM_Max_To" size="10" value="$Global{PM_Max_To}"> </td></tr>
	<tr><td class="TableCell">Default Messages Per Page:</td><td class="TableCell"><input type="text" name="Messages_Per_Page" size="10" value="$Global{Messages_Per_Page}"> </td></tr>

	<tr><td class="TableCell">Maximum Inbox Messages:</td><td class="TableCell"><input type="text" name="PM_Max_Inbox" size="10" value="$Global{PM_Max_Inbox}"> </td></tr>
	<tr><td class="TableCell">Maximum Sentbox Messages:</td><td class="TableCell"><input type="text" name="PM_Max_Sentbox" size="10" value="$Global{PM_Max_Sentbox}"> </td></tr>
	<tr><td class="TableCell">Maximum Saved Messages:</td><td class="TableCell"><input type="text" name="PM_Max_Savedbox" size="10" value="$Global{PM_Max_Savedbox}"> </td></tr>
	<tr><td class="TableCell">Maximum Drafts Messages:</td><td class="TableCell"><input type="text" name="PM_Max_Draftsbox" size="10" value="$Global{PM_Max_Draftsbox}"> </td></tr>

    <tr><td class="TableCell" valign="top">Listing Date Format:</td><td class="TableCell"><input type="text" name="PM_ListDateFormat" size="65" value="$Global{PM_ListDateFormat}">
		<br><b>HR:</b> Hour 0-23 - <b>HH:</b> Hour 1-12 - <b>MM:</b> Minute 0-59 - <b>SS:</b> Second 0-59 - <b>AP:</b> AM/PM<br><b>MON:</b> Month 1-12 - <b>MD:</b> Day 1-31- <b>WD:</b> Weekday - <b>MONTH:</b> Month Name- <b>YY</b>: Year  - <b>YYYY</b>: Year
	</td></tr>

    <tr><td class="TableCell" valign="top">Message Date Format:</td><td class="TableCell"><input type="text" name="PM_MsgDateFormat" size="65" value="$Global{PM_MsgDateFormat}">
		<br><b>HR:</b> Hour 0-23 - <b>HH:</b> Hour 1-12 - <b>MM:</b> Minute 0-59 - <b>SS:</b> Second 0-59 - <b>AP:</b> AM/PM<br><b>MON:</b> Month 1-12 - <b>MD:</b> Day 1-31- <b>WD:</b> Weekday - <b>MONTH:</b> Month Name- <b>YY</b>: Year  - <b>YYYY</b>: Year
	</td></tr>

	<tr><td class="TableCell">Allow Users to Attach Files</td><td class="TableCell"><select size="1" name="PM_Allow_File_Upload">$PM_Allow_File_Upload</select></td></tr>
	<tr><td class="TableCell">Maximum Number of Files Allowed to Attach:</td><td class="TableCell"><input type="text" name="PM_Max_Upload_Files" size="10" value="$Global{PM_Max_Upload_Files}"></td></tr>
	<tr><td class="TableCell">Maximum Attached File Size (Per File):</td><td class="TableCell"><input type="text" name="PM_Max_Upload_File_Size" size="10" value="$Global{PM_Max_Upload_File_Size}"> KB</td></tr>
	<tr><td class="TableCell">Maximum Attached Combined Total Files Size</td><td class="TableCell"><input type="text" name="PM_Max_Upload_Size" size="10" value="$Global{PM_Max_Upload_Size}"> KB</td></tr>
	<tr><td class="TableCell">Allow any File Type to Attach:</td><td class="TableCell"><select size="1" name="PM_Upload_Any_File">$PM_Upload_Any_File</select></td></tr>
	<tr><td valign="top" class="TableCell">Files Extensions Allowed: <br>Separate by a Space</td><td class="TableCell"><textarea name="PM_Files_Ext_Allowed" rows="5" cols="55">$Global{PM_Files_Ext_Allowed}</textarea></td></tr>
	
	<tr><td class="TableCell" colspan="2" align="center">
		<input type="submit" value="Save Changes">&nbsp;&nbsp;
		<input type="reset" value="Reset" name="Reset">
	</td></tr>

</table>
</form>
<br>
HTML

	return $Out;
}
#==========================================================
sub SavePrivMsgsOptions{
my (%Config, $Key);

	undef %Config;

	$Config{PM_Status} = $Param{PM_Status};
	$Config{PM_Treat_HTML} = $Param{PM_Treat_HTML};
	$Config{PM_Max_Title_Length} = $Param{PM_Max_Title_Length};
	$Config{PM_Max_Len} = $Param{PM_Max_Len};
	$Config{PM_Max_To} = $Param{PM_Max_To};
	$Config{Messages_Per_Page} = $Param{Messages_Per_Page};
	$Config{PM_ListDateFormat} = $Param{PM_ListDateFormat};
	$Config{PM_MsgDateFormat} = $Param{PM_MsgDateFormat};
	$Config{PM_Allow_File_Upload} = $Param{PM_Allow_File_Upload};
	$Config{PM_Upload_Any_File} = $Param{PM_Upload_Any_File};
	
	$Config{PM_Max_Upload_Files} = $Param{PM_Max_Upload_Files};
	$Config{PM_Max_Upload_File_Size} = $Param{PM_Max_Upload_File_Size};
	$Config{PM_Max_Upload_Size} = $Param{PM_Max_Upload_Size};

	$Param{PM_Files_Ext_Allowed} =~ s/\cM|\n|\r//g;
	$Config{PM_Files_Ext_Allowed} = $Param{PM_Files_Ext_Allowed};

	$Config{PrivMsg_Notify_Email} = $Param{PrivMsg_Notify_Email};

	$Config{PM_Max_Inbox} = $Param{PM_Max_Inbox};
	$Config{PM_Max_Sentbox} = $Param{PM_Max_Sentbox};
	$Config{PM_Max_Savedbox} = $Param{PM_Max_Savedbox};
	$Config{PM_Max_Draftsbox} = $Param{PM_Max_Draftsbox};
	#----------------------------------------------------------
	&UpdateConfiguration(%Config);

	foreach $Key (keys %Config) {
			$Global{$Key} = $Config{$Key};
	}

	&PrivMsgsOptions("Private Messages Options Successfully Saved");
}
#==========================================================

1;