=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut

#Taken from HTML::Entities
%entity2char = (
 # Some normal chars that have special meaning in SGML context
# amp    => '&',  # ampersand 
#'gt'    => '>',  # greater than
#'lt'    => '<',  # less than
# quot   => '"',  # double quote
# apos   => "'",  # single quote

 # PUBLIC ISO 8879-1986//ENTITIES Added Latin 1//EN//HTML
 AElig	=> chr(198),  # capital AE diphthong (ligature)
 Aacute	=> chr(193),  # capital A, acute accent
 Acirc	=> chr(194),  # capital A, circumflex accent
 Agrave	=> chr(192),  # capital A, grave accent
 Aring	=> chr(197),  # capital A, ring
 Atilde	=> chr(195),  # capital A, tilde
 Auml	=> chr(196),  # capital A, dieresis or umlaut mark
 Ccedil	=> chr(199),  # capital C, cedilla
 ETH	=> chr(208),  # capital Eth, Icelandic
 Eacute	=> chr(201),  # capital E, acute accent
 Ecirc	=> chr(202),  # capital E, circumflex accent
 Egrave	=> chr(200),  # capital E, grave accent
 Euml	=> chr(203),  # capital E, dieresis or umlaut mark
 Iacute	=> chr(205),  # capital I, acute accent
 Icirc	=> chr(206),  # capital I, circumflex accent
 Igrave	=> chr(204),  # capital I, grave accent
 Iuml	=> chr(207),  # capital I, dieresis or umlaut mark
 Ntilde	=> chr(209),  # capital N, tilde
 Oacute	=> chr(211),  # capital O, acute accent
 Ocirc	=> chr(212),  # capital O, circumflex accent
 Ograve	=> chr(210),  # capital O, grave accent
 Oslash	=> chr(216),  # capital O, slash
 Otilde	=> chr(213),  # capital O, tilde
 Ouml	=> chr(214),  # capital O, dieresis or umlaut mark
 THORN	=> chr(222),  # capital THORN, Icelandic
 Uacute	=> chr(218),  # capital U, acute accent
 Ucirc	=> chr(219),  # capital U, circumflex accent
 Ugrave	=> chr(217),  # capital U, grave accent
 Uuml	=> chr(220),  # capital U, dieresis or umlaut mark
 Yacute	=> chr(221),  # capital Y, acute accent
 aacute	=> chr(225),  # small a, acute accent
 acirc	=> chr(226),  # small a, circumflex accent
 aelig	=> chr(230),  # small ae diphthong (ligature)
 agrave	=> chr(224),  # small a, grave accent
 aring	=> chr(229),  # small a, ring
 atilde	=> chr(227),  # small a, tilde
 auml	=> chr(228),  # small a, dieresis or umlaut mark
 ccedil	=> chr(231),  # small c, cedilla
 eacute	=> chr(233),  # small e, acute accent
 ecirc	=> chr(234),  # small e, circumflex accent
 egrave	=> chr(232),  # small e, grave accent
 eth	=> chr(240),  # small eth, Icelandic
 euml	=> chr(235),  # small e, dieresis or umlaut mark
 iacute	=> chr(237),  # small i, acute accent
 icirc	=> chr(238),  # small i, circumflex accent
 igrave	=> chr(236),  # small i, grave accent
 iuml	=> chr(239),  # small i, dieresis or umlaut mark
 ntilde	=> chr(241),  # small n, tilde
 oacute	=> chr(243),  # small o, acute accent
 ocirc	=> chr(244),  # small o, circumflex accent
 ograve	=> chr(242),  # small o, grave accent
 oslash	=> chr(248),  # small o, slash
 otilde	=> chr(245),  # small o, tilde
 ouml	=> chr(246),  # small o, dieresis or umlaut mark
 szlig	=> chr(223),  # small sharp s, German (sz ligature)
 thorn	=> chr(254),  # small thorn, Icelandic
 uacute	=> chr(250),  # small u, acute accent
 ucirc	=> chr(251),  # small u, circumflex accent
 ugrave	=> chr(249),  # small u, grave accent
 uuml	=> chr(252),  # small u, dieresis or umlaut mark
 yacute	=> chr(253),  # small y, acute accent
 yuml	=> chr(255),  # small y, dieresis or umlaut mark

 # Some extra Latin 1 chars that are listed in the HTML3.2 draft (21-May-96)
 copy   => chr(169),  # copyright sign
 reg    => chr(174),  # registered sign
 nbsp   => chr(160),  # non breaking space

 # Additional ISO-8859/1 entities listed in rfc1866 (section 14)
 iexcl  => chr(161),
 cent   => chr(162),
 pound  => chr(163),
 curren => chr(164),
 yen    => chr(165),
 brvbar => chr(166),
 sect   => chr(167),
 uml    => chr(168),
 ordf   => chr(170),
 laquo  => chr(171),
'not'   => chr(172),    # not is a keyword in perl
 shy    => chr(173),
 macr   => chr(175),
 deg    => chr(176),
 plusmn => chr(177),
 sup1   => chr(185),
 sup2   => chr(178),
 sup3   => chr(179),
 acute  => chr(180),
 micro  => chr(181),
 para   => chr(182),
 middot => chr(183),
 cedil  => chr(184),
 ordm   => chr(186),
 raquo  => chr(187),
 frac14 => chr(188),
 frac12 => chr(189),
 frac34 => chr(190),
 iquest => chr(191),
'times' => chr(215),    # times is a keyword in perl
 divide => chr(247),

 ( $] > 5.007 ? (
  'OElig;'    => chr(338),
  'oelig;'    => chr(339),
  'Scaron;'   => chr(352),
  'scaron;'   => chr(353),
  'Yuml;'     => chr(376),
  'fnof;'     => chr(402),
  'circ;'     => chr(710),
  'tilde;'    => chr(732),
  'Alpha;'    => chr(913),
  'Beta;'     => chr(914),
  'Gamma;'    => chr(915),
  'Delta;'    => chr(916),
  'Epsilon;'  => chr(917),
  'Zeta;'     => chr(918),
  'Eta;'      => chr(919),
  'Theta;'    => chr(920),
  'Iota;'     => chr(921),
  'Kappa;'    => chr(922),
  'Lambda;'   => chr(923),
  'Mu;'       => chr(924),
  'Nu;'       => chr(925),
  'Xi;'       => chr(926),
  'Omicron;'  => chr(927),
  'Pi;'       => chr(928),
  'Rho;'      => chr(929),
  'Sigma;'    => chr(931),
  'Tau;'      => chr(932),
  'Upsilon;'  => chr(933),
  'Phi;'      => chr(934),
  'Chi;'      => chr(935),
  'Psi;'      => chr(936),
  'Omega;'    => chr(937),
  'alpha;'    => chr(945),
  'beta;'     => chr(946),
  'gamma;'    => chr(947),
  'delta;'    => chr(948),
  'epsilon;'  => chr(949),
  'zeta;'     => chr(950),
  'eta;'      => chr(951),
  'theta;'    => chr(952),
  'iota;'     => chr(953),
  'kappa;'    => chr(954),
  'lambda;'   => chr(955),
  'mu;'       => chr(956),
  'nu;'       => chr(957),
  'xi;'       => chr(958),
  'omicron;'  => chr(959),
  'pi;'       => chr(960),
  'rho;'      => chr(961),
  'sigmaf;'   => chr(962),
  'sigma;'    => chr(963),
  'tau;'      => chr(964),
  'upsilon;'  => chr(965),
  'phi;'      => chr(966),
  'chi;'      => chr(967),
  'psi;'      => chr(968),
  'omega;'    => chr(969),
  'thetasym;' => chr(977),
  'upsih;'    => chr(978),
  'piv;'      => chr(982),
  'ensp;'     => chr(8194),
  'emsp;'     => chr(8195),
  'thinsp;'   => chr(8201),
  'zwnj;'     => chr(8204),
  'zwj;'      => chr(8205),
  'lrm;'      => chr(8206),
  'rlm;'      => chr(8207),
  'ndash;'    => chr(8211),
  'mdash;'    => chr(8212),
  'lsquo;'    => chr(8216),
  'rsquo;'    => chr(8217),
  'sbquo;'    => chr(8218),
  'ldquo;'    => chr(8220),
  'rdquo;'    => chr(8221),
  'bdquo;'    => chr(8222),
  'dagger;'   => chr(8224),
  'Dagger;'   => chr(8225),
  'bull;'     => chr(8226),
  'hellip;'   => chr(8230),
  'permil;'   => chr(8240),
  'prime;'    => chr(8242),
  'Prime;'    => chr(8243),
  'lsaquo;'   => chr(8249),
  'rsaquo;'   => chr(8250),
  'oline;'    => chr(8254),
  'frasl;'    => chr(8260),
  'euro;'     => chr(8364),
  'image;'    => chr(8465),
  'weierp;'   => chr(8472),
  'real;'     => chr(8476),
  'trade;'    => chr(8482),
  'alefsym;'  => chr(8501),
  'larr;'     => chr(8592),
  'uarr;'     => chr(8593),
  'rarr;'     => chr(8594),
  'darr;'     => chr(8595),
  'harr;'     => chr(8596),
  'crarr;'    => chr(8629),
  'lArr;'     => chr(8656),
  'uArr;'     => chr(8657),
  'rArr;'     => chr(8658),
  'dArr;'     => chr(8659),
  'hArr;'     => chr(8660),
  'forall;'   => chr(8704),
  'part;'     => chr(8706),
  'exist;'    => chr(8707),
  'empty;'    => chr(8709),
  'nabla;'    => chr(8711),
  'isin;'     => chr(8712),
  'notin;'    => chr(8713),
  'ni;'       => chr(8715),
  'prod;'     => chr(8719),
  'sum;'      => chr(8721),
  'minus;'    => chr(8722),
  'lowast;'   => chr(8727),
  'radic;'    => chr(8730),
  'prop;'     => chr(8733),
  'infin;'    => chr(8734),
  'ang;'      => chr(8736),
  'and;'      => chr(8743),
  'or;'       => chr(8744),
  'cap;'      => chr(8745),
  'cup;'      => chr(8746),
  'int;'      => chr(8747),
  'there4;'   => chr(8756),
  'sim;'      => chr(8764),
  'cong;'     => chr(8773),
  'asymp;'    => chr(8776),
  'ne;'       => chr(8800),
  'equiv;'    => chr(8801),
  'le;'       => chr(8804),
  'ge;'       => chr(8805),
  'sub;'      => chr(8834),
  'sup;'      => chr(8835),
  'nsub;'     => chr(8836),
  'sube;'     => chr(8838),
  'supe;'     => chr(8839),
  'oplus;'    => chr(8853),
  'otimes;'   => chr(8855),
  'perp;'     => chr(8869),
  'sdot;'     => chr(8901),
  'lceil;'    => chr(8968),
  'rceil;'    => chr(8969),
  'lfloor;'   => chr(8970),
  'rfloor;'   => chr(8971),
  'lang;'     => chr(9001),
  'rang;'     => chr(9002),
  'loz;'      => chr(9674),
  'spades;'   => chr(9824),
  'clubs;'    => chr(9827),
  'hearts;'   => chr(9829),
  'diams;'    => chr(9830),
 ) : ())
);

my (%char2entity);
# Make the opposite mapping
while (my($entity, $char) = each(%entity2char)) {
    $entity =~ s/;\z//;
    $char2entity{$char} = "&$entity;";
}

my $entities_chars = join "|", values %entity2char;
#==========================================================
&ModLoad("Encode");
#==========================================================
sub RSS {
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst);
my ($doc, $Query, $pubDate, @Forums, $Forums, $sth, @Posts);
my ($Post, %Post, %Topic, %Media, %Message, $Title, $Description);
my ($Images, @Media, @Upload, $File, $Temp, $Enclosure);
my (@Months) = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );
my (@Weekday) = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" );

	$ScriptURL = $Global{ProgURL};
    #------------------------------------------------------------------------------------
	$| = 1;
    #------------------------------------------------------------------------------------
	#Content-Type: text/xml; charset=utf-8
	#<?xml version="1.0" encoding="utf-8"?>
	#print "Content-type: application/rss+xml\n\n";
	#print "Content-type: text/xml; charset:ISO-8859-1;\n\n";
	print "$Language{rss_content_type}\n\n";
    #------------------------------------------------------------------------------------
	#Wiring Up the XSL Stylesheet to the Site's Feed
	#<?xml-stylesheet type="text/xsl" href="urlToXSLstyleSheet" version="1.0"?>  
    #------------------------------------------------------------------------------------
	#&ModLoad("XML::Writer");
	use Writer;
    #------------------------------------------------------------------------------------
	$doc = new XML::Writer(UNSAFE=> 0, NAMESPACES => 0, NEWLINES => 0, 
								ENCODING => "",
													PREFIX_MAP => {
																						"http://purl.org/rss/1.0/modules/content/" => 'xmlns:content',
																					"http://purl.org/dc/elements/1.1/" =>'xmlns:dc'
																					}
														);
	$doc->setDataMode(1);
	$doc->setDataIndent(2);
    #------------------------------------------------------------------------------------
	# Allowed: 'US-ASCII', 'ISO-8859-1', 'ISO-8859-2', 'ISO-8859-5', 'ISO-8859-7', 'ISO-8859-9', 'SHIFT_JIS', 'EUC-JP', 'GB2312', 
	# 'EUC-KR', 'BIG5', 'WINDOWS-1250', 'WINDOWS-1251', 'UTF-8', 'X-MAC-ROMAN'.
	# available: us-ascii or utf-8
	# <?xml version="1.0" encoding="ISO-8859-1" ?> 
	$doc->xmlDecl($Language{rss_encoding});
    #------------------------------------------------------------------------------------
    #------------------------------------------------------------------------------------
	$doc->startTag( "rss",
								"version"      => '2.0',
								'xmlns:dc'      => 'http://purl.org/dc/elements/1.1/',
								'xmlns:content' => 'http://purl.org/rss/1.0/modules/content/',
								
								);

	$doc->startTag("channel");
	$doc->dataElement(title => $Language{rss_title});
	#----------------------------------------------
    $Query = "";
	if ($ENV{CONTENT_LENGTH} ) {
				read(STDIN, $Query, $ENV{CONTENT_LENGTH});
    } 
	elsif ($ENV{QUERY_STRING}) {
			$Query = $ENV{QUERY_STRING};
    }
	
	#The link element identifies the URL of the web site associated with the channel (required).
	$doc->dataElement(link => "$Global{ProgURL}$Query");

	#The description element provides a human-readable characterization or summary of the channel (required). 
	$doc->dataElement(description => $Language{rss_description});

    # The channel's language element identifies the natural language employed in the channel (optional).
	$doc->dataElement(language => $Language{rss_language}) if ($Language{rss_language});

    #The copyright element declares the human-readable copyright statement that applies to the channel (optional).
	$doc->dataElement(copyright => $Language{rss_copyright}) if ($Language{rss_copyright});
	#----------------------------------------------
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime(time);
	$sec = sprintf("%02d", $sec);
	$min = sprintf("%02d", $min);
	$hour = sprintf("%02d", $hour);
	$mon = sprintf("%02d", $mon);
	$mday = sprintf("%02d", $mday);
	$year += 1900;
	# <pubDate>Sun, 19 May 2002 15:21:36 GMT</pubDate>
	$pubDate = qq!$Weekday[$wday], $mday $Months[$mon] $year $hour\:$min\:$sec GMT!;
	#----------------------------------------------
	#The channel's pubDate element indicates the publication date of the channel's content (optional).
	$doc->dataElement(pubDate => $pubDate);

    #The channel's lastBuildDate element indicates the last date and time the content of the channel was updated (optional).
	$doc->dataElement(lastBuildDate => $pubDate);

    # managing editor
	$doc->dataElement(managingEditor => $Language{rss_managingeditor}) if ($Language{rss_managingeditor});

    #The channel's webMaster element provides the e-mail address of the person to contact about technical issues regarding the channel (optional). 
	$doc->dataElement(webMaster => $Language{rss_webmaster}) if ($Language{rss_webmaster});

    #The category element identifies a category or tag to which the channel belongs (optional).
	$doc->dataElement(category => $Language{rss_category}) if ($Language{rss_category});

    # The generator element credits the software that created the channel (optional).
	$doc->dataElement(generator => $Language{rss_generator}) if ($Language{rss_generator});

    #The channel's ttl element represents the channel's time to live: the number of minutes it can be cached before another request should be made by an aggregator (optional).
	if ($Language{rss_ttl} ne "") {$Language{rss_ttl} += 0; $Language{rss_ttl} = int($Language{rss_ttl});}
	$doc->dataElement(ttl => $Language{rss_ttl}) if ($Language{rss_ttl});
	#--------------------------------------------------------------------------------------
	$Param{Limit} += 0;
	$Param{Limit} = int($Param{Limit});
	if ($Param{Limit} < 1) {$Param{Limit} = 20;}

	$Paramx{Forum} =~ s/\|\|/\,/g;
	$Paramx{Forum} =~ s/[^\d\,]//g;
	@Forums = split(/\,/, $Paramx{Forum});
	if (@Forums) {
			$Forums = "WHERE Forum IN (" . join (",", @Forums) . ")";
	}
	else {
			$Forums = "";
	}

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT TOP $Param{Limit} Post FROM Forum_Posts $Forums ORDER BY TIME DESC!;
	}
	else{
			$Query = qq!SELECT Post FROM Forum_Posts $Forums ORDER BY TIME DESC LIMIT $Param{Limit}!;
	}
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Posts;
	while(($Post) = $sth->fetchrow_array) {
			push @Posts, $Post;
	}
	$sth->finish;
	#--------------------------------------------------------------------------------------
	#--------------------------------------------------------------------------------------
	foreach $Post (@Posts) {
			%Post = &GetForumPost($Post);
			%Topic = &GetForumTopic($Post{Topic});
			%Media = &GetForumPostMedia($Post);
			%Message = &GetForumMessage($Post);
			#%User = &GetForumUser($Post{Author});
			#----------------------------------------------
			$Post{Time} ||= time;
			($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime($Post{Time});
			$sec = sprintf("%02d", $sec);
			$min = sprintf("%02d", $min);
			$hour = sprintf("%02d", $hour);
			$mon = sprintf("%02d", $mon);
			$mday = sprintf("%02d", $mday);
			$year += 1900;
			# <pubDate>Wed, 02 Oct 2002 13:00:00 GMT</pubDate>
			$pubDate = "$Weekday[$wday], $mday $Months[$mon] $year $hour\:$min\:$sec GMT";
			#----------------------------------------------
			#			Title
			#----------------------------------------------
			if ($Message{Subject}) {
					$Title = $Message{Subject};
			}
			else{
					$Title = $Topic{Title};
			}
			$Title || next;
			#------------------------------------------------------
			# Process syntax highlighting [perl] ..[/perl]
			$Description = &FormatMessage($Message{Message});
			$Description || next;
			#------------------------------------------------------
			$Link = qq!$Global{ProgURL}action=ViewPost&Post=$Post&Lang=$Global{Language}!;
			#------------------------------------------------------
			#$Profile = qq!$Global{ProgURL}action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
			#--------------------------------------------------------------------------------------
			#			Images
			#--------------------------------------------------------------------------------------
			$Images = ""; 
			undef @Media;
			if ($Media{Media}) {
					@Upload = split(/\|/, $Media{Media});
					foreach $File (@Upload) {
						if ($File =~ /\.gif|\.png|\.jpg|\.pjpeg|\.pjpg|\.jpeg|\.bmp$/i ) {
							push @Media, $File;
						}
					}
			}

			#<enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" /> 
			if (@Media) {
				$Temp = 0; $Images = ""; $Enclosure = "";
				foreach $File (@Media) {
						$Images .= qq!<br><img src="$Global{HTML_URL}/upload/$File">!;
						#$Temp++;
						#image/bmp, image/png, image/jpeg  jpeg,jpg,jpe,jfif,pjpeg,pjp, image/gif
						#if ($File =~ /\.gif$/i ) {$Temp1 = "image/gif";}
						#elsif ($File =~ /\.png$/i ) {$Temp1 = "image/png";}
						#elsif ($File =~ /\.bmp$/i ) {$Temp1 = "image/bmp";}
						#elsif ($File =~ /\.jpg|\.pjpeg|\.pjpg|\.jpeg$/i ) {$Temp1 = "image/jpeg";}
						#else {$Temp1 = "";}
						#$Size = -s "$Global{HTML_Dir}/upload/$File";
						#if ($Temp1 ne "" and $Enclosure eq "") {
						#		$Enclosure .= "<enclosure " . &EncodeRSS(qq!url="$Global{HTML_URL}/upload/$File" length="$Size" type="$Temp1"!). " />\n";
						#}
						#if ($Temp >= 5) {last;}
				}
			}
			#--------------------------------------------------------------------------------------
			# <enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" /> 
			#--------------------------------------------------------------------------------------
			$doc->startTag( "item");
				$doc->cdataElement(title => &SafeText($Title));
				$doc->dataElement(link => &SafeText($Link));
				$doc->dataElement(pubDate => &SafeText($pubDate));
				$doc->dataElement(guid => &SafeText($Link), isPermaLink=>"true");
				$doc->dataElement("dc:creator" => &SafeText($Post{Author}));
				#$doc->dataElement("author" => &SafeText($Post{Author}));
				$doc->cdataElement("description", &SafeText($Description . $Images));
			$doc->endTag(); # close item
			#--------------------------------------------------------------------------------------
	}
	#----------------------------------------------------------------------------------------------
	$doc->endTag(); # close channel
	$doc->endTag(); # close rss
	$doc->end(); # close document
	#----------------------------------------------------------------------------------------------
}
#==========================================================
#==========================================================
sub SafeText {
my ($Text) = @_;
	
	#use HTML::Entities qw (encode_entities encode_entities_numeric);
	#$Text = encode_entities_numeric($Text);
	#$Text = HTML::Entities::encode($Text);
	#$Text =~ s/([\200-\377])/'&#'.ord($1).';'/ge;
    #$Text =~ s{([\x00-\x08\x0B\x0C\x0E-\x1F\x7F])}{sprintf( '&#%d;', ord($1));}gex;
	
	$Text =~ s/(([\x00-\x08\x0B\x0C\x0E-\x1F\x7F]))/'&#'.ord($1).';'/ge;
	$Text =~ s/($entities_chars)/'&#'.ord($1).';'/ge;

	$Text = encode("utf8", $Text);

	return $Text;
}
#==========================================================
sub _escapeASCII($) {
my ($str) = shift;
  #$str =~ s/([^\x00-\x7F])/sprintf('&#x%X;', ord($1))/ge;
  $str =~ s/([^\x00-\x7F])/sprintf('&#%d;', ord($1))/ge;
  return $str;
}
#==========================================================
sub ExitT{
my ($Msg) = @_;
my ($Out);
	print "$Msg";
	if ($dbh) {&DB_Disconnect();}
	exit 0;
}
#==========================================================

1;