=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Register{
my ($Template, $Temp, $Temp1, $URL, %User);
my ($Field, %Fields, $Key, $Value);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	
	$Template =&TranslateFile($Global{RegisterTemplate});
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{register_menu_label};
	$Plugins{Menu_Bar} = "";
	#------------------------------------------------------
	$Param{Error} ||= "";
	if ($Param{Error}) {
			$Template =~ s/<!--Errors_Form-->/$Language{Errors_Form}/g;
	}
	$Template =~ s/<!--Error-->/$Param{Error}/;
	#------------------------------------------------------

	foreach $Field (@Pending_User_Fields) {
		if (!defined $Param{$Field}) {$Param{$Field} = "";}
	}

	%Fields = &GetRegisterSettings;
	#------------------------------------------------------
	push @Pending_User_Fields, "Agree";
	push @Pending_User_Fields, "SecurityCode";

	foreach $Field (@Pending_User_Fields) {
			$Key = $Field ."_Form";
			if ($Fields{$Field}{Register}) {$Value = $Language{$Key};} else {$Value = "";}
			$Template =~ s/<!--$Key-->/$Value/;
			$Template =~ s/<!--$Field-->/$Param{$Field}/;

			$Key = $Field ."_Required";
			if ($Fields{$Field}{Required}) {$Value = $Language{required};} else {$Value = "";}
			$Template =~ s/<!--$Key-->/$Value/g;
	}
	
	if ($Param{Agree}) {$Temp = "checked";} else {$Temp = "";}
	$Template =~ s/<!--AgreeBox-->/$Temp/g;
	#------------------------------------------------------
	$Param{SecurityCode} ||= "";
	$Template =~ s/<!--SecurityCode-->/$Param{SecurityCode}/g;
	$SecImgLink = &GetSecurityImage("BoardawyRegister");
	$Template =~ s/<!--SecurityImageLink-->/$SecImgLink/g;
	#------------------------------------------------------
	$Temp = "";
	if (!$Global{Auto_Approve_New_Users}) {
			$Temp = $Language{Register_Steps_Form};
	}
	$Template =~ s/<!--Register_Steps_Form-->/$Temp/g;
	#------------------------------------------------------
	$Param{Country} ||= $Global{Default_Item_Country};
	$Temp = &Country_List($Param{Country});;
	$Template =~ s/<!--Country_List-->/$Temp/;

	$Template =~ s/<!--User_ID-->/$Param{User_ID}/g;
	$Template =~ s/<!--Email-->/$Param{Email}/;
	$Template =~ s/<!--Password-->/$Param{Password}/;
	$Template =~ s/<!--PasswordVerify-->/$Param{PasswordVerify}/;

	if ($Global{SSL_Status}){
			$Temp = qq!$Global{SSL_URL}/$Global{MainProg}?action=Register&Lang=$Global{Language}!;
	}
	else{
			$Temp = qq!$Global{CGI_URL}/$Global{MainProg}?action=Register&Lang=$Global{Language}!;
	}

	$Template =~ s/<!--Action-->/$Temp/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Param{CC_IssueNum} ||= "00";	

	@CC_Fields = qw(
							CC_Number
							CC_Name
							CC_Type
							CC_Month
							CC_Year
							CC_CVV
							CC_IssueNum
							CC_Bank
							CC_Phone
							CC_Street
							CC_City
							CC_State
							CC_Zip
							CC_Country
							);
	
	if ($Global{Require_Credit_Card}) {
				$Temp = &TranslateFile($Global{CreditCardFormTemplate});
				$Template =~ s/<!--Credit_Card_Form-->/$Temp/;

				foreach $Field (@CC_Fields) {
						$Key = $Field ."_Form";
						if ($Fields{$Field}{Register}) {$Value = $Language{$Key};} else {$Value = "";}
						$Template =~ s/<!--$Key-->/$Value/;
						$Template =~ s/<!--$Field-->/$Param{$Field}/;

						$Key = $Field ."_Required";
						if ($Fields{$Field}{Required}) {$Value = $Language{required};} else {$Value = "";}
						$Template =~ s/<!--$Key-->/$Value/g;
				}


				if ($Param{CC_Type} =~ /visa/i) { 
							$Template =~ s/<!--CC_Visa-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /mastercard/i) { 
							$Template =~ s/<!--CC_MC-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /American/i) { 
							$Template =~ s/<!--CC_AmEx-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /novus/i || $Type =~ /discover/i) { 
							$Template =~ s/<!--CC_Discover-->/selected/;
				}
				elsif ($Type =~ /diner/i) { 
							$Template =~ s/<!--CC_DinerClub-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /enRoute/i) { 
							$Template =~ s/<!--CC_enRoute-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /JCB/i) { 
							$Template =~ s/<!--CC_JCB-->/selected/;
				}
				elsif ($Type =~ /BankCard/i) { 
							$Template =~ s/<!--CC_BankCard-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /Switch/i) { 
							$Template =~ s/<!--CC_Switch-->/selected/;
				}
				elsif ($Param{CC_Type} =~ /Solo/i) { 
							$Template =~ s/<!--CC_Solo-->/selected/;
				}
	
				$Template =~ s/<!--CC_Visa-->//;
				$Template =~ s/<!--CC_MC-->//;
				$Template =~ s/<!--CC_AmEx-->//;
				$Template =~ s/<!--CC_Discover-->//;
				$Template =~ s/<!--CC_DinerClub-->//;
				$Template =~ s/<!--CC_enRoute-->//;
				$Template =~ s/<!--CC_JCB-->//;
				$Template =~ s/<!--CC_BankCard-->//;
				$Template =~ s/<!--CC_Switch-->//;
				$Template =~ s/<!--CC_Solo-->//;
				#--------------------------------------------------------------
				for $x(1..12) {
						if ($Param{CC_Month} == $x) {$Temp = "selected";} else { $Temp = "";}
						$Key = "<!--CC_Month_" . $x . "-->";
						$Template =~ s/$Key/$Temp/;
				}

				for $x(4..50) {
						if ($Param{CC_Year} == $x) {$Temp = "selected";} else { $Temp = "";}
						$Key = "<!--CC_Year_" . $x . "-->";
						$Template =~ s/$Key/$Temp/;
				}
				#--------------------------------------------------------------

	}

	&Display($Template,1);
}
#==========================================================
sub Save_New_Account{
my ($Title, $Msg, $x, %Temp, $URL) ;
my (%User, $Status, $Field, $Code, $Subj);
my ($User_ID, $Password);

	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});

	if ($Global{SSL_Status}){
			$URL = qq!$Global{SSL_URL}/$Global{MainProg}!;
	}
	else{
			$URL = qq!$Global{CGI_URL}/$Global{MainProg}!;
	}

	$Msg = "";

	%Fields = &GetRegisterSettings;

	$Param{User_ID} = lc($Param{User_ID});
	$Param{User_ID} =~ s/\s+//g;
	$Param{User_ID} =~ s/\&lt;//g;
	$Param{User_ID} =~ s/\&gt;//g;

	if ($Param{User_ID} =~ m/([\s\:\,\?\/\\\+\=\-\)\(\*\^\%\$\!\>\<\"\'\~\`\{\}\|\[\]\#\&\;])/g){
					$Msg = $Language{choose_valid_id};
	}

	if ($Param{User_ID} =~ m/(\.\.)|(\@\@)|(\_\_)|(\-\-)/g){
					$Msg = $Language{choose_valid_id};
	}
	if ($Param{User_ID} =~ m/\.\@|\@\.|\.\_|\_\.|\-\-/g){
					$Msg = $Language{choose_valid_id};
	}

	if (!$Param{User_ID}){
			$Msg .= $Language{choose_valid_id};
	}
	else{
			if (length $Param{User_ID} < 3){
					$Msg .= $Language{choose_valid_id};
			}
	 }

	 if (&Check_User_ID_Available($Param{User_ID})) {
			$Param{Error} = $Language{error_registration_information} . $Language{user_id_taken};
			&Register;
			return ;
	}
	#------------------------------------------------------------
	if (!$Param{Password}) {
				$Msg .= $Language{error_valid_password};
	}
	else{
			if (length($Param{Password}) < 4) {
				$Msg .= $Language{error_password_length};
			}
	}

	if (!$Param{PasswordVerify}) {$Msg .= $Language{error_verify_password};}

	if ($Param{Password} &&  $Param{PasswordVerify}) {
			if ($Param{Password} ne  $Param{PasswordVerify}) {
					$Msg .= $Language{error_password_match};
			}
	}
	#------------------------------------------------------------
	if ($Fields{Email}{Register} && $Fields{Email}{Required}) {
			if (!$Param{Email}) {
					$Msg .= $Language{error_email};
			}
			else{
					if (! &Check_Email_Address($Param{Email})) {
							$Msg .= $Language{invalid_email};
					}
					else{
							 if (&Check_Email_Exist($Param{Email})) {
								 $Msg .= $Language{error_email_exists};
							}
					}
			}
	}
	#------------------------------------------------------------
	if (! &CheckBannedRegistrationEmail($Param{Email})) {
			$Msg .= $Language{banned_email};
	}
	#------------------------------------------------------------
	if ($Fields{FName}{Register} && $Fields{FName}{Required} && !$Param{FName}) {$Msg .= $Language{error_fname};}
	if ($Fields{LName}{Register} && $Fields{LName}{Required} && !$Param{LName}) {$Msg .= $Language{error_lname};}
	if ($Fields{Company}{Register} && $Fields{Company}{Required} && !$Param{Company}) {$Msg .= $Language{error_company};}
	if ($Fields{Street}{Register} && $Fields{Street}{Required} &&!$Param{Street}) {$Msg .= $Language{error_street};}
	if ($Fields{City}{Register} && $Fields{City}{Required} && !$Param{City}) {$Msg .= $Language{error_city};}
	if ($Fields{State}{Register} && $Fields{State}{Required} && !$Param{State}) {$Msg .= $Language{error_state};}
	if ($Fields{Zip}{Register} && $Fields{Zip}{Required} && !$Param{Zip}) {$Msg .= $Language{error_zip};}
	if ($Fields{Country}{Register} && $Fields{Country}{Country} && !$Param{Country}) {$Msg .= $Language{error_country};}
	if ($Fields{Phone}{Register} && $Fields{Phone}{Required} && !$Param{Phone}) {$Msg .= $Language{error_phone};}
	if ($Fields{Mobile}{Register} && $Fields{Mobile}{Required} && !$Param{Mobile}) {$Msg .= $Language{error_mobile};}
	if ($Fields{Fax}{Register} && $Fields{Fax}{Required} && !$Param{Fax}) {$Msg .= $Language{error_fax};}
	if ($Fields{Website}{Register} && $Fields{Website}{Required} && !$Param{Website}) {$Msg .= $Language{error_website};}
	if ($Fields{Job_Title}{Register} && $Fields{Job_Title}{Required} && !$Param{Job_Title}) {$Msg .= $Language{error_job_title};}
	if ($Fields{Agree}{Register} && $Fields{Agree}{Required} && !$Param{Agree}) {$Msg .= $Language{error_agree};}
	#----------------------------------------------------------------
	$Param{SecurityCode} = uc($Param{SecurityCode});
	if ($Fields{SecurityCode}{Register} && $Fields{SecurityCode}{Required} && !$Param{SecurityCode}) {$Msg .= $Language{error_security_code};}
	if ($Fields{SecurityCode}{Register} && $Fields{SecurityCode}{Required} && $Param{SecurityCode}){
		$Digest = md5_hex($Param{SecurityCode} . $Global{Secure_Key});
		if (!-e "$Global{HTML_Dir}/SecImg/$Digest\.jpg") {
			$Msg .= $Language{error_security_code};
		}
	}
	#----------------------------------------------------------------
	for $x (1..20) { #Custom fields
			$Key = "User" . $x;
			if ($Fields{$Key}{Register} && $Fields{$Key}{Required} && !$Param{$Key}) {
					$Key = "error_user" . $x;
					$Msg .= $Language{$Key};
			}
	}
	#----------------------------------------------------------
	# Require credit card for registration
	#----------------------------------------------------------
	if ($Global{Require_Credit_Card}){
				if ($Fields{CC_Name}{Register} && $Fields{CC_Name}{Required} && !$Param{CC_Name}) {$Msg .= $Language{error_cc_name};}
				if ($Fields{CC_Number}{Register} && $Fields{CC_Number}{Required} && !$Param{CC_Number}) {$Msg .= $Language{error_cc_number};}
				if ($Fields{CC_Street}{Register} && $Fields{CC_Street}{Required} && !$Param{CC_Street}) {$Msg .= $Language{error_cc_street};} 
				if ($Fields{CC_City}{Register} && $Fields{CC_City}{Required} && !$Param{CC_City}) {$Msg .= $Language{error_cc_city};}
				if ($Fields{CC_State}{Register} && $Fields{CC_State}{Required} && !$Param{CC_State}) {$Msg .= $Language{error_cc_state};}
				if ($Fields{CC_Zip}{Register} && $Fields{CC_Zip}{Required} && !$Param{CC_Zip}) {$Msg .= $Language{error_cc_zip};}
				if ($Fields{CC_Country}{Register} && $Fields{CC_Country}{Required} && !$Param{CC_Country}) {$Msg .= $Language{error_cc_country};}
				if ($Fields{CC_CVV}{Register} && $Fields{CC_CVV}{Required} && !$Param{CC_CVV}) {$Msg .= $Language{error_cc_cvv};}
				if ($Fields{CC_IssueNum}{Register} && $Fields{CC_IssueNum}{Required} && !$Param{CC_IssueNum}) {$Msg .= $Language{error_cc_issuenum};}
				
				if (!&Verify_Credit_Card($Param{CC_Type}, $Param{CC_Number})){$Msg .= $Language{invalid_cc_number};}
	}
	#------------------------------------------------------------
	# End of if Require_Credit_Card
	#----------------------------------------------------------
	if ($Msg) {
			$Param{Error} =  $Language{error_registration_information} . $Msg;
			&Register;
			return;
	}
	#------------------------------------------------------------
	$Param{Status} = "0";
	$Param{Start_Date} = &Time(time);
	$Param{Last_Updated} = $Param{Start_Date};
	#------------------------------------------------------------
	#            Save it now
	#------------------------------------------------------------
	undef %User;
	foreach $Field (@Pending_User_Fields) {
		if (!defined $Param{$Field}) {$Param{$Field} = "";}
		$User{$Field} = $Param{$Field};
	}

	$Code = &Get_Random_Password;
	$User{Confirmation_Code} = $Code;
	
	$Global{New_Users_Status} ||= 0;
	$User{Status} = $Global{New_Users_Status};
	#------------------------------------------------------------
	# Auto approve new users
	if ($Global{Auto_Approve_New_Users}) {
					&Add_New_User(%User);
					&Activate_New_User(%User);
					&UpdateSettings(NewestUser => $User{User_ID});

					$Plugins{Body} = $Language{auto_approved_registration_complete};
					$Temp = $User{FName};
					$Temp .= " ".$User{LName} if ($User{LName} ne "");
					$Plugins{Body} =~ s/<!--Name-->/$Temp/g;
					$Plugins{Body} =~ s/<!--FName-->/$User{FName}/g;
					$Plugins{Body} =~ s/<!--LName-->/$User{LName}/g;
					$Plugins{Body} =~ s/<!--Email-->/$User{Email}/g;
					&Display($Global{AccountManagerTemplate});
					return;
	}
	#------------------------------------------------------------
	# Save pending user
	#------------------------------------------------------------
	&Delete_Pending_User_By_Email($Param{Email});
	&Add_New_Pending_User(%User);
	#----------------------------------------------------------------
	unlink "$Global{HTML_Dir}/SecImg/$Digest\.jpg";
	#----------------------------------------------------------------
	$User_ID = $Param{User_ID};
	$Password = $Param{Password};
	&ReadClasses; #Read classes will load the logged in user ID and password to $Param{User_ID}, $Param{Password}
	
	$Msg = &Translate_Classes(&Translate($Language{pre_registration_email_message}));
	$Temp = $Param{FName};
	$Temp .= " ".$Param{LName} if ($Param{LName} ne "");
	$Msg =~ s/<!--Name-->/$Temp/g;
	$Msg =~ s/<!--FName-->/$User{FName}/g;
	$Msg =~ s/<!--LName-->/$User{LName}/g;
	$Msg =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Msg =~ s/<!--Email-->/$User{Email}/g;

	$Msg =~ s/<!--Confirmation_Code-->/$Code/g;
	$Temp = qq!$URL?action=ConfirmRegistration&Email=$Param{Email}&Code=$Code!;
	$Msg =~ s/<!--Confirmation_URL-->/$Temp/g;

	$Subj = &Translate_Classes(&Translate($Language{pre_registration_email_subject}));
	$Temp = $Param{FName};
	$Temp .= " ".$Param{LName} if ($Param{LName} ne "");
	$Subj =~ s/<!--Name-->/$Temp/g;
	$Subj =~ s/<!--FName-->/$User{FName}/g;
	$Subj =~ s/<!--LName-->/$User{LName}/g;
	$Subj =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Subj =~ s/<!--Email-->/$User{Email}/g;
	
	#Email($From, $TO, $Subject,   $Message);
	&Email($Global{Account_Confirmation_Email}, $Param{Email}, $Subj, $Msg);

	$Plugins{Body} = $Language{pre_registration_message};
	$Plugins{Body} =~ s/<!--Name-->/$User{FName}/g;
	$Plugins{Body} =~ s/<!--Email-->/$User{Email}/g;
	
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
1;