=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Activate_New_User{
my (%User) = @_;
my (%Card, %Info, $Promot, $Source, $Msg, $Subj, $Temp, $Name);

	if ($Global{Require_Credit_Card}){
				%Card = %User;
				$Card{DefaultCC} = 1; # Make it the default card for payments.
				&Save_Credit_Card(%Card);
	}

	#------------------------------------------------------
	undef %Info;
	$Info{User_ID} = $User{User_ID};

	$Info{Sell} = $Global{New_Users_Sellers};
	$Info{Buy} = $Global{New_Users_Buyers};
	$Info{Status} = $Global{New_Users_Status};
	$Info{Verified} = "";
	$Info{Verified1} = "";
	$Info{Verified2} = "";
	$Info{Partner} = "";
	$Info{Sponser} = "";
	$Info{Power} = "";
	$Info{Rated} = "";

	&Add_New_User_Info(%Info);
	#------------------------------------------------------
	&AddNewForumUserInfo($User{User_ID});
	#------------------------------------------------------
	$Promot = &Get_Promotional_Code($User{Promotional_Code});
	$Promot ||= 0;

	if ($Global{New_Account_Deposit} > 0) {
				$Source = "new_account_credit_payment_source";
				&Make_Deposit($User{User_ID}, $Global{New_Account_Deposit}, &Time(time), $Source, "", "");
	}
	elsif ($Global{New_Account_Deposit} < 0) {
				$Source = "new_account_debit_payment_source";
				&Make_Deposit($Param{User_ID}, $Promot, &Time(time), $Source, "", "");
	}

	if ($Promot > 0) {
				$Source = "new_account_promot_payment_source";
				&Make_Deposit($User{User_ID}, $Promot, &Time(time), $Source, "", "");
	}
	#------------------------------------------------------------
	$Msg = &Translate_Classes(&Translate($Language{registration_confimation_email}));
	$Subj = &Translate_Classes(&Translate($Language{registration_confimation_subject}));

	$Name = $User{FName};
	$Name .= " ".$User{LName} if ($User{LName} ne "");
	$Msg =~ s/<!--Name-->/$Name/g;
	$Msg =~ s/<!--FName-->/$User{FName}/g;
	$Msg =~ s/<!--LName-->/$User{LName}/g;
	$Msg =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Msg =~ s/<!--Password-->/$User{Password}/g;
	$Msg =~ s/<!--Email-->/$User{Email}/g;

	$Subj =~ s/<!--Name-->/$Name/g;
	$Subj =~ s/<!--FName-->/$User{FName}/g;
	$Subj =~ s/<!--LName-->/$User{LName}/g;
	$Subj =~ s/<!--User_ID-->/$User{User_ID}/g;
	$Subj =~ s/<!--Email-->/$User{Email}/g;

	#Email($From, $TO, $Subject,   $Message);
	&Email($Global{Account_Confirmation_Email}, $User{Email}, $Subj, $Msg);
	#------------------------------------------------------------
	if ($Global{Auto_Update_Accounts_Counts}) {
				&UpdateSettings(TotalUsers => &Get_Total_Accounts_Count);
	}
	#------------------------------------------------------------
	#$Param{User_ID} = $User{User_ID};
	#&CreateAboutMe($User{User_ID});
}
#==========================================================
sub ConfirmRegistration{
my(%User, %Info, $Source, $Promot, $Msg, $Subj, $Temp);
	
	&LoadLangFile($Global{LanguageAccountManagerFile});
	&LoadLangFile($Global{LanguageRegisterFile});
	&ReadClasses;

	undef %User;
	%User = &Get_Pending_User($Param{Email});
	
	if (%User && ($User{Confirmation_Code} eq $Param{Code})) {
				$Global{New_Users_Status} ||= 0;
				$User{Status} = $Global{New_Users_Status};
				
				&Add_New_User(%User);
				&Activate_New_User(%User);
				&UpdateSettings(NewestUser => $User{User_ID});
				&Delete_Pending_User($User{User_ID});
				
				$Plugins{Body} = $Language{success_confirmation};
	}
	else{
				$Plugins{Body} = $Language{error_confirmation};
	}
	
	&Display($Global{AccountManagerTemplate});
}
#==========================================================
sub Get_Promotional_Code{
my ($Code) = @_;
my (@All, $Line, %Promot, $K, $V, $Credit);

	$Credit = 0;
	%Promot = &Get_Promotional_Code_File;
	if ($Promot{$Code}){
		$Promot = $Promot{$Code};
	}
	
	return $Promot;
}
#==========================================================
sub Get_Promotional_Code_File{
my (@All, $Line, %Promot, $K, $V);

	undef %Promot;
	if (-e $Global{Promotional_Code_File}){	
			open (FILE, "$Global{Promotional_Code_File}") || &Exit("Cannot read data file $Global{Promotional_Code_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
			@All = <FILE>;
			close(FILE);
			foreach $Line(@All){
					$Line =~ s/\n$//;
					($K, $V) = split(/\=/ , $Line);
					$Promot{$K} = $V;
			}
	}

	return %Promot;
}
#==========================================================
sub Check_User_ID_Available{
my ($User_ID) = shift;
my (%User);

	undef %User;
	%User = &Get_User($User_ID);
	if (%User) {return 1;}
	
	%User = &Get_Pending_User_Info($User_ID);
	if (%User) {return 1;}

	return 0;
}
#==========================================================
sub CreateAboutMe{
my ($UserID) = @_;
my ($Zip, $Member, $Temp, $Status, $Page);

	#--------- Zip file------------------------
	$Zip = Archive::Zip->new();
	$Member = $Zip->addString($Param{Description}, 'AboutMe.txt' );
	$Member->desiredCompressionMethod(COMPRESSION_DEFLATED); #COMPRESSION_STORED 
	$Member->desiredCompressionLevel(9); #0..9

	$Temp = qq!$Global{AboutMe_Data_Dir}!;
	if (!-d $Temp) {
		mkdir ($Temp, 0755) || &Exit("Can't creat directory $Temp: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	chmod (0755, $Temp);

	$Temp = qq!$Global{AboutMe_Data_Dir}/$UserID!;
	if (!-d $Temp) {
		mkdir ($Temp, 0755) || &Exit("Can't creat directory $Temp: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	chmod (0755, $Temp);

	$Temp = qq!$Global{AboutMe_Data_Dir}/$UserID/$UserID\.zip!;
	$Status = $Zip->writeToFileNamed($Temp);

	&ReadClasses;

	$Page = &TranslateFile($Global{AboutMeTemplate});
	$Page =~ s/<!--AboutMe_Body-->/$Param{Description}/g;
	$Page = &Translate($Page);
	$Page =&Translate_Classes($Page);
	$Page = &Translate($Page);
	$Page =&Translate_Classes($Page);
	$Page =~ s/<!--User_ID-->/$UserID/g;

	$Temp = qq!$Global{AboutMe_Dir}!;
	if (!-d $Temp) {
		mkdir ($Temp, 0755) || &Exit("Can't creat directory $Temp: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	chmod (0755, $Temp);

	$Temp = qq!$Global{AboutMe_Dir}/$UserID!;
	if (!-d $Temp) {
		mkdir ($Temp, 0755) || &Exit("Can't creat directory $Temp: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	chmod (0755, $Temp);

	$Temp = qq!$Global{AboutMe_Dir}/$UserID/$Global{AboutMe_Page}!;

	open(FILE, ">$Temp") || &Exit("Error: Can't create file $Temp: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__);
	print FILE $Page;
	close(FILE);
	chmod (0755, $Temp);
}
#==========================================================
sub Get_Pending_User_Info{
my ($User_ID) = @_;
my ($Query, %User, $Temp, $sth);

	$User_ID = $dbh->quote($User_ID);
	$Query .= qq!SELECT * FROM Pending_Users WHERE User_ID=$User_ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %User;
	while ($Temp = $sth->fetchrow_hashref){%User = %{$Temp};}
	$sth->finish;
	return %User;
}
#==========================================================
sub GetRegisterSettings{
my (@All, $Line, $Field, $Required, $Register, $Edit, %Fields);

	open (FILE, "$Global{RegisterOptions_File}") || &Exit("Cannot open file $Global{RegisterOptions_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@All = <FILE>;
	close(FILE);

	undef %Fields;
	foreach $Line (@All){
			$Line =~ s/\n//g;
			$Line =~ s/\s+//;
			if (!$Line) {next;}
			($Field, $Required, $Register, $Edit) = split(/\|/ , $Line);
			$Fields{$Field}{Required} = $Required;
			$Fields{$Field}{Register} = $Register;
			$Fields{$Field}{Edit} = $Edit;
	}

	return %Fields;
}
#==========================================================
sub GetRegistrationBannedEmails{
my ($List, @List, %List);

	open (File, "$Global{BannedEmail_File}") || &Exit("Cannot read file $Global{BannedEmail_File}: $!\n"."<br>Line ". __LINE__ . ", File ". __FILE__);
	@List = <File>;
	close File;
	
	undef %List;
	foreach $List (@List) {
			chomp $List;
			$List{$List} = 1;
	}
	return keys %List;
}
#==========================================================
sub CheckBannedRegistrationEmail{
my ($Email) = @_;
my (@List, $List);

	@List = &GetRegistrationBannedEmails;
	foreach $List (@List) {
			if ($Email =~ /^$List$/i) {return 0;} #Banned, return 0
	}
	return 1; # Not banned
}
#==========================================================
sub AddNewForumUserInfo{
my ($User_ID) = @_;
my (%Info);

	undef %Info;
	$Info{User_ID} = $User_ID;

	$Info{View} = $Global{New_Users_View};
	$Info{Browse} = $Global{New_Users_Browse};
	$Info{Readx} = $Global{New_Users_Reads};
	$Info{Post} = $Global{New_Users_Post};
	$Info{Reply} = $Global{New_Users_Reply};
	$Info{Edit} = $Global{New_Users_Edit};
	$Info{Deletes} = $Global{New_Users_Deletes};
	$Info{Announce} = $Global{New_Users_Announce};
	$Info{Sticky} = $Global{New_Users_Sticky};
	$Info{Poll} = $Global{New_Users_Poll};
	$Info{Vote} = $Global{New_Users_Vote};
	$Info{Attach} = $Global{New_Users_Attach};
	$Info{ViewIP} = $Global{New_Users_ViewIP};
	
	$Info{LastVisit} = &Time(time);
	$Info{Level} = 0; # 0=User, 1=Admin, 2=Mod
	$Info{Posts} = 0;
	$Info{Timezone} = $Global{GMT_Offset};
	$Info{Language} = $Global{Language};
	$Info{DateFormat} = $Global{DateFormat};
	$Info{EmailTime} = 0;
	$Info{ViewEmail} = 1;
	$Info{AttachSign} = 1;
	$Info{AllowPM} = 1;
	$Info{ViewOnline} = 1;
	$Info{NotifyPM} = 1;
	$Info{Rank} = 0;
	$Info{Avatar} = "";
	$Info{Location} = "";
	$Info{WebTitle} = "";
	$Info{WebURL} = "";
	$Info{Sig} = "";
	$Info{ICQ} = "";
	$Info{AIM} = "";
	$Info{YIM} = "";
	$Info{MSNM} = "";
	$Info{Occupation} = "";
	$Info{Interests} = "";
	$Info{Custom1} = "";
	$Info{Custom2} = "";
	$Info{Custom3} = "";
	$Info{Custom4} = "";
	$Info{Custom5} = "";
	$Info{Custom6} = "";
	$Info{Custom7} = "";
	$Info{Custom8} = "";
	$Info{Custom9} = "";
	$Info{Custom10} = "";

	&Add_New_Forum_Users_Info(%Info);
}
#==========================================================

1;