=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Server_Test{
my($Help);

	$Help = &Help_Link("Server_Configuration");
	&Print_Page(&Get_Server_Test, "Server Configuration", $Help);

}
#==========================================================
sub Commander1{
my ($Command, $Output, @Commands);
my ($Out, $CWD);

	$Help = &Help_Link("Commander");

   if ($@) {
		   $CWD = "$Global{CGI_Dir}>";
   }
   else {
			$CWD = Cwd::cwd;
   }

	if (!$Param{CWD}) {$Param{CWD} = $CWD;}

	if ($Param{CWD}) {chdir ($Param{CWD});}

	$Output = "";
	$Command = "";
	if ($Demo) {$Param{Command} = "ls -R -l" ; $Param{CWD} = $Global{CGI_Dir};}

	if (defined $Param{Command}) {
		@Commands = split(/\n/, $Param{Command});
		foreach $Command (@Commands) {
			$Command=~ s/\n//g;
			$Command=~ s/\cM//g;
			if ($Command) {
				system("$Command  > $Global{Temp_Dir}/command.txt");
				open(FILE,"$Global{Temp_Dir}/command.txt");
				@Out = <FILE>;
				$Output .= join("", @Out);
				close(FILE);
				#$Output .= `$Command`;
			}
		}
	}
	
	chdir ($Global{CGI_Dir});

	$Output = &Encode_HTML($Output);
	$Output =~ s/\n/<br>/g;
	$Output =~ s/\&lt;br\&gt;/<br>/ig;
	#$Output=~ s/\cM/<br>/g;
	$Param{Command} = join("\n", @Commands);
	&Print_Page(&Commander_Form($Param{Command}, $Output, $Param{CWD}), "Telnet Commander", $Help);
}
#==========================================================
sub ServerCommander{
my ($Command, $Output, @Commands);
my ($Out, $CWD);

	$Help = &Help_Link("Commander");
   if ($Global{CGI_Dir} && -d $Global{CGI_Dir}) {
		   $CWD = $Global{CGI_Dir};
   }
   else {
			$CWD = &Cwd::cwd;
			if (!-d $CWD) {$CWD = ".";	}
   }

	$Param{CWD} =~ s/^\s+//;
	$Param{CWD} =~ s/\s+$//;
	$Param{CWD} ||= $CWD;
	$Param{Command} ||= "";

	if ($Global{Demo_Mode}) {$Param{Command} = "ls -R -l" ; $Param{CWD} = $Global{CGI_Dir};}

	@Temp = split(/\n/, $Param{Command});
	undef @Commands;

	foreach $Command (@Temp) {
			$Command =~ s/\n//g;
			$Command =~ s/\cM//g;
			$Command =~ s/^\s+//;
			$Command =~ s/\s+$//;
			if (!$Command) {next;}
			push @Commands, $Command;
	}

	$Output = "";
	foreach $Command (@Commands) {
			if ($Param{CWD}) {chdir ($Param{CWD});}
			$Output .=  "[[Command::X]]" . $Command . "[[Command::Y]]<BR>";
			#$Command = "perl -c $File 2> $Temp_File";
			system("$Command  > $Global{Temp_Dir}/command.txt");
			open(FILE,"$Global{Temp_Dir}/command.txt");
			@Out = <FILE>;
			$Output .= join("", @Out);
			close(FILE);
	}
	
	chdir ($Global{CGI_Dir});

	$Output = &Encode_HTML($Output);
	$Output =~ s/\n/<br>/g;
	$Output =~ s/\&lt;br\&gt;/<br>/ig;

	$Output =~ s|\[\[Command::X\]\]|\<font size\=\"4\" color\=\"red\"\>\<b\>|g;
	$Output =~ s|\[\[Command::Y\]\]|\<\/b\>\<\/font\>|g;
	
	$Param{Command} = join("\n", @Commands);
	&Print_Page(&Commander_Form($Param{Command}, $Output, $Param{CWD}), "Server Commander", $Help);
}
#==========================================================
sub Commander_Form{
my($Command, $Output, $CWD) = @_;
my($Out);

$Out=<<HTML;
<form name="Command" method="POST" action="$ScriptURL">
<input type="hidden" name="action" value="ServerCommander">
<input type="hidden" name="CWD" value="$CWD">
<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
  <tr><td width="100%" class="TableCell"><a name="commander">
	Please Enter Your System Commands to Run (One Command per line):<br>
	  </td>
  </tr>
  <tr><td width="100%" class="TableCell">$CWD></td></tr>
  <tr><td width="100%" class="TableCell">
		<textarea name="Command" style="width: 550px; height: 200px;">$Command</textarea>
	  </td>
  </tr>
  <tr><td width="100%" class="TableCell">
	  <input type="submit" value="Do it!" style="width: 100px;"> &nbsp;&nbsp;
      <input type="reset" value="Reset" style="width: 100px;"> 
	  </td>
  </tr>

  <tr><td width="100%"class="TableCell" align="center">
        <table border="1" width="100%" cellpadding="3" class="TableAttr">
			<tr><td width="100%" align="center"><font size="4" face="Tahoma">O u t p u t</font></td></tr>
			<tr><td width="100%">$Output</td></tr>
        </table>
    </td>
  </tr>

  <tr><td width="100%"  align="center"><p align="center">	<a href="#commander">Top of Page</a></td></tr>
</table>
</form>

  <script language="JavaScript">
<!--
   document.Command.Command.focus()
   // -->
</script>
HTML
	return $Out;
}
#==========================================================
sub Reset_Permissions {
my($Out);

	$Out= "<center><b><font color=red size=3>Setting System Permissions</font></b></center><BR><BR>\n";

	$Out .="<p align=\"left\">";
	$Out .= "<font color=blue>1)- Main CGI Directory            ...Finished</font><BR>\n";
	$Out .= `chmod -R 755  $Global{CGI_Dir}/*.*`;

	$Out.= "<font color=blue>2)- Lib Directory            ...Finished</font><BR>\n";
	$Out .= `chmod -R 740 $Global{CGI_Dir}/lib*.*`;

	$Out.= "<font color=blue>3)- Data Directory            ...Finished</font><BR>\n";
	$Out .= `chmod -R 740 $Global{Data_Dir}/*.*`;

	$Out.= "<font color=blue>5)- Languages Directories            ...Finished</font><BR>\n";
	$Out .= `chmod -R 740 $Global{Data_Dir}/language/*.*`;

	$Out.="<font color=blue>6)- HTML Directories            ...Finished</font><BR>\n";
	$Out .= `chmod -R 740 $Global{HTML_Dir}/download/*.*`;
	$Out .= `chmod -R 740 $Global{HTML_Dir}/upload/*.*`;
	$Out .= `chmod -R 740 $Global{HTML_Dir}/backup/*.*`;

	$Out.="<BR><font color=Green>If you are on Windows system, or non Unix System, this function will not work for you, Please check your server manual for setting permisssions or try from your server control panel.</font><BR>\n";
	
	$Out.= qq!<I><CENTER><A HREF="javascript:history.go(-1)">Back to Previous Page</A></I></CENTER>!;

	&Print_Page($Out);

 }
#==========================================================
sub Get_Program_Exec_Directories{
my (@Exec);

	@Exec = qw (
								data
								data/database
								data/language
								data/lib
								data/lock
								data/logs
								data/mail
								data/temp
								data/templates
							);

	return @Exec;
 }
#==========================================================
sub Get_Program_Docs_Directories{
my (@Docs);

	@Docs = qw (
							aboutme
							aboutme_data
							attach
							avatars
							download
							htmleditor
							logos
							images
							upload
							theme
							SecImg
							);

 }
#==========================================================
sub Check_Program_Directory{
my($Dir, $Perkey, $PerValue) = @_;
my($Action, $Status, $Result, $Permissions, $Row, $Result);

	$Action = "-";
	
	if (!-d $Dir) {
			&Create_Directory_Path($Dir, $PerValue);
			chmod($PerValue, $Dir);
			if (!-d $Dir) {
					$Action = "Can't create";
			}
			else{
					$Action = "Created";
			}
	}
	
	if (-d $Dir) {
			$Status = "OK";
	}
	else{
			$Status = "Error";
			$Result .= "Failed to create directory: $Dir <BR>";
	}
	
	if ($Perkey eq "x") {
			if (!-x $Dir) {chmod($PerValue, $Dir);}
	}
	if ($Perkey eq "w") {
			if (!-w $Dir) {chmod($PerValue, $Dir);}
	}

	if ($Perkey eq "x") {
			if (-x $Dir) {
					$Permissions = "OK";
			}
			else{
					$Permissions = "Error";
					$Result .= "Failed to change permissions to executable: $Dir.<BR>";
							$Result .= "Failed to change permissions to writable: $Dir.<BR>";
			}
	}

	if ($Perkey eq "w") {
			if (-w $Dir) {
					$Permissions = "OK";
			}
			else{
					$Permissions = "Error";
					$Result .= "Failed to change permissions to writable: $Dir.<BR>";
			}
	}

	$Row .= qq|<tr>
		<td class="TableCell">$Dir</td><td class="TableCell" align="center">$Status</td>
		<td class="TableCell" align="center">$Permissions</td>
		<td class="TableCell" align="center">$Action&nbsp;</td>
		</tr>|;
	return ($Result, $Row);
 }
#==========================================================
sub Check_Program_Directories{
my (@Dirs, $Msg, $Out, $Results, $Table, $Row);
my ($Help);

	$Help = &Help_Link("Check_Program_Directories");

	$Table = "";
	$Results = "";
	
	($Result, $Row) = &Check_Program_Directory("$Global{CGI_Dir}", "x", 0755);
	$Table .= $Row;
	$Results .= $Result;

	($Result, $Row) = &Check_Program_Directory("$Global{HTML_Dir}", "x", 0755);
	$Table .= $Row;
	$Results .= $Result;

	@Dirs = &Get_Program_Exec_Directories;
	foreach $Dir(@Dirs) {
		($Result, $Row) = &Check_Program_Directory("$Global{CGI_Dir}/$Dir", "w", 0744);
		$Table .= $Row;
		$Results .= $Result;
	}

	@Dirs = &Get_Program_Docs_Directories;
	foreach $Dir(@Dirs) {
		($Result, $Row) = &Check_Program_Directory("$Global{HTML_Dir}/$Dir", "w", 0744);
		$Table .= $Row;
		$Results .= $Result;
	}
	($Result, $Row) = &Check_Program_Directory("$Global{HTML_Dir}/images", "x", 0755);
	$Table .= $Row;
	$Results .= $Result;
	
	if (($^O =~ /win/i)) {
			$Msg = qq!!;
	}
	
	if (!$Results) {
			$Results = "<B>Congratulations, All tests passed.</B>";
	}

$Out=<<HTML;
<form method="post" action="$ScriptURL">
<input type="hidden" name="action" value="Do_Server_Backup">
<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
	<tr>
		<td align="center" class="TableHeader">Directory</td>
		<td align="center" class="TableHeader">Status</td>
		<td align="center" class="TableHeader">Permissions</td>
		<td align="center" class="TableHeader">Action</td>
	</tr>
$Table
</tr>
</table>
</form>
	$Results
HTML

	&Print_Page($Out, "Check Program Directories", $Help);

 }
#==========================================================
sub Check_Program_Files_Permissions{
my(@Dirs, $Out, $Table, $Dir, $Read, $Write, $Execute, $Filename);
my($Help);

	$Help = &Help_Link("Check_Program_Directories");

	$Table = "";
	@Files = &Scan_Directory_Files($Global{CGI_Dir});

	foreach $File(@Files) {
			$Read = "&nbsp;";
			$Write = "&nbsp;";
			$Execute = "&nbsp;";
			if (-r "$File") {$Read = "Yes";}
			if (-w "$File") {$Write = "Yes";}
			if (-x "$File") {$Execute = "Yes";}
			$Filename = $File;
			$Filename =~ s/^$Global{CGI_Dir}//;
			if (-d $File) {$Filename = qq!<font color="red"><b>$Filename</b></font>!;}
			$Table .= qq|<tr>
				<td class="TableCell">$Filename</td>
				<td align="center" class="TableCell">$Read</td>
				<td align="center" class="TableCell">$Write</td>
				<td align="center" class="TableCell">$Execute</td>
				</tr>|;
	}

	@Files = &Scan_Directory_Files($Global{HTML_Dir});

	foreach $File(@Files) {
			$Read = "";
			$Write = "";
			$Execute = "";
			if (-r "$File") {$Read = "Yes";}
			if (-w "$File") {$Write = "Yes";}
			if (-x "$File") {$Execute = "Yes";}
			$Filename = $File;
			$Filename =~ s/^$Global{HTML_Dir}//;
			if (-d $File) {$Filename = qq!<font color="red"><b>$Filename</b></font>!;}
			$Table .= qq|<tr>
										<td class="TableCell">$Filename</td>
										<td class="TableCell" align="center">$Read</td>
										<td class="TableCell" align="center">$Write</td>
										<td class="TableCell" align="center">$Execute</td>
								</tr>|;
	}

$Out=<<HTML;
<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
<tr><td class="TableHeader">File</td>
	<td align="center" class="TableHeader">Read</td>
	<td align="center" class="TableHeader">Write</td>
	<td align="center" class="TableHeader">Execute</td>
</tr>
$Table
</table>
HTML

	&Print_Page($Out, "Check Program Files Permissions", $Help);
}
#==========================================================
sub Scan_Directory_Files{
my($Directory)=@_;
my($File, $Temp, @Directories, @Files, $Current_Directory, @Found);

	undef @Directories;
	undef @Files;
	undef @Found;

	if (!$Directory) {$Directory = Cwd::cwd();}

	push @Directories, $Directory;
	
	while (@Directories) {
						   $Current_Directory = shift (@Directories);
						   opendir (DIR, $Current_Directory) || return undef;
						   @Files = readdir (DIR);
						   closedir (DIR);
						   foreach $File (@Files) {
									$Temp = "$Current_Directory/$File";
									$Temp =~ s|\/\/|\/|;
									  if (-d $Temp && $File ne "." && $File ne "..") {
												unshift @Directories, $Temp;
												push @Found, $Temp;
												next;
									  }
									  else{
											 if ($File ne "." && $File ne "..") {
													push @Found, $Temp;
											 }
									  }
							}
	}

	return sort @Found;
}
#==========================================================
1;
