=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Update_System_Statistics{
my($Total_Links, 	$Categories_Count);
my(%Config);

	&Update_Total_Accounts_Counts;
	&Update_Accounts_Counts;
	&System_Statistics();
}
#==========================================================
sub System_Statistics{
my ($Out);
my($Help);

	$Help = &Help_Link("index");
	
	&ReadSettings;

$Out=<<HTML;
<table border="0" cellpadding="2" cellspacing="2" style="border-collapse: collapse" width="100%">
  <tr>
    <td width="100%"><a href="$Global{AdminURL}action=Update_System_Statistics">Update System Statistics</a></td>
  </tr>
  <tr>
    <td width="100%"><a href="$Global{AdminURL}action=User_Registration_Analysis">User Registration Analysis</a></td>
  </tr>

</table>
<br>

<table cellpadding="2" cellspacing="0" class="TableAttr" width="600">
<tr><td colspan="2" class="TableHeader" align="center">Accounts</td></tr>
  <tr><td width="100%" class="TableCell">
			Registration History   <a href="$Global{AdminURL}action=New_Users_History&Period=7">1 Week</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=31">1 Month</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=186">6 Months</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=365">1 Year</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=1095">3 Years</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=1825">5 Years</a>
			&nbsp;&nbsp;<a href="$Global{AdminURL}action=New_Users_History&Period=0">All</a>
	</td>
</tr>
</table>
HTML

	&Print_Page($Out, "System Statistics", $Help);
}
#==========================================================
sub New_Users_History{
my($Out, %Users, %User, @Keys);
my ($User_ID, $Key, $MaxCount, $Count, $Date, $Width);
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst);

	undef %Users;
	undef %User;

	$Param{Period} ||= 0;
	if ($Param{Period} > 0) {
		$Start = &Time(time) - ($Param{Period}*24*60*60);
		$End = &Time(time);
	}
	else {
			$Start = 0; $End = 0;
	}
	
	%Users = &Users_History_Count($Start, $End);

	while (($User_ID, $Date) = each %Users) {
			($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst ) = gmtime($Date);
			$year += 1900;
			$mon++;
			$mday = sprintf("%02d", $mday);
			$mon = sprintf("%02d", $mon);
			$Key = "$mon-$mday-$year";
			$User{$Key}++;
	}

	$Count = 0;
	@Keys = reverse sort keys %User;

	$MaxCount = 0; $Total = 0;
	foreach $Date(@Keys) {
		$Total += $User{$Date};
		if ($User{$Date} > $MaxCount) {$MaxCount = $User{$Date};}
	}

$Out =<<HTML;
<div align="left" style="padding: 5px;">
User Registration Daily Statistics<br><br>
$Total Users registered during this time period.<br>
</div>
<br>

<table cellpadding="2" cellspacing="0" class="TableAttr">
	<tr>
		<td class="TableHeader" align="center" nowrap><b>#</b></td>
		<td class="TableHeader" align="center" nowrap><b>Date</b></td>
		<td class="TableHeader" align="center" nowrap><b>Count</b></td>
		<td class="TableHeader" width="100%" align="center"><b>Graph</b></td>
	</tr>
HTML

	foreach $Date(@Keys) {
		$Count++;
		$Width = ($User{$Date} / $MaxCount)*500;
		$Out .= qq!<tr><td class="TableCell" nowrap align="right">&nbsp;$Count&nbsp;</td><td nowrap>&nbsp;$Date&nbsp;</td>
			<td nowrap class="TableCell">&nbsp;<font color="green">$User{$Date}</font></td>
			<td width="100%" align="left" nowrap>&nbsp;<img src="$Global{Skin}/barred.jpg" width="$Width" height="5" border="0"></td>
			</tr>!;
	}

	$Out .= "</table>";
	&Print_Page($Out, "User Registration Statistics", $Help);
}
#==========================================================
#==========================================================
sub User_Registration_Analysis{
my ($Field, $Start, $End, @All, %Users, $user, @Keys);
my ($MaxCount, $Total, $Out, $Help);

	$Field = "User10";
	$Start = "";
	$End = "";
	
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime(time);
	$thisYear = $year;
	$year += 1900; $mon++;
	$mday = sprintf("%02d", $mday);
	$mon = sprintf("%02d", $mon);
	$year -=2000;
	$year = sprintf("%02d", $year);

	$Date = &Time(time);

	if (!$Param{Start_Day}) {
		$End_Date = &Time(time);

		($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst ) = gmtime($End_Date);
		$year += 1900; $mon++;
		$Param{End_Day} = $mday; $Param{End_Month} = $mon; $Param{End_Year} = $year;

		$Start_Date = $End_Date -  30*24*60*60;
		($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst ) = gmtime($Start_Date);
		$year += 1900; $mon++;
		$Param{Start_Day} = $mday; $Param{Start_Month} = $mon; $Param{Start_Year} = $year;
	}
	else {
		$days = &days_in_month($Param{Start_Month}, $Param{Start_Year});
		if ($Param{Start_Day} > $days) {$Param{Start_Day} = $days;}
		$Start_Date = timelocal(0, 0, 0, $Param{Start_Day}, $Param{Start_Month}-1, $Param{Start_Year}-1900);
		
		$days = &days_in_month($Param{End_Month}, $Param{End_Year});
		if ($Param{End_Day} > $days) {$Param{End_Day} = $days;}
		$End_Date = timelocal(59, 59, 23, $Param{End_Day}, $Param{End_Month}-1, $Param{End_Year}-1900);
	}
	
	$Start_Day = "";
	for $x(1..31) {
		if ($x == $Param{Start_Day}) {
			$Start_Day.=qq!<option value="$x" selected>$x</option>!;
		}
		else{
			$Start_Day.=qq!<option value="$x">$x</option>!;
		}
	}

	$Start_Month = "";
	for $x(1..12) {
		if ($x == $Param{Start_Month}) {
			$Start_Month.=qq!<option value="$x" selected>$x</option>!;
		}
		else{
			$Start_Month.=qq!<option value="$x">$x</option>!;
		}
	}

	$Start_Year="";
	for $x(110..$thisYear ) {
			$Y=$x+1900;
			if ($x == $Param{Start_Year}) {
					$Start_Year.=qq!<option value="$Y" selected>$Y</option>!;
			}
			else{
					$Start_Year.=qq!<option value="$Y">$Y</option>!;
			}
	}

	$End_Day = "";
	for $x(1..31) {
		if ($x == $Param{End_Day}) {
			$End_Day.=qq!<option value="$x" selected>$x</option>!;
		}
		else{
			$End_Day.=qq!<option value="$x">$x</option>!;
		}
	}

	$End_Month = "";
	for $x(1..12) {
		if ($x == $Param{End_Month}) {
			$End_Month.=qq!<option value="$x" selected>$x</option>!;
		}
		else{
			$End_Month.=qq!<option value="$x">$x</option>!;
		}
	}

	$End_Year="";
	for $x(110..$thisYear ) {
			$Y=$x+1900;
			if ($x == $Param{End_Year}) {
					$End_Year.=qq!<option value="$Y" selected>$Y</option>!;
			}
			else{
					$End_Year.=qq!<option value="$Y">$Y</option>!;
			}
	}

	@All = &SqlCol(qq!SELECT $Field FROM Users WHERE Start_Date>=$Start_Date AND Start_Date<=$End_Date ORDER BY Start_Date ASC!);

	undef %Users;

	foreach $user (@All) {
		$Users{$user}++;
	}

	@Keys = reverse sort keys %Users;

	$MaxCount = 0; $Total = 0;

	foreach $user(@Keys) {
		$Total += $Users{$user};
		if ($Users{$user} > $MaxCount) {$MaxCount = $Users{$user};}
	}

$Out =<<HTML;
<p><b>User Registration Analysis</b></p>
<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="User_Registration_Analysis">

<table border="0" cellpadding="2" cellspacing="02">
  <tr><td nowrap><b>&nbsp;Start date:</b></td><td nowrap>&nbsp;
				<select size="1" name="Start_Month">$Start_Month</select>
				<select size="1" name="Start_Day">$Start_Day</select>
				<select size="1" name="Start_Year">$Start_Year</select>
					&nbsp; mm/dd/yyyy
  </td></tr>
  <tr><td nowrap><b>&nbsp;End date:</b></td><td nowrap>&nbsp;
				<select size="1" name="End_Month">$End_Month</select>
				<select size="1" name="End_Day">$End_Day</select>
				<select size="1" name="End_Year">$End_Year</select>
					&nbsp; mm/dd/yyyy
  </td></tr>
<tr><td nowrap colspan="2" align="center"><input type="submit" value="Submit">&nbsp;&nbsp;<input type="reset" value="Reset"></td></tr>

</table>
<br>
$Total Users registered during this time period.<br><br>
<br>

<table border="1" cellpadding="2" cellspacing="02" style="border-collapse: collapse" bordercolor="#F7F7F7" width="100%">
<tr>
<td bgcolor="#E1E1E1" align="center" nowrap><b>#</b></td>
<td bgcolor="#E1E1E1" align="center" nowrap><b>Source</b></td>
<td bgcolor="#E1E1E1" align="center" nowrap><b>Count</b></td>
<td bgcolor="#E1E1E1" width="100%" align="center"><b>Graph</b></td>
</tr>
HTML

	foreach $key(@Keys) {
		$Count++;
		$Width = ($Users{$key} / $MaxCount)*500;
		$temp = $key;
		if (!$temp) {$temp = "<center>-</center>";}
		$Out .= qq!<tr><td bgcolor="#F0F0F0" nowrap align="right">&nbsp;$Count&nbsp;</td><td nowrap><font color="#0033CC"><b>$temp</b></font></td><td nowrap>&nbsp;<font color="green">$Users{$key}</font></td><td width="100%" align="left" nowrap>&nbsp;<img src="$Global{Images}/bar5x5.jpg" width="$Width" height="5" border="0"></td></tr>!;
	}

	$Out .= "</table>";

	&Print_Page($Out, "User Registration Analysis", $Help);
}
#==========================================================
1;