#!/usr/bin/perl
#!C:\perl\bin\perl.exe
=Copyright Infomation
==========================================================
Program Name    : Mewsoft Auctionawy
Program Author   : Dr. Ahmed Amin Elsheshtawy, Ph.D.
Home Page          : http://www.mewsoft.com
Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
 This software license prohibits selling, giving away, or otherwise distributing 
 the source code for any of the scripts contained in this SOFTWARE PRODUCT,
 either in full or any subpart thereof. Nor may you use this source code, in full or 
 any subpart thereof, to create derivative works or as part of another program 
 that you either sell, give away, or otherwise distribute via any method. You must
 not (a) reverse assemble, reverse compile, decode the Software or attempt to 
 ascertain the source code by any means, to create derivative works by modifying 
 the source code to include as part of another program that you either sell, give
 away, or otherwise distribute via any method, or modify the source code in a way
 that the Software looks and performs other functions that it was not designed to; 
 (b) remove, change or bypass any copyright or Software protection statements 
 embedded in the Software; or (c) provide bureau services or use the Software in
 or for any other company or other legal entity. For more details please read the
 full software agreement file distributed with this software.
==========================================================
=cut
#==========================================================
$| = 1;
print "Content-type: text/html\n\n";
use CGI::Carp qw(fatalsToBrowser);
#==========================================================
BEGIN {
	undef %Param;
	undef %Global;
	undef @User_Fields;
	undef @Category_Fields;
	undef %Cookies;
	undef %Plugins;
	undef %PluginsNames;
}
#==========================================================
BEGIN {
	if ($ENV{SCRIPT_FILENAME}) {
			use File::Basename;
			($Script, $Bin) = fileparse($ENV{SCRIPT_FILENAME});
	}
	else {
			use FindBin qw($Bin $Script);
	}
	$Bin ||= ".";
	use lib "$Bin/lib";
	unshift @INC, $Bin;
	$Global{CGI_Dir} = $Bin;
	$Global{MainProg} = $Script;
}
#==========================================================
use Configuration;
&ProgramStart;
#==========================================================
&ModLoad("constant", "Archive::Zip qw( :ERROR_CODES :CONSTANTS )");

&ProcessUpgrade;

print "<br><font size=\"4\" color=\"green\"><b>Finished...</b></font><br>";
&Quit;
exit 0;
#==========================================================
#==========================================================
sub ProcessUpgrade {
my (@Users, $UsersCount, $Counter, $User, $Content, $File, $Zip, $User_ID);
		
	print qq!<p align="center"><b>About Me Users Page Upgrade Tool</b></p>!;
	#----------------------------------------------------------------------
	#Modify the size of the banner click log fields
	#----------------------------------------------------------------------
	print qq!Modifying <b>Banner_Click_Log</b> SQL Table, please ignore any error messages!;
	$dbh->do("ALTER TABLE Banner_Click_Log MODIFY Campaign VARCHAR(255), MODIFY Remote VARCHAR(50), MODIFY Refer VARCHAR(255), MODIFY  Agent VARCHAR(255)");
	print "...Done<br>";
	#----------------------------------------------------------------------
	# Create the AboutMe Table
	#----------------------------------------------------------------------
	print qq!Creating new About Me SQL table, please ignore error messages about already exists tables.<br>!;
	print &Create_AboutMe_Table;
	#----------------------------------------------------------------------
	# Get all users id's
	#----------------------------------------------------------------------
	@Users = &SqlCol(qq!SELECT User_ID FROM Users ORDER BY User_ID ASC !);
	$UsersCount = @Users;
	print "<b>Total Users Found: $UsersCount</b><br>";
	#----------------------------------------------------------------------
	# Import users about me page data from the zip files to the sql table
	#----------------------------------------------------------------------
	$Counter = 0;
	foreach $User (@Users) {
		$Counter++;
		print "$Counter)- $User, ";

		$Content = "";
		$File = qq!$Global{AboutMe_Data_Dir}/$User/$User\.zip!;
		if (-e $File) {
				$Zip = Archive::Zip->new();
				if ($Zip->read($File) == AZ_OK){
					$Content = $Zip->contents('AboutMe.txt');
				}
				else{
					$Content = "";
					print " <font color=\"red\">Error reading zip file</font>, ";
				}
		}
		else {
			print " <font color=\"blue\">No Folder Found</font>, ";
		}
		$Length = length($Content);
		print "$Length Bytes, ";
		#------------------------------------------------------
		$User_ID = $dbh->quote($User);
		
		@Row = &SqlRow(qq!SELECT User_ID, Content FROM AboutMe WHERE User_ID=$User_ID!);

		if ($Row[0] && $Row[1] ne "") {
			$Content =	$Row[1];
		}

		$Content =~ s/\cM//g;
		$dbh->do(qq!DELETE from AboutMe WHERE User_ID=$User_ID!);

		$Content =  $dbh->quote($Content);
		$dbh->do(qq!INSERT INTO AboutMe values($User_ID, $Content)!);
		#------------------------------------------------------
		print "...Done<br>";
	}
}
#==========================================================
sub Create_AboutMe_Table{
my ($Table, $Out);

	$Table = qq!CREATE TABLE AboutMe (
							User_ID VARCHAR(250),
							Content longtext
						)!;
	$Out .= &CreateTable("About Me", $Table);
	return $Out;
}
#==========================================================
sub CreateTable{
my ($Name, $Code) = @_;

   if ($dbh->do($Code)) {
			return (" $Name Table Successfully Created.<br>\n");
	}
   else {
			return (" Error Creating $Name Table: $DBI::errstr.<br>\n");
   }
}
#==========================================================
