=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ViewProfile{
my ($Template, $Temp, %User, %User, $TimeClass, $TimeFormat);

	&Check_Account_Login;
	#------------------------------------------------------
	$Plugins{Bar_Action} = $Language{bar_view_profile};
	
	$Template = &TranslateFile($Global{ForumViewProfileTemplate});
	#------------------------------------------------------
	%User = &GetForumUser($Param{Author});

	$Template =~ s/<!--Author-->/$User{User_ID}/g;

	$Temp = "";
	$Template =~ s/<!--Joined-->/$Temp/g;
	
	if ($User{ViewEmail}) {
			$Template =~ s/<!--Email-->/$User{Email}/g;
	}
	else{
			$Template =~ s/<!--Email-->//g;
	}
	
	$Template =~ s/<!--MSNM-->/$User{MSNM}/g;
	$Template =~ s/<!--AIM-->/$User{AIM}/g;
	$Template =~ s/<!--AIM-->/$User{AIM}/g;
	$Template =~ s/<!--YIM-->/$User{YIM}/g;
	$Template =~ s/<!--ICQ-->/$User{ICQ}/g;

	if ($User{Posts} > 0) {
			$Temp = $User{Posts};
	}
	else{
		$Temp = $Language{profile_posts_zero};
	}
	$Template =~ s/<!--Posts-->/$Temp/g;
	
	$User{WebTitle} ||= $User{WebURL};

	if ($User{WebURL}) {
			$Temp = $Language{profile_website_link};
			$Temp =~ s/<!--WebURL-->/$User{WebURL}/g;
			$Temp =~ s/<!--WebTitle-->/$User{WebTitle}/g;
			$Template =~ s/<!--WebSite-->/$Temp/g;
	}
	else{
			$Template =~ s/<!--Website-->//g;
	}

	$Temp = qq!$Global{ProgURL}action=MyCompose&To=$User{User_ID}&&Lang=$Global{Language}!;
	$Template =~ s/<!--PM-->/$Temp/g;

	$Template =~ s/<!--Occupation-->/$User{Occupation}/g;
	$Template =~ s/<!--Location-->/$User{Location}/g;
	$Template =~ s/<!--Interests-->/$User{Interests}/g;
	$Template =~ s/<!--Sig-->/$User{Sig}/g;
	
	if ($User{Avatar}) {
			$Temp = $Language{profile_avatar_link};
			$Link = qq!$Global{Avatars_URL}/$User{Avatar}!;
			$Temp =~ s/<!--AvatarLink-->/$Link/g;
			$Template =~ s/<!--Avatar-->/$Temp/g;
	}
	else{
			$Template =~ s/<!--Avatar-->//g;
	}
	#------------------------------------------------------
	$TimeClass = ""; $TimeFormat = "";	# <!--Joined:(WD-MD-YY-HH-MM-AP)-->
	if ($Template =~ m/(<!--)(Joined)(:\()([^\)]+)(\)-->)/){
				$TimeClass = $1 . $2 . $3. $4. $5;
				$TimeFormat =  $4;
	}
	$TimeClass =~ s/\(/\\\(/g;
	$TimeClass =~ s/\)/\\\)/g;

	$Temp = &ParseDate($TimeFormat, $User{Start_Date});
	$Template =~ s/$TimeClass/$Temp/g;
	#------------------------------------------------------
	#------------------------------------------------------
	if ($Global{Auctionawy_Plugin}) {
			($Rating, $Stars) = &Get_User_Feedback_Stars($User{User_ID});
			if (!$Rating) {
					$Temp = $Language{feedback_rating_zero};
			}
			else{
					$Temp = $Language{feedback_rating};
			}
			$Temp =~ s/<!--FeedbackRating-->/$Rating/g;
			$Temp =~ s/<!--FeedbackStars-->/$Stars/g;
			$Form =~ s/<!--Feedback-->/$Temp/g;

			$Temp1 = &GetUserOpenAuctionsCount($User{User_ID});
			if ($Temp1 > 0) {
				$Temp = $Language{member_auctions};
			}
			else {
				$Temp = $Language{member_auctions_zero};
			}
			$Link = qq!$Global{AuctionMainURL}?action=Browse&Search=SellerAuctions&Status=&SellerID=$User{User_ID}&Lang=$Global{Language}!;
			$Temp =~ s/<!--MemberAuctionsLink-->/$Link/g;
			$Temp =~ s/<!--Auctions-->/$Temp1/g;
			$Form =~ s/<!--MemberAuctions-->/$Temp/g;
			$Form =~ s/<!--Auctions-->/$Temp1/g;

			$Temp = qq!$Global{AuctionMainURL}?action=ListUserFeedback&User_ID_Feedback=$User{User_ID}&Lang=$Global{Language}!;
			$Form =~ s/<!--MemberFeedbackLink-->/$Temp/g;
	}
	#------------------------------------------------------
	if ($Global{Classifiedawy_Plugin}) {
			$Temp1 = &GetUserOpenAdsCount($User{User_ID});
			if ($Temp1 > 0) {
					$Temp = $Language{member_ads};
			}
			else {
					$Temp = $Language{member_ads_zero};
			}
			$Link = qq!$Global{ClassifiedMainURL}?action=Browse&Search=SellerAds&Status=&SellerID=$User{User_ID}&Lang=$Global{Language}!;
			$Temp =~ s/<!--MemberAdsLink-->/$Link/g;
			$Temp =~ s/<!--Ads-->/$Temp1/g;
			$Form =~ s/<!--MemberAds-->/$Temp/g;
			$Form =~ s/<!--Ads-->/$Temp1/g;
	}
	#------------------------------------------------------
	#------------------------------------------------------
	$Temp = $Language{about_me_link};
	$Link = qq!$Global{AboutMe_URL}/$User{User_ID}!;
	$Temp =~ s/<!--AboutMeLink-->/$Link/g;
	$Temp =~ s/<!--Author-->/$User{User_ID}/g;
	$Template =~ s/<!--AboutMe-->/$Temp/g;
	#------------------------------------------------------

	&Display($Template, 1);
}
#==========================================================
1;