=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
#==========================================================
sub Banner_Manager{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Manager_Form, "Banner Manager", $Help);	

}
#==========================================================
sub Banner_Manager_Form{
my($Out);
	
	$Out = &Banner_Manager_Nav;
	return $Out;
}
#==========================================================
sub Banner_Manager_Nav{
my($Out);

$Out=<<HTML;
<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
	<tr class="TableHeader">
		<td ><a href="$Global{AdminURL}action=Add_New_Banner_Account">Add Account</a></td>
		<td ><a href="$Global{AdminURL}action=Add_New_Banner_Campaign">Add Campaign</a></td>
		<td ><a href="$Global{AdminURL}action=Manage_Banner_Accounts">Manage Accounts</a></td>
		<td ><a href="$Global{AdminURL}action=Manage_Banner_Campaigns">Manage Campaigns</a></td>
		<td ><a href="$Global{AdminURL}action=Manage_Banner_Zones">Manage Zones</a></td>
	</tr>
</table>
HTML
	return $Out;
}
#==========================================================
sub Manage_Banner_Zones{
my ($Help);

	$Help = &Help_Link("Banner_Zones");
	&Print_Page(&Zones_Manager_Form, " Manage Banner Zones", $Help);	
}
#==========================================================
sub Zones_Manager_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth);

	$Query = qq!SELECT * FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Count = 0;
	while(($Zone, $Default_Zone, $Default_Campaign) = $sth->fetchrow_array) {
			$Zones[$Count]{Zone} = $Zone;
			$Zones[$Count]{Default_Zone} = $Default_Zone;
			$Zones[$Count]{Default_Campaign} = $Default_Campaign;
			$Count++;
	}

	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Zones;
	$LastPage = int ($TotalCount / $Global{Admin_Accounts_Per_Page});
	if (($TotalCount % $Global{Admin_Accounts_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}
	$NextPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Zones&Page=$NextPage">Next >></A>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Zones&Page=$PrevPage"><< Prev</A>!;

	$Start = ($CurrentPage - 1) * $Global{Admin_Accounts_Per_Page};
	$End = $Start + $Global{Admin_Accounts_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next >>";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "<< Prev";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
		$x = $Count+1;
		$Zone = &Web_Encode($Zones[$Count]{Zone});
$Form =<<Zones;
	  <tr>
        <td class="TableCell" align="center">&nbsp;$x</td>
        <td class="TableCell" width="30%" align="left">&nbsp; 
		<a href="$Global{AdminURL}action=Configure_Banner_Zone&Zone=$Zones[$Count]{Zone}">$Zones[$Count]{Zone}</A>
		</td>
        <td class="TableCell" width="30%" align="left">&nbsp; $Zones[$Count]{Default_Zone}</td>
        <td class="TableCell" width="30%" align="left">&nbsp; $Zones[$Count]{Default_Campaign}</td>
        <td class="TableCell" align="center"><a href="$Global{AdminURL}action=Configure_Banner_Zone&Zone=$Zone">Config</a></td>
		<td class="TableCell" align="center"><a href="#" onClick="Delete_Banner_Zone_Confirm('$Zone', '$Zones[$Count]{Zone}'); return false;">Delete</a></td>
      </tr>
Zones
			
		$Table .= $Form;
	}

	$Start++;
	
	my $Nav =Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<div align="center"><center>
  <form method="post" action="$Global{AdminURL}">
    <table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
      <tr>
        <td align="center" class="TableHeader">#</td>
        <td width="30%" align="center" class="TableHeader">Zone</td>
        <td width="30%" align="center" class="TableHeader">Default Zone</td>
        <td width="30%" align="center" class="TableHeader">Default Campaign</td>
        <td align="center" class="TableHeader" colspan="2">Action</td>
      </tr>

	$Table

      <tr>
        <td align="right" colspan="6"><b>
			$PrevPage &nbsp;&nbsp; $NextPage
			&nbsp;&nbsp;&nbsp;
        </td>
      </tr>
      <tr>
        <td align="center" colspan="6">
			<input type="submit" value="Save Changes" name="Submit" style="width: 100px;">&nbsp;
          <input type="reset" value="Reset" name="Reset" style="width: 100px;">
			  </td>
      </tr>
    </table>
  </form>
  </center>
</div>
<P>&nbsp;</P>

<div align="center"><center>
<form method="post" action="$Global{AdminURL}">

<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
    <tr><td align="center" class="TableHeader">Create New Zones</td></tr>
    <tr><td>Please enter one zone name per each line and press enter key at the end of each line.</td></tr>
	<tr><td>
          <input type="hidden" name="action" value="Create_New_Banner_Zones">
		  <textarea name="New_Zones_Names" style="width:400px; height: 150px;"></textarea>
	</td></tr>
	<tr><td>		 
		  <input type="submit" value="Create Zones" name="Submit" style="width: 100px;">&nbsp;
          <input type="reset" value="Reset" name="Reset" style="width: 100px;">
      </td>
    </tr>
  </table>
    </form>
 </center>
</div>

<script language="JavaScript">
<!--
function Delete_Banner_Zone_Confirm(Zone_Encoded, Zone) {
	var agree=confirm("Are you sure you want to Delete the ["+Zone+"] banner Zone\\n");
	if (agree){
			var agree=confirm("Please note once the Zone deleted, you will not be able to recover it again\\nAre you sure you still want to delete this zone ["+Zone+"]\\n");
			if (agree){
				window.location = "$Global{AdminURL}action=Delete_Banner_Zone&Zone=" +Zone_Encoded;
			}
	}
}
-->
</script>
HTML
	
	return $Out;

}
#==========================================================
sub Delete_Banner_Zone{

	$Param{Zone} = $dbh->quote($Param{Zone});

	$Query = qq!DELETE FROM Banner_Zones WHERE Zone=$Param{Zone}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Zones;

}
#==========================================================
sub Create_New_Banner_Zones{

	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Zone) = $sth->fetchrow_array) {
			$Zones{$Zone} = 1;;
	}
	$sth->finish;


	@Zones = split (/\n/, $Param{New_Zones_Names});
	foreach $Zone (@Zones) {
				$Zone =~ s/\r+$//;
				$Zone =~ s/\n+$//;
				$Zone =~ s/^\s+//;
				$Zone =~ s/\s+$//;
				if ($Zones{$Zone}) {next;}

				$Zone =$dbh->quote($Zone);
				$Query = qq!INSERT INTO Banner_Zones VALUES($Zone, '', '')!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	}
	$sth->finish;

	&Manage_Banner_Zones;

}
#==========================================================
sub Configure_Banner_Zone{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Configure_Banner_Zone_Form, "Banner Manager", $Help);
}
#==========================================================
sub Configure_Banner_Zone_Form{
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth);
my($Out);

	$Param{Zone} = $dbh->quote($Param{Zone});
	$Query = qq!SELECT * FROM Banner_Zones WHERE Zone=$Param{Zone} ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {($Zone_Name, $Default_Zone, $Default_Campaign) = @Row;}
	$sth->finish;

	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Default_Zone_Menu .= "";
	while($Zone = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if ($Default_Zone eq $Zone) {$Temp1 = "SELECTED";}
			$Default_Zone_Menu .= qq!<OPTION value="$Temp" $Temp1>$Zone!;
	}
	$Temp1 = "";
	if ($Default_Zone eq "") {$Temp1 = "SELECTED";}
	$Default_Zone_Menu .= qq!<OPTION value="" $Temp1>!;
	$sth->finish;

	$Query = qq!SELECT Campaign FROM Banner_Campaigns ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Default_Campaing_Menu = "";
	while($Zone = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if ($Default_Campaign eq $Zone) {$Temp1 = "SELECTED";}
			$Default_Campaing_Menu .= qq!<OPTION value="$Temp" $Temp1>$Zone!;
	}
	$Temp1 = "";
	if ($Default_Campaign eq "") {$Temp1 = "SELECTED";}
	$Default_Campaing_Menu .= qq!<OPTION value="" $Temp1>!;
	$sth->finish;
	my $Nav =Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="Save_Configure_Banner_Zone">
<input type="hidden" name="Zone" value="$Param{Zone}">
  <div align="center">
    <center>
    <table border="1" width="90%" cellspacing="0" cellpadding="5" class="TableAttr">
      <tr>
        <td width="100%" colspan="2" align="center" HEIGHT="25" class="TableHeader"><b><font size="4">Banner
          Zone Configuration</font></b></td>
      </tr>
      <tr>
        <td class="TableCell">Zone Name:</td>
        <td width="50%" HEIGHT="19">&nbsp; $Zone_Name</td>
      </tr>
      <tr>
        <td class="TableCell">Default Zone:</td>
        <td width="50%" HEIGHT="22">&nbsp;
		
		<SELECT size="1" name="Default_Zone">
		$Default_Zone_Menu
          </SELECT>
			
		</td>
      </tr>
      <tr>
        <td class="TableCell">Default Campaign:</td>
        <td width="50%" HEIGHT="19">&nbsp;
	
		<SELECT size="1" name="Default_Campaign">
		$Default_Campaing_Menu
          </SELECT>
	
</td>
      </tr>
      <tr>
        <td colspan="2" align="center"><input type="submit" value="Save Changes" name="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <input type="reset" value="Reset" name="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </td>
      </tr>
    </table>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_Configure_Banner_Zone{

	$Param{Default_Zone} = $dbh->quote(&Web_Decode($Param{Default_Zone}));
	$Param{Default_Campaign} = $dbh->quote(&Web_Decode($Param{Default_Campaign}));
	
	if (!$Param{Default_Zone}) {$Param{Default_Zone} = '';}
	if (!$Param{Default_Campaign}) {$Param{Default_Campaign} = '';}

	$Query = qq!UPDATE Banner_Zones SET Default_Zone=$Param{Default_Zone} , Default_Campaign=$Param{Default_Campaign} WHERE Zone=$Param{Zone}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	
	&Manage_Banner_Zones;
}
#==========================================================
sub Add_New_Banner_Account{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Account_Form(""), "Create New Banner Account", $Help);
}
#==========================================================
sub Banner_Account_Form{
my($Required_Account) = @_;
my($Query, $sth);
my($Out, %Account);
	
	undef %Account;

	if ($Required_Account) {
			$Required_Account = $dbh->quote($Required_Account);
			$Query = qq!SELECT * FROM Banner_Accounts WHERE Account=$Required_Account!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Account = "";
			while ($Temp = $sth->fetchrow_hashref){%Account = %{$Temp};}
			$sth->finish;
			$Title ="Edit Banner Account";
	}
	else{
			$Title ="Create New Banner Account";
	}

	if ($Account{Account}) {
			$Account_ID = $Account{Account};
			$Param{Edit_Account} = "$Account{Account}";
	}
	else{
		$Account_ID = qq!<input type="text" name="Account" value="$Account{Account}" size="20">!;
		$Param{Edit_Account} = "";
	}
	my $Nav = Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<form method="post" action="$Global{AdminURL}">
 <input type="hidden" name="action" value="Save_New_Banner_Account">
 <input type="hidden" name="Edit_Account" value="$Param{Edit_Account}">

<DIV align="center">
    <CENTER>
    <table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
      <tr>
        <td class="TableCell" nowrap>Account ID:</td>
        <td class="TableCell" width="100%" nowrap>$Account_ID</td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Login Password:</td>
        <td class="TableCell" width="100%" nowrap><input name="Password" size="20"  value="$Account{Password}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Email Address:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Email" size="30"  value="$Account{Email}" ></td>
      </tr>

		<tr>
        <td class="TableCell" nowrap>Full Name:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Name" size="30"  value="$Account{Name}" ></td>
      </tr>

      <tr>
        <td class="TableCell" nowrap>Company:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Company" size="30"  value="$Account{Company}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Street Address:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Street" size="30"  value="$Account{Street}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>City:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="City" size="20"  value="$Account{City}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>State:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="State" size="20"  value="$Account{State}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Zip:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Zip" size="15"  value="$Account{Zip}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Country:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Country" size="20"  value="$Account{Country}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Phone:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Phone" size="20"  value="$Account{Phone}" ></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Fax: </td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Fax" size="20"  value="$Account{Fax}" ></td>
      </tr>
      <tr>
        <td class="TableCell" valign="top" nowrap>Comments or <BR>Payment Information:</td>
        <td class="TableCell" width="100%" nowrap><textarea rows="10" name="Comments" cols="70">$Account{Comments}</textarea></td>
      </tr>
      <tr>
        <td colspan="2" align="center"><input type="submit" value="Submit" name="Submit" style="width:100px;">&nbsp;
          <input type="reset" value="Reset" name="Reset" style="width:100px;">
			  </td>
      </tr>
    </table>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_New_Banner_Account{
my($Msg, $Out);
my ($Help);

	$Help = &Help_Link("Banner_Manager");

	$Msg = "";

	$Param{Account} =~ s/^\s+//;
	$Param{Account} =~ s/\s+$//;
	$Param{Password} =~ s/^\s+//g;
	$Param{Password} =~ s/\s+$//g;
	

	if (!$Param{Edit_Account}) {
		if (!$Param{Account}) {$Msg = "Please Enter Account ID.<BR>";}
	}
	if (!$Param{Password}){$Msg .= "Please Enter Password.<BR>";}

	$Param{Account} =$dbh->quote($Param{Account});
	
	if (!$Param{Edit_Account}) {
			$Query = qq!SELECT count(*) FROM Banner_Accounts WHERE Account=$Param{Account}!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while(@Row = $sth->fetchrow_array) {
						if ($Row[0]) {$Msg = "This account already exists. Please choose another Account ID";}
			}
			$sth->finish;
	}

	if ($Msg) {
			$Out =&Msgs("Missing Information", $Msg, 1);
			&Print_Page($Out, "Banner Manager", $Help);
			return;
	}

	$Param{Email} =~ s/^\s+//g;
	$Param{Email} =~ s/\s+$//g;

	$Param{Name} =~ s/^\s+//g;
	$Param{Name} =~ s/\s+$//g;

	$Param{Company} =~ s/^\s+//;
	$Param{Company} =~ s/\s+$//;

	$Param{Street} =~ s/^\s+//;
	$Param{Street} =~ s/\s+$//;

	$Param{City} =~ s/^\s+//;
	$Param{City} =~ s/\s+$//;

	$Param{State} =~ s/^\s+//;
	$Param{State} =~ s/\s+$//;

	$Param{Zip} =~ s/^\s+//;
	$Param{Zip} =~ s/\s+$//;

	$Param{Country} =~ s/^\s+//;
	$Param{Country} =~ s/\s+$//;

	$Param{Phone} =~ s/^\s+//;
	$Param{Phone} =~ s/\s+$//;

	$Param{Fax} =~ s/^\s+//;
	$Param{Fax} =~ s/\s+$//;

	$Param{Comments} =~ s/^\s+//;
	$Param{Comments} =~ s/\s+$//;

	$Param{Password} = $dbh->quote($Param{Password});
	$Param{Email} = $dbh->quote($Param{Email});
	$Param{Name} = $dbh->quote($Param{Name});
	$Param{Company} = $dbh->quote($Param{Company});
	$Param{Street} = $dbh->quote($Param{Street});
	$Param{City} = $dbh->quote($Param{City});
	$Param{State} = $dbh->quote($Param{State});
	$Param{Zip} = $dbh->quote($Param{Zip});
	$Param{Country} =$dbh->quote($Param{Country});
	$Param{Phone} = $dbh->quote($Param{Phone});
	$Param{Fax} = $dbh->quote($Param{Fax});
	$Param{Comments} = $dbh->quote($Param{Comments});
	
	if (!$Param{Edit_Account}) {
			$Param{Status} = 1;
			$Param{Start_Date} =$dbh->quote(&Time(time));

			$Query = qq!INSERT INTO Banner_Accounts 
								VALUES(
													$Param{Account},
													$Param{Password},
													$Param{Email},
													$Param{Name},
													$Param{Company},
													$Param{Street},
													$Param{City},
													$Param{State},
													$Param{Zip},
													$Param{Country},
													$Param{Phone},
													$Param{Fax},
													$Param{Status},
													$Param{Start_Date},
													$Param{Comments}
								)!;

				$Out =&Msgs("New Banner Account", "The new banner account <b>$Param{Account}</b> has been created and enabled.", 2);
	}
	else{
				$Param{Edit_Account} = $dbh->quote($Param{Edit_Account});
				$Query = qq!UPDATE Banner_Accounts  SET 
													Password=$Param{Password},
													Email=$Param{Email},
													Name=$Param{Name},
													Company=$Param{Company},
													Street=$Param{Street},
													City=$Param{City},
													State=$Param{State},
													Zip=$Param{Zip},
													Country=$Param{Country},
													Phone=$Param{Phone},
													Fax=$Param{Fax},
													Comments=$Param{Comments}
													WHERE Account=$Param{Edit_Account}
								!;
			$Out =&Msgs("Banner Account Saved", "The changes to the banner account <b>$Param{Edit_Account}</b> has been saved.", 2);							
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	$sth->finish;
	
	&Print_Page($Out, "Banner Manager", $Help);
						
}
#==========================================================
sub Edit_Banner_Account{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Account_Form($Param{Account}), "Edit Banner Account", $Help);
}
#==========================================================
sub Manage_Banner_Accounts{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Manage_Banner_Accounts_Form, "Manage Banner Accounts", $Help);
}
#==========================================================
sub Manage_Banner_Accounts_Form{
my($Out);
my($Query, $sth);

	$Query = qq!SELECT Account, Status FROM Banner_Accounts ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Account, $Status) = $sth->fetchrow_array) {
			push @Accounts, $Account;
			$Accounts{$Account} = $Status;
	}

	$sth->finish;
	#------------------------------------------------------
	undef %Count;
	$Query = qq!SELECT Account, COUNT(Campaign) FROM Banner_Campaigns GROUP BY Account!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(($Account, $Count) = $sth->fetchrow_array) {
			$Count{$Account} = $Count;
	}

	$sth->finish;
	#------------------------------------------------------
	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Accounts;
	$LastPage = int ($TotalCount / $Global{Admin_Accounts_Per_Page});
	if (($TotalCount % $Global{Admin_Accounts_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}
	$NextPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Accounts&Page=$NextPage">Next >></A>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Accounts&Page=$PrevPage"><< Prev</A>!;

	$Start = ($CurrentPage - 1) * $Global{Admin_Accounts_Per_Page};
	$End = $Start + $Global{Admin_Accounts_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next >>";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "<< Prev";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}

	$Accounts = "";
	for $Count($Start..$End-1) {
		$x = $Count+1;
		$Temp = $Accounts[$Count];
		$Account = &Web_Encode($Accounts[$Count]);
		if ($Accounts{$Account}) {
				$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Account_Status&Account=$Account&Status=Enabled&Page=$Param{Page}">Enabled</A>!;
		}
		else{
				$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Account_Status&Account=$Account&Status=Disabled&Page=$Param{Page}">Disabled</A>!;
		}

		$Campaigns = qq!<a href="$Global{AdminURL}action=Manage_Banner_Account_Campaigns&Account=$Account">$Count{$Account}</A>!;
		if (!$Count{$Account}) {$Campaigns ="None";}

		$Delete = qq~<a href="#" onClick="Delete_Banner_Account_Confirm(\'$Account\', \'$Temp\'); return false;">Delete</A>~;

		$Account = qq!<a href="$Global{AdminURL}action=Edit_Banner_Account&Account=$Account">$Account</A>!;

		$Accounts .=qq!
		  <tr>
			<td align="center" width="10%">&nbsp;$x</td>
			<td align="center" width="30%">&nbsp;$Account</td>
			<td align="center" width="30%">&nbsp;$Campaigns</td>
			<td align="center" width="15%">&nbsp;$Status</td>
			<td align="center" width="15%">&nbsp;$Delete</td>
		  </tr>
		!;

	}
	
	$Start++;

	my $Nav = Banner_Manager_Nav;

$Out =<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<div align="center"><center>

<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">

      <tr>
        <td align="center" width="10%" class="TableHeader"><b>#</b></td>
        <td align="center" width="30%" class="TableHeader"><b>Account</b></td>
        <td align="center" width="30%" class="TableHeader"><b>Campaigns</b></td>
        <td align="center" width="15%" class="TableHeader" colspan="2"><b>Action</b></td>
      </tr>

		$Accounts

    </table>
    </center>
  </div>
  <input type="hidden" name="action" value="Save_New_Banner_Account">
</form>

<p align="right">Showing $Start - $End of $TotalCount totals &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$PrevPage &nbsp;&nbsp; $NextPage	&nbsp;&nbsp;&nbsp;</P>

<script language="javascript">
<!--
function Delete_Banner_Account_Confirm(Account_Encoded, Account) {
	var agree=confirm("Are you sure you want to Delete the banner Account ["+Account+"] and all its campaigns\\n");
	if (agree){
				window.location = "$Global{AdminURL}action=Delete_Banner_Account&Account=" +Account_Encoded;
	}
}
-->
</script>
HTML
	return $Out;
}
#==========================================================
sub Delete_Banner_Account{
my($Query);

	$Param{Account} = $dbh->quote($Param{Account});
	$Query = qq!DELETE FROM Banner_Accounts WHERE Account=$Param{Account}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Accounts;
}
#==========================================================
sub Change_Banner_Account_Status{

	$Status = 1;
	if ($Param{Status} eq "Enabled") {$Status = 0;}
	
	$Param{Account} = $dbh->quote($Param{Account});
	$Query = qq!UPDATE Banner_Accounts SET Status = $Status WHERE Account=$Param{Account}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Accounts;
}
#==========================================================
sub Add_New_Banner_Campaign{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Campaign_Form(""), "Create New Banner Campaign", $Help);
}
#==========================================================
sub Banner_Campaign_Form{
my($Campaign) = @_;
my($Out, $Temp, $Temp1, $Accounts_Menu);
my($Selected, $Target_Tag_Menu);
my($Query, $sth);
	
	undef %Campaign;
	#------------------------------------------------------
	if ($Campaign) {
			$Campaign = $dbh->quote($Campaign);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$Campaign = undef;
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
			$sth->finish;

			$Temp = $Campaign{Banner_URL};
			$Temp =~ s|^http://||;

			$Banner = "";
			if ($Temp){
					$Banner .= qq!<BR><P align="center"><IMG SRC="$Campaign{Banner_URL}" BORDER="0">!;
			}
			
			if ($Campaign{Text_Banner}){
					$Banner .= "<BR>$Campaign{Text_Banner}<BR>";
			}
	}
	else{
			$Banner = "";
	}
	#------------------------------------------------------	
	$Query = qq!SELECT Account FROM Banner_Accounts ORDER BY Account ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Accounts_Menu = "";
	while(($Account) = $sth->fetchrow_array) {
			$Temp = &Web_Encode($Account);
			$Temp1 = "";
			if ($Account eq $Campaign{Account}) {$Temp1 = "SELECTED";}
			$Accounts_Menu .= qq!<OPTION value="$Temp" $Temp1>&nbsp;&nbsp; $Account &nbsp;&nbsp;!;
	}

	$sth->finish;
	#------------------------------------------------------	
	$Selected = "";
	if (!$Campaign{Target_Tag}) {$Selected = "SELECTED";}
	$Target_Tag_Menu = qq!<OPTION value="" $Selected>Page Default!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_self") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION value="_self" $Selected>Same Frame!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_top") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION value="_top" $Selected>Whole Page!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_blank") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION value="_blank" $Selected>New Window!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "_parent") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION value="_parent" $Selected>Parent Frame!;
	$Selected = "";
	if ($Campaign{Target_Tag} eq "new") {$Selected = "SELECTED";}
	$Target_Tag_Menu .= qq!<OPTION value="new" $Selected>Reuse New Window!;
	#------------------------------------------------------
	$Day = ""; $Month = ""; $Year = "";
	if ($Campaign{Start_Date}) {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++
	}

	$Day1 = ""; $Month1 = ""; $Year1 = "";
	if ($Campaign{End_Date}) {
					($Day1, $Month1, $Year1) = (localtime($Campaign{End_Date}))[3..5];	
					$Year1 += 1900;
					$Month1++;
	}
	#------------------------------------------------------
	$Clicks = "";
	$Impressions = "";
	$Time_Period = "";
	if ($Campaign{Type} eq "Clicks"){$Clicks = "CHECKED";}
	if ($Campaign{Type} eq "Impressions"){$Impressions = "CHECKED";}
	if ($Campaign{Type} eq "Time Period"){$Time_Period = "CHECKED";}
	#------------------------------------------------------
	if (!$Campaign{Max_Impressions}) {$Campaign{Max_Impressions} = "";	}
	if (!$Campaign{Max_Clicks}) {$Campaign{Max_Clicks} = "";}
	if (!$Campaign{Width}) {$Campaign{Width} = "";}
	if (!$Campaign{Height}) {$Campaign{Height} = "";}
	if (!$Campaign{Under_Text}) {$Campaign{Under_Text} = "";}
	if (!$Campaign{ALT_Text}) {$Campaign{ALT_Text} = "";}
	if (!$Campaign{Redirect_URL}) {$Campaign{Redirect_URL} = "";}
	if (!$Campaign{Banner_URL}) {$Campaign{Banner_URL} = "";}
	if (!$Campaign{Text_Banner}) {$Campaign{Text_Banner} = "";}
	#------------------------------------------------------
	my $Nav = Banner_Manager_Nav;

$Out =<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="Save_Banner_Campaign">
<div align="center"><center>

<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
      <tr><td class="TableCell" nowrap>Account :</td>
        <td class="TableCell" width="100%" nowrap>	<select size="1" name="Account">$Accounts_Menu</select></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Campaign Name:</td>
        <td class="TableCell" width="100%" nowrap><input name="Campaign"  value="$Campaign{Campaign}" size="20"></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap valign="top">Campaign Type:</td>
        <td class="TableCell" width="100%" nowrap>

          <table cellpadding="2" cellspacing="0" class="TableAttr">
            <tr>
              <td class="TableCell" nowrap><input type="radio" value="Clicks" name="Type" $Clicks> Number of clicks</td>
              <td class="TableCell"><input type="text" name="Max_Clicks" value="$Campaign{Max_Clicks}" size="20"> Clicks allowed</td>
            </tr>	
            <tr>
              <td class="TableCell" nowrap><input type="radio" name="Type" value="Impressions" $Impressions> Number of impressions</td>
              <td class="TableCell"><input type="text" name="Max_Impressions"  value="$Campaign{Max_Impressions}"  size="20"> Impressions allowed</td>
            </tr>
            <tr>
              <td class="TableCell" valign="top" nowrap><input type="radio" name="Type" value="Time Period" $Time_Period> Number of days</td>
              <td class="TableCell">
						<table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
						  <tr>
							<td class="TableCell">Start Date:</td>
							<td class="TableCell"><input type="text" name="Month" value="$Month" size="3">/<input type="text" name="Day" value="$Day" size="3">/<input type="text" name="Year" value="$Year" size="3"> (mm/dd/yyyy)</td>
						  </tr>
						  <tr>
							<td class="TableCell">End Date: </td>
							<td class="TableCell"><input type="text" name="Month1" value="$Month1" size="3">/<input type="text" name="Day1"  value="$Day1" size="3">/<input type="text" name="Year1" value="$Year1" size="3"> (mm/dd/yyyy)</td>
						  </tr>
						</table>
              </td>
            </tr>
          </table>
        </td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Size:</td>
        <td class="TableCell" width="100%" nowrap>Width: <input type="text" name="Width"  value="$Campaign{Width}" size="10">&nbsp;&nbsp;&nbsp;&nbsp;
          Height: <input type="text" name="Height"  value="$Campaign{Height}"  size="10"></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Target:</td>
        <td class="TableCell" width="100%" nowrap>
				<SELECT name="Target_Tag">
					$Target_Tag_Menu
				</SELECT>			  
		  </td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Redirect URL:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Redirect_URL" value="$Campaign{Redirect_URL}" size="60"></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Under Text:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="Under_Text"  value="$Campaign{Under_Text}" size="60"></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Alt Text:</td>
        <td class="TableCell" width="100%" nowrap><input type="text" name="ALT_Text"  value="$Campaign{ALT_Text}" size="60"></td>
      </tr>
      <tr>
        <td class="TableCell" nowrap>Banner URL:</td>
        <td class="TableCell" width="100%" nowrap>
			  <input type="text" name="Banner_URL"  value="$Campaign{Banner_URL}" size="60">
			$Banner
		  </td>
      </tr>
      <tr>
        <td class="TableCell" valign="top" nowrap>HTML Banner:</td>
        <td class="TableCell" width="100%">
			  <textarea rows="7" name="Text_Banner" cols="50">$Campaign{Text_Banner}</textarea><br>
				Please use the class &lt;!--Click_Track--&gt; in your HREF of the clickable URL's inside your 
				html banner code.<BR>For example, &lt;a href="&lt;!--Click_Track--&gt;" &lt;!--TARGET--&gt;&gt; Click Here&lt;/A&gt;.
		  </td>
      </tr>
      <tr>
        <td class="TableCell" colspan="2" align="center">
					<input type="submit" value="Submit" name="Submit" style="width: 100px;">&nbsp;
					<input type="reset" value="Reset" name="Reset" style="width: 100px;">
		</td>
      </tr>
    </table>
    </center>
  </div>
</form>
HTML
	return $Out;
}
#==========================================================
sub Save_Banner_Campaign{
my($Msg, $Temp, @Row, $Found);
my($Query, $sth);

	if (!$Param{Account}){$Msg ="Please choose account for the campaign.<br>";}
	if (!$Param{Campaign}){$Msg .="Please enter a campaign name.<br>";}
	if (!$Param{Redirect_URL}){$Msg .="Please enter a Redirect URL.<br>";}
	if (!$Param{Width}){$Msg .="Please enter the banner width.<br>";}
	if (!$Param{Height}){$Msg .="Please enter the banner height.<br>";}
	if (!$Param{Type}){$Msg .="Please select the campaign type.<br>";}

	$Param{Banner_URL} =~ s/^\s+//;
	$Param{Banner_URL} =~ s/\s+$//;
	$Temp = $Param{Banner_URL};
	$Temp =~ s|^http:://||i;
	if (!$Temp) {$Param{Banner_URL} = "";}

	$Param{Text_Banner} =~ s/^\s+//;
	$Param{Text_Banner} =~ s/\s+$//;
	
	if (!$Param{Banner_URL} && !$Param{Text_Banner}) {
			$Msg .= "Please enter a banner image URL or a text banner code.<BR>";
	}

	if ($Msg) {
			$Out =&Msgs("Missing Information", $Msg, 1);
			&Print_Page($Out, "Banner Manager", $Help);
			return;
	}

	if ($Param{Type} eq "Time Period") {
			$Start_Date = timelocal(0, 0, 0, $Param{Day}, $Param{Month} - 1, $Param{Year} - 1900);
			$End_Date = timelocal(0, 0, 0, $Param{Day1}, $Param{Month1} - 1, $Param{Year1} - 1900);
			$Param{Start_Date} = $Start_Date;
			$Param{End_Date} = $End_Date;
	}
	else{
			$Param{Start_Date} = "";
			$Param{End_Date} = "";
	}

	$Param{Account} =  $dbh->quote($Param{Account});
	$Param{Campaign} = $dbh->quote($Param{Campaign});
	$Param{Target_Tag} = $dbh->quote($Param{Target_Tag});
	$Param{Redirect_URL} = $dbh->quote($Param{Redirect_URL});
	$Param{Under_Text} = $dbh->quote($Param{Under_Text});
	$Param{ALT_Text} = $dbh->quote($Param{ALT_Text});
	$Param{Banner_URL} = $dbh->quote($Param{Banner_URL});
	$Param{Text_Banner} = $dbh->quote($Param{Text_Banner});
	if (!$Param{Width}) {$Param{Width} = 468;}
	if (!$Param{Height}) {$Param{Height} = 60;}
	$Param{Type} = $dbh->quote($Param{Type});
	if (!$Param{Max_Clicks}) {$Param{Max_Clicks} = 0;}
	if (!$Param{Max_Impressions}) {$Param{Max_Impressions} = 0;}
	if (!$Param{Start_Date}) {$Param{Start_Date} = time;}
	if (!$Param{End_Date}) {$Param{End_Date} = 0;}

	$Query = qq!SELECT count(*) FROM Banner_Campaigns WHERE Campaign=$Param{Campaign}!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (@Row = $sth->fetchrow_array){$Found = $Row[0];}
	$sth->finish;

	if ($Found) {
			#if ($Param{Max_Clicks} > $Campaign{Clicks}) {Campaign{Status} = 1;}
			$Query = qq!UPDATE Banner_Campaigns SET 
											Account=$Param{Account},
											Campaign=$Param{Campaign},
											Target_Tag=$Param{Target_Tag},
											Redirect_URL=$Param{Redirect_URL},
											Under_Text=$Param{Under_Text},
											ALT_Text=$Param{ALT_Text},
											Banner_URL=$Param{Banner_URL},
											Text_Banner=$Param{Text_Banner},
											width=$Param{Width},
											Height=$Param{Height},
											Type=$Param{Type},
											Max_Clicks=$Param{Max_Clicks},
											Max_Impressions=$Param{Max_Impressions},
											Start_Date=$Param{Start_Date},
											End_Date=$Param{End_Date}
								WHERE  Campaign=$Param{Campaign}
								!;
	}
	else{

			$Param{Clicks} = 0;
			$Param{Impressions} = 0;
			$Param{Status} = 1;

			$Query = qq!INSERT INTO Banner_Campaigns VALUES(
											$Param{Account},
											$Param{Campaign},
											$Param{Target_Tag},
											$Param{Redirect_URL},
											$Param{Under_Text},
											$Param{ALT_Text},
											$Param{Banner_URL},
											$Param{Text_Banner},
											$Param{Width},
											$Param{Height},
											$Param{Type},
											$Param{Clicks},
											$Param{Max_Clicks},
											$Param{Impressions},
											$Param{Max_Impressions},
											$Param{Start_Date},
											$Param{End_Date},
											$Param{Status}
								)!;
	}

	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Out =&Msgs("Campaign Saved", "The campaign $Param{Campaign} has been saved.", 2);
	&Print_Page($Out, "Banner Manager", $Help);
	
}
#==========================================================
sub Manage_Banner_Campaigns{
my ($Help);

	$Help = &Help_Link("Manage_Zones");
	&Print_Page(&Manage_Banner_Campaigns_Form, "Manage Banner Campaigns", $Help);	
}
#==========================================================
sub Manage_Banner_Campaigns_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth, %Campaign);

	$Query = qq!SELECT Campaign FROM Banner_Campaigns ORDER BY Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {
				push @Campaigns, $Row[0];
	}
	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Campaigns;
	$LastPage = int ($TotalCount / $Global{Admin_Accounts_Per_Page});
	if (($TotalCount % $Global{Admin_Accounts_Per_Page})) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}

	$NextPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Campaigns&Page=$NextPage">Next >></A>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Campaigns&Page=$PrevPage"><< Prev</A>!;

	$Start = ($CurrentPage - 1) * $Global{Admin_Accounts_Per_Page};
	$End = $Start + $Global{Admin_Accounts_Per_Page};
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next >>";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "<< Prev";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
			$x = $Count+1;
			undef %Campaign;
			$Temp = $dbh->quote($Campaigns[$Count]);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Temp!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp}};
			$sth->finish;

			$Temp = &Web_Encode($Campaign{Campaign});
			$Campaign_Name = qq!<a href="$Global{AdminURL}action=Edit_Banner_Campaign&Campaign=$Temp"><font size="-1">$Campaign{Campaign}</font></A>!;
			$Edit = qq!<a href="$Global{AdminURL}action=Edit_Banner_Campaign&Campaign=$Temp"><font size="-1">Edit</font></A>!;

			$Temp = &Web_Encode($Campaign{Account});
			$Account = qq!<a href="$Global{AdminURL}action=Edit_Banner_Account&Account=$Temp"><font size="-1">$Campaign{Account}</font></A>!;
			
			$Progress = "";
			if ($Campaign{Type} eq "Clicks") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Clicks}) {
							$Progress = int (($Campaign{Clicks} / $Campaign{Max_Clicks}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Impressions") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Impressions}) {
							$Progress = int (($Campaign{Impressions} / $Campaign{Max_Impressions}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Time Period") {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Startd = timelocal(0, 0, 0, $Day, $Month, $Year);

					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$Start_Date = "$Month/$Day/$Year";
					
					($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$End_Date = "$Month/$Day/$Year";	
					
					($Day, $Month, $Year) = (localtime(time))[3..5];
					$Today = timelocal(0, 0, 0, $Day, $Month, $Year);

					if ($Campaign{End_Date}) {
							if (($Campaign{End_Date}-$Startd) == 0) {
									$Progress = "100%";
							}
							else{
									$Progress = int ((($Today-$Startd) / ($Campaign{End_Date}-$Startd)) * 100) . "%";
							}
					}
			}
			else{
					$Start_Date = " ";
					$End_Date = " ";
			}
			
			$Precentage = " ";
			if ($Campaign{Impressions}) {
						$Precentage = (($Campaign{Clicks} / $Campaign{Impressions}) *100 );
						$Precentage = sprintf("%2.2f\%",$Precentage);
			}

			$Temp = &Web_Encode($Campaign{Campaign});

			if ($Campaign{Status}){
					$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Enabled&Page=$Param{Page}"><font size="-2">&nbsp;Active&nbsp;</font></A>!;
			}
			else{
					$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Disabled&Page=$Param{Page}"><font size="-2">Inactive</font></A>!;
			}

			$Delete = qq!<a href="#" onClick="Delete_Banner_Campaign_Confirm(\'$Campaign{Campaign}\', \'$Temp\'); return false;"><font size="-2">Delete</font></A>!;		
			$Config = qq!<a href="$Global{AdminURL}action=Configure_Banner_Campaign&Campaign=$Campaign{Campaign}"><font size="-2">Config</font></A>!;
			$Temp = &Web_Encode($Campaign{Account});
			$Stats = qq!<a href="$Global{AdminURL}action=List_Advertiser_Campaigns&Account=$Temp&AdvertiserUsername=$Temp&AdminFlag=1&Campaign=$Campaign{Campaign}"><font size="-2">Stats</font></A>!;
			#$Code  = qq!<a href="$Global{AdminURL}action=Admin_Banner_Campaign_Stats&Campaign=$Campaign{Campaign}"><font size="-2">Code</font></A>!;
$Form =<<HTML;
    <tr>
      <td class="TableCell" align="center">$Campaign_Name</td>
      <td class="TableCell" align="center">$Account</td>
      <td class="TableCell" align="center"><font size="-1">$Campaign{Clicks}</font></td>
      <td class="TableCell" align="center"><font size="-1">$Campaign{Impressions}</font></td>
      <td class="TableCell" align="center"><font size="-1">$Precentage</font></td>
      <td class="TableCell" align="center"><font size="-1">$Progress</font></td>
       <td class="TableCell" align="center">
        <table border="0" width="100%" cellpadding="2" cellspacing="0">
          <tr>
            <td align="center" nowrap>$Config</td>
            <td align="center" nowrap>$Status</td>
            <td align="center" nowrap>$Delete</td>
            <td align="center" nowrap>$Stats</td>
          </tr>
        </table>
	</td>
	</tr>

HTML

			$Table .= $Form;
	}
	
	$sth->finish;

	$Start++;
	my $Nav =Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<div align="center"> <center>
  <table cellpadding="2" cellspacing="0" class="TableAttr" width="100%">
    <tr>
      <td width="25%" class="TableHeader" align="center"><b>Campaign</b></td>
      <td width="20%" class="TableHeader" align="center"><b>Account</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Clicks</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Impr</b></td>
      <td width="7%" class="TableHeader" align="center"><b>CTR</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Spent</b></td>
      <td width="25%" class="TableHeader" align="center" nowrap><b>Action</b></td>
    </tr>

$Table

</table>
  </center>
</div>
<p align="right">Showing $Start - $End of $TotalCount totals &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$PrevPage &nbsp;&nbsp; $NextPage	&nbsp;&nbsp;&nbsp;</P>

<script language="JavaScript">
<!--
function Delete_Banner_Campaign_Confirm(Campaign_Encoded, Campaign) {
	var agree=confirm("Are you sure you want to Delete the banner Campaign ["+Campaign+"] \\n");
	if (agree){
			var agree=confirm("Please note once the Campaign deleted, all its logs and statistics also will be deleted\\nAre you sure you still want to delete the banner Campaign ["+Campaign+"]\\n");
			if (agree){
				window.location = "$Global{AdminURL}action=Delete_Banner_Campaign&Campaign=" +Campaign_Encoded;
			}
	}
}
-->
</script>
HTML
	
	return $Out;

}
#==========================================================
sub Manage_Banner_Account_Campaigns{
my ($Help);

	$Help = &Help_Link("Manage_Banner_Account_Campaigns");
	&Print_Page(&Manage_Banner_Account_Campaigns_Form, "Manage Banner Account Campaigns", $Help);	
}
#==========================================================
sub Manage_Banner_Account_Campaigns_Form{
my($Out, $Form, $Count, $Table);
my($Zone, $Default_Zone, $Default_Campaign);
my($Query, $sth, %Campaign);

	$Account = $dbh->quote($Param{Account});
	$Query = qq!SELECT Campaign FROM Banner_Campaigns Where Account=$Account ORDER BY Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {
				push @Campaigns, $Row[0];
	}
	$sth->finish;

	if (!$Param{Page}) {$Param{Page} = 1;}

	$TotalCount = @Campaigns;
	$LastPage = int ($TotalCount / 10);
	if (($TotalCount % 10)) { $LastPage++; }
	$CurrentPage = $Param{Page};
	$NextPage = $CurrentPage + 1;
	$PrevPage = $CurrentPage - 1;
	if ($NextPage > $LastPage) {$NextPage = $LastPage;}

	$NextPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Campaigns&Page=$NextPage">Next >></A>!;
	$PrevPage_Link = qq!<a href="$Global{AdminURL}action=Manage_Banner_Campaigns&Page=$PrevPage"><< Prev</A>!;

	$Start = ($CurrentPage - 1) * 10;
	$End = $Start + 10;
	if ($End > $TotalCount) {$End = $TotalCount;}

	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Next >>";
	}
	else{
			$NextPage = $NextPage_Link;
	}

	if ($CurrentPage == 1) {
			$PrevPage = "<< Prev";
	}
	else{
			$PrevPage = $PrevPage_Link;
	}

	$Table = "";
	for $Count($Start..$End-1) {
			$x = $Count+1;
			undef %Campaign;
			$Temp = $dbh->quote($Campaigns[$Count]);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Temp!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp}};
			$sth->finish;

			$Temp = &Web_Encode($Campaign{Campaign});
			$Campaign_Name = qq!<a href="$Global{AdminURL}action=Edit_Banner_Campaign&Campaign=$Temp"><font size="-1">$Campaign{Campaign}</font></A>!;
			$Edit = qq!<a href="$Global{AdminURL}action=Edit_Banner_Campaign&Campaign=$Temp"><font size="-1">Edit</font></A>!;

			$Temp = &Web_Encode($Campaign{Account});
			$Account = qq!<a href="$Global{AdminURL}action=Edit_Banner_Account&Account=$Temp"><font size="-1">$Campaign{Account}</font></A>!;
			
			$Progress = "";
			if ($Campaign{Type} eq "Clicks") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Clicks}) {
							$Progress = int (($Campaign{Clicks} / $Campaign{Max_Clicks}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Impressions") {
					$Start_Date = "-";
					$End_Date = "-";
					if ($Campaign{Max_Impressions}) {
							$Progress = int (($Campaign{Impressions} / $Campaign{Max_Impressions}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Time Period") {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Startd = timelocal(0, 0, 0, $Day, $Month, $Year);

					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$Start_Date = "$Month/$Day/$Year";
					
					($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$End_Date = "$Month/$Day/$Year";	
					
					($Day, $Month, $Year) = (localtime(time))[3..5];
					$Today = timelocal(0, 0, 0, $Day, $Month, $Year);

					if ($Campaign{End_Date}) {
							$Progress = int ((($Today-$Startd) / ($Campaign{End_Date}-$Startd)) * 100) . "%";
					}
			}
			else{
					$Start_Date = " ";
					$End_Date = " ";
			}
			
			$Precentage = " ";
			if ($Campaign{Impressions}) {
						$Precentage = (($Campaign{Clicks} / $Campaign{Impressions}) *100 );
						$Precentage = sprintf("%2.2f\%",$Precentage);
			}

			$Temp = &Web_Encode($Campaign{Campaign});

			if ($Campaign{Status}){
					$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Enabled&Page=$Param{Page}"><font size="-2">&nbsp;Active&nbsp;</font></A>!;
			}
			else{
					$Status = qq!<a href="$Global{AdminURL}action=Change_Banner_Campaign_Status&Campaign=$Temp&Status=Disabled&Page=$Param{Page}"><font size="-2">Inactive</font></A>!;
			}

			$Delete = qq!<a href="#" onClick="Delete_Banner_Campaign_Confirm(\'$Campaign{Campaign}\', \'$Temp\'); return false;"><font size="-2">Delete</font></A>!;		
			$Config = qq!<a href="$Global{AdminURL}action=Configure_Banner_Campaign&Campaign=$Campaign{Campaign}"><font size="-2">Config</font></A>!;
			$Temp = &Web_Encode($Campaign{Account});
			$Stats = qq!<a href="$Global{AdminURL}action=List_Advertiser_Campaigns&Account=$Temp&AdvertiserUsername=$Temp&AdminFlag=1&Campaign=$Campaign{Campaign}"><font size="-2">Stats</font></A>!;
			#$Code  = qq!<a href="$Global{AdminURL}action=Admin_Banner_Campaign_Stats&Campaign=$Campaign{Campaign}"><font size="-2">Code</font></A>!;
$Form =<<HTML;
    <tr>
      <td align="center">$Campaign_Name</td>
      <td align="center">$Account</td>
      <td align="center"><font size="-1">$Campaign{Clicks}</font></td>
      <td align="center"><font size="-1">$Campaign{Impressions}</font></td>
      <td align="center"><font size="-1">$Precentage</font></td>
      <td align="center"><font size="-1">$Progress</font></td>
       <td align="center"  >
        <TABLE BORDER="0" width="100%" CELLPADDING="2" CELLSPACING="0">
          <tr>
            <td align="center" nowrap>$Config</td>
            <td align="center" nowrap>$Status</td>
            <td align="center" nowrap>$Delete</td>
            <td align="center" nowrap>$Stats</td>
          </tr>
        </table>
	</td>
	</tr>

HTML

			$Table .= $Form;
	}
	
	$sth->finish;

	$Start++;
	my $Nav =Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<div align="center"> <center>
  <table border="01" width="100%" cellspacing="0" cellpadding="3" class="TableAttr">
    <tr>
      <td width="25%" class="TableHeader" align="center"><b>Campaign</b></td>
      <td width="20%" class="TableHeader" align="center"><b>Account</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Clicks</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Impr</b></td>
      <td width="7%" class="TableHeader" align="center"><b>CTR</b></td>
      <td width="7%" class="TableHeader" align="center"><b>Spent</b></td>
      <td width="25%" class="TableHeader" align="center" nowrap><b>Action</b></td>
    </tr>

$Table

</table>
  </CENTER>
</DIV>
<P align="right">Showing $Start - $End of $TotalCount totals &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$PrevPage &nbsp;&nbsp; $NextPage	&nbsp;&nbsp;&nbsp;</P>

<script language="JavaScript">
<!--
function Delete_Banner_Campaign_Confirm(Campaign_Encoded, Campaign) {
	var agree=confirm("Are you sure you want to Delete the banner Campaign ["+Campaign+"] \\n");
	if (agree){
			var agree=confirm("Please note once the Campaign deleted, all its logs and statistics also will be deleted\\nAre you sure you still want to delete the banner Campaign ["+Campaign+"]\\n");
			if (agree){
				window.location = "$Global{AdminURL}action=Delete_Banner_Campaign&Campaign=" +Campaign_Encoded;
			}
	}
}
-->
</script>
HTML
	
	return $Out;

}
#==========================================================
sub Change_Banner_Campaign_Status{
my($Status, $Query);

	$Status = 1;
	if ($Param{Status} eq "Enabled") {$Status = 0;}
	
	$Param{Campaign} = $dbh->quote($Param{Campaign});

	$Query = qq!UPDATE Banner_Campaigns SET Status = $Status WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!UPDATE Banners SET Status = $Status WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	&Manage_Banner_Campaigns;
}
#==========================================================
sub Delete_Banner_Campaign{
	
	$Param{Campaign} = $dbh->quote($Param{Campaign});		
	$Query = qq!DELETE FROM Banner_Campaigns WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Banners WHERE Campaign=$Param{Campaign}!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	# delete its logs and stats

	&Manage_Banner_Campaigns;
}
#==========================================================
sub Edit_Banner_Campaign{
my ($Help);

	$Help = &Help_Link("Banner_Manager");
	&Print_Page(&Banner_Campaign_Form("$Param{Campaign}"), "Edit Banner Campaign", $Help);

}
#==========================================================
sub Configure_Banner_Campaign{
my ($Help);
			
	$Help = &Help_Link("Configure_Banner_Campaign");
	&Print_Page(&Configure_Banner_Campaign_Form("$Param{Campaign}"), "Configure Banner Campaign", $Help);
}
#==========================================================
sub Configure_Banner_Campaign_Form{
my($Campaign) = @_;
my($Out, $Temp);

	$Campaign_encoded = $dbh->quote($Campaign);

	$Query = qq!SELECT Zone FROM Banners WHERE Campaign=$Campaign_encoded ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	undef %Zones;
	while(($Zone) = $sth->fetchrow_array) {
			$Zones{$Zone} = 1;
	}
	$sth->finish;
	#-------------------
	$Query = qq!SELECT Zone FROM Banner_Zones ORDER BY Zone ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	$Zone_Menu = "";
	while(($Zone) = $sth->fetchrow_array) {
			push @Zones, $Zone;
			$Temp = &Web_Encode($Zone);
			$Temp1 = "";
			if (exists $Zones{$Zone}) {$Temp1 = "SELECTED";}
			$Zone_Menu .= qq!<OPTION value="$Temp" $Temp1>$Zone!;
	}
	$sth->finish;
	my $Nav =Banner_Manager_Nav;

$Out=<<HTML;
<div style="padding: 0px; width: 100%">$Nav</div><br>

<P>Select the zones that the campaign will rotate in.</P>
<FORM METHOD="POST" ACTION="$Global{AdminURL}">
 <input type="hidden" name="action" value="Save_Banner_Campaign_Configuration">
<input type="hidden" name="Campaign" value="$Campaign_encoded">
<div align="center">
    <center>
    <table border="1" cellspacing="0" cellpadding="4" width="100%" class="TableAttr">
      <tr>
        <td nowrap width="20%" Valign="top">Campaign:</td>
        <td width="80%">$Campaign</td>
      </tr>
      <tr>
        <td nowrap width="20%" Valign="top">Active Zones:</td>
        <td width="80%">
			To Select more than one zone from the list, drag your mouse or click with the &lt;CTRL&gt; Key pressed. <BR>
				<P align="center">
			<SELECT size="8" name="Zones_Selected" MULTIPLE>
			<OPTION value="">------    Select Campaign Rotation Zones    ------</OPTION>
			$Zone_Menu
          </SELECT>
			</P>

			 </td>
      </tr>
      <tr>
        <td align="center" HEIGHT="25" colspan="2"><input type="submit" value="Save Changes" name="Submit" STYLE="color: #000080; border-style: ridge">&nbsp;
          <input type="reset" value="Reset" name="Reset" STYLE="color: #000080; border-style: ridge">&nbsp;
			  </td>
      </tr>
    </table>
    </CENTER>
  </DIV>
</FORM>
HTML
	return $Out;
}
#==========================================================
sub Save_Banner_Campaign_Configuration{

	$Campaign = $Param{Campaign};
	$Param{Campaign} = &Web_Decode($Param{Campaign});
	$Param{Zones_Selected} = &Web_Decode($Param{Zones_Selected});
	#print "Content-Type: text/html\n\n";
	#print "$Param{Zones_Selected}";
	@Zones = split(/\|\|/, $Param{Zones_Selected});

	$Query = qq!SELECT Status FROM Banner_Campaigns WHERE Campaign=$Campaign!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	while($Temp = $sth->fetchrow_array) {$Status = $Temp;}
	$sth->finish;

	$Query = qq!DELETE FROM Banners WHERE Campaign=$Campaign!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

	foreach $Zone (@Zones) {
				$Zone = $dbh->quote($Zone);
				$Query = qq!INSERT INTO Banners VALUES($Param{Campaign}, $Zone, '$Status')!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);		
	}

	$sth->finish;
			
	$Out =&Msgs("Configuration Saved", "The campaign $Campaign zones configuration has been saved.", 2);
	&Print_Page($Out, "Banner Manager", $Help);
}
#==========================================================
1;