=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub LoadReport {
my($Table, $Out, @Campaigns, $Stats_Menus, $Template);
	
	$Param{AdminFlag} ||= 0;

	@Campaigns = &Get_Account_Campaigns($Param{Account});
	$Stats_Menus = &Get_Advertisers_Stats_Menus(@Campaigns);
	
	if (!$Param{Campaign}) {&List_Advertiser_Campaigns; return;}
	$Table = "";
	
	if ($Param{ReportType} eq "daily_report") {	
				$Table =  &Get_Daily_Report_Page($Param{Campaign});
	}
	elsif ($Param{ReportType} eq "hourly_report") {
				$Table =  &Get_Hourly_Report_Page($Param{Campaign});
	}
	elsif ($Param{ReportType} eq "click_log_report") {
				$Table =  &Get_Click_Log_Report_Page($Param{Campaign});
	}

	$Stats_Menus =~ s/<!--Stats_Listing-->/$Table/g;

	if ($Param{AdminFlag}) {
			&Print_Page($Stats_Menus, "Banner Advertiser Stats", "");
	}
	else{
			$Template = &TranslateFilex($Global{BannerTemplate});
			#------------------------------------------------------
			$Plugins{AdvertiserLogin} = qq!$Global{CGI_URL}/$Global{BannerStatsProg}!;
			$Plugins{AdvertiserLogout} = qq!$Global{CGI_URL}/$Global{BannerStatsProg}?action=Logout!;
			#------------------------------------------------------
			while (($K, $V) = each %Plugins) {
				$Template =~ s/<!--CLASS::$K-->/$V/g;
			}
			#------------------------------------------------------
			$Template =~ s/<!--Body-->/$Stats_Menus/g;
			#------------------------------------------------------
			while (($K, $V) = each %Plugins) {
				$Template =~ s/<!--CLASS::$K-->/$V/g;
			}
			#------------------------------------------------------
			print "Content-type: text/html\n\n";
			print "$Template";
	}

}
#==========================================================
sub Get_Click_Log_Report_Page{
my($Campaign)  = @_;
my($Temp, $Table, $Form, $Campaign_Enc);
my($Query, $sth, $Counter, @Forms, $Forms);
my($H, $M, $S, $Y, $D);

	if (!$Campaign) {&List_Advertiser_Campaigns;}
	$Campaign_Enc = $dbh->quote($Campaign);
	
	@Forms = ($Global{BannerClickLogTableRow}, $Global{BannerClickLogTableRow1});
	$Forms = "";

	$mon = $Param{ReportMonth};
	$year = $Param{ReportYear};
	if(length($mon) == 1) {$mon = "0$mon";}
	$Counter_Row  = 0;
	for $Counter(1..31) {
			$Form_Row = &Translatex($Forms[int($Counter % 2)]);
			$mday = $Counter;
			if(length($mday) == 1) {$mday = "0$mday";}
			$Today = $year.":".$mon.":". $mday;
			$Today = $dbh->quote($Today);			
			
			$Query = qq!SELECT * FROM Banner_Click_Log WHERE Campaign=$Campaign_Enc AND Date=$Today ORDER BY Date DESC!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute() || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			
			while ($Temp = $sth->fetchrow_hashref){
					$Counter_Row++;
					$Form = &Translatex($Forms[int($Counter_Row  % 2)]);
					undef %Stats;
					%Stats = %{$Temp};
					$Form =~ s/<!--Campaign-->/$Stats{Campaign}/g;
					
					($Y, $M, $D) = split(":", $Stats{Date});
					$Form =~ s/<!--Year-->/$Y/g;
					$Form =~ s/<!--Month-->/$M/g;
					$Form =~ s/<!--Day-->/$D/g;
					
					($H, $M, $S) = split(":", $Stats{Time});
					$Form =~ s/<!--Hour-->/$H/g;
					$Form =~ s/<!--Minute-->/$M/g;
					$Form =~ s/<!--Second-->/$S/g;

					$Form =~ s/<!--IP-->/$Stats{Remote}/g;
					$Form =~ s/<!--Refere-->/$Stats{Refer}/g;
					$Form =~ s/<!--Agent-->/$Stats{Agent}/g;
					$Forms .= $Form;
			}
			$sth->finish;
	}

	$Table = &Translatex($Global{BannerClickLogTable});
	$Table =~ s/<!--Table-->/$Forms/g;
	return $Table;
}
#==========================================================
sub Get_Daily_Report_Page{
my($Campaign)  = @_;
my($Temp, $Table, $Row, @Row, $Form, $CTR, $Campaign_Enc);
my($Start_Date, $End_Date, $Query, $sth, $Counter);

	$Campaign_Enc = $dbh->quote($Campaign);
	#------------------------------------------------------
	$Global{BannerImpressionsBar} = "$Global{Images}/imprbar.gif";
	$Global{BannerClicksBar} = "$Global{Images}/clickbar.gif";
	#---------------------------------------------------------------------------------------
	$Max_Impr = 0;
	$Max_Click = 0;

	$mon = $Param{ReportMonth};
	$year = $Param{ReportYear};
	if(length($mon) == 1) {$mon = "0$mon";}

	for $Counter(1..31) {
				$mday = $Counter;
				if(length($mday) == 1) {$mday = "0$mday";}
				$Today = $year.":".$mon.":". $mday;

				$Today = $dbh->quote($Today);
				$Query = qq!SELECT Clicks, Impressions FROM Banner_Daily_Stats WHERE Campaign=$Campaign_Enc AND Date=$Today!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute() || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				while (@Row = $sth->fetchrow_array){
					if ($Row[0] > $Max_Click) {$Max_Click = $Row[0];}
					if ($Row[1] > $Max_Impr) {$Max_Impr = $Row[1];}
				}
				$sth->finish;
	}
	
	if (!$Max_Impr) {$Max_Impr = 1;}
	$Impr_Tick = $Global{Banner_Gragh_Width} / $Max_Impr;

	if (!$Max_Click) {$Max_Click = 1;}
	$Click_Tick = $Global{Banner_Gragh_Width} / $Max_Click;
	#------------------------------------------------------
	$Rows = "";
	$mon = $Param{ReportMonth};
	$year = $Param{ReportYear};
	if(length($mon) == 1) {$mon = "0$mon";}

	for $Counter(1..31) {
		$mday = $Counter;
		if(length($mday) == 1) {$mday = "0$mday";}
		$Today = $year.":".$mon.":". $mday;
		$Today = $dbh->quote($Today);

		$Query = qq!SELECT Clicks, Impressions, Date FROM Banner_Daily_Stats WHERE Campaign=$Campaign_Enc AND Date=$Today!;
		$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
		$sth->execute() || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
		while (@Row = $sth->fetchrow_array){
					$Form = $Global{BannerDailyReportTableRow};
					$Form =~ s/<!--Counter-->/$Counter/g;
					$Form =~ s/<!--Clicks-->/$Row[0]/g;
					$Form =~ s/<!--Imprs-->/$Row[1]/g;
					$CTR = "";
					if ($Row[1]) {
								$CTR = sprintf("%.2f", (($Row[0] / $Row[1]) *100 ));
								$CTR =~ s/\.0+$//g;
								$CTR .= "%"
					}
					else{
								$CTR = "&nbsp;";
					}

					$Form =~ s/<!--CTR-->/$CTR/g;

					$Click_Width = $Row[0] * $Click_Tick;
					$Impr_Width = $Row[1] * $Impr_Tick;
					$Temp=qq!<table border="0" width="200" cellspacing="0" cellpadding="0">
									  <tr>
										<td width="100%"><img border="01" src="$Global{BannerImpressionsBar}" width="$Impr_Width" height="6"></td>
									  </tr>
									  <tr>
										<td width="100%"><img border="01" src="$Global{BannerClicksBar}" width="$Click_Width" height="6"></td>
									  </tr>
									</table>		
									!;
					$Form =~ s/<!--Graph-->/$Temp/g;

					$Rows .= $Form;
		}
		$sth->finish;
	}
	#------------------------------------------------------
	$Table = &Translatex($Global{BannerDailyReportTable});
	$Table =~ s/<!--Table-->/$Rows/g;
	
	$Temp = qq!<img border="1" src="$Global{BannerImpressionsBar}" width="5" height="6">!;
	$Table =~ s/<!--Impr_Img-->/$Temp/g;

	$Temp = qq!<IMG border="1" SRC="$Global{BannerClicksBar}" width="5" height="6">!;
	$Table =~ s/<!--Click_Img-->/$Temp/g;

	$Temp = sprintf("%.5f", $Click_Tick);
	$Temp =~ s/\.0+$//g;
	$Table =~ s/<!--Impr_Factor-->/$Temp/g;

	$Temp = sprintf("%.5f", $Impr_Tick);
	$Temp =~ s/\.0+$//g;
	$Table =~ s/<!--Click_Factor-->/$Temp/g;
	#------------------------------------------------------
	$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign_Enc!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
	$sth->finish;

	if ($Campaign{Impressions}) {
						$CTR = sprintf("%.2f", (($Campaign{Clicks} / $Campaign{Impressions}) *100 ));
						$CTR =~ s/\.0+$//g;
	}

	$Table =~ s/<!--Clicks-->/$Campaign{Clicks}/g;
	$Table =~ s/<!--Impressions-->/$Campaign{Impressions}/g;
	$Table =~ s/<!--CTR-->/$CTR/g;

	return $Table;
}
#==========================================================
sub Get_Hourly_Report_Page{
my($Campaign)  = @_;
my($Temp, $Table, $Row, @Row, $Form, $CTR);
my($Start_Date, $End_Date, $Query, $sth, $Counter);

	$Campaign_Enc = $dbh->quote($Campaign);

	$mon = $Param{ReportMonth};
	$year = $Param{ReportYear};
	if(length($mon) == 1) {$mon = "0$mon";}
	#------------------------------------------------------
	$Global{BannerImpressionsBar} = "$Global{Images}/imprbar.gif";
	$Global{BannerClicksBar} = "$Global{Images}/clickbar.gif";
	#---------------------------------------------------------------------------------------
	$Max_Impr = 0;
	$Max_Click = 0;

	for $Counter(0..23) {
				$hour = $Counter;
				if (length($hour) == 1) {$hour = "0$hour";}
				$This_Hour = "$year:$mon:$hour";
				$This_Hour = $dbh->quote($This_Hour);
				$Query = qq!SELECT Clicks, Impressions, Hour FROM Banner_Hourly_Stats WHERE Campaign=$Campaign_Enc AND Hour=$This_Hour!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute() || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				while (@Row = $sth->fetchrow_array){
					if ($Row[0] > $Max_Click) {$Max_Click = $Row[0];}
					if ($Row[1] > $Max_Impr) {$Max_Impr = $Row[1];}
				}
				$sth->finish;
	}
	
	if (!$Max_Impr) {$Max_Impr = 1;}
	$Impr_Tick = $Global{Banner_Gragh_Width} / $Max_Impr;

	if (!$Max_Click) {$Max_Click = 1;}
	$Click_Tick = $Global{Banner_Gragh_Width} / $Max_Click;
	#------------------------------------------------------
	for $Counter(0..23) {
				$hour = $Counter;
				if (length($hour) == 1) {$hour = "0$hour";}
				$This_Hour = "$year:$mon:$hour";
				$This_Hour = $dbh->quote($This_Hour);
				$Query = qq!SELECT Clicks, Impressions, Hour FROM Banner_Hourly_Stats WHERE Campaign=$Campaign_Enc AND Hour=$This_Hour!;
				$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				$sth->execute() || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				while (@Row = $sth->fetchrow_array){
							$Form = $Global{BannerHourlyReportTableRow};
							$Form =~ s/<!--Counter-->/$Counter/g;
							$Form =~ s/<!--Clicks-->/$Row[0]/g;
							$Form =~ s/<!--Imprs-->/$Row[1]/g;
							if ($Row[1]) {
										$CTR = sprintf("%.2f", (($Row[0] / $Row[1]) *100 ));
										$CTR =~ s/\.0+$//g;
										$CTR .= "%";
							}
							else{
										$CTR = "&nbsp;";
							}

							$Form =~ s/<!--CTR-->/$CTR/g;

							$Click_Width = $Row[0] * $Click_Tick;
							$Impr_Width = $Row[1] * $Impr_Tick;
							$Temp=qq!<table border="0" width="200" cellspacing="0" cellpadding="0">
											  <tr>
												<td width="100%"><img border="01" src="$Global{BannerImpressionsBar}" width="$Impr_Width" height="6"></td>
											  </tr>
											  <tr>
												<td width="100%"><img border="01" src="$Global{BannerClicksBar}" width="$Click_Width" height="6"></td>
											  </tr>
											</table>		
											!;
							$Form =~ s/<!--Graph-->/$Temp/g;

							$Rows .= $Form;
				}
				$sth->finish;
	}
	$Table = &Translatex($Global{BannerHourlyReportTable});
	$Table =~ s/<!--Table-->/$Rows/g;
	#------------------------------------------------------
	#------------------------------------------------------
	
	$Temp = qq!<img border="1" src="$Global{BannerImpressionsBar}" width="5" height="6">!;
	$Table =~ s/<!--Impr_Img-->/$Temp/g;

	$Temp = qq!<img border="1" src="$Global{BannerClicksBar}" width="5" height="6">!;
	$Table =~ s/<!--Click_Img-->/$Temp/g;

	$Temp = sprintf("%.5f", $Click_Tick);
	$Temp =~ s/\.0+$//g;
	$Table =~ s/<!--Impr_Factor-->/$Temp/g;

	$Temp = sprintf("%.5f", $Impr_Tick);
	$Temp =~ s/\.0+$//g;
	$Table =~ s/<!--Click_Factor-->/$Temp/g;
	#------------------------------------------------------
	$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign_Enc!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
	$sth->finish;

	if ($Campaign{Impressions}) {
						$CTR = sprintf("%.2f", (($Campaign{Clicks} / $Campaign{Impressions}) *100 ));
						$CTR =~ s/\.0+$//g;
						$CTR .= "%";
	}

	$Table =~ s/<!--Clicks-->/$Campaign{Clicks}/g;
	$Table =~ s/<!--Impressions-->/$Campaign{Impressions}/g;
	$Table =~ s/<!--CTR-->/$CTR/g;
	#$Table =~ s/<!--Total_Graph-->/$CTR/g;

	return $Table;
}
#==========================================================
sub List_Advertiser_Campaigns{
my($Table, $Out, @Campaigns, $Stats_Menus, $Template);

	if (!$Param{AdminFlag}) {$Param{AdminFlag} = 0;}

	@Campaigns = &Get_Account_Campaigns($Param{Account});
	$Stats_Menus = &Get_Advertisers_Stats_Menus(@Campaigns);
	
	$Campaigns_List = &List_Account_Campaigns_Form(@Campaigns);
	$Stats_Menus =~ s/<!--Stats_Listing-->/$Campaigns_List/g;

	if ($Param{AdminFlag}) {
			&Print_Page($Stats_Menus, "Banner Advertiser Stats", "");
	}
	else{
			$Template = &TranslateFilex($Global{BannerTemplate});
			$Plugins{AdvertiserLogin} = qq!$Global{CGI_URL}/$Global{BannerStatsProg}!;
			$Plugins{AdvertiserLogout} = qq!$Global{CGI_URL}/$Global{BannerStatsProg}?action=Logout!;
			#------------------------------------------------------
			while (($K, $V) = each %Plugins) {
				$Template =~ s/<!--CLASS::$K-->/$V/g;
			}
			#------------------------------------------------------
			$Template =~ s/<!--Body-->/$Stats_Menus/g;
			#------------------------------------------------------
			while (($K, $V) = each %Plugins) {
				$Template =~ s/<!--CLASS::$K-->/$V/g;
			}
			#------------------------------------------------------
			print "Content-type: text/html\n\n";
			print "$Template";
	}

}
#==========================================================
sub Get_Account_Campaigns{
my($Account) = @_;
my($Temp, $Query, $sth, $Out, @Campaigns, @Row);

	undef @Campaigns;
	$Temp = $dbh->quote($Account);
	$Query = qq!SELECT Campaign FROM Banner_Campaigns WHERE Account=$Temp!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while (@Row = $sth->fetchrow_array){push @Campaigns, $Row[0];}
	$sth->finish;

	return @Campaigns;
}
#==========================================================
sub Get_Advertisers_Stats_Menus{
my(@Campaigns) = @_;
my($Temp, $Query, $sth, $Out, $Campaign, %Campaign);

	$Out = &TranslateFilex($Global{BannerStatsTemplate});
	$Out =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Out =~ s/<!--AdvertiserUsername-->/$Param{Account}/g;
	$Out =~ s/<!--Account-->/$Param{Account}/g;
	$Out =~ s/<!--AdvertiserPassword-->/$Param{Password}/g;
	$Out =~ s/<!--AdminFlag-->/$Param{AdminFlag}/g;

	my( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst )= localtime( time );
   $mon++;
   $year += 1900;
	
	$Month="";
	if (!$Param{ReportMonth}) { $Param{ReportMonth} = $mon;}
	for $x(1..12) {
		if ($x == $Param{ReportMonth}) {
			$Month .= qq!<option value="$x" selected>$x</option>!;
		}
		else{
			$Month .= qq!<option value="$x">$x</option>!;
		}
	}

	$Year = "";
	if (!$Param{ReportYear}) { $Param{ReportYear} = $year;}
	for $x(2008..2015) {
			if ($x == $Param{ReportYear}) {
					$Year .= qq!<option value="$x" selected>$x</option>!;
			}
			else{
					$Year .= qq!<option value="$x">$x</option>!;
			}
	}

	$Out =~ s/<!--ReportMonthMenu-->/$Month/g;
	$Out =~ s/<!--ReportYearMenu-->/$Year/g;
	
   $Temp2 = "";

	$Temp1 = "";
	if (!$Param{Campaign}) {$Temp1 = "selected";}
	$Temp2 .= qq!<option value="" $Temp1>$Language{all_campaigns_summary}!;

   foreach $Temp(@Campaigns) {
			$Temp1 = "";
			if ($Temp eq $Param{Campaign}) {$Temp1 = "selected";}
			$Temp2 .= qq!<option value="$Temp" $Temp1>$Temp!;
   }
	
	$Out =~ s/<!--CampaignMenu-->/$Temp2/g;
   
	if (!$Param{ReportType}) {$Param{ReportType} = "";	}
	
	$Temp1 = "";
	if ($Param{ReportType} eq "daily_report") {$Temp1 = "selected";}
	$Temp = qq!<option value="daily_report" $Temp1>$Language{daily_report}!;

	$Temp1 = "";
	if ($Param{ReportType} eq "hourly_report") {$Temp1 = "selected";}
	$Temp .= qq!<option value="hourly_report" $Temp1>$Language{hourly_report}!;

	$Temp1 = "";
	if ($Param{ReportType} eq "click_log_report") {$Temp1 = "selected";}
	$Temp .= qq!<option value="click_log_report" $Temp1>$Language{click_log_report}!;

	$Out =~ s/<!--ReportTypeMenu-->/$Temp/g;

	return $Out;
}
#==========================================================
sub List_Account_Campaigns_Form{
my(@Campaigns) = @_;
my($Out);

	$Form = "";
	$Rows = "";
	$Count = 0;
	foreach $Campaign(@Campaigns) {
			$Count++;
			$Temp = $dbh->quote($Campaign);
			$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Temp!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
			$sth->finish;

			$Form = $Global{BannerListCampaignsRow};

			$Form =~ s/<!--Counter-->/$Count/g;
			$Form =~ s/<!--Campaign-->/$Campaign{Campaign}/g;
			$Form =~ s/<!--Clicks-->/$Campaign{Clicks}/g;
			$Form =~ s/<!--Imprs-->/$Campaign{Impressions}/g;

			$Progress = "";
			if ($Campaign{Type} eq "Clicks") {
					if ($Campaign{Max_Clicks}) {
							$Progress = int (($Campaign{Clicks} / $Campaign{Max_Clicks}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Impressions") {
					if ($Campaign{Max_Impressions}) {
							$Progress = int (($Campaign{Impressions} / $Campaign{Max_Impressions}) * 100) . "%";
					}
			}
			elsif ($Campaign{Type} eq "Time Period") {
					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Startd = timelocal(0, 0, 0, $Day, $Month, $Year);

					($Day, $Month, $Year) = (localtime($Campaign{Start_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$Start_Date = "$Month/$Day/$Year";
					
					($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
					$Year += 1900;
					$Month++;
					$End_Date = "$Month/$Day/$Year";	
					
					($Day, $Month, $Year) = (localtime(time))[3..5];
					$Today = timelocal(0, 0, 0, $Day, $Month, $Year);

					if ($Campaign{End_Date}) {
							if (($Campaign{End_Date}-$Startd) == 0) {
									$Progress = "100%";
							}
							else{
									$Progress = int ((($Today-$Startd) / ($Campaign{End_Date}-$Startd)) * 100) . "%";
							}
					}
			}
			
			$Precentage = " ";
			if ($Campaign{Impressions}) {
						$Precentage = (($Campaign{Clicks} / $Campaign{Impressions}) *100 );
						$Precentage = sprintf("%2.2f\%",$Precentage);
			}

			$Form =~ s/<!--CTR-->/$Precentage/g;
			$Form =~ s/<!--Progress-->/$Progress/g;
			
			$Rows .= $Form;
	} 

	$Table = &Translatex($Global{BannerListCampaignsTable});
	$Table =~ s/<!--Table-->/$Rows/g;

	return $Table;
}
#==========================================================
sub AdvertiserLogout {

	&Delete_Cookies("AdvertiserUsername", "AdvertiserPassword");
	$Cookies{AdvertiserUsername} = "";
	$Cookies{AdvertiserPassword} = "";
	$Global{AdvertiserUsername} = "";
	$Global{AdvertiserPassword} = "";
	$Param{AdvertiserUsername} = "";
	$Param{AdvertiserPassword} = "";
	
	&CheckAdvertiserLogin;
}
#==========================================================
sub CheckAdvertiserLogin {
my ($Out);

	$Param{AdvertiserUsername} ||= "";
	$Param{AdvertiserPassword} ||= "";
	
	if (!&CheckAccount($Param{AdvertiserUsername}, $Param{AdvertiserPassword})){
			$Out = &TranslateFilex($Global{BannerLoginTemplate});
			$Out =~ s/<!--Action-->/$Global{ProgURL}/g;
			$Out =~ s/<!--Language-->/$Global{Language}/g;
			if ($Global{Demo_Mode}) {
				$Param{AdvertiserUsername} = "mewsoft";
				$Param{AdvertiserPassword} = "mewsoft";
			}
			$Out =~ s/<!--AdvertiserUsername-->/$Param{AdvertiserUsername}/g;
			$Out =~ s/<!--AdvertiserPassword-->/$Param{AdvertiserPassword}/g;
			print "Content-type: text/html\n\n";
			print "$Out";
			&Quit;
	}	
	
	return 1;
}
#==========================================================
sub CheckAccount {
my($Account, $Password) = @_;
my($Query, $sth, $Temp, %Account);
	
	if (!$Account || !$Password) { return 0;}
	
	undef %Account;

	$Temp = $dbh->quote($Account);
	$Query = qq!SELECT * FROM Banner_Accounts WHERE Account=$Temp!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Account = %{$Temp};}
	$sth->finish;

	if ((lc($Account{Account}) eq lc($Account)) && ($Account{Password} eq $Password)){
			$Global{Account} = $Account;
			$Global{Password} = $Password;
			$Param{Account} = $Account;
			$Param{Password} = $Password;
			return 1;
	}

	return 0;
}
#==========================================================
sub LoadLangFilex{
my($Language_Filename) = shift;
my (@Variables, $Line, $Key, $Value);

	open(FILE, "$Language_Filename") or
									&Exit("Error: Can't open language file $Language_Filename: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	@Variables = <FILE>;
	close(FILE);
	
	foreach $Line (@Variables) {
		chomp($Line);
		($Key, $Value)=split('~==~', $Line);
		$Value =~ s/\'/\&\#39\;/g;
		$Key =~ s/^\s+//;
		if ($Key) {
				$Language{$Key} = $Value;
		}
	}

}
#==========================================================
sub GetLangFilex{ 
my ($Language_Filename) = @_;
my (%Langs, @Variables, $Line);
my ($Key, $Value);

	open(FILE, "$Language_Filename") or
									&Exit("Error: Can't open file lnaguage file $Language_Filename: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	@Variables = <FILE>;
	close(FILE);
	
	foreach $Line (@Variables) {
				chomp($Line);
				($Key, $Value) = split('~==~', $Line);
				$Value =~ s/\'/\&\#39\;/g;
				$Key =~ s/^\s+//;
				if ($Key) {
						$Langs{$Key} = $Value;
				}
	}

	return  %Langs;
}
#==========================================================
sub TranslateFilex{
my($Template_File) = shift;
my(@Templ, $Out);

	open(FILE, "$Template_File") || &Exit("Error, Can't open file $Template_File: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
    @Templ = <FILE>;
    close(FILE);

	$Out = join("", @Templ);
	$Out = Translatex($Out);
	return $Out;
}
#==========================================================
sub Translatex{
my ($Text) = @_;
my ($K, $V);

	while (($K, $V) = each %Language) {
		$Text =~ s/\[\[$K\]\]/$V/gs;
	}
	return $Text;
}
#==========================================================
1;