=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Get_Banner_Class{
my($Param, $Static_Code) = @_;
my($Required_Campaign, $Required_Zone);
my($SSI_Flag, $Banner, $Temp);

	#print "Content-type: text/html\n\n";
	if (!$Static_Code) {$Static_Code = 0;} #Building pages flag
	$Param =~ s/^\s+//;
	$Param =~ s/\s+$//;

	$Required_Campaign = undef;
	$Required_Zone = undef;
	
	if ($Param =~ m/\:/){
			($Temp, $Required_Campaign) = split(/\:/, $Param);
			$Required_Campaign =~ s/^\s+//;
			$Required_Campaign =~ s/\s+$//;
			$Required_Zone = "";
	}
	else{
			$Required_Zone = $Param;
			$Required_Zone =~ s/^\s+//;
			$Required_Zone =~ s/\s+$//;
	}
	
	$SSI_Flag = 1;
	$Banner = &Get_Banner($Required_Zone, $Required_Campaign, $SSI_Flag, $Static_Code);
	return($Banner);

}
#==========================================================
sub Get_Banner{
my($Required_Zone, $Required_Campaign, $SSI_Flag, $Static_Code) = @_;
my(%Campaign, $Banner, $Non_SSI_Banner);

	if (!$Required_Zone && !$Required_Campaign) {return "";}	
	undef %Campaign;

	if (!$Required_Zone){
			%Campaign = &Get_Banner_Campaign($Required_Campaign);
	}
	else{
			%Campaign = &Get_Zone_Banner_Campaign($Required_Zone);
	}
	
	if (!$Campaign{Campaign}) {return undef;}

	if (!$SSI_Flag) {
			$Non_SSI_Banner = $Campaign{Banner_URL};				
			&Update_Banner_Campaign_Impressions_Stats($Campaign{Campaign});
			return $Non_SSI_Banner;
	}

	$Campaign{Zone} = $Required_Zone;

	if ($Static_Code) { #Building pages flag
			$Banner = &Get_Banner_Static_Code(%Campaign);
	}
	else{
			if ($SSI_Flag == 1) {
						$Banner = &Get_Banner_Dynamic_Code(%Campaign);
						if ($Campaign{Text_Banner}){
							&Update_Banner_Campaign_Impressions_Stats($Campaign{Campaign});
						}
			}
			elsif ($SSI_Flag == 2) {
						$Banner = &Get_SSI_Banner_Code(%Campaign);
			}
	}
	
	return ($Banner);
}
#==========================================================
sub Update_Banner_Campaign_Impressions_Stats{
my($Campaign) = @_;
my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst, $Campaign_Encoded);
my($Query, $sth, $Temp, @Row, %Campaign, $This_Hour);
my($Remote, 	$Agent, $Refer, $Today);

	if (!$Campaign) {return undef;}
	($sec, $min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$mon++;
	$year += 1900;
    if(length($mday) == 1) {$mday = "0$mday";}
    if(length($mon) == 1) {$mon = "0$mon";}
	if(length($hour) == 1) {$hour = "0$hour";}
	$Today = $year.":".$mon.":". $mday;
	$This_Hour = $year.":".$mon.":".$hour;

	$Today = $dbh->quote($Today);
	$This_Hour = $dbh->quote($This_Hour);
	$Campaign_Encoded = $dbh->quote($Campaign);

	$Query = qq!UPDATE Banner_Campaigns SET Impressions=Impressions+1 WHERE Campaign=$Campaign_Encoded!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

   $Query = qq!SELECT Campaign FROM Banner_Daily_Stats WHERE Campaign=$Campaign_Encoded AND Date=$Today!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	#$sth->{NUM_OF_FIELDS};
	$Temp = "";
	while (@Row = $sth->fetchrow_array){$Temp = $Row[0];}
	$sth->finish;

	if ($Temp) {
				$Query = qq!UPDATE Banner_Daily_Stats SET Impressions = Impressions+1 WHERE Campaign=$Campaign_Encoded AND Date=$Today!;
	}
	else {
				$Query = qq!INSERT INTO Banner_Daily_Stats VALUES($Campaign_Encoded, 0, 1, $Today)!;
   }
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	#Hourly Stats
	$Query = qq!SELECT Campaign FROM Banner_Hourly_Stats WHERE Campaign=$Campaign_Encoded AND Hour=$This_Hour!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while (@Row = $sth->fetchrow_array){$Temp = $Row[0]};
	$sth->finish;

	if ($Temp) {
				$Query = qq!UPDATE Banner_Hourly_Stats SET Impressions = Impressions+1 WHERE Campaign=$Campaign_Encoded AND Hour=$This_Hour!;
	}
	else {
				$Query = qq!INSERT INTO Banner_Hourly_Stats VALUES($Campaign_Encoded, 0, 1, $This_Hour)!;
	}
	$dbh->do($Query);
	#------------------------------------------------------
	%Campaign = &Check_Banner_Campaign_Expire($Campaign);
}
#==========================================================
sub Update_Banner_Campaign_Click_Stats{
my($Campaign, $Zone) = @_;
my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);
my($Query, $sth, $Temp, $Campaign_Encoded);
my($Day, $Month, $Year, @Row, $Time_Now);
my($Today, %Campaign);
	
	if (!$Campaign) {return undef;}

	($sec, $min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(&Time(time));
	$mon++;
	$year += 1900;

	if(length($sec) == 1) {$sec = "0$sec";}
    if(length($min) == 1) {$min = "0$min";}
	if(length($hour) == 1) {$hour = "0$hour";}

	if(length($mday) == 1) {$mday = "0$mday";}
    if(length($mon) == 1) {$mon = "0$mon";}

	$Today = $year.":".$mon.":". $mday;
	$This_Hour = $year.":".$mon.":".$hour;
	$Time_Now = $hour.":".$min.":".$sec;
	
	$This_Hour = $dbh->quote($This_Hour);
	$Today = $dbh->quote($Today);
	$Campaign_Encoded = $dbh->quote($Campaign);

	$Query = qq!UPDATE Banner_Campaigns SET Clicks=Clicks+1 WHERE Campaign=$Campaign_Encoded!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

   $Query = qq!SELECT count(*) FROM Banner_Daily_Stats WHERE Campaign=$Campaign_Encoded AND Date=$Today!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Temp = "";
	while (@Row = $sth->fetchrow_array){$Temp = $Row[0];}
	$sth->finish;

   if ($Temp) {
				$Query = qq!UPDATE Banner_Daily_Stats SET Clicks = Clicks+1 WHERE Campaign=$Campaign_Encoded AND Date=$Today!;
   }
   else {
				$Query = qq!INSERT INTO Banner_Daily_Stats VALUES($Campaign_Encoded, 0, 1, $Today)!;
   }
   $dbh->do($Query);
	#------------------------------------------------------
	#Hourly Stats
   $Query = qq!SELECT count(*) FROM Banner_Hourly_Stats WHERE Campaign=$Campaign_Encoded AND Hour=$This_Hour!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Temp = "";
	while (@Row = $sth->fetchrow_array){$Temp = $Row[0]};

   if ($Temp) {
				$Query = qq!UPDATE Banner_Hourly_Stats SET Clicks = Clicks+1 WHERE Campaign=$Campaign_Encoded AND Hour=$This_Hour!;
   }
   else {
				$Query = qq!INSERT INTO Banner_Hourly_Stats VALUES($Campaign_Encoded, 1, 1, $This_Hour)!;
   }
   
   $dbh->do($Query);
	#------------------------------------------------------
	$Remote = $ENV{REMOTE_ADDR};
	$Remote =~ s/\s|\=|\'|\"|\}|\`|\)//g;

	$Agent = $ENV{HTTP_USER_AGENT};
	
	$Refer = $ENV{HTTP_REFERER};
	#$Query_String= $ENV{QUERY_STRING};

	$Remote = $dbh->quote($Remote);
	$Agent = $dbh->quote($Agent);
	$Refer = $dbh->quote($Refer);
	$Time_Now = $dbh->quote($Time_Now);

	$Query = qq!INSERT INTO Banner_Click_Log VALUES($Campaign_Encoded, $Remote, $Refer, $Agent, $Today, $Time_Now, 1)!;
	$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	%Campaign = &Check_Banner_Campaign_Expire($Campaign);
	#------------------------------------------------------
	return $Campaign{Redirect_URL};
}
#==========================================================
sub Check_Banner_Campaign_Expire{
my($Campaign) = @_;
my($Today, %Campaign, $Status, $Query);
my($Day, $Month, $Year, $Campaign_Encoded, $Temp, $sth);
	
	if (!$Campaign) {return undef;}

	undef %Campaign;
	
	$Campaign_Encoded = $dbh->quote($Campaign);
	$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign_Encoded!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
	$sth->finish;

	$Status = 1;

	if ($Campaign{Type} eq "Clicks") {
				if ($Campaign{Clicks} >= $Campaign{Max_Clicks}){$Status = 0;}
	}
	elsif ($Campaign{Type} eq "Impressions") {
				if ($Campaign{Impressions} >= $Campaign{Max_Impressions}){$Status = 0;}
	}
	elsif ($Campaign{Type} eq "Time Period") {
				($Day, $Month, $Year) = (localtime(time))[3..5];
				$Today = timelocal(0, 0, 0, $Day, $Month, $Year);
				($Day, $Month, $Year) = (localtime($Campaign{End_Date}))[3..5];
				$End_Date = timelocal(0, 0, 0, $Day, $Month, $Year);
				if ($Today >= $End_Date) {$Status = 0;}
	}
	
	if (!$Status) {
				$Query = qq!UPDATE Banner_Campaigns SET Status=0 WHERE Campaign=$Campaign_Encoded!;
				$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

				$Query = qq!UPDATE Banners SET Status =0 WHERE Campaign=$Campaign_Encoded!;
				$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

				$Campaign{Status} = 0;
	}

	$Query = qq!SELECT * FROM Banners WHERE Campaign=$Campaign_Encoded!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Temp= %{$Temp};}
	$sth->finish;

	return %Campaign;
}
#==========================================================
sub Get_Banner_Dynamic_Code{#for classes and direct calls only
my(%Campaign) = @_;
my($Temp, $Required_Campaign_Encoded);
my($Text_Banner, $Under_Text, $Banner_Image);
my($Target, $Ad_URL, $Img_URL, $Img_Attr);

	if (!$Campaign{Campaign}) {return undef;}

	$Required_Campaign_Encoded = &Web_Encode($Campaign{Campaign});

	if (!$Campaign{Banner_URL}) {$Campaign{Banner_URL} = "";}
	if (!$Campaign{Text_Banner}) {$Campaign{Text_Banner} = "";}

	$Target = " TARGET=$Campaign{Target_Tag}";
#	$Ad_URL = qq!$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&RID=!;
#	$Img_URL = qq!$Global{BannerURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&TID=0&RID=!;
	$Ad_URL = qq!$Global{BannerClickURL}?ZID=&ID=$Required_Campaign_Encoded&RID=!;
	$Img_URL = qq!$Global{BannerURL}?ZID=&ID=$Required_Campaign_Encoded&TID=0&RID=!;
	$Img_Attr = qq!BORDER="0" HEIGHT="$Campaign{Height}" WIDTH="$Campaign{Width}" align="absmiddle" ALT="$Campaign{ALT_Text}"!;

	$Banner_Image = "";

	if ($Campaign{Banner_URL}) {
$Banner_Image =<<HTML;
<tr><td width="100%" valign="top">
<script language="JavaScript">
<!--
 document.write('<A HREF="$Ad_URL' + (new Date()).getTime()+'" $Target><IMG SRC="$Img_URL' + (new Date()).getTime() + '" $Img_Attr></A>');
//-->
</script>
</td></tr>
HTML
	}
	
	$Text_Banner = "";
	if ($Campaign{Text_Banner}){
			$Temp = qq!$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded!;
			$Campaign{Text_Banner} =~ s/<!--Click_Track-->/$Temp/g;

			 $Temp = qq!TARGET="$Campaign{Target_Tag}"!;
			 $Campaign{Text_Banner} =~ s/<!--TARGET-->/$Temp/g;
			$Text_Banner = qq!<TR><TD WIDTH="100%" align="center">$Campaign{Text_Banner}</TD></TR>!;
	}

	$Under_Text = "";
	if ($Campaign{Under_Text}) {
			$Under_Text = qq!<tr><td width="100%" align="center">
											<a href="$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded" target="$Campaign{Target_Tag}">
											$Campaign{Under_Text}
											</a></td></tr>!;
	}

	$Banner = qq!
				<table border="0" cellspacing="0" cellpadding="0" width="$Campaign{Width}">
				$Banner_Image
				$Text_Banner
				$Under_Text
				</table>
				!;

	return ($Banner);
}
#==========================================================
sub Get_SSI_Banner_Code{#for SSI calls only
my(%Campaign) = @_;
my($Temp, $Required_Campaign_Encoded);
my($Text_Banner, $Under_Text, $Banner_Image);
my($Target, $Ad_URL, $Img_URL, $Img_Attr);

	if (!$Campaign{Campaign}) {return undef;}

	$Required_Campaign_Encoded = &Web_Encode($Campaign{Campaign});

	if (!$Campaign{Banner_URL}) {$Campaign{Banner_URL} = "";}
	if (!$Campaign{Text_Banner}) {$Campaign{Text_Banner} = "";}

	$Target = " TARGET=$Campaign{Target_Tag}";
#	$Ad_URL = qq!$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&RID=!;
#	$Img_URL = qq!$Global{BannerURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&TID=0&RID=!;
	$Ad_URL = qq!$Global{BannerClickURL}?ZID=&ID=$Required_Campaign_Encoded&RID=!;
	$Img_URL = qq!$Global{BannerURL}?ZID=&ID=$Required_Campaign_Encoded&TID=0&RID=!;
	$Img_Attr = qq!border="0" height="$Campaign{Height}" width="$Campaign{Width}" alt="$Campaign{ALT_Text}"!;

	$Banner_Image = "";

	if ($Campaign{Banner_URL}) {
				$Banner_Image = qq!<a href="$Ad_URL' + (new Date()).getTime()+'" $Target><img src="$Campaign{Banner_URL}" $Img_Attr></a>!;
	}
	$Text_Banner = "";

	if ($Campaign{Text_Banner}){
			$Temp = qq!$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded!;
			$Campaign{Text_Banner} =~ s/<!--Click_Track-->/$Temp/g;

			 $Temp = qq!TARGET="$Campaign{Target_Tag}"!;
			 $Campaign{Text_Banner} =~ s/<!--TARGET-->/$Temp/g;
			$Text_Banner = qq!<tr><td width="100%" align="center">$Campaign{Text_Banner}</td></tr>!;
	}

	$Under_Text = "";
	if ($Campaign{Under_Text}) {
			$Under_Text = qq!<tr><td width="100%" align="center">
											<a href="$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded" target="$Campaign{Target_Tag}">
											$Campaign{Under_Text}
											</a></td></tr>!;
	}

	$Banner = qq!
				<table border="0" cellspacing="0" cellpadding="0" width="$Campaign{Width}">
				$Banner_Image
				$Text_Banner
				$Under_Text
				</table>
				!;

	return ($Banner);
}
#==========================================================
sub Get_Banner_Static_Code{
my(%Campaign) = @_;
my($Temp, $Required_Campaign_Encoded);
my($Text_Banner, $Under_Text, $Banner_Image);
my($Target, $Ad_URL, $Img_URL, $Img_Attr);

	if (!%Campaign) {return undef;}

	$Required_Campaign_Encoded = &Web_Encode($Campaign{Campaign});

	if (!$Campaign{Banner_URL}) {$Campaign{Banner_URL} = "";}
	if (!$Campaign{Text_Banner}) {$Campaign{Text_Banner} = "";}
	
	$Target = " TARGET=$Campaign{Target_Tag}";
	$Ad_URL = qq!$Global{BannerClickURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&RID=!;
	$Img_URL = qq!$Global{BannerURL}?ZID=$Campaign{Zone}&ID=$Required_Campaign_Encoded&TID=0&RID=!;
	$Img_Attr = qq!border="0" height="$Campaign{Height}" width="$Campaign{Width}" align="absmiddle" ALT="$Campaign{ALT_Text}"!;

	if ($Global{Static_Banner_Type} eq "Normal HTML") {
		$Banner =<<HTML;
<script language="JavaScript">
<!--
 document.write('<A HREF="$Ad_URL' + (new Date()).getTime()+'" $Target><IMG SRC="$Img_URL' + (new Date()).getTime() + '" $Img_Attr></A>');
//-->
</script>
HTML

	}
	elsif ($Global{Static_Banner_Type} eq "SSI Exec") {
				$Banner = qq|<!--\#exec cgi="$Img_URL"-->|;
	}
	elsif ($Global{Static_Banner_Type} eq "SSI Include") {
				$Banner = qq|<!--\#include virtual="$Img_URL"-->| ;
	}

	return ($Banner);
}
#==========================================================
sub Get_Banner_Campaign{
my($Campaign) = @_;
my(%Campaign, $Temp, $Query, $sth, $Campaign_Encoded, $Campaign_ref);

	if (!$Campaign) {return undef;}

	$Campaign_ref = undef;
	undef %Campaign;

	$Campaign_Encoded = $dbh->quote($Campaign);

	$Query = qq!SELECT * FROM Banner_Campaigns WHERE Campaign=$Campaign_Encoded AND Status=1!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Campaign = %{$Temp};}
	$sth->finish;

	if (!$Campaign{Campaign}) {undef %Campaign;}
	
	return %Campaign;

}
#==========================================================
sub Get_Zone_Banner_Campaign{
my($Required_Zone) = @_;
my(%Campaign, $Temp, $Query, $sth, @Campaigns);
my($Campaign, $Zone_Index, @Found, @Row);
my($Campaigns_Count);

	if (!$Required_Zone) {return undef;}

	undef %Campaign;
	undef @Campaigns;

	$Required_Zone = $dbh->quote($Required_Zone);

	$Query = qq!SELECT Campaign FROM Banners WHERE Zone=$Required_Zone  AND Status=1 ORDER BY Campaign ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	while(@Row = $sth->fetchrow_array) {
			push @Campaigns, $Row[0];
	}
	$sth->finish;

	$Campaigns_Count = @Campaigns;
	if (! $Campaigns_Count) {return undef;}

	$Query = qq!SELECT Zone_Index FROM Banner_Rotation_Index WHERE Zone=$Required_Zone!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Zone_Index = 0;
	$Found = 0;
	while (@Row = $sth->fetchrow_array){
			$Zone_Index = $Row[0];
			$Found = 1;
	};
	$sth->finish;

	if (!$Zone_Index) {$Zone_Index = 0;}
	if ($Zone_Index >= $Campaigns_Count) {$Zone_Index = 0;}
	$Campaign = $Campaigns[$Zone_Index];
	if (!$Campaign) {return undef;}

	$Zone_Index++;

	if ($Found) {
			$Query = qq!UPDATE Banner_Rotation_Index SET Zone_Index=$Zone_Index WHERE Zone=$Required_Zone!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	else{
			$Query = qq!INSERT INTO Banner_Rotation_Index VALUES($Required_Zone, $Zone_Index)!;
			$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	%Campaign = &Get_Banner_Campaign($Campaign);

	return %Campaign;
}
#==========================================================
1;