=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub DirectoryTreeFolders {
my ($path) = @_;
my (@dir, $entry, $fullpath, @folders);
	
	$path ||= ".";
	$path =~ s/\\/\//g;

    opendir (DIR, $path) or &Exit( "Cannot open directory $path: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
    @dir = readdir(DIR);
    closedir (DIR);
	
	 undef @folders;
    foreach $entry (sort {lc($a) cmp lc($b)} @dir) {
        if ($entry eq '.' or $entry eq '..') { next; }
        $fullpath = "$path/$entry";
        if (-d $fullpath) {
			push @folders, $fullpath;
            push @folders, &DirectoryTreeFolders($fullpath);  # recursive directory listing
        }
    }
	return (@folders);
}
#==========================================================
sub DirectoryTreeFiles {
my ($path) = @_;
my (@dir, $entry, $fullpath, @files);
	
	$path ||= ".";
	$path =~ s/\\/\//g;

    opendir (DIR, $path) or &Exit( "Cannot open directory $path: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
    @dir = readdir(DIR);
    closedir (DIR);
	
	 undef @files;

    foreach $entry (sort {lc($a) cmp lc($b)} @dir) {
        if ($entry eq '.' or $entry eq '..') { next; }
        $fullpath = "$path/$entry";
        if (-d $fullpath) {
            push @files, &DirectoryTreeFiles ($fullpath);  # recursive directory listing
        } else {
			push @files, $fullpath;
        }
    }
	return (@files);
}
#==========================================================
# returns the directory files list with full path
sub DirectoryFiles {
my ($path) = @_;
my (@dir, $entry, $fullpath, @files, @folders);
	
	$path ||= ".";
	$path =~ s/\\/\//g;

    opendir (DIR, $path) or &Exit( "Cannot open directory $path: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
    @dir = readdir(DIR);
    closedir (DIR);
	
	 undef @files;
    foreach $entry (sort {lc($a) cmp lc($b)} @dir) {
        $fullpath = "$path/$entry";
        if ($entry ne '.' && $entry ne '..' && !-d $fullpath) {
			push @files, $fullpath;
        }
    }
	return (@files);
}
#==========================================================
# returns the directory files list without the path
sub DirectoryList {
my ($path) = @_;
my (@dir, $entry, $fullpath, @files, @folders);
	
	$path ||= ".";
	$path =~ s/\\/\//g;

    opendir (DIR, $path) or &Exit( "Cannot open directory $path: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
    @dir = readdir(DIR);
    closedir (DIR);
	
	 undef @files;
    foreach $entry (sort {lc($a) cmp lc($b)} @dir) {
        $fullpath = "$path/$entry";
        if ($entry ne '.' && $entry ne '..' && !-d $fullpath) {
			push @files, $entry;
        }
    }
	return (@files);
}
#==========================================================
1;