=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub GetAllForumsID {
	return @{$dbh->selectcol_arrayref(qq!SELECT Forum FROM Forum_Forums!)};
}
#==========================================================
sub GetForumsNumber {
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Forum_Forums!);
}
#==========================================================
sub GetForumTopics {
my ($Forum, $SortBy, $SortDir, $Period) = @_;
my ($Dir, $TimeFilter, $Sort);
	
	$Forum += 0;
	$Forum || return undef;

	if ($SortDir ==1 ) {$Dir = "ASC";	} else {$Dir = "DESC";}

	$TimeFilter = "";
	if ($Period > 0) {$TimeFilter = " AND (Time>" . (time - $Period) .")";}

	$Sort = qq!ORDER BY Type DESC!;
	if ($SortBy) {$Sort .= ", $SortBy $Dir";}
	
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Forum=$Forum $TimeFilter $Sort!)};
}
#==========================================================
sub GetForumsTopics {
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics!)};
}
#==========================================================
sub GetForumTopic {
my ($Topic) = @_;
	$Topic += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Topics WHERE Topic=$Topic LIMIT 1!)};
}
#==========================================================
sub GetForumLastTopic {
my ($Forum) = @_;
	$Forum+= 0;
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Forum=$Forum ORDER BY TIME DESC!)};
}
#==========================================================
sub GetForumLastPost {
my ($Forum) = @_;
	$Forum+= 0;
	return @{$dbh->selectcol_arrayref(qq!SELECT Post FROM Forum_Posts WHERE Forum=$Forum ORDER BY TIME DESC LIMIT 1!)};
}
#==========================================================
sub GetAllTopicsID {
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics!)};
}
#==========================================================
sub GetAllPostsID {
	return @{$dbh->selectcol_arrayref(qq!SELECT Post FROM Forum_Posts!)};
}
#==========================================================
sub GetForumPost{
my ($Post) = @_;
	$Post += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Posts WHERE Post=$Post!)};
}
#==========================================================
sub GetForumPostMedia{
my ($Post) = @_;
	$Post += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Media WHERE Post=$Post!)};
}
#==========================================================
sub GetForumTopicsCount {
my ($Forum) = @_;
	$Forum += 0;
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Forum_Topics WHERE Forum=$Forum!);
}
#==========================================================
sub GetForumPostsCount{
my ($Forum) = @_;
	$Forum += 0;
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Forum_Posts WHERE Forum=$Forum!);
}
#==========================================================
sub GetForumsTopicsCount{
	return $dbh->selectrow_array(qq!SELECT Count(Topic) FROM Forum_Topics!);
}
#==========================================================
sub GetForumsPostsCount{
	return $dbh->selectrow_array(qq!SELECT Count(Post) FROM Forum_Posts!);
}
#==========================================================
sub GetForumTopicPosts{
my ($Topic) = @_;
	$Topic += 0;
	$Topic || return undef;
	return @{$dbh->selectcol_arrayref(qq!SELECT Post FROM Forum_Posts WHERE Topic=$Topic ORDER BY Time ASC!)};
}
#==========================================================
sub GetForumMessage{
my ($Post) = @_;
	$Post += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Messages WHERE Post=$Post!)};
}
#==========================================================
sub DeleteForumPost{
my ($Post) = @_;
my ($Query, $sth, @Media, $Temp, $Media, @Files, $File);

	# Delete post attached files 
	$Post += 0;
	@Media = @{$dbh->selectcol_arrayref(qq!SELECT Media FROM Forum_Media WHERE Post=$Post!)};

	foreach $Media (@Media) {
			@Files = split(/\|/, $Media);
			foreach $File (@Files){
					unlink ("$Global{Upload_Dir}/$File");
			}
	}

	$Query = qq!DELETE FROM Forum_Posts WHERE Post=$Post!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Forum_Messages WHERE Post=$Post!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Forum_Media WHERE Post=$Post!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub GetForumIPUsers{
my ($IP, $SortDir) = @_;
my ($Query, $sth, $User, $Posts, @Users, $Counter);

	$IP = $dbh->quote($IP);
	$Query = qq!SELECT Author, COUNT(*) FROM Forum_Posts WHERE IP=$IP GROUP BY Author!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Users;
	$Counter = 0;
	while(($User, $Posts) = $sth->fetchrow_array) {
			@{$Users[$Counter++]}{qw(User Posts)} = ($User, $Posts);
	}
	$sth->finish;

	$SortDir ||= 0;
	if ($SortDir) {
				@Users = sort { $a->{Posts} <=> $b->{Posts} } @Users;
	}
	else{
				@Users = sort { $b->{Posts} <=> $a->{Posts} } @Users;
	}
	return @Users;
}
#==========================================================
sub GetForumUserIPs{
my ($Author, $SortDir) = @_;
my ($Query, $sth, $IP, $Posts, @IP, $Counter);

	$Author = $dbh->quote($Author);
	$Query = qq!SELECT IP, COUNT(*) FROM Forum_Posts WHERE Author=$Author GROUP BY IP!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @IP;
	$Counter = 0;
	while(($IP, $Posts) = $sth->fetchrow_array) {
			@{$IP[$Counter++]}{qw(IP Posts)} = ("$IP", $Posts);
	}
	$sth->finish;

	$SortDir ||= 0;
	if ($SortDir) {
				@IP = sort { $a->{Posts} <=> $b->{Posts} } @IP;
	}
	else{
				@IP = sort { $b->{Posts} <=> $a->{Posts} } @IP;
	}
	return @IP;
}
#==========================================================
sub GetTopicLastPost {
my ($Topic) = @_;
	$Topic += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Posts WHERE Topic=$Topic ORDER BY Time DESC!)};
}
#==========================================================
sub GetForumName{
my ($Forum) = @_;
	$Forum += 0;
	$Forum || return undef;
	return @{$dbh->selectcol_arrayref(qq!SELECT Name FROM Forum_Forums WHERE Forum=$Forum!)};
}
#==========================================================
sub GetForumCash{
my ($CashID) = @_;
	$CashID += 0;
	$CashID || return undef;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Search WHERE Cash=$CashID!)};
}
#==========================================================
sub PagesNumbers{
my ($CurrentPage, $LastPage) = @_;
my ($TotalPages, %Pages, $Count, $Div, $Page);
my ($LtPage, $RtPage, @Pages);

	if ($LastPage <= 25) {$Div = 1;}
	elsif ($LastPage > 25 && $LastPage <= 50) {$Div = 2;}
	elsif ($LastPage > 50 && $LastPage <= 75) {$Div = 3;}
	elsif ($LastPage > 75 && $LastPage <= 100) {$Div = 4;}
	elsif ($LastPage > 100 && $LastPage <= 250) {$Div = 5;}
	elsif ($LastPage > 250 && $LastPage <= 500) {$Div = 10;}
	elsif ($LastPage > 500 && $LastPage <= 1000) {$Div = 20;}
	elsif ($LastPage > 1000 && $LastPage <= 2500) {$Div = 40;}
	elsif ($LastPage > 2500 && $LastPage <= 5000) {$Div = 100;}
	elsif ($LastPage > 5000 && $LastPage <= 7500) {$Div = 150;}
	elsif ($LastPage > 7500 && $LastPage <= 10000) {$Div = 200;}
	elsif ($LastPage > 10000) {$Div = 250;}
	
	$TotalPages = int($LastPage / $Div);

	undef %Pages;
	for $Count(1..$TotalPages) {
		$Page = $Count * $Div;
		$Pages{$Page} = 1;
	}

	$LtPage = $CurrentPage-5;
	$RtPage = $CurrentPage+5;
	
	if ($LtPage < 1 ) {$LtPage = 1;}

	if ($RtPage > $LastPage) {$RtPage = $LastPage;}

	for $Page($LtPage..$RtPage) {
			$Pages{$Page} = 1;
	}
	
	@Pages = sort {$a <=> $b} keys %Pages;
	return @Pages;
}
#==========================================================
sub Search_Forums {
my ($Terms, $Forums, $SearchMsg, $Period, $Authors, $Mode, $SortBy, $SortDir, $SaveCash) = @_;
my (@Terms, $Term, %Required, %Execlud, %Optional);
my ($Query, $What, $AND, $OR, $NOT, $sth, $Data, @Items, $x);
my ($TimeFilter, @AuthorsFilter, $Author, $AuthorsFilter, $Dir);
my ($Temp, $Cash, $Time, $Result);

	@Terms = &PrepareForumSearchTerms($Terms);

	if (!@Terms) {
				$Global{Total_Matched_Count} = 0;
				undef @Items;
				return ("", @Items);
	}
	#------------------------------------------------------
	if ($SortDir ==1 ) {$Dir = "ASC";	} else {$Dir = "DESC";}
	#------------------------------------------------------
	foreach $Term(@Terms) {
				if ($Term =~ /^\+/) {$Term =~s/\+//; $Required{$Term}=1;}      
				elsif ($Term =~ /^\-/) {$Term =~s/\-//; $Execlud{$Term}=1;}      
				elsif ($Term =~ /^\|/) {$Term =~s/\|//; $Optional{$Term}=1;}      
				else {$Required{$Term}=1;}
	}
	
	if ($Global{Maximum_Search_Results}) {
			if ($Global{DB_Server} eq "MS_SQL") {
					$Query = qq!SELECT TOP $Global{Maximum_Search_Results} Post FROM Forum_Messages WHERE  !;
			}
			else{
					$Query = qq!SELECT Post FROM Forum_Messages WHERE !;
			}
	}
	else{
			$Query = qq!SELECT Post FROM Forum_Messages WHERE !;
	}
	

	if ($Forums) {
			$Query .= qq! Forum IN ($Forums) AND !;
	}

	$Query .= "(";

	$What = "Subject"; # Subject, Message

	$AND = "";
	foreach $Term (keys %Required) {$AND .= "$What LIKE \'%$Term%' AND ";}
	$AND =~ s/AND\s*$//;

	$OR = "";
	foreach $Term (keys %Optional) {$OR .= "$What LIKE \'%$Term%\' OR ";}
	$OR =~ s/OR\s*$//;

	$NOT = "";
	foreach $Term(keys %Execlud) {$NOT .= "$What NOT LIKE \'%$Term%\' AND ";}
	$NOT =~ s/AND\s*$//;

	if ($AND) {$Query .= " ($AND) ";}
	
	if ($NOT and $AND) {
			$Query .= " AND ($NOT) ";
	}
	elsif ($NOT) {
			$Query .= " ($NOT) ";
	}

	if ($OR && ($AND || $NOT)) {
			$Query .= " OR ($OR) ";
	}
	elsif ($OR) {
			$Query .= " ($OR) ";
	}

	$Query =~ s/AND\s*$//;
	
	if ($SearchMsg) {
				$Query .= " OR ";
				$What = "Message"; # Subject, Message

				$AND = "";
				foreach $Term (keys %Required) {$AND .= "$What LIKE \'%$Term%' AND ";}
				$AND =~ s/AND\s*$//;

				$OR = "";
				foreach $Term (keys %Optional) {$OR .= "$What LIKE \'%$Term%\' OR ";}
				$OR =~ s/OR\s*$//;

				$NOT = "";
				foreach $Term(keys %Execlud) {$NOT .= "$What NOT LIKE \'%$Term%\' AND ";}
				$NOT =~ s/AND\s*$//;

				$Query =~ s/AND\s*$//;
				
				if ($AND) {$Query .= " ($AND) ";}
				
				if ($NOT and $AND) {
						$Query .= " AND ($NOT) ";
				}
				elsif ($NOT) {
						$Query .= " ($NOT) ";
				}

				if ($OR && ($AND || $NOT)) {
						$Query .= " OR ($OR) ";
				}
				elsif ($OR) {
						$Query .= " ($OR) ";
				}

				$Query =~ s/AND\s*$//;
	}
	$Query .= ")";

	if ($Global{DB_Server} eq "MS_SQL") {}
	else{
			if ($Global{Maximum_Search_Results}) {$Query .= " LIMIT $Global{Maximum_Search_Results} ";}
	}

	if ($Mode != 1 && $SortBy eq "Title") {# sort posts by subject
			$Query .= qq! ORDER BY Subject $Dir!;
	}
	
	@Items = @{$dbh->selectcol_arrayref($Query)};
	$Global{Total_Matched_Count} = @Items;
	# @Items now contains the search results as posts not sorted or filtered
	#------------------------------------------------------
	if (!@Items) {undef @Items; return ("", @Items);}
	#------------------------------------------------------
	# Filter results by time and authors if any required
	$TimeFilter = "";
	if ($Period > 0) {
			$TimeFilter = int(time - $Period * 86400);
			$TimeFilter = "AND (Time > $TimeFilter)";
	}
	# Filter by authors
	$Authors =~ s/\,+/ /g;
	@AuthorsFilter = split (/\s+/, $Authors);

	$AuthorsFilter = "";
	if (@AuthorsFilter) {
			foreach $Author (@AuthorsFilter) {
					$Author =~ s/\*+/\%/g;
					$AuthorsFilter .= "Author Like  \'$Author\' OR ";
			}
			$AuthorsFilter =~ s/OR\s+$//g;
			$AuthorsFilter = "AND ($AuthorsFilter)";
	}
	#------------------------------------------------------
	#------------------------------------------------------
	# return result as sorted posts or topics and apply filters if required
	$Posts = join (",", @Items);

	# filter search results by time and authors
	$Temp = $dbh->selectall_arrayref(qq!SELECT Post, Topic FROM Forum_Posts WHERE Post IN ($Posts) $TimeFilter $AuthorsFilter!);
	@Items = map {$_->[0]} @{$Temp};
	@Topics = map {$_->[1]} @{$Temp};
	$Global{Total_Matched_Count} = @Items;
	#------------------------------------------------------
	if (!@Items) {undef @Items; return ("", @Items);}
	#------------------------------------------------------
	$Sort = qq!ORDER BY Type DESC!;
	if ($SortBy) {
			$Sort .= ", $SortBy $Dir";
	}

	if ($Mode == 1) { # return the result as topics sort
			$Topics =  join (",", @Topics);
			@Items = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Topic IN ($Topics) GROUP BY Topic $Sort!)};
			$Global{Total_Matched_Count} = @Items;
	}
	else{ # return the result as posts sorted
			$Posts =  join (",", @Items);
			if ($SortBy eq "Time" || $SortBy eq "Updated" || $SortBy eq "Author") {
					@Items = @{$dbh->selectcol_arrayref(qq!SELECT Post FROM Forum_Posts WHERE Post IN ($Posts) ORDER BY $SortBy $Dir!)};
					$Global{Total_Matched_Count} = @Items;
			}
	}
	#------------------------------------------------------
	#------------------------------------------------------
	# save the search result in the cash if required
	$Cash = "";
	if ($SaveCash) {
				# Delete any old search cash
				$Time = time - int($Global{Forum_Cash_Time}*60);
				$Query = qq!DELETE FROM Forum_Search WHERE Time<=$Time!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				#------------------------------------------------------
				# Create new search cash for this search term
				$Result = join (",", @Items);
				$Result = $dbh->quote($Result);
				
				$Time = time;
				$Forums1 = $dbh->quote($Forums);
				$Term = $dbh->quote($Terms);
				$AuthorsFilter = $dbh->quote($Authors);

				$Query = qq!INSERT INTO Forum_Search SET 
											Cash=NULL,
											Time=$Time,
											Forums=$Forums1,
											Terms=$Term,
											Authors='',
											AuthorsFilter=$AuthorsFilter,
											Mode=$Mode,
											Period=$Period,
											TitlesOnly=$SearchMsg,
											Result=$Result
									!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				$Cash = $dbh->{mysql_insertid};
	}
	#------------------------------------------------------
	#&p ($Query);
	return ($Cash, @Items);
}
#==========================================================
sub Search_Forums_Authors {
my ($Authors, $Forums, $Period, $Mode, $SortBy, $SortDir, $SaveCash) = @_;
my (@Items, $TimeFilter, @AuthorsFilter, $AuthorsFilter, $Author, $Temp);
my ($ForumsFilter, $Query, $sth, $Post, $Topic, $Topics, $Posts, %Topics);
my ($Cash, $Dir, $Time, $Result, $Forums1, $Term);

	if (!$Authors) {
			undef @Items; return ("", @Items);
	}
	#------------------------------------------------------
	# Filter results by time and authors
	$TimeFilter = "";
	if ($Period > 0) {
			$TimeFilter = int(time - $Period * 86400);
			 $TimeFilter = qq! AND(Time>$TimeFilter)!;
	}
	# Filter by authors
	$Authors =~ s/\,+/ /g;
	@AuthorsFilter = split (/\s+/, $Authors);

	$AuthorsFilter = "";
	if (@AuthorsFilter) {
			foreach $Author (@AuthorsFilter) {
					$Author =~ s/\*+/\%/g;
					$AuthorsFilter .= "Author Like  \'$Author\' OR ";
			}
			$AuthorsFilter =~ s/OR\s+$//g;
			$AuthorsFilter = "($AuthorsFilter)";
	}
	#------------------------------------------------------
	$ForumsFilter = "";
	if ($Forums) {
			$ForumsFilter = qq! AND Forum IN ($Forums)!;
	}
	#------------------------------------------------------
	if ($SortDir ==1 ) {$Dir = "ASC";	} else {$Dir = "DESC";}
	#------------------------------------------------------
	$Temp = $dbh->selectall_arrayref(qq!SELECT Post, Topic FROM Forum_Posts WHERE $AuthorsFilter $TimeFilter $ForumsFilter!);
	@Items = map {$_->[0]} @{$Temp};
	@Topics = map {$_->[1]} @{$Temp};
	$Global{Total_Matched_Count} = @Items;
	#------------------------------------------------------
	if (!@Items) {undef @Items; return ("", @Items);}
	#------------------------------------------------------
	$Sort = qq!ORDER BY Type DESC!;
	if ($SortBy) {
			$Sort .= ", $SortBy $Dir";
	}

	if ($Mode == 1) { # return the result as topics sorted
			$Topics =  join (",", @Topics);
			@Items = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Topic IN ($Topics) GROUP BY Topic $Sort!)};
			$Global{Total_Matched_Count} = @Items;
	}
	else{ # return the result as posts sorted
			$Posts =  join (",", @Items);
			if ($SortBy eq "Time" || $SortBy eq "Updated" || $SortBy eq "Author") {
					@Items = @{$dbh->selectcol_arrayref(qq!SELECT Post FROM Forum_Posts WHERE Post IN ($Posts) ORDER BY $SortBy $Dir!)};
					$Global{Total_Matched_Count} = @Items;
			}
	}
	#------------------------------------------------------
	if (!@Items) {return ("", @Items);}
	#------------------------------------------------------
	#------------------------------------------------------
	# save the search result in the cash if required
	$Cash = "";
	if ($SaveCash) {
				# Delete any old search cash
				$Time = time - int($Global{Forum_Cash_Time}*60);
				$Query = qq!DELETE FROM Forum_Search WHERE Time<=$Time!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				#------------------------------------------------------
				# Create new search cash for this search term
				$Result = join (",", @Items);
				$Result = $dbh->quote($Result);
				
				$Time = time;
				$Forums1 = $dbh->quote($Forums);
				$Term = $dbh->quote($Terms);
				$AuthorsFilter = $dbh->quote($Authors);

				$Query = qq!INSERT INTO Forum_Search SET 
											Cash=NULL,
											Time=$Time,
											Forums=$Forums1,
											Terms='',
											Authors=$AuthorsFilter,
											AuthorsFilter='',
											Mode=$Mode,
											Period=$Period,
											TitlesOnly=1,
											Result=$Result
									!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
				$Cash = $dbh->{mysql_insertid};
	}
	#------------------------------------------------------
	return ($Cash, @Items);
}
#==========================================================
sub ParseForumTopicsList{
my ($Action, $FormAction, $Template, $Form1, $Form2, $Mode, $User, $PostLink, @Topics) = @_;
my (@Forms, $TotalCount, $LastPage, $CurrentPage);
my ($NextPage, $PrevPage, $Temp, $Pages, $Link);
my ($Start, $End, $LastPostTimeClass, $LastPostTimeFormat, $Output);
my ($Counter, $Topic, %Topic, $Form, %Forum, %LastPost);
my ($StartTime);

	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Param{Forum}/g;
	$Template =~ s/<!--Category-->/$Param{Category}/g;
	#------------------------------------------------------
	@Forms = (&Translate($Form1), &Translate($Form2));
	#------------------------------------------------------
	$Param{Page} +=0;
	$Param{Page} ||= 1;
	$Param{NewPage} += 0;
	if ($Param{NewPage} > 0) {$Param{Page} = $Param{NewPage};}
	$Global{Topics_Per_Page} ||= 10;
	$Param{PageSize} ||= $Global{Topics_Per_Page};
	$TotalCount = @Topics;
	#------------------------------------------------------
	# Pagination start
	#------------------------------------------------------
	use Pagination;
	my $paginate = Mewsoft::Pagination->new(
												entries_per_page    => $Global{Topics_Per_Page},
												total_entries       => $TotalCount, 
												current_page        => $Param{Page},
												pages_per_set       => $Global{Pages_Per_Set},
												mode => $Global{Pages_Mode}, #modes are 'slide', 'fixed', default is 'slide'
											);

	$Param{Page} = $paginate->current_page;
	$LastPage = $paginate->last_page;
	$NextPage = $paginate->next_page;
	$PrevPage = $paginate->previous_page;
	$Start = $paginate->first;
	$End = $paginate->last;
	$CurrentPage = $Param{Page};
	#------------------------------------------------------
	$NextPageLink = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$NextPage&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$PrevPageLink = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$PrevPage&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$FirstPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=1&Lang=$Global{Language}!;
	$LastPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$LastPage&Lang=$Global{Language}!;
	#------------------------------------------------------
	# Next Page, Last page
	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$Template =~ s/<!--NextPage-->/$Language{paginate_next_page_current}/g;
			$Template =~ s/<!--LastPage-->/$Language{paginate_last_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_next_page};
			$Temp =~ s/<!--Link-->/$NextPageLink/g;
			$Template =~ s/<!--NextPage-->/$Temp/g;
			if ($paginate->last_page_in_set) {
				$Temp = ""; # Last page in set, do not display the last page link
			}
			else {
				$Temp = $Language{paginate_last_page};
				$Temp =~ s/<!--Page-->/$LastPage/g; # Last page number
				$Temp =~ s/<!--Link-->/$LastPageLink/g;
			}
			$Template =~ s/<!--LastPage-->/$Temp/g;
	}
	#----------------------------------------------
	# Previous Page, First Page
	if ($CurrentPage == 1) {
			$Template =~ s/<!--PrevPage-->/$Language{paginate_prev_page_current}/g;
			$Template =~ s/<!--FirstPage-->/$Language{paginate_first_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_prev_page};
			$Temp =~ s/<!--Link-->/$PrevPageLink/g;
			$Template =~ s/<!--PrevPage-->/$Temp/g;
			if ($paginate->first_page_in_set) {
					$Temp = ""; # First page in set, do not display the first page link
			}
			else {
				$Temp = $Language{paginate_first_page};
				$Temp =~ s/<!--Link-->/$FirstPageLink/g;
			}
			$Template =~ s/<!--FirstPage-->/$Temp/g;
	}
	#------------------------------------------------------
	# Pagination Pages set
	$Pages = ""; 
	foreach $Page (@{$paginate->pages_in_set()}) {
			if ($Page == $CurrentPage) {
					$Link = $Language{paginate_current_page};
			}
			else{
					$Link = $Language{paginate_page};
			}
			$Temp = qq!$Global{ProgURL}$Action&Sorted=0&Sort=$Param{Sort}&Dir=$Param{Dir}&Page=$Page&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
			$Link =~ s/<!--Link-->/$Temp/;
			$Link =~ s/<!--Page-->/$Page/;
			$Pages .= $Link;
			if ($Page != $LastPage) {
					$Pages .= $Language{paginate_separtor};
			}
	}

	$Pages =~ s/$Language{paginate_separtor}$//g;
	$Template =~ s/<!--Pages-->/$Pages/g;
	#------------------------------------------------------
	$Temp = $Language{paginate_showing_page};
	$Temp =~ s/<!--CurrentPage-->/$CurrentPage/g;
	$Temp =~ s/<!--TotalPages-->/$LastPage/g;
	$Template =~ s/<!--ShowingPage-->/$Temp/g;
	#------------------------------------------------------
	# Pagination end
	#------------------------------------------------------
	$Template =~ s/<!--Sorted-->/0/g;
	$Template =~ s/<!--Sort-->/$Param{Sort}/g;
	$Template =~ s/<!--Dir-->/$Param{Dir}/g;
	$Template =~ s/<!--Page-->/$Param{Page}/g;
	$Template =~ s/<!--PageSize-->/$Param{PageSize}/g;
	$Template =~ s/<!--Period-->/Period=$Param{Period}/g;
	$Template =~ s/<!--Cash-->/$Param{Cash}/g;
	$Template =~ s/<!--FormAction-->/$FormAction/g;
	#------------------------------------------------------
	$Plugins{ResultsFound} =~ s/<!--Found-->/$TotalCount/g;
	$Plugins{ResultsFound} =~ s/<!--FoundStart-->/$Start/g;
	$Plugins{ResultsFound} =~ s/<!--FoundEnd-->/$End/g;
	#------------------------------------------------------
	$LastPostTimeClass = ""; $LastPostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Forms[0] =~ m/(<!--)(LastPostTime)(:\()([^\)]+)(\)-->)/){
				$LastPostTimeClass = $1 . $2 . $3. $4. $5;
				$LastPostTimeFormat =  $4;
	}
	$LastPostTimeClass =~ s/\(/\\\(/g;
	$LastPostTimeClass =~ s/\)/\\\)/g;
	#------------------------------------------------------
	# Get the topics read by the current user for the current page only
	$User ||= "";
	if ($Start > 0) {
		%Read = &GetForumUserTopicsRead($User, @Topics[$Start-1..$End-1]);
	}
	#------------------------------------------------------
	$StartTime = &Time - int($Global{UnreadTopicsTime} * 86400);
	#------------------------------------------------------
	$Output = "";
	for $Counter ($Start-1..$End-1){
				if ($Counter < 0) {next;}
				$Topic = $Topics[$Counter];
				%Topic = &GetForumTopic($Topic);
				#----------------------------------------------------------------------------------
				$Form = $Forms[int($Counter % 2)]; 
				#----------------------------------------------------------------------------------
				%LastPost = &GetForumPost($Topic{LastPost});
				#----------------------------------------------------------------------------------
				# topic icon according to Type, Status, Read
				if ($Read{$Topic} || ($LastPost{Time} < $StartTime)) {# old topic
						if (!$Topic{Status}) { # open topic
								$Icon = $Language{topic_icon_old};
						}
						else{ # locked topic
								$Icon = $Language{topic_icon_old_locked};
						}
				}
				else{ # new topic
						if (!$Topic{Status}) { # open topic
								$Icon = $Language{topic_icon_new};
						}
						else{ # locked topic
								$Icon = $Language{topic_icon_new_locked};
						}
				}

				$Form =~ s/<!--Status-->/$Icon/g;
				#----------------------------------------------------------------------------------
				if ($Topic{Replies} >= $Global{HotTopicsPosts}){
						$Icon = $Language{topic_icon_hot};
				}
				elsif ($Topic{Replies} >= $Global{PopularTopicsPosts}){
						$Icon = $Language{topic_icon_popular};
				}
				elsif ($Topic{Replies} >= $Global{CoolTopicsPosts}){
						$Icon = $Language{topic_icon_cool};
				}
				else{
						$Icon = $Language{topic_icon_normal};
				}				
				$Form =~ s/<!--Rank-->/$Icon/g;
				#----------------------------------------------------------------------------------
				$Temp = $Counter + 1;
				$Form =~ s/<!--Counter-->/$Temp/g;

				$Temp = $Topic{Type}; # Normal, Sticky, Announcement
				if ($Topic{Type} == 1) {
						$Temp = $Language{sticky_topic};
				}
				elsif ($Topic{Type} == 2) {
						$Temp = $Language{announcement_topic};
				}
				else{
						$Temp = "";
				}
				$Form =~ s/<!--Type-->/$Temp/g;

				$Temp = "";
				if ($Topic{Poll}) {$Temp = $Language{topic_has_poll};}
				$Form =~ s/<!--Poll-->/$Temp/g;
				#--------------------------------------------------------------
				#Forum_Media
				#--------------------------------------------------------------

				$TitleSanitize = &SanitizeTitle($Topic{Title});

				$Temp = qq!$Global{ProgURL}$TitleSanitize&action=ViewTopic&Topic=$Topic&Forum=$Topic{Forum}&Page=1&Period=$Param{Period}&Lang=$Global{Language}!;
				$Form =~ s/<!--TitleLink-->/$Temp/g;

				$Temp = $Topic{Title};
				$Form =~ s/<!--Title-->/$Temp/g;

				$Temp = $Topic{Title};
				$Form =~ s/<!--Preview-->/$Temp/g;

				if ($Topic{Replies} > 0) {$Temp = $Topic{Replies};}else {$Temp = $Language{zero_replies};}
				$Form =~ s/<!--Replies-->/$Temp/g;
				
				$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Topic{Author}&Lang=$Global{Language}!;
				$Form =~ s/<!--AuthorLink-->/$Temp/g;
				
				$Temp = $Topic{Author};
				$Form =~ s/<!--Author-->/$Temp/g;

				if ($Topic{Views} > 0) {$Temp = $Topic{Views};}else {$Temp = $Language{zero_views};}
				$Form =~ s/<!--Views-->/$Temp/g;
				
				$Temp = $Topic{LastPost};
				$Form =~ s/<!--LastPost-->/$Temp/g;

				$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Topic{Author}&Lang=$Global{Language}!;
				$Form =~ s/<!--LastPostAuthorLink-->/$Temp/g;
				
				if ($Mode == 1) { # show forum name for topics
						%Forum = &GetForum($Topic{Forum});
						$Temp = qq!$Global{ProgURL}action=Forums&Forum=$Topic{Forum}&Period=$Param{Period}&Lang=$Global{Language}!;
						$Form =~ s/<!--ForumLink-->/$Temp/g;
						$Form =~ s/<!--ForumName-->/$Forum{Name}/g;
				}
				
				%LastPost = &GetForumPost($Topic{LastPost});
				$Form =~ s/<!--LastPostAuthor-->/$LastPost{Author}/g;
				#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
				if ($LastPost{Time} > 0) {
						$Temp = &ParseDate($LastPostTimeFormat, $LastPost{Time});
				}
				else{	
						$Temp = "";
				}
				$Form =~ s/$LastPostTimeClass/$Temp/g;

				$Counter++;
				$Form =~ s/<!--Counter-->/$Counter/g;

				$Output .= $Form;
	}

	$Template =~ s/<!--TopicsList-->/$Output/;
	#------------------------------------------------------
	$Plugins{SortTitle} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Title&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortReplies} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Replies&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortAuthor} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Author&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortViews} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Views&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortTime} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Time&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;
	$Plugins{SortUpdated} = qq!$Global{ProgURL}$Action&Sorted=1&Sort=Updated&Dir=$Param{Dir}&Page=1&Pagesize=$Param{PageSize}&Period=$Param{Period}&Lang=$Global{Language}!;

	$Plugins{SortTitleImg} = "";
	$Plugins{SortRepliesImg} = "";
	$Plugins{SortAuthorImg} = "";
	$Plugins{SortViewsImg} = "";
	$Plugins{SortTimeImg} = "";
	$Plugins{SortUpdatedImg} = "";

	if ($Param{Dir} ==1){$Temp = $Language{sort_up_image};}
	else{$Temp = $Language{sort_dn_image};}

	if ($Param{Sort} eq "Title") {$Temp =~ s/<!--Link-->/$Plugins{SortTitle}/; $Plugins{SortTitleImg} = $Temp;}
	elsif ($Param{Sort} eq "Replies") {$Temp =~ s/<!--Link-->/$Plugins{SortReplies}/; $Plugins{SortRepliesImg} = $Temp;}
	elsif ($Param{Sort} eq "Author") {$Temp =~ s/<!--Link-->/$Plugins{SortAuthor}/; $Plugins{SortAuthorImg} = $Temp;}
	elsif ($Param{Sort} eq "Views") {$Temp =~ s/<!--Link-->/$Plugins{SortViews}/; $Plugins{SortViewsImg} = $Temp;}
	elsif ($Param{Sort} eq "Time") {$Temp =~ s/<!--Link-->/$Plugins{SortTime}/; $Plugins{SortTimeImg} = $Temp;}
	elsif ($Param{Sort} eq "Updated") {$Temp =~ s/<!--Link-->/$Plugins{SortUpdated}/; $Plugins{SortUpdatedImg} = $Temp;}
	#------------------------------------------------------
	# display the post new topic link?
	if ($PostLink) {
					$Link = $Language{forum_post_new_topic};
					$Temp = qq!$Global{ProgURL}action=NewTopic&Forum=$Param{Forum}&Lang=$Global{Language}!;
					$Link =~ s/<!--NewTopicLink-->/$Temp/g;
	}
	else{
					$Link = "";
	}
	$Template =~ s/<!--PostNewTopic-->/$Link/g;
	#------------------------------------------------------
	return $Template;
	#&Display($Template, 1);
}
#==========================================================
sub Get_ForumPeriods_Menu{
my ($Default) = @_;
my ($Form, @Periods, %Labels, $Options, $Line, $Period, $Label, $Temp);

	$Form = &Translate($Global{ForumPeriod});

	#$Global{ForumPeriods} = qq!0a,0.42h,0.25H,1d,2D,3D,1w,2W,1m,3M,6M,1y!;
	@Periods = split(/\,/, $Global{ForumPeriods});
	#----------------------------------------------------------
	%Labels = (
							a => $Language{all_periods},
							h => $Language{hour_label},
							H => $Language{hours_label},
							d => $Language{day_label},
							D => $Language{days_label},
							w => $Language{week_label},
							W => $Language{weeks_label},
							m => $Language{month_label},
							M => $Language{months_label},
							y => $Language{year_label},
							Y => $Language{years_label}
						);
	#----------------------------------------------------------
	$Options = "";
	foreach $Line (@Periods) {
				if ($Line =~ /([0-9\.]+)(.+)$/) {
						$Period = $1;
						$Label = $2;
				}
				if ($Line eq $Default) {$Sel = "selected";} else { $Sel = "";}
				$Option = $Language{forum_period_menu_option};
				if ($Period <= 0) {$Period = "";}
				$Option =~ s/<!--Period-->/$Line/g;
				$Option =~ s/<!--Value-->/$Period/g;
				$Option =~ s/<!--Selected-->/$Sel/g;
				$Option =~ s/<!--Label-->/$Labels{$Label}/g;
				$Options .= $Option;
	}
	#----------------------------------------------------------
	$Form =~ s/<!--Periods-->/$Options/g;

	$Temp = qq!$Global{ProgURL}action=Forums&Forum=$Param{Forum}&Period=!;
	$Form =~ s/<!--JumpPeriodLink-->/$Temp/g;

	$Form =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Form =~ s/<!--Language-->/$Global{Language}/g;

	$Plugins{ForumPeriods_Menu} = $Form;

	return $Form;
}
#==========================================================
sub ForumPeriods_Time{
my ($Input) = @_;	
my (@Periods, $Line, $Period, $Label, %Times);

	@Periods = split(/\,/, $Global{ForumPeriods});
	
	$Period = ""; $Label = "";
	foreach $Line (@Periods) {
			if ($Line eq $Input) {
					if ($Line =~ /([0-9\.]+)(.+)$/) {
							$Period = $1;
							$Label = $2;
					}
					last;
			}
	}

	%Times = (
						a => 0,
						h => 3600,
						H => 3600,
						d => 24*3600,
						D => 24*3600,
						w => 7*24*3600,
						W => 7*24*3600,
						m => 30*24*3600,
						M => 30*24*3600,
						y => 364*24*3600,
						Y => 364*24*3600
					);
	return ($Period * $Times{$Label});
}
#==========================================================
sub GetForumDisplayLastMenu{
my ($Default) = @_;
my ($Form, @Periods, %Labels, $Options, $Line, $Period, $Label, $Temp);

	$Form = &Translate($Global{ForumDisplayLast});

	#$Global{ForumPeriods} = qq!0a,0.42h,0.25H,1d,2D,3D,1w,2W,1m,3M,6M,1y!;
	@Periods = split(/\,/, $Global{ForumDisplayLast_Periods});
	#----------------------------------------------------------
	%Labels = (
							a => $Language{all_periods},
							h => $Language{hour_label},
							H => $Language{hours_label},
							d => $Language{day_label},
							D => $Language{days_label},
							w => $Language{week_label},
							W => $Language{weeks_label},
							m => $Language{month_label},
							M => $Language{months_label},
							y => $Language{year_label},
							Y => $Language{years_label}
						);
	#----------------------------------------------------------
	$Options = "";
	foreach $Line (@Periods) {
				if ($Line =~ /([0-9\.]+)(.+)$/) {
						$Period = $1;
						$Label = $2;
				}
				if ($Line eq $Default) {$Sel = "selected";} else { $Sel = "";}
				$Option = $Language{forum_display_last_menu_option};
				if ($Period <= 0) {$Period = "";}
				$Option =~ s/<!--Period-->/$Line/g;
				$Option =~ s/<!--Value-->/$Period/g;
				$Option =~ s/<!--Selected-->/$Sel/g;
				$Option =~ s/<!--Label-->/$Labels{$Label}/g;
				$Options .= $Option;
	}
	#----------------------------------------------------------
	$Form =~ s/<!--Periods-->/$Options/g;

	$Temp = qq!$Global{ProgURL}action=DisplayLast&Forum=$Param{Forum}&Period=!;
	$Form =~ s/<!--JumpPeriodLink-->/$Temp/g;

	$Form =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Form =~ s/<!--Language-->/$Global{Language}/g;

	$Plugins{ForumDisplayLastMenu} = $Form;

	return $Form;
}
#==========================================================
sub GetForumMenuBar {
my ($Bar, @Bar, $ID_Ref, $Name_Ref, @ID, @Name, $x, $Link, $Temp);	

	$Bar = &Translate($Global{ForumMenuBar});

	undef @Bar;
	push @Bar, $Language{bar_home};

	if ($Param{Forum}) {
			($ID_Ref, $Name_Ref) = &GetForumFullname($Param{Forum});
			@ID = @{$ID_Ref};
			@Name = @{$Name_Ref};

			 for $x (0..$#ID) {
				 $Link = $Language{bar_forum_link};
				 $Temp = qq!$Global{ProgURL}action=Forums&Forum=$ID[$x]&Lang=$Global{Language}!;
				 $Link =~ s/<!--ForumLink-->/$Temp/g;
				 $Link =~ s/<!--ForumName-->/$Name[$x]/g;
				 push @Bar, $Link;
			}

	}
	if ($Plugins{Bar_Action}) {push @Bar, $Plugins{Bar_Action};}
	
	$Temp = join ($Language{bar_separator}, @Bar);
	$Bar =~ s/<!--MenuBar-->/$Temp/;

	return $Bar;
}
#==========================================================
sub GetForum {
my ($Forum) = @_;
	$Forum += 0;
	$Forum || return undef;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Forums WHERE Forum=$Forum LIMIT 1!)};
}
#==========================================================
#Warning: We need to get sub forums for Forum = 0, the main forums
sub GetSubForums{
my ($Forum) = @_;
	$Forum += 0;
	return @{$dbh->selectcol_arrayref(qq!SELECT Forum FROM Forum_Forums WHERE Parent=$Forum ORDER BY Sort ASC!)};
}
#==========================================================
sub GetForumFullname {
my ($Forum) = @_;
my ($Parent, $Name, @Name, @ID);
	
	$Forum += 0;
	($Forum, $Parent, $Name) = $dbh->selectrow_array(qq!SELECT Forum, Parent, Name FROM Forum_Forums WHERE Forum=$Forum ORDER BY Name, Sort LIMIT 1!);
	unshift @ID, $Forum;
	unshift @Name, $Name;

	while ($Parent > 0) {
			($Forum, $Parent, $Name) = $dbh->selectrow_array(qq!SELECT Forum, Parent, Name FROM Forum_Forums WHERE Forum=$Parent ORDER BY Name, Sort LIMIT 1!);
			unshift @ID, $Forum;
			unshift @Name, $Name;
	}

	return (\@ID, \@Name);
}
#==========================================================
sub GetForumTree {
my (@ForumsID) = @_;
my ($Forums, @Saved, @Forums);
	
	$Forums = join ",", @ForumsID;
	$Forums ||= 0;
	@Forums = @{$dbh->selectcol_arrayref(qq!SELECT Forum FROM Forum_Forums WHERE Parent IN ($Forums)
																			ORDER BY Sort ASC, Name ASC!)};
	push @Saved, @Forums;
	if (@Forums) {
		push @Saved, &GetForumTree(@Forums);
	}
	return @Saved;
}
#==========================================================
sub ForumsTreeForm{
my ($ForumID, $Action)=@_;
my (@Forums, $Out, $Counter, @Tree, $Forum, @Forums);
my ($ID_Ref, $Name_Ref, @ID, @Name, $x, $Last, $Levels);
my ($Line, $Width, %Forum, $Temp, $Link, $Sel);
	
	$ForumID += 0;
	@Forums = &GetForumTree($ForumID);

	$Out = ""; $Counter = 0;
	undef @Tree;

	foreach  $Forum (@Forums) {
			($ID_Ref, $Name_Ref) = &GetForumFullname($Forum);
			@ID = @{$ID_Ref};
			@{$Tree[$Counter]}{Forum} = $ID[$#ID];
			@{$Tree[$Counter]}{Name} = join("~|~", @{$Name_Ref});
			@{$Tree[$Counter]}{Sort} = $Counter;
			$Counter++;
	}

	@Tree = sort {$a->{Name} cmp $b->{Name}} @Tree;

	for  $x (0..$#Tree) {
			@Name = split(/~\|~/, $Tree[$x]{Name});
			$Last = pop @Name;

			$Levels = @Name;
			if ($Levels > 0) {$Width = $Levels * 30;} else {$Width = 0;}

			%Forum = &GetForum($Tree[$x]{Forum});
			if (!$Forum{Topics}) {$Forum{Topics} = "0";}
			
			if (!$Levels) { #Main Forums
					$Line = $Global{ForumsTreeMainForm};
			}
			else{ #Sub forums
					$Line = $Global{ForumsTreeMainSubForm};
			}
			
			$Line =~ s/<!--Levels-->/$Width/g; 
			$Line =~ s/<!--CLASS::Images-->/$Global{Images}/g;
			$Line =~ s/<!--Name-->/$Last/g;
			
			$Link = qq!$Global{ProgURL}action=$Action&Forum=$Tree[$x]{Forum}&Lang=$Global{Language}!;					
			$Line =~ s/<!--Link-->/$Link/g;
			
			if ($Tree[$x]{Forum} == $Param{Forum}) {$Sel = "selected";} else {$Sel = "";}
			$Line =~ s/<!--Selected-->/$Sel/g;

			if ($Forum{Topics} > 0) {$Temp = $Forum{Topics};} else {$Temp = $Language{tree_zero_topics};}
			$Line =~ s/<!--Topics-->/$Temp/g;
			if ($Forum{Posts} > 0) {$Temp = $Forum{Posts};} else {$Temp = $Language{tree_zero_posts};}
			$Line =~ s/<!--Posts-->/$Temp/g;
			$Out .= $Line;
	}

	return $Out;
}
#==========================================================
sub ForumsTreeMenuList {
my ($ForumID, $All) = @_;
my (@Forums, $Out, $Counter, @Tree, $Forum, @Forums);
my ($ID_Ref, $Name_Ref, @ID, @Name, $x, $Last, $Levels);
my ($Line, $Width, %Forum, $Temp);
	
	$ForumID += 0;
	@Forums = &GetForumTree($ForumID);

	$Out = "";
	if ($All==1) { # all forums menu option
			$Out = $Language{forums_menu_list_all};
			if (!$Param{Forum}) {$Sel = "selected";} else {$Sel = "";}
			$Out =~ s/<!--Selected-->/$Sel/g;
	}
	elsif ($All==2) { # jump to main forums menu option
			$Out = $Language{forums_menu_main};
			if (!$Param{Forum}) {$Sel = "selected";} else {$Sel = "";}
			$Out =~ s/<!--Selected-->/$Sel/g;
	}

	$Counter = 0;
	undef @Tree;

	foreach  $Forum (@Forums) {
			($ID_Ref, $Name_Ref) = &GetForumFullname($Forum);
			@ID = @{$ID_Ref};
			@{$Tree[$Counter]}{Forum} = $ID[$#ID];
			@{$Tree[$Counter]}{Name} = join("~|~", @{$Name_Ref});
			@{$Tree[$Counter]}{Sort} = $Counter;
			$Counter++;
	}

	@Tree = sort {$a->{Name} cmp $b->{Name}} @Tree;

	$Forums = join "," , @Forums;
	if ($Forums) {
			$ForumsHash = $dbh->selectall_hashref(qq!SELECT * FROM Forum_Forums WHERE Forum IN ($Forums)!, 'Forum');
	}

	for  $x (0..$#Tree) {
			%Forum = %{$ForumsHash->{$Tree[$x]{Forum}}};
			@Name = split(/~\|~/, $Tree[$x]{Name});
			$Last = pop @Name;

			$Levels = @Name;
			if ($Levels > 0) {
					$Width = $Levels * 4;
			}
			else{
					$Width = 0;
			}
			
			if (!$Levels) { #Main Forums
					$Line = $Language{forums_menu_main_line};
			}
			else{ #Sub forums
					$Line = $Language{forums_menu_list_line};
			}
			
			$Temp = "&nbsp;" x $Width;
			$Line =~ s/<!--Levels-->/$Temp/g; 

			$Line =~ s/<!--Name-->/$Last/g;
			$Line =~ s/<!--Forum-->/$Tree[$x]{Forum}/g;

			if ($Tree[$x]{Forum} == $Param{Forum}) {$Sel = "selected";} else {$Sel = "";}
			$Line =~ s/<!--Selected-->/$Sel/g;

			if ($Forum{Topics} > 0) {$Temp = $Forum{Topics};} else {$Temp = $Language{tree_zero_topics};}
			$Line =~ s/<!--Topics-->/$Temp/g;
			
			if ($Forum{Posts} > 0) {$Temp = $Forum{Posts};} else {$Temp = $Language{tree_zero_posts};}
			$Line =~ s/<!--Posts-->/$Temp/g;

			$Out .= $Line;
	}

	return $Out;
}
#==========================================================
sub GetForumUserLevel {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return @{$dbh->selectcol_arrayref(qq!SELECT Level FROM Forum_Users_Info WHERE User_ID=$User_ID LIMIT 1!)};
}
#==========================================================
sub UpdateForumUserInfo{
my ($User_ID, %Info) = @_;
my ($Query, $Field);
	
	$User_ID = $dbh->quote($User_ID);
	
	$Query = qq!UPDATE Forum_Users_Info SET !;
	
	foreach $Field (keys %Info) {
			next if ($Field eq "User_ID");
			$Query .= "$Field=". $dbh->quote($Info{$Field}) .",";
	}

	$Query =~ s/\,$//g;
	$Query .= qq! WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub GetForumUserInfo {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Users_Info WHERE User_ID=$User_ID LIMIT 1!)};
}
#==========================================================
sub GetForumUser {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Users, Forum_Users_Info WHERE Users.User_ID=$User_ID AND Forum_Users_Info.User_ID=$User_ID LIMIT 1!)};
}
#==========================================================
sub GetForumUserWatchingTopics{
my ($User, $SortBy, $SortDir, $Period) = @_;
my (@Topics, $Dir, $TimeFilter, $Sort);
	
	if ($SortDir ==1 ) {$Dir = "ASC";	} else {$Dir = "DESC";}

	$TimeFilter = "";
	if ($Period > 0) {
			$TimeFilter = " AND (time>" . (time - $Period) .")"; # $Period is in seconds
	}

	$Sort = "";
	if ($SortBy) {
			$Sort = qq!ORDER BY $SortBy $Dir!;
	}

	
	$User = $dbh->quote($User);
	#------------------------------------------------------
	# get the topics this user is watching, no sorting
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Watching WHERE User=$User!)};
	#------------------------------------------------------
	if (!@Topics) {return @Topics;}
	#------------------------------------------------------
	# sort topics
	$Topics =  join (",", @Topics);
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Topic IN ($Topics) $TimeFilter GROUP BY Topic ORDER BY $SortBy $Dir!)};
	#------------------------------------------------------
	$Global{Total_Matched_Count} = @Topics;
	return @Topics;
}
#==========================================================
sub GetModeratorForums {
my ($User) = @_;
	$User = $dbh->quote($User);
	return @{$dbh->selectcol_arrayref(qq!SELECT Forum FROM Forum_Moderators WHERE User=$User!)};
}
#==========================================================
sub CheckPostActionPermissions{
my ($Action, %Post) = @_;
	
	#Forum permissions (0=>"Everyone", 1=>"Registered Users", 2=>"Private Groups", 3=>"Moderators", 4=>"Administartors");
	#User  Levels : # 0=User, 1=Admin, 2=Mod

	%Forum = &GetForum($Post{Forum});
	#------------------------------------------------------
	# check if Everyone can delete
	if ($Forum{$Action} == 0) {return 1;}
	#------------------------------------------------------
	# if current user is the owner of the post, then allow him if forum permissions allow registered
	if ($CurrentUser{Level} == 0 && $Forum{$Action} == 1 && ($Post{Author} eq $Param{User_ID}) ) {return 1;}
	#------------------------------------------------------
	# if current user is Admin, then allow him to do anything
	if ($CurrentUser{Level} == 1) {return 1;}
	#------------------------------------------------------
	# if current user is Moderator, then check if he is a moderator for this forum
	if ($CurrentUser{Level} == 2 && $Forum{$Action} <= 3) {
			if (&CheckForumModerator($Param{User_ID}, $Post{Forum})) {
					return 1;
			}
	}
	#------------------------------------------------------
	# all checks failed, not allowed operation
	return 0;
	#------------------------------------------------------
}
#==========================================================
sub CheckForumActionPermissions{
my ($Action, %Forum) = @_;
	
	#Forum permissions (0=>"Everyone", 1=>"Registered Users", 2=>"Private Groups", 3=>"Moderators", 4=>"Administartors");
	#User  Levels : # 0=User, 1=Admin, 2=Mod
	#------------------------------------------------------
	# Avoid hacking for Forum=0 permissions
	$Forum{Forum} += 0;
	$Forum{Forum} = int($Forum{Forum});
	if ($Forum{Forum} < 1) {return 0;	}
	#------------------------------------------------------
	# check if Everyone is allowed
	if ($Forum{$Action} == 0) {return 1;}
	#------------------------------------------------------
	# if current user is Administrator, then allow to do anything
	if ($CurrentUser{Level} == 1) {return 1;}
	#------------------------------------------------------
	# if current user is registered and forum permissions allow registered
	if ($CurrentUser{User_ID} ne "" && $CurrentUser{Level} == 0 && $CurrentUser{$Action} == 1 && $Forum{$Action} == 1) {return 1;}
	#------------------------------------------------------
	# if current user is moderator or administrator, he has the registered users permissions also
	if ($CurrentUser{Level} == 1 || $CurrentUser{Level} == 2){
			if ($CurrentUser{$Action} == 1 && ($Forum{$Action} == 1 || $Forum{$Action} == 2 || $Forum{$Action} == 3)) {return 1;}
	}
	#------------------------------------------------------
	# if current user is Moderator, then check if he is a moderator for this forum
	if ($CurrentUser{Level} == 2 && $Forum{$Action} <= 3){
				if (&CheckForumModerator($Param{User_ID}, $Forum{Forum})) {
						return 1;
				}
	}
	#------------------------------------------------------
	# if this is a private forum, check if the current user belongs to any group of this forum
	if ($Forum{$Action} == 2 && $Param{User_ID} ne "") {
			if (&CheckPrivateForumUser($Param{User_ID}, $Forum{Forum})) {
					return 1;
			}
	}
	#------------------------------------------------------
	# all checks failed, not allowed operation
	return 0;
	#------------------------------------------------------
}
#==========================================================
sub CheckTopicActionPermissions{
my ($Action, %Topic) = @_;
	
	#Forum permissions (0=>"Everyone", 1=>"Registered Users", 2=>"Private Groups", 3=>"Moderators", 4=>"Administartors");
	#User  Levels : # 0=User, 1=Admin, 2=Mod

	#------------------------------------------------------
	# Avoid hacking for Forum=0 permissions
	$Topic{Forum} += 0;
	$Topic{Forum} = int($Topic{Forum});
	if ($Topic{Forum} < 1) {return 0;}
	if ($Topic{Topic} < 1) {return 0;}
	#------------------------------------------------------
	%Forum = &GetForum($Topic{Forum});
	#------------------------------------------------------
	# check if Everyone can delete
	if ($Forum{$Action} == 0) {return 1;}
	#------------------------------------------------------
	# if current user is the topic starter, then allow him if forum permissions allow registered
	#if ($CurrentUser{Level} == 0 && $Forum{$Action} == 1 && ($Topic{Author} eq $Param{User_ID}) ) {return 1;}
	#------------------------------------------------------
	# if current user is Admin, then allow him to do anything
	if ($CurrentUser{Level} == 1) {return 1;}
	#------------------------------------------------------
	# if current user is Moderator, then check if he is a moderator for this forum
	if ($CurrentUser{Level} == 2 && $Forum{$Action} <=3) {
			# get all the forums for this moderator 
			#@Forums = &GetModeratorForums($Param{User_ID});
			#map {$Fourms{$_} = 1} @Forums;
			#if ($Forums{$Topic{Forum}}) {return 1;}
			if (&CheckForumModerator($Param{User_ID}, $Topic{Forum})) {
					return 1;
			}
	}
	#------------------------------------------------------
	# all checks failed, not allowed operation
	return 0;
	#------------------------------------------------------
}
#==========================================================
sub CheckForumModerator{
my ($User, $Forum) = @_;
	if (!$Forum || !$User) {return 0;}
	$User = $dbh->quote($User);
	return @{$dbh->selectcol_arrayref(qq!SELECT User FROM Forum_Moderators WHERE Forum=$Forum AND User=$User LIMIT 1!)};
}
#==========================================================
sub CheckPrivateForumUser{
my ($User, $Forum) = @_;
my ($Query, $sth, $Found, $Temp);

	if (!$Forum || !$User) {return 0;}
	$User = $dbh->quote($User);

	$Found = 0;
	#while(($Temp) = $sth->fetchrow_array) {$Found = 1; last;}
	#$sth->finish;
	return $Found;
}
#==========================================================
sub GetForumModerators{
my ($Forum) = @_;
	$Forum || return ();
	return @{$dbh->selectcol_arrayref(qq!SELECT User FROM Forum_Moderators WHERE Forum=$Forum ORDER BY User ASC!)};
}
#==========================================================
sub DeleteForumTopic{
my ($Topic) = @_;
my ($Query, @Posts, $Posts);
	
	$Topic += 0;
	@Posts = &GetForumTopicPosts($Topic);
	$Posts = join (",", @Posts);

	if ($Posts) {
			#--------------------------------------------------------------------------------------
			# Delete attached files for topics posts
			$Query = qq!SELECT Media FROM Forum_Media WHERE Post IN($Posts)!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			undef @Media;
			while (($Temp) = $sth->fetchrow_array){push @Media, $Temp;}
			$sth->finish;

			foreach $Media (@Media) {
					@Files = split(/\|/, $Media);
					foreach $File (@Files){
							unlink ("$Global{Upload_Dir}/$File");
					}
			}
			#--------------------------------------------------------------------------------------
			$Query = qq!DELETE FROM Forum_Posts WHERE Post IN ($Posts)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

			$Query = qq!DELETE FROM Forum_Messages WHERE Post IN ($Posts)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

			$Query = qq!DELETE FROM Forum_Media WHERE Post IN ($Posts)!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	$Query = qq!DELETE FROM Forum_Topics WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Forum_Watching WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	$Query = qq!DELETE FROM Forum_Topic_Read WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Forum_Topic_Notify WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub UpdateForumsCounts{
my ($Topics, $Posts);

	($Topics) = &UpdateForumsTopicsCounts;
	($Posts) = &UpdateForumsPostsCounts;
	&UpdateSettings(TotalTopics=>$Topics, TotalPosts=>$Posts);
}
#==========================================================
sub UpdateForumsTopicsCounts{
my (%Counts, @Forums, %Count, $Forum, %SubsCount);
my ($Total, $Query, $sth, %Parent, $Count, $Parent);

	%Counts = &GetForumsTopicsCounts;
	@Forums = &GetAllForumsID;

	$Total = 0;
	foreach $Forum (@Forums) {
			if (!$Counts{$Forum}) {$Counts{$Forum} = 0;}
			$Count{$Forum} = $Counts{$Forum};
			$Total += $Counts{$Forum};
	}

	%SubsCount = %Count;

	$Query = qq!SELECT Forum, Parent FROM Forum_Forums!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Parent;
	while(($Forum, $Parent) = $sth->fetchrow_array) {
				$Parent{$Forum}=$Parent;
	}
	$sth->finish;

	while (($Forum, $Count) =each (%Count)){
			$Parent = $Parent{$Forum};
			while ($Parent > 0) {
						$SubsCount{$Parent} += $Count;
						$Parent = $Parent{$Parent};
			}
	}

	while (($Forum, $Count) =each (%SubsCount)){
			$Query = qq!UPDATE  Forum_Forums SET Topics=$Count, SubTopics=$Count{$Forum} WHERE Forum=$Forum!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	return ($Total);
}
#==========================================================
sub UpdateForumsPostsCounts{
my (%Counts, @Forums, %Count, $Forum, %SubsCount);
my ($Total, $Query, $sth, %Parent, $Count, $Parent);

	%Counts = &GetForumsPostsCounts;
	@Forums = &GetAllForumsID;

	$Total = 0;
	foreach $Forum (@Forums) {
			if (!$Counts{$Forum}) {$Counts{$Forum} = 0;}
			$Count{$Forum} = $Counts{$Forum};
			$Total += $Counts{$Forum};
	}

	%SubsCount = %Count;

	$Query = qq!SELECT Forum, Parent FROM Forum_Forums!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Parent;
	while(($Forum, $Parent) = $sth->fetchrow_array) {
				$Parent{$Forum}=$Parent;
	}
	$sth->finish;

	while (($Forum, $Count) =each (%Count)){
			$Parent = $Parent{$Forum};
			while ($Parent > 0) {
						$SubsCount{$Parent} += $Count;
						$Parent = $Parent{$Parent};
			}
	}

	while (($Forum, $Count) =each (%SubsCount)){
			$Query = qq!UPDATE  Forum_Forums SET Posts=$Count, SubPosts=$Count{$Forum} WHERE Forum=$Forum!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	return ($Total);
}
#==========================================================
sub GetForumsTopicsCounts{
my(%Count, $Query, $Forum, $Count, $sth);
	
	$Query = qq!SELECT Forum, COUNT(Topic) FROM Forum_Topics GROUP BY Forum!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Count;
	while(($Forum, $Count) = $sth->fetchrow_array) {
			$Count{$Forum} = $Count;
	}
	$sth->finish;
	return %Count;
}
#==========================================================
sub GetForumsPostsCounts{
my(%Count, $Query, $Forum, $Count, $sth);

	$Query = qq!SELECT Forum, COUNT(Post) FROM Forum_Posts GROUP BY Forum!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Count;
	while(($Forum, $Count) = $sth->fetchrow_array) {
			$Count{$Forum} = $Count;
	}
	$sth->finish;
	return %Count;
}
#==========================================================
sub WatchingTopicStatus {
my ($User, $Topic) = @_;
	$User = $dbh->quote($User);
	return $dbh->selectrow_array(qq!SELECT COUNT(*) FROM Forum_Watching WHERE Topic=$Topic AND User=$User!);
}
#==========================================================
sub NotifyTopicStatus {
my ($User, $Topic) = @_;
	$User = $dbh->quote($User);
	return $dbh->selectrow_array(qq!SELECT COUNT(*) FROM Forum_Topic_Notify WHERE Topic=$Topic AND User=$User!);
}
#==========================================================
sub NotifyTopicSent {
my ($User, $Topic) = @_;
	$User = $dbh->quote($User);
	return $dbh->selectrow_array(qq!SELECT Status FROM Forum_Topic_Notify WHERE Topic=$Topic AND User=$User!);
}
#==========================================================
sub GetNotifyTopicUsersList{
my ($Topic) = @_;
	$Topic += 0;
	return @{$dbh->selectcol_arrayref(qq!SELECT User FROM Forum_Topic_Notify WHERE Topic=$Topic AND Status=0!)};
}
#==========================================================
sub UpdateNotifyTopicUsersList{
my ($Topic, $Status, @Users) = @_;
my ($Query, $User, $Users);
	
	$Topic += 0;
	if (!$Topic || !@Users) {return;}
	$Users = "";
	foreach $User (@Users) {$Users .= ",". $dbh->quote($User);}
	$Users =~ s/^\,//;
	$Query = qq!UPDATE Forum_Topic_Notify SET Status=$Status WHERE Topic=$Topic AND User IN($Users)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_User_Feedback_Stars{
my ($User_ID) = @_;
my ($Temp, $Total, $Positive, $Neutral, $Negative);
my ($Image, $Link);

	$User_ID = $dbh->quote($User_ID);
	($Temp, $Total, $Positive, $Neutral, $Negative) = @{$dbh->selectrow_arrayref(qq!SELECT * FROM FeedbackRating WHERE User_ID=$User_ID LIMIT 1!)};
	$Image = &Rating_Stars_Image($Total);

	if ($Image) {
			$Link = $Language{feedback_stars_link};
			$Link =~ s/<!--Stars_Image-->/$Image/;
	}
	else{
			$Link = "";
	}
	return ($Total, $Link);
}
#==========================================================
sub Rating_Stars_Image{
my ($Rating) = @_;
my (@Stars, $Star, $From, $To, $Image);

	@Stars = split (/\|/, $Language{feedback_stars});

	foreach $Star (@Stars) {
			($From, $To, $Image) = split(/\:/, $Star);
			if ($Rating >= $From && $Rating <= $To) {
				return $Image;
			}
	}
	return "";
}
#==========================================================
sub MarkTopicRead {
my ($User, $Topic) = @_;

	$Topic += 0;
	$User = $dbh->quote($User);
	$Query = qq!DELETE From Forum_Topic_Read WHERE Topic=$Topic AND User=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!INSERT INTO Forum_Topic_Read SET Topic=$Topic, User=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub PrepareForumSearchTerms{
my ($Terms) = @_;
my (@Terms, $Terms1, $Temp, $x, $Term, $Found);
		
	#$Terms =~ s/<[^>]+>//ig; # remove html code
	$Terms =~ s/^\s+//;
	$Terms =~ s/\s+$//;
	$Terms || return "";
	$Global{Required_Search_Term} =~ s/\*+/\%/g;

	$Terms =~ s/\s+/ /g;
	$Terms =~ s/\'/\\'/g;
	$Terms =~ s/\s*\+\s*/ and /ig;

	$Global{Required_Search_Term} = $Terms;

	$Terms =~ s/ and not / -/ig;
	$Terms =~ s/ and / \+/ig;
	$Terms =~ s/ not / -/ig;        
	$Terms =~ s/ or / \|/ig;

	#$Terms =~ s/\*+/\\S*\\W/g;
	$Terms =~ s/\*+/\%/g;
	$Terms1 = $Terms;

	while( $Terms1 =~ m|"([^\"\\]*(?:\\.[^\"\\]*)*)"|gx ) { 
					$Temp = $1;
					$Temp1= $Temp;
					$Temp1 =~ s/^\s+//;
					$Temp1 =~ s/\s+$//;
					$Temp1 =~ s/\s+/\_/g;
					$Terms =~ s/$Temp/$Temp1/g;
	}

	$Terms =~ s/\"//g;
	$Global{Required_Search_Term} =~ s/\"//g;

	@Terms = split(/\s+/, $Terms);

	for $x (0..$#Terms) {
		$Terms[$x] =~ s/\%+/\%/g;
		$Terms[$x] =~ s/\_/ /g;
		if ($Terms[$x] =~ /\-/) {
				$Global{Required_Search_Term} =~ s/$Terms[$x]//g;
		}
	}

	$Global{Required_Search_Term} =~ s/\s+/ /g;
	
	$Found = 0;
	foreach $Term (@Terms) {
			if ($Global{Required_Search_Term} eq "*") { next;}
			if ($Term =~ /$Global{Required_Search_Term}/) {$Found = 1; last;}
	}
	if (!$Found) {
			unshift @Terms , "|$Global{Required_Search_Term}";
	}

	return @Terms;
}
#==========================================================
sub GetNewestTopics {
my ($SortBy, $SortDir) = @_;
my ($Dir, $StartTime, $Dir, $Sort);
	
	if ($SortDir ==1 ) {$Dir = "ASC";} else {$Dir = "DESC";}
	$Sort = qq!ORDER BY Time Desc, Type DESC!;
	if ($SortBy) {
			$Sort .= ", $SortBy $Dir";
	}
	$StartTime = &Time - int($Global{NewestTopicsTime} * 3600); #in hours
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE Updated > $StartTime $Sort!)};
}
#==========================================================
sub GetUnreadTopics {
my ($User, $SortBy, $SortDir) = @_;
my ($Dir, $Sort, $StartTime, @Topics);
	
	$User || return ();
	#------------------------------------------------------
	if ($SortDir ==1) {$Dir = "ASC";	} else {$Dir = "DESC";}
	$Sort = qq!ORDER BY Time Desc, Type DESC!;
	if ($SortBy) {
			$Sort = qq!ORDER BY $SortBy $Dir!;
	}
	#------------------------------------------------------
	$StartTime = &Time - int($Global{UnreadTopicsTime} * 86400); # in days
	#------------------------------------------------------
	# get user already read topics
	$User = $dbh->quote($User);
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topic_Read WHERE User=$User!)};
	#------------------------------------------------------
	$Topics = "";
	if (@Topics) {$Topics = "Topic NOT IN (" . join (",", @Topics) . ") AND ";}
	return @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topics WHERE $Topics Updated>$StartTime $Sort!)};
}
#==========================================================
sub GetForumUserUnreadCount {
my ($User, $Forum) = @_;
my ($StartTime, @Topics);

	$Forum += 0;
	$Forum || return undef;
	$User = $dbh->quote($User);
	#------------------------------------------------------
	$StartTime = &Time - int($Global{UnreadTopicsTime} * 86400); # in days
	#------------------------------------------------------
	# get the user read topics
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topic_Read WHERE Forum=$Forum AND User=$User!)};
	#------------------------------------------------------
	$Topics = "";
	if (@Topics) {$Topics = "Topic NOT IN (" . join (",", @Topics) . ") AND ";}
	return $dbh->selectrow_array(qq!SELECT COUNT(*) FROM Forum_Topics WHERE $Topics Forum=$Forum AND Updated>$StartTime!);
}
#==========================================================
sub GetForumTreeUserUnreadCount {
my ($User, $Forum) = @_;
my (@Forums, $Forums, @Topics, $Topics);

	$Forum += 0;
	$Forum || return undef;
	@Forums = &GetForumTree($Forum);
	push @Forums, $Forum;
	$Forums = join (",", @Forums);
	$User = $dbh->quote($User);
	#------------------------------------------------------
	$StartTime = &Time - int($Global{UnreadTopicsTime} * 86400); # in days
	#------------------------------------------------------
	# get the user read topics
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topic_Read WHERE User=$User!)};
	#------------------------------------------------------
	$Topics = "";
	if (@Topics) {$Topics = "Topic NOT IN (" . join (",", @Topics) . ") AND ";}
	return $dbh->selectrow_array(qq!SELECT COUNT(*) FROM Forum_Topics WHERE $Topics Forum IN ($Forums) AND Updated>$StartTime!);
}
#==========================================================
sub GetForumUserTopicsRead {
my ($User, @Topics) = @_;
my ($Topics, %Topics);
	
	if (!@Topics) {return ();}
	#------------------------------------------------------
	# if no user (Guest), assume all topics read
	if (!$User) {
			foreach $Topic (@Topics) {
					$Topics{$Topic} = 1;
			}
			return %Topics;
	}
	#------------------------------------------------------
	$Topics = join (",", @Topics);
	$User = $dbh->quote($User);
	@Topics = @{$dbh->selectcol_arrayref(qq!SELECT Topic FROM Forum_Topic_Read WHERE Topic IN ($Topics) AND User=$User!)};
	undef %Topics;
	map {$Topics{$_} = 1} @Topics;
	return %Topics;
}
#==========================================================
sub MoveForumTopic {
my ($Forum, $Topic) = @_;
my ($Query, $sth);
	
	$Topic += 0;

	@Posts = &GetForumTopicPosts($Topic);
	$Posts = join (",", @Posts);

	$Query = qq!UPDATE  Forum_Topics SET Forum=$Forum WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!UPDATE  Forum_Posts SET Forum=$Forum WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!UPDATE  Forum_Messages SET Forum=$Forum WHERE Post IN ($Posts)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
1;