=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub Check_Referer{
	$Check=&Check_Referers;
	if ($Check == 0) {
		print "Content-type: text/html\n\n";
		&Msg($Language{referer_error_title}, $Language{referer_error_msg}, 1);
		exit 0;
	}
}
#==========================================================
sub Get_Languages{
my (@Languages);

	$Global{Languages} ||= "English";
	@Languages=split(/\|/, $Global{Languages});
	return @Languages;
}
#==========================================================
sub Access_Lock_Status{
my ($Format);

	if ($Global{Access_Lock_Status} == 0) {
		return 0;
	}
	else{
		&LoadLangFile($Global{LanguageAccessLockFile});
		print "Content-Type: text/html\n\n";
		print  $Language{access_lock_header};
		print  $Language{access_lock_title};
		print  $Language{access_lock_description};
		$Format = $Language{access_lock_time};
		#------------------------------------------------------
		$PostTimeClass = ""; $PostTimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
		if ($Format =~ m/(<!--)(Time)(:\()([^\)]+)(\)-->)/){
					$PostTimeClass = $1 . $2 . $3. $4. $5;
					$PostTimeFormat =  $4;
		}
		$PostTimeClass =~ s/\(/\\\(/g;
		$PostTimeClass =~ s/\)/\\\)/g;
		#------------------------------------------------------
		#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
		$Temp = &ParseDate($PostTimeFormat, &Time(time));
		$Format =~ s/$PostTimeClass/$Temp/g;
		print "$Format";
		#------------------------------------------------------
		print  $Language{access_lock_signature};
		exit 0;
	}
	
}
#==========================================================
sub Exit {
my ($Msg, $Title, $Level) = @_;
my ($Out);

	$Title ||= "Error";
	$Out = &Error($Msg, $Title, $Level);
	print "Content-type: text/html\n\n";
	print "$Out";
	if ($dbh) {&DB_Disconnect();}
	exit 0;
}
#==========================================================
sub Quit{
	if ($dbh) {&DB_Disconnect();}
	exit 0;
}
#==========================================================
sub LoadLangFile {
my ($LangFile) = @_;
my (@vars, $str, $k, $v, $package, $file, $line);
	
	($package, $file, $line) = caller;
	open(F, "$LangFile") || &Exit("Error: Can't open language file $LangFile: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__.", <br>Caller: $file, Line: $line");
	@vars = <F>;
	close(F);
	
	foreach $str (@vars) {
		chomp($str);
		($k, $v) = split ('~==~', $str);
		#$v =~ s/\'/\&\#39\;/g;
		$v =~ s/\\n/\n/g;
		$v =~ s/\\r/\r/g;
		$v =~ s/\\cM/\cM/g;
		$Language{$k} = $v;
	}
}
#==========================================================
sub GetLangFile { 
my ($LangFile) = @_;
my (@vars, $str, $k, $v, $package, $file, $line, %langs);
	
	($package, $file, $line) = caller;
	open(F, "$LangFile") || &Exit("Error: Can't open language file $LangFile: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__.", <br>Caller: $file, Line: $line");
	@vars = <F>;
	close(F);
	
	undef %langs;
	foreach $str (@vars) {
		chomp($str);
		($k, $v) = split ('~==~', $str);
		#$v =~ s/\'/\&\#39\;/g;
		$v =~ s/\\n/\n/g;
		$v =~ s/\\r/\r/g;
		$v =~ s/\\cM/\cM/g;
		$langs{$k} = $v;
	}
	return %langs;
}
#==========================================================
sub Sign_Out {

	if ($Global{MewsoftPassport}) {
			&Delete_Cookies("MewsoftPassport_User", "MewsoftPassport_Password", "MewsoftPassport_Session");
			$Cookies{MewsoftPassport_User} = "";
			$Cookies{MewsoftPassport_Password}  = "";
			$Cookies{MewsoftPassport_Session} = "";
	}
	else{
			&Delete_Cookies("Boardawy_User", "Boardawy_Password", "Boardawy_Session");
			$Cookies{Boardawy_User} = "";
			$Cookies{Boardawy_Password}  = "";
			$Cookies{Boardawy_Session} = "";
	}

	$Param{User_ID} = "";
	$Param{Password} = "";

	&Account_Login;
}
#==========================================================
sub Account_Login{
my ($URL);

	if ($Global{SSL_Status}){
			$URL = "$Global{SSL_URL}$Global{MainProg}";
	}
	else{
			$URL = $Global{ProgURL};
	}

	print "Location: $URL"."action=AccountManager_Login\n\n";
}
#==========================================================
sub Check_Account_Login{

	if (!&Check_Previous_User_Login) {
			&Account_Login;
			&Quit;
	}
}
#==========================================================
sub Check_Previous_User_Login{
my (%User);

	#$Param{User_ID} = "";
	#$Param{Password} = "";
	#$Param{Boardawy_Session} = "";
	#$Param{MewsoftPassport_Session} = "";

	if ($Global{MewsoftPassport}) {
			if ($Cookies{MewsoftPassport_User} && $Cookies{MewsoftPassport_Password} ){
						%User = &Get_User_By_Login($Cookies{MewsoftPassport_User}, $Cookies{MewsoftPassport_Password});
						if (%User && $User{Status}) {
								$Param{User_ID} = lc($Cookies{MewsoftPassport_User});
								$Param{Password} = $Cookies{MewsoftPassport_Password};
								$Param{MewsoftPassport_Session} = $Cookies{MewsoftPassport_Session};
								return 1;
						}
			}
	}
	else{
			if ($Cookies{Boardawy_User} && $Cookies{Boardawy_Password} ){
						%User = &Get_User_By_Login($Cookies{Boardawy_User}, $Cookies{Boardawy_Password});
						if (%User && $User{Status}) {
								$Param{User_ID} = lc($Cookies{Boardawy_User});
								$Param{Password} = $Cookies{Boardawy_Password};
								$Param{Boardawy_Session} = $Cookies{Boardawy_Session};
								return 1;
						}
			}
	}

	return 0;
}
#==========================================================
sub LoadCurrentUser {
	undef %CurrentUser;
	&Check_Previous_User_Login;
	if ($Param{User_ID}) {
			%CurrentUser = &GetForumUser($Param{User_ID});
			if ($CurrentUser{User_ID}) {
				$Param{User_ID} = $CurrentUser{User_ID};
			}
	}
	return %CurrentUser;
	#%Groups = (0=>"Everyone", 1=>"Registered Users", 2=>"Private Groups", 3=>"Moderators", 4=>"Administartors");
}
#==========================================================
sub ReadFile {
my ($File) = shift;
my (@Temp, $Out);

	open(IN, "$File") || &Exit("Error, Can't open file $File: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
    @Temp = <IN>;
    close(IN);
	$Out = join("", @Temp);
	return $Out;
}
#==========================================================
sub Check_User_Exist{
my ($User_ID) = shift;
my ($Query, $sth, $Found, $Temp);

	$User_ID = $dbh->quote($User_ID);
	$Query = qq!SELECT User_ID FROM Users WHERE User_ID = $User_ID!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (($Temp) = $sth->fetchrow_array){$Found = 1; last;}
	$sth->finish;
	return $Found;
}
#==========================================================
sub Check_Email_Exist{
my ($Email) = @_;
my ($Query, $sth, $Found, $Temp);

	$Email = $dbh->quote($Email);
	$Query = qq!SELECT Email FROM Users WHERE Email=$Email!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while (($Temp) = $sth->fetchrow_array){$Found = 1; last;}
	$sth->finish;
	return $Found;
}
#==========================================================
sub Check_User_Authentication{
my ($User_ID, $Password) = @_;
my (%User);
		
	%User = &Get_User_By_Login($User_ID, $Password);
	if (%User) {
		if ($User{Status} && ($User{User_ID} eq $User_ID) && ($User{Password} eq $Password)) {return 1;}
	}
	return 0;
}
#==========================================================
sub OnlineUsers {
my ($IP, $TimeOut, $Time, $Query, $sth);
my ($User_ID, $User, $Users, @Rows, %User);

	$Param{Forum} +=0;
	$Param{Topic} +=0;
	$Param{Post} +=0;
	$Param{action} ||= "Forums";

	$IP = $dbh->quote($ENV{REMOTE_ADDR});
	$Time = time;

	&Check_Previous_User_Login;
	$Param{User_ID} ||= "";

	$TimeOut = time - $Global{Whos_Online_Time_Out};
	$Global{ForumWhosOnlinePruned} += 0;
	$Global{ForumWhosOnlinePruned} ||= $TimeOut;

	$Action = $dbh->quote($Param{action});
	$User_ID =	 $dbh->quote($Param{User_ID});

	# Auto Prune online users status once every $Global{Whos_Online_Time_Out} to optimize the sql table
	if ((time - $Global{ForumWhosOnlinePruned}) > $Global{Whos_Online_Time_Out}) {
			$Query = qq!DELETE FROM Forum_Whos_Online WHERE Time < $TimeOut!;
			$sth = $dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			&UpdateSettings(ForumWhosOnlinePruned => time);
	}
	
	if ($Param{User_ID}) {
			#Update user last visit information
			$sth = $dbh->do(qq!UPDATE Forum_Users_Info SET LastVisit=$Time WHERE User_ID=$User_ID!) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

			@Rows = @{$dbh->selectcol_arrayref(qq!SELECT User_ID FROM Forum_Whos_Online WHERE User_ID=$User_ID!)};
			if (@Rows > 1) {
				$Query = qq!DELETE FROM Forum_Whos_Online WHERE User_ID=$User_ID!;
				$sth = $dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				undef @Rows;
			}

			if (@Rows) {
					$Query = qq!UPDATE Forum_Whos_Online SET
											IP=$IP,
											Time=$Time,
											Action=$Action,
											Forum=$Param{Forum},
											Topic=$Param{Topic},
											Post=$Param{Post}
											WHERE User_ID=$User_ID
											!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
			else {
					$Query = qq!INSERT INTO Forum_Whos_Online SET
											IP=$IP,
											User_ID=$User_ID,
											Time=$Time,
											Action=$Action,
											Forum=$Param{Forum},
											Topic=$Param{Topic},
											Post=$Param{Post}
											!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
	}	#if ($Param{User_ID}) {
	else {
			#Update guest by IP last seen information
			@Rows = @{$dbh->selectcol_arrayref(qq!SELECT IP FROM Forum_Whos_Online WHERE IP=$IP!)};
			if (@Rows > 1) {
				$Query = qq!DELETE FROM Forum_Whos_Online WHERE IP=$IP!;
				$sth = $dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
				undef @Rows;
			}

			if (@Rows) {
					$Query = qq!UPDATE Forum_Whos_Online SET
											User_ID=$User_ID,
											Time=$Time,
											Action=$Action,
											Forum=$Param{Forum},
											Topic=$Param{Topic},
											Post=$Param{Post}
											WHERE IP=$IP
											!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
			else {
					$Query = qq!INSERT INTO Forum_Whos_Online SET
											IP=$IP,
											User_ID=$User_ID,
											Time=$Time,
											Action=$Action,
											Forum=$Param{Forum},
											Topic=$Param{Topic},
											Post=$Param{Post}
											!;
					$dbh->do($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}

	}#if ($Param{User_ID}) {
	#------------------------------------------------------
	$Query = qq!SELECT * FROM Forum_Whos_Online WHERE Time > $TimeOut!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth ->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	
	$Plugins{Online_Users} = 0;
	$Plugins{Online_Total} =  0;
	undef $Plugins{Online_Usernames};

	while (%User = %{$sth->fetchrow_hashref()}) {
			#IP VARCHAR(50),User_ID VARCHAR(250), Time INT Default 0,Action VARCHAR(50),Forum INT,Topic INT,Post INT
			$Plugins{Online_Total} ++;
			if ($User{User_ID}) {
					$Plugins{Online_Users} ++;
					push @{$Plugins{Online_Usernames}}, $User{User_ID};
			}
	}
	$sth->finish;

	$Plugins{Online_Guests} = $Plugins{Online_Total} - $Plugins{Online_Users};
	if ($Plugins{Online_Guests} < 0) {$Plugins{Online_Guests} = 0;}
	#--------------------------------------------------------------------------
	$Users = ""; $Hidden = 0;
	foreach $User (@{$Plugins{Online_Usernames}}) {
			$User_ID = $dbh->quote($User);
#LastVisit INT Default 0,
#Level INT Default 0, # 0=User, 1=Admin, 2=Mod
			%User = %{$dbh->selectrow_hashref(qq!SELECT Level, ViewOnline FROM Forum_Users_Info WHERE User_ID=$User_ID!)};
			$Level = 0; $ViewOnline = 0;
			if (!$User{ViewOnline}) {
					$Hidden++;
					# Admin's and Mod's allowed to see any user
					if (!$CurrentUser{Level}) {next;}
			}

			# 0=User, 1=Admin, 2=Mod
			if ($User{Level} == 0) {
					$Temp = $Language{online_user_link};
			}
			elsif ($User{Level} == 1) {
					$Temp = $Language{online_admin_link};
			}
			elsif ($User{Level} == 2) {
					$Temp = $Language{online_mod_link};
			}

			$Temp =~ s/<!--Author-->/$User/g;
			$Link = qq!$Global{ProgURL}action=ViewProfile&Author=$User!;
			$Temp =~ s/<!--AuthorLink-->/$Link/g;

			$Users .= $Temp .  $Language{online_users_sep};
	}

	$Users =~ s/$Language{online_users_sep}$//g;
	$Plugins{Online_Users_List} = $Users;
	$Plugins{Online_Hidden} = $Hidden;
	#--------------------------------------------------------------------------
	return ($Plugins{Online_Total}, $Plugins{Online_Users},  $Plugins{Online_Guests}, $Plugins{Online_Usernames}, $Plugins{Online_Users_List}, $Plugins{Online_Hidden});
}
#==========================================================
sub Check_SSL_Graphics{

	if ($Global{SSL_Status}){
		$Global{Images} = $Global{ImagesSSL};	
	}

}
#==========================================================
sub ReadThemeConfig {
my (@Temp, %Classes, $Line, $K, $V);

	open(FILE, "$Global{ThemeConfigFile}") || &Exit("Error, Can't open file $Global{ThemeConfigFile}: $!"."<br>Line ". __LINE__ . ", File ". __FILE__);
    @Temp = <FILE>;
    close(FILE);
	undef %Classes;
	foreach $Line (@Temp) {
			$Line =~ s/\n$//;
			if (!$Line) {next;}
			($K, $V) = split('~==~', $Line);
			if (!$K) {next;}
			$V =~ s/\\n/\n/g;
			$Classes{$K} = $V;
	}
	return %Classes;
}
#==========================================================
sub GetLanguageMenu {
my ($Language) = @_;
my ($Form, $Menu, @Langs, $Lang, $Temp);

	$Form = &Translate($Global{LanguageMenu});
	$Form =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Form =~ s/<!--Language-->/$Global{Language}/g;
	
	@Langs = &Get_Languages;
	$Menu = "";
	foreach $Lang (@Langs) {
			$Option = qq!$Language{language_menu_option}!;
			if ($Language{$Lang} ne "") {
				$Temp = $Language{$Lang};
			}
			else { $Temp = $Lang;}
			$Option =~ s/<!--Lang-->/$Temp/g;
			if ($Lang eq $Language) {$Sel = "selected";} else { $Sel = "";}
			$Option =~ s/<!--Selected-->/$Sel/g;
			$Menu .= $Option;
	}
	$Form =~ s/<!--Languages-->/$Menu/g;
	return $Form;
 }
#==========================================================
sub ChangeLanguage {
	$Global{Language} = $Param{NewLanguage};
	$Param{Lang} = $Param{NewLanguage};
	&Set_Cookies("User_Language", $Param{NewLanguage}, 1 );
	$Cookies{User_Language} = $Param{NewLanguage};
	print "Location: $Global{ProgURL}\n\n";
}
#==========================================================
sub GetEditorForm {
my ($Template, $Field, $Width, $Height) = @_;
my ($Out);

	if ($Param{VisualEditorSwitch}) {
			$Cookies{UserVisualEditorStatus} ||= 0;
			$Cookies{UserVisualEditorStatus} = !$Cookies{UserVisualEditorStatus};
			&Set_Cookies("UserVisualEditorStatus", $Cookies{UserVisualEditorStatus}, 1 );
	}
	#--------------------------------------------------------------------------
	if ($Cookies{UserVisualEditorStatus}) {
			$Temp = $Language{visual_editor_enabled};
			$Template =~ s/<!--UserVisualEditorSwitch-->/$Temp/g;
			$Plugins{FooterCode} = &HTML_Editor_Code($Field, $Width, $Height);
			$Temp = &Translate($Global{VisualEditorForm});
			$Temp =~ s/<!--FormField-->/$Field/g;
			$Temp =~ s/<!--Width-->/$Width/g;
			$Temp =~ s/<!--Height-->/$Height/g;
			$Template =~ s/<!--EditorForm-->/$Temp/g;
	}
	else {
			$Temp = $Language{visual_editor_disabled};
			$Template =~ s/<!--UserVisualEditorSwitch-->/$Temp/g;
			$Temp = &TranslateFile($Global{TextEditorTemplate});
			$Temp =~ s/<!--FormField-->/$Field/g;
			$Template =~ s/<!--EditorForm-->/$Temp/g;
	}
	return $Template;
}
#==========================================================
sub HTML_Editor_Code {
my ($Field, $Width, $Height) = @_;
my ($Out);

	#$Width ||= "700px";
	#$Height ||= "300px";
	$Width = "auto";
	$Height = "auto";
	$Plugins{JS_Code} ||= "";
	#$Plugins{JS_Code} .= "initEditor();" htmlarea editor
	
	$Out = &TranslateFile($Global{HtmlEditorTemplate});
	$Out =~ s/<!--FormField-->/$Field/g;
	$Out =~ s/<!--Width-->/$Width/g;
	$Out =~ s/<!--Height-->/$Height/g;
	$Out =~ s/<!--CLASS\:\:HTML_URL-->/$Global{HTML_URL}/g;
	return $Out;
}
#==========================================================
sub GetHostname {
my ($IP_Address) = @_;
my (@Numbers, $IP_Number, $Host);

	@Numbers = split(/\./, $IP_Address);
	$IP_Number = pack("C4", @Numbers);
	$Host = (gethostbyaddr($IP_Number, 2))[0];
	return $Host;
}
#==========================================================

1;