=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ListingOptions{
my ($Message) = @_;
my ($Help, $Out);

	$Help = &Help_Link("Listing_Options");
	$Out = &ListingOptionsForm($Message);
	&Print_Page($Out, "Listing Options", $Help);
}
#==========================================================
sub ListingOptionsForm{
my ($Message) = @_;
my (%HTM, $Out, $Sig_Treat_HTML, $Avatar_Allow_File_Upload);

	#----------------------------------------------------------------
	%HTM = (
			Show_Code => "Disable All HTML",
			Show_Safe_Code => "Allow Safe HTML",
			Remove_Code => "Remove All HTML",
			Show_HTML => "Allow All HTML"
		);
	
	$Sig_Treat_HTML = "";
	foreach $Key  (sort keys %HTM) {
				$Selected = "";
				if ($Key eq $Global{Sig_Treat_HTML}) {$Selected = "selected";}
				$Sig_Treat_HTML .= qq!<option value="$Key" $Selected>$HTM{$Key}</option>!;
	}

	$Board_Treat_HTML = "";
	foreach $Key  (sort keys %HTM) {
				$Selected = "";
				if ($Key eq $Global{Board_Treat_HTML}) {$Selected = "selected";}
				$Board_Treat_HTML .= qq!<option value="$Key" $Selected>$HTM{$Key}</option>!;
	}
	#----------------------------------------------------------------
	if ($Global{Avatar_Allow_File_Upload}) {
            $Avatar_Allow_File_Upload = qq!<option selected value="1">YES</option><option value="0">NO</option>!;
	}
	else{
           $Avatar_Allow_File_Upload = qq!<option selected value="0">NO</option><option value="1">YES</option>!;
	}

	if ($Global{Avatar_Upload_Any_File}) {
            $Avatar_Upload_Any_File = qq!<option selected value="1">YES</option><option value="0">NO</option>!;
	}
	else{
           $Avatar_Upload_Any_File = qq!<option selected value="0">NO</option><option value="1">YES</option>!;
	}
	#----------------------------------------------------------------
	if ($Global{Pages_Mode eq "fixed"}) {
            $Pages_Mode = qq!<option selected value="fixed">Fixed</option><option value="slide">Slide</option>!;
	}
	else{
           $Pages_Mode = qq!<option selected value="slide">Slide</option><option value="fixed">Fixed</option>!;
	}
	#----------------------------------------------------------------

$Out=<<HTML;
<div align="center" style="padding: 5px;"><font color="red" size="3"><b>$Message</b></font></div>

<form method="post" action="$ScriptURL">
<input type="hidden" name="action" value="SaveListingOptions">

<table class="TableAttr" width="100%" cellspacing="0" cellpadding="3">
	<tr><td class="TableCell">Signature HTML Manipulation:</td><td class="TableCell"><select size="1" name="Sig_Treat_HTML">$Sig_Treat_HTML</select></td></tr>

<tr><td class="TableCell">Maximum Signature Size:</td><td class="TableCell"><input type="text" name="Sig_Max_Len" size="10" value="$Global{Sig_Max_Len}"> Bytes</td></tr>

	<tr><td class="TableCell">Topics per page:</td><td class="TableCell"><input type="text" name="Topics_Per_Page" size="10" value="$Global{Topics_Per_Page}"> </td></tr>
	<tr><td class="TableCell">Posts per page:</td><td class="TableCell"><input type="text" name="Posts_Per_Page" size="10" value="$Global{Posts_Per_Page}"> </td></tr>
	<tr><td class="TableCell">Members per page:</td><td class="TableCell"><input type="text" name="Members_Per_Page" size="10" value="$Global{Members_Per_Page}"> </td></tr>

	<tr><td class="TableCell">Pages visible per set:</td><td class="TableCell"><input type="text" name="Pages_Per_Set" size="10" value="$Global{Pages_Per_Set}"> </td></tr>
	<tr><td class="TableCell">Pages visible mode:</td><td class="TableCell"><select size="1" name="Pages_Mode">$Pages_Mode</select></td></tr>

	<tr><td class="TableCell">Marked read topics time (days):</td><td class="TableCell"><input type="text" name="UnreadTopicsTime" size="10" value="$Global{UnreadTopicsTime}"> Topics older than these days considered as read</td></tr>
	<tr><td class="TableCell">Newest topics time (hours):</td><td class="TableCell"><input type="text" name="NewestTopicsTime" size="10" value="$Global{NewestTopicsTime}"> Topics newer than these hours considered as new</td></tr>

	<tr><td class="TableCell">Replies required for cool topics:</td><td class="TableCell"><input type="text" name="CoolTopicsPosts" size="10" value="$Global{CoolTopicsPosts}"> </td></tr>
	<tr><td class="TableCell">Replies required for popular topics:</td><td class="TableCell"><input type="text" name="PopularTopicsPosts" size="10" value="$Global{PopularTopicsPosts}"> </td></tr>
	<tr><td class="TableCell">Replies required for hot topics:</td><td class="TableCell"><input type="text" name="HotTopicsPosts" size="10" value="$Global{HotTopicsPosts}"> </td></tr>

	<tr><td valign="top">Default date format:</td><td class="TableCell"><input type="text" name="DateFormat" size="65" value="$Global{DateFormat}">
	<br><b>HR:</b> Hour 0-23 - <b>HH:</b> Hour 1-12 - <b>MM:</b> Minute 0-59 - <b>SS:</b> Second 0-59 - <b>AP:</b> AM/PM<br><b>MON:</b> Month 1-12 - <b>MD:</b> Day 1-31- <b>WD:</b> Weekday - <b>MONTH:</b> Month Name- <b>YY</b>: Year  - <b>YYYY</b>: Year
	</td></tr>

	<tr><td class="TableCell">Search results cash time:</td><td class="TableCell"><input type="text" name="Forum_Cash_Time" size="10" value="$Global{Forum_Cash_Time}"> Seconds</td></tr>
	<tr><td class="TableCell">Posts search results message size:</td><td class="TableCell"><input type="text" name="Posts_Return_Size" size="10" value="$Global{Posts_Return_Size}"> Bytes</td></tr>

	<tr><td valign="top">Display previous menu periods:</td><td class="TableCell">
		<input type="text" name="ForumPeriods" size="65" value="$Global{ForumPeriods}"> 
		<br><b>a:</b> All posts - <b>h:</b> Hour - <b>H:</b> Hours - <b>d:</b> Day - <b>D:</b> days - <b>w:</b> Week <br> <b>W:</b> Weeks - <b>m:</b> Month - <b>M:</b> Months - <b>y:</b> Year - <b>Y:</b> Years
	</td>
	</tr>

	<tr><td valign="top">Display last menu periods:</td><td class="TableCell"><input type="text" name="ForumDisplayLast_Periods" size="65" value="$Global{ForumDisplayLast_Periods}"></td></tr>

	<tr><td class="TableCell">Allow users to upload avatars files</td><td class="TableCell"><select size="1" name="Avatar_Allow_File_Upload">$Avatar_Allow_File_Upload</select></td></tr>
	<tr><td class="TableCell">Allow any Avatars File Type to Upload:</td><td class="TableCell"><select size="1" name="Avatar_Upload_Any_File">$Avatar_Upload_Any_File</select></td></tr>
	<tr><td valign="top">Avatars files extensions allowed: <br>Separate by a Space</td><td class="TableCell"><textarea name="Avatar_Files_Ext_Allowed" rows="3" cols="55">$Global{Avatar_Files_Ext_Allowed}</textarea></td></tr>
	<tr><td class="TableCell">Maximum Avatars Upload File Size:</td><td class="TableCell"><input type="text" name="Avatar_Max_Upload_File_Size" size="10" value="$Global{Avatar_Max_Upload_File_Size}"> KB</td></tr>

	<tr><td class="TableCell">Community Board HTML Manipulation:</td><td class="TableCell"><select size="1" name="Board_Treat_HTML">$Board_Treat_HTML</select></td></tr>
	<tr><td class="TableCell">Community Board Message Length:</td><td class="TableCell"><input type="text" name="Board_Max_Len" size="10" value="$Global{Board_Max_Len}"></td></tr>

	<tr><td nowrap align="center" colspan="2">
		<input type="submit" value="Save Changes" name="submit" style="color: #000080; border-style: ridge">&nbsp;&nbsp;
		<input type="reset" value="Reset" name="Reset" style="color: #000080; border-style: ridge"> 
	</td>
	</tr>
</table>
</form>
HTML

	return $Out;
}
#==========================================================
sub SaveListingOptions{
my (%Config, $Key);

	undef %Config;

	$Config{Members_Per_Page} = $Param{Members_Per_Page};
	$Config{Posts_Per_Page} = $Param{Posts_Per_Page};
	$Config{Topics_Per_Page} = $Param{Topics_Per_Page};
	$Config{Avatar_Allow_File_Upload} = $Param{Avatar_Allow_File_Upload};
	$Config{Avatar_Upload_Any_File} = $Param{Avatar_Upload_Any_File};
	$Config{Avatar_Max_Upload_File_Size} = $Param{Avatar_Max_Upload_File_Size};
	$Config{Forum_Cash_Time} = $Param{Forum_Cash_Time};
	$Config{Posts_Return_Size} = $Param{Posts_Return_Size};
	
	$Config{Board_Treat_HTML} = $Param{Board_Treat_HTML};
	$Config{Board_Max_Len} = $Param{Board_Max_Len};

	$Param{ForumPeriods} =~ s/\s+//g;
	$Config{ForumPeriods} = $Param{ForumPeriods};
	
	$Param{ForumDisplayLast_Periods} =~ s/\s+//g;
	$Config{ForumDisplayLast_Periods} = $Param{ForumDisplayLast_Periods};

	$Config{Sig_Treat_HTML} = $Param{Sig_Treat_HTML};
	$Config{Sig_Max_Len} = $Param{Sig_Max_Len};
	#----------------------------------------------------------
	$Config{HotTopicsPosts} = $Param{HotTopicsPosts};
	$Config{PopularTopicsPosts} = $Param{PopularTopicsPosts};
	$Config{CoolTopicsPosts} = $Param{CoolTopicsPosts};
	#----------------------------------------------------------
	$Param{DateFormat} =~ s/\s+//g;
	$Config{DateFormat} = $Param{DateFormat};

	$Param{Avatar_Files_Ext_Allowed} =~ s/\cM|\n|\r//g;
	$Config{Avatar_Files_Ext_Allowed} = $Param{Avatar_Files_Ext_Allowed};
	
	$Param{Pages_Per_Set} += 0;
	$Param{Pages_Per_Set} ||= 9;
	$Config{Pages_Per_Set} = $Param{Pages_Per_Set};
	$Config{Pages_Mode} = $Param{Pages_Mode};
	
	$Param{UnreadTopicsTime} += 0;
	$Config{UnreadTopicsTime} = $Param{UnreadTopicsTime};
	
	$Param{NewestTopicsTime} += 0;
	$Config{NewestTopicsTime} = $Param{NewestTopicsTime};
	#----------------------------------------------------------
	&UpdateConfiguration(%Config);

	foreach $Key (keys %Config) {
			$Global{$Key} = $Config{$Key};
	}

	&ListingOptions("Listing Options Successfully Saved");
}
#==========================================================

1;