=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub NewTopic{
my (%Forum, $Template, $PostTimeClass, $PostTimeFormat, $Form, $Temp);
	
	$Param{Forum} += 0;
	$Param{Forum} = int($Param{Forum});
	%Forum = &GetForum($Param{Forum});
	if (!%Forum || !$Param{Forum}) {
		$Plugins{Body} = $Language{error_invalid_forum_number};
		&Display($Global{GeneralTemplate});
		return;
	}

	$Plugins{Bar_Action} = $Language{bar_new_topic};
	$Template = &TranslateFile($Global{ForumNewTopicTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Param{Forum}/g;
	#------------------------------------------------------
	if (!&CheckForumActionPermissions("Post", %Forum)) {
				$Plugins{Body} = $Language{error_new_post_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Param{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	# Announce, Sticky, Poll, Vote, Attach, ViewIP
	$Param{Type} ||= 0; # Normal, Sticky, Announcement
	if ($Param{Type} ==0) {
			$Template =~ s/<!--NormalStatus-->/checked/g;
	}
	else{
			$Template =~ s/<!--NormalStatus-->//g;
	}

	if (&CheckForumActionPermissions("Sticky", %Forum)) {
			if ($Param{Type} == 1) {
					$Template =~ s/<!--StickyStatus-->/checked/g;
			}
			else{
					$Template =~ s/<!--StickyStatus-->//g;
			}
	}
	else{
			$Template =~ s/<!--StickyStatus-->/disabled/g;
	}

	if (&CheckForumActionPermissions("Announce", %Forum)) {
			if ($Param{Type} == 2) {
					$Template =~ s/<!--AnnounceStatus-->/checked/g;
			}
			else{
					$Template =~ s/<!--AnnounceStatus-->//g;
			}
	}
	else{
			$Template =~ s/<!--AnnounceStatus-->/disabled/g;
	}
	#------------------------------------------------------
	#Delete uploaded file
	$Upload = 0;
	if ($Param{Delete_Uploaded_File}) {
			@Files = split(/\|/, $Param{Uploaded_Files});
			undef %Files;
			foreach $File (@Files) {
				$Files{$File} = 1;
			}
			delete $Files{$Param{Delete_Uploaded_File}};
			$Param{Uploaded_User_Size} -=  int((-s "$Global{Upload_Dir}/$Param{Delete_Uploaded_File}")/1000);
			$Param{Uploaded_User_Count}--;
			if (!$Param{Uploaded_User_Count}) {
					$Param{Uploaded_User_Size} = 0;
					undef %Files;
			}

			unlink ("$Global{Upload_Dir}/$Param{Delete_Uploaded_File}");
			@Files = keys %Files;
			$Param{Uploaded_Files} = join("\|", @Files);
			$Upload = 1;
	}
	#------------------------------------------------------
	#Upload files
	$Upload_Error = "";
	if ($Global{Allow_File_Upload}) {
		foreach $Key (keys %Param) {
				if ($Key =~ m/Mewsoft_Corporation_Upload_File\d+/) {
							$Filename = ""; $File_Content = "";
							#($Filename, $File_Content) = split(/\|/, $Param{$Key});
							$Upload_File = $Param{$Key};
							$Upload_File =~ /\r\n\r\n|\n\n/;         #separate header and body 
							$Upload_File_Name = $`;                # front part
							$Upload_File_Content = $';             # rear part
							$Upload_File_Content =~ s/\r\n$//;  # the last \r\n was put in by Netscape

							# Parse uploaded files
							$Upload_File_Name =~ /filename=\"(.+)\"/; 
							$Upload_File_Name = $1;  #print "[[Header= $Header ]](($Input))<br>";
							$Upload_File_Name =~ s/\"//g; # remove "s
							$Upload_File_Name =~ s/\s//g; # make sure no space(include \n, \r..) in the file name 
							@File_Name = split(/[\/|\\]/, $Upload_File_Name); 
							$Upload_File_Name = pop @File_Name;
							$Filename = $Upload_File_Name;
							$File_Content = $Upload_File_Content;
							#print "\$Filename=$Filename<br><br>\$File_Content=$File_Content<br><br>";
							#$File_Content = $Param{$Key};
							#$File_Content =~ s/^$Filename\|//;
							if ($Filename) {
										$Upload_Error .= &Upload_File($Filename, $File_Content);
										$Upload = 1;
							}
							delete $Param{$Key};
				}
		}
	}
	else{
			$Upload_Error = $Language{upload_not_allowed_error};
	}
	#---------------------------------------------------------------------------------------------------------
	$Template =~ s/<!--Uploaded_Files-->/$Param{Uploaded_Files}/;
	$Template =~ s/<!--Uploaded_User_Size-->/$Param{Uploaded_User_Size}/;
	$Template =~ s/<!--Uploaded_User_Count-->/$Param{Uploaded_User_Count}/;
	if ($Upload_Error) {
			$Upload_Error = $Language{upload_error_msg} . $Upload_Error;
	}
	$Template =~ s/<!--Upload_File_Error_Msg-->/$Upload_Error/;
	#------------------------------------------------------
	@Files = split(/\|/, $Param{Uploaded_Files});
	$List = ""; $Count = 0;
	foreach $File (@Files) {
			$Count++;
			$Line = $Global{ManageUploadedFilesRow};
			$Line =~ s/<!--Count-->/$Count/;

			$Link = qq!$Global{HTML_URL}/upload/$File!;
			$Temp = $Language{upload_file_view_link};
			$Temp =~ s/<!--Link-->/$Link/g;
			$Temp =~ s/<!--Name-->/$File/g;
			$Line =~ s/<!--File-->/$Temp/g;
			
			$Temp = -s "$Global{Upload_Dir}/$File";
			$Line =~ s/<!--Size-->/$Temp/g;
			
			$Temp = $Language{delete_uploaded_file_link};
			$Temp =~ s/<!--File-->/$File/g;
			$Line =~ s/<!--Delete-->/$Temp/;

			if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_image};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.wav$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_sound};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mid$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_mid};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.mov$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_movie};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			elsif ($File =~ /\.avi$/i) {
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_avi};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			else{
					$Link = qq!$Global{HTML_URL}/upload/$File!;
					$URL = $Language{upload_file_other};
					$URL =~ s/<!--Link-->/$Link/g;
					$URL =~ s/<!--Name-->/$File/g;
			}
			$Line =~ s/<!--Preview-->/$URL/;
			$List .= $Line;
	}
	$Template =~ s/<!--Uploaded_Files_List_Manager-->/$List/;
	#------------------------------------------------------
	$Param{Media_Show} ||= 0;
	@Options = ($Language{media_type_1}, $Language{media_type_2}, $Language{media_type_3});
	$Temp = "";
	for $x(0..$#Options) {
				$Selected = "";
				if ($x eq $Param{Media_Show}) {$Selected = "SELECTED";}
				$Temp .= qq!<option value="$x" $Selected>$Options[$x]!;
	}
	$Template =~ s/<!--Media_Show-->/$Temp/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Param{Subject} ||= "";
	$Param{Subject} =~ s/^\s+//;
	$Param{Subject} =~ s/\s+$//;
	$Param{Subject} =~ s/\cM//g;

	$Template =~ s/<!--Subject-->/$Param{Subject}/g;
	#------------------------------------------------------
	$Template = &GetEditorForm($Template, "Message", "700px", "300px");
	#------------------------------------------------------
	$Param{Message} ||= "";
	$Param{Message} =~ s/^\s+//;
	$Param{Message} =~ s/\s+$//;
	#$Param{Message} =~ s/\cM//g;
	$Template =~ s/<!--EditorText-->/$Param{Message}/g;
	#------------------------------------------------------
	$Param{Uploaded_User_Count} ||= 0; $Temp = 0;
	if ($Param{Uploaded_User_Count} == 1) {$Temp = $Global{Upload_One_File_Fee};}
	if ($Param{Uploaded_User_Count} == 2) {$Temp = $Global{Upload_Two_File_Fee};}
	if ($Param{Uploaded_User_Count} == 3) {$Temp = $Global{Upload_Three_File_Fee};}
	if ($Param{Uploaded_User_Count} == 4) {$Temp = $Global{Upload_Four_File_Fee};}
	if ($Param{Uploaded_User_Count} >= 5) {$Temp = ($Global{Upload_Five_File_Fee} * $Param{Uploaded_User_Count});}
	$Template =~ s/<!--Total_Uploaded_Fees-->/$Temp/;
	$Template =~ s/<!--Total_Uploaded_Count-->/$Param{Uploaded_User_Count}/;
	#------------------------------------------------------
	#------------------------------------------------------
	$Template =~ s/<!--MAX_UPLOAD_FILES-->/$Global{Max_Upload_Files}/;
	$Template =~ s/<!--MAX_UPLOAD_FILE_SIZE-->/$Global{Max_Upload_File_Size}/;
	$Template =~ s/<!--MAX_UPLOAD_SIZE-->/$Global{Max_Upload_Size}/;
	$Template =~ s/<!--UPLOADED_USER_SIZE-->/$Param{Uploaded_User_Size}/;
	$Template =~ s/<!--UPLOADED_FILES_COUNT-->/$Param{Uploaded_User_Count}/;
	$Template =~ s/<!--ALLOWED_TYPES-->/$Global{Files_Ext_Allowed}/;
	$Template =~ s/<!--Max_Title_Length-->/$Global{Max_Title_Length}/g;
	$Template =~ s/<!--Post_Max_Len-->/$Global{Post_Max_Len}/g;
	#------------------------------------------------------
	if ($Param{Preview}) {
			$Form = &TranslateFile($Global{PreviewTopicFormTemplate});
			#------------------------------------------------------
			$PostTimeClass = ""; $PostTimeFormat = "";	# <!--PostTime:(WD-MD-YY-HH-MM-AP)-->
			if ($Form =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
						$PostTimeClass = $1 . $2 . $3. $4. $5;
						$PostTimeFormat =  $4;
			}
			$PostTimeClass =~ s/\(/\\\(/g;
			$PostTimeClass =~ s/\)/\\\)/g;
			#------------------------------------------------------
			#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
			$Temp = &ParseDate($PostTimeFormat, &Time(time));
			$Form =~ s/$PostTimeClass/$Temp/g;
			#------------------------------------------------------
			$Temp = $Param{Subject};
			$Form =~ s/<!--Subject-->/$Temp/g;
			#------------------------------------------------------
			%Smileys = &LoadSmileys();
			$Message = $Param{Message};
			$Message = &FormatMessage($Message);
			$Form =~ s/<!--Message-->/$Message/g;
			#------------------------------------------------------
			if ($Param{Uploaded_Files}) {
					undef @Media; undef @Docs;
					@Upload = split(/\|/, $Param{Uploaded_Files});
					foreach $File (@Upload) {
						if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
							push @Media, $File;
						}
						else{
							push @Docs, $File;
						}
					}
					$Temp = &Get_Media_Show($Param{Media_Show}, @Media);
					$Form =~ s/<!--Multimedia-->/$Temp/;

					$Docs = "";
					foreach $File (@Docs) {
							if ($File =~ /\.wav$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_sound};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.mid$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_mid};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.mov$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_movie};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							elsif ($File =~ /\.avi$/i) {
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_avi};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							else{
									$Link = qq!$Global{HTML_URL}/upload/$File!;
									$URL = $Language{upload_file_other};
									$URL =~ s/<!--Link-->/$Link/g;
									$URL =~ s/<!--Name-->/$File/g;
							}
							$Docs .= $URL . $Language{docs_files_join};
					}
					$Docs =~ s/$Language{docs_files_join}$//g;
					$Form =~ s/<!--Documents-->/$Docs/;
			}
			#------------------------------------------------------
	}
	else{
			$Form = "";
	}
	$Template =~ s/<!--PreviewNewTopic-->/$Form/g;

	&Display($Template, 1);
}
#==========================================================
sub SaveNewTopic{
my (%Forum, $Title, $Subject, $Message, $Author, $Time, $Poll);
my ($Topic, $Post, $FirstPost, $LastPost, $Query, $Username, $IP);
my ($Topics, $Posts, $Icon, $Color, $Media);
	
	$Param{Message} = $Paramx{Message};

	if ($Param{Preview} || $Param{SubAction} eq "Preview") {
			$Param{Preview} = "Preview";
			&NewTopic;
			return;
	}
	#------------------------------------------------------
	$Param{Forum} += 0;
	$Param{Forum} = int($Param{Forum});
	%Forum = &GetForum($Param{Forum});
	if (!%Forum || !$Param{Forum}) {
		$Plugins{Body} = $Language{error_invalid_forum_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	if (!&CheckForumActionPermissions("Post", %Forum)) {
				$Plugins{Body} = $Language{error_new_reply_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Param{Subject} =~ s/^\s+//;
	$Param{Subject} =~ s/\s+$//;
	$Param{Subject} =~ s/<[^>]+>//ig;
	
	$Param{Message} =~ s/^\s+//;
	$Param{Message} =~ s/\s+$//;
	$Param{Message} =~ s/\cM//g;

	$Param{Message} = &HTML_Treat($Param{Message}, $Global{Post_Treat_HTML});
	$Param{Message} = substr($Param{Message}, 0, $Global{Post_Max_Len});
	
	if (!$Param{Subject}) {
			&NewTopic();
			return;
	}

	if (!$Param{Message}) {
			&NewTopic();
			return;
	}
	#------------------------------------------------------	
	$Title = $dbh->quote($Param{Subject});
	$Subject = $dbh->quote($Param{Subject});
	$Message = $dbh->quote($Param{Message});

	$Param{User_ID} ||= $Global{Guest_User};
	$Author = $dbh->quote($Param{User_ID});
	
	$Time = &Time(time);
	$Poll += 0;  # Poll
	
	$Param{Type} += 0;  # Normal, Sticky, Announcement
	$Param{Status} += 0;  # Open , Closed
	$Param{Type} += 0;

	$Query = qq!INSERT INTO Forum_Topics SET 
							Topic=NULL,
							Forum=$Param{Forum},
							Title=$Title,
							Author=$Author,
							Time=$Time,
							Updated=$Time,
							Views=0,
							Replies=0,
							Status=$Param{Status},
							Type=$Param{Type},
							Poll=$Poll,
							FirstPost= 0,
							LastPost= 0
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Topic = $dbh->{mysql_insertid};
	#------------------------------------------------------
	$Username =  $dbh->quote("");
	$Param{Notify} += 0;
	
	$IP = &Get_Host;
	$IP = $dbh->quote($ENV{REMOTE_ADDR});

	$Query = qq!INSERT INTO Forum_Posts SET 
							Post=NULL,
							Topic=$Topic,
							Forum=$Param{Forum},
							Time=$Time,
							Updated=$Time,
							Author=$Author,
							Username=$Username,
							Notify=$Param{Notify},
							IP=$IP
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Post = $dbh->{mysql_insertid};
	#------------------------------------------------------
	$Query = qq!UPDATE Forum_Topics SET FirstPost=$Post, LastPost=$Post WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	$Query = qq!INSERT INTO Forum_Messages SET 
							Post=$Post,
							Forum=$Param{Forum},
							Subject=$Subject,
							Message=$Message
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	$Param{Icon} ||= "";
	$Param{Color} ||= "";
	$Param{Uploaded_Files} ||= "";
	$Param{Media_Show} ||= 0;

	$Icon = $dbh->quote($Param{Icon});
	$Color = $dbh->quote($Param{Color});
	$Media = $dbh->quote($Param{Uploaded_Files});
	
	$Query = qq!INSERT INTO Forum_Media SET 
							Post=$Post,
							Color=$Color,
							Icon=$Icon,
							Media_Show=$Param{Media_Show},
							Media=$Media
						!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	$Topics = &GetForumTopicsCount($Param{Forum});
	$Posts = &GetForumPostsCount($Param{Forum});
	$Query = qq!UPDATE Forum_Forums SET Posts=$Posts, Topics=$Topics, LastPost=$Post WHERE Forum=$Param{Forum}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# update user posts count
	$User = $dbh->quote($Param{User_ID});
	$Query = qq!UPDATE Forum_Users_Info SET Posts=(Posts+1) WHERE User_ID=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# Mark topic read for this user
	&MarkTopicRead($Param{User_ID}, $Topic);
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	#&Forums;
	# redirect to avoid page refresh and resubmits
	print "Location: $web{ProgUrl}action=Forums&Forum=$Param{Forum}\n\n";
}
#==========================================================

1;