=Copyright Infomation
==========================================================
Program Name    : Mewsoft Classifiedawy RSS Feeder Module
Program Author   : Elsheshtawy, A. A.
Home Page          : http://www.mewsoft.com
Copyrights  2000-2008 Mewsoft Corporation. All rights reserved.
==========================================================
=cut
#==========================================================
# For RSS Validation: http://www.feedvalidator.org/ , http://rss.scripting.com/
#http://www.rssboard.org/rss-2-0
#http://www.rssboard.org/rss-specification
#http://www.rssboard.org/rss-draft-1
#http://www.aggreg8.net/RSS/RSSParser.php
# http://validator.w3.org/feed/check.cgi
#http://aggregator.userland.com/validator 
#http://feeds.archive.org/validator 
# http://www.w3schools.com/tags/ref_entities.asp

#Really Simple Syndication (RSS) is an XML-based document format for the syndication of web content 
# so that it can be republished on other sites or downloaded periodically and presented to users.
#Software designed to retrieve and present RSS documents to users is called an aggregator, newsreader or reader.
#3.3 Character Data
#For all elements defined in this specification that enclose character data, the text must be interpreted as
#plain text with the exception of an item's description element, which must be suitable for presentation as HTML. 
#All of these elements must not contain child elements. 
#There's no limit on the length of character data that can be contained in an RSS element. 
#==========================================================
my %EntityRSS = (
	      nbsp   => "&#160;",
	      iexcl  => "&#161;",
	      cent   => "&#162;",
	      pound  => "&#163;",
	      curren => "&#164;",
	      yen    => "&#165;",
	      brvbar => "&#166;",
	      sect   => "&#167;",
	      uml    => "&#168;",
	      copy   => "&#169;",
	      ordf   => "&#170;",
	      laquo  => "&#171;",
	      'not'    => "&#172;",
	      shy    => "&#173;",
	      reg    => "&#174;",
	      macr   => "&#175;",
	      deg    => "&#176;",
	      plusmn => "&#177;",
	      sup2   => "&#178;",
	      sup3   => "&#179;",
	      acute  => "&#180;",
	      micro  => "&#181;",
	      para   => "&#182;",
	      middot => "&#183;",
	      cedil  => "&#184;",
	      sup1   => "&#185;",
	      ordm   => "&#186;",
	      raquo  => "&#187;",
	      frac14 => "&#188;",
	      frac12 => "&#189;",
	      frac34 => "&#190;",
	      iquest => "&#191;",
	      Agrave => "&#192;",
	      Aacute => "&#193;",
	      Acirc  => "&#194;",
	      Atilde => "&#195;",
	      Auml   => "&#196;",
	      Aring  => "&#197;",
	      AElig  => "&#198;",
	      Ccedil => "&#199;",
	      Egrave => "&#200;",
	      Eacute => "&#201;",
	      Ecirc  => "&#202;",
	      Euml   => "&#203;",
	      Igrave => "&#204;",
	      Iacute => "&#205;",
	      Icirc  => "&#206;",
	      Iuml   => "&#207;",
	      ETH    => "&#208;",
	      Ntilde => "&#209;",
	      Ograve => "&#210;",
	      Oacute => "&#211;",
	      Ocirc  => "&#212;",
	      Otilde => "&#213;",
	      Ouml   => "&#214;",
	      'times'  => "&#215;",
	      Oslash => "&#216;",
	      Ugrave => "&#217;",
	      Uacute => "&#218;",
	      Ucirc  => "&#219;",
	      Uuml   => "&#220;",
	      Yacute => "&#221;",
	      THORN  => "&#222;",
	      szlig  => "&#223;",
	      agrave => "&#224;",
	      aacute => "&#225;",
	      acirc  => "&#226;",
	      atilde => "&#227;",
	      auml   => "&#228;",
	      aring  => "&#229;",
	      aelig  => "&#230;",
	      ccedil => "&#231;",
	      egrave => "&#232;",
	      eacute => "&#233;",
	      ecirc  => "&#234;",
	      euml   => "&#235;",
	      igrave => "&#236;",
	      iacute => "&#237;",
	      icirc  => "&#238;",
	      iuml   => "&#239;",
	      eth    => "&#240;",
	      ntilde => "&#241;",
	      ograve => "&#242;",
	      oacute => "&#243;",
	      ocirc  => "&#244;",
	      otilde => "&#245;",
	      ouml   => "&#246;",
	      divide => "&#247;",
	      oslash => "&#248;",
	      ugrave => "&#249;",
	      uacute => "&#250;",
	      ucirc  => "&#251;",
	      uuml   => "&#252;",
	      yacute => "&#253;",
	      thorn  => "&#254;",
	      yuml   => "&#255;",
	      );

my $EntitiesRSS = join('|', keys %EntityRSS);
#==========================================================
#==========================================================
sub RSS{
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst);
my ($Output, $RssFile, $pubDate, %Currency, @List, $Line);
my ($Temp, $Temp1, $End_Time, $Query, $sth, @Items, $Counter, $ID, %Item);
my ($Link, $ID_Ref, $Name_Ref, @Name, $Category, $Thumb, $Title);
my ($Description, $Images, @Media, @Upload, $File, $Price, $Size);
my (@Months) = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );
my (@Weekday) = ( "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" );

	$ScriptURL = $Global{ProgURL};
    #------------------------------------------------------------------------------------
	$| = 1;
	#print "Content-type: text/xml\n\n";
	print "Content-type: application/rss+xml\n\n";
	
    #------------------------------------------------------------------------------------
    # XML declaration, default 'UTF-8'
    #print qq!<?xml version="1.0" encoding="UTF-8"?>\n\n!;
	print qq!<?xml version="1.0" encoding="$Language{rss_encoding}"?>\n\n!;

    # RSS root element
    print qq!<rss version="2.0" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:dc="http://purl.org/dc/elements/1.1/">\n\n!;
    #------------------------------------------------------------------------------------
    # Channel Element
    #------------------------------------------------------------------------------------
    print "<channel>\n";

	#The title element provides the name of the channel (required). If the channel corresponds directly to a web site, the name
	#should match the name of the site.
    print "<title>".&EncodeCdata($Language{rss_title})."</title>\n";

    $Query = "";
	if ($ENV{CONTENT_LENGTH} ) {
				read(STDIN, $Query, $ENV{CONTENT_LENGTH});
    } 
	elsif ($ENV{QUERY_STRING}) {
			$Query = $ENV{QUERY_STRING};
    }

	#The link element identifies the URL of the web site associated with the channel (required).
    print "<link>".&EncodeRSS("$ScriptURL?$Query")."</link>\n";

	#The description element provides a human-readable characterization or summary of the channel (required). 
	print "<description>".&EncodeCdata($Language{rss_description})."</description>\n";

    # The channel's language element identifies the natural language employed in the channel (optional).
    print "<language>".&EncodeRSS($Language{rss_language})."</language>\n" if ($Language{rss_language});

    #The copyright element declares the human-readable copyright statement that applies to the channel (optional).
    print "<copyright>".&EncodeCdata($Language{rss_copyright})."</copyright>\n" if ($Language{rss_copyright});
	#----------------------------------------------
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime(time);
	$sec = sprintf("%02d", $sec);
	$min = sprintf("%02d", $min);
	$hour = sprintf("%02d", $hour);
	$mon = sprintf("%02d", $mon);
	$mday = sprintf("%02d", $mday);
	$year += 1900;
	# <pubDate>Sun, 19 May 2002 15:21:36 GMT</pubDate>
	$pubDate = qq!$Weekday[$wday], $mday $Months[$mon] $year $hour\:$min\:$sec GMT!;
	#----------------------------------------------
	#The channel's pubDate element indicates the publication date of the channel's content (optional).
    print  "<pubDate>".&EncodeRSS($pubDate)."</pubDate>\n";

    #The channel's lastBuildDate element indicates the last date and time the content of the channel was updated (optional).
	print "<lastBuildDate>".&EncodeRSS($pubDate)."</lastBuildDate>\n";

    # managing editor
    print "<managingEditor>".&EncodeRSS($Language{rss_managingeditor})."</managingEditor>\n" if ($Language{rss_managingeditor});

    #The channel's webMaster element provides the e-mail address of the person to contact about technical issues regarding the channel (optional). 
    print "<webMaster>".&EncodeRSS($Language{rss_webmaster})."</webMaster>\n" if ($Language{rss_webmaster});

    #The category element identifies a category or tag to which the channel belongs (optional).
    print "<category>".&EncodeRSS($Language{rss_category})."</category>\n" if ($Language{rss_category});

    # The generator element credits the software that created the channel (optional).
    print "<generator>".&EncodeRSS($Language{rss_generator})."</generator>\n" if ($Language{rss_generator});

    #The channel's ttl element represents the channel's time to live: the number of minutes it can be cached before another request should be made by an aggregator (optional).
	if ($Language{rss_ttl} ne "") {$Language{rss_ttl} += 0; $Language{rss_ttl} = int($Language{rss_ttl});}
    print "<ttl>".&EncodeRSS($Language{rss_ttl})."</ttl>\n" if ($Language{rss_ttl} > 0);

    print "\n";
	#--------------------------------------------------------------------------------------
	$Param{Limit} += 0;
	$Param{Limit} = int($Param{Limit});
	if ($Param{Limit} < 1) {$Param{Limit} = 20;}

	$Paramx{Forum} =~ s/\|\|/\,/g;
	$Paramx{Forum} =~ s/[^\d\,]//g;
	@Forums = split(/\,/, $Paramx{Forum});
	if (@Forums) {
			$Forums = "WHERE Forum IN (" . join (",", @Forums) . ")";
	}
	else {
			$Forums = "";
	}

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT TOP $Param{Limit} Post FROM Forum_Posts $Forums ORDER BY TIME DESC!;
	}
	else{
			$Query = qq!SELECT Post FROM Forum_Posts $Forums ORDER BY TIME DESC LIMIT $Param{Limit}!;
	}
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Posts;
	while(($Post) = $sth->fetchrow_array) {
			push @Posts, $Post;
	}
	$sth->finish;
	#--------------------------------------------------------------------------------------
	#--------------------------------------------------------------------------------------
	$Counter = 0;
	foreach $Post (@Posts) {
			%Post = &GetForumPost($Post);
			%Topic = &GetForumTopic($Post{Topic});
			%Media = &GetForumPostMedia($Post);
			%Message = &GetForumMessage($Post);
			%User = &GetForumUser($Post{Author});
			#----------------------------------------------
			($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $dst) = gmtime($Post{Time});
			$sec = sprintf("%02d", $sec);
			$min = sprintf("%02d", $min);
			$hour = sprintf("%02d", $hour);
			$mon = sprintf("%02d", $mon);
			$mday = sprintf("%02d", $mday);
			$year += 1900;
			# <pubDate>Wed, 02 Oct 2002 13:00:00 GMT</pubDate>
			$pubDate = "$Weekday[$wday], $mday $Months[$mon] $year $hour\:$min\:$sec GMT";
			#----------------------------------------------
			#			Title
			#----------------------------------------------
			if ($Message{Subject}) {
					$Title = $Message{Subject};
			}
			else{
					$Title = $Topic{Title};
			}
			$Title || next;
			#------------------------------------------------------
			# Process syntax highlighting [perl] ..[/perl]
			$Description = &FormatMessage($Message{Message});
			$Description || next;
			#------------------------------------------------------
			$Link = qq!$ScriptURL?action=ViewTopic&Topic=$Post{Topic}&Forum=$Topic{Forum}&Page=1&Lang=$Global{Language}!;
			#------------------------------------------------------
			$Profile = qq!$ScriptURL?action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
			#------------------------------------------------------
			#http://www.rssboard.org/rss-draft-1
			#The description must be suitable for presentation as HTML. HTML markup must be encoded as character data either 
			#by employing the HTML entities &lt; ("<") and &gt; (">") or a CDATA section. 
			#Escaped markup created with character entities: 
			#<description>I'm headed for France. I wasn't gonna go this year, but then last week &lt;a href="http://www.imdb.com/title/tt0086525/"&gt;Valley
			#	Girl&lt;/a&gt; came out and I said to myself, Joe Bob, you gotta get out of the country for a while.</description> 
			#
			#CDATA encoding: 
			#<description><![CDATA[I'm headed for France. I wasn't gonna go this year, but then last 
			#week <a href="http://www.imdb.com/title/tt0086525/">Valley Girl</a> came out and I said to myself, Joe 
			#Bob, you gotta get out of the country for a while.]]></description> 
			#The description should not contain relative URLs. When a relative URL is present, an aggregator may 
			#attempt to resolve it to a full URL using the channel's link as the base.
			#--------------------------------------------------------------------------------------
			#			Images
			#--------------------------------------------------------------------------------------
			$Images = ""; 
			undef @Media;
			if ($Media{Media}) {
					@Upload = split(/\|/, $Media{Media});
					foreach $File (@Upload) {
						if ($File =~ /\.gif|\.png|\.jpg|\.pjpeg|\.pjpg|\.jpeg|\.bmp$/i ) {
							push @Media, $File;
						}
					}
			}

			#<enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" /> 
			if (@Media) {
				$Temp = 0; $Images = ""; $Enclosure = "";
				foreach $File (@Media) {
						$Images .= qq!<br><img src="$Global{HTML_URL}/upload/$File">!;
						$Temp++;
						#image/bmp, image/png, image/jpeg  jpeg,jpg,jpe,jfif,pjpeg,pjp, image/gif
						if ($File =~ /\.gif$/i ) {$Temp1 = "image/gif";}
						elsif ($File =~ /\.png$/i ) {$Temp1 = "image/png";}
						elsif ($File =~ /\.bmp$/i ) {$Temp1 = "image/bmp";}
						elsif ($File =~ /\.jpg|\.pjpeg|\.pjpg|\.jpeg$/i ) {$Temp1 = "image/jpeg";}
						else {$Temp1 = "";}
						$Size = -s "$Global{HTML_Dir}/upload/$File";
						if ($Temp1 ne "" and $Enclosure eq "") {
								$Enclosure .= "<enclosure " . &EncodeRSS(qq!url="$Global{HTML_URL}/upload/$File" length="$Size" type="$Temp1"!). " />\n";
						}
						#if ($Temp >= 5) {last;}
				}
			}
			#--------------------------------------------------------------------------------------
			print "<item>\n";
            print "<title>" . &EncodeCdata($Title) . "</title>\n";
            print "<link>" . &EncodeRSS($Link) . "</link>\n";
			#print "<author>" . &EncodeCdata($Post{Author}) . "</author>\n";
			print "<dc:creator>" . &EncodeCdata($Post{Author}) . "</dc:creator>\n";
            print "<description>" . &EncodeCdata($Description) . "</description>\n";
			#print "<content:encoded>" . &EncodeCdata($Description) . "</content:encoded>\n";
            #print RSS '<author>'.&EncodeRSS($Item{User_ID}).'</author>'."\n";
			#An item's comments element identifies the URL of a web page that contains comments received in response to the item (optional). 
            #print RSS '<comments>'.&EncodeRSS($item->{comments}).'</comments>'."\n" if $item->{comments};
			# <enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" /> 
			#if ($Enclosure) {print $Enclosure;}
			print "<pubDate>" . &EncodeRSS($pubDate). "</pubDate>\n";
			print qq!<guid>! . &EncodeRSS($Link) . "</guid>\n";
			print "</item>\n";
			#--------------------------------------------------------------------------------------
			$Counter++;
			#--------------------------------------------------------------------------------------
	}
	#----------------------------------------------------------------------------------------------
	#----------------------------------------------------------------------------------------------
    # end channel element
    print '</channel>'."\n";
    print '</rss>';
	#----------------------------------------------------------------------------------------------
}
#==========================================================
sub xml_escape {
    my $str = shift;
    return '' unless defined $str;
    # except for TAB(\x09),CR(\x0D),LF(\x0A)
    $str =~ s{
        ([\x00-\x08\x0B\x0C\x0E-\x1F\x7F])
    }{
        sprintf( '&#%d;', ord($1) );
    }gex;
    $str =~ s/&(?!#(\d+;|x[\dA-Fa-f]+;))/&amp;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/'/&apos;/g;
    $str =~ s/"/&quot;/g;
    $str;
}
#==========================================================
sub EncodeCdata {
my ($Text) = @_;
	
	return &xml_escape($Text);

    $Text =~ s{
        ([\x00-\x08\x0B\x0C\x0E-\x1F\x7F])
    }{
        sprintf( '&#%d;', ord($1) );
    }gex;

	#$Text = "<![CDATA[". $Text . "]]>";
	$Text = "<![CDATA[". EncodeTextRSS($Text) . "]]>";
	return $Text;
}
#==========================================================
sub EncodeRSS {
my ($Text) = @_;
	
	return &xml_escape($Text);

	#$Text =~ s/([\200-\377])/'&#'.ord($1).';'/ge;
	#$Text =~ s/&(?!(#[0-9]+|#x[0-9a-fA-F]+|\w+);)/&amp;/g;

    # except for TAB(\x09),CR(\x0D),LF(\x0A)
    $Text =~ s{
        ([\x00-\x08\x0B\x0C\x0E-\x1F\x7F])
    }{
        sprintf( '&#%d;', ord($1) );
    }gex;

	$Text =~ s/&/&amp;/g;
	#$Text =~ s/&(?!#(\d+;|x[\dA-Fa-f]+;))/&amp;/g;
    $Text =~ s/&($EntitiesRSS);/$EntityRSS{$1}/g;
    $Text =~ s/</&lt;/g;
	$Text =~ s/>/&gt;/g;
	$Text =~ s/"/&quot;/g;
	$Text =~ s/'/&apos;/g;
	return $Text;
}
#==========================================================
sub ExitT{
my ($Msg) = @_;
my ($Out);

	print "$Msg";
	if ($dbh) {&DB_Disconnect();}
	exit 0;
}
#==========================================================

1;