=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub SqlVal {
my ($query) = shift;
my ($Col);
	#SELECT Forum FROM Forum_Forums WHERE ID=123
	#Return one column value
	($Col) = @{$dbh->selectcol_arrayref($query)};
	return $Col;
}
#==========================================================
sub SqlCol {
my ($query) = shift;
my ($Col);
	#SELECT Forum FROM Forum_Forums
	#Return array of one column values
	#($Col) = @{$dbh->selectcol_arrayref($query)};
	return @{$dbh->selectcol_arrayref($query)};
}
#==========================================================
sub SqlRow {
my ($query) = shift;
	#SELECT Forum, Parent, Name FROM Forum_Forums
	return $dbh->selectrow_array($query);
}
#==========================================================
sub SqlHash {
my ($query) = shift;
	#SELECT * FROM Forum_Topics WHERE Topic=$Topic LIMIT 1
	return %{$dbh->selectrow_hashref($query)};
}
#==========================================================
sub SqlCount {
my ($query) = shift;
	#SELECT Count(*) FROM Forum_Forums
	return $dbh->selectrow_array($query);
}
#==========================================================
sub SqlCols {
my ($query) = shift;
	#SELECT Post, Topic FROM Forum_Posts
	my $arrayref = $dbh->selectall_arrayref($query);
	#@Items = map {$_->[0]} @{$arrayref};
	#@Topics = map {$_->[1]} @{$arrayref};
	return $arrayref;
}
#==========================================================
sub SqlColHash {
my ($query) = shift;
	#SELECT Post, Topic FROM Forum_Posts
	my %list = map { $_->[0], $_->[1]} @{$dbh->selectall_arrayref($query)};
	return %list;
}
#==========================================================
sub SqlDel {
my ($query) = shift;
	#DELETE From Forum_Topic_Read
	$dbh->do($query) || &dbExit($query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Update_Total_Accounts_Counts{

	$Global{TotalUsers} = &Get_Total_Accounts_Count;
	$Global{TotalActiveUsers} = &Get_Total_Active_Accounts_Count;
	$Global{TotalInactiveUsers} = &Get_Total_Suspended_Accounts_Count;
	
	&UpdateNewestUser;
	&UpdateSettings(TotalUsers=>$Global{TotalUsers},
									TotalActiveUsers=>$Global{TotalActiveUsers},
									TotalInactiveUsers=>$Global{TotalInactiveUsers}
								);
}
#==========================================================
sub UpdateNewestUser {
my ($User);
	($User) =  $dbh->selectrow_array(qq!SELECT User_ID FROM Users ORDER BY Start_Date DESC LIMIT 1!);
	&UpdateSettings(NewestUser => $User);
}
#==========================================================
sub Get_Total_Accounts_Count {
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Users!);
}
#==========================================================
sub Get_Total_Suspended_Accounts_Count{
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Users WHERE Status=0!);
}
#==========================================================
sub Get_Total_Active_Accounts_Count{
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM Users WHERE Status=1!);
}
#==========================================================
sub Users_History_Count {
my ($Start, $End) = @_;
my ($Query, %Users);

	if ($Start > 0 && $End > 0) {
		$Query = qq!SELECT User_ID, Start_Date FROM Users WHERE (Start_Date>=$Start AND Start_Date<=$End) ORDER BY Start_Date DESC!;
	}
	else{
		$Query = qq!SELECT User_ID, Start_Date FROM Users ORDER BY Start_Date DESC!;
	}

	%Users = map { $_->[0], $_->[1]} @{$dbh->selectall_arrayref($Query)};
	return %Users;
}
#==========================================================
sub Delete_Accounts{
my (@Users) = @_;
my ($Users, $User, $Query);
	
	if (!@Users) {return;}
	$Users = "";
	foreach $User (@Users) {
			$Users .= $dbh->quote($User) . ",";
	}
	$Users =~ s/\,\s*$//g;
	
    $Query = qq!DELETE FROM Users WHERE User_ID IN ($Users)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

    $Query = qq!DELETE FROM Users_Info WHERE User_ID IN ($Users)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

    $Query = qq!DELETE FROM Forum_Users_Info WHERE User_ID IN ($Users)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Change_Accounts_Status{
my (%Status) = @_;
my ($User_ID, $Status, $Query);

	while (($User_ID, $Status) = each %Status) {
			$Status = $dbh->quote($Status);
			$User_ID = $dbh->quote($User_ID);
			$Query = qq!UPDATE Users set  Status=$Status WHERE User_ID=$User_ID!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	
}
#==========================================================
sub Add_New_User {
my (%User) = @_;
my ($Query, $K);

	if ($User{Total_Paid} eq "") {$User{Total_Paid} = 0;}
	if ($User{Current_Balance} eq "") {$User{Current_Balance} = 0;}
	if ($User{CC_Month} eq "") {$User{CC_Month} = 0;}
	if ($User{CC_Year} eq "") {$User{CC_Year} = 0;}
	if ($User{CC_CVV} eq "") {$User{CC_CVV} = 0;}

	$Query = qq!INSERT INTO Users SET !;
	foreach $K (@User_Fields) {
			$Query .= "$K=" . $dbh->quote($User{$K}) . ",";
	}
    $Query =~ s/,$//g;
    $Query =~ s/,$//;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Add_New_Pending_User {
my (%User) = @_;
my ($Field, $Query, $sth);
	
	if ($User{Total_Paid} eq "") {$User{Total_Paid} = 0;}
	if ($User{Current_Balance} eq "") {$User{Current_Balance} = 0;}
	if ($User{CC_Month} eq "") {$User{CC_Month} = 0;}
	if ($User{CC_Year} eq "") {$User{CC_Year} = 0;}
	if ($User{CC_CVV} eq "") {$User{CC_CVV} = 0;}

    $Query = qq!INSERT INTO Pending_Users (!;
	$Query .= join(", ", @Pending_User_Fields);
    $Query .= qq!) VALUES (!;

    foreach $Field (@Pending_User_Fields) {
        $Query .= $dbh->quote($User{$Field}) . ",";
    }

    $Query =~ s/,$//;
    $Query .= ")";

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->finish;
}
#==========================================================
sub Get_User{
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Users WHERE User_ID = $User_ID LIMIT 1!)};
}
#==========================================================
sub Get_Pending_User{
my ($Email) = @_;
	$Email = $dbh->quote($Email);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Pending_Users WHERE Email=$Email LIMIT 1!)};
}
#==========================================================
sub Add_New_User_Info{
my (%Info) = @_;
my ($Query, @Fields, $Field);
	
	if ($Info{Sell} eq "") {$Info{Sell} = 0;}
	if ($Info{Buy} eq "") {$Info{Buy} = 0;}
	if ($Info{Verified} eq "") {$Info{Verified} = 0;}
	if ($Info{Verified1} eq "") {$Info{Verified1} = 0;}
	if ($Info{Verified2} eq "") {$Info{Verified2} = 0;}
	if ($Info{Partner} eq "") {$Info{Partner} = 0;}
	if ($Info{Sponser} eq "") {$Info{Sponser} = 0;}
	if ($Info{Power} eq "") {$Info{Power} = 0;}
	if ($Info{Rated} eq "") {$Info{Rated} = 0;}

	$Query = qq!INSERT INTO Users_Info (!;
	
	@Fields = qw(
							User_ID
							Sell
							Buy
							Verified
							Verified1
							Verified2
							Partner
							Sponser
							Power
							Rated
						);	
	
	$Query .= join(", ", @Fields);
    $Query .= qq!) VALUES (!;

    foreach $Field (@Fields) {
        $Query .= $dbh->quote($Info{$Field}) . ",";
    }
    
	$Query =~ s/,$//;
    $Query .= ")";

	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Add_New_Forum_Users_Info{
my (%Info) = @_;
my ($Query, $Fields, $Field);
	
	$Fields = "";
	foreach $Field (keys %Info) {
			$Fields .= $Field . "=". $dbh->quote($Info{$Field}) . ",";
	}
	$Fields =~ s/\,$//g;

	$Query = qq!INSERT INTO Forum_Users_Info SET $Fields!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_User_Info{
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Users_Info WHERE User_ID=$User_ID LIMIT 1!)};
}
#==========================================================
sub Update_User_Info{
my ($User_ID, %Info) = @_;
my ($Query, $Field);
	
	$User_ID = $dbh->quote($User_ID);
	$Query = qq!UPDATE Users_Info SET !;
	
	foreach $Field (keys %Info) {
			next if ($Field eq "User_ID");
			$Query .= "$Field=". $dbh->quote($Info{$Field}) .",";
	}

	$Query =~ s/\,$//g;
	$Query .= qq! WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Delete_Pending_User{
my ($User_ID) = @_;
	
	$User_ID = $dbh->quote($User_ID);
	$Query = qq!DELETE FROM Pending_Users WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Delete_Pending_User_By_Email{
my ($Email) = @_;
	
	$Email = $dbh->quote($Email);
	$Query = qq!DELETE FROM Pending_Users WHERE Email=$Email!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_User_By_Login{
my ($User_ID, $Password) = @_;
	$User_ID = $dbh->quote($User_ID);
	$Password = $dbh->quote($Password);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Users WHERE User_ID=$User_ID AND Password=$Password LIMIT 1!)};
}
#==========================================================
sub Get_User_ID_by_Email{
my ($Email) = @_;
	$Email = $dbh->quote($Email);
	return %{$dbh->selectrow_hashref(qq!SELECT User_ID FROM Users WHERE Email=$Email LIMIT 1!)};
}
#==========================================================
sub Get_User_By_Email{
my ($Email) = @_;
	$Email = $dbh->quote($Email);
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Users WHERE Email=$Email LIMIT 1!)};
}
#==========================================================
sub Update_User{
my ($User_ID, %User) = @_;
my ($Query, $Field, $sth);

    $User_ID = $dbh->quote($User_ID);
	$Query = qq!UPDATE Users SET !;

    foreach $Field (keys %User) {
				next if ($Field eq 'User_ID');
			    $Query .= "$Field=" . $dbh->quote($User{$Field}) . ",";
    }

    $Query =~ s/\,$//g;

    $Query .= qq! WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_Accounts_Group{
my ($Group) = @_;
my (@Accounts, $Query, $sth, $User_ID);

	if ($Group) {
			if ($Group eq "9") { #ORDER BY Rank DESC, Price DESC, Title ASC!;
					#SELECT * FROM pet WHERE name REGEXP "^[bB]"; 
					$Query = qq!SELECT User_ID FROM Users WHERE User_ID REGEXP "^[0-9]" ORDER BY Start_Date DESC, User_ID ASC!;
			}
			else{
					$Query = qq!SELECT User_ID FROM Users WHERE User_ID LIKE '$Group%' ORDER BY Start_Date DESC, User_ID ASC!;
			}
	}
	else{
			$Query = qq!SELECT User_ID FROM Users ORDER BY Start_Date DESC, User_ID ASC!;
	}

	return @{$dbh->selectcol_arrayref($Query)};
}
#==========================================================
sub Get_Accounts_List{
	return @{$dbh->selectcol_arrayref(qq!SELECT User_ID FROM Users ORDER BY User_ID ASC!)};
}
#==========================================================
sub Get_Pending_Accounts_Group{
my ($Group) = @_;
my (@Accounts, $Query, $sth, $User_ID);

	if ($Group) {
			if ($Group eq "9") { #ORDER BY Rank DESC, Price DESC, Title ASC!;
					#SELECT * FROM pet WHERE name REGEXP "^[bB]"; 
					$Query = qq!SELECT User_ID FROM Pending_Users WHERE User_ID REGEXP "^[0-9]" ORDER BY Start_Date DESC, User_ID ASC!;
			}
			else{
					$Query = qq!SELECT User_ID FROM Pending_Users WHERE User_ID LIKE '$Group%' ORDER BY Start_Date DESC, User_ID ASC!;
			}
	}
	else{
			$Query = qq!SELECT User_ID FROM Pending_Users ORDER BY Start_Date DESC, User_ID ASC!;
	}

	return @{$dbh->selectcol_arrayref($Query)};
}
#==========================================================
sub Add_User_Balance{
my ($User_ID, $Amount) = @_;
my ($Query, $Time);
	
	if (!$User_ID ||  !$Amount) {return;}
	$Time = $dbh->quote(&Time(time));
	$User_ID = $dbh->quote($User_ID);
    $Query = qq!UPDATE Users set  Current_Balance=(Current_Balance+$Amount), Total_Paid=Total_Paid+$Amount, Last_Paid_Date=$Time WHERE User_ID = $User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Add_User_Deposit{
my ($User_ID, $Amount, $Time, $Source) = @_;
my ($Query, $sth);
	
	$User_ID = $dbh->quote($User_ID);
	$Source = $dbh->quote($Source);
    $Query = qq!INSERT INTO Deposits VALUES($User_ID, $Amount, $Time, $Source)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Make_Deposit{
my ($User_ID, $Amount, $Time, $Source) = @_;
my ($Query, $sth, $Balance, $Temp, $ID, $Type);
	
	$User = $dbh->quote($User_ID);
	$Source = $dbh->quote($Source);

	$Query = qq!INSERT INTO Deposits VALUES($User, $Amount, $Time, $Source)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

    $Query = qq!UPDATE Users set Current_Balance=(Current_Balance+$Amount), Total_Paid=(Total_Paid+$Amount), Last_Paid_Date=$Time WHERE User_ID=$User!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	
	if ($Amount > 0) {
		&Process_Transactions_Payments($User_ID, $Amount);
	}

}
#==========================================================
sub Process_Transactions_Payments{
my ($User_ID, $Amount) = @_;
my (@Trans, $User_ID1, $Query, $sth, $Count, $Temp, @Row);

	$User_ID1 = $dbh->quote($User_ID);
	if ($Amount <= 0) {return;}

	$Query = qq!SELECT * FROM Transactions WHERE User_ID=$User_ID1 AND Due>0 ORDER BY Date ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Count = 0;
	undef @Trans;
	while(@Row = $sth->fetchrow_array) {
			@{$Trans[$Count++]}{qw(TID User_ID ID Type Amount Due Balance Date Comments)} = @Row;
	}

	$sth->finish;

	for $Count(0..$#Trans) {
			if ($Trans[$Count]{Due}<=0) {next;}
			if ($Amount <=0) {last;}
			if ($Amount >= $Trans[$Count]{Due}) {
					$Amount -= $Trans[$Count]{Due};
					$Query = qq!UPDATE Transactions SET Due=0 WHERE TID='$Trans[$Count]{TID}'!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
			elsif ($Amount >0 && ($Amount < $Trans[$Count]{Due})){
					$Temp = abs($Trans[$Count]{Due}) - $Amount;
					$Query = qq!UPDATE Transactions SET Due=$Temp WHERE TID='$Trans[$Count]{TID}'!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					last;
			}
			else{
					last;
			}
	}

}
#==========================================================
sub User_Balance_Deduct{
my ($User_ID, $Amount) = @_;
my ($Query);

	$Amount = abs($Amount);
	$Query = qq!UPDATE Users set Current_Balance = (Current_Balance-$Amount) WHERE User_ID=$User_ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub Get_User_Balance{
my ($User_ID) = @_;
my ($Balance, $Query, $sth, $Temp);

	$User_ID = $dbh->quote($User_ID);
	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT TOP 1 Current_Balance FROM Users WHERE User_ID=$User_ID!;
	}
	else{
			$Query = qq!SELECT Current_Balance FROM Users WHERE User_ID=$User_ID LIMIT 1!;
	}
	
	return ($dbh->selectrow_array($Query));
}
#==========================================================
sub Process_Invoices_Payments{
my($User_ID, $Amount) = @_;
my(@Invoice, $Query, $sth, $Count, $Temp, @Row);

	$User_ID = $dbh->quote($User_ID);
	if ($Amount <= 0) {return;}

	#Invoice User_ID Date Start End Amount Balance Due PaidDate Overdue 
	$Query = qq!SELECT * FROM Auction_Invoices WHERE User_ID=$User_ID AND Due>0 ORDER BY Date ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
	$Count = 0;
	undef @Trans;
	while(@Row = $sth->fetchrow_array) {
			@{$Invoice[$Count++]}{qw(Invoice User_ID Date Start End Amount Balance Due PaidDate Overdue)} = @Row;
	}

	$sth->finish;

	for $Count(0..$#Invoice) {
			if ($Invoice[$Count]{Due}<=0) {next;}
			if ($Amount <=0) {last;}

			if ($Amount >= $Invoice[$Count]{Due}) {
					$Amount -= $Invoice[$Count]{Due};
					$Query = qq!UPDATE Auction_Invoices SET Due=0 WHERE Invoice='$Invoice[$Count]{Invoice}'!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
			elsif ($Amount >0 && ($Amount < $Invoice[$Count]{Due})){
					$Temp = abs($Invoice[$Count]{Due}) - $Amount;
					$Query = qq!UPDATE Auction_Invoices SET Due=$Temp WHERE TID='$Invoice[$Count]{Invoice}'!;
					$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
					last;
			}
			else{
					last;
			}
	}

}
#==========================================================
sub Delete_User {
my ($User_ID) = shift;
my ($Query, $sth);

	$User_ID = $dbh->quote($User_ID);
	$Query = qq!DELETE FROM users WHERE User_ID=$User_ID!;
    $dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Users_Info WHERE User_ID=$User_ID!;
    $dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	$Query = qq!DELETE FROM Credit_Cards WHERE User_ID=$User_ID!;
    $dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub GetSmiley{
my ($ID) = @_;
	$ID += 0;
	return %{$dbh->selectrow_hashref(qq!SELECT * FROM Forum_Smileys WHERE ID=$ID LIMIT 1!)};
}
#==========================================================
sub GetUserInboxUnReadMsgsCount{
my ($User) = @_;
	$User = $dbh->quote($User);
	return $dbh->selectrow_array(qq!SELECT Count(*) FROM PrivMsgs WHERE Status=0 AND User=$User AND Folder=0!);
}
#==========================================================
sub GetUserOpenAuctionsCount {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return $dbh->selectrow_array(qq!SELECT Count(ID) FROM Items WHERE User_ID=$User_ID AND Status=1!);
}
#==========================================================
sub GetUserOpenAdsCount {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return $dbh->selectrow_array(qq!SELECT Count(ID) FROM Ads WHERE User_ID=$User_ID AND Status=1!);
}
#==========================================================
sub GetUserAllAuctionsCount {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return $dbh->selectrow_array(qq!SELECT Count(ID) FROM Items WHERE User_ID=$User_ID!);
}
#==========================================================
sub GetUserAllAdsCount {
my ($User_ID) = @_;
	$User_ID = $dbh->quote($User_ID);
	return $dbh->selectrow_array(qq!SELECT Count(ID) FROM Ads WHERE User_ID=$User_ID!);
}
#==========================================================
sub Import_Table{
my ($Table, $Delimiter, $Escape, $EOLine, $File)=@_;
my ($Query, $sth);

	$File = $dbh->quote($File);
    $Delimiter = $dbh->quote($Delimiter);
    $Escape = $dbh->quote($Escape);
	$EOLine = "'" . $EOLine . "'";

	$Query = qq!LOAD DATA INFILE $File INTO TABLE $Table
						FIELDS 
						TERMINATED BY $Delimiter 
						ESCAPED BY $Escape
						LINES TERMINATED BY $EOLine!;
        
    $sth = $dbh->do($Query);
}
#==========================================================
sub Export_Table{
my ($Table, $Delimiter, $Escape, $EOLine, $File)=@_;
my ($Query, $sth);

	$File = $dbh->quote($File);
    $Delimiter = $dbh->quote($Delimiter);
    $Escape = $dbh->quote($Escape);
	$EOLine = "'" . $EOLine . "'";

	$Query = qq!SELECT * INTO OUTFILE $File FIELDS TERMINATED BY $Delimiter 	ESCAPED BY $Escape LINES TERMINATED BY $EOLine FROM $Table!;
        
	#$sth = $dbh->do($Query);
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#while(@Row = $sth->fetchrow_array) {
	#	print "@Row <br>";
	#}
	$sth->finish;
}
#==========================================================
sub Get_Table_Fields{
my ($Table) = @_;
my (@Fields, $Query, $sth);
my ($Field, $type, $null, $key, $default, $extra);

return;

	$Query = qq!SHOW COLUMNS FROM $Table!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while(($Field, $type, $null, $key, $default, $extra) = $sth->fetchrow_array) {
			push(@Fields, $Field);
	}
	$sth->finish;
	return @Fields;
}
#==========================================================
sub Get_Col_Type{   
my ($Table) = @_;
my ($sth, $Query, @array, @Type);
# Gets the type each field/column of the table specified.

    $Query = qq!DESCRIBE $Table!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while (@array = $sth->fetchrow_array()) {
				#push (@Type, $array[0]); #Filed Name
				push (@Type, $array[1]); #Field type
    }
    $sth->finish();
    return @Type;
}
#==========================================================
sub Get_PRI_Key{
my ($Table) = @_;
my ($sth, $Query, @array, @PRI_Key);
# Gets the primary key of the table specified.
    
    @PRI_Key = ();
    $Query = qq!DESCRIBE $Table!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
    while (@array = $sth->fetchrow_array) {
        if ($array[3] eq 'PRI') { push(@PRI_Key, $array[0]); }
    }
    $sth->finish();
    return @PRI_Key;
}
#==========================================================
sub DB_Connect{
my ($Driver, $DSN);

#  $dbh = Mysql->connect($host, undef, $user, $password);
# $dbh = Mysql->connect($host, $database, $user, $password);
# $dbh = DBI->connect('dbi:ODBC:DSN', 'user', 'password');
#    $driver = "mysql";
#    $dsn = "DBI:$driver:database=$database;host=$hostname;port=$port";
#my $dbh = DBI->connect ("dbi:mysql:dbname=test;host=screamer;port=3306", 
#"some_username", "somepassword", {PrintError => 0,RaiseError => 0,AutoCommit => 1,});


=help
General Commentary re web database access 
Typically, the Web server is installed as an NT service or a Windows 95/98 service.
This typically means that the web server itself does not have the same environment and
permissions the web developer does. This situation, of course, can and does apply to Unix
web servers. Under Win32, however, the problems are usually slightly different. 

Defining your DSN -- which type should I use? 
Under Win32 take care to define your DSN as a system DSN, not as a user DSN. 
The system DSN is a "global" one, while the user is local to a user. Typically, as stated 
above, the web server is "logged in" as a different user than the web developer.
This helps cause the situation where someone asks why a script succeeds from the 
command line, but fails when called from the web server. 
=cut

	if ($Global{DB_Driver} =~ m/ODBC/i) {
		$dbh = DBI->connect("DBI:ODBC:$Global{DB_DSN}", $Global{DB_UserID}, $Global{DB_Password}) || &DB_Exit("DBI:ODBC:$Global{DB_DSN} <br>Line ".__LINE__ . ", File ". __FILE__);
		return;
	}

   $DSN = "DBI:$Global{DB_Driver}:database=$Global{DB_Name};host=$Global{DB_Host};port=$Global{DB_Port}";
   $dbh = DBI->connect($DSN, $Global{DB_UserID}, $Global{DB_Password}) || &DB_Exit("$DSN");
}
#==========================================================
sub DB_Start{

	&DB_Connect();
	#@User_Fields = &Get_Table_Fields("Users");
	@User_Fields = qw(
							User_ID
							Password
							Email
							FName
							LName
							Company
							Job_Title
							Street
							City
							State
							Zip
							Country
							Phone
							Mobile
							Fax
							Website
							Payment_Method
							Start_Date
							Last_Updated
							Status
							User_Icon
							Total_Paid
							Current_Balance
							Last_Paid_Date
							User1
							User2
							User3
							User4
							User5
							User6
							User7
							User8
							User9
							User10
							User11
							User12
							User13
							User14
							User15
							User16
							User17
							User18
							User19
							User20
				);

	@Pending_User_Fields = qw(
							User_ID
							Password
							Email
							FName
							LName
							Company
							Job_Title
							Street
							City
							State
							Zip
							Country
							Phone
							Mobile
							Fax
							Website
							Payment_Method
							CC_Number
							CC_Name
							CC_Type
							CC_Month
							CC_Year
							CC_CVV
							CC_IssueNum
							CC_Bank
							CC_Phone
							CC_Street
							CC_City
							CC_State
							CC_Zip
							CC_Country
							Start_Date
							Last_Updated
							Status
							User_Icon
							Total_Paid
							Current_Balance
							Last_Paid_Date
							Promotional_Code
							Confirmation_Code
							User1
							User2
							User3
							User4
							User5
							User6
							User7
							User8
							User9
							User10
							User11
							User12
							User13
							User14
							User15
							User16
							User17
							User18
							User19
							User20
				);
	#------------------------------------------------------
	#SELECT * FROM pet WHERE name REGEXP "^b"; case sensitive
	#SELECT * FROM pet WHERE name REGEXP "^[bB]";
	#SELECT * FROM pet WHERE name REGEXP BINARY "^b";
	#SELECT * FROM pet WHERE name REGEXP "fy$";
	#SELECT * FROM pet WHERE name REGEXP "w";
	#SELECT * FROM pet WHERE name REGEXP "^.....$";
	#SELECT * FROM pet WHERE name REGEXP "^.{5}$";
	# Let SQL use temp disk tables instead of temp memory tables, slower but no errors
	#$SQL = qq!SET OPTION SQL_BIG_TABLES=1!;
	#$dbh->do($SQL);
	#------------------------------------------------------
}
#==========================================================
sub DB_Disconnect{
   $sth->finish if($sth);
   $dbh->disconnect if($dbh);
}
#==========================================================
sub DB_Query{
my ($Query) = @_;
my ($sth);
	
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__); 
	return $sth;
}
#==========================================================
sub Get_DB_List{
my ($Query, $sth, $DB, @DB);

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT table_name FROM information_schema.tables!;
	}
	else{
			$Query = qq!SHOW DATABASES!;
	}
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__); 
	undef @DB;
	while (($DB)=$sth->fetchrow_array){
			push (@DB, $DB);
	}
	$sth->finish;
	return @DB;
}
#==========================================================
sub DB_Create{
my ($DB_Name) = @_;
my ($Query, $sth);

	#$Query = "CREATE DATABASE IF NOT EXISTS $DB_Name";
	$Query = qq!CREATE DATABASE $DB_Name!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Drop{
my ($DB_Name) = shift;
my ($Query, $sth);

	#$Query = "DROP DATABASE IF EXISTS $DB_Name";
	$Query = qq!DROP DATABASE $DB_Name!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Variables{
my ($Query, $sth, $Var, $Value, %Var);

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT table_name FROM information_schema.tables!;
	}
	else{
			$Query = qq!SHOW VARIABLES!;
	}
	
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__); 
	undef %Var;
	while (($Var, $Value) = $sth->fetchrow_array) {
					$Var{$Var} = $Value;
    }

	$sth->finish;
	return %Var;
}
#==========================================================
sub DB_Show_Table{
my ($Table) = @_;
my ($Query, $sth, %Var, $Var, @Row, $x);

	$Table = $dbh->quote($Table);
	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT * FROM information_schema.columns WHERE table_name=$Table!;
	}
	else{
			$Query = qq!SHOW TABLE STATUS LIKE $Table!;
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__); 
	undef %Var;
	$x = 0;
	if ($Global{DB_Server} eq "MS_SQL") {
				while (@Row=$sth->fetchrow_array){
						$Var{$x++} = join " ", @Row;
				}
	}
	else{
				if (@Row = $sth->fetchrow_array){
						for (my $i = 0; $i < $sth->{NUM_OF_FIELDS}; $i++) {
							$Var{$sth->{NAME}->[$i]} = $Row[$i];
						}
				}
	}

	$sth->finish;
	return %Var;
}
#==========================================================
sub DB_STATUS {
my ($Query, $sth, $Var, $Value, %Var);

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT table_name FROM information_schema.tables!;
	}
	else{
			$Query = qq!SHOW STATUS!;
	}
	
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__); 
	undef %Var;
	while (($Var, $Value) = $sth->fetchrow_array) {
				$Var{$Var} = $Value;
    }
	$sth->finish;
	return %Var;
}
#==========================================================
sub DB_Show_Tables{
my ($Query, $sth, @DB_Tables, @Row);

	#@Servers = ("MySQL", "MS_SQL");
	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT table_name FROM information_schema.tables!;
	}
	else{
			$Query = qq!SHOW TABLES!;
	}

	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @DB_Tables;
	while (@Row=$sth->fetchrow_array){
			push (@DB_Tables, $Row[0]);
	}
	$sth->finish;
	return @DB_Tables;
}
#==========================================================
sub DB_Drop_Table{
my ($Table) = shift;
my ($Query);

	$Query = qq!DROP TABLE $Table!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Optimize_Table{
my ($Table) = @_;
my ($Query);

	$Query = qq!OPTIMIZE TABLE $Table!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Empty_Table{
my ($Table) = @_;
my ($Query);

	$Query = qq!DELETE FROM $Table!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Drop_Col{
my ($Table, $Column) = @_;
my ($Query);

	$Query = qq!ALTER TABLE $Table DROP $Column!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Rename_Table{
my ($Old_Name, $New_Name) = @_;
my ($Query);

	$Query = qq!ALTER TABLE $Old_Name RENAME AS $New_Name!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Delete_Entry{
my ($Table, $Entry_Modifier) = @_;
my ($Query);
	
	if ($Global{DB_Server} eq "MS_SQL") {
			$Query =  qq!DELETE TOP 1 FROM $Table WHERE $Entry_Modifier!;
	}
	else{
			$Query =  qq!DELETE FROM $Table WHERE $Entry_Modifier LIMIT 1!;
	}
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Update_Entry{
my ($Table, $Entry_Modifier, @Fields) = @_;
my ($Query, $sth, $New_Entry);

	$New_Entry = join (",", @Fields); #each filed must be 'Field=Value'
	$Query =  qq!UPDATE $Table SET $New_Entry WHERE $Entry_Modifier!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DB_Entry_Count{
my ($Table) = @_;
my ($Query, $sth, $Rows);

	$Query =  qq!SELECT COUNT(*) FROM $Table!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Rows = $sth->fetchrow();
	$sth->finish;
	return $Rows;
}
#==========================================================
#==========================================================
sub DB_Error_Msg{
my ($Title, $Msg, $Level) = @_;
my ($Out);

$Out=<<HTML;
<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=windows-1252">
<TITLE>Mewsoft - www.mewsoft.com</TITLE>
<STYLE >
<!--
 A:hover {color: #ff3300 ;} 
-->
</STYLE>

<STYLE TYPE="text/css">
<!--
.lwr  a:link    { color: white; }
.lwr  a:visited { color: white; }
.lwr  a:active  { color: #ff3300; }
.lwr  a:hover   { color: red; background-color : yellow;}
.lwr  a{ text-decoration: none }

.lbr  a:link    { color: blue; }
.lbr  a:visited { color: blue; }
.lbr  a:active  { color: #ff3300; }
.lbr  a:hover   { color: red; background-color : #FFFF00;}
.lbr  a{ text-decoration: none }
-->
</STYLE>
</head>
<body bgcolor="#FFFFFF" >
<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p>
<div class="lbr" align="center"><center>
<table border="0" width="405" bgcolor="#005329" >
  <tr>
    <td width="100%" align="center" height="19"><b><font color="#ffff00" face="times new roman, arial">
	$Title
	</font></b>
    </td>
  </tr>
  <tr>
    <td width="400">
      <div align="center">
      <table border="0" width="400" cellspacing="0" cellpadding="0" bgcolor="#e1e1c4">
        <tr><td valign="middle" align="center" bgcolor="#FFFFD9">
          <div align="center">
            <table width="100%" border="0" cellpadding="3">
	              <tr><td width="100%" align="LEFT">$Msg</td></tr>
            </table>
          </div>
          </td>
        </tr>
        <tr>
          <td valign="middle" align="center" bgcolor="#ffffd9">
		  <form>
                <p align="center">
				<input type=button value="--OK--" onClick="history.go(-$Level)">
  		  </form>
          </td>
        </tr>
      </table>
      </div>
    </td>
  </tr>
</table>
</center>
</div>
</body>
</html>
HTML
	return $Out;
}
#==========================================================
sub DB_Exit{
my ($Query, $Title, $Level) = @_;
my ($Out, $Message);
	
	my ($package, $file, $line) = caller;

	if ($Title eq "") {$Title="SQL Error";}
	if ($Level !~ /^\d+$/) {$Level=1;}
	if (!$Query) {
			$Query = "";
	}
	else{
			$Query="<b>Query</b>: <br>$Query.<br>";
	}
	$Message="SQL Error: $DBI::errstr<br>$Query<br>Package: $package, File: $file, Line: $line<br>";
	$Out=&DB_Error_Msg($Title, $Message, $Level);
	print "Content-type: text/html\n\n";
	print "$Out";
	&DB_Disconnect();
	exit (0);
}
#==========================================================
1;
