=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub AdvancedSearch{
my ($Template, $Temp);

	$Plugins{Bar_Action} = $Language{bar_advanced_search};

	$Template = &TranslateFile($Global{AdvancedSearchTemplate});
	#------------------------------------------------------
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Post{Forum}/g;
	$Template =~ s/<!--Topic-->/$Post{Topic}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;
	#------------------------------------------------------
	$Temp = &ForumsTreeMenuList(0, 1);
	$Template =~ s/<!--ForumsList-->/$Temp/g;

	&Display($Template, 1);
}
#==========================================================
sub ForumSmartSearch {
my (@Forum, @Forums, $Forums, $Cash, @Topics, $Out);

	&Check_Previous_User_Login;

	$Param{Terms} ||= "";
	$Param{Authors} ||= "";
	$Param{AuthorsFilter} ||= "";

	$Param{Terms} =~ s/^\s+//;
	$Param{Terms} =~ s/\s+$//;

	$Param{Authors} =~ s/^\s+//;
	$Param{Authors} =~ s/\s+$//;
	$Param{Authors} =~ s/\,+/ /g;
	$Param{Authors} =~ s/\s+/\, /g; # formated: user1, user2, etc
	
	$Param{AuthorsFilter} =~ s/^\s+//;
	$Param{AuthorsFilter} =~ s/\s+$//;
	#------------------------------------------------------
	# search options
	$Param{Dir} ||= 0;
	$Param{Sort} ||= "Updated";
	$Param{Mode} ||= 0; # display mode, 1=topics, 0=posts
	$Param{PageSize} ||= $Global{Topics_Per_Page};	
	$Param{Period} ||= 0; # Search previous days
	$Param{TitlesOnly} ||= 0; # search title only
	$Param{Partial} ||= $Global{Posts_Return_Size}; # Return first characters of messages
	if ($Param{Sorted} ==1) {$Param{Dir} = !$Param{Dir};	}
	#------------------------------------------------------
	$Plugins{Menu_Bar} = "";
	if (!$Param{Terms} && !$Param{Authors}) {
			&AdvancedSearch;
			return;
	}
	#------------------------------------------------------
	# prepare the forums and categories selected for search
	$Param{Forums} ||= "";
	@Forum = split (/\|\|/, $Param{Forums});
	$Param{Forum} = $Forum[0];

	foreach $Forum (@Forum) {
			if (!$Forum) {next;} # skip the all forums option
			push @Forums, $Forum;
	}
	$Forums = join (",", @Forums);
	#------------------------------------------------------
	# search title only flag
	if ($Param{TitlesOnly}) {$SearchMsg = 0;}	 else {$SearchMsg = 1;}
	#------------------------------------------------------
	# search the posts, result returned in the post format
	undef @Posts;
	if ($Param{Terms}) { # Keyword search
			# search the forums for the required keywords
			# ($Cash, @Topics) = &Search_Forums ($Terms, $Forums, $Categories, $SearchMsg, $Period, $Authors, $Mode, $SortBy, $SortDir, $SaveCash)
			($Cash, @Topics) = &Search_Forums($Param{Terms}, $Forums, $SearchMsg, $Param{Period}, $Param{AuthorsFilter}, $Param{Mode}, $Param{Sort}, $Param{Dir}, 1);
			$Plugins{Bar_Action} = $Language{bar_search_results};
			$Plugins{Bar_Action} =~ s/<!--Terms-->/$Param{Terms}/;
	}
	elsif ($Param{Authors}) { # Search for Authors
			# search the forums for posts by the selected authors only
			# ($Authors, $Forums, $Categories, $Period, $Mode, $SortBy, $SortDir, $SaveCash)
			($Cash, @Topics) = &Search_Forums_Authors($Param{Authors}, $Forums, $Param{Period}, $Param{Mode}, $Param{Sort}, $Param{Dir}, 1);

			$Plugins{Bar_Action} = $Language{bar_authors_search_results};
			$Plugins{Bar_Action} =~ s/<!--Authors-->/$Param{Authors}/;
	}
	else{&AdvancedSearch; return;}
	$Param{Cash} = $Cash;
	#------------------------------------------------------
	$Plugins{ResultsFound} = $Language{topics_results_found};
	#------------------------------------------------------
	# parse the search results for display
	# ($Action, $Template, $Form1, $Form2, $Mode, $PostLink, @Topics)
	$Out = &ParseForumTopicsList("action=ForumCash&Cash=$Cash", "ForumCash",
													&TranslateFile($Global{ForumSearchTopicsTemplate}),
													$Global{ForumTopicsListSearchForm},
													$Global{ForumTopicsListSearchForm1},
													1,
													$Param{User_ID},
													0,
													@Topics
												);
	#------------------------------------------------------
	# print the page
	&Display($Out, 1);
}
#==========================================================
sub DisplayLast{

	&Check_Previous_User_Login;

	$Param{Terms} = '*';
	$Param{Period} = &ForumPeriods_Time($Param{Period});
	#------------------------------------------------------
	# search options
	$Param{Dir} = 0;
	$Param{Sort} = "Updated";
	$Param{Mode} = 1; # display mode, 1=topics, 0=posts
	$Param{PageSize} = $Global{Topics_Per_Page};	
	$Param{Period} ||= 0; # Search previous days
	$Param{TitlesOnly} ||= 0; # search title only
	$Param{Partial} = $Global{Posts_Return_Size}; # Return first characters of messages
	if ($Param{Sorted} ==1) {$Param{Dir} = !$Param{Dir};	}
	#------------------------------------------------------
	&ForumSmartSearch;
}
#==========================================================
1;