=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub SmileysManager {
my ($Message) = @_;
my($Help);

	$Help = &Help_Link("SmileysManager");
	&Print_Page(&SmileysManagerForm($Message), "Standard Smileys Manager", $Help);
}
#==========================================================
sub SmileysManagerForm {
my ($Message) = @_;
my ($Out, $SmileysLang, $Query, $sth, %Smileys, $TotalCount);
my ($ID, @Smileys);
	
	$Param{SmileysLang} ||= $Global{Language};
	$SmileysLang = $dbh->quote($Global{SmileysLang});
	#------------------------------------------------------
	#$Query = qq!SELECT ID FROM Forum_Smileys WHERE  Lang=$SmileysLang ORDER BY Category ASC, Code ASC, File ASC!;
	$Query = qq!SELECT ID FROM Forum_Smileys ORDER BY Category ASC!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Smileys;
	$TotalCount = 0;
	while (($ID) = $sth->fetchrow_array){
		push @Smileys, $ID;
		$TotalCount++;
	}
	$sth->finish;
	#------------------------------------------------------
	$Param{Page} += 0;
	$Param{Page} ||= 1;

	$Param{Size} += 0;
	$Param{Size} ||= $Global{AdminSmileysPageSize};
	$Param{Size} ||= 50;

	use Pagination;
	my $paginate = Mewsoft::Pagination->new(
												entries_per_page    => $Param{Size},
												total_entries       => $TotalCount, 
												current_page        => $Param{Page},
												pages_per_set       => 1000,
												mode => 'fixed', #modes are 'slide', 'fixed', default is 'slide'
											);

	$Param{Page} = $paginate->current_page;
	$LastPage = $paginate->last_page;
	$NextPage = $paginate->next_page;
	$PrevPage = $paginate->previous_page;
	$Start = $paginate->first;
	$End = $paginate->last;
	$CurrentPage = $Param{Page};
	#------------------------------------------------------
	#------------------------------------------------------
	$NextPage = qq!&nbsp;<a href="$ScriptURL?action=SmileysManager&Page=$NextPage&size=$Param{Size}&SmileysLang=$Global{SmileysLang}">[Next&gt;&gt;]</a>!;
	$PrevPage = qq!<a href="$ScriptURL?action=SmileysManager&Page=$PrevPage&size=$Param{Size}&SmileysLang=$Global{SmileysLang}">[&lt;&lt;Prev]</a>&nbsp;!;
	#------------------------------------------------------
	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$NextPage = "Last";
	}
	if ($CurrentPage == 1) {
			$PrevPage = "First";
	}
	#------------------------------------------------------
	$Pages = ""; 
	# Print the page numbers of the current set
	foreach $Page (@{$paginate->pages_in_set()}) {
			if ($Page == $CurrentPage) {
					$Pages .= "[$Page]";
			}
			else{
					$Pages .= qq!<a href="$ScriptURL?action=SmileysManager&Page=$Page&size=$Param{Size}&SmileysLang=$Global{SmileysLang}">$Page</a>!;
			}
			if ($Page != $LastPage) {$Pages .= " ";}
	}
	#------------------------------------------------------
	#------------------------------------------------------
	$Output = "";
	$Smileys = "";
	
	for $Counter ($Start-1..$End-1){
				$Count = $Counter + 1;
				$Smiley = $Smileys[$Counter];
				if (!$Smiley) {last;}
				%Smiley = &GetSmiley($Smiley);
				$Code = $Smiley{Code};
				$File = $Smiley{File};
				$Meaning = $Smiley{Meaning};
				$Category = $Smiley{Category};
				$Language = $Smiley{Lang};
				
				$NoImage = "";
				if (!-e "$Global{HTML_Dir}/smileys/$File") {
						$NoImage = qq!<font color="red">NO Image</font>!;
				}
$Smileys .=<<Row;
  <tr>
    <td class="TableCell">$Count</td>
    <td class="TableCell" align="center"><input type="text" name="Code_$Smiley" value="$Code"></td>
    <td  class="TableCell" align="center"><input type="text" name="File_$Smiley" value="$File"></td>
    <td class="TableCell" align="center"><input type="text" name="Meaning_$Smiley" value="$Meaning"></td>
    <td class="TableCell" align="center"><input type="text" name="Category_$Smiley" value="$Category"></td>
    <td class="TableCell" align="center"><input type="checkbox" name="Del_$Smiley" style="border: 0;" value="1"></td>
    <td class="TableCell"><img src="$Global{HTML_URL}/smileys/$File" border="0" alt="$Code ($File)">$NoImage</td>
  </tr>
Row
	}
	#------------------------------------------------------
	# Add new smileys form
	#------------------------------------------------------
	$NewSmileys = "";
	for $Counter (1..3) {
$NewSmileys.=<<NewSmileys;
<tr>
<td class="TableCell" align="center"><input type="text" name="NewCode$Counter" value=""></td>
<td  class="TableCell" align="center"><input type="text" name="NewFile$Counter" value=""></td>
<td class="TableCell" align="center"><input type="text" name="NewMeaning$Counter" value=""></td>
<td class="TableCell" align="center"><input type="text" name="NewCategory$Counter" value=""></td>
</tr>
NewSmileys
	}
	#------------------------------------------------------
$Out=<<HTML;
<div align="center" style="padding: 5px;"><font color="red" size="3"><b>$Message</b></font></div>

<div align="left">
<form method="post" action="$ScriptURL">
<input type="hidden" name="action" value="SaveSmileysChanges">
<table cellpadding="2" cellspacing="0" class="TableAttr">
  <tr>
    <td class="TableHeader" align="center" width="50" nowrap><b>#</b></td>
    <td class="TableHeader" align="center"><b>Code</b></td>
    <td class="TableHeader" align="center"><b>File</b></td>
    <td class="TableHeader" align="center"><b>Meaning</b></td>
    <td class="TableHeader" align="center"><b>Category</b></td>
    <td class="TableHeader" align="center"><b>Delete</b></td>
    <td class="TableHeader" align="center"><b>Image</b></td>
  </tr>
$Smileys

	<tr>
		<td class="TableCell" colspan="5" align="left" height="30"><b>$PrevPage &nbsp; $Pages &nbsp; $NextPage</b></td>
		<td class="TableCell" colspan="2" align="left" height="30"><b>Showing $Start-$End of $TotalCount</b></td>
	</tr>

  <tr><td width="100%" colspan="7" align="center" height="30" class="TableCell">
		<input type="submit" value="Save Changes" style="color: #000080; border-style: ridge">
		<input type="reset" value="Reset" style="color: #000080; border-style: ridge">
		</td>
  </tr>
</table>
</form>
<br>

<form method="post" action="$ScriptURL">
<input type="hidden" name="action" value="AddNewSmileys">

<table cellspacing="0" width="100%" cellpadding="2" class="TableAttr">
  <tr><td colspan="4" class="TableHeader" align="center">Add New Smileys</td></tr>

  <tr>
    <td class="TableSubHeader" align="center"><b>Code</b></td>
    <td class="TableSubHeader" align="center"><b>File</b></td>
    <td class="TableSubHeader" align="center"><b>Meaning</b></td>
    <td class="TableSubHeader" align="center"><b>Category</b></td>
  </tr>

	$NewSmileys

  <tr><td class="TableCell" width="100%" colspan="4" align="center" height="30">
		<input type="submit" value="Add Smileys" style="color: #000080; border-style: ridge">
		<input type="reset" value="Reset" style="color: #000080; border-style: ridge">
		</td>
  </tr>
</table>
</form>

</div>
HTML

return $Out;

}
#==========================================================
sub AddNewSmileys {
my ($Counter, $Code, $File, $Meaning, $Category, $Added, $Msg);
	
	$Added = 0;
	for $Counter (1..100) {
			$Code = $Param{"NewCode$Counter"};
			$Code =~ s/^\s+|\s+$//;

			$File = $Param{"NewFile$Counter"};
			$File =~ s/^\s+|\s+$//;

			$Meaning = $Param{"NewMeaning$Counter"};
			$Meaning =~ s/^\s+|\s+$//;

			$Category = $Param{"NewCategory$Counter"};
			$Category =~ s/^\s+|\s+$//;

			if ($Code && $File) {
					&AddNewSmiley($Code, $File, $Meaning, $Category, $Global{Language});
					$Added++;
			}
	}
	
	$Msg = "";
	if ($Added > 0) {
			$Msg = qq!<p align="center"><font size="3" color="red"><b>$Added Smilers Added</b></font></p>!;
	}

	&SmileysManager($Msg);
}
#==========================================================
sub AddNewSmiley {
my ($Code, $File, $Meaning, $Category, $Language) = @_;
my ($Query, $sth);
	
	$Code = $dbh->quote($Code);
	$File = $dbh->quote($File);
	$Meaning = $dbh->quote($Meaning);
	$Category = $dbh->quote($Category);
	$Lang = $dbh->quote($Language);
    $Query = qq!INSERT INTO Forum_Smileys VALUES(NULL, $Code, $File, $Meaning, $Category, $Lang)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub SaveSmileysChanges {
my ($Deleted, $K, $V, @Del, $Msg);
	
	$Deleted = 0; undef @Del;
	while (($K, $V) = each %Param) {
			if ($K =~ /^Del\_(\d+)$/ && $V) {
				push @Del, $1;
				$Deleted++;
			}
	}

	foreach $K (@Del) {
			delete $Param{$K};
	}
	
	if (@Del) {
		&DeleteSmileys(@Del);
	}

	$Updated = 0; undef @Update;
	while (($K, $V) = each %Param) {
			if ($K =~ /^Code\_(\d+)$/) {
				$ID = $1;
				$Code = $Param{"Code_$ID"};
				$File = $Param{"File_$ID"};
				$Meaning = $Param{"Meaning_$ID"};
				$Category = $Param{"Category_$ID"};
				$Code =~ s/^\s+|\s+$//;
				$File =~ s/^\s+|\s+$//;
				$Meaning =~ s/^\s+|\s+$//;
				$Category =~ s/^\s+|\s+$//;
				push @Update, $ID;
				#%Smiley = &GetSmiley($ID);
				&UpdateSmiley($ID, $Code, $File, $Meaning, $Category, $Global{Language});
			}
	}

	$Msg = "";
	if ($Deleted > 0) {
			$Msg = qq!<p align="center"><font size="3" color="red"><b>$Deleted Smilers Deleted</b></font></p>!;
	}

	&SmileysManager($Msg);
}
#==========================================================
sub UpdateSmiley {
my ($ID, $Code, $File, $Meaning, $Category, $Language) = @_;

	$Code = $dbh->quote($Code);
	$File = $dbh->quote($File);
	$Meaning = $dbh->quote($Meaning);
	$Category = $dbh->quote($Category);
	$Lang = $dbh->quote($Language);
    $Query = qq!UPDATE Forum_Smileys SET Code=$Code, File=$File, Meaning=$Meaning, Category=$Category, Lang=$Lang WHERE ID=$ID!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
sub DeleteSmileys {
my (@ID) = @_;
my ($Query, $IDs);

	$IDs = join (",", @ID);
	$Query = qq!DELETE FROM Forum_Smileys WHERE ID IN($IDs)!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
}
#==========================================================
#Generic Smilies
#Assortment
#Requests
#Animals
#Fantasy
#Cartoons
#Military
#Symbolic
#Romance
#Requests
#Specials
#Dancing Circles
#Dancing Squares
#Devil Smilies
#Stone
#Eusa
#Gearheads
#Pirates
#Smilies with Text
#Bananas
#Speech Emots
#Crazy Green
#Welcomes
#Spiders
#Wacky emotions
#Toadstool Emoticons v2
#Monkey Emoticons
#Chores &amp; Work
#Aliens
#Talk
#Bears
#Eggheads
#Bowlerhats
#Clowns
#Red Noses
#Blushes
#Christmas 06
#Christmas
#Flags
#==========================================================


1;