=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ThemeManager {
my ($Message) = @_;
my ($Help);

	$Help = &Help_Link("Theme Manager");
	&Print_Page(&ThemeAdminForm($Message), "Theme Manager", $Help);		
}
#==========================================================
sub ThemeAdminForm {
my ($Message) = @_;
my ($Themes, @Themes, @Languages, @Defaults, %Default);
my ($Line, $Lang, $Theme, $Config, $Selected, $Out);

	$Themes = &ThemesMenuList;
	@Themes = &ThemesList;
	@Languages = &LanguagesList;

	@Defaults = split (/\|/, $Global{Themes});
	undef %Default;
	foreach $Line (@Defaults) {
			($Lang, $Theme) = split(/\:/, $Line);
			$Default{$Lang} = $Theme;
	}

	$Config = "";
	foreach $Language (@Languages) {
			$Config .= qq!<tr><td nowrap class="TableCell">$Language</td>!;
			$Config .= qq!<td class="TableCell" width="100%"><select name="ConfigTheme\:$Language" size="1">!;
			foreach $Theme (@Themes) {
					$Selected = "";
					if ($Default{$Language} eq $Theme) {$Selected = "selected";}
					$Config .= qq!<option value="$Theme" $Selected>$Theme</option>!;
			}
			$Config .= qq!</select></td></tr>!;
	}

$Out=<<HTML;
<div align="center" style="padding: 5px;"><font color="red" size="3"><b>$Message</b></font></div>

<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('CreateTheme');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Create New Theme</a>
</div>
<div name="CreateTheme" id="CreateTheme" style="display: none;">

<form method="post" action="$Global{AdminURL}">
<input type="hidden" name="action" value="CreateTheme">

<table width="100%"  cellspacing="0" cellpadding="3" class="TableAttr">
<tr><td colspan="2" class="TableHeader" align="center">Create New Theme</td></tr>
    <tr><td class="TableCell" nowrap>Copy from theme: </td><td class="TableCell" width="100%"><select size="1" name="CopyFromTheme">$Themes</select></td></tr>
    <tr><td class="TableCell" nowrap>New Theme Name:</td><td class="TableCell"><input type="text" name="NewThemeName" size="40"> No spaces or strange letters</td></tr>
     <tr><td class="TableCell" width="100%" colspan="2">
			<input type="submit" value="Create Theme" name="Submit" style="width: 100px;">&nbsp;
			<input type="reset" value="Reset" name="Reset" style="width: 100px;">
	</td>
    </tr>
</table>
</form>
<br>
</div>

<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('DeleteTheme');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Delete Themes</a>
</div>
<div name="DeleteTheme" id="DeleteTheme" style="display: none;">

<form method="post" name="Delete_Theme" action="$Global{AdminURL}">
<input type="hidden" name="action" value="DeleteTheme">

<table width="100%"  cellspacing="0" cellpadding="3" class="TableAttr">
<tr><td colspan="2" class="TableHeader" align="center">Delete Themes</td></tr>
    <tr><td class="TableCell" nowrap>Select Theme:</td><td class="TableCell" width="100%"><select size="1" name="Theme">$Themes</select></td></tr>
	<tr><td class="TableCell" colspan="2">
			<input type="submit" value="Delete Theme" name="Submit" onClick="DeleteThemeConfirm(document.Delete_Theme.Theme[document.Delete_Theme.Theme.selectedIndex].value); return false;" >&nbsp;
			<input type="reset" value="Reset" name="Reset">
	</td>
    </tr>
  </table>
</form>
<br>
</div>

<div style="padding-bottom: 5px;width:100%;">
	<a href="Javascript: Toggle('ConfigureThemes');"><img src="$Global{Skin}/show.gif" border="0" align="absmiddle">Configure Themes</a>
</div>
<div name="ConfigureThemes" id="ConfigureThemes" style="display: none;">

<form method="post" name="Configure_Themes" action="$Global{AdminURL}" >
<input type="hidden" name="action" value="ConfigureThemes">

<table width="100%"  cellspacing="0" cellpadding="3" class="TableAttr">
<tr><td colspan="2" class="TableHeader" align="center">Configure Themes</td></tr>
    <tr><td class="TableCell" nowrap colspan="2">Assign themes to languages</td></tr>
      <td class="TableCell" colspan="2">
			<table width="100%"  cellspacing="0" cellpadding="3" class="TableAttr">
					$Config
			</table>
			<br>
		</td></tr>
		<td class="TableCell" colspan="2">
			<input type="submit" value="Save Changes" name="Submit">&nbsp;
			<input type="reset" value="Reset" name="Reset">
	</td>
    </tr>
  </table>
</form>
<br>
</div>

<script language="javascript">
<!--
function DeleteThemeConfirm(Theme) {
	var agree=confirm("Are you sure you want to delete this Theme?\\nTheme: "+Theme+"\\n");
	if (agree){
			var agree=confirm("Please note once the Theme deleted, you will not be able to recover it again\\nAre you sure you still want to delete this Theme?\\n                   Theme: "+Theme+"\\n");
			if (agree){
					window.location = "$Global{AdminURL}action=DeleteTheme&Theme=" +Theme;
			}
	}
	//document.Delete_Theme.submit();
}

/* Cross browser related methods */
function GetElementById(id) {
	if (document.all) {
		return document.all(id);
	} else
		if (document.getElementById) {
			return document.getElementById(id);
		}
}

function Toggle(id) {  
	//HideOthers(id);
	var ctrlID = '';
	if (document.all) {ctrlID = document.all(id);}
	else	if (document.getElementById) {ctrlID = document.getElementById(id);}

	if (ctrlID.style.display == 'none'){ctrlID.style.display = 'block';	}
	else	{ctrlID.style.display = 'none';}
}

function HideAll(){
	var tags = document.getElementsByTagName("div")
	for(i=0;i<tags.length;i++){
		tags[i].style.display = 'none'
	}
}

function HideOthers(divID){
	var tags = document.getElementsByTagName("div")
	for(i=0;i<tags.length;i++){
		if (tags[i].getAttribute('id') != divID){
			tags[i].style.display = 'none'
		}
	}
}

// -->
</script>

HTML
	return $Out;
}
#==========================================================
sub ConfigureThemes{
my (%Themes, %Config, $Key, $Themes, $Language, $Theme);

	undef %Themes;
	foreach $Key (keys %Param) {
			if ($Key =~ /^ConfigTheme\:(.*)/ ) {
					$Themes{$1} = $Param{$Key};
			}
	}

	$Themes = "";
	while (($Language, $Theme) = each %Themes) {
			$Themes .= "$Language\:$Theme|";
	}
	$Themes =~ s/\|$//;

	undef %Config;
	$Config{Themes} = $Themes;
	&UpdateConfiguration(%Config);
	#------------------------------------------------------
	&ThemeManager(qq!<p align="center"><font size="3" color="red"><b>Theme configuration successfully saved</b></p>!);
}
#==========================================================
sub ThemesMenuList {
my ($Default) = @_;
my ($Out, @Files, $File, $Selected);

	undef @Files;
	opendir(Dir, $Global{Templates_Dir});
	foreach $File (readdir(Dir)) {
			push @Files, $File;
    }
	closedir(Dir);

	foreach $File (@Files) {
			if (-d "$Global{Templates_Dir}/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
				$Selected = "";
				if (lc($File) eq lc($Default)) {$Selected="SELECTED";}
				$Out .= qq!<OPTION value="$File" $Selected>$File</OPTION>!;
			}
	}

	return $Out;
 }
#==========================================================
sub ThemesList {
my (@Files, $File);

	undef @Files;
	opendir(Dir, $Global{Templates_Dir});
	foreach $File (readdir(Dir)) {
			if (-d "$Global{Templates_Dir}/$File" && $File ne "." && $File ne ".." && $File !~ m/^\_/) { 
					push @Files, $File;
			}
    }
	closedir(Dir);
	return @Files;
 }
#==========================================================
sub DeleteTheme {
my ($Dir, $Directory, @Files, @Directories);

	#------------------------------------------------------
	# delete the theme templates directory and all its contents
	$Dir = "$Global{Templates_Dir}/$Param{Theme}";
	undef @Files;

	@Directories = &Scan_Directory_Tree($Dir);
	@Directories  = sort @Directories;
	
	foreach $Directory (@Directories) {
			@Files = &Scan_Directory($Directory);
			if (@Files) {
				unlink (@Files) or &Exit("Can't remove theme files @Files: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
			rmdir ("$Directory") or &Exit( "Can't remove theme directory $Directory: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	@Files = &Scan_Directory($Dir);
	if (@Files) {
		unlink (@Files) or &Exit("Can't remove theme files @Files: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	rmdir ("$Dir") or &Exit( "Can't remove theme directory $Dir: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# delete the theme images directory and all its contents
	$Dir = "$Global{HTML_Dir}/theme/$Param{Theme}";
	undef @Files;

	@Directories = &Scan_Directory_Tree($Dir);
	@Directories  = sort @Directories;
	
	foreach $Directory (@Directories) {
			@Files = &Scan_Directory($Directory);
			if (@Files) {
				unlink (@Files) or &Exit("Can't remove theme files @Files: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
			}
			rmdir ("$Directory") or &Exit( "Can't remove theme directory $Directory: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}

	@Files = &Scan_Directory($Dir);
	if (@Files) {
		unlink (@Files) or &Exit("Can't remove theme files @Files: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	}
	rmdir ("$Dir") or &Exit( "Can't remove theme directory $Dir: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	&ThemeManager(qq!<p align="center"><font size="3" color="red"><b>Theme successfully deleted</b></p>!);
}
#==========================================================
sub CreateTheme {
my ($TargetDir, $SourceDir, $File);
	
	$Param{NewThemeName} =~ s/^\s+//;
	$Param{NewThemeName} =~ s/\s+$//;
	$Param{NewThemeName} =~ s/\s+/ /g;
	
	if (!$Param{NewThemeName}) {
			&ThemeManager;
			return;
	}

	#------------------------------------------------------
	# copy the templates directory
	$TargetDir = "$Global{Templates_Dir}/$Param{NewThemeName}";
	$SourceDir ="$Global{Templates_Dir}/$Param{CopyFromTheme}";

	mkdir ($TargetDir, 0777) or &Exit("Can't creat theme directory $TargetDir: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	opendir(Dir, $SourceDir);
	foreach $File (readdir(Dir)) {
			copy("$SourceDir/$File",	"$TargetDir/$File");
			chmod (0755, "$TargetDir/$File");
    }

	closedir(Dir);
	chmod (0755, $TargetDir);
	#------------------------------------------------------
	# copy the theme images directory
	$Global{ThemeImages} = "$Global{HTML_URL}/theme/$Global{Theme}";

	$TargetDir = "$Global{HTML_Dir}/theme/$Param{NewThemeName}";
	$SourceDir ="$Global{HTML_Dir}/theme/$Param{CopyFromTheme}";

	mkdir ($TargetDir, 0777) or &Exit("Can't creat theme directory $TargetDir: $!"."<BR>Line ". __LINE__ . ", File ". __FILE__);

	opendir(Dir, $SourceDir);
	foreach $File (readdir(Dir)) {
			copy("$SourceDir/$File",	"$TargetDir/$File");
			chmod (0755, "$TargetDir/$File");
    }

	closedir(Dir);
	chmod (0755, $TargetDir);
	#------------------------------------------------------
	&ThemeManager(qq!<p align="center"><font size="3" color="red"><b>New theme successfully created</b></p>!);
}
#==========================================================
sub Scan_Directory_Tree {
my ($Directory) = @_;
my (@Directories, %Found);

	%Found = &Scan_Dir($Directory);
	undef @Directories;
	while (($Key, $Value)= each %Found) {
			if ($Value) {
				push @Directories, $Key;
			}
	}
	return @Directories;
}
#==========================================================
sub Scan_Directory {
my ($Directory)=@_;
my (@Files, %Found);

	%Found = ();
	@Files = ();
	my $CRLF = "\015\012"; # how lines should be terminated; "\r\n" is not correct on all systems, for instance MacPerl defines it to "\012\015"
	%Found = &Scan_Dir($Directory);
	while (($Key, $Value)= each %Found) {
			if (!$Value) {
				push @Files, $Key;
			}
	}
	return @Files;
}
#==========================================================
sub Scan_Dir {
my ($Directory)=@_;
my (@Directories, @Files, %Found);
my ($Current_Directory);

	undef @Directories;
	undef %Found;
	undef @Files;
	if (!$Directory) {$Directory = '.';}
	push @Directories, $Directory;
	while (@Directories) {
		   $Current_Directory = shift (@Directories);
		   opendir (DIR, "$Current_Directory") 
					or &Exit( "Cannot open directory $Current_Directory: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
		   @Files = readdir (DIR);
		   closedir (DIR);
		   foreach $File (@Files) {
					$Temp = "$Current_Directory/$File";
					  if (-d $Temp && $File ne "." && $File ne "..") {
								push @Directories, $Temp;
								$Found{$Temp} = 1;
								next;
					  }
					  else{
								if ($File ne "." && $File ne "..") {
										$Found{$Temp} = 0;
								}
					  }
			}
	}
	return %Found;
}
#==========================================================

1;