=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub DeleteTopic{
my (%Forum, %Topic, @Posts, $Posts, %Message, $Template);
my ($Temp, $TimeClass, $TimeFormat);

	$Plugins{Bar_Action} = $Language{bar_delete_topic};
	
	$Param{Topic} += 0;
	#------------------------------------------------------
	%Topic = &GetForumTopic($Param{Topic});
	if (!%Topic) {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	$Param{Forum} = $Topic{Forum};
	%Forum = &GetForum($Topic{Forum});
	if (!%Forum) {
		$Plugins{Body} = $Language{error_invalid_forum_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	@Posts = &GetForumTopicPosts($Param{Topic});
	$Posts = @Posts;
	if ($Posts) {
			%Message = &GetForumMessage($Posts[0]);
	}
	#------------------------------------------------------
	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Template = &TranslateFile($Global{ForumDeleteTopicTemplate});
	$Template =~ s/<!--Action-->/$ScriptURL/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Topic{Forum}/g;
	$Template =~ s/<!--Topic-->/$Topic{Topic}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;
	$Template =~ s/<!--Author-->/$Topic{Author}/g;
	$Template =~ s/<!--Posts-->/$Posts/g;
	
	$Temp = qq!$ScriptURL?action=ViewProfile&Author=$Topic{Author}&Lang=$Global{Language}!;
	$Template =~ s/<!--AuthorLink-->/$Temp/g;
	#------------------------------------------------------
	$Temp = qq!$ScriptURL?action=TopicReview&Topic=$Param{Topic}&Page=1&Lang=$Global{Language}!;
	$Template =~ s/<!--TopicReviewLink-->/$Temp/g;
	#------------------------------------------------------
	$TimeClass = ""; $TimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Template =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$TimeClass = $1 . $2 . $3. $4. $5;
				$TimeFormat =  $4;
	}
	$TimeClass =~ s/\(/\\\(/g;
	$TimeClass =~ s/\)/\\\)/g;

	if ($Topic{Time} > 0) {
			$Temp = &ParseDate($TimeFormat, $Topic{Time});
	}
	else{	
			$Temp = "";
	}
	$Template =~ s/$TimeClass/$Temp/g;
	#------------------------------------------------------
	$Template =~ s/<!--Subject-->/$Message{Subject}/g;
	
	$Temp = $Message{Message};
	#$Temp =~ s/\\\n/\n/g;
	#$Temp =~ s/[\>]\s*\n/\> /g;
	#$Temp =~ s/\n/\<br\>/g;
	$Template =~ s/<!--Message-->/$Temp/g;

	&Display($Template, 1);
}
#==========================================================
sub ProcessDeleteTopic{
my (%Topic, $Posts, $Topics, $Query, $Post);

	$Param{Topic} += 0;
	%Topic = &GetForumTopic($Param{Topic});
	$Param{Topic} = $Topic{Topic};
	$Param{Forum} = $Topic{Forum};

	if ($Param{Cancel}) {
			&ViewTopic;
			return;
	}

	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Topic{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}

	&DeleteForumTopic($Topic{Topic});
	#------------------------------------------------------
	$Post = &GetForumLastPost($Topic{Forum});
	#------------------------------------------------------
	if ($Post) {
		$Query = qq!UPDATE Forum_Forums SET LastPost=$Post WHERE Forum=$Topic{Forum}!;
		$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	&Forums;
}
#==========================================================
sub StatusTopic{
my (%Topic, $Query, $sth, $Status, $Temp);

	%Topic = &GetForumTopic($Param{Topic});
	#%Forum = &GetForum($Topic{Forum});
	#------------------------------------------------------
	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Query = qq!SELECT Status FROM Forum_Topics WHERE Topic=$Param{Topic}!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Status = 0;
	while(($Temp) = $sth->fetchrow_array) {$Status = $Temp; last;}
	$sth->finish;
	$Status = !$Status;

	$Status ||= 0;
	$Query = qq!UPDATE  Forum_Topics SET Status=$Status WHERE Topic=$Param{Topic}!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	&ViewTopic;
}
#==========================================================
sub EmailTopic{
	&ViewTopic;
}
#==========================================================
sub DownloadTopic{
}
#==========================================================
sub WatchTopic{
my ($User, $Query, $sth, $Temp, $Found);

	&Check_Account_Login;
	#------------------------------------------------------
	$Param{Topic} += 0;
	%Topic = &GetForumTopic($Param{Topic});
	if (!%Topic) {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Query = qq!SELECT User FROM Forum_Watching WHERE Topic=$Param{Topic} AND User=$User!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while(($Temp) = $sth->fetchrow_array) {$Found = 1; last;}
	$sth->finish;

	if ($Found) {
				$Query = qq!DELETE FROM Forum_Watching WHERE User=$User AND Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	else{
				$Query = qq!INSERT INTO  Forum_Watching SET User=$User, Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	&ViewTopic;
}
#==========================================================
sub NotifyTopic{
my ($User, $Query, $sth, $Temp, $Found);

	&Check_Account_Login;
	#------------------------------------------------------
	$Param{Topic} += 0;
	%Topic = &GetForumTopic($Param{Topic});
	if (!%Topic) {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	$User = $dbh->quote($Param{User_ID});
	$Query = qq!SELECT User FROM Forum_Topic_Notify WHERE Topic=$Param{Topic} AND User=$User!;
	$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$Found = 0;
	while(($Temp) = $sth->fetchrow_array) {$Found = 1; last;}
	$sth->finish;

	if ($Found) {
				$Query = qq!DELETE FROM Forum_Topic_Notify WHERE User=$User AND Topic=$Param{Topic}!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	else{
				$Query = qq!INSERT INTO  Forum_Topic_Notify SET User=$User, Topic=$Param{Topic}, Status=0!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	&ViewTopic;
}
#==========================================================
sub MoveTopic {
my (%Forum, %Topic, @Posts, $Posts, %Message, $Template);
my ($Temp, $TimeClass, $TimeFormat);

	$Plugins{Bar_Action} = $Language{bar_move_topic};
	$Param{Topic} += 0;
	#------------------------------------------------------
	%Topic = &GetForumTopic($Param{Topic});
	if (!%Topic) {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	$Param{Forum} = $Topic{Forum};
	%Forum = &GetForum($Topic{Forum});
	if (!%Forum) {
		$Plugins{Body} = $Language{error_invalid_forum_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	@Posts = &GetForumTopicPosts($Param{Topic});
	$Posts = @Posts;
	if (@Posts) {
			%Message = &GetForumMessage($Posts[0]);
	}
	#------------------------------------------------------
	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Post{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}
	#------------------------------------------------------
	$Template = &TranslateFile($Global{ForumMoveTopicTemplate});
	$Template =~ s/<!--Action-->/$ScriptURL/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Forum-->/$Topic{Forum}/g;
	$Template =~ s/<!--Topic-->/$Topic{Topic}/g;
	$Template =~ s/<!--Author-->/$Topic{Author}/g;
	$Template =~ s/<!--Posts-->/$Posts/g;
	
	$Temp = qq!$ScriptURL?action=ViewProfile&Author=$Topic{Author}&Lang=$Global{Language}!;
	$Template =~ s/<!--AuthorLink-->/$Temp/g;
	#------------------------------------------------------
	$Temp = qq!$ScriptURL?action=TopicReview&Topic=$Param{Topic}&Page=1&Lang=$Global{Language}!;
	$Template =~ s/<!--TopicReviewLink-->/$Temp/g;
	#------------------------------------------------------
	#------------------------------------------------------
	$Form = &Translate($Global{MoveTopicsForm});
	$Form =~ s/<!--Action-->/$ScriptURL/g;
	$Form =~ s/<!--Language-->/$Global{Language}/g;
	$Temp = &ForumsTreeMenuList(0, 1);
	$Template =~ s/<!--ForumsList-->/$Temp/g;
	#------------------------------------------------------
	#------------------------------------------------------
	$TimeClass = ""; $TimeFormat = "";	# <!--LastPostTime:(WD-MD-YY-HH-MM-AP)-->
	if ($Template =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$TimeClass = $1 . $2 . $3. $4. $5;
				$TimeFormat =  $4;
	}
	$TimeClass =~ s/\(/\\\(/g;
	$TimeClass =~ s/\)/\\\)/g;

	if ($Topic{Time} > 0) {
			$Temp = &ParseDate($TimeFormat, $Topic{Time});
	}
	else{	
			$Temp = "";
	}
	$Template =~ s/$TimeClass/$Temp/g;
	#------------------------------------------------------
	$Template =~ s/<!--Subject-->/$Message{Subject}/g;
	$Temp = $Message{Message};
	$Template =~ s/<!--Message-->/$Temp/g;
	#------------------------------------------------------
	&Display($Template, 1);
}
#==========================================================
sub ProcessMoveTopic {
my (%Topic, $Post, $Topic, $Query);
	
	$Param{Topic} += 0;
	%Topic = &GetForumTopic($Param{Topic});
	$Param{Topic} = $Topic{Topic};
	$Param{Forum} = $Topic{Forum};

	if ($Param{Cancel}) {
			&ViewTopic;
			return;
	}

	if (!&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Plugins{Body} = $Language{error_delete_topic_permissions};
				$Plugins{Body} =~ s/<!--Forum-->/$Topic{Forum}/g;
				$Plugins{Body} =~ s/<!--Language-->/$Global{Language}/g;
				&Display($Global{GeneralTemplate});
				return;
	}

	&MoveForumTopic($Param{NewForum}, $Param{Topic});
	#------------------------------------------------------
	#update old forum last post
	$Post = &GetForumLastPost($Param{Forum});
	if ($Post) {
		$Query = qq!UPDATE Forum_Forums SET LastPost=$Post WHERE Forum=$Topic{Forum}!;
		$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	#update new forum last post
	$Post = &GetForumLastPost($Param{NewForum});
	if ($Post) {
		$Query = qq!UPDATE Forum_Forums SET LastPost=$Post WHERE Forum=$Param{NewForum}!;
		$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	#------------------------------------------------------
	&UpdateForumsCounts;
	#------------------------------------------------------
	$Param{Forum} = $Param{NewForum};
	&Forums;
}
#==========================================================
sub PrintTopic {
my ($Template, $Out, $Topic, $Temp);

	$Param{Topic} += 0;
	$Topic = $Param{Topic};
	%Topic = &GetForumTopic($Param{Topic});
	$Plugins{Bar_Action} = $Language{bar_view_topic};
	$Template = &TranslateFile($Global{ForumPrintTopicTemplate});

	if (%Topic) {
		$Plugins{Bar_Action} = $Topic{Title};
		$Temp = $Global{ForumPostCode};
		$Global{ForumPostCode} = $Global{ForumPostCodePrint};
		#----------------------------------------------------------
		# Use Print Syntax Highlight Styles
		#----------------------------------------------------------
		$Global{Highlight_Comment} = $Global{Highlight_Comment_Print};
		$Global{Highlight_Comment1} = $Global{Highlight_Comment1_Print};

		$Global{Highlight_Function} = $Global{Highlight_Function_Print};
		$Global{Highlight_Function1} = $Global{Highlight_Function1_Print};

		$Global{Highlight_Keyword} = $Global{Highlight_Keyword_Print};
		$Global{Highlight_Keyword1} = $Global{Highlight_Keyword1_Print};

		$Global{Highlight_Normal} = $Global{Highlight_Normal_Print};
		$Global{Highlight_Normal1} = $Global{Highlight_Normal1_Print};

		$Global{Highlight_Operator} = $Global{Highlight_Operator_Print};
		$Global{Highlight_Operator1} = $Global{Highlight_Operator1_Print};

		$Global{Highlight_Variable} = $Global{Highlight_Variable_Print};
		$Global{Highlight_Variable1} = $Global{Highlight_Variable1_Print};

		$Global{Highlight_String} = $Global{Highlight_String_Print};
		$Global{Highlight_String1} = $Global{Highlight_String1_Print};

		$Global{Highlight_Char} = $Global{Highlight_Char_Print};
		$Global{Highlight_Char1} = $Global{Highlight_Char1_Print};

		$Global{Highlight_DataType} = $Global{Highlight_DataType_Print};
		$Global{Highlight_DataType1} = $Global{Highlight_DataType1_Print};

		$Global{Highlight_DecVal} = $Global{Highlight_DecVal_Print};
		$Global{Highlight_DecVal1} = $Global{Highlight_DecVal1_Print};

		$Global{Highlight_Float} = $Global{Highlight_Float_Print};
		$Global{Highlight_Float1} = $Global{Highlight_Float1_Print};

		$Global{Highlight_BaseN} = $Global{Highlight_BaseN_Print};
		$Global{Highlight_BaseN1} = $Global{Highlight_BaseN1_Print};

		$Global{Highlight_BString} = $Global{Highlight_BString_Print};
		$Global{Highlight_BString1} = $Global{Highlight_BString1_Print};

		$Global{Highlight_IString} = $Global{Highlight_IString_Print};
		$Global{Highlight_IString1} = $Global{Highlight_IString1_Print};

		$Global{Highlight_Reserved} = $Global{Highlight_Reserved_Print};
		$Global{Highlight_Reserved1} = $Global{Highlight_Reserved1_Print};

		$Global{Highlight_Others} = $Global{Highlight_Others_Print};
		$Global{Highlight_Others1} = $Global{Highlight_Others1_Print};

		$Global{Highlight_RegionMarker} = $Global{Highlight_RegionMarker_Print};
		$Global{Highlight_RegionMarker1} = $Global{Highlight_RegionMarker1_Print};

		$Global{Highlight_Alert} = $Global{Highlight_Alert_Print};
		$Global{Highlight_Alert1} = $Global{Highlight_Alert1_Print};

		$Global{Highlight_Error} = $Global{Highlight_Error_Print};
		$Global{Highlight_Error1} = $Global{Highlight_Error1_Print};

		$Global{Highlight_Warning} = $Global{Highlight_Warning_Print};
		$Global{Highlight_Warning1} = $Global{Highlight_Warning1_Print};
		#----------------------------------------------------------
		($Out, $Msgs) = &ParseTopic("action=PrintTopic", $Param{Topic}, $Global{ForumPostListPrintForm}, $Global{ForumPostListPrintForm1}, $Template, $Param{Post});
		$Global{ForumPostCode} = $Temp;
	}
	else {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub CopyTopic{
	&ViewTopic;
}
#==========================================================

1;