=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
sub ViewPost {
my (%Post);

	$Param{Post} += 0;
	$Param{Topic} += 0;
	%Post = &GetForumPost($Param{Post});
	if (%Post) {
		$Param{Topic} = $Post{Topic};
		$Param{Forum} = $Post{Forum};
	}
	&ViewTopic;
}
#==========================================================
sub ViewTopic {
my (%Topic, $Template, $Out, $Msgs, $Topic, $Query, $User, $Found);

	$Param{Topic} += 0;
	$Param{Post} += 0;
	$Topic = $Param{Topic};
	
	%Topic = &GetForumTopic($Param{Topic});

	$Plugins{Bar_Action} = $Language{bar_view_topic};
	$Template = &TranslateFile($Global{ForumViewTopicTemplate});
	$Template =~ s/<!--Action-->/$Global{ProgURL}/g;
	$Template =~ s/<!--Language-->/$Global{Language}/g;
	$Template =~ s/<!--Topic-->/$Param{Topic}/g;
	$Template =~ s/<!--Forum-->/$Param{Forum}/g;
	$Template =~ s/<!--Page-->/$Param{Page}/g;
	$Template =~ s/<!--Post-->/$Param{Post}/g;

	if (%Topic) {
		$Plugins{Bar_Action} = $Topic{Title};
		($Out, $Msgs) = &ParseTopic("action=ViewTopic", $Param{Topic}, $Global{ForumPostListForm}, $Global{ForumPostListForm1}, $Template, $Param{Post});
	}
	else {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}
	#------------------------------------------------------
	# Update view topics count
	$Query = qq!UPDATE Forum_Topics SET Views=(Views+1) WHERE Topic=$Topic!;
	$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	#------------------------------------------------------
	# mark topic as read for this user
	$Param{User_ID} ||= "";
	if (&Check_Previous_User_Login) {
			$User = $dbh->quote($Param{User_ID});
			$Query = qq!SELECT Topic FROM Forum_Topic_Read WHERE Topic=$Topic AND User=$User!;
			$sth = $dbh->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			$Found = 0;
			while(($Found) = $sth->fetchrow_array) {$Found = 1; last;}
			$sth->finish;
			if (!$Found) {
				$Query = qq!INSERT INTO Forum_Topic_Read values ($Topic, $User)!;
				$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
	}
	#------------------------------------------------------
	# if current user is watching this topic, reset the sent notify email status
	&UpdateNotifyTopicUsersList($Topic, 0, $Param{User_ID});
	#------------------------------------------------------
	&Display($Out, 1);
}
#==========================================================
sub TopicReview{
my ($Template, $Out, $Msgs);

	$Template = &TranslateFile($Global{ForumTopicReviewTemplate});
	%Topic = &GetForumTopic($Param{Topic});

	if (%Topic) {
		$Plugins{Bar_Action} = $Topic{Title};
		($Out, $Msgs) = &ParseTopic("action=TopicReview", $Param{Topic}, $Global{ForumPostListReviewForm}, $Global{ForumPostListReviewForm1}, $Template);
	}
	else {
		$Plugins{Body} = $Language{error_invalid_topic_number};
		&Display($Global{GeneralTemplate});
		return;
	}

	&Display($Out, 1);
}
#==========================================================
sub ParseTopic {
my ($Action, $Topic, $Form1, $Form2, $Template, $ViewPost) = @_;
my (@Posts, %Topic, %Forum, $Temp, $Temp1, $Code, @Code, %Joined);
my (%Online, $Post, $Page);

	@Posts = &GetForumTopicPosts($Topic);
	%Topic = &GetForumTopic($Topic);
	%Forum = &GetForum($Topic{Forum});
	$Param{Forum} = $Topic{Forum};
	@Forms = (&Translate($Form1), &Translate($Form2));
	#------------------------------------------------------
	$Param{Page} ||= 1;
	$Param{NewPage} += 0;
	if ($Param{NewPage} > 0) {$Param{Page} = $Param{NewPage};}
	$TotalCount = @Posts;
	$Global{Posts_Per_Page} += 0;
	$Global{Posts_Per_Page} ||= 20;
	#------------------------------------------------------
	#Ensure specific post page is displayed if post value set
	if ($ViewPost > 0) {
			$Counter = 0;
			foreach $Post (@Posts) {
					$Counter++;
					if ($ViewPost == $Post) {
							$Param{Page} = int($Counter / $Global{Posts_Per_Page}) + 1;
							last;
					}

			}
	}
	#------------------------------------------------------
	# Pagination start
	#------------------------------------------------------
	use Pagination;
	my $paginate = Mewsoft::Pagination->new(
												entries_per_page    => $Global{Posts_Per_Page},
												total_entries       => $TotalCount, 
												current_page        => $Param{Page},
												pages_per_set       => $Global{Pages_Per_Set},
												mode => $Global{Pages_Mode}, #modes are 'slide', 'fixed', default is 'slide'
											);

	$Param{Page} = $paginate->current_page;
	$LastPage = $paginate->last_page;
	$NextPage = $paginate->next_page;
	$PrevPage = $paginate->previous_page;
	$Start = $paginate->first;
	$End = $paginate->last;
	$CurrentPage = $Param{Page};
	#------------------------------------------------------
	$NextPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$NextPage&Lang=$Global{Language}!;
	$PrevPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$PrevPage&Lang=$Global{Language}!;
	$FirstPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=1&Lang=$Global{Language}!;
	$LastPageLink = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$LastPage&Lang=$Global{Language}!;
	#------------------------------------------------------
	# Next Page, Last page
	if ($CurrentPage == $LastPage || $TotalCount <= 0) {
			$Template =~ s/<!--NextPage-->/$Language{paginate_next_page_current}/g;
			$Template =~ s/<!--LastPage-->/$Language{paginate_last_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_next_page};
			$Temp =~ s/<!--Link-->/$NextPageLink/g;
			$Template =~ s/<!--NextPage-->/$Temp/g;
			if ($paginate->last_page_in_set) {
				$Temp = ""; # Last page in set
			}
			else {
				$Temp = $Language{paginate_last_page};
				$Temp =~ s/<!--Page-->/$LastPage/g; # Last page number
				$Temp =~ s/<!--Link-->/$LastPageLink/g;
			}

			$Template =~ s/<!--LastPage-->/$Temp/g;
	}
	#----------------------------------------------
	# Previous Page, First Page
	if ($CurrentPage == 1) {
			$Template =~ s/<!--PrevPage-->/$Language{paginate_prev_page_current}/g;
			$Template =~ s/<!--FirstPage-->/$Language{paginate_first_page_current}/g;
	}
	else{
			$Temp = $Language{paginate_prev_page};
			$Temp =~ s/<!--Link-->/$PrevPageLink/g;
			$Template =~ s/<!--PrevPage-->/$Temp/g;
			
			if ($paginate->first_page_in_set) {
					$Temp = ""; # First page in set
			}
			else {
				$Temp = $Language{paginate_first_page};
				$Temp =~ s/<!--Link-->/$FirstPageLink/g;
			}
			$Template =~ s/<!--FirstPage-->/$Temp/g;
	}
	#------------------------------------------------------
	# Pagination Pages set
	$Pages = ""; 
	foreach $Page (@{$paginate->pages_in_set()}) {
			if ($Page == $CurrentPage) {
					$Link = $Language{paginate_current_page};
			}
			else{
					$Link = $Language{paginate_page};
			}
			$Temp = qq!$Global{ProgURL}$Action&Topic=$Topic&Forum=$Param{Forum}&Page=$Page&Lang=$Global{Language}!;
			$Link =~ s/<!--Link-->/$Temp/;
			$Link =~ s/<!--Page-->/$Page/;
			$Pages .= $Link;
			if ($Page != $LastPage) {
					$Pages .= $Language{paginate_separtor};
			}
	}

	$Pages =~ s/$Language{paginate_separtor}$//g;
	$Template =~ s/<!--Pages-->/$Pages/g;
	#------------------------------------------------------
	$Temp = $Language{paginate_showing_page};
	$Temp =~ s/<!--CurrentPage-->/$CurrentPage/g;
	$Temp =~ s/<!--TotalPages-->/$LastPage/g;
	$Template =~ s/<!--ShowingPage-->/$Temp/g;
	#------------------------------------------------------
	# Pagination end
	#------------------------------------------------------
	$PostTimeClass = ""; $PostTimeFormat = "";	# <!--PostTime:(MON-MD-YY HH:MM AP)-->
	if ($Forms[0] =~ m/(<!--)(PostTime)(:\()([^\)]+)(\)-->)/){
				$PostTimeClass = $1 . $2 . $3. $4. $5;
				$PostTimeFormat =  $4;
	}
	#------------------------------------------------------
	$JoinedTimeClass = ""; $JoinedTimeFormat = "";	# <!--JoinedTime:(MON-MD-YY HH:MM AP)-->
	if ($Forms[0] =~ m/(<!--)(JoinedTime)(:\()([^\)]+)(\)-->)/){
				$JoinedTimeClass = $1 . $2 . $3. $4. $5;
				$JoinedTimeFormat =  $4;
	}
	#------------------------------------------------------
	#------------------------------------------------------
	#Expand/Colapse code blocks
	#------------------------------------------------------
	if ($Param{Expand}) {
			$Cookies{BoardawyExpandCollapseCode} ||= "";
			$Cookies{BoardawyExpandCollapseCode} = !$Cookies{BoardawyExpandCollapseCode};
			&Set_Cookies("BoardawyExpandCollapseCode", $Cookies{BoardawyExpandCollapseCode}, 1);
	}
	#------------------------------------------------------
	undef %Joined;
	undef %Online;
	map ($Online{$_} = 1, @{$Plugins{Online_Usernames}});
	#------------------------------------------------------
	undef @Levels;
	$Levels[0] = $Language{author_level_user};
	$Levels[1] = $Language{author_level_admin};
	$Levels[2] = $Language{author_level_mod};
	#------------------------------------------------------
	$Output = "";
	$PrevPost = ""; $NextPost = "";

	for $Counter($Start-1..$End-1){
					$Post = $Posts[$Counter];
					if ($Counter < 0) {next;}

					%Post = &GetForumPost($Post);
					%Media = &GetForumPostMedia($Post);
					%User = &GetForumUser($Post{Author});
					if (!$Joined{$Post{Author}}) {
					}

					$Form = $Forms[int($Counter % 2)]; 

					$Temp = "";
					if ($Topic{Poll}) {$Temp = $Language{topic_has_poll};}
					$Form =~ s/<!--Poll-->/$Temp/g;

					%Message = &GetForumMessage($Post);
					#------------------------------------------------------
					if ($Message{Subject}) {
							$Temp = $Message{Subject};
							$Form =~ s/<!--Subject-->/$Temp/g;
					}
					else{
							$Temp = $Language{posts_subject};
							$Temp =~ s/<!--Subject-->/$Topic{Title}/g;
							$Form =~ s/<!--Subject-->/$Temp/g;
					}
					#------------------------------------------------------
					# Process syntax highlighting [perl] ..[/perl]
					$Message = $Message{Message};
					$Message = &FormatMessage($Message);
					#------------------------------------------------------
					$Form =~ s/<!--Message-->/$Message/g;
					#------------------------------------------------------
					$Form =~ s/<!--ID-->/$Post/g;
					#------------------------------------------------------
					if ($User{AttachSign} && $User{Sig}) {
							$Temp = $Language{posts_signature};
							$Temp =~ s/<!--Sig-->/$User{Sig}/;
							$Form =~ s/<!--Signature-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--Signature-->//g;
					}
					#------------------------------------------------------
					if ($User{Avatar}) {
							$Temp = $Language{post_avatar_link};
							$Link = qq!$Global{Avatars_URL}/$User{Avatar}!;
							$Temp =~ s/<!--AvatarLink-->/$Link/g;
							$Form =~ s/<!--Avatar-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--Avatar-->//g;
					}
					#------------------------------------------------------
					$Form =~ s/<!--AuthorType-->/$Levels[$User{Level}]/g;
					#------------------------------------------------------
					if ($Online{$Post{Author}}) {
							$Form =~ s/<!--Online-->/$Language{user_online}/g;
					}
					else{
							$Form =~ s/<!--Online-->/$Language{user_offline}/g;
					}
					#------------------------------------------------------
					#------------------------------------------------------
					$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Form =~ s/<!--AuthorLink-->/$Temp/g;
					#------------------------------------------------------
					$Temp = $Language{edit_with_quote};
					$Link = qq!$Global{ProgURL}action=QuotePost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Temp =~ s/<!--QuoteLink-->/$Link/g;
					$Form =~ s/<!--QuotePost-->/$Temp/g;
					#------------------------------------------------------
					if (&CheckPostActionPermissions("Edit", %Post)) {
							$Temp = $Language{post_edit_link};
							$Link = qq!$Global{ProgURL}action=EditPost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--EditLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_edit_link_disabled};
					}
					$Form =~ s/<!--EditPost-->/$Temp/g;
					#------------------------------------------------------
					if (&CheckPostActionPermissions("Deletes", %Post)) {
							$Temp = $Language{post_delete_link};
							$Link = qq!$Global{ProgURL}action=DeletePost&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--DeleteLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_delete_link_disabled};
					}
					$Form =~ s/<!--DeletePost-->/$Temp/g;
					#------------------------------------------------------
					$Temp = qq!$Global{ProgURL}action=ViewIP&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
					$Form =~ s/<!--IPLink-->/$Temp/g;
					if (&CheckPostActionPermissions("Deletes", %Post)) {
							$Temp = $Language{post_viewip_link};
							$Link = qq!$Global{ProgURL}action=ViewIP&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--IPLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_viewip_link_disabled};
					}
					$Form =~ s/<!--PostIP-->/$Temp/g;
					#------------------------------------------------------
					if ($User{AllowPM}) {
							$Temp = $Language{post_pm_link};
							$Link = qq!$Global{ProgURL}action=MyCompose&To=$Post{Author}&Post=$Post&Topic=$Topic&Forum=$Topic{Forum}&Lang=$Global{Language}!;
							$Temp =~ s/<!--PMLink-->/$Link/g;
					}
					else{
							$Temp = $Language{post_pm_link_disabled};
					}
					$Form =~ s/<!--PM-->/$Temp/g;
					#------------------------------------------------------
					if ($User{ICQ}) {
							$Temp = $Language{post_icq};
							$Temp =~ s/<!--ICQ-->/$User{ICQ}/g;
							$Form =~ s/<!--ICQ-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--ICQ-->//g;
					}
					if ($User{AIM}) {
							$Temp = $Language{post_aim};
							$Temp =~ s/<!--AIM-->/$User{AIM}/g;
							$Form =~ s/<!--AIM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--AIM-->//g;
					}
					if ($User{YIM}) {
							$Temp = $Language{post_yim};
							$Temp =~ s/<!--YIM-->/$User{YIM}/g;
							$Form =~ s/<!--YIM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--YIM-->//g;
					}
					if ($User{MSNM}) {
							$Temp = $Language{post_msnm};
							$Temp =~ s/<!--MSNM-->/$User{MSNM}/g;
							$Form =~ s/<!--MSNM-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--MSNM-->//g;
					}

					if ($User{WebURL}) {
							$User{WebTitle} ||= $User{WebURL};
							$Temp = $Language{post_weburl};
							$Temp =~ s/<!--WebURL-->/$User{WebURL}/g;
							$Temp =~ s/<!--WebTitle-->/$User{WebTitle}/g;
							$Form =~ s/<!--WebSite-->/$Temp/g;
					}
					else{
							$Form =~ s/<!--WebSite-->//g;
					}
					#------------------------------------------------------
					if (($User{ViewEmail} && $Global{ShowUserEmail}) || $CurrentUser{Level} == 1) {
							$Temp = $Language{post_email};
							$Temp =~ s/<!--Email-->/$User{Email}/g;
					}
					else{
							$Temp = $Language{post_email_disabled};
					}
					$Form =~ s/<!--Email-->/$Temp/g;
					#----------------------------------------------
					$Temp = $Language{post_member_posts};
					$Link = qq!$Global{ProgURL}action=ForumSmartSearch&Authors=$User{User_ID}&Dir=0&Sort=Updated&Mode=1&Period=0&TitlesOnly=1&&Terms=&Lang=$Global{Language}!;
					$Temp =~ s/<!--AuthorPostsLink-->/$Link/g;
					$Form =~ s/<!--AuthorPosts-->/$Temp/g;
					#----------------------------------------------
					$Temp = qq!$Global{AuctionMainURL}?action=ListUserFeedback&User_ID_Feedback=$User{User_ID}&Lang=$Global{Language}!;
					$Form =~ s/<!--MemberFeedbackLink-->/$Temp/g;
					#----------------------------------------------
					$Form =~ s/<!--Posts-->/$User{Posts}/g;
					#----------------------------------------------
					if ($User{Location}) {
							$Temp = $Language{posts_user_location};
							$Temp =~ s/<!--Location-->/$User{Location}/g;
							$Form =~ s/<!--Location-->/$Temp/g;
					}
					#----------------------------------------------
					$Temp = $Post{Author};
					$Form =~ s/<!--Author-->/$Temp/g;

					#Time parser: date= YY, MONTH, MON, MD, WD, time= HR, HH:MM:SS
					if ($Post{Time} > 0) {
							$Temp = &ParseDate($PostTimeFormat, $Post{Time});
					}
					else{	
							$Temp = "";
					}
					$Form =~ s/\Q$PostTimeClass\E/$Temp/g;
					#------------------------------------------------------
					$Form =~ s/<!--Counter-->/$Counter/g;
					#------------------------------------------------------
					$Temp = &ParseDate($JoinedTimeFormat, $User{Start_Date});
					$Form =~ s/\Q$JoinedTimeClass\E/$Temp/g;
					#------------------------------------------------------
					if ($Media{Media}) {
							undef @Media; undef @Docs;
							@Upload = split(/\|/, $Media{Media});
							foreach $File (@Upload) {
								if ($File =~ /\.gif$/i || $File =~ /\.png$/i || $File =~ /\.jpg$/i || $File =~ /\.pjpeg$/i || $File =~ /\.pjpg$/i || $File =~ /\.jpeg$/i || $File =~ /\.bmp$/i ) {
									push @Media, $File;
								}
								else{
									push @Docs, $File;
								}
							}
							$Temp = &Get_Media_Show($Media{Media_Show}, @Media);
							$Form =~ s/<!--Multimedia-->/$Temp/;
							
							$Docs = "";
							foreach $File (@Docs) {
									if ($File =~ /\.wav$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_sound};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.mid$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_mid};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.mov$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_movie};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									elsif ($File =~ /\.avi$/i) {
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_avi};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									else{
											$Link = qq!$Global{HTML_URL}/upload/$File!;
											$URL = $Language{upload_file_other};
											$URL =~ s/<!--Link-->/$Link/g;
											$URL =~ s/<!--Name-->/$File/g;
									}
									$Docs .= $URL . $Language{docs_files_join};
							}
							$Docs =~ s/$Language{docs_files_join}$//g;
							$Form =~ s/<!--Documents-->/$Docs/;
			}
			#------------------------------------------------------
			$Temp = qq!$Global{ProgURL}action=ViewProfile&Author=$Post{Author}&Forum=$Topic{Forum}&Lang=$Global{Language}!;
			$Form =~ s/<!--Profile-->/$Temp/g;
			#------------------------------------------------------
			$Temp = $Counter;
			if ($Counter == 0) {
					$Link = $Language{post_first_number};
			}
			else{
					$Link = $Language{post_number};
			}
			$Link =~ s/<!--PostNum-->/$Temp/g;
			$Form =~ s/<!--PostNum-->/$Link/g;
			#------------------------------------------------------
			if ($PrevPost) {
					$Temp = $Language{posts_up_post};
					$Temp =~ s/<!--UpPost-->/$PrevPost/g;
					$Form =~ s/<!--UpPost-->/$Temp/g;
			}
			else{
					$Form =~ s/<!--UpPost-->/$Language{posts_up_post_disabled}/g;
			}
			
			if ($Counter < $End-1) {
					$NextPost = $Posts[$Counter+1];
					$Temp = $Language{posts_dn_post};
					$Temp =~ s/<!--DnPost-->/$NextPost/g;
					$Form =~ s/<!--DnPost-->/$Temp/g;
			}
			else{
					$Form =~ s/<!--DnPost-->/$Language{posts_dn_post_disabled}/g;
			}

			$PrevPost = $Post;
			#------------------------------------------------------
					if ($Global{Auctionawy_Plugin}) {
							($Rating, $Stars) = &Get_User_Feedback_Stars($Poster{Author});
							if (!$Rating) {
									$Temp = $Language{feedback_rating_zero};
							}
							else{
									$Temp = $Language{feedback_rating};
							}
							$Temp =~ s/<!--FeedbackRating-->/$Rating/g;
							$Temp =~ s/<!--FeedbackStars-->/$Stars/g;
							$Form =~ s/<!--Feedback-->/$Temp/g;

							$Temp1 = &GetUserOpenAuctionsCount($Poster{Author});
							if ($Temp1 > 0) {
								$Temp = $Language{member_auctions};
							}
							else {
								$Temp = $Language{member_auctions_zero};
							}
							$Link = qq!$Global{AuctionMainURL}?action=Browse&Search=SellerAuctions&Status=&SellerID=$Poster{Author}&Lang=$Global{Language}!;
							$Temp =~ s/<!--MemberAuctionsLink-->/$Link/g;
							$Temp =~ s/<!--Auctions-->/$Temp1/g;
							$Form =~ s/<!--MemberAuctions-->/$Temp/g;
							$Form =~ s/<!--Auctions-->/$Temp1/g;

							$Temp = qq!$Global{AuctionMainURL}?action=ListUserFeedback&User_ID_Feedback=$Poster{Author}&Lang=$Global{Language}!;
							$Form =~ s/<!--MemberFeedbackLink-->/$Temp/g;
					}
					#------------------------------------------------------
					if ($Global{Classifiedawy_Plugin}) {
							$Temp1 = &GetUserOpenAdsCount($Poster{Author});
							if ($Temp1 > 0) {
									$Temp = $Language{member_ads};
							}
							else {
									$Temp = $Language{member_ads_zero};
							}
							$Link = qq!$Global{ClassifiedMainURL}?action=Browse&Search=SellerAds&Status=&SellerID=$Poster{Author}&Lang=$Global{Language}!;
							$Temp =~ s/<!--MemberAdsLink-->/$Link/g;
							$Temp =~ s/<!--Ads-->/$Temp1/g;
							$Form =~ s/<!--MemberAds-->/$Temp/g;
							$Form =~ s/<!--Ads-->/$Temp1/g;
					}
			#------------------------------------------------------
			$Temp = $Language{about_me_link};
			$Link = qq!$Global{ProgURL}me/$Post{Author}!;
			$Temp =~ s/<!--AboutMeLink-->/$Link/g;
			$Temp =~ s/<!--Author-->/$Post{Author}/g;
			$Form =~ s/<!--AboutMe-->/$Temp/g;
			#------------------------------------------------------
			$Output .= $Form;
	}
	#------------------------------------------------------
	if ($Forum{Status} == 1 && $Forum{Accept}) {$PostLink = 1;} else {$PostLink = 0;	}
	# display the post new topic link?
	if ($PostLink && &CheckForumActionPermissions("Post", %Forum)) {
					$Link = $Language{topicview_post_new_topic};
					$Temp = qq!$Global{ProgURL}action=NewTopic&Forum=$Param{Forum}&Lang=$Global{Language}!;
					$Link =~ s/<!--NewTopicLink-->/$Temp/g;
	}
	else{
					$Link = $Language{topicview_post_new_topic_disabled};
	}
	$Template =~ s/<!--PostNewTopic-->/$Link/g;

	if ($PostLink && !$Topic{Status} && &CheckForumActionPermissions("Reply", %Forum)) {
					$Link = $Language{topicview_post_new_reply};
					$Temp = qq!$Global{ProgURL}action=NewPost&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
					$Link =~ s/<!--NewReplyLink-->/$Temp/g;
	}
	else{
					$Link = $Language{topicview_post_new_reply_disabled};
	}
	$Template =~ s/<!--PostNewReply-->/$Link/g;
	#------------------------------------------------------
	$Link = $Language{topic_mark_unread};
	$Temp = qq!$Global{ProgURL}action=MarkTopicUnread&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--Link-->/$Temp/g;
	$Template =~ s/<!--MarkTopicUnread-->/$Link/g;
	#------------------------------------------------------
	#<!--DeleteTopic--> &nbsp; <!--MoveTopic--> &nbsp; <!--CopyTopic--> &nbsp; <!--StatusTopic--> &nbsp;
	if (&CheckTopicActionPermissions("Deletes", %Topic)) {
				$Link = $Language{topic_delete_link};
				$Temp = qq!$Global{ProgURL}action=DeleteTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--DeleteTopicLink-->/$Temp/g;
				$Template =~ s/<!--DeleteTopic-->/$Link/g;

				$Link = $Language{topic_move_link};
				$Temp = qq!$Global{ProgURL}action=MoveTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--MoveTopicLink-->/$Temp/g;
				$Template =~ s/<!--MoveTopic-->/$Link/g;

				$Link = $Language{topic_copy_link};
				$Temp = qq!$Global{ProgURL}action=CopyTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
				$Link =~ s/<!--CopyTopicLink-->/$Temp/g;
				$Template =~ s/<!--CopyTopic-->/$Link/g;

				if (!$Topic{Status}) { # open topic
						$Link = $Language{topic_lock_link};
						$Temp = qq!$Global{ProgURL}action=StatusTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
						$Link =~ s/<!--StatusLink-->/$Temp/g;
				}
				else{ # locked topic
						$Link = $Language{topic_unlock_link};
						$Temp = qq!$Global{ProgURL}action=StatusTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
						$Link =~ s/<!--StatusLink-->/$Temp/g;
				}
				$Template =~ s/<!--StatusTopic-->/$Link/g;
	}
	else{
				$Template =~ s/<!--DeleteTopic-->/$Language{topic_delete_disabled}/g;
				$Template =~ s/<!--MoveTopic-->/$Language{topic_move_disabled}/g;
				$Template =~ s/<!--CopyTopic-->/$Language{topic_copy_disabled}/g;
				if (!$Topic{Status}) { # open topic
						$Template =~ s/<!--StatusTopic-->/$Language{topic_lock_link_disabled}/g;
				}
				else{ # locked topic
						$Template =~ s/<!--StatusTopic-->/$Language{topic_unlock_link_disabled}/g;
				}
	}
	#------------------------------------------------------
	#<!--EmailTopic--> &nbsp; <!--WatchTopic--> &nbsp; <!--NotifyTopic--> &nbsp; <!--PrintTopic--> &nbsp; <!--DownloadTopic-->
	#------------------------------------------------------
	$Link = $Language{topic_email_link};
	$Temp = qq!$Global{ProgURL}action=EmailTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--EmailTopicLink-->/$Temp/g;
	$Template =~ s/<!--EmailTopic-->/$Link/g;
	#------------------------------------------------------
	if (&WatchingTopicStatus($Param{User_ID}, $Topic)) {
				$Link = $Language{topic_unwatch_link};
	}
	else{
				$Link = $Language{topic_watch_link};
	}
	$Temp = qq!$Global{ProgURL}action=WatchTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--WatchTopicLink-->/$Temp/g;
	$Template =~ s/<!--WatchTopic-->/$Link/g;
	#------------------------------------------------------
	if (&NotifyTopicStatus($Param{User_ID}, $Topic)) {
				$Link = $Language{topic_unnotify_link};
	}
	else{
				$Link = $Language{topic_notify_link};
	}
	$Temp = qq!$Global{ProgURL}action=NotifyTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--NotifyTopicLink-->/$Temp/g;
	$Template =~ s/<!--NotifyTopic-->/$Link/g;
	#------------------------------------------------------
	$Link = $Language{topic_print_link};
	$Temp = qq!$Global{ProgURL}action=PrintTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--PrintTopicLink-->/$Temp/g;
	$Template =~ s/<!--PrintTopic-->/$Link/g;
	#------------------------------------------------------
	$Link = $Language{topic_download_link};
	$Temp = qq!$Global{ProgURL}action=DownloadTopic&Topic=$Topic&Forum=$Param{Forum}&Lang=$Global{Language}!;
	$Link =~ s/<!--DownloadTopicLink-->/$Temp/g;
	$Template =~ s/<!--DownloadTopic-->/$Link/g;
	#----------------------------------------------------------------
	$Template =~ s/<!--MessagesList-->/$Output/g;
	#------------------------------------------------------
	# Expand/Collapse code blocks links
	#------------------------------------------------------
	if ($Cookies{BoardawyExpandCollapseCode}==1) {
		$Link = qq!$Global{ProgURL}action=ViewTopic&Topic=$Param{Topic}&Page=1&Expand=1&Lang=$Global{Language}!;
		$Template =~ s/<!--ExpandCollapseLink-->/$Link/g;
		$Template =~ s/<!--ExpandCollapse-->/$Language{code_blocks_collapse}/g;
	}
	else {
		$Link = qq!$Global{ProgURL}action=ViewTopic&Topic=$Param{Topic}&Page=1&Expand=1&Lang=$Global{Language}!;
		$Template =~ s/<!--ExpandCollapseLink-->/$Link/g;
		$Template =~ s/<!--ExpandCollapse-->/$Language{code_blocks_expand}/g;
	}
	#----------------------------------------------------------------
	return ($Template, $Output);
}
#==========================================================
1;