#!/usr/bin/perl
#!C:\perl\bin\perl.exe
=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Boardawy
    Program Author   : Dr. Elsheshtawy, Ahmed Amin, Ph.D. Physics
    Home Page          : http://www.mewsoft.com
	Email                    : support@mewsoft.com
	Products               : Auction, Classifieds, Directory, etc. Integrated
	Copyrights  2000-2011 Mewsoft Corporation. All rights reserved.
==========================================================
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==========================================================
=cut
#==========================================================
$| = 1;
print "Content-type: text/html\n\n";
use CGI::Carp qw(fatalsToBrowser); 
#==========================================================
BEGIN {
	undef %Param;
	undef %Global;
	undef @User_Fields;
	undef %Cookies;
}
#==========================================================
BEGIN {
	if ($ENV{SCRIPT_FILENAME}) {
			use File::Basename;
			($Script, $Bin) = fileparse($ENV{SCRIPT_FILENAME});
	}
	else {
			use FindBin qw($Bin $Script);
	}
	$Bin ||= ".";
	use lib "$Bin/lib";
	unshift @INC, $Bin;
	$Global{CGI_Dir} = $Bin;
	$Global{MainProg} = $Script;
}
#==========================================================
use Configuration;
&ProgramStart;
#==========================================================
use LWP::UserAgent;
use RssParser;
#==========================================================
	my $rsslink = "";
	if ($ENV{CONTENT_LENGTH} ) {
		read (STDIN, $rsslink, $ENV{CONTENT_LENGTH});
	} 
	elsif ($ENV{QUERY_STRING}) {
		$rsslink =  $ENV{QUERY_STRING};
	}
#==========================================================
my $Header;
$Header=<<Header;
<html>
<head>
<title>Mewsoft Products RSS Feed</title>

<style type="text/css">
.TableHeader{
	height:25px;
	background-image: url('$Global{Skin}/table-header-bg.jpg');
	color: #0B2044;
	border:  #85ABEB 1px solid;
	padding: 1px 4px 1px 4px;
	font-size:11px;
	font-weight: bold;
	font-family: arial,tahoma,verdana;
	vertical-align: middle;
}

.TableSubHeader{
	height:25px;
	background-image: url('$Global{Skin}/table-sub-header-bg.jpg');
	color: #0B2044;
	border:  #85ABEB 1px solid;
	padding: 1px 4px 1px 4px;
	font-size:11px;
	font-weight: bold;
	font-family: arial,tahoma,verdana;
	vertical-align: middle;
}

.TableAttr{
	font-family: arial,tahoma,verdana;
	font-weight: normal;
	font-size: 11px;
	color: #330033;
	background-color: #FFFFFF;
	border:  #85ABEB 1px solid;
	border-collapse: collapse;
	border-spacing: 0px;
	margin-top: 0px;
}

.TableCell{
	background-color: #FFFFFF;
	color: #002233;
	border:  #C2D5F3 1px dashed;
	padding: 3px 4px 3px 4px;
	font-size:11px;
	font-weight: normal;
	font-family: arial,tahoma,verdana;
}

</style>

<script type="text/javascript">
function Toggle(id) {  
	var ctrlID = '';
	if (document.all) {
		ctrlID = document.all(id);
	} else
		if (document.getElementById) {
			ctrlID = document.getElementById(id);
	}
	if (ctrlID.style.display == 'none')
	{
		ctrlID.style.display = 'block';
	}
	else
	{
		ctrlID.style.display = 'none';
	}        
}

function PreloadPage() {
	if (document.getElementById) {  // DOM3 = IE5, NS6
		document.getElementById('PagePreload').style.visibility = 'hidden';
	}
	else {
			if (document.layers) {  // Netscape 4
					document.PagePreload.visibility = 'hidden';
			}
			else {  // IE 4
				document.all.PagePreload.style.visibility = 'hidden';
			}
	}
}

//DOM-ready watcher
function domReady()
{
	//start or increment the counter
	this.n = typeof this.n == 'undefined' ? 0 : this.n + 1;
	
	//if DOM methods are supported, and the body element exists
	//(using a double-check including document.body, for the benefit of older moz builds [eg ns7.1] 
	//in which getElementsByTagName('body')[0] is undefined, unless this script is in the body section)
	//>>> and any elements the script is going to manipulate exist
	if
	(
		typeof document.getElementsByTagName != 'undefined' 
		&& (document.getElementsByTagName('body')[0] != null || document.body != null)
		//>>> && document.getElementById('something') != null 
	)
	{
	//>>>-- DOM SCRIPTING GOES HERE --<<<
		PreloadPage();
	//>>>-----------------------------<<<
	}

	//otherwise if we haven't reached 60 (so timeout after 15 seconds)
	//in practise, I've never seen this take longer than 7 iterations [in kde 3.2.2 
	//in second place was IE6, which takes 2 or 3 iterations roughly 5% of the time]
	else if(this.n < 60)
	{
		//restart the watcher
		//using the syntax ('domReady()', n) rather than (domReady, n)
		//because the latter doesn't work in Safari 1.0
		setTimeout('domReady()', 250);
	}
};
//start the watcher
domReady();

</script>

</head>

<body>

<div id="PagePreload" name="PagePreload" style="position: absolute; left:0px; top:0px; height: 95%; width: 98%;"> 
<table  style="width: 100%; height: 100%;">
	<tr><td style="width: 100%; height: 100%" valign="middle" align="center"><img src="$Global{Skin}/loading.gif" border="0" /></td></tr>
</table>
</div> 
Header
	
$Body=<<Body;
<table cellspacing="0" cellpadding="2" style="border-collapse: collapse" bordercolor="#111111" width="100%" class="TableAttr">
  <tr>
    <td nowrap align="center" class="TableSubHeader"><b>Headlines</b></td>
    <td nowrap align="center" class="TableSubHeader"><b>Published</b></td>
    <td nowrap align="center" class="TableSubHeader"><b>Author</b></td>
  </tr>
<!--Output-->
</table>
Body

my $OutputLine;
$OutputLine=<<OutputLine;
  <tr>
    <td width="100%" class="TableCell"  valign="top">
		<a href="javascript:Toggle('id<!--ID-->');"><!--Title--></a> &nbsp; <a href="<!--Link-->" target="_blank">Visit...</a><br />
		<div id="id<!--ID-->" name="id<!--ID-->" style="display: none; overflow:auto;background-color: #F8F8F8; color: #000000;padding: 4;margin: 4; border-right: 1px inset; border-top: 1px inset; border-left: 1px inset; border-bottom: 1px inset">
			<!--Description-->
		</div>
	</td>
    <td nowrap class="TableCell" valign="top"><!--pubDate--></td>
    <td nowrap class="TableCell"  valign="top"><!--Author--></td>
  </tr>
OutputLine
	
	print "$Header";
	
	#$rsslink = qq!http://localhost/cgi-bin/forum/forum.cgi?action=RSS&Forum=9,15,13,23,1,6&Limit=5!;
	my ($tree, @items) = parse_url($rsslink);

	my $output = "";
	my $counter = 0;
	foreach my $item (@items) {
			$counter++;
			$line = $OutputLine;
			$line =~ s/<!--Link-->/$item->{link}/g;
			$line =~ s/<!--Title-->/$item->{title}/g;
			$line =~ s/<!--Description-->/$item->{description}/g;
			$line =~ s/<!--pubDate-->/$item->{pubdate}/g;
			$item->{'dc:creator'} ||= $item->{author};
			$line =~ s/<!--Author-->/$item->{'dc:creator'}/g;
			$line =~ s/<!--ID-->/$counter/g;
			$output .= $line;
	}
	$Body =~ s/<!--Output-->/$output/g;
	print $Body;
	print "</body>\n</html>\n";
	exit 0;
#==========================================================
#==========================================================
